******************************************************************************************
*                                                                                        *
*  AppleIIgsKarate.Sprite4.s :  Compiled Sprites display Code for Sprite Bank #4.        *
*                                                                                        *
******************************************************************************************
*  Authors : Antoine VIGNAU / Olivier ZARDINI  *  Brutal Deluxe Software  *  April 2022  *
******************************************************************************************

*----------   Merlin 16+ Directives   ---------

                    mx         %00                  ; Assemble in 16 bit

                    rel                             ; Build a relocated S16 file
                    dsk        Sprite4 .l           ; Name of the Segment

**************************************************************************************
*  DrawSpriteBank4() :  Display a Sprite on the Screen (IN:A=SpriteID,IN:Y=@Screen). *
**************************************************************************************
DrawSpriteBank4     ENT                             ; First Byte of this Segment
                    PHB
                    PHK
                    PLB                             ; Y=Target Screen Address ($2000-$9D00)
                    DEC                             ; A=Sprite Number ($0001-$008A)
                    ASL                             
                    TAX                             
                    JMP        (TabSpriteBank4,X)

StackAddress        HEX        0000

*----------   DrawSpriteBank4 Variables   ---------  
TabSpriteBank4      DA         Sprite_BR_000,Sprite_BR_000,Sprite_BR_000,Sprite_BR_000,Sprite_BR_000,Sprite_BR_000,Sprite_BR_000,Sprite_BR_000
                    DA         Sprite_BR_000,Sprite_BR_000,Sprite_BR_000,Sprite_BR_000,Sprite_BR_000,Sprite_BR_000,Sprite_BR_000,Sprite_BR_000
                    DA         Sprite_BR_000,Sprite_BR_000,Sprite_BR_000,Sprite_BR_000,Sprite_BR_000,Sprite_BR_000,Sprite_BR_000,Sprite_BR_000
                    DA         Sprite_BR_000,Sprite_BR_000,Sprite_BR_000,Sprite_BR_000,Sprite_BR_000,Sprite_BR_000,Sprite_BR_000,Sprite_BR_000
                    DA         Sprite_BR_000,Sprite_BR_000,Sprite_BR_000,Sprite_BR_000,Sprite_BR_000,Sprite_BR_000,Sprite_BR_000,Sprite_BR_000
                    DA         Sprite_BR_000,Sprite_BR_000,Sprite_BR_000,Sprite_BR_000,Sprite_BR_000,Sprite_BR_000,Sprite_BR_000,Sprite_BR_000
                    DA         Sprite_BR_000,Sprite_BR_000,Sprite_BR_000,Sprite_BR_000,Sprite_BR_000,Sprite_BR_000,Sprite_BR_000,Sprite_BR_000
                    DA         Sprite_BR_000,Sprite_BR_000,Sprite_BR_000,Sprite_BR_000,Sprite_BR_000,Sprite_BR_000,Sprite_BR_000,Sprite_BR_000
                    DA         Sprite_BR_000,Sprite_BR_000,Sprite_BR_000,Sprite_BR_000,Sprite_BR_000,Sprite_BR_000,Sprite_BR_000,Sprite_BR_000
                    DA         Sprite_BR_000,Sprite_BR_000,Sprite_BR_000,Sprite_BR_000,Sprite_BR_000,Sprite_BR_000,Sprite_BR_000,Sprite_BR_000
                    DA         Sprite_BR_000,Sprite_BR_000,Sprite_BR_000,Sprite_BR_000,Sprite_BR_000,Sprite_BR_000,Sprite_BR_000,Sprite_BR_000
                    DA         Sprite_BR_000,Sprite_BR_000,Sprite_BR_000,Sprite_BR_000,Sprite_BR_000,Sprite_BR_000,Sprite_BR_000,Sprite_BR_000
                    DA         Sprite_BR_000,Sprite_BR_000,Sprite_BR_000,Sprite_BR_000,Sprite_BR_000,Sprite_BR_000,Sprite_BR_000,Sprite_BR_000
                    DA         Sprite_BR_000,Sprite_BR_000,Sprite_BR_000,Sprite_BR_000,Sprite_BR_000,Sprite_BR_000,Sprite_BR_000,Sprite_BR_000
                    DA         Sprite_BR_000,Sprite_BR_000,Sprite_BR_000,Sprite_BR_000,Sprite_BR_000,Sprite_BR_000,Sprite_BR_000,Sprite_BR_000
                    DA         Sprite_BR_000,Sprite_BR_000,Sprite_BR_000,Sprite_BR_000,Sprite_BR_000,Sprite_BR_000,Sprite_BR_000,Sprite_BR_000
                    DA         Sprite_BR_000,Sprite_SM_082,Sprite_SM_083,Sprite_SM_084,Sprite_HI_085,Sprite_HI_086,Sprite_HI_087,Sprite_HI_088
                    DA         Sprite_SH_089,Sprite_SH_08A

*-----------------------------------
Sprite_BR_000       PLB                             ; Sprite #0 does not exist
                    RTL

*-----------------------------------
Sprite_SM_082       CLC                             ; Sprite #082 : 12x7, 152 bytes, 254 cycles
                    SEI                             ; Disable Interrupts
                    PHD                             ; Backup Direct Page
                    TSC                             ; Backup Stack
                    STA        StackAddress         
                    LDAL       $E1C068              ; Direct Page and Stack in Bank 01/
                    ORA        #$0030               
                    STAL       $E1C068              
                    TYA                             ; Y = Sprite Target Screen Address (upper left corner)
                    TCS                             ; New Stack address
                    LDX        #$2222               ; Pattern #1 : 7
                    LDY        #$2626               ; Pattern #2 : 3
                    LDA        #$6222               ; Pattern #3 : 1
                    TCD                             
*--                                                 
                    TXA                             ; Line 0
                    STA        $A2,S                
                    SEP        #$20                 
                    LDA        #$22                 
                    STA        $02,S                
                    REP        #$30                 
                    TSC                             ; Line 2
                    ADC        #$0140               
                    TCS                             
                    TXA                             
                    STA        $01,S                
                    LDA        $03,S                
                    AND        #$0F00               
                    ORA        #$2026               
                    STA        $03,S                
                    SEP        #$20                 
                    LDA        #$62                 
                    STA        $A4,S                
                    LDA        $00,S                
                    AND        #$F0                 
                    ORA        #$02                 
                    STA        $00,S                
                    REP        #$30                 
                    TSC                             ; Line 3
                    ADC        #$00A3               
                    TCS                             
                    SEP        #$20                 
                    LDA        #$62                 
                    STA        $9D,S                
                    REP        #$30                 
                    PHX                             
                    PHX                             
                    TSC                             ; Line 4
                    ADC        #$00A5               
                    TCS                             
                    LDA        $A0,S                
                    AND        #$0F00               
                    ORA        #$2026               
                    STA        $A0,S                
                    PHD                             
                    PHX                             
                    TSC                             ; Line 5
                    ADC        #$00A3               
                    TCS                             
                    LDA        $9D,S                
                    AND        #$00F0               
                    ORA        #$6202               
                    STA        $9D,S                
                    LDA        $A0,S                
                    AND        #$00F0               
                    ORA        #$6202               
                    STA        $A0,S                
                    PHY                             
                    PHY                             
*--                                                 
                    LDAL       $E1C068              ; Direct Page and Stack in Bank 00/
                    AND        #$FFCF               
                    STAL       $E1C068              
                    LDA        StackAddress         ; Restore Stack
                    TCS                             
                    PLD                             ; Restore Direct Page
                    CLI                             ; Enable Interrupts
                    PLB
                    RTL                             

*-----------------------------------                                

Sprite_SM_083       CLC                             ; Sprite #083 : 14x9, 222 bytes, 374 cycles
                    SEI                             ; Disable Interrupts
                    PHD                             ; Backup Direct Page
                    TSC                             ; Backup Stack
                    STA        StackAddress         
                    LDAL       $E1C068              ; Direct Page and Stack in Bank 01/
                    ORA        #$0030               
                    STAL       $E1C068              
                    TYA                             ; Y = Sprite Target Screen Address (upper left corner)
                    TCS                             ; New Stack address
                    LDX        #$2222               ; Pattern #1 : 12
                    LDY        #$6222               ; Pattern #2 : 4
                    LDA        #$2626               ; Pattern #3 : 4
                    TCD                             
*--                                                 
                    LDA        #$2622               ; Line 0
                    STA        $A2,S                
                    LDA        $02,S                
                    AND        #$00F0               
                    ORA        #$2202               
                    STA        $02,S                
                    LDA        $A5,S                
                    AND        #$0FF0               
                    ORA        #$2002               
                    STA        $A5,S                
                    SEP        #$20                 
                    LDA        $A4,S                
                    AND        #$0F                 
                    ORA        #$20                 
                    STA        $A4,S                
                    REP        #$30                 
                    TSC                             ; Line 2
                    ADC        #$0140               
                    TCS                             
                    SEP        #$20                 
                    LDA        #$26                 
                    STA        $A6,S                
                    LDA        $00,S                
                    AND        #$F0                 
                    ORA        #$02                 
                    STA        $00,S                
                    REP        #$30                 
                    TSC                             
                    ADC        #$0006               
                    TCS                             
                    PHY                             
                    PHY                             
                    PHX                             
                    TSC                             ; Line 3
                    ADC        #$00A5               
                    TCS                             
                    SEP        #$20                 
                    LDA        #$62                 
                    STA        $A1,S                
                    REP        #$30                 
                    PHX                             
                    PHX                             
                    PHX                             
                    TSC                             ; Line 4
                    ADC        #$00A6               
                    TCS                             
                    SEP        #$20                 
                    LDA        $9B,S                
                    AND        #$F0                 
                    ORA        #$02                 
                    STA        $9B,S                
                    REP        #$30                 
                    PHX                             
                    PHX                             
                    PHX                             
                    TSC                             ; Line 5
                    ADC        #$00A7               
                    TCS                             
                    PHD                             
                    PEA        $2262                
                    PEA        $2262                
                    TSC                             ; Line 6
                    ADC        #$00A6               
                    TCS                             
                    LDA        #$6262               
                    STA        $9D,S                
                    LDA        $9B,S                
                    AND        #$00F0               
                    ORA        #$6202               
                    STA        $9B,S                
                    LDA        $9F,S                
                    AND        #$0F00               
                    ORA        #$2062               
                    STA        $9F,S                
                    PHY                             
                    PHD                             
                    PHD                             
                    TSC                             ; Line 8
                    ADC        #$0140               
                    TCS                             
                    LDA        $04,S                
                    AND        #$0F00               
                    ORA        #$2026               
                    STA        $04,S                
                    SEP        #$20                 
                    LDA        $02,S                
                    AND        #$0F                 
                    ORA        #$20                 
                    STA        $02,S                
                    REP        #$30                 
*--                                                 
                    LDAL       $E1C068              ; Direct Page and Stack in Bank 00/
                    AND        #$FFCF               
                    STAL       $E1C068              
                    LDA        StackAddress         ; Restore Stack
                    TCS                             
                    PLD                             ; Restore Direct Page
                    CLI                             ; Enable Interrupts
                    PLB
                    RTL                             
                                                    
*-----------------------------------                                

Sprite_SM_084       CLC                             ; Sprite #084 : 16x12, 267 bytes, 463 cycles
                    SEI                             ; Disable Interrupts
                    PHD                             ; Backup Direct Page
                    TSC                             ; Backup Stack
                    STA        StackAddress         
                    LDAL       $E1C068              ; Direct Page and Stack in Bank 01/
                    ORA        #$0030               
                    STAL       $E1C068              
                    TYA                             ; Y = Sprite Target Screen Address (upper left corner)
                    TCS                             ; New Stack address
                    LDX        #$2222               ; Pattern #1 : 22
                    LDY        #$2626               ; Pattern #2 : 4
                    LDA        #$6222               ; Pattern #3 : 4
                    TCD                             
*--                                                 
                    LDA        $02,S                ; Line 0
                    AND        #$00F0               
                    ORA        #$2202               
                    STA        $02,S                
                    SEP        #$20                 
                    LDA        $04,S                
                    AND        #$0F                 
                    ORA        #$20                 
                    STA        $04,S                
                    REP        #$30                 
                    TSC                             ; Line 1
                    ADC        #$00A4               
                    TCS                             
                    TXA                             
                    STA        $9E,S                
                    LDA        $9C,S                
                    AND        #$00F0               
                    ORA        #$2202               
                    STA        $9C,S                
                    LDA        $A0,S                
                    AND        #$0F00               
                    ORA        #$2026               
                    STA        $A0,S                
                    PHD                             
                    PHX                             
                    TSC                             ; Line 3
                    ADC        #$0140               
                    TCS                             
                    TXA                             
                    STA        $02,S                
                    LDA        $00,S                
                    AND        #$00F0               
                    ORA        #$2202               
                    STA        $00,S                
                    LDA        $04,S                
                    AND        #$0F00               
                    ORA        #$6062               
                    STA        $04,S                
                    LDA        $A6,S                
                    AND        #$0F00               
                    ORA        #$2026               
                    STA        $A6,S                
                    TSC                             ; Line 4
                    ADC        #$00A5               
                    TCS                             
                    PEA        $2622                
                    PHX                             
                    PHX                             
                    TSC                             ; Line 5
                    ADC        #$00A8               
                    TCS                             
                    PHD                             
                    PHX                             
                    PHX                             
                    PHX                             
                    TSC                             ; Line 6
                    ADC        #$00A8               
                    TCS                             
                    PHY                             
                    PHX                             
                    PHX                             
                    PHX                             
                    TSC                             ; Line 7
                    ADC        #$00A8               
                    TCS                             
                    LDA        $99,S                
                    AND        #$00F0               
                    ORA        #$6202               
                    STA        $99,S                
                    LDA        $9F,S                
                    AND        #$0F00               
                    ORA        #$2026               
                    STA        $9F,S                
                    PHD                             
                    PHX                             
                    PEA        $2226                
                    PEA        $2226                
                    TSC                             ; Line 8
                    ADC        #$00A6               
                    TCS                             
                    PEA        $2262                
                    PEA        $6262                
                    TSC                             ; Line 9
                    ADC        #$00A5               
                    TCS                             
                    LDA        $9D,S                
                    AND        #$00F0               
                    ORA        #$6202               
                    STA        $9D,S                
                    LDA        $9F,S                
                    AND        #$0F00               
                    ORA        #$2026               
                    STA        $9F,S                
                    SEP        #$20                 
                    LDA        $9B,S                
                    AND        #$F0                 
                    ORA        #$02                 
                    STA        $9B,S                
                    REP        #$30                 
                    PHD                             
                    PHY                             
                    PHY                             
                    TSC                             ; Line 11
                    ADC        #$0140               
                    TCS                             
                    SEP        #$20                 
                    LDA        $05,S                
                    AND        #$F0                 
                    ORA        #$02                 
                    STA        $05,S                
                    REP        #$30                 
*--                                                 
                    LDAL       $E1C068              ; Direct Page and Stack in Bank 00/
                    AND        #$FFCF               
                    STAL       $E1C068              
                    LDA        StackAddress         ; Restore Stack
                    TCS                             
                    PLD                             ; Restore Direct Page
                    CLI                             ; Enable Interrupts
                    PLB
                    RTL                             

*--------------------------

Sprite_HI_085       CLC                             ; Sprite #085 : 6x5, 122 bytes, 194 cycles
                    SEI                             ; Disable Interrupts
                    PHD                             ; Backup Direct Page
                    TSC                             ; Backup Stack
                    STA        StackAddress         
                    LDAL       $E1C068              ; Direct Page and Stack in Bank 01/
                    ORA        #$0030               
                    STAL       $E1C068              
                    TYA                             ; Y = Sprite Target Screen Address (upper left corner)
                    TCS                             ; New Stack address
*--                                                 
                    LDA        $01,S                ; Line 0
                    AND        #$0FF0               
                    ORA        #$2002               
                    STA        $01,S                
                    LDA        $A1,S                
                    AND        #$0FF0               
                    ORA        #$2002               
                    STA        $A1,S                
                    SEP        #$20                 
                    LDA        #$22                 
                    STA        $00,S                
                    STA        $A0,S                
                    REP        #$30                 
                    TSC                             ; Line 2
                    ADC        #$0140               
                    TCS                             
                    LDA        $A1,S                
                    AND        #$0FF0               
                    ORA        #$2002               
                    STA        $A1,S                
                    SEP        #$20                 
                    LDA        #$22                 
                    STA        $A0,S                
                    LDA        $01,S                
                    AND        #$0F                 
                    ORA        #$20                 
                    STA        $01,S                
                    REP        #$30                 
                    TSC                             ; Line 4
                    ADC        #$0140               
                    TCS                             
                    LDA        $01,S                
                    AND        #$0FF0               
                    ORA        #$2002               
                    STA        $01,S                
                    SEP        #$20                 
                    LDA        #$22                 
                    STA        $00,S                
                    REP        #$30                 
*--                                                 
                    LDAL       $E1C068              ; Direct Page and Stack in Bank 00/
                    AND        #$FFCF               
                    STAL       $E1C068              
                    LDA        StackAddress         ; Restore Stack
                    TCS                             
                    PLD                             ; Restore Direct Page
                    CLI                             ; Enable Interrupts
                    PLB
                    RTL                             
                                                    
*-----------------------------------                                

Sprite_HI_086       CLC                             ; Sprite #086 : 6x5, 120 bytes, 192 cycles
                    SEI                             ; Disable Interrupts
                    PHD                             ; Backup Direct Page
                    TSC                             ; Backup Stack
                    STA        StackAddress         
                    LDAL       $E1C068              ; Direct Page and Stack in Bank 01/
                    ORA        #$0030               
                    STAL       $E1C068              
                    TYA                             ; Y = Sprite Target Screen Address (upper left corner)
                    TCS                             ; New Stack address
*--                                                 
                    LDA        $00,S                ; Line 0
                    AND        #$00F0               
                    ORA        #$2202               
                    STA        $00,S                
                    LDA        $A1,S                
                    AND        #$0FF0               
                    ORA        #$2002               
                    STA        $A1,S                
                    SEP        #$20                 
                    LDA        #$22                 
                    STA        $A0,S                
                    REP        #$30                 
                    TSC                             ; Line 2
                    ADC        #$0140               
                    TCS                             
                    LDA        $A1,S                
                    AND        #$0FF0               
                    ORA        #$2002               
                    STA        $A1,S                
                    SEP        #$20                 
                    LDA        #$22                 
                    STA        $A0,S                
                    LDA        $00,S                
                    AND        #$0F                 
                    ORA        #$20                 
                    STA        $00,S                
                    LDA        $02,S                
                    AND        #$0F                 
                    ORA        #$20                 
                    STA        $02,S                
                    REP        #$30                 
                    TSC                             ; Line 4
                    ADC        #$0140               
                    TCS                             
                    LDA        $00,S                
                    AND        #$00F0               
                    ORA        #$2202               
                    STA        $00,S                
*--                                                 
                    LDAL       $E1C068              ; Direct Page and Stack in Bank 00/
                    AND        #$FFCF               
                    STAL       $E1C068              
                    LDA        StackAddress         ; Restore Stack
                    TCS                             
                    PLD                             ; Restore Direct Page
                    CLI                             ; Enable Interrupts
                    PLB
                    RTL                             
                                                    
*-----------------------------------                                

Sprite_HI_087       CLC                             ; Sprite #087 : 6x5, 111 bytes, 183 cycles
                    SEI                             ; Disable Interrupts
                    PHD                             ; Backup Direct Page
                    TSC                             ; Backup Stack
                    STA        StackAddress         
                    LDAL       $E1C068              ; Direct Page and Stack in Bank 01/
                    ORA        #$0030               
                    STAL       $E1C068              
                    TYA                             ; Y = Sprite Target Screen Address (upper left corner)
                    TCS                             ; New Stack address
                    LDX        #$2222               ; Pattern #1 : 2
*--                                                 
                    TXA                             ; Line 0
                    STA        $A0,S                
                    LDA        $00,S                
                    AND        #$F0F0               
                    ORA        #$0202               
                    STA        $00,S                
                    SEP        #$20                 
                    LDA        $A2,S                
                    AND        #$0F                 
                    ORA        #$20                 
                    STA        $A2,S                
                    REP        #$30                 
                    TSC                             ; Line 2
                    ADC        #$0140               
                    TCS                             
                    TXA                             
                    STA        $A0,S                
                    LDA        $00,S                
                    AND        #$F0F0               
                    ORA        #$0202               
                    STA        $00,S                
                    SEP        #$20                 
                    LDA        $A2,S                
                    AND        #$0F                 
                    ORA        #$20                 
                    STA        $A2,S                
                    REP        #$30                 
                    TSC                             ; Line 4
                    ADC        #$0140               
                    TCS                             
                    LDA        $00,S                
                    AND        #$F0F0               
                    ORA        #$0202               
                    STA        $00,S                
*--                                                 
                    LDAL       $E1C068              ; Direct Page and Stack in Bank 00/
                    AND        #$FFCF               
                    STAL       $E1C068              
                    LDA        StackAddress         ; Restore Stack
                    TCS                             
                    PLD                             ; Restore Direct Page
                    CLI                             ; Enable Interrupts
                    PLB
                    RTL                             
                                                    
*-----------------------------------                                

Sprite_HI_088       CLC                             ; Sprite #088 : 6x5, 135 bytes, 217 cycles
                    SEI                             ; Disable Interrupts
                    PHD                             ; Backup Direct Page
                    TSC                             ; Backup Stack
                    STA        StackAddress         
                    LDAL       $E1C068              ; Direct Page and Stack in Bank 01/
                    ORA        #$0030               
                    STAL       $E1C068              
                    TYA                             ; Y = Sprite Target Screen Address (upper left corner)
                    TCS                             ; New Stack address
                    LDX        #$2222               ; Pattern #1 : 2
*--                                                 
                    TXA                             ; Line 0
                    STA        $00,S                
                    SEP        #$20                 
                    LDA        $02,S                
                    AND        #$0F                 
                    ORA        #$20                 
                    STA        $02,S                
                    LDA        $A0,S                
                    AND        #$0F                 
                    ORA        #$20                 
                    STA        $A0,S                
                    LDA        $A2,S                
                    AND        #$0F                 
                    ORA        #$20                 
                    STA        $A2,S                
                    REP        #$30                 
                    TSC                             ; Line 2
                    ADC        #$0140               
                    TCS                             
                    LDA        $00,S                
                    AND        #$0F0F               
                    ORA        #$2020               
                    STA        $00,S                
                    SEP        #$20                 
                    LDA        $02,S                
                    AND        #$0F                 
                    ORA        #$20                 
                    STA        $02,S                
                    LDA        $A0,S                
                    AND        #$0F                 
                    ORA        #$20                 
                    STA        $A0,S                
                    LDA        $A2,S                
                    AND        #$0F                 
                    ORA        #$20                 
                    STA        $A2,S                
                    REP        #$30                 
                    TSC                             ; Line 4
                    ADC        #$0140               
                    TCS                             
                    TXA                             
                    STA        $00,S                
                    SEP        #$20                 
                    LDA        $02,S                
                    AND        #$0F                 
                    ORA        #$20                 
                    STA        $02,S                
                    REP        #$30                 
*--                                                 
                    LDAL       $E1C068              ; Direct Page and Stack in Bank 00/
                    AND        #$FFCF               
                    STAL       $E1C068              
                    LDA        StackAddress         ; Restore Stack
                    TCS                             
                    PLD                             ; Restore Direct Page
                    CLI                             ; Enable Interrupts
                    PLB
                    RTL                             
                                                    
*-----------------------------------                                

Sprite_SH_089       CLC                             ; Sprite #089 : 6x6, 92 bytes, 146 cycles
                    SEI                             ; Disable Interrupts
                    PHD                             ; Backup Direct Page
                    TSC                             ; Backup Stack
                    STA        StackAddress         
                    LDAL       $E1C068              ; Direct Page and Stack in Bank 01/
                    ORA        #$0030               
                    STAL       $E1C068              
                    TYA                             ; Y = Sprite Target Screen Address (upper left corner)
                    TCS                             ; New Stack address
                    LDX        #$2222               ; Pattern #1 : 1
                    LDY        #$2444               ; Pattern #2 : 1
*--                                                 
                    SEP        #$20                 ; Line 0
                    LDA        #$24                 
                    STA        $01,S                
                    STA        $A1,S                
                    REP        #$30                 
                    TSC                             ; Line 2
                    ADC        #$0140               
                    TCS                             
                    TYA                             
                    STA        $00,S                
                    TXA                             
                    STA        $A0,S                
                    SEP        #$20                 
                    LDA        #$44                 
                    STA        $02,S                
                    LDA        #$22                 
                    STA        $A2,S                
                    REP        #$30                 
                    TSC                             ; Line 4
                    ADC        #$0140               
                    TCS                             
                    SEP        #$20                 
                    LDA        #$24                 
                    STA        $01,S                
                    STA        $A1,S                
                    REP        #$30                 
*--                                                 
                    LDAL       $E1C068              ; Direct Page and Stack in Bank 00/
                    AND        #$FFCF               
                    STAL       $E1C068              
                    LDA        StackAddress         ; Restore Stack
                    TCS                             
                    PLD                             ; Restore Direct Page
                    CLI                             ; Enable Interrupts
                    PLB
                    RTL                             
                                                    
*-----------------------------------                                

Sprite_SH_08A       CLC                             ; Sprite #08A : 8x6, 128 bytes, 206 cycles
                    SEI                             ; Disable Interrupts
                    PHD                             ; Backup Direct Page
                    TSC                             ; Backup Stack
                    STA        StackAddress         
                    LDAL       $E1C068              ; Direct Page and Stack in Bank 01/
                    ORA        #$0030               
                    STAL       $E1C068              
                    TYA                             ; Y = Sprite Target Screen Address (upper left corner)
                    TCS                             ; New Stack address
*--                                                 
                    LDA        $02,S                ; Line 0
                    AND        #$0FF0               
                    ORA        #$4002               
                    STA        $02,S                
                    LDA        $A0,S                
                    AND        #$0FF0               
                    ORA        #$4002               
                    STA        $A0,S                
                    SEP        #$20                 
                    LDA        #$24                 
                    STA        $00,S                
                    STA        $A2,S                
                    REP        #$30                 
                    TSC                             ; Line 2
                    ADC        #$0140               
                    TCS                             
                    LDA        $01,S                
                    AND        #$0F00               
                    ORA        #$4022               
                    STA        $01,S                
                    LDA        $A1,S                
                    AND        #$0F00               
                    ORA        #$4022               
                    STA        $A1,S                
                    TSC                             ; Line 4
                    ADC        #$0140               
                    TCS                             
                    LDA        $00,S                
                    AND        #$0FF0               
                    ORA        #$4002               
                    STA        $00,S                
                    LDA        $A2,S                
                    AND        #$0FF0               
                    ORA        #$4002               
                    STA        $A2,S                
                    SEP        #$20                 
                    LDA        #$24                 
                    STA        $02,S                
                    STA        $A0,S                
                    REP        #$30                 
*--                                                 
                    LDAL       $E1C068              ; Direct Page and Stack in Bank 00/
                    AND        #$FFCF               
                    STAL       $E1C068              
                    LDA        StackAddress         ; Restore Stack
                    TCS                             
                    PLD                             ; Restore Direct Page
                    CLI                             ; Enable Interrupts
                    PLB
                    RTL                             

********************************************************************************