******************************************************************************************
*                                                                                        *
*  AppleIIgsKarate.Sprite2.s :  Compiled Sprites display Code for Sprite Bank #2.        *
*                                                                                        *
******************************************************************************************
*  Authors : Antoine VIGNAU / Olivier ZARDINI  *  Brutal Deluxe Software  *  April 2022  *
******************************************************************************************

*----------   Merlin 16+ Directives   ---------

                    mx         %00                  ; Assemble in 16 bit

                    rel                             ; Build a relocated S16 file
                    dsk        Sprite2.l            ; Name of the Segment

**************************************************************************************
*  DrawSpriteBank2() :  Display a Sprite on the Screen (IN:A=SpriteID,IN:Y=@Screen). *
**************************************************************************************
DrawSpriteBank2     ENT                             ; First Byte of this Segment
                    PHB
                    PHK
                    PLB                             ; Y=Target Screen Address ($2000-$9D00)
                    DEC                             ; A=Sprite Number ($0001-$008A)
                    ASL  
                    TAX
                    JMP        (TabSpriteBank2,X)

*----------   DrawSpriteBank2 Variables   ---------  
TabSpriteBank2      DA         Sprite_BR_000,Sprite_BR_000,Sprite_BR_000,Sprite_BR_000,Sprite_BR_000,Sprite_BR_000,Sprite_BR_000,Sprite_BR_000
                    DA         Sprite_BR_000,Sprite_BR_000,Sprite_BR_000,Sprite_BR_000,Sprite_BR_000,Sprite_BR_000,Sprite_BR_000,Sprite_BR_000
                    DA         Sprite_BR_000,Sprite_BR_000,Sprite_BR_000,Sprite_BR_000,Sprite_BR_000,Sprite_BR_000,Sprite_BR_000,Sprite_BR_000
                    DA         Sprite_BR_000,Sprite_BR_000,Sprite_BR_000,Sprite_BR_000,Sprite_BR_000,Sprite_BR_000,Sprite_BR_000,Sprite_BR_000
                    DA         Sprite_BR_000,Sprite_BR_000,Sprite_BR_000,Sprite_BR_000,Sprite_BR_000,Sprite_BR_000,Sprite_BR_000,Sprite_BR_000
                    DA         Sprite_BR_000,Sprite_BL_02A,Sprite_BL_02B,Sprite_BL_02C,Sprite_BL_02D,Sprite_BL_02E,Sprite_BL_02F,Sprite_BL_030
                    DA         Sprite_BL_031,Sprite_BL_032,Sprite_BL_033,Sprite_BL_034,Sprite_BL_035,Sprite_BL_036,Sprite_BL_037,Sprite_BL_038
                    DA         Sprite_BL_039,Sprite_BL_03A,Sprite_BL_03B,Sprite_BL_03C,Sprite_BL_03D,Sprite_BL_03E,Sprite_BL_03F,Sprite_AM_040
                    DA         Sprite_RR_041,Sprite_RR_042,Sprite_RR_043,Sprite_RR_044,Sprite_RR_045,Sprite_RR_046,Sprite_RR_047,Sprite_RR_048
                    DA         Sprite_RR_049,Sprite_RR_04A,Sprite_RR_04B,Sprite_RR_04C,Sprite_RR_04D,Sprite_RR_04E,Sprite_RR_04F,Sprite_RR_050
                    DA         Sprite_RR_051,Sprite_RR_052,Sprite_RR_053,Sprite_BR_000,Sprite_BR_000,Sprite_BR_000,Sprite_BR_000,Sprite_BR_000
                    DA         Sprite_BR_000,Sprite_BR_000,Sprite_BR_000,Sprite_BR_000,Sprite_BR_000,Sprite_BR_000,Sprite_BR_000,Sprite_BR_000
                    DA         Sprite_BR_000,Sprite_BR_000,Sprite_BR_000,Sprite_BR_000,Sprite_BR_000,Sprite_BR_000,Sprite_BR_000,Sprite_BR_000
                    DA         Sprite_BR_000,Sprite_BR_000,Sprite_BR_000,Sprite_BR_000,Sprite_BR_000,Sprite_BR_000,Sprite_BR_000,Sprite_BR_000
                    DA         Sprite_BR_000,Sprite_BR_000,Sprite_BR_000,Sprite_BR_000,Sprite_BR_000,Sprite_BR_000,Sprite_BR_000,Sprite_BR_000
                    DA         Sprite_BR_000,Sprite_BR_000,Sprite_BR_000,Sprite_BR_000,Sprite_BR_000,Sprite_BR_000,Sprite_BR_000,Sprite_BR_000
                    DA         Sprite_BR_000
                    
StackAddress        HEX        0000

*--------------------------------------------------
Sprite_BR_000       PLB                             ; Sprite #0 does not exist
                    RTL
     
*-----------------------------------                                
Sprite_BL_02A       CLC                             ; Sprite #02A : 64x49, 1830 bytes, 2930 cycles
                    SEI                             ; Disable Interrupts
                    PHD                             ; Backup Direct Page
                    TSC                             ; Backup Stack
                    STA        StackAddress         
                    LDAL       $E1C068              ; Direct Page and Stack in Bank 01/
                    ORA        #$0030               
                    STAL       $E1C068              
                    TYA                             ; Y = Sprite Target Screen Address (upper left corner)
                    TCS                             ; New Stack address
                    LDX        #$5777               ; Pattern #1 : 21
                    LDY        #$6767               ; Pattern #2 : 19
                    LDA        #$4444               ; Pattern #3 : 11
                    TCD                             
*--                                                 
                    TDC                             ; Line 0
                    STA        $BA,S                
                    LDA        $1A,S                
                    AND        #$00F0               
                    ORA        #$4404               
                    STA        $1A,S                
                    TSC                             ; Line 2
                    ADC        #$0140               
                    TCS                             
                    LDA        #$7766               
                    STA        $B8,S                
                    LDA        $18,S                
                    AND        #$00F0               
                    ORA        #$6406               
                    STA        $18,S                
                    LDA        $1A,S                
                    AND        #$0F00               
                    ORA        #$4044               
                    STA        $1A,S                
                    SEP        #$20                 
                    LDA        #$44                 
                    STA        $BA,S                
                    REP        #$30                 
                    TSC                             ; Line 4
                    ADC        #$0140               
                    TCS                             
                    LDA        #$7577               
                    STA        $19,S                
                    LDA        $17,S                
                    AND        #$00F0               
                    ORA        #$6606               
                    STA        $17,S                
                    TSC                             ; Line 5
                    ADC        #$00BA               
                    TCS                             
                    TYA                             
                    STA        $9D,S                
                    LDA        $9F,S                
                    AND        #$0F00               
                    ORA        #$7075               
                    STA        $9F,S                
                    SEP        #$20                 
                    LDA        $9C,S                
                    AND        #$F0                 
                    ORA        #$06                 
                    STA        $9C,S                
                    REP        #$30                 
                    PHX                             
                    PEA        $7716                
                    TSC                             ; Line 7
                    ADC        #$012A               
                    TCS                             
                    SEP        #$20                 
                    LDA        $15,S                
                    AND        #$F0                 
                    ORA        #$01                 
                    STA        $15,S                
                    LDA        $B9,S                
                    AND        #$0F                 
                    ORA        #$70                 
                    STA        $B9,S                
                    REP        #$30                 
                    TSC                             
                    ADC        #$0019               
                    TCS                             
                    PHX                             
                    PEA        $7666                
                    TSC                             ; Line 8
                    ADC        #$00A3               
                    TCS                             
                    SEP        #$20                 
                    LDA        $9C,S                
                    AND        #$F0                 
                    ORA        #$01                 
                    STA        $9C,S                
                    REP        #$30                 
                    PEA        $7567                
                    PEA        $6717                
                    TSC                             ; Line 9
                    ADC        #$00A4               
                    TCS                             
                    TYA                             
                    STA        $9D,S                
                    LDA        $9B,S                
                    AND        #$00F0               
                    ORA        #$6701               
                    STA        $9B,S                
                    LDA        $9F,S                
                    AND        #$0F00               
                    ORA        #$7075               
                    STA        $9F,S                
                    PHX                             
                    PEA        $7676                
                    TSC                             ; Line 11
                    ADC        #$012C               
                    TCS                             
                    LDA        $B6,S                
                    AND        #$0F00               
                    ORA        #$7075               
                    STA        $B6,S                
                    SEP        #$20                 
                    LDA        #$66                 
                    STA        $13,S                
                    REP        #$30                 
                    TSC                             
                    ADC        #$0017               
                    TCS                             
                    PHX                             
                    PEA        $7676                
                    TSC                             ; Line 12
                    ADC        #$00A2               
                    TCS                             
                    PEA        $7767                
                    PEA        $6766                
                    TSC                             ; Line 13
                    ADC        #$00A5               
                    TCS                             
                    SEP        #$20                 
                    LDA        $A0,S                
                    AND        #$0F                 
                    ORA        #$70                 
                    STA        $A0,S                
                    REP        #$30                 
                    PEA        $5757                
                    PEA        $7776                
                    PEA        $6666                
                    TSC                             ; Line 14
                    ADC        #$009A               
                    TCS                             
                    LDA        $A2,S                
                    AND        #$0F00               
                    ORA        #$7076               
                    STA        $A2,S                
                    SEP        #$20                 
                    LDA        #$57                 
                    STA        $AB,S                
                    REP        #$30                 
                    PEA        $7757                
                    PEA        $7777                
                    TSC                             
                    ADC        #$000F               
                    TCS                             
                    PEA        $7575                
                    PHY                             
                    PEA        $6676                
                    TSC                             ; Line 15
                    ADC        #$009C               
                    TCS                             
                    LDA        $A9,S                
                    AND        #$0F00               
                    ORA        #$7075               
                    STA        $A9,S                
                    PEA        $7675                
                    PEA        $7576                
                    PEA        $7667                
                    TSC                             
                    ADC        #$000F               
                    TCS                             
                    PHX                             
                    PEA        $7666                
                    PEA        $6666                
                    TSC                             ; Line 16
                    ADC        #$00A5               
                    TCS                             
                    LDA        $92,S                
                    AND        #$00F0               
                    ORA        #$6707               
                    STA        $92,S                
                    PEA        $7577                
                    PHY                             
                    PEA        $6666                
                    PEA        $6367                
                    PEA        $5757                
                    PHY                             
                    PEA        $6777                
                    TSC                             ; Line 17
                    ADC        #$00AF               
                    TCS                             
                    LDA        $91,S                
                    AND        #$00F0               
                    ORA        #$7706               
                    STA        $91,S                
                    LDA        $9F,S                
                    AND        #$0F00               
                    ORA        #$7075               
                    STA        $9F,S                
                    PEA        $5757                
                    PEA        $7777                
                    PEA        $6667                
                    PEA        $6733                
                    PEA        $7675                
                    PHY                             
                    PEA        $6677                
                    TSC                             ; Line 18
                    ADC        #$00AC               
                    TCS                             
                    SEP        #$20                 
                    LDA        $93,S                
                    AND        #$F0                 
                    ORA        #$05                 
                    STA        $93,S                
                    REP        #$30                 
                    PEA        $7575                
                    PEA        $7776                
                    PEA        $6633                
                    PHX                             
                    PEA        $7666                
                    PEA        $5177                
                    TSC                             ; Line 19
                    ADC        #$00AD               
                    TCS                             
                    LDA        #$3553               
                    STA        $8E,S                
                    SEP        #$20                 
                    LDA        #$55                 
                    STA        $90,S                
                    LDA        $A0,S                
                    AND        #$0F                 
                    ORA        #$70                 
                    STA        $A0,S                
                    REP        #$30                 
                    PEA        $5757                
                    PHX                             
                    PHY                             
                    PEA        $3375                
                    PHY                             
                    PEA        $5177                
                    PEA        $7757                
                    TSC                             ; Line 20
                    ADC        #$00AD               
                    TCS                             
                    LDA        #$5535               
                    STA        $90,S                
                    LDA        $8E,S                
                    AND        #$00F0               
                    ORA        #$5305               
                    STA        $8E,S                
                    SEP        #$20                 
                    LDA        $92,S                
                    AND        #$0F                 
                    ORA        #$50                 
                    STA        $92,S                
                    REP        #$30                 
                    PEA        $7575                
                    PEA        $7776                
                    PEA        $6636                
                    PEA        $5767                
                    PEA        $1675                
                    PEA        $7557                
                    PEA        $7567                
                    TSC                             ; Line 21
                    ADC        #$00AE               
                    TCS                             
                    SEP        #$20                 
                    LDA        #$75                 
                    STA        $A0,S                
                    REP        #$30                 
                    PEA        $5757                
                    PEA        $7767                
                    PEA        $6736                
                    PEA        $7517                
                    PEA        $5757                
                    PEA        $7755                
                    PEA        $7766                
                    TSC                             ; Line 22
                    ADC        #$00AD               
                    TCS                             
                    SEP        #$20                 
                    LDA        $A1,S                
                    AND        #$0F                 
                    ORA        #$50                 
                    STA        $A1,S                
                    REP        #$30                 
                    PEA        $7575                
                    PEA        $7776                
                    PEA        $3657                
                    PEA        $6677                
                    PEA        $7555                
                    PEA        $7766                
                    PEA        $4654                
                    PEA        $5535                
                    PEA        $5355                
                    TSC                             ; Line 23
                    ADC        #$00B2               
                    TCS                             
                    PEA        $5757                
                    PHY                             
                    PEA        $3675                
                    PEA        $6576                
                    PEA        $5577                
                    PEA        $6644                
                    PHD                             
                    PEA        $5435                
                    PEA        $5355                
                    TSC                             ; Line 24
                    ADC        #$00B2               
                    TCS                             
                    PEA        $7575                
                    PEA        $7776                
                    PEA        $3653                
                    PEA        $6716                
                    PEA        $7567                
                    PHD                             
                    PHD                             
                    PEA        $5535                
                    PEA        $5355                
                    TSC                             ; Line 25
                    ADC        #$00B2               
                    TCS                             
                    LDA        #$7577               
                    STA        $9E,S                
                    LDA        $9B,S                
                    AND        #$F0F0               
                    ORA        #$0303               
                    STA        $9B,S                
                    SEP        #$20                 
                    LDA        #$55                 
                    STA        $8F,S                
                    LDA        #$66                 
                    STA        $9D,S                
                    LDA        $94,S                
                    AND        #$0F                 
                    ORA        #$40                 
                    STA        $94,S                
                    LDA        $A0,S                
                    AND        #$0F                 
                    ORA        #$70                 
                    STA        $A0,S                
                    REP        #$30                 
                    PEA        $5757                
                    PEA        $7767                
                    PEA        $3373                
                    PEA        $7566                
                    PEA        $7746                
                    PEA        $6666                
                    PHD                             
                    PEA        $4434                
                    PEA        $5355                
                    TSC                             ; Line 26
                    ADC        #$00A5               
                    TCS                             
                    TXA                             
                    STA        $AB,S                
                    LDA        $A1,S                
                    AND        #$F00F               
                    ORA        #$0640               
                    STA        $A1,S                
                    LDA        $A8,S                
                    AND        #$F0F0               
                    ORA        #$0303               
                    STA        $A8,S                
                    SEP        #$20                 
                    LDA        #$66                 
                    STA        $AA,S                
                    LDA        $9C,S                
                    AND        #$F0                 
                    ORA        #$05                 
                    STA        $9C,S                
                    LDA        $A7,S                
                    AND        #$0F                 
                    ORA        #$50                 
                    STA        $A7,S                
                    LDA        $AD,S                
                    AND        #$0F                 
                    ORA        #$50                 
                    STA        $AD,S                
                    REP        #$30                 
                    PHD                             
                    PEA        $3453                
                    TSC                             
                    ADC        #$000B               
                    TCS                             
                    PEA        $7767                
                    PEA        $4177                
                    PEA        $5567                
                    TSC                             ; Line 27
                    ADC        #$009F               
                    TCS                             
                    LDA        #$7577               
                    STA        $AB,S                
                    LDA        $A1,S                
                    AND        #$F00F               
                    ORA        #$0640               
                    STA        $A1,S                
                    LDA        $A8,S                
                    AND        #$F00F               
                    ORA        #$0330               
                    STA        $A8,S                
                    SEP        #$20                 
                    LDA        #$67                 
                    STA        $AA,S                
                    LDA        $9C,S                
                    AND        #$F0                 
                    ORA        #$05                 
                    STA        $9C,S                
                    LDA        $A7,S                
                    AND        #$0F                 
                    ORA        #$70                 
                    STA        $A7,S                
                    LDA        $AD,S                
                    AND        #$0F                 
                    ORA        #$70                 
                    STA        $AD,S                
                    REP        #$30                 
                    PEA        $4454                
                    PEA        $3453                
                    TSC                             
                    ADC        #$000A               
                    TCS                             
                    PEA        $4756                
                    PEA        $5577                
                    TSC                             ; Line 28
                    ADC        #$009E               
                    TCS                             
                    LDA        #$3453               
                    STA        $9D,S                
                    TXA                             
                    STA        $AB,S                
                    LDA        $A9,S                
                    AND        #$00F0               
                    ORA        #$6606               
                    STA        $A9,S                
                    SEP        #$20                 
                    LDA        #$44                 
                    STA        $9F,S                
                    LDA        $AD,S                
                    AND        #$0F                 
                    ORA        #$50                 
                    STA        $AD,S                
                    REP        #$30                 
                    PEA        $4454                
                    PEA        $3453                
                    TSC                             
                    ADC        #$000A               
                    TCS                             
                    PEA        $4744                
                    PEA        $6567                
                    TSC                             ; Line 29
                    ADC        #$00A4               
                    TCS                             
                    LDA        #$5716               
                    STA        $9D,S                
                    LDA        #$7766               
                    STA        $A4,S                
                    LDA        $9F,S                
                    AND        #$0F00               
                    ORA        #$4074               
                    STA        $9F,S                
                    LDA        $A6,S                
                    AND        #$0F00               
                    ORA        #$7075               
                    STA        $A6,S                
                    SEP        #$20                 
                    LDA        $A3,S                
                    AND        #$F0                 
                    ORA        #$01                 
                    STA        $A3,S                
                    REP        #$30                 
                    PHD                             
                    PEA        $7766                
                    TSC                             ; Line 31
                    ADC        #$013A               
                    TCS                             
                    LDA        #$7565               
                    STA        $08,S                
                    TXA                             
                    STA        $0F,S                
                    LDA        #$5766               
                    STA        $A8,S                
                    LDA        #$7766               
                    STA        $AE,S                
                    LDA        $0D,S                
                    AND        #$00F0               
                    ORA        #$6706               
                    STA        $0D,S                
                    LDA        $B0,S                
                    AND        #$0F00               
                    ORA        #$7075               
                    STA        $B0,S                
                    SEP        #$20                 
                    LDA        $07,S                
                    AND        #$F0                 
                    ORA        #$01                 
                    STA        $07,S                
                    LDA        $11,S                
                    AND        #$0F                 
                    ORA        #$50                 
                    STA        $11,S                
                    LDA        $AA,S                
                    AND        #$0F                 
                    ORA        #$50                 
                    STA        $AA,S                
                    LDA        $AD,S                
                    AND        #$F0                 
                    ORA        #$01                 
                    STA        $AD,S                
                    REP        #$30                 
                    TSC                             ; Line 33
                    ADC        #$0140               
                    TCS                             
                    TXA                             
                    STA        $0F,S                
                    TYA                             
                    STA        $A8,S                
                    STA        $AE,S                
                    LDA        $08,S                
                    AND        #$00F0               
                    ORA        #$7706               
                    STA        $08,S                
                    LDA        $0D,S                
                    AND        #$00F0               
                    ORA        #$6606               
                    STA        $0D,S                
                    SEP        #$20                 
                    LDA        #$75                 
                    STA        $B0,S                
                    LDA        $0A,S                
                    AND        #$0F                 
                    ORA        #$70                 
                    STA        $0A,S                
                    LDA        $AA,S                
                    AND        #$0F                 
                    ORA        #$50                 
                    STA        $AA,S                
                    REP        #$30                 
                    TSC                             ; Line 35
                    ADC        #$0140               
                    TCS                             
                    LDA        #$7716               
                    STA        $08,S                
                    TXA                             
                    STA        $0F,S                
                    LDA        #$7767               
                    STA        $A8,S                
                    TYA                             
                    STA        $AE,S                
                    SEP        #$20                 
                    LDA        #$16                 
                    STA        $0E,S                
                    LDA        #$75                 
                    STA        $B0,S                
                    LDA        $0A,S                
                    AND        #$0F                 
                    ORA        #$70                 
                    STA        $0A,S                
                    LDA        $A7,S                
                    AND        #$F0                 
                    ORA        #$01                 
                    STA        $A7,S                
                    REP        #$30                 
                    TSC                             ; Line 37
                    ADC        #$0140               
                    TCS                             
                    TXA                             
                    STA        $0F,S                
                    LDA        #$4744               
                    STA        $A7,S                
                    TYA                             
                    STA        $AE,S                
                    LDA        $07,S                
                    AND        #$00F0               
                    ORA        #$7704               
                    STA        $07,S                
                    SEP        #$20                 
                    LDA        #$16                 
                    STA        $0E,S                
                    LDA        #$75                 
                    STA        $B0,S                
                    LDA        $09,S                
                    AND        #$0F                 
                    ORA        #$70                 
                    STA        $09,S                
                    REP        #$30                 
                    TSC                             ; Line 39
                    ADC        #$0140               
                    TCS                             
                    TXA                             
                    STA        $0F,S                
                    TYA                             
                    STA        $AE,S                
                    LDA        $07,S                
                    AND        #$0F00               
                    ORA        #$4044               
                    STA        $07,S                
                    SEP        #$20                 
                    LDA        #$16                 
                    STA        $0E,S                
                    LDA        #$44                 
                    STA        $A7,S                
                    LDA        #$75                 
                    STA        $B0,S                
                    REP        #$30                 
                    TSC                             ; Line 41
                    ADC        #$0140               
                    TCS                             
                    TXA                             
                    STA        $0F,S                
                    LDA        #$7567               
                    STA        $AF,S                
                    SEP        #$20                 
                    LDA        #$66                 
                    STA        $0E,S                
                    LDA        $AE,S                
                    AND        #$F0                 
                    ORA        #$06                 
                    STA        $AE,S                
                    REP        #$30                 
                    TSC                             ; Line 43
                    ADC        #$0140               
                    TCS                             
                    LDA        #$7777               
                    STA        $0F,S                
                    LDA        #$7567               
                    STA        $AF,S                
                    SEP        #$20                 
                    LDA        $0E,S                
                    AND        #$F0                 
                    ORA        #$06                 
                    STA        $0E,S                
                    LDA        $AE,S                
                    AND        #$F0                 
                    ORA        #$06                 
                    STA        $AE,S                
                    REP        #$30                 
                    TSC                             ; Line 45
                    ADC        #$0140               
                    TCS                             
                    LDA        $09,S                
                    AND        #$F0F0               
                    ORA        #$0505               
                    STA        $09,S                
                    LDA        $0B,S                
                    AND        #$F0F0               
                    ORA        #$0505               
                    STA        $0B,S                
                    LDA        $0D,S                
                    AND        #$F0F0               
                    ORA        #$0605               
                    STA        $0D,S                
                    LDA        $0F,S                
                    AND        #$0F00               
                    ORA        #$7077               
                    STA        $0F,S                
                    LDA        $11,S                
                    AND        #$0F0F               
                    ORA        #$5050               
                    STA        $11,S                
                    LDA        $13,S                
                    AND        #$0F0F               
                    ORA        #$5050               
                    STA        $13,S                
                    LDA        $A2,S                
                    AND        #$0F0F               
                    ORA        #$5050               
                    STA        $A2,S                
                    LDA        $A4,S                
                    AND        #$0F0F               
                    ORA        #$5050               
                    STA        $A4,S                
                    LDA        $A6,S                
                    AND        #$0F0F               
                    ORA        #$5050               
                    STA        $A6,S                
                    LDA        $A8,S                
                    AND        #$0F0F               
                    ORA        #$5050               
                    STA        $A8,S                
                    LDA        $AA,S                
                    AND        #$0F0F               
                    ORA        #$5050               
                    STA        $AA,S                
                    LDA        $AC,S                
                    AND        #$0F0F               
                    ORA        #$5050               
                    STA        $AC,S                
                    LDA        $AE,S                
                    AND        #$000F               
                    ORA        #$4450               
                    STA        $AE,S                
                    LDA        $B0,S                
                    AND        #$F000               
                    ORA        #$0545               
                    STA        $B0,S                
                    LDA        $B2,S                
                    AND        #$F0F0               
                    ORA        #$0505               
                    STA        $B2,S                
                    LDA        $B4,S                
                    AND        #$F0F0               
                    ORA        #$0505               
                    STA        $B4,S                
                    LDA        $B6,S                
                    AND        #$F0F0               
                    ORA        #$0505               
                    STA        $B6,S                
                    LDA        $B8,S                
                    AND        #$F0F0               
                    ORA        #$0505               
                    STA        $B8,S                
                    LDA        $BA,S                
                    AND        #$F0F0               
                    ORA        #$0505               
                    STA        $BA,S                
                    LDA        $BC,S                
                    AND        #$F0F0               
                    ORA        #$0505               
                    STA        $BC,S                
                    LDA        $BE,S                
                    AND        #$F0F0               
                    ORA        #$0505               
                    STA        $BE,S                
                    TSC                             ; Line 47
                    ADC        #$0140               
                    TCS                             
                    TDC                             
                    STA        $0E,S                
                    LDA        #$4544               
                    STA        $AE,S                
                    LDA        $01,S                
                    AND        #$F0F0               
                    ORA        #$0505               
                    STA        $01,S                
                    LDA        $03,S                
                    AND        #$F0F0               
                    ORA        #$0505               
                    STA        $03,S                
                    LDA        $05,S                
                    AND        #$F0F0               
                    ORA        #$0505               
                    STA        $05,S                
                    LDA        $07,S                
                    AND        #$F0F0               
                    ORA        #$0505               
                    STA        $07,S                
                    LDA        $09,S                
                    AND        #$F0F0               
                    ORA        #$0505               
                    STA        $09,S                
                    LDA        $0B,S                
                    AND        #$F0F0               
                    ORA        #$0505               
                    STA        $0B,S                
                    LDA        $10,S                
                    AND        #$0F0F               
                    ORA        #$5040               
                    STA        $10,S                
                    LDA        $12,S                
                    AND        #$0F0F               
                    ORA        #$5050               
                    STA        $12,S                
                    LDA        $14,S                
                    AND        #$0F0F               
                    ORA        #$5050               
                    STA        $14,S                
                    LDA        $16,S                
                    AND        #$0F0F               
                    ORA        #$5050               
                    STA        $16,S                
                    LDA        $18,S                
                    AND        #$0F0F               
                    ORA        #$5050               
                    STA        $18,S                
                    LDA        $1A,S                
                    AND        #$0F0F               
                    ORA        #$5050               
                    STA        $1A,S                
                    LDA        $1C,S                
                    AND        #$0F0F               
                    ORA        #$5050               
                    STA        $1C,S                
                    LDA        $A3,S                
                    AND        #$0F0F               
                    ORA        #$5050               
                    STA        $A3,S                
                    LDA        $AC,S                
                    AND        #$0F0F               
                    ORA        #$5050               
                    STA        $AC,S                
                    LDA        $B1,S                
                    AND        #$F0F0               
                    ORA        #$0505               
                    STA        $B1,S                
                    LDA        $B3,S                
                    AND        #$F0F0               
                    ORA        #$0505               
                    STA        $B3,S                
                    LDA        $B5,S                
                    AND        #$F0F0               
                    ORA        #$0505               
                    STA        $B5,S                
                    SEP        #$20                 
                    LDA        $0D,S                
                    AND        #$F0                 
                    ORA        #$05                 
                    STA        $0D,S                
                    LDA        $A5,S                
                    AND        #$0F                 
                    ORA        #$50                 
                    STA        $A5,S                
                    LDA        $B0,S                
                    AND        #$F0                 
                    ORA        #$05                 
                    STA        $B0,S                
                    REP        #$30                 
*--                                                 
                    LDAL       $E1C068              ; Direct Page and Stack in Bank 00/
                    AND        #$FFCF               
                    STAL       $E1C068              
                    LDA        StackAddress         ; Restore Stack
                    TCS                             
                    PLD                             ; Restore Direct Page
                    CLI                             ; Enable Interrupts
                    PLB
                    RTL                             
                                                    
*-----------------------------------                                
Sprite_BL_02B       CLC                             ; Sprite #02B : 32x56, 1772 bytes, 2837 cycles
                    SEI                             ; Disable Interrupts
                    PHD                             ; Backup Direct Page
                    TSC                             ; Backup Stack
                    STA        StackAddress         
                    LDAL       $E1C068              ; Direct Page and Stack in Bank 01/
                    ORA        #$0030               
                    STAL       $E1C068              
                    TYA                             ; Y = Sprite Target Screen Address (upper left corner)
                    TCS                             ; New Stack address
                    LDX        #$7575               ; Pattern #1 : 18
                    LDY        #$5777               ; Pattern #2 : 15
                    LDA        #$5757               ; Pattern #3 : 14
                    TCD                             
*--                                                 
                    LDA        #$5555               ; Line 0
                    STA        $0B,S                
                    STA        $AA,S                
                    LDA        $AC,S                
                    AND        #$0F00               
                    ORA        #$5055               
                    STA        $AC,S                
                    TSC                             ; Line 2
                    ADC        #$0140               
                    TCS                             
                    SEP        #$20                 
                    LDA        $09,S                
                    AND        #$F0                 
                    ORA        #$05                 
                    STA        $09,S                
                    LDA        $A9,S                
                    AND        #$F0                 
                    ORA        #$03                 
                    STA        $A9,S                
                    REP        #$30                 
                    TSC                             
                    ADC        #$000D               
                    TCS                             
                    PEA        $5555                
                    PEA        $5555                
                    TSC                             ; Line 3
                    ADC        #$00A4               
                    TCS                             
                    SEP        #$20                 
                    LDA        $9C,S                
                    AND        #$F0                 
                    ORA        #$03                 
                    STA        $9C,S                
                    REP        #$30                 
                    PEA        $3333                
                    PEA        $3333                
                    TSC                             ; Line 4
                    ADC        #$00A4               
                    TCS                             
                    SEP        #$20                 
                    LDA        $9C,S                
                    AND        #$F0                 
                    ORA        #$04                 
                    STA        $9C,S                
                    REP        #$30                 
                    PEA        $3333                
                    PEA        $3333                
                    TSC                             ; Line 5
                    ADC        #$00A4               
                    TCS                             
                    SEP        #$20                 
                    LDA        $9C,S                
                    AND        #$F0                 
                    ORA        #$04                 
                    STA        $9C,S                
                    REP        #$30                 
                    PEA        $5555                
                    PEA        $4544                
                    TSC                             ; Line 6
                    ADC        #$00A4               
                    TCS                             
                    SEP        #$20                 
                    LDA        #$55                 
                    STA        $A0,S                
                    REP        #$30                 
                    PEA        $5555                
                    PEA        $4555                
                    TSC                             ; Line 7
                    ADC        #$00A3               
                    TCS                             
                    SEP        #$20                 
                    LDA        $A1,S                
                    AND        #$0F                 
                    ORA        #$50                 
                    STA        $A1,S                
                    REP        #$30                 
                    PEA        $4545                
                    PEA        $4444                
                    TSC                             ; Line 8
                    ADC        #$00A4               
                    TCS                             
                    LDA        #$4444               
                    STA        $9E,S                
                    LDA        $A0,S                
                    AND        #$0F00               
                    ORA        #$5045               
                    STA        $A0,S                
                    SEP        #$20                 
                    LDA        $99,S                
                    AND        #$0F                 
                    ORA        #$40                 
                    STA        $99,S                
                    LDA        $9D,S                
                    AND        #$F0                 
                    ORA        #$04                 
                    STA        $9D,S                
                    REP        #$30                 
                    PEA        $4544                
                    PEA        $4444                
                    TSC                             ; Line 10
                    ADC        #$0138               
                    TCS                             
                    LDA        #$4444               
                    STA        $0A,S                
                    LDA        $04,S                
                    AND        #$00F0               
                    ORA        #$4404               
                    STA        $04,S                
                    LDA        $A4,S                
                    AND        #$00F0               
                    ORA        #$4404               
                    STA        $A4,S                
                    LDA        $AA,S                
                    AND        #$00F0               
                    ORA        #$4404               
                    STA        $AA,S                
                    SEP        #$20                 
                    LDA        $09,S                
                    AND        #$F0                 
                    ORA        #$04                 
                    STA        $09,S                
                    LDA        $AC,S                
                    AND        #$0F                 
                    ORA        #$60                 
                    STA        $AC,S                
                    REP        #$30                 
                    TSC                             ; Line 12
                    ADC        #$0140               
                    TCS                             
                    SEP        #$20                 
                    LDA        #$44                 
                    STA        $05,S                
                    STA        $A5,S                
                    LDA        $08,S                
                    AND        #$F0                 
                    ORA        #$06                 
                    STA        $08,S                
                    REP        #$30                 
                    TSC                             
                    ADC        #$000C               
                    TCS                             
                    PEA        $1646                
                    PEA        $5476                
                    TSC                             ; Line 13
                    ADC        #$00A5               
                    TCS                             
                    LDA        $97,S                
                    AND        #$00F0               
                    ORA        #$7605               
                    STA        $97,S                
                    LDA        $9A,S                
                    AND        #$00F0               
                    ORA        #$7601               
                    STA        $9A,S                
                    LDA        $A0,S                
                    AND        #$0F00               
                    ORA        #$6066               
                    STA        $A0,S                
                    PEA        $5667                
                    PEA        $6144                
                    PEA        $6567                
                    TSC                             ; Line 14
                    ADC        #$00A5               
                    TCS                             
                    LDA        $98,S                
                    AND        #$00F0               
                    ORA        #$7107               
                    STA        $98,S                
                    PEA        $7516                
                    PEA        $4654                
                    TSC                             ; Line 15
                    ADC        #$00A6               
                    TCS                             
                    LDA        $97,S                
                    AND        #$F000               
                    ORA        #$0166               
                    STA        $97,S                
                    SEP        #$20                 
                    LDA        $96,S                
                    AND        #$F0                 
                    ORA        #$05                 
                    STA        $96,S                
                    LDA        $A1,S                
                    AND        #$0F                 
                    ORA        #$60                 
                    STA        $A1,S                
                    REP        #$30                 
                    PEA        $6667                
                    PEA        $5667                
                    PEA        $6154                
                    PEA        $7617                
                    TSC                             ; Line 16
                    ADC        #$00A8               
                    TCS                             
                    LDA        $96,S                
                    AND        #$00F0               
                    ORA        #$7107               
                    STA        $96,S                
                    LDA        $A0,S                
                    AND        #$0F00               
                    ORA        #$7075               
                    STA        $A0,S                
                    PEA        $7776                
                    PEA        $6775                
                    PEA        $1646                
                    PEA        $6567                
                    TSC                             ; Line 17
                    ADC        #$00A7               
                    TCS                             
                    LDA        $97,S                
                    AND        #$00F0               
                    ORA        #$6605               
                    STA        $97,S                
                    PEA        $6777                
                    PEA        $5647                
                    PEA        $6465                
                    PEA        $7766                
                    TSC                             ; Line 18
                    ADC        #$00AA               
                    TCS                             
                    LDA        $95,S                
                    AND        #$00F0               
                    ORA        #$7607               
                    STA        $95,S                
                    PHY                             
                    PEA        $7675                
                    PEA        $6744                
                    PEA        $4456                
                    PEA        $6767                
                    TSC                             ; Line 19
                    ADC        #$00AA               
                    TCS                             
                    LDA        $95,S                
                    AND        #$00F0               
                    ORA        #$6705               
                    STA        $95,S                
                    PHX                             
                    PEA        $6755                
                    PEA        $4444                
                    PEA        $4461                
                    PEA        $7576                
                    TSC                             ; Line 20
                    ADC        #$00AA               
                    TCS                             
                    SEP        #$20                 
                    LDA        #$76                 
                    STA        $96,S                
                    REP        #$30                 
                    PHY                             
                    PEA        $6665                
                    PEA        $4464                
                    PEA        $7516                
                    PEA        $5767                
                    TSC                             ; Line 21
                    ADC        #$00AA               
                    TCS                             
                    SEP        #$20                 
                    LDA        $96,S                
                    AND        #$F0                 
                    ORA        #$07                 
                    STA        $96,S                
                    REP        #$30                 
                    PHX                             
                    PEA        $6766                
                    PEA        $4775                
                    PEA        $5767                
                    PEA        $7175                
                    TSC                             ; Line 22
                    ADC        #$00AA               
                    TCS                             
                    SEP        #$20                 
                    LDA        $98,S                
                    AND        #$F0                 
                    ORA        #$07                 
                    STA        $98,S                
                    REP        #$30                 
                    PHY                             
                    PEA        $6657                
                    PHY                             
                    PEA        $6775                
                    PEA        $5657                
                    TSC                             ; Line 23
                    ADC        #$00AA               
                    TCS                             
                    SEP        #$20                 
                    LDA        $98,S                
                    AND        #$F0                 
                    ORA        #$05                 
                    STA        $98,S                
                    REP        #$30                 
                    PHX                             
                    PEA        $7775                
                    PEA        $7577                
                    PEA        $7756                
                    TSC                             ; Line 24
                    ADC        #$00A8               
                    TCS                             
                    SEP        #$20                 
                    LDA        $98,S                
                    AND        #$F0                 
                    ORA        #$06                 
                    STA        $98,S                
                    REP        #$30                 
                    PHD                             
                    PHD                             
                    PEA        $7777                
                    PEA        $6767                
                    TSC                             ; Line 25
                    ADC        #$00A8               
                    TCS                             
                    LDA        $9F,S                
                    AND        #$0F00               
                    ORA        #$5057               
                    STA        $9F,S                
                    SEP        #$20                 
                    LDA        $98,S                
                    AND        #$F0                 
                    ORA        #$06                 
                    STA        $98,S                
                    REP        #$30                 
                    PHX                             
                    PHX                             
                    PEA        $7767                
                    PEA        $7666                
                    TSC                             ; Line 26
                    ADC        #$00A6               
                    TCS                             
                    SEP        #$20                 
                    LDA        $9A,S                
                    AND        #$F0                 
                    ORA        #$06                 
                    STA        $9A,S                
                    REP        #$30                 
                    PHY                             
                    PEA        $7767                
                    PEA        $6767                
                    TSC                             ; Line 27
                    ADC        #$00A6               
                    TCS                             
                    SEP        #$20                 
                    LDA        #$33                 
                    STA        $A0,S                
                    REP        #$30                 
                    PEA        $2277                
                    PEA        $7776                
                    PEA        $7666                
                    TSC                             ; Line 28
                    ADC        #$00A5               
                    TCS                             
                    SEP        #$20                 
                    LDA        #$75                 
                    STA        $A1,S                
                    REP        #$30                 
                    PEA        $2322                
                    PEA        $2277                
                    PEA        $6733                
                    TSC                             ; Line 29
                    ADC        #$00A6               
                    TCS                             
                    SEP        #$20                 
                    LDA        #$77                 
                    STA        $9B,S                
                    REP        #$30                 
                    PEA        $3533                
                    PEA        $3323                
                    PEA        $2223                
                    TSC                             ; Line 30
                    ADC        #$00A7               
                    TCS                             
                    SEP        #$20                 
                    LDA        #$57                 
                    STA        $A0,S                
                    REP        #$30                 
                    PHD                             
                    PHY                             
                    PEA        $2723                
                    TSC                             ; Line 31
                    ADC        #$00A5               
                    TCS                             
                    SEP        #$20                 
                    LDA        $97,S                
                    AND        #$F0                 
                    ORA        #$06                 
                    STA        $97,S                
                    REP        #$30                 
                    PHY                             
                    PEA        $7677                
                    PEA        $2723                
                    PEA        $6366                
                    TSC                             ; Line 32
                    ADC        #$00A9               
                    TCS                             
                    LDA        $95,S                
                    AND        #$00F0               
                    ORA        #$6606               
                    STA        $95,S                
                    PHX                             
                    PEA        $6767                
                    PEA        $6626                
                    PEA        $7332                
                    PEA        $6666                
                    TSC                             ; Line 33
                    ADC        #$00AA               
                    TCS                             
                    PHD                             
                    PEA        $7766                
                    PEA        $6666                
                    PEA        $3227                
                    PEA        $6767                
                    TSC                             ; Line 34
                    ADC        #$00AA               
                    TCS                             
                    SEP        #$20                 
                    LDA        #$66                 
                    STA        $94,S                
                    REP        #$30                 
                    PHX                             
                    PEA        $6767                
                    PEA        $7676                
                    PEA        $3277                
                    PEA        $7676                
                    PEA        $6661                
                    TSC                             ; Line 35
                    ADC        #$00AC               
                    TCS                             
                    LDA        $93,S                
                    AND        #$00F0               
                    ORA        #$6101               
                    STA        $93,S                
                    PHY                             
                    PEA        $7766                
                    PEA        $6667                
                    PEA        $7577                
                    PEA        $7767                
                    PEA        $6767                
                    TSC                             ; Line 36
                    ADC        #$00AC               
                    TCS                             
                    LDA        $9F,S                
                    AND        #$0F00               
                    ORA        #$5077               
                    STA        $9F,S                
                    PHX                             
                    PEA        $6767                
                    PEA        $7656                
                    PHD                             
                    PHY                             
                    PEA        $7776                
                    TSC                             ; Line 37
                    ADC        #$00AA               
                    TCS                             
                    LDA        $A1,S                
                    AND        #$0F00               
                    ORA        #$7075               
                    STA        $A1,S                
                    PEA        $7776                
                    PEA        $6676                
                    PHX                             
                    PHX                             
                    PEA        $7777                
                    PEA        $1616                
                    TSC                             ; Line 38
                    ADC        #$00AC               
                    TCS                             
                    SEP        #$20                 
                    LDA        #$67                 
                    STA        $95,S                
                    LDA        $A2,S                
                    AND        #$0F                 
                    ORA        #$50                 
                    STA        $A2,S                
                    REP        #$30                 
                    PEA        $6767                
                    PEA        $6657                
                    PHD                             
                    PHD                             
                    PHY                             
                    PEA        $6761                
                    TSC                             ; Line 39
                    ADC        #$00A5               
                    TCS                             
                    LDA        #$5767               
                    STA        $9C,S                
                    LDA        $9E,S                
                    AND        #$0F00               
                    ORA        #$5057               
                    STA        $9E,S                
                    SEP        #$20                 
                    LDA        $A9,S                
                    AND        #$0F                 
                    ORA        #$70                 
                    STA        $A9,S                
                    REP        #$30                 
                    PHX                             
                    PHX                             
                    TSC                             
                    ADC        #$000C               
                    TCS                             
                    PEA        $7777                
                    PEA        $7676                
                    TSC                             ; Line 40
                    ADC        #$00A4               
                    TCS                             
                    LDA        #$7577               
                    STA        $94,S                
                    LDA        #$7666               
                    STA        $9E,S                
                    LDA        $96,S                
                    AND        #$0F00               
                    ORA        #$7075               
                    STA        $96,S                
                    LDA        $A0,S                
                    AND        #$0F00               
                    ORA        #$5077               
                    STA        $A0,S                
                    SEP        #$20                 
                    LDA        $9D,S                
                    AND        #$F0                 
                    ORA        #$06                 
                    STA        $9D,S                
                    REP        #$30                 
                    PEA        $7567                
                    PEA        $6761                
                    TSC                             ; Line 42
                    ADC        #$0138               
                    TCS                             
                    LDA        #$6716               
                    STA        $0A,S                
                    LDA        #$6761               
                    STA        $AA,S                
                    LDA        $00,S                
                    AND        #$00F0               
                    ORA        #$7706               
                    STA        $00,S                
                    LDA        $02,S                
                    AND        #$0F00               
                    ORA        #$5057               
                    STA        $02,S                
                    LDA        $0C,S                
                    AND        #$0F00               
                    ORA        #$7075               
                    STA        $0C,S                
                    LDA        $A0,S                
                    AND        #$00F0               
                    ORA        #$6707               
                    STA        $A0,S                
                    LDA        $A2,S                
                    AND        #$0F00               
                    ORA        #$7075               
                    STA        $A2,S                
                    LDA        $AC,S                
                    AND        #$0F00               
                    ORA        #$5077               
                    STA        $AC,S                
                    SEP        #$20                 
                    LDA        $09,S                
                    AND        #$F0                 
                    ORA        #$06                 
                    STA        $09,S                
                    LDA        $A9,S                
                    AND        #$F0                 
                    ORA        #$06                 
                    STA        $A9,S                
                    REP        #$30                 
                    TSC                             ; Line 44
                    ADC        #$0140               
                    TCS                             
                    TYA                             
                    STA        $01,S                
                    LDA        #$1616               
                    STA        $0A,S                
                    TXA                             
                    STA        $A2,S                
                    LDA        #$6661               
                    STA        $AA,S                
                    LDA        $0C,S                
                    AND        #$0F00               
                    ORA        #$7075               
                    STA        $0C,S                
                    LDA        $AC,S                
                    AND        #$0F00               
                    ORA        #$5067               
                    STA        $AC,S                
                    SEP        #$20                 
                    LDA        #$57                 
                    STA        $03,S                
                    LDA        #$67                 
                    STA        $A1,S                
                    LDA        $09,S                
                    AND        #$F0                 
                    ORA        #$06                 
                    STA        $09,S                
                    LDA        $A9,S                
                    AND        #$F0                 
                    ORA        #$06                 
                    STA        $A9,S                
                    REP        #$30                 
                    TSC                             ; Line 46
                    ADC        #$0140               
                    TCS                             
                    LDA        #$1766               
                    STA        $0A,S                
                    LDA        #$7467               
                    STA        $A2,S                
                    LDA        #$7766               
                    STA        $AA,S                
                    LDA        $01,S                
                    AND        #$00F0               
                    ORA        #$7706               
                    STA        $01,S                
                    LDA        $03,S                
                    AND        #$0F00               
                    ORA        #$5057               
                    STA        $03,S                
                    LDA        $0C,S                
                    AND        #$0F00               
                    ORA        #$7075               
                    STA        $0C,S                
                    LDA        $AC,S                
                    AND        #$0F00               
                    ORA        #$5057               
                    STA        $AC,S                
                    SEP        #$20                 
                    LDA        $A1,S                
                    AND        #$F0                 
                    ORA        #$07                 
                    STA        $A1,S                
                    REP        #$30                 
                    TSC                             ; Line 48
                    ADC        #$0140               
                    TCS                             
                    LDA        #$4444               
                    STA        $02,S                
                    STA        $A1,S                
                    LDA        #$6767               
                    STA        $0A,S                
                    TYA                             
                    STA        $AB,S                
                    LDA        $0C,S                
                    AND        #$0F00               
                    ORA        #$7075               
                    STA        $0C,S                
                    SEP        #$20                 
                    LDA        #$66                 
                    STA        $AA,S                
                    LDA        $A3,S                
                    AND        #$0F                 
                    ORA        #$40                 
                    STA        $A3,S                
                    REP        #$30                 
                    TSC                             ; Line 50
                    ADC        #$0140               
                    TCS                             
                    LDA        #$6766               
                    STA        $0A,S                
                    TYA                             
                    STA        $AB,S                
                    LDA        $00,S                
                    AND        #$00F0               
                    ORA        #$4404               
                    STA        $00,S                
                    SEP        #$20                 
                    LDA        #$75                 
                    STA        $0C,S                
                    LDA        $02,S                
                    AND        #$0F                 
                    ORA        #$40                 
                    STA        $02,S                
                    LDA        $AA,S                
                    AND        #$F0                 
                    ORA        #$06                 
                    STA        $AA,S                
                    REP        #$30                 
                    TSC                             ; Line 52
                    ADC        #$0140               
                    TCS                             
                    TXA                             
                    STA        $0B,S                
                    LDA        $02,S                
                    AND        #$F0F0               
                    ORA        #$0505               
                    STA        $02,S                
                    LDA        $04,S                
                    AND        #$F0F0               
                    ORA        #$0505               
                    STA        $04,S                
                    LDA        $06,S                
                    AND        #$F0F0               
                    ORA        #$0505               
                    STA        $06,S                
                    LDA        $A0,S                
                    AND        #$0F0F               
                    ORA        #$5050               
                    STA        $A0,S                
                    LDA        $A2,S                
                    AND        #$0F0F               
                    ORA        #$5050               
                    STA        $A2,S                
                    LDA        $A4,S                
                    AND        #$0F0F               
                    ORA        #$5050               
                    STA        $A4,S                
                    LDA        $A6,S                
                    AND        #$0F0F               
                    ORA        #$5050               
                    STA        $A6,S                
                    LDA        $A8,S                
                    AND        #$0F0F               
                    ORA        #$5050               
                    STA        $A8,S                
                    LDA        $AA,S                
                    AND        #$000F               
                    ORA        #$4450               
                    STA        $AA,S                
                    SEP        #$20                 
                    LDA        $0A,S                
                    AND        #$F0                 
                    ORA        #$06                 
                    STA        $0A,S                
                    LDA        $AC,S                
                    AND        #$0F                 
                    ORA        #$40                 
                    STA        $AC,S                
                    REP        #$30                 
                    TSC                             ; Line 54
                    ADC        #$0140               
                    TCS                             
                    LDA        #$4444               
                    STA        $AC,S                
                    LDA        $00,S                
                    AND        #$F0F0               
                    ORA        #$0505               
                    STA        $00,S                
                    LDA        $02,S                
                    AND        #$F0F0               
                    ORA        #$0505               
                    STA        $02,S                
                    LDA        $04,S                
                    AND        #$F0F0               
                    ORA        #$0505               
                    STA        $04,S                
                    LDA        $06,S                
                    AND        #$F0F0               
                    ORA        #$0505               
                    STA        $06,S                
                    LDA        $08,S                
                    AND        #$F0F0               
                    ORA        #$0505               
                    STA        $08,S                
                    LDA        $0A,S                
                    AND        #$00F0               
                    ORA        #$4405               
                    STA        $0A,S                
                    LDA        $0C,S                
                    AND        #$0F00               
                    ORA        #$4044               
                    STA        $0C,S                
                    LDA        $A2,S                
                    AND        #$0F0F               
                    ORA        #$5050               
                    STA        $A2,S                
                    LDA        $A4,S                
                    AND        #$0F0F               
                    ORA        #$5050               
                    STA        $A4,S                
                    LDA        $A6,S                
                    AND        #$0F0F               
                    ORA        #$5050               
                    STA        $A6,S                
                    LDA        $A8,S                
                    AND        #$0F0F               
                    ORA        #$5050               
                    STA        $A8,S                
                    LDA        $AA,S                
                    AND        #$0F0F               
                    ORA        #$5050               
                    STA        $AA,S                
                    SEP        #$20                 
                    LDA        $AE,S                
                    AND        #$0F                 
                    ORA        #$40                 
                    STA        $AE,S                
                    REP        #$30                 
*--                                                 
                    LDAL       $E1C068              ; Direct Page and Stack in Bank 00/
                    AND        #$FFCF               
                    STAL       $E1C068              
                    LDA        StackAddress         ; Restore Stack
                    TCS                             
                    PLD                             ; Restore Direct Page
                    CLI                             ; Enable Interrupts
                    PLB
                    RTL                             
                                                    
*-----------------------------------                                
Sprite_BL_02C       CLC                             ; Sprite #02C : 56x53, 1906 bytes, 3115 cycles
                    SEI                             ; Disable Interrupts
                    PHD                             ; Backup Direct Page
                    TSC                             ; Backup Stack
                    STA        StackAddress         
                    LDAL       $E1C068              ; Direct Page and Stack in Bank 01/
                    ORA        #$0030               
                    STAL       $E1C068              
                    TYA                             ; Y = Sprite Target Screen Address (upper left corner)
                    TCS                             ; New Stack address
                    LDX        #$7575               ; Pattern #1 : 31
                    LDY        #$7777               ; Pattern #2 : 29
                    LDA        #$6666               ; Pattern #3 : 21
                    TCD                             
*--                                                 
                    LDA        #$5555               ; Line 0
                    STA        $B7,S                
                    LDA        $16,S                
                    AND        #$00F0               
                    ORA        #$5505               
                    STA        $16,S                
                    LDA        $B5,S                
                    AND        #$00F0               
                    ORA        #$5505               
                    STA        $B5,S                
                    SEP        #$20                 
                    LDA        $18,S                
                    AND        #$0F                 
                    ORA        #$50                 
                    STA        $18,S                
                    REP        #$30                 
                    TSC                             ; Line 2
                    ADC        #$0158               
                    TCS                             
                    SEP        #$20                 
                    LDA        $01,S                
                    AND        #$0F                 
                    ORA        #$50                 
                    STA        $01,S                
                    LDA        $A1,S                
                    AND        #$0F                 
                    ORA        #$30                 
                    STA        $A1,S                
                    REP        #$30                 
                    PEA        $5555                
                    PEA        $5555                
                    TSC                             ; Line 3
                    ADC        #$00A4               
                    TCS                             
                    SEP        #$20                 
                    LDA        $A1,S                
                    AND        #$0F                 
                    ORA        #$30                 
                    STA        $A1,S                
                    REP        #$30                 
                    PEA        $3333                
                    PEA        $3333                
                    TSC                             ; Line 4
                    ADC        #$00A4               
                    TCS                             
                    SEP        #$20                 
                    LDA        $A1,S                
                    AND        #$0F                 
                    ORA        #$50                 
                    STA        $A1,S                
                    REP        #$30                 
                    PEA        $3333                
                    PEA        $3333                
                    TSC                             ; Line 5
                    ADC        #$00A4               
                    TCS                             
                    SEP        #$20                 
                    LDA        $A1,S                
                    AND        #$0F                 
                    ORA        #$50                 
                    STA        $A1,S                
                    REP        #$30                 
                    PEA        $5555                
                    PEA        $4444                
                    TSC                             ; Line 6
                    ADC        #$00A4               
                    TCS                             
                    LDA        #$5544               
                    STA        $9E,S                
                    LDA        $9C,S                
                    AND        #$00F0               
                    ORA        #$4404               
                    STA        $9C,S                
                    LDA        $A0,S                
                    AND        #$0F00               
                    ORA        #$5055               
                    STA        $A0,S                
                    PEA        $5555                
                    PEA        $5445                
                    TSC                             ; Line 8
                    ADC        #$012C               
                    TCS                             
                    SEP        #$20                 
                    LDA        #$55                 
                    STA        $B8,S                
                    LDA        $14,S                
                    AND        #$F0                 
                    ORA        #$04                 
                    STA        $14,S                
                    REP        #$30                 
                    TSC                             
                    ADC        #$0018               
                    TCS                             
                    PEA        $5554                
                    PEA        $4444                
                    TSC                             ; Line 9
                    ADC        #$00A3               
                    TCS                             
                    LDA        $90,S                
                    AND        #$00F0               
                    ORA        #$4404               
                    STA        $90,S                
                    PEA        $4444                
                    PEA        $4477                
                    PEA        $6766                
                    PHD                             
                    PHD                             
                    PHD                             
                    PEA        $6646                
                    PEA        $4444                
                    TSC                             ; Line 10
                    ADC        #$00B1               
                    TCS                             
                    LDA        $91,S                
                    AND        #$F00F               
                    ORA        #$0740               
                    STA        $91,S                
                    SEP        #$20                 
                    LDA        #$44                 
                    STA        $90,S                
                    LDA        $A1,S                
                    AND        #$0F                 
                    ORA        #$60                 
                    STA        $A1,S                
                    REP        #$30                 
                    PEA        $4444                
                    PEA        $4444                
                    PEA        $7776                
                    PEA        $7676                
                    PEA        $6767                
                    PEA        $7776                
                    PEA        $7676                
                    PEA        $4644                
                    TSC                             ; Line 11
                    ADC        #$00B0               
                    TCS                             
                    SEP        #$20                 
                    LDA        $93,S                
                    AND        #$F0                 
                    ORA        #$05                 
                    STA        $93,S                
                    REP        #$30                 
                    PEA        $4644                
                    PEA        $6561                
                    PEA        $6767                
                    PHY                             
                    PHY                             
                    PHY                             
                    PEA        $6777                
                    TSC                             ; Line 12
                    ADC        #$00AF               
                    TCS                             
                    LDA        $A0,S                
                    AND        #$0F00               
                    ORA        #$5057               
                    STA        $A0,S                
                    SEP        #$20                 
                    LDA        $95,S                
                    AND        #$F0                 
                    ORA        #$07                 
                    STA        $95,S                
                    REP        #$30                 
                    PEA        $7566                
                    PEA        $4455                
                    PEA        $1677                
                    PEA        $6677                
                    PHX                             
                    PHX                             
                    PHX                             
                    TSC                             ; Line 13
                    ADC        #$00AD               
                    TCS                             
                    SEP        #$20                 
                    LDA        #$75                 
                    STA        $A2,S                
                    REP        #$30                 
                    PEA        $6744                
                    PEA        $4465                
                    PEA        $7177                
                    PEA        $5657                
                    PEA        $5757                
                    TSC                             ; Line 14
                    ADC        #$00AB               
                    TCS                             
                    SEP        #$20                 
                    LDA        $97,S                
                    AND        #$F0                 
                    ORA        #$07                 
                    STA        $97,S                
                    REP        #$30                 
                    PEA        $7565                
                    PEA        $4644                
                    PEA        $5416                
                    PHY                             
                    PHX                             
                    TSC                             ; Line 15
                    ADC        #$00AB               
                    TCS                             
                    SEP        #$20                 
                    LDA        $96,S                
                    AND        #$F0                 
                    ORA        #$05                 
                    STA        $96,S                
                    REP        #$30                 
                    PEA        $5777                
                    PEA        $5766                
                    PEA        $4644                
                    PEA        $6577                
                    PEA        $7757                
                    TSC                             ; Line 16
                    ADC        #$00AA               
                    TCS                             
                    LDA        $96,S                
                    AND        #$00F0               
                    ORA        #$7707               
                    STA        $96,S                
                    LDA        $A0,S                
                    AND        #$0F00               
                    ORA        #$5057               
                    STA        $A0,S                
                    PEA        $7577                
                    PEA        $7755                
                    PEA        $6644                
                    PEA        $6571                
                    PHY                             
                    TSC                             ; Line 17
                    ADC        #$00A9               
                    TCS                             
                    LDA        $97,S                
                    AND        #$00F0               
                    ORA        #$7707               
                    STA        $97,S                
                    LDA        $A1,S                
                    AND        #$0F00               
                    ORA        #$7065               
                    STA        $A1,S                
                    PEA        $7677                
                    PEA        $7755                
                    PHD                             
                    PEA        $7677                
                    TSC                             ; Line 18
                    ADC        #$00A8               
                    TCS                             
                    LDA        $A1,S                
                    AND        #$0F00               
                    ORA        #$5077               
                    STA        $A1,S                
                    PHY                             
                    PEA        $7676                
                    PEA        $5555                
                    PHD                             
                    TSC                             ; Line 19
                    ADC        #$00A8               
                    TCS                             
                    SEP        #$20                 
                    LDA        $96,S                
                    AND        #$F0                 
                    ORA        #$07                 
                    STA        $96,S                
                    REP        #$30                 
                    PEA        $7677                
                    PEA        $6767                
                    PEA        $6767                
                    PEA        $5555                
                    PEA        $6566                
                    TSC                             ; Line 20
                    ADC        #$00AC               
                    TCS                             
                    LDA        $91,S                
                    AND        #$00F0               
                    ORA        #$6606               
                    STA        $91,S                
                    PEA        $7565                
                    PEA        $7677                
                    PEA        $7776                
                    PEA        $7676                
                    PHD                             
                    PEA        $5655                
                    TSC                             ; Line 21
                    ADC        #$00AC               
                    TCS                             
                    LDA        $85,S                
                    AND        #$0F00               
                    ORA        #$4044               
                    STA        $85,S                
                    SEP        #$20                 
                    LDA        $88,S                
                    AND        #$F0                 
                    ORA        #$06                 
                    STA        $88,S                
                    REP        #$30                 
                    PEA        $5767                
                    PEA        $6757                
                    PHY                             
                    PEA        $7767                
                    PEA        $6776                
                    PHD                             
                    PEA        $6623                
                    TSC                             ; Line 22
                    ADC        #$00AE               
                    TCS                             
                    PHX                             
                    PEA        $7675                
                    PHX                             
                    PHY                             
                    PEA        $7666                
                    PEA        $7676                
                    PEA        $2222                
                    PHD                             
                    PHD                             
                    PHD                             
                    PHD                             
                    PHD                             
                    TSC                             ; Line 23
                    ADC        #$00B8               
                    TCS                             
                    TXA                             
                    STA        $9F,S                
                    LDA        $9D,S                
                    AND        #$00F0               
                    ORA        #$6605               
                    STA        $9D,S                
                    SEP        #$20                 
                    LDA        $85,S                
                    AND        #$F0                 
                    ORA        #$04                 
                    STA        $85,S                
                    REP        #$30                 
                    LDA        #$7676               
                    PEA        $5767                
                    PEA        $6757                
                    PEA        $5757                
                    PEA        $5777                
                    PEA        $6767                
                    PEA        $6767                
                    PEA        $3266                
                    PHA                             
                    PHA                             
                    PHA                             
                    PHA                             
                    PHA                             
                    PEA        $4644                
                    PEA        $4444                
                    TSC                             ; Line 24
                    ADC        #$00B7               
                    TCS                             
                    LDA        #$7767               
                    STA        $A3,S                
                    LDA        $8B,S                
                    AND        #$00F0               
                    ORA        #$4404               
                    STA        $8B,S                
                    LDA        $9F,S                
                    AND        #$0F00               
                    ORA        #$5057               
                    STA        $9F,S                
                    SEP        #$20                 
                    LDA        #$57                 
                    STA        $A5,S                
                    REP        #$30                 
                    PHX                             
                    PEA        $7577                
                    PEA        $7676                
                    PEA        $2673                
                    PEA        $6767                
                    PEA        $6777                
                    PHY                             
                    PHY                             
                    PHY                             
                    PEA        $7747                
                    PEA        $4444                
                    TSC                             ; Line 25
                    ADC        #$00B4               
                    TCS                             
                    TXA                             
                    STA        $A6,S                
                    SEP        #$20                 
                    LDA        #$66                 
                    STA        $A5,S                
                    LDA        $8F,S                
                    AND        #$F0                 
                    ORA        #$05                 
                    STA        $8F,S                
                    REP        #$30                 
                    PEA        $5777                
                    PHY                             
                    PEA        $2377                
                    PEA        $7676                
                    PHY                             
                    PHY                             
                    PHY                             
                    PEA        $5757                
                    PEA        $7747                
                    TSC                             ; Line 26
                    ADC        #$00B3               
                    TCS                             
                    LDA        #$5766               
                    STA        $A4,S                
                    LDA        $9F,S                
                    AND        #$0F00               
                    ORA        #$5057               
                    STA        $9F,S                
                    SEP        #$20                 
                    LDA        $A6,S                
                    AND        #$0F                 
                    ORA        #$50                 
                    STA        $A6,S                
                    REP        #$30                 
                    PHX                             
                    PHX                             
                    PEA        $2733                
                    PEA        $7267                
                    PEA        $7775                
                    PHX                             
                    PHX                             
                    PHX                             
                    PHX                             
                    TSC                             ; Line 27
                    ADC        #$00B0               
                    TCS                             
                    LDA        #$7567               
                    STA        $A6,S                
                    SEP        #$20                 
                    LDA        $A5,S                
                    AND        #$F0                 
                    ORA        #$07                 
                    STA        $A5,S                
                    REP        #$30                 
                    LDA        #$5757               
                    PEA        $5722                
                    PEA        $2233                
                    PEA        $7266                
                    PEA        $5657                
                    PHA                             
                    PHA                             
                    PHA                             
                    PHA                             
                    TSC                             ; Line 28
                    ADC        #$00B1               
                    TCS                             
                    LDA        #$5757               
                    STA        $A5,S                
                    SEP        #$20                 
                    LDA        #$76                 
                    STA        $A4,S                
                    LDA        $97,S                
                    AND        #$F0                 
                    ORA        #$07                 
                    STA        $97,S                
                    REP        #$30                 
                    PEA        $7522                
                    PEA        $3273                
                    PEA        $3722                
                    PEA        $6675                
                    PHX                             
                    PHX                             
                    TSC                             ; Line 29
                    ADC        #$00AB               
                    TCS                             
                    LDA        $99,S                
                    AND        #$00F0               
                    ORA        #$7505               
                    STA        $99,S                
                    LDA        $9F,S                
                    AND        #$0F00               
                    ORA        #$5057               
                    STA        $9F,S                
                    LDA        $A4,S                
                    AND        #$00F0               
                    ORA        #$6507               
                    STA        $A4,S                
                    LDA        $A6,S                
                    AND        #$0F00               
                    ORA        #$7075               
                    STA        $A6,S                
                    PEA        $3273                
                    PEA        $7537                
                    PEA        $3263                
                    PEA        $5757                
                    TSC                             ; Line 30
                    ADC        #$00A6               
                    TCS                             
                    LDA        #$5757               
                    STA        $A7,S                
                    SEP        #$20                 
                    LDA        $A6,S                
                    AND        #$F0                 
                    ORA        #$07                 
                    STA        $A6,S                
                    REP        #$30                 
                    PEA        $5737                
                    PEA        $7266                
                    TSC                             ; Line 31
                    ADC        #$00A5               
                    TCS                             
                    LDA        #$7544               
                    STA        $A5,S                
                    LDA        $9B,S                
                    AND        #$00F0               
                    ORA        #$6607               
                    STA        $9B,S                
                    SEP        #$20                 
                    LDA        $A4,S                
                    AND        #$F0                 
                    ORA        #$04                 
                    STA        $A4,S                
                    REP        #$30                 
                    PHX                             
                    PEA        $3767                
                    PEA        $7657                
                    TSC                             ; Line 32
                    ADC        #$00A6               
                    TCS                             
                    LDA        $9B,S                
                    AND        #$00F0               
                    ORA        #$6607               
                    STA        $9B,S                
                    LDA        $A5,S                
                    AND        #$0F00               
                    ORA        #$4044               
                    STA        $A5,S                
                    PEA        $5757                
                    PEA        $3777                
                    TSC                             ; Line 33
                    ADC        #$00A4               
                    TCS                             
                    LDA        #$7776               
                    STA        $9D,S                
                    LDA        $9B,S                
                    AND        #$00F0               
                    ORA        #$7607               
                    STA        $9B,S                
                    LDA        $9F,S                
                    AND        #$0F00               
                    ORA        #$5057               
                    STA        $9F,S                
                    SEP        #$20                 
                    LDA        #$44                 
                    STA        $A5,S                
                    REP        #$30                 
                    PHX                             
                    PEA        $7767                
                    TSC                             ; Line 35
                    ADC        #$0143               
                    TCS                             
                    SEP        #$20                 
                    LDA        $01,S                
                    AND        #$0F                 
                    ORA        #$70                 
                    STA        $01,S                
                    LDA        $A1,S                
                    AND        #$0F                 
                    ORA        #$50                 
                    STA        $A1,S                
                    REP        #$30                 
                    PEA        $7577                
                    PEA        $6766                
                    TSC                             ; Line 36
                    ADC        #$00A4               
                    TCS                             
                    PEA        $5776                
                    PEA        $7666                
                    TSC                             ; Line 37
                    ADC        #$00A4               
                    TCS                             
                    LDA        #$5777               
                    STA        $9F,S                
                    LDA        $9D,S                
                    AND        #$00F0               
                    ORA        #$7606               
                    STA        $9D,S                
                    PEA        $7567                
                    PEA        $1766                
                    TSC                             ; Line 39
                    ADC        #$0133               
                    TCS                             
                    LDA        #$7567               
                    STA        $10,S                
                    LDA        #$5777               
                    STA        $B0,S                
                    LDA        $0E,S                
                    AND        #$00F0               
                    ORA        #$1706               
                    STA        $0E,S                
                    LDA        $AE,S                
                    AND        #$00F0               
                    ORA        #$7106               
                    STA        $AE,S                
                    TSC                             ; Line 41
                    ADC        #$0140               
                    TCS                             
                    LDA        #$7565               
                    STA        $10,S                
                    LDA        #$5776               
                    STA        $B0,S                
                    LDA        $0E,S                
                    AND        #$00F0               
                    ORA        #$6706               
                    STA        $0E,S                
                    LDA        $AE,S                
                    AND        #$00F0               
                    ORA        #$6106               
                    STA        $AE,S                
                    TSC                             ; Line 43
                    ADC        #$0140               
                    TCS                             
                    LDA        #$1767               
                    STA        $0F,S                
                    LDA        #$7761               
                    STA        $AF,S                
                    SEP        #$20                 
                    LDA        #$75                 
                    STA        $11,S                
                    LDA        #$57                 
                    STA        $B1,S                
                    REP        #$30                 
                    TSC                             ; Line 45
                    ADC        #$0140               
                    TCS                             
                    LDA        #$6767               
                    STA        $0F,S                
                    LDA        #$7766               
                    STA        $AF,S                
                    SEP        #$20                 
                    LDA        #$75                 
                    STA        $11,S                
                    LDA        #$57                 
                    STA        $B1,S                
                    REP        #$30                 
                    TSC                             ; Line 47
                    ADC        #$0140               
                    TCS                             
                    LDA        #$6766               
                    STA        $0F,S                
                    LDA        #$5777               
                    STA        $B0,S                
                    LDA        $A9,S                
                    AND        #$0F0F               
                    ORA        #$5050               
                    STA        $A9,S                
                    SEP        #$20                 
                    LDA        #$75                 
                    STA        $11,S                
                    LDA        $AF,S                
                    AND        #$F0                 
                    ORA        #$06                 
                    STA        $AF,S                
                    REP        #$30                 
                    TSC                             ; Line 49
                    ADC        #$0140               
                    TCS                             
                    TXA                             
                    STA        $10,S                
                    LDA        $04,S                
                    AND        #$F0F0               
                    ORA        #$0505               
                    STA        $04,S                
                    LDA        $06,S                
                    AND        #$F0F0               
                    ORA        #$0505               
                    STA        $06,S                
                    LDA        $08,S                
                    AND        #$F0F0               
                    ORA        #$0505               
                    STA        $08,S                
                    LDA        $0A,S                
                    AND        #$F0F0               
                    ORA        #$0505               
                    STA        $0A,S                
                    LDA        $0C,S                
                    AND        #$F0F0               
                    ORA        #$0505               
                    STA        $0C,S                
                    LDA        $16,S                
                    AND        #$0F0F               
                    ORA        #$5050               
                    STA        $16,S                
                    LDA        $18,S                
                    AND        #$0F0F               
                    ORA        #$5050               
                    STA        $18,S                
                    LDA        $A1,S                
                    AND        #$0F0F               
                    ORA        #$5050               
                    STA        $A1,S                
                    LDA        $A3,S                
                    AND        #$0F0F               
                    ORA        #$5050               
                    STA        $A3,S                
                    LDA        $A5,S                
                    AND        #$0F0F               
                    ORA        #$5050               
                    STA        $A5,S                
                    LDA        $A7,S                
                    AND        #$0F0F               
                    ORA        #$5050               
                    STA        $A7,S                
                    LDA        $A9,S                
                    AND        #$0F0F               
                    ORA        #$5050               
                    STA        $A9,S                
                    LDA        $AB,S                
                    AND        #$0F0F               
                    ORA        #$5050               
                    STA        $AB,S                
                    LDA        $AD,S                
                    AND        #$0F0F               
                    ORA        #$5050               
                    STA        $AD,S                
                    LDA        $AF,S                
                    AND        #$000F               
                    ORA        #$4450               
                    STA        $AF,S                
                    LDA        $B2,S                
                    AND        #$F0F0               
                    ORA        #$0505               
                    STA        $B2,S                
                    LDA        $B4,S                
                    AND        #$F0F0               
                    ORA        #$0505               
                    STA        $B4,S                
                    LDA        $B6,S                
                    AND        #$F0F0               
                    ORA        #$0505               
                    STA        $B6,S                
                    LDA        $B8,S                
                    AND        #$F0F0               
                    ORA        #$0505               
                    STA        $B8,S                
                    LDA        $BA,S                
                    AND        #$F0F0               
                    ORA        #$0505               
                    STA        $BA,S                
                    SEP        #$20                 
                    LDA        $0F,S                
                    AND        #$F0                 
                    ORA        #$06                 
                    STA        $0F,S                
                    LDA        $1A,S                
                    AND        #$0F                 
                    ORA        #$50                 
                    STA        $1A,S                
                    LDA        $B1,S                
                    AND        #$0F                 
                    ORA        #$40                 
                    STA        $B1,S                
                    REP        #$30                 
                    TSC                             ; Line 51
                    ADC        #$0140               
                    TCS                             
                    LDA        #$4444               
                    STA        $10,S                
                    LDA        $02,S                
                    AND        #$F0F0               
                    ORA        #$0505               
                    STA        $02,S                
                    LDA        $04,S                
                    AND        #$F0F0               
                    ORA        #$0505               
                    STA        $04,S                
                    LDA        $06,S                
                    AND        #$F0F0               
                    ORA        #$0505               
                    STA        $06,S                
                    LDA        $08,S                
                    AND        #$F0F0               
                    ORA        #$0505               
                    STA        $08,S                
                    LDA        $0A,S                
                    AND        #$F0F0               
                    ORA        #$0505               
                    STA        $0A,S                
                    LDA        $0C,S                
                    AND        #$F0F0               
                    ORA        #$0505               
                    STA        $0C,S                
                    LDA        $0E,S                
                    AND        #$F0F0               
                    ORA        #$0505               
                    STA        $0E,S                
                    LDA        $12,S                
                    AND        #$0F0F               
                    ORA        #$5040               
                    STA        $12,S                
                    LDA        $14,S                
                    AND        #$0F0F               
                    ORA        #$5050               
                    STA        $14,S                
                    LDA        $16,S                
                    AND        #$0F0F               
                    ORA        #$5050               
                    STA        $16,S                
                    LDA        $18,S                
                    AND        #$0F0F               
                    ORA        #$5050               
                    STA        $18,S                
                    LDA        $1A,S                
                    AND        #$0F0F               
                    ORA        #$5050               
                    STA        $1A,S                
                    LDA        $AA,S                
                    AND        #$0F0F               
                    ORA        #$5050               
                    STA        $AA,S                
                    LDA        $AC,S                
                    AND        #$0F0F               
                    ORA        #$5050               
                    STA        $AC,S                
                    LDA        $AE,S                
                    AND        #$0F0F               
                    ORA        #$5050               
                    STA        $AE,S                
                    LDA        $B0,S                
                    AND        #$000F               
                    ORA        #$4450               
                    STA        $B0,S                
                    LDA        $B2,S                
                    AND        #$0F00               
                    ORA        #$4044               
                    STA        $B2,S                
                    LDA        $B4,S                
                    AND        #$F0F0               
                    ORA        #$0505               
                    STA        $B4,S                
                    LDA        $B6,S                
                    AND        #$F0F0               
                    ORA        #$0505               
                    STA        $B6,S                
                    LDA        $B8,S                
                    AND        #$F0F0               
                    ORA        #$0505               
                    STA        $B8,S                
*--                                                 
                    LDAL       $E1C068              ; Direct Page and Stack in Bank 00/
                    AND        #$FFCF               
                    STAL       $E1C068              
                    LDA        StackAddress         ; Restore Stack
                    TCS                             
                    PLD                             ; Restore Direct Page
                    CLI                             ; Enable Interrupts
                    PLB
                    RTL                             
                                                    
*-----------------------------------                                
Sprite_BL_02D       CLC                             ; Sprite #02D : 62x53, 2272 bytes, 3649 cycles
                    SEI                             ; Disable Interrupts
                    PHD                             ; Backup Direct Page
                    TSC                             ; Backup Stack
                    STA        StackAddress         
                    LDAL       $E1C068              ; Direct Page and Stack in Bank 01/
                    ORA        #$0030               
                    STAL       $E1C068              
                    TYA                             ; Y = Sprite Target Screen Address (upper left corner)
                    TCS                             ; New Stack address
                    LDX        #$7777               ; Pattern #1 : 25
                    LDY        #$7575               ; Pattern #2 : 19
                    LDA        #$7676               ; Pattern #3 : 16
                    TCD                             
*--                                                 
                    LDA        #$5555               ; Line 0
                    STA        $BA,S                
                    LDA        $19,S                
                    AND        #$00F0               
                    ORA        #$5505               
                    STA        $19,S                
                    LDA        $B8,S                
                    AND        #$00F0               
                    ORA        #$5505               
                    STA        $B8,S                
                    SEP        #$20                 
                    LDA        $1B,S                
                    AND        #$0F                 
                    ORA        #$50                 
                    STA        $1B,S                
                    REP        #$30                 
                    TSC                             ; Line 2
                    ADC        #$015B               
                    TCS                             
                    LDA        #$3333               
                    STA        $9E,S                
                    LDA        $9C,S                
                    AND        #$00F0               
                    ORA        #$3303               
                    STA        $9C,S                
                    LDA        $A0,S                
                    AND        #$0F00               
                    ORA        #$3033               
                    STA        $A0,S                
                    SEP        #$20                 
                    LDA        $01,S                
                    AND        #$0F                 
                    ORA        #$50                 
                    STA        $01,S                
                    REP        #$30                 
                    PEA        $5555                
                    PEA        $5555                
                    TSC                             ; Line 4
                    ADC        #$0129               
                    TCS                             
                    LDA        #$3333               
                    STA        $19,S                
                    LDA        #$4444               
                    STA        $AC,S                
                    LDA        $0B,S                
                    AND        #$00F0               
                    ORA        #$4404               
                    STA        $0B,S                
                    LDA        $17,S                
                    AND        #$00F0               
                    ORA        #$3303               
                    STA        $17,S                
                    LDA        $1B,S                
                    AND        #$0F00               
                    ORA        #$3033               
                    STA        $1B,S                
                    SEP        #$20                 
                    LDA        $AE,S                
                    AND        #$0F                 
                    ORA        #$60                 
                    STA        $AE,S                
                    LDA        $BC,S                
                    AND        #$0F                 
                    ORA        #$50                 
                    STA        $BC,S                
                    REP        #$30                 
                    TSC                             ; Line 5
                    ADC        #$00BB               
                    TCS                             
                    LDA        #$6146               
                    STA        $92,S                
                    SEP        #$20                 
                    LDA        $88,S                
                    AND        #$0F                 
                    ORA        #$40                 
                    STA        $88,S                
                    LDA        $94,S                
                    AND        #$0F                 
                    ORA        #$60                 
                    STA        $94,S                
                    LDA        $A1,S                
                    AND        #$0F                 
                    ORA        #$50                 
                    STA        $A1,S                
                    REP        #$30                 
                    PEA        $5555                
                    PEA        $4444                
                    TSC                             ; Line 6
                    ADC        #$00A4               
                    TCS                             
                    LDA        #$6161               
                    STA        $94,S                
                    LDA        #$5544               
                    STA        $9E,S                
                    LDA        $92,S                
                    AND        #$00F0               
                    ORA        #$6606               
                    STA        $92,S                
                    LDA        $9C,S                
                    AND        #$00F0               
                    ORA        #$4404               
                    STA        $9C,S                
                    LDA        $A0,S                
                    AND        #$0F00               
                    ORA        #$5055               
                    STA        $A0,S                
                    SEP        #$20                 
                    LDA        #$44                 
                    STA        $88,S                
                    REP        #$30                 
                    PEA        $5555                
                    PEA        $5445                
                    TSC                             ; Line 8
                    ADC        #$0129               
                    TCS                             
                    LDA        $03,S                
                    AND        #$0F00               
                    ORA        #$4044               
                    STA        $03,S                
                    LDA        $A3,S                
                    AND        #$00F0               
                    ORA        #$4404               
                    STA        $A3,S                
                    SEP        #$20                 
                    LDA        #$66                 
                    STA        $13,S                
                    LDA        $17,S                
                    AND        #$F0                 
                    ORA        #$04                 
                    STA        $17,S                
                    REP        #$30                 
                    TSC                             
                    ADC        #$0012               
                    TCS                             
                    PEA        $6161                
                    PEA        $6767                
                    PHX                             
                    TSC                             
                    ADC        #$000F               
                    TCS                             
                    PEA        $5554                
                    PEA        $4444                
                    TSC                             ; Line 9
                    ADC        #$009F               
                    TCS                             
                    LDA        #$4444               
                    STA        $A3,S                
                    LDA        $8D,S                
                    AND        #$00F0               
                    ORA        #$4404               
                    STA        $8D,S                
                    LDA        $A1,S                
                    AND        #$000F               
                    ORA        #$4470               
                    STA        $A1,S                
                    SEP        #$20                 
                    LDA        #$77                 
                    STA        $98,S                
                    LDA        $8F,S                
                    AND        #$0F                 
                    ORA        #$40                 
                    STA        $8F,S                
                    LDA        $A5,S                
                    AND        #$0F                 
                    ORA        #$40                 
                    STA        $A5,S                
                    REP        #$30                 
                    PEA        $6666                
                    PEA        $6676                
                    PHD                             
                    PEA        $7677                
                    PHX                             
                    TSC                             
                    ADC        #$000F               
                    TCS                             
                    PEA        $5544                
                    PEA        $4444                
                    TSC                             ; Line 10
                    ADC        #$009F               
                    TCS                             
                    LDA        #$4644               
                    STA        $8E,S                
                    SEP        #$20                 
                    LDA        #$75                 
                    STA        $99,S                
                    REP        #$30                 
                    PEA        $6667                
                    PEA        $6767                
                    PHX                             
                    PEA        $5757                
                    TSC                             ; Line 11
                    ADC        #$00AD               
                    TCS                             
                    LDA        #$6644               
                    STA        $89,S                
                    SEP        #$20                 
                    LDA        $8B,S                
                    AND        #$0F                 
                    ORA        #$60                 
                    STA        $8B,S                
                    LDA        $94,S                
                    AND        #$F0                 
                    ORA        #$07                 
                    STA        $94,S                
                    REP        #$30                 
                    PEA        $4644                
                    PEA        $4475                
                    PEA        $1677                
                    PHD                             
                    PHX                             
                    PHY                             
                    TSC                             ; Line 12
                    ADC        #$00AC               
                    TCS                             
                    LDA        #$7644               
                    STA        $89,S                
                    LDA        $8B,S                
                    AND        #$0F00               
                    ORA        #$6066               
                    STA        $8B,S                
                    PEA        $6644                
                    PEA        $4475                
                    PEA        $6771                
                    PEA        $6776                
                    PEA        $5757                
                    PEA        $5757                
                    TSC                             ; Line 13
                    ADC        #$00AD               
                    TCS                             
                    LDA        $A0,S                
                    AND        #$0F00               
                    ORA        #$5057               
                    STA        $A0,S                
                    SEP        #$20                 
                    LDA        #$16                 
                    STA        $8C,S                
                    LDA        $95,S                
                    AND        #$F0                 
                    ORA        #$07                 
                    STA        $95,S                
                    REP        #$30                 
                    PEA        $7566                
                    PEA        $4644                
                    PEA        $5475                
                    PEA        $1677                
                    PEA        $6775                
                    PHY                             
                    TSC                             ; Line 14
                    ADC        #$0097               
                    TCS                             
                    LDA        $9D,S                
                    AND        #$00F0               
                    ORA        #$5507               
                    STA        $9D,S                
                    PEA        $6666                
                    PEA        $6775                
                    TSC                             
                    ADC        #$0018               
                    TCS                             
                    PEA        $6766                
                    PEA        $4444                
                    PEA        $5567                
                    PHX                             
                    PEA        $5757                
                    TSC                             ; Line 15
                    ADC        #$0098               
                    TCS                             
                    LDA        $A9,S                
                    AND        #$00F0               
                    ORA        #$7707               
                    STA        $A9,S                
                    PEA        $1666                
                    PHD                             
                    TSC                             
                    ADC        #$0018               
                    TCS                             
                    PEA        $5777                
                    PEA        $5565                
                    PEA        $6646                
                    PEA        $4465                
                    PEA        $7177                
                    PEA        $7775                
                    TSC                             ; Line 16
                    ADC        #$0099               
                    TCS                             
                    LDA        $B3,S                
                    AND        #$0F00               
                    ORA        #$5057               
                    STA        $B3,S                
                    SEP        #$20                 
                    LDA        $A8,S                
                    AND        #$F0                 
                    ORA        #$07                 
                    STA        $A8,S                
                    REP        #$30                 
                    PEA        $6161                
                    PEA        $6667                
                    PEA        $5757                
                    TSC                             
                    ADC        #$0019               
                    TCS                             
                    PEA        $7577                
                    PEA        $7757                
                    PEA        $6566                
                    PEA        $4675                
                    PEA        $7677                
                    TSC                             ; Line 17
                    ADC        #$0098               
                    TCS                             
                    SEP        #$20                 
                    LDA        $9B,S                
                    AND        #$F0                 
                    ORA        #$07                 
                    STA        $9B,S                
                    LDA        $B3,S                
                    AND        #$0F                 
                    ORA        #$70                 
                    STA        $B3,S                
                    REP        #$30                 
                    PEA        $6166                
                    PEA        $6667                
                    PEA        $7775                
                    TSC                             
                    ADC        #$0017               
                    TCS                             
                    PHX                             
                    PEA        $7755                
                    PEA        $5566                
                    PEA        $6666                
                    PHX                             
                    TSC                             ; Line 18
                    ADC        #$009A               
                    TCS                             
                    LDA        $A5,S                
                    AND        #$00F0               
                    ORA        #$6606               
                    STA        $A5,S                
                    LDA        $B1,S                
                    AND        #$0F00               
                    ORA        #$5057               
                    STA        $B1,S                
                    SEP        #$20                 
                    LDA        $A1,S                
                    AND        #$0F                 
                    ORA        #$60                 
                    STA        $A1,S                
                    REP        #$30                 
                    PEA        $6666                
                    PHD                             
                    PEA        $7657                
                    TSC                             
                    ADC        #$0017               
                    TCS                             
                    PEA        $7577                
                    PHX                             
                    PHX                             
                    PEA        $5555                
                    PEA        $6566                
                    PEA        $7677                
                    TSC                             ; Line 19
                    ADC        #$009B               
                    TCS                             
                    LDA        $B1,S                
                    AND        #$0F00               
                    ORA        #$7075               
                    STA        $B1,S                
                    SEP        #$20                 
                    LDA        #$66                 
                    STA        $A2,S                
                    REP        #$30                 
                    PEA        $6666                
                    PEA        $6777                
                    PHY                             
                    TSC                             
                    ADC        #$0016               
                    TCS                             
                    PEA        $7776                
                    PHX                             
                    PHD                             
                    PEA        $7757                
                    PEA        $5555                
                    TSC                             ; Line 20
                    ADC        #$009B               
                    TCS                             
                    LDA        $B0,S                
                    AND        #$0F00               
                    ORA        #$5057               
                    STA        $B0,S                
                    PEA        $6676                
                    PHD                             
                    PEA        $5757                
                    TSC                             
                    ADC        #$0015               
                    TCS                             
                    PEA        $6757                
                    PHX                             
                    PEA        $6767                
                    PEA        $6767                
                    PEA        $6666                
                    PEA        $5575                
                    TSC                             ; Line 21
                    ADC        #$00AC               
                    TCS                             
                    SEP        #$20                 
                    LDA        $8D,S                
                    AND        #$F0                 
                    ORA        #$07                 
                    STA        $8D,S                
                    REP        #$30                 
                    PEA        $7776                
                    PHY                             
                    PHX                             
                    PEA        $7776                
                    PEA        $6667                
                    PEA        $6626                
                    PEA        $6366                
                    PEA        $6666                
                    PEA        $6777                
                    PHY                             
                    TSC                             ; Line 22
                    ADC        #$00B5               
                    TCS                             
                    LDA        #$5777               
                    STA        $9F,S                
                    SEP        #$20                 
                    LDA        #$66                 
                    STA        $9E,S                
                    REP        #$30                 
                    PEA        $7567                
                    PEA        $6757                
                    PEA        $5757                
                    PHX                             
                    PEA        $6767                
                    PEA        $6667                
                    PEA        $2763                
                    PEA        $6676                
                    PHD                             
                    PEA        $5757                
                    TSC                             ; Line 23
                    ADC        #$00B0               
                    TCS                             
                    LDA        #$6767               
                    STA        $A2,S                
                    LDA        $9E,S                
                    AND        #$0F00               
                    ORA        #$5057               
                    STA        $9E,S                
                    SEP        #$20                 
                    LDA        #$75                 
                    STA        $A4,S                
                    LDA        $91,S                
                    AND        #$F0                 
                    ORA        #$07                 
                    STA        $91,S                
                    REP        #$30                 
                    PHY                             
                    PHY                             
                    PEA        $7776                
                    PHD                             
                    PEA        $2663                
                    PEA        $6667                
                    PEA        $6777                
                    PHY                             
                    TSC                             ; Line 24
                    ADC        #$00AD               
                    TCS                             
                    LDA        #$5777               
                    STA        $A6,S                
                    SEP        #$20                 
                    LDA        #$75                 
                    STA        $A1,S                
                    LDA        #$66                 
                    STA        $A5,S                
                    REP        #$30                 
                    PEA        $5777                
                    PEA        $6767                
                    PEA        $6732                
                    PEA        $6776                
                    PHD                             
                    PEA        $5757                
                    TSC                             ; Line 25
                    ADC        #$00AC               
                    TCS                             
                    LDA        #$6766               
                    STA        $A5,S                
                    LDA        $95,S                
                    AND        #$00F0               
                    ORA        #$5707               
                    STA        $95,S                
                    SEP        #$20                 
                    LDA        #$75                 
                    STA        $A7,S                
                    LDA        $A1,S                
                    AND        #$0F                 
                    ORA        #$50                 
                    STA        $A1,S                
                    REP        #$30                 
                    PHY                             
                    PHX                             
                    PEA        $3772                
                    PEA        $6766                
                    PHX                             
                    PHY                             
                    TSC                             ; Line 26
                    ADC        #$00AC               
                    TCS                             
                    LDA        #$5777               
                    STA        $A6,S                
                    SEP        #$20                 
                    LDA        #$75                 
                    STA        $96,S                
                    LDA        #$66                 
                    STA        $A5,S                
                    REP        #$30                 
                    PEA        $5757                
                    PHX                             
                    PEA        $3223                
                    PEA        $6776                
                    PEA        $5757                
                    TSC                             ; Line 27
                    ADC        #$00AA               
                    TCS                             
                    LDA        #$6766               
                    STA        $A5,S                
                    LDA        $9F,S                
                    AND        #$0F00               
                    ORA        #$5027               
                    STA        $9F,S                
                    SEP        #$20                 
                    LDA        #$75                 
                    STA        $A7,S                
                    REP        #$30                 
                    PHY                             
                    PEA        $2522                
                    PEA        $3223                
                    PEA        $6766                
                    PHY                             
                    TSC                             ; Line 28
                    ADC        #$00A8               
                    TCS                             
                    LDA        #$5777               
                    STA        $A8,S                
                    LDA        $A0,S                
                    AND        #$0F00               
                    ORA        #$2033               
                    STA        $A0,S                
                    SEP        #$20                 
                    LDA        #$66                 
                    STA        $A7,S                
                    LDA        $99,S                
                    AND        #$F0                 
                    ORA        #$05                 
                    STA        $99,S                
                    REP        #$30                 
                    PEA        $2233                
                    PEA        $7723                
                    PEA        $6256                
                    PEA        $5757                
                    TSC                             ; Line 29
                    ADC        #$00A7               
                    TCS                             
                    LDA        #$7567               
                    STA        $A9,S                
                    SEP        #$20                 
                    LDA        #$75                 
                    STA        $A1,S                
                    LDA        $A8,S                
                    AND        #$F0                 
                    ORA        #$06                 
                    STA        $A8,S                
                    REP        #$30                 
                    PEA        $5777                
                    PEA        $2333                
                    PEA        $7675                
                    TSC                             ; Line 30
                    ADC        #$00A6               
                    TCS                             
                    LDA        #$5777               
                    STA        $A9,S                
                    LDA        $9B,S                
                    AND        #$00F0               
                    ORA        #$7705               
                    STA        $9B,S                
                    LDA        $A1,S                
                    AND        #$0F00               
                    ORA        #$7057               
                    STA        $A1,S                
                    SEP        #$20                 
                    LDA        $A8,S                
                    AND        #$F0                 
                    ORA        #$06                 
                    STA        $A8,S                
                    REP        #$30                 
                    PHY                             
                    PEA        $2367                
                    PEA        $5657                
                    TSC                             ; Line 31
                    ADC        #$00A6               
                    TCS                             
                    LDA        #$7567               
                    STA        $A9,S                
                    SEP        #$20                 
                    LDA        $A8,S                
                    AND        #$F0                 
                    ORA        #$06                 
                    STA        $A8,S                
                    REP        #$30                 
                    PEA        $5777                
                    PEA        $7366                
                    TSC                             ; Line 32
                    ADC        #$00A5               
                    TCS                             
                    LDA        $9F,S                
                    AND        #$0F00               
                    ORA        #$5057               
                    STA        $9F,S                
                    LDA        $A8,S                
                    AND        #$0FF0               
                    ORA        #$4004               
                    STA        $A8,S                
                    PHY                             
                    PEA        $7573                
                    PEA        $6776                
                    TSC                             ; Line 33
                    ADC        #$00A4               
                    TCS                             
                    LDA        $AA,S                
                    AND        #$0FF0               
                    ORA        #$4004               
                    STA        $AA,S                
                    SEP        #$20                 
                    LDA        #$77                 
                    STA        $9D,S                
                    REP        #$30                 
                    PHX                             
                    PEA        $6676                
                    TSC                             ; Line 34
                    ADC        #$00A5               
                    TCS                             
                    LDA        $A9,S                
                    AND        #$0FF0               
                    ORA        #$4004               
                    STA        $A9,S                
                    SEP        #$20                 
                    LDA        $9C,S                
                    AND        #$F0                 
                    ORA        #$06                 
                    STA        $9C,S                
                    REP        #$30                 
                    PHY                             
                    PEA        $6767                
                    TSC                             ; Line 35
                    ADC        #$00A4               
                    TCS                             
                    SEP        #$20                 
                    LDA        #$44                 
                    STA        $A9,S                
                    LDA        $9C,S                
                    AND        #$F0                 
                    ORA        #$06                 
                    STA        $9C,S                
                    REP        #$30                 
                    PEA        $5777                
                    PEA        $7766                
                    TSC                             ; Line 36
                    ADC        #$00A4               
                    TCS                             
                    LDA        #$7666               
                    STA        $9D,S                
                    LDA        $9F,S                
                    AND        #$0F00               
                    ORA        #$5077               
                    STA        $9F,S                
                    SEP        #$20                 
                    LDA        $9C,S                
                    AND        #$F0                 
                    ORA        #$06                 
                    STA        $9C,S                
                    REP        #$30                 
                    PEA        $7565                
                    PEA        $6767                
                    TSC                             ; Line 38
                    ADC        #$0131               
                    TCS                             
                    LDA        #$6767               
                    STA        $10,S                
                    LDA        #$7666               
                    STA        $B0,S                
                    LDA        $12,S                
                    AND        #$0F00               
                    ORA        #$7075               
                    STA        $12,S                
                    LDA        $B2,S                
                    AND        #$0F00               
                    ORA        #$5077               
                    STA        $B2,S                
                    TSC                             ; Line 40
                    ADC        #$0140               
                    TCS                             
                    LDA        #$6767               
                    STA        $10,S                
                    LDA        #$7666               
                    STA        $B0,S                
                    LDA        $12,S                
                    AND        #$0F00               
                    ORA        #$7075               
                    STA        $12,S                
                    LDA        $B2,S                
                    AND        #$0F00               
                    ORA        #$5057               
                    STA        $B2,S                
                    TSC                             ; Line 42
                    ADC        #$0140               
                    TCS                             
                    LDA        #$6766               
                    STA        $10,S                
                    LDA        $12,S                
                    AND        #$0F00               
                    ORA        #$7065               
                    STA        $12,S                
                    LDA        $B0,S                
                    AND        #$00F0               
                    ORA        #$7606               
                    STA        $B0,S                
                    LDA        $B2,S                
                    AND        #$0F00               
                    ORA        #$5077               
                    STA        $B2,S                
                    TSC                             ; Line 44
                    ADC        #$0140               
                    TCS                             
                    TYA                             
                    STA        $12,S                
                    LDA        #$5777               
                    STA        $B2,S                
                    LDA        $10,S                
                    AND        #$00F0               
                    ORA        #$6706               
                    STA        $10,S                
                    LDA        $B0,S                
                    AND        #$00F0               
                    ORA        #$7606               
                    STA        $B0,S                
                    TSC                             ; Line 46
                    ADC        #$0140               
                    TCS                             
                    LDA        $10,S                
                    AND        #$00F0               
                    ORA        #$6706               
                    STA        $10,S                
                    LDA        $12,S                
                    AND        #$0F00               
                    ORA        #$7075               
                    STA        $12,S                
                    LDA        $B0,S                
                    AND        #$00F0               
                    ORA        #$6606               
                    STA        $B0,S                
                    LDA        $B2,S                
                    AND        #$0F00               
                    ORA        #$5077               
                    STA        $B2,S                
                    TSC                             ; Line 48
                    ADC        #$0140               
                    TCS                             
                    LDA        #$7567               
                    STA        $11,S                
                    LDA        #$5767               
                    STA        $B1,S                
                    LDA        $09,S                
                    AND        #$F0F0               
                    ORA        #$0505               
                    STA        $09,S                
                    LDA        $18,S                
                    AND        #$F0F0               
                    ORA        #$0505               
                    STA        $18,S                
                    LDA        $A0,S                
                    AND        #$0F0F               
                    ORA        #$5050               
                    STA        $A0,S                
                    LDA        $A2,S                
                    AND        #$0F0F               
                    ORA        #$5050               
                    STA        $A2,S                
                    LDA        $A4,S                
                    AND        #$0F0F               
                    ORA        #$5050               
                    STA        $A4,S                
                    LDA        $A6,S                
                    AND        #$0F0F               
                    ORA        #$5050               
                    STA        $A6,S                
                    LDA        $A8,S                
                    AND        #$0F0F               
                    ORA        #$5050               
                    STA        $A8,S                
                    LDA        $AA,S                
                    AND        #$0F0F               
                    ORA        #$5050               
                    STA        $AA,S                
                    LDA        $AC,S                
                    AND        #$0F0F               
                    ORA        #$5050               
                    STA        $AC,S                
                    LDA        $AE,S                
                    AND        #$0F0F               
                    ORA        #$5050               
                    STA        $AE,S                
                    LDA        $B5,S                
                    AND        #$0F0F               
                    ORA        #$5050               
                    STA        $B5,S                
                    LDA        $B7,S                
                    AND        #$0F0F               
                    ORA        #$5050               
                    STA        $B7,S                
                    LDA        $B9,S                
                    AND        #$0F0F               
                    ORA        #$5050               
                    STA        $B9,S                
                    LDA        $BB,S                
                    AND        #$0F0F               
                    ORA        #$5050               
                    STA        $BB,S                
                    SEP        #$20                 
                    LDA        $0B,S                
                    AND        #$F0                 
                    ORA        #$05                 
                    STA        $0B,S                
                    LDA        $13,S                
                    AND        #$0F                 
                    ORA        #$70                 
                    STA        $13,S                
                    LDA        $1A,S                
                    AND        #$F0                 
                    ORA        #$05                 
                    STA        $1A,S                
                    LDA        $B3,S                
                    AND        #$0F                 
                    ORA        #$50                 
                    STA        $B3,S                
                    REP        #$30                 
                    TSC                             ; Line 50
                    ADC        #$0140               
                    TCS                             
                    LDA        #$4444               
                    STA        $B2,S                
                    LDA        $00,S                
                    AND        #$F0F0               
                    ORA        #$0505               
                    STA        $00,S                
                    LDA        $02,S                
                    AND        #$F0F0               
                    ORA        #$0505               
                    STA        $02,S                
                    LDA        $04,S                
                    AND        #$F0F0               
                    ORA        #$0505               
                    STA        $04,S                
                    LDA        $06,S                
                    AND        #$F0F0               
                    ORA        #$0505               
                    STA        $06,S                
                    LDA        $08,S                
                    AND        #$F0F0               
                    ORA        #$0505               
                    STA        $08,S                
                    LDA        $0A,S                
                    AND        #$F0F0               
                    ORA        #$0505               
                    STA        $0A,S                
                    LDA        $0C,S                
                    AND        #$F0F0               
                    ORA        #$0505               
                    STA        $0C,S                
                    LDA        $0E,S                
                    AND        #$F0F0               
                    ORA        #$0505               
                    STA        $0E,S                
                    LDA        $10,S                
                    AND        #$F0F0               
                    ORA        #$0405               
                    STA        $10,S                
                    LDA        $13,S                
                    AND        #$F0F0               
                    ORA        #$0505               
                    STA        $13,S                
                    LDA        $15,S                
                    AND        #$F0F0               
                    ORA        #$0505               
                    STA        $15,S                
                    LDA        $17,S                
                    AND        #$F0F0               
                    ORA        #$0505               
                    STA        $17,S                
                    LDA        $19,S                
                    AND        #$F0F0               
                    ORA        #$0505               
                    STA        $19,S                
                    LDA        $1B,S                
                    AND        #$F0F0               
                    ORA        #$0505               
                    STA        $1B,S                
                    LDA        $A4,S                
                    AND        #$0F0F               
                    ORA        #$5050               
                    STA        $A4,S                
                    LDA        $A6,S                
                    AND        #$0F0F               
                    ORA        #$5050               
                    STA        $A6,S                
                    LDA        $A8,S                
                    AND        #$0F0F               
                    ORA        #$5050               
                    STA        $A8,S                
                    LDA        $AA,S                
                    AND        #$0F0F               
                    ORA        #$5050               
                    STA        $AA,S                
                    LDA        $AC,S                
                    AND        #$0F0F               
                    ORA        #$5050               
                    STA        $AC,S                
                    LDA        $AE,S                
                    AND        #$0F0F               
                    ORA        #$5050               
                    STA        $AE,S                
                    LDA        $B0,S                
                    AND        #$000F               
                    ORA        #$5450               
                    STA        $B0,S                
                    LDA        $B4,S                
                    AND        #$0F0F               
                    ORA        #$5050               
                    STA        $B4,S                
                    LDA        $B6,S                
                    AND        #$0F0F               
                    ORA        #$5050               
                    STA        $B6,S                
                    LDA        $B8,S                
                    AND        #$0F0F               
                    ORA        #$5050               
                    STA        $B8,S                
                    LDA        $BA,S                
                    AND        #$0F0F               
                    ORA        #$5050               
                    STA        $BA,S                
                    SEP        #$20                 
                    LDA        #$44                 
                    STA        $12,S                
                    REP        #$30                 
                    TSC                             ; Line 52
                    ADC        #$0140               
                    TCS                             
                    LDA        #$4444               
                    STA        $13,S                
                    LDA        $09,S                
                    AND        #$F0F0               
                    ORA        #$0505               
                    STA        $09,S                
                    LDA        $0B,S                
                    AND        #$F0F0               
                    ORA        #$0505               
                    STA        $0B,S                
                    LDA        $0D,S                
                    AND        #$F0F0               
                    ORA        #$0505               
                    STA        $0D,S                
                    LDA        $0F,S                
                    AND        #$F0F0               
                    ORA        #$0505               
                    STA        $0F,S                
                    LDA        $11,S                
                    AND        #$F0F0               
                    ORA        #$0405               
                    STA        $11,S                
                    LDA        $17,S                
                    AND        #$F0F0               
                    ORA        #$0505               
                    STA        $17,S                
                    LDA        $19,S                
                    AND        #$F0F0               
                    ORA        #$0505               
                    STA        $19,S                
*--                                                 
                    LDAL       $E1C068              ; Direct Page and Stack in Bank 00/
                    AND        #$FFCF               
                    STAL       $E1C068              
                    LDA        StackAddress         ; Restore Stack
                    TCS                             
                    PLD                             ; Restore Direct Page
                    CLI                             ; Enable Interrupts
                    PLB
                    RTL                             
                                                    
*-----------------------------------                                
Sprite_BL_02E       CLC                             ; Sprite #02E : 48x56, 1945 bytes, 3120 cycles
                    SEI                             ; Disable Interrupts
                    PHD                             ; Backup Direct Page
                    TSC                             ; Backup Stack
                    STA        StackAddress         
                    LDAL       $E1C068              ; Direct Page and Stack in Bank 01/
                    ORA        #$0030               
                    STAL       $E1C068              
                    TYA                             ; Y = Sprite Target Screen Address (upper left corner)
                    TCS                             ; New Stack address
                    LDX        #$7575               ; Pattern #1 : 25
                    LDY        #$5777               ; Pattern #2 : 16
                    LDA        #$5757               ; Pattern #3 : 16
                    TCD                             
*--                                                 
                    LDA        #$5555               ; Line 0
                    STA        $0F,S                
                    STA        $AE,S                
                    LDA        $B0,S                
                    AND        #$0F00               
                    ORA        #$5055               
                    STA        $B0,S                
                    TSC                             ; Line 2
                    ADC        #$0140               
                    TCS                             
                    SEP        #$20                 
                    LDA        $0D,S                
                    AND        #$F0                 
                    ORA        #$05                 
                    STA        $0D,S                
                    LDA        $AD,S                
                    AND        #$F0                 
                    ORA        #$03                 
                    STA        $AD,S                
                    REP        #$30                 
                    TSC                             
                    ADC        #$0011               
                    TCS                             
                    PEA        $5555                
                    PEA        $5555                
                    TSC                             ; Line 3
                    ADC        #$00A4               
                    TCS                             
                    SEP        #$20                 
                    LDA        $9C,S                
                    AND        #$F0                 
                    ORA        #$03                 
                    STA        $9C,S                
                    REP        #$30                 
                    PEA        $3333                
                    PEA        $3333                
                    TSC                             ; Line 4
                    ADC        #$00A4               
                    TCS                             
                    SEP        #$20                 
                    LDA        $9C,S                
                    AND        #$F0                 
                    ORA        #$04                 
                    STA        $9C,S                
                    REP        #$30                 
                    PEA        $3333                
                    PEA        $3333                
                    TSC                             ; Line 5
                    ADC        #$00A4               
                    TCS                             
                    SEP        #$20                 
                    LDA        $9C,S                
                    AND        #$F0                 
                    ORA        #$04                 
                    STA        $9C,S                
                    REP        #$30                 
                    PEA        $5555                
                    PEA        $4544                
                    TSC                             ; Line 6
                    ADC        #$00A4               
                    TCS                             
                    SEP        #$20                 
                    LDA        #$55                 
                    STA        $A0,S                
                    REP        #$30                 
                    PEA        $5555                
                    PEA        $4555                
                    TSC                             ; Line 7
                    ADC        #$00A3               
                    TCS                             
                    SEP        #$20                 
                    LDA        $A1,S                
                    AND        #$0F                 
                    ORA        #$50                 
                    STA        $A1,S                
                    REP        #$30                 
                    PEA        $4545                
                    PEA        $4444                
                    TSC                             ; Line 8
                    ADC        #$00A4               
                    TCS                             
                    LDA        #$4444               
                    STA        $9E,S                
                    LDA        $A0,S                
                    AND        #$0F00               
                    ORA        #$5045               
                    STA        $A0,S                
                    SEP        #$20                 
                    LDA        $9D,S                
                    AND        #$F0                 
                    ORA        #$04                 
                    STA        $9D,S                
                    REP        #$30                 
                    PEA        $4544                
                    PEA        $4444                
                    TSC                             ; Line 10
                    ADC        #$0134               
                    TCS                             
                    LDA        #$4444               
                    STA        $0F,S                
                    LDA        #$6744               
                    STA        $B0,S                
                    LDA        $0D,S                
                    AND        #$00F0               
                    ORA        #$4404               
                    STA        $0D,S                
                    LDA        $AE,S                
                    AND        #$00F0               
                    ORA        #$4404               
                    STA        $AE,S                
                    TSC                             ; Line 12
                    ADC        #$0140               
                    TCS                             
                    LDA        #$4444               
                    STA        $0F,S                
                    LDA        $0D,S                
                    AND        #$00F0               
                    ORA        #$7707               
                    STA        $0D,S                
                    LDA        $11,S                
                    AND        #$0F00               
                    ORA        #$5067               
                    STA        $11,S                
                    TSC                             ; Line 13
                    ADC        #$00B2               
                    TCS                             
                    LDA        $9A,S                
                    AND        #$00F0               
                    ORA        #$7707               
                    STA        $9A,S                
                    LDA        $A0,S                
                    AND        #$0F00               
                    ORA        #$5057               
                    STA        $A0,S                
                    PEA        $7567                
                    PEA        $6644                
                    PEA        $7577                
                    TSC                             ; Line 14
                    ADC        #$00A5               
                    TCS                             
                    PEA        $7766                
                    PEA        $4454                
                    TSC                             ; Line 15
                    ADC        #$00A6               
                    TCS                             
                    LDA        $98,S                
                    AND        #$00F0               
                    ORA        #$7706               
                    STA        $98,S                
                    LDA        $A0,S                
                    AND        #$0F00               
                    ORA        #$5057               
                    STA        $A0,S                
                    PHX                             
                    PEA        $5767                
                    PEA        $4174                
                    PEA        $7577                
                    TSC                             ; Line 16
                    ADC        #$00A7               
                    TCS                             
                    PHY                             
                    PEA        $7516                
                    PEA        $4457                
                    TSC                             ; Line 17
                    ADC        #$00A8               
                    TCS                             
                    LDA        $96,S                
                    AND        #$00F0               
                    ORA        #$7706               
                    STA        $96,S                
                    LDA        $A0,S                
                    AND        #$0F00               
                    ORA        #$5057               
                    STA        $A0,S                
                    PHX                             
                    PEA        $7777                
                    PEA        $5767                
                    PEA        $4175                
                    PEA        $7567                
                    TSC                             ; Line 18
                    ADC        #$00A9               
                    TCS                             
                    PEA        $7767                
                    PEA        $6777                
                    PEA        $7516                
                    PHY                             
                    TSC                             ; Line 19
                    ADC        #$00AA               
                    TCS                             
                    LDA        $94,S                
                    AND        #$00F0               
                    ORA        #$6706               
                    STA        $94,S                
                    LDA        $A0,S                
                    AND        #$0F00               
                    ORA        #$5057               
                    STA        $A0,S                
                    PHX                             
                    PEA        $7776                
                    PEA        $7676                
                    PEA        $5767                
                    PEA        $7675                
                    PEA        $7566                
                    TSC                             ; Line 20
                    ADC        #$00AB               
                    TCS                             
                    LDA        $94,S                
                    AND        #$00F0               
                    ORA        #$6606               
                    STA        $94,S                
                    SEP        #$20                 
                    LDA        $A2,S                
                    AND        #$0F                 
                    ORA        #$70                 
                    STA        $A2,S                
                    REP        #$30                 
                    PEA        $7767                
                    PEA        $6767                
                    PEA        $6777                
                    PEA        $7576                
                    PHD                             
                    TSC                             ; Line 21
                    ADC        #$00AB               
                    TCS                             
                    PEA        $7577                
                    PEA        $7677                
                    PEA        $7777                
                    PEA        $6657                
                    PEA        $6677                
                    PHX                             
                    TSC                             ; Line 22
                    ADC        #$00AD               
                    TCS                             
                    LDA        #$7577               
                    STA        $9F,S                
                    LDA        $9D,S                
                    AND        #$F00F               
                    ORA        #$0650               
                    STA        $9D,S                
                    SEP        #$20                 
                    LDA        #$76                 
                    STA        $96,S                
                    LDA        $8E,S                
                    AND        #$F0                 
                    ORA        #$04                 
                    STA        $8E,S                
                    REP        #$30                 
                    PHY                             
                    PEA        $6777                
                    PEA        $7775                
                    PEA        $6767                
                    PEA        $6667                
                    PEA        $5657                
                    PHY                             
                    PEA        $6666                
                    TSC                             ; Line 23
                    ADC        #$00A4               
                    TCS                             
                    LDA        #$5767               
                    STA        $AB,S                
                    SEP        #$20                 
                    LDA        #$75                 
                    STA        $A8,S                
                    LDA        $A0,S                
                    AND        #$0F                 
                    ORA        #$50                 
                    STA        $A0,S                
                    LDA        $AD,S                
                    AND        #$0F                 
                    ORA        #$50                 
                    STA        $AD,S                
                    REP        #$30                 
                    PHX                             
                    PEA        $7766                
                    PEA        $6644                
                    TSC                             
                    ADC        #$000E               
                    TCS                             
                    PHD                             
                    PEA        $7776                
                    PEA        $6656                
                    TSC                             ; Line 24
                    ADC        #$009D               
                    TCS                             
                    LDA        #$7576               
                    STA        $AC,S                
                    SEP        #$20                 
                    LDA        #$44                 
                    STA        $9C,S                
                    LDA        #$76                 
                    STA        $A3,S                
                    LDA        $AE,S                
                    AND        #$0F                 
                    ORA        #$70                 
                    STA        $AE,S                
                    REP        #$30                 
                    PEA        $5767                
                    PEA        $6767                
                    PEA        $4444                
                    TSC                             
                    ADC        #$000E               
                    TCS                             
                    PHX                             
                    PEA        $6766                
                    PEA        $6675                
                    TSC                             ; Line 25
                    ADC        #$009E               
                    TCS                             
                    TDC                             
                    STA        $9D,S                
                    LDA        #$5767               
                    STA        $AD,S                
                    LDA        $9F,S                
                    AND        #$0F00               
                    ORA        #$7057               
                    STA        $9F,S                
                    SEP        #$20                 
                    LDA        #$75                 
                    STA        $A9,S                
                    LDA        $AC,S                
                    AND        #$F0                 
                    ORA        #$07                 
                    STA        $AC,S                
                    REP        #$30                 
                    PHX                             
                    PHX                             
                    TSC                             
                    ADC        #$000D               
                    TCS                             
                    PHD                             
                    PHY                             
                    PEA        $7666                
                    TSC                             ; Line 26
                    ADC        #$00A5               
                    TCS                             
                    LDA        #$7576               
                    STA        $A5,S                
                    SEP        #$20                 
                    LDA        $9B,S                
                    AND        #$F0                 
                    ORA        #$06                 
                    STA        $9B,S                
                    LDA        $A4,S                
                    AND        #$F0                 
                    ORA        #$06                 
                    STA        $A4,S                
                    REP        #$30                 
                    PHX                             
                    PEA        $7767                
                    PEA        $6676                
                    TSC                             ; Line 27
                    ADC        #$00A7               
                    TCS                             
                    LDA        #$5767               
                    STA        $A4,S                
                    SEP        #$20                 
                    LDA        #$33                 
                    STA        $A0,S                
                    REP        #$30                 
                    PEA        $2257                
                    PEA        $7777                
                    PEA        $7666                
                    TSC                             ; Line 28
                    ADC        #$00A5               
                    TCS                             
                    LDA        $A5,S                
                    AND        #$00F0               
                    ORA        #$7506               
                    STA        $A5,S                
                    SEP        #$20                 
                    LDA        #$75                 
                    STA        $A1,S                
                    REP        #$30                 
                    PEA        $2322                
                    PEA        $2267                
                    PEA        $6633                
                    TSC                             ; Line 29
                    ADC        #$00A6               
                    TCS                             
                    SEP        #$20                 
                    LDA        #$77                 
                    STA        $9B,S                
                    LDA        #$64                 
                    STA        $A6,S                
                    REP        #$30                 
                    PEA        $3533                
                    PEA        $3333                
                    PEA        $2323                
                    TSC                             ; Line 30
                    ADC        #$00A7               
                    TCS                             
                    LDA        $99,S                
                    AND        #$00F0               
                    ORA        #$6206               
                    STA        $99,S                
                    SEP        #$20                 
                    LDA        #$44                 
                    STA        $A5,S                
                    LDA        $A1,S                
                    AND        #$0F                 
                    ORA        #$70                 
                    STA        $A1,S                
                    REP        #$30                 
                    PHD                             
                    PHY                             
                    PEA        $3773                
                    TSC                             ; Line 31
                    ADC        #$00A6               
                    TCS                             
                    SEP        #$20                 
                    LDA        #$44                 
                    STA        $A5,S                
                    LDA        $A1,S                
                    AND        #$0F                 
                    ORA        #$50                 
                    STA        $A1,S                
                    REP        #$30                 
                    PHX                             
                    PEA        $6777                
                    PEA        $3732                
                    TSC                             ; Line 32
                    ADC        #$00A6               
                    TCS                             
                    LDA        $A0,S                
                    AND        #$0F00               
                    ORA        #$7075               
                    STA        $A0,S                
                    SEP        #$20                 
                    LDA        $A5,S                
                    AND        #$0F                 
                    ORA        #$40                 
                    STA        $A5,S                
                    REP        #$30                 
                    PHY                             
                    PEA        $7676                
                    PEA        $2377                
                    PEA        $7366                
                    TSC                             ; Line 33
                    ADC        #$00A7               
                    TCS                             
                    LDA        $98,S                
                    AND        #$00F0               
                    ORA        #$6706               
                    STA        $98,S                
                    SEP        #$20                 
                    LDA        $A2,S                
                    AND        #$0F                 
                    ORA        #$50                 
                    STA        $A2,S                
                    REP        #$30                 
                    PEA        $7567                
                    PEA        $3662                
                    PEA        $2773                
                    PEA        $7766                
                    TSC                             ; Line 34
                    ADC        #$00A9               
                    TCS                             
                    LDA        $96,S                
                    AND        #$00F0               
                    ORA        #$6706               
                    STA        $96,S                
                    LDA        $A0,S                
                    AND        #$0F00               
                    ORA        #$7075               
                    STA        $A0,S                
                    PHY                             
                    PEA        $7636                
                    PEA        $6277                
                    PEA        $7767                
                    TSC                             ; Line 35
                    ADC        #$00A7               
                    TCS                             
                    LDA        $A1,S                
                    AND        #$0F00               
                    ORA        #$5057               
                    STA        $A1,S                
                    PEA        $7767                
                    PEA        $3677                
                    PEA        $7657                
                    PEA        $7766                
                    TSC                             ; Line 36
                    ADC        #$00A8               
                    TCS                             
                    LDA        $96,S                
                    AND        #$00F0               
                    ORA        #$1706               
                    STA        $96,S                
                    PEA        $7776                
                    PEA        $6667                
                    PHX                             
                    PEA        $7577                
                    PEA        $7666                
                    TSC                             ; Line 37
                    ADC        #$00AB               
                    TCS                             
                    SEP        #$20                 
                    LDA        $94,S                
                    AND        #$F0                 
                    ORA        #$01                 
                    STA        $94,S                
                    REP        #$30                 
                    PEA        $7577                
                    PEA        $6767                
                    PEA        $6657                
                    PHD                             
                    PEA        $5767                
                    TSC                             ; Line 38
                    ADC        #$00AA               
                    TCS                             
                    SEP        #$20                 
                    LDA        $9A,S                
                    AND        #$0F                 
                    ORA        #$50                 
                    STA        $9A,S                
                    LDA        $9C,S                
                    AND        #$F0                 
                    ORA        #$07                 
                    STA        $9C,S                
                    REP        #$30                 
                    PHY                             
                    PEA        $7666                
                    PEA        $7675                
                    PHX                             
                    PHX                             
                    PEA        $7661                
                    TSC                             ; Line 39
                    ADC        #$00A5               
                    TCS                             
                    LDA        $9A,S                
                    AND        #$00F0               
                    ORA        #$7601               
                    STA        $9A,S                
                    SEP        #$20                 
                    LDA        $A3,S                
                    AND        #$F0                 
                    ORA        #$06                 
                    STA        $A3,S                
                    REP        #$30                 
                    PHD                             
                    PEA        $5767                
                    PEA        $1716                
                    TSC                             
                    ADC        #$000D               
                    TCS                             
                    PEA        $7577                
                    PEA        $6767                
                    TSC                             ; Line 40
                    ADC        #$009C               
                    TCS                             
                    LDA        $9A,S                
                    AND        #$00F0               
                    ORA        #$6706               
                    STA        $9A,S                
                    SEP        #$20                 
                    LDA        $A0,S                
                    AND        #$0F                 
                    ORA        #$50                 
                    STA        $A0,S                
                    REP        #$30                 
                    PHX                             
                    PEA        $7577                
                    TSC                             
                    ADC        #$000C               
                    TCS                             
                    PHY                             
                    PEA        $7616                
                    TSC                             ; Line 41
                    ADC        #$009B               
                    TCS                             
                    LDA        $9F,S                
                    AND        #$0F00               
                    ORA        #$7075               
                    STA        $9F,S                
                    SEP        #$20                 
                    LDA        $9A,S                
                    AND        #$F0                 
                    ORA        #$06                 
                    STA        $9A,S                
                    REP        #$30                 
                    PHD                             
                    PEA        $5767                
                    TSC                             
                    ADC        #$000D               
                    TCS                             
                    PEA        $7567                
                    PEA        $6766                
                    TSC                             ; Line 42
                    ADC        #$0099               
                    TCS                             
                    LDA        $9B,S                
                    AND        #$00F0               
                    ORA        #$6606               
                    STA        $9B,S                
                    PHX                             
                    PEA        $7666                
                    TSC                             
                    ADC        #$000F               
                    TCS                             
                    PHY                             
                    PEA        $6661                
                    TSC                             ; Line 43
                    ADC        #$0099               
                    TCS                             
                    SEP        #$20                 
                    LDA        $9F,S                
                    AND        #$0F                 
                    ORA        #$70                 
                    STA        $9F,S                
                    REP        #$30                 
                    PHD                             
                    PEA        $6767                
                    TSC                             
                    ADC        #$000F               
                    TCS                             
                    PEA        $7577                
                    PEA        $1666                
                    TSC                             ; Line 44
                    ADC        #$0097               
                    TCS                             
                    SEP        #$20                 
                    LDA        #$57                 
                    STA        $A0,S                
                    REP        #$30                 
                    PHX                             
                    PEA        $7646                
                    TSC                             
                    ADC        #$0011               
                    TCS                             
                    PEA        $5767                
                    PEA        $6161                
                    TSC                             ; Line 45
                    ADC        #$0096               
                    TCS                             
                    TXA                             
                    STA        $9F,S                
                    TYA                             
                    STA        $AD,S                
                    LDA        $9D,S                
                    AND        #$0F00               
                    ORA        #$4044               
                    STA        $9D,S                
                    LDA        $AB,S                
                    AND        #$00F0               
                    ORA        #$6106               
                    STA        $AB,S                
                    SEP        #$20                 
                    LDA        $9C,S                
                    AND        #$F0                 
                    ORA        #$04                 
                    STA        $9C,S                
                    REP        #$30                 
                    PEA        $5767                
                    PEA        $4444                
                    TSC                             
                    ADC        #$0012               
                    TCS                             
                    PEA        $7566                
                    PEA        $1666                
                    TSC                             ; Line 47
                    ADC        #$0132               
                    TCS                             
                    LDA        #$4444               
                    STA        $00,S                
                    TXA                             
                    STA        $11,S                
                    TYA                             
                    STA        $B1,S                
                    LDA        $0F,S                
                    AND        #$00F0               
                    ORA        #$6706               
                    STA        $0F,S                
                    LDA        $AF,S                
                    AND        #$00F0               
                    ORA        #$7606               
                    STA        $AF,S                
                    SEP        #$20                 
                    LDA        #$57                 
                    STA        $03,S                
                    REP        #$30                 
                    TSC                             ; Line 49
                    ADC        #$0140               
                    TCS                             
                    LDA        $0F,S                
                    AND        #$00F0               
                    ORA        #$6706               
                    STA        $0F,S                
                    LDA        $11,S                
                    AND        #$0F00               
                    ORA        #$7075               
                    STA        $11,S                
                    LDA        $AF,S                
                    AND        #$00F0               
                    ORA        #$6606               
                    STA        $AF,S                
                    LDA        $B1,S                
                    AND        #$0F00               
                    ORA        #$5077               
                    STA        $B1,S                
                    TSC                             ; Line 51
                    ADC        #$0140               
                    TCS                             
                    LDA        #$7567               
                    STA        $10,S                
                    LDA        #$5767               
                    STA        $B0,S                
                    LDA        $A8,S                
                    AND        #$0F0F               
                    ORA        #$5050               
                    STA        $A8,S                
                    LDA        $AA,S                
                    AND        #$0F0F               
                    ORA        #$5050               
                    STA        $AA,S                
                    LDA        $AC,S                
                    AND        #$0F0F               
                    ORA        #$5050               
                    STA        $AC,S                
                    SEP        #$20                 
                    LDA        $12,S                
                    AND        #$0F                 
                    ORA        #$70                 
                    STA        $12,S                
                    LDA        $B2,S                
                    AND        #$0F                 
                    ORA        #$50                 
                    STA        $B2,S                
                    REP        #$30                 
                    TSC                             ; Line 53
                    ADC        #$0140               
                    TCS                             
                    LDA        #$4454               
                    STA        $B0,S                
                    LDA        $00,S                
                    AND        #$F0F0               
                    ORA        #$0505               
                    STA        $00,S                
                    LDA        $02,S                
                    AND        #$F0F0               
                    ORA        #$0505               
                    STA        $02,S                
                    LDA        $04,S                
                    AND        #$F0F0               
                    ORA        #$0505               
                    STA        $04,S                
                    LDA        $06,S                
                    AND        #$F0F0               
                    ORA        #$0505               
                    STA        $06,S                
                    LDA        $08,S                
                    AND        #$F0F0               
                    ORA        #$0505               
                    STA        $08,S                
                    LDA        $0A,S                
                    AND        #$F0F0               
                    ORA        #$0505               
                    STA        $0A,S                
                    LDA        $0C,S                
                    AND        #$F0F0               
                    ORA        #$0505               
                    STA        $0C,S                
                    LDA        $0E,S                
                    AND        #$F0F0               
                    ORA        #$0505               
                    STA        $0E,S                
                    LDA        $10,S                
                    AND        #$00F0               
                    ORA        #$4404               
                    STA        $10,S                
                    LDA        $13,S                
                    AND        #$F0F0               
                    ORA        #$0505               
                    STA        $13,S                
                    LDA        $15,S                
                    AND        #$F0F0               
                    ORA        #$0505               
                    STA        $15,S                
                    LDA        $A1,S                
                    AND        #$0F0F               
                    ORA        #$5050               
                    STA        $A1,S                
                    LDA        $A3,S                
                    AND        #$0F0F               
                    ORA        #$5050               
                    STA        $A3,S                
                    LDA        $A5,S                
                    AND        #$0F0F               
                    ORA        #$5050               
                    STA        $A5,S                
                    LDA        $A7,S                
                    AND        #$0F0F               
                    ORA        #$5050               
                    STA        $A7,S                
                    LDA        $A9,S                
                    AND        #$0F0F               
                    ORA        #$5050               
                    STA        $A9,S                
                    LDA        $AB,S                
                    AND        #$0F0F               
                    ORA        #$5050               
                    STA        $AB,S                
                    LDA        $AD,S                
                    AND        #$0F0F               
                    ORA        #$5050               
                    STA        $AD,S                
                    LDA        $B2,S                
                    AND        #$0F00               
                    ORA        #$5044               
                    STA        $B2,S                
                    LDA        $B4,S                
                    AND        #$0F0F               
                    ORA        #$5050               
                    STA        $B4,S                
                    LDA        $B6,S                
                    AND        #$0F0F               
                    ORA        #$5050               
                    STA        $B6,S                
                    SEP        #$20                 
                    LDA        $AF,S                
                    AND        #$0F                 
                    ORA        #$50                 
                    STA        $AF,S                
                    REP        #$30                 
                    TSC                             ; Line 55
                    ADC        #$0140               
                    TCS                             
                    LDA        #$4444               
                    STA        $12,S                
                    LDA        $05,S                
                    AND        #$F0F0               
                    ORA        #$0505               
                    STA        $05,S                
                    LDA        $07,S                
                    AND        #$F0F0               
                    ORA        #$0505               
                    STA        $07,S                
                    LDA        $09,S                
                    AND        #$F0F0               
                    ORA        #$0505               
                    STA        $09,S                
                    LDA        $0B,S                
                    AND        #$F0F0               
                    ORA        #$0505               
                    STA        $0B,S                
                    LDA        $0D,S                
                    AND        #$F0F0               
                    ORA        #$0505               
                    STA        $0D,S                
                    LDA        $0F,S                
                    AND        #$F0F0               
                    ORA        #$0505               
                    STA        $0F,S                
                    LDA        $15,S                
                    AND        #$F0F0               
                    ORA        #$0505               
                    STA        $15,S                
                    SEP        #$20                 
                    LDA        $11,S                
                    AND        #$F0                 
                    ORA        #$04                 
                    STA        $11,S                
                    REP        #$30                 
*--                                                 
                    LDAL       $E1C068              ; Direct Page and Stack in Bank 00/
                    AND        #$FFCF               
                    STAL       $E1C068              
                    LDA        StackAddress         ; Restore Stack
                    TCS                             
                    PLD                             ; Restore Direct Page
                    CLI                             ; Enable Interrupts
                    PLB
                    RTL                             
                                                    
*-----------------------------------                                
Sprite_BL_02F       CLC                             ; Sprite #02F : 40x53, 1784 bytes, 2849 cycles
                    SEI                             ; Disable Interrupts
                    PHD                             ; Backup Direct Page
                    TSC                             ; Backup Stack
                    STA        StackAddress         
                    LDAL       $E1C068              ; Direct Page and Stack in Bank 01/
                    ORA        #$0030               
                    STAL       $E1C068              
                    TYA                             ; Y = Sprite Target Screen Address (upper left corner)
                    TCS                             ; New Stack address
                    LDX        #$7575               ; Pattern #1 : 19
                    LDY        #$5757               ; Pattern #2 : 14
                    LDA        #$4444               ; Pattern #3 : 12
                    TCD                             
*--                                                 
                    LDA        #$5555               ; Line 0
                    STA        $AD,S                
                    LDA        $0C,S                
                    AND        #$00F0               
                    ORA        #$5505               
                    STA        $0C,S                
                    LDA        $AB,S                
                    AND        #$00F0               
                    ORA        #$5505               
                    STA        $AB,S                
                    SEP        #$20                 
                    LDA        $0E,S                
                    AND        #$0F                 
                    ORA        #$50                 
                    STA        $0E,S                
                    REP        #$30                 
                    TSC                             ; Line 2
                    ADC        #$014E               
                    TCS                             
                    SEP        #$20                 
                    LDA        $01,S                
                    AND        #$0F                 
                    ORA        #$50                 
                    STA        $01,S                
                    LDA        $A1,S                
                    AND        #$0F                 
                    ORA        #$30                 
                    STA        $A1,S                
                    REP        #$30                 
                    PEA        $5555                
                    PEA        $5555                
                    TSC                             ; Line 3
                    ADC        #$00A4               
                    TCS                             
                    SEP        #$20                 
                    LDA        $A1,S                
                    AND        #$0F                 
                    ORA        #$30                 
                    STA        $A1,S                
                    REP        #$30                 
                    PEA        $3333                
                    PEA        $3333                
                    TSC                             ; Line 4
                    ADC        #$00A4               
                    TCS                             
                    SEP        #$20                 
                    LDA        $A1,S                
                    AND        #$0F                 
                    ORA        #$50                 
                    STA        $A1,S                
                    REP        #$30                 
                    PEA        $3333                
                    PEA        $3333                
                    TSC                             ; Line 5
                    ADC        #$00A4               
                    TCS                             
                    SEP        #$20                 
                    LDA        $A1,S                
                    AND        #$0F                 
                    ORA        #$50                 
                    STA        $A1,S                
                    REP        #$30                 
                    PEA        $5555                
                    PHD                             
                    TSC                             ; Line 6
                    ADC        #$00A4               
                    TCS                             
                    LDA        #$5444               
                    STA        $9E,S                
                    LDA        $9C,S                
                    AND        #$00F0               
                    ORA        #$4404               
                    STA        $9C,S                
                    LDA        $A0,S                
                    AND        #$0F00               
                    ORA        #$5055               
                    STA        $A0,S                
                    PEA        $5555                
                    PEA        $5445                
                    TSC                             ; Line 8
                    ADC        #$0136               
                    TCS                             
                    SEP        #$20                 
                    LDA        $0A,S                
                    AND        #$F0                 
                    ORA        #$04                 
                    STA        $0A,S                
                    REP        #$30                 
                    TSC                             
                    ADC        #$000E               
                    TCS                             
                    PEA        $5544                
                    PHD                             
                    TSC                             ; Line 9
                    ADC        #$00A4               
                    TCS                             
                    TDC                             
                    STA        $9D,S                
                    LDA        $9F,S                
                    AND        #$0F00               
                    ORA        #$4044               
                    STA        $9F,S                
                    PEA        $5544                
                    PHD                             
                    TSC                             ; Line 11
                    ADC        #$0136               
                    TCS                             
                    TDC                             
                    STA        $0C,S                
                    SEP        #$20                 
                    LDA        #$46                 
                    STA        $0E,S                
                    LDA        $AF,S                
                    AND        #$0F                 
                    ORA        #$60                 
                    STA        $AF,S                
                    REP        #$30                 
                    TSC                             ; Line 12
                    ADC        #$00AE               
                    TCS                             
                    LDA        $A1,S                
                    AND        #$0F00               
                    ORA        #$6075               
                    STA        $A1,S                
                    SEP        #$20                 
                    LDA        $9C,S                
                    AND        #$F0                 
                    ORA        #$07                 
                    STA        $9C,S                
                    REP        #$30                 
                    PEA        $6144                
                    PEA        $7476                
                    TSC                             ; Line 13
                    ADC        #$00A4               
                    TCS                             
                    SEP        #$20                 
                    LDA        #$77                 
                    STA        $A2,S                
                    REP        #$30                 
                    PEA        $1646                
                    PEA        $5467                
                    TSC                             ; Line 14
                    ADC        #$00A5               
                    TCS                             
                    LDA        $A1,S                
                    AND        #$0F00               
                    ORA        #$7077               
                    STA        $A1,S                
                    PEA        $5667                
                    PEA        $6144                
                    PEA        $7571                
                    TSC                             ; Line 15
                    ADC        #$00A6               
                    TCS                             
                    LDA        $A1,S                
                    AND        #$0F00               
                    ORA        #$5077               
                    STA        $A1,S                
                    SEP        #$20                 
                    LDA        $9A,S                
                    AND        #$F0                 
                    ORA        #$01                 
                    STA        $9A,S                
                    REP        #$30                 
                    PEA        $6775                
                    PEA        $1646                
                    PEA        $5717                
                    TSC                             ; Line 16
                    ADC        #$00A6               
                    TCS                             
                    SEP        #$20                 
                    LDA        #$66                 
                    STA        $9A,S                
                    REP        #$30                 
                    PEA        $7756                
                    PEA        $6761                
                    PEA        $7475                
                    TSC                             ; Line 17
                    ADC        #$00A8               
                    TCS                             
                    LDA        $97,S                
                    AND        #$00F0               
                    ORA        #$6706               
                    STA        $97,S                
                    PHX                             
                    PEA        $7767                
                    PEA        $7516                
                    PEA        $4675                
                    TSC                             ; Line 18
                    ADC        #$00A8               
                    TCS                             
                    LDA        $97,S                
                    AND        #$00F0               
                    ORA        #$7706               
                    STA        $97,S                
                    PEA        $5777                
                    PEA        $7777                
                    PEA        $5667                
                    PEA        $6154                
                    TSC                             ; Line 19
                    ADC        #$00A8               
                    TCS                             
                    PEA        $7565                
                    PEA        $5777                
                    PEA        $6775                
                    PEA        $6755                
                    TSC                             ; Line 20
                    ADC        #$00A8               
                    TCS                             
                    SEP        #$20                 
                    LDA        $96,S                
                    AND        #$F0                 
                    ORA        #$06                 
                    STA        $96,S                
                    REP        #$30                 
                    PEA        $5777                
                    PEA        $7675                
                    PEA        $7756                
                    PEA        $1667                
                    PEA        $6567                
                    TSC                             ; Line 21
                    ADC        #$00AA               
                    TCS                             
                    LDA        $93,S                
                    AND        #$00F0               
                    ORA        #$6106               
                    STA        $93,S                
                    SEP        #$20                 
                    LDA        #$44                 
                    STA        $92,S                
                    LDA        $A1,S                
                    AND        #$0F                 
                    ORA        #$50                 
                    STA        $A1,S                
                    REP        #$30                 
                    PEA        $7567                
                    PEA        $5657                
                    PEA        $7767                
                    PEA        $7577                
                    PEA        $5776                
                    TSC                             ; Line 22
                    ADC        #$00AA               
                    TCS                             
                    LDA        $A0,S                
                    AND        #$0F00               
                    ORA        #$7075               
                    STA        $A0,S                
                    SEP        #$20                 
                    LDA        $91,S                
                    AND        #$F0                 
                    ORA        #$04                 
                    STA        $91,S                
                    REP        #$30                 
                    PEA        $5777                
                    PEA        $6675                
                    PEA        $7577                
                    PEA        $5657                
                    PEA        $7565                
                    PEA        $6761                
                    TSC                             ; Line 23
                    ADC        #$00AB               
                    TCS                             
                    LDA        $A1,S                
                    AND        #$0F00               
                    ORA        #$5057               
                    STA        $A1,S                
                    SEP        #$20                 
                    LDA        $92,S                
                    AND        #$F0                 
                    ORA        #$04                 
                    STA        $92,S                
                    REP        #$30                 
                    PEA        $7776                
                    PEA        $1616                
                    PEA        $4667                
                    PEA        $6657                
                    PEA        $7766                
                    PEA        $7676                
                    PEA        $4644                
                    TSC                             ; Line 24
                    ADC        #$00AE               
                    TCS                             
                    SEP        #$20                 
                    LDA        $94,S                
                    AND        #$F0                 
                    ORA        #$07                 
                    STA        $94,S                
                    REP        #$30                 
                    LDA        #$6767               
                    PHA                             
                    PHA                             
                    PEA        $4744                
                    PEA        $6475                
                    PHX                             
                    PHA                             
                    PEA        $4744                
                    TSC                             ; Line 25
                    ADC        #$00A6               
                    TCS                             
                    LDA        $A8,S                
                    AND        #$0F00               
                    ORA        #$5057               
                    STA        $A8,S                
                    PHY                             
                    PHY                             
                    TSC                             
                    ADC        #$000D               
                    TCS                             
                    PHX                             
                    PHX                             
                    PEA        $7545                
                    PEA        $4464                
                    TSC                             ; Line 26
                    ADC        #$00A6               
                    TCS                             
                    SEP        #$20                 
                    LDA        $A1,S                
                    AND        #$0F                 
                    ORA        #$20                 
                    STA        $A1,S                
                    REP        #$30                 
                    PHY                             
                    PEA        $5747                
                    PEA        $4466                
                    TSC                             ; Line 27
                    ADC        #$00A6               
                    TCS                             
                    LDA        $9A,S                
                    AND        #$00F0               
                    ORA        #$3603               
                    STA        $9A,S                
                    LDA        $A0,S                
                    AND        #$0F00               
                    ORA        #$3033               
                    STA        $A0,S                
                    PEA        $7277                
                    PEA        $7767                
                    PEA        $6766                
                    TSC                             ; Line 28
                    ADC        #$00A5               
                    TCS                             
                    LDA        $9B,S                
                    AND        #$00F0               
                    ORA        #$3202               
                    STA        $9B,S                
                    LDA        $A1,S                
                    AND        #$0F00               
                    ORA        #$5057               
                    STA        $A1,S                
                    PEA        $2222                
                    PEA        $7277                
                    TSC                             ; Line 29
                    ADC        #$00A4               
                    TCS                             
                    LDA        $9B,S                
                    AND        #$00F0               
                    ORA        #$7207               
                    STA        $9B,S                
                    LDA        $A1,S                
                    AND        #$0F00               
                    ORA        #$7075               
                    STA        $A1,S                
                    PEA        $3333                
                    PEA        $3322                
                    TSC                             ; Line 30
                    ADC        #$00A4               
                    TCS                             
                    LDA        $A1,S                
                    AND        #$0F00               
                    ORA        #$5057               
                    STA        $A1,S                
                    SEP        #$20                 
                    LDA        $9A,S                
                    AND        #$F0                 
                    ORA        #$06                 
                    STA        $9A,S                
                    REP        #$30                 
                    PHX                             
                    PEA        $7732                
                    TSC                             ; Line 31
                    ADC        #$00A4               
                    TCS                             
                    SEP        #$20                 
                    LDA        $A2,S                
                    AND        #$0F                 
                    ORA        #$70                 
                    STA        $A2,S                
                    REP        #$30                 
                    PEA        $7776                
                    PEA        $7727                
                    PEA        $2363                
                    TSC                             ; Line 32
                    ADC        #$00A7               
                    TCS                             
                    LDA        $A0,S                
                    AND        #$0F00               
                    ORA        #$5057               
                    STA        $A0,S                
                    PEA        $7567                
                    PEA        $6766                
                    PEA        $2673                
                    PEA        $3266                
                    TSC                             ; Line 33
                    ADC        #$00A7               
                    TCS                             
                    SEP        #$20                 
                    LDA        $A2,S                
                    AND        #$0F                 
                    ORA        #$70                 
                    STA        $A2,S                
                    REP        #$30                 
                    PEA        $7766                
                    PEA        $6666                
                    PEA        $3226                
                    PEA        $6766                
                    TSC                             ; Line 34
                    ADC        #$00A9               
                    TCS                             
                    LDA        $96,S                
                    AND        #$00F0               
                    ORA        #$6706               
                    STA        $96,S                
                    LDA        $A0,S                
                    AND        #$0F00               
                    ORA        #$5077               
                    STA        $A0,S                
                    PEA        $7567                
                    PEA        $6776                
                    PEA        $7632                
                    PEA        $7776                
                    PEA        $7666                
                    TSC                             ; Line 35
                    ADC        #$00A9               
                    TCS                             
                    LDA        $A1,S                
                    AND        #$0F00               
                    ORA        #$7075               
                    STA        $A1,S                
                    PEA        $7766                
                    PEA        $6667                
                    PEA        $7577                
                    PEA        $7767                
                    TSC                             ; Line 36
                    ADC        #$00A8               
                    TCS                             
                    LDA        $A1,S                
                    AND        #$0F00               
                    ORA        #$5077               
                    STA        $A1,S                
                    SEP        #$20                 
                    LDA        $96,S                
                    AND        #$F0                 
                    ORA        #$06                 
                    STA        $96,S                
                    REP        #$30                 
                    PEA        $6767                
                    PEA        $7656                
                    PHY                             
                    PEA        $5777                
                    PEA        $7666                
                    TSC                             ; Line 37
                    ADC        #$00AA               
                    TCS                             
                    SEP        #$20                 
                    LDA        #$16                 
                    STA        $96,S                
                    LDA        $9D,S                
                    AND        #$0F                 
                    ORA        #$50                 
                    STA        $9D,S                
                    LDA        $A2,S                
                    AND        #$0F                 
                    ORA        #$70                 
                    STA        $A2,S                
                    REP        #$30                 
                    PEA        $7776                
                    PEA        $6676                
                    PHX                             
                    PHX                             
                    PEA        $7716                
                    TSC                             ; Line 38
                    ADC        #$00A6               
                    TCS                             
                    SEP        #$20                 
                    LDA        #$61                 
                    STA        $9A,S                
                    LDA        $A6,S                
                    AND        #$0F                 
                    ORA        #$50                 
                    STA        $A6,S                
                    REP        #$30                 
                    PHY                             
                    PHY                             
                    PEA        $5767                
                    TSC                             
                    ADC        #$000B               
                    TCS                             
                    PEA        $7567                
                    PEA        $6766                
                    TSC                             ; Line 39
                    ADC        #$009D               
                    TCS                             
                    SEP        #$20                 
                    LDA        $A8,S                
                    AND        #$0F                 
                    ORA        #$70                 
                    STA        $A8,S                
                    REP        #$30                 
                    PHX                             
                    PHX                             
                    TSC                             
                    ADC        #$000B               
                    TCS                             
                    PEA        $7777                
                    PEA        $7676                
                    TSC                             ; Line 40
                    ADC        #$009C               
                    TCS                             
                    LDA        #$7567               
                    STA        $9D,S                
                    LDA        #$7666               
                    STA        $A6,S                
                    LDA        $9F,S                
                    AND        #$0F00               
                    ORA        #$7075               
                    STA        $9F,S                
                    LDA        $A8,S                
                    AND        #$0F00               
                    ORA        #$5077               
                    STA        $A8,S                
                    SEP        #$20                 
                    LDA        $A5,S                
                    AND        #$F0                 
                    ORA        #$06                 
                    STA        $A5,S                
                    REP        #$30                 
                    PHY                             
                    PEA        $7766                
                    TSC                             
                    ADC        #$000C               
                    TCS                             
                    PEA        $7567                
                    PEA        $6761                
                    TSC                             ; Line 42
                    ADC        #$0135               
                    TCS                             
                    LDA        #$5766               
                    STA        $04,S                
                    LDA        #$7567               
                    STA        $A4,S                
                    SEP        #$20                 
                    LDA        $06,S                
                    AND        #$0F                 
                    ORA        #$50                 
                    STA        $06,S                
                    LDA        $0C,S                
                    AND        #$F0                 
                    ORA        #$06                 
                    STA        $0C,S                
                    LDA        $A6,S                
                    AND        #$0F                 
                    ORA        #$70                 
                    STA        $A6,S                
                    REP        #$30                 
                    TSC                             
                    ADC        #$0010               
                    TCS                             
                    PHX                             
                    PEA        $6761                
                    TSC                             ; Line 43
                    ADC        #$00A4               
                    TCS                             
                    LDA        #$5766               
                    STA        $94,S                
                    SEP        #$20                 
                    LDA        $96,S                
                    AND        #$0F                 
                    ORA        #$50                 
                    STA        $96,S                
                    REP        #$30                 
                    PEA        $5777                
                    PEA        $6716                
                    TSC                             ; Line 44
                    ADC        #$00A4               
                    TCS                             
                    LDA        #$7566               
                    STA        $94,S                
                    LDA        #$6766               
                    STA        $9E,S                
                    LDA        $A0,S                
                    AND        #$0F00               
                    ORA        #$5057               
                    STA        $A0,S                
                    SEP        #$20                 
                    LDA        $96,S                
                    AND        #$0F                 
                    ORA        #$70                 
                    STA        $96,S                
                    LDA        $9D,S                
                    AND        #$F0                 
                    ORA        #$06                 
                    STA        $9D,S                
                    REP        #$30                 
                    PHX                             
                    PEA        $6661                
                    TSC                             ; Line 46
                    ADC        #$0134               
                    TCS                             
                    LDA        #$7767               
                    STA        $04,S                
                    LDA        #$7566               
                    STA        $A4,S                
                    TYA                             
                    STA        $B0,S                
                    LDA        $AE,S                
                    AND        #$00F0               
                    ORA        #$6706               
                    STA        $AE,S                
                    SEP        #$20                 
                    LDA        $06,S                
                    AND        #$0F                 
                    ORA        #$50                 
                    STA        $06,S                
                    LDA        $A6,S                
                    AND        #$0F                 
                    ORA        #$70                 
                    STA        $A6,S                
                    REP        #$30                 
                    TSC                             
                    ADC        #$0011               
                    TCS                             
                    PHX                             
                    PEA        $7566                
                    TSC                             ; Line 48
                    ADC        #$0133               
                    TCS                             
                    LDA        #$5767               
                    STA        $04,S                
                    LDA        #$7566               
                    STA        $0F,S                
                    TYA                             
                    STA        $B1,S                
                    LDA        $06,S                
                    AND        #$0F0F               
                    ORA        #$5050               
                    STA        $06,S                
                    LDA        $08,S                
                    AND        #$0F0F               
                    ORA        #$5050               
                    STA        $08,S                
                    LDA        $0A,S                
                    AND        #$0F0F               
                    ORA        #$5050               
                    STA        $0A,S                
                    LDA        $0C,S                
                    AND        #$0F0F               
                    ORA        #$5050               
                    STA        $0C,S                
                    LDA        $11,S                
                    AND        #$0F00               
                    ORA        #$7075               
                    STA        $11,S                
                    LDA        $A3,S                
                    AND        #$F00F               
                    ORA        #$0450               
                    STA        $A3,S                
                    LDA        $A6,S                
                    AND        #$F0F0               
                    ORA        #$0505               
                    STA        $A6,S                
                    LDA        $A8,S                
                    AND        #$F0F0               
                    ORA        #$0505               
                    STA        $A8,S                
                    LDA        $AA,S                
                    AND        #$F0F0               
                    ORA        #$0505               
                    STA        $AA,S                
                    LDA        $AC,S                
                    AND        #$F0F0               
                    ORA        #$0505               
                    STA        $AC,S                
                    LDA        $AE,S                
                    AND        #$F0F0               
                    ORA        #$0705               
                    STA        $AE,S                
                    SEP        #$20                 
                    LDA        #$44                 
                    STA        $A5,S                
                    LDA        #$67                 
                    STA        $B0,S                
                    REP        #$30                 
                    TSC                             ; Line 50
                    ADC        #$0140               
                    TCS                             
                    TDC                             
                    STA        $04,S                
                    STA        $B1,S                
                    LDA        #$7475               
                    STA        $11,S                
                    LDA        $00,S                
                    AND        #$F0F0               
                    ORA        #$0505               
                    STA        $00,S                
                    LDA        $02,S                
                    AND        #$F0F0               
                    ORA        #$0405               
                    STA        $02,S                
                    LDA        $06,S                
                    AND        #$0F0F               
                    ORA        #$5050               
                    STA        $06,S                
                    LDA        $08,S                
                    AND        #$0F0F               
                    ORA        #$5050               
                    STA        $08,S                
                    LDA        $0A,S                
                    AND        #$0F0F               
                    ORA        #$5050               
                    STA        $0A,S                
                    LDA        $0C,S                
                    AND        #$0F0F               
                    ORA        #$5050               
                    STA        $0C,S                
                    LDA        $0E,S                
                    AND        #$0F0F               
                    ORA        #$5050               
                    STA        $0E,S                
                    LDA        $A0,S                
                    AND        #$0F0F               
                    ORA        #$5050               
                    STA        $A0,S                
                    LDA        $A7,S                
                    AND        #$F0F0               
                    ORA        #$0505               
                    STA        $A7,S                
                    LDA        $A9,S                
                    AND        #$F0F0               
                    ORA        #$0505               
                    STA        $A9,S                
                    LDA        $AB,S                
                    AND        #$F0F0               
                    ORA        #$0505               
                    STA        $AB,S                
                    LDA        $AD,S                
                    AND        #$F0F0               
                    ORA        #$0505               
                    STA        $AD,S                
                    LDA        $AF,S                
                    AND        #$F0F0               
                    ORA        #$0405               
                    STA        $AF,S                
                    SEP        #$20                 
                    LDA        #$76                 
                    STA        $10,S                
                    LDA        $13,S                
                    AND        #$0F                 
                    ORA        #$50                 
                    STA        $13,S                
                    LDA        $A6,S                
                    AND        #$F0                 
                    ORA        #$05                 
                    STA        $A6,S                
                    LDA        $B3,S                
                    AND        #$F0                 
                    ORA        #$05                 
                    STA        $B3,S                
                    REP        #$30                 
                    TSC                             ; Line 51
                    ADC        #$00A5               
                    TCS                             
                    TDC                             
                    STA        $AB,S                
                    LDA        $A7,S                
                    AND        #$0F0F               
                    ORA        #$5050               
                    STA        $A7,S                
                    LDA        $A9,S                
                    AND        #$0F0F               
                    ORA        #$5050               
                    STA        $A9,S                
                    SEP        #$20                 
                    LDA        $AD,S                
                    AND        #$0F                 
                    ORA        #$40                 
                    STA        $AD,S                
                    REP        #$30                 
                    PHD                             
                    PEA        $4454                
*--                                                 
                    LDAL       $E1C068              ; Direct Page and Stack in Bank 00/
                    AND        #$FFCF               
                    STAL       $E1C068              
                    LDA        StackAddress         ; Restore Stack
                    TCS                             
                    PLD                             ; Restore Direct Page
                    CLI                             ; Enable Interrupts
                    PLB
                    RTL                             
                                                    
*-----------------------------------                                
Sprite_BL_030       CLC                             ; Sprite #030 : 32x56, 1189 bytes, 1930 cycles
                    SEI                             ; Disable Interrupts
                    PHD                             ; Backup Direct Page
                    TSC                             ; Backup Stack
                    STA        StackAddress         
                    LDAL       $E1C068              ; Direct Page and Stack in Bank 01/
                    ORA        #$0030               
                    STAL       $E1C068              
                    TYA                             ; Y = Sprite Target Screen Address (upper left corner)
                    TCS                             ; New Stack address
                    LDX        #$7575               ; Pattern #1 : 15
                    LDY        #$4444               ; Pattern #2 : 14
                    LDA        #$7777               ; Pattern #3 : 10
                    TCD                             
*--                                                 
                    LDA        #$5555               ; Line 0
                    STA        $A3,S                
                    LDA        $03,S                
                    AND        #$00F0               
                    ORA        #$5505               
                    STA        $03,S                
                    LDA        $A5,S                
                    AND        #$0F00               
                    ORA        #$5033               
                    STA        $A5,S                
                    SEP        #$20                 
                    LDA        $05,S                
                    AND        #$0F                 
                    ORA        #$30                 
                    STA        $05,S                
                    REP        #$30                 
                    TSC                             ; Line 2
                    ADC        #$0140               
                    TCS                             
                    LDA        $A6,S                
                    AND        #$0F00               
                    ORA        #$5055               
                    STA        $A6,S                
                    SEP        #$20                 
                    LDA        $02,S                
                    AND        #$F0                 
                    ORA        #$05                 
                    STA        $02,S                
                    REP        #$30                 
                    TSC                             
                    ADC        #$0006               
                    TCS                             
                    PEA        $5535                
                    PEA        $5355                
                    TSC                             ; Line 3
                    ADC        #$00A3               
                    TCS                             
                    LDA        $A1,S                
                    AND        #$0F00               
                    ORA        #$5055               
                    STA        $A1,S                
                    PEA        $3553                
                    PEA        $5555                
                    TSC                             ; Line 4
                    ADC        #$00A4               
                    TCS                             
                    LDA        $A2,S                
                    AND        #$000F               
                    ORA        #$5750               
                    STA        $A2,S                
                    SEP        #$20                 
                    LDA        #$55                 
                    STA        $9D,S                
                    REP        #$30                 
                    PEA        $5533                
                    PEA        $5555                
                    TSC                             ; Line 5
                    ADC        #$00A5               
                    TCS                             
                    PEA        $4555                
                    PEA        $3553                
                    TSC                             ; Line 6
                    ADC        #$00A7               
                    TCS                             
                    LDA        $99,S                
                    AND        #$00F0               
                    ORA        #$3303               
                    STA        $99,S                
                    LDA        $A1,S                
                    AND        #$0F00               
                    ORA        #$5057               
                    STA        $A1,S                
                    PHX                             
                    PEA        $4454                
                    PEA        $4534                
                    PEA        $3355                
                    TSC                             ; Line 7
                    ADC        #$00A8               
                    TCS                             
                    SEP        #$20                 
                    LDA        #$34                 
                    STA        $9A,S                
                    REP        #$30                 
                    PEA        $5767                
                    PHY                             
                    PHY                             
                    TSC                             ; Line 8
                    ADC        #$00A8               
                    TCS                             
                    SEP        #$20                 
                    LDA        $A1,S                
                    AND        #$0F                 
                    ORA        #$50                 
                    STA        $A1,S                
                    REP        #$30                 
                    PHX                             
                    PEA        $7765                
                    PHY                             
                    PEA        $5445                
                    TSC                             ; Line 9
                    ADC        #$00A8               
                    TCS                             
                    SEP        #$20                 
                    LDA        $99,S                
                    AND        #$F0                 
                    ORA        #$04                 
                    STA        $99,S                
                    REP        #$30                 
                    PEA        $5757                
                    PEA        $6775                
                    PEA        $4644                
                    PHY                             
                    TSC                             ; Line 10
                    ADC        #$00A9               
                    TCS                             
                    LDA        $99,S                
                    AND        #$0FF0               
                    ORA        #$4004               
                    STA        $99,S                
                    SEP        #$20                 
                    LDA        $A1,S                
                    AND        #$0F                 
                    ORA        #$50                 
                    STA        $A1,S                
                    REP        #$30                 
                    PHX                             
                    PEA        $7577                
                    PEA        $5646                
                    PHY                             
                    TSC                             ; Line 11
                    ADC        #$00A8               
                    TCS                             
                    SEP        #$20                 
                    LDA        #$67                 
                    STA        $9B,S                
                    REP        #$30                 
                    PEA        $5757                
                    PEA        $7767                
                    PEA        $6165                
                    TSC                             ; Line 12
                    ADC        #$00A7               
                    TCS                             
                    LDA        $A0,S                
                    AND        #$0F00               
                    ORA        #$5057               
                    STA        $A0,S                
                    PHX                             
                    PHD                             
                    PEA        $7716                
                    TSC                             ; Line 13
                    ADC        #$00A5               
                    TCS                             
                    LDA        $A1,S                
                    AND        #$0F00               
                    ORA        #$7075               
                    STA        $A1,S                
                    SEP        #$20                 
                    LDA        $9A,S                
                    AND        #$F0                 
                    ORA        #$06                 
                    STA        $9A,S                
                    REP        #$30                 
                    PHD                             
                    PHD                             
                    PEA        $6765                
                    TSC                             ; Line 14
                    ADC        #$00A6               
                    TCS                             
                    LDA        $A1,S                
                    AND        #$0F00               
                    ORA        #$5057               
                    STA        $A1,S                
                    SEP        #$20                 
                    LDA        $9A,S                
                    AND        #$F0                 
                    ORA        #$06                 
                    STA        $9A,S                
                    REP        #$30                 
                    PHD                             
                    PEA        $7677                
                    PEA        $1675                
                    TSC                             ; Line 15
                    ADC        #$00A6               
                    TCS                             
                    SEP        #$20                 
                    LDA        $9A,S                
                    AND        #$F0                 
                    ORA        #$06                 
                    STA        $9A,S                
                    REP        #$30                 
                    PEA        $7767                
                    PEA        $5777                
                    PEA        $6775                
                    TSC                             ; Line 16
                    ADC        #$00A8               
                    TCS                             
                    SEP        #$20                 
                    LDA        $98,S                
                    AND        #$F0                 
                    ORA        #$07                 
                    STA        $98,S                
                    REP        #$30                 
                    PHX                             
                    PEA        $7776                
                    PEA        $7675                
                    PEA        $6657                
                    TSC                             ; Line 17
                    ADC        #$00A8               
                    TCS                             
                    LDA        $95,S                
                    AND        #$00F0               
                    ORA        #$7601               
                    STA        $95,S                
                    LDA        $97,S                
                    AND        #$000F               
                    ORA        #$7760               
                    STA        $97,S                
                    PEA        $5757                
                    PEA        $7767                
                    PEA        $5757                
                    PEA        $6756                
                    TSC                             ; Line 18
                    ADC        #$00A8               
                    TCS                             
                    PHX                             
                    PEA        $7576                
                    PEA        $7675                
                    PEA        $7656                
                    TSC                             ; Line 19
                    ADC        #$00A8               
                    TCS                             
                    LDA        $93,S                
                    AND        #$00F0               
                    ORA        #$7701               
                    STA        $93,S                
                    PEA        $3353                
                    PEA        $5767                
                    PEA        $5657                
                    PEA        $6756                
                    PEA        $6577                
                    PEA        $6717                
                    TSC                             ; Line 20
                    ADC        #$00AC               
                    TCS                             
                    PEA        $7733                
                    PEA        $3337                
                    PEA        $3375                
                    PEA        $7567                
                    PEA        $5657                
                    PEA        $7766                
                    TSC                             ; Line 21
                    ADC        #$00AC               
                    TCS                             
                    PEA        $7766                
                    PEA        $3333                
                    PEA        $6656                
                    PEA        $5777                
                    PEA        $6666                
                    PHY                             
                    PEA        $7717                
                    TSC                             ; Line 22
                    ADC        #$00AE               
                    TCS                             
                    LDA        $9F,S                
                    AND        #$0F00               
                    ORA        #$7067               
                    STA        $9F,S                
                    PHD                             
                    PEA        $6666                
                    PEA        $6666                
                    PHX                             
                    PEA        $6567                
                    PHY                             
                    PEA        $7566                
                    TSC                             ; Line 23
                    ADC        #$00AC               
                    TCS                             
                    LDA        $95,S                
                    AND        #$00F0               
                    ORA        #$7506               
                    STA        $95,S                
                    LDA        $A1,S                
                    AND        #$0F00               
                    ORA        #$7077               
                    STA        $A1,S                
                    PEA        $6767                
                    PEA        $6766                
                    PEA        $6757                
                    PEA        $5757                
                    PEA        $4464                
                    PEA        $5517                
                    TSC                             ; Line 24
                    ADC        #$00AC               
                    TCS                             
                    LDA        $9A,S                
                    AND        #$00F0               
                    ORA        #$5705               
                    STA        $9A,S                
                    SEP        #$20                 
                    LDA        $A2,S                
                    AND        #$0F                 
                    ORA        #$50                 
                    STA        $A2,S                
                    REP        #$30                 
                    PEA        $7676                
                    PEA        $7676                
                    PEA        $7675                
                    PEA        $5575                
                    PEA        $7767                
                    TSC                             ; Line 25
                    ADC        #$00A3               
                    TCS                             
                    TXA                             
                    STA        $9F,S                
                    LDA        $9D,S                
                    AND        #$00F0               
                    ORA        #$6706               
                    STA        $9D,S                
                    SEP        #$20                 
                    LDA        #$55                 
                    STA        $A2,S                
                    REP        #$30                 
                    PEA        $5577                
                    PEA        $6667                
                    TSC                             
                    ADC        #$000C               
                    TCS                             
                    PHD                             
                    PEA        $6767                
                    PEA        $7757                
                    TSC                             ; Line 26
                    ADC        #$00A6               
                    TCS                             
                    LDA        #$7766               
                    STA        $96,S                
                    LDA        $98,S                
                    AND        #$0F00               
                    ORA        #$5057               
                    STA        $98,S                
                    LDA        $9F,S                
                    AND        #$0F00               
                    ORA        #$5057               
                    STA        $9F,S                
                    PEA        $7577                
                    PHD                             
                    PHX                             
                    TSC                             ; Line 27
                    ADC        #$00A4               
                    TCS                             
                    SEP        #$20                 
                    LDA        $9D,S                
                    AND        #$F0                 
                    ORA        #$05                 
                    STA        $9D,S                
                    REP        #$30                 
                    PEA        $5757                
                    PEA        $5757                
                    TSC                             ; Line 28
                    ADC        #$009F               
                    TCS                             
                    SEP        #$20                 
                    LDA        $A1,S                
                    AND        #$0F                 
                    ORA        #$40                 
                    STA        $A1,S                
                    REP        #$30                 
                    PEA        $7557                
                    PEA        $7567                
                    TSC                             
                    ADC        #$000A               
                    TCS                             
                    PHX                             
                    PHX                             
                    TSC                             ; Line 29
                    ADC        #$009E               
                    TCS                             
                    LDA        #$7567               
                    STA        $9D,S                
                    TYA                             
                    STA        $A0,S                
                    PEA        $7457                
                    PEA        $7766                
                    TSC                             ; Line 31
                    ADC        #$013E               
                    TCS                             
                    LDA        #$7566               
                    STA        $03,S                
                    TYA                             
                    STA        $A3,S                
                    LDA        $06,S                
                    AND        #$0F00               
                    ORA        #$4044               
                    STA        $06,S                
                    LDA        $A5,S                
                    AND        #$0FF0               
                    ORA        #$4004               
                    STA        $A5,S                
                    SEP        #$20                 
                    LDA        $A2,S                
                    AND        #$F0                 
                    ORA        #$04                 
                    STA        $A2,S                
                    REP        #$30                 
                    TSC                             ; Line 33
                    ADC        #$0144               
                    TCS                             
                    PHY                             
                    PHY                             
                    TSC                             ; Line 52
                    ADC        #$0BE0               
                    TCS                             
                    LDA        $08,S                
                    AND        #$0F0F               
                    ORA        #$5050               
                    STA        $08,S                
                    LDA        $0A,S                
                    AND        #$0F0F               
                    ORA        #$5050               
                    STA        $0A,S                
                    LDA        $A0,S                
                    AND        #$F0F0               
                    ORA        #$0505               
                    STA        $A0,S                
                    LDA        $A2,S                
                    AND        #$F0F0               
                    ORA        #$0505               
                    STA        $A2,S                
                    LDA        $A4,S                
                    AND        #$F0F0               
                    ORA        #$0505               
                    STA        $A4,S                
                    LDA        $A6,S                
                    AND        #$F0F0               
                    ORA        #$0505               
                    STA        $A6,S                
                    LDA        $A8,S                
                    AND        #$F0F0               
                    ORA        #$0505               
                    STA        $A8,S                
                    LDA        $AA,S                
                    AND        #$F0F0               
                    ORA        #$0505               
                    STA        $AA,S                
                    LDA        $AC,S                
                    AND        #$F0F0               
                    ORA        #$0505               
                    STA        $AC,S                
                    LDA        $AE,S                
                    AND        #$F0F0               
                    ORA        #$0505               
                    STA        $AE,S                
                    SEP        #$20                 
                    LDA        $0C,S                
                    AND        #$0F                 
                    ORA        #$50                 
                    STA        $0C,S                
                    REP        #$30                 
                    TSC                             ; Line 54
                    ADC        #$0140               
                    TCS                             
                    LDA        $00,S                
                    AND        #$0F0F               
                    ORA        #$5050               
                    STA        $00,S                
                    LDA        $02,S                
                    AND        #$0F0F               
                    ORA        #$5050               
                    STA        $02,S                
                    LDA        $04,S                
                    AND        #$0F0F               
                    ORA        #$5050               
                    STA        $04,S                
                    LDA        $06,S                
                    AND        #$0F0F               
                    ORA        #$5050               
                    STA        $06,S                
                    LDA        $08,S                
                    AND        #$0F0F               
                    ORA        #$5050               
                    STA        $08,S                
                    LDA        $0A,S                
                    AND        #$0F0F               
                    ORA        #$5050               
                    STA        $0A,S                
                    LDA        $0C,S                
                    AND        #$0F0F               
                    ORA        #$5050               
                    STA        $0C,S                
                    LDA        $A2,S                
                    AND        #$F0F0               
                    ORA        #$0505               
                    STA        $A2,S                
                    LDA        $A4,S                
                    AND        #$F0F0               
                    ORA        #$0505               
                    STA        $A4,S                
                    LDA        $A6,S                
                    AND        #$F0F0               
                    ORA        #$0505               
                    STA        $A6,S                
                    LDA        $A8,S                
                    AND        #$F0F0               
                    ORA        #$0505               
                    STA        $A8,S                
                    LDA        $AA,S                
                    AND        #$F0F0               
                    ORA        #$0505               
                    STA        $AA,S                
                    SEP        #$20                 
                    LDA        $0E,S                
                    AND        #$0F                 
                    ORA        #$50                 
                    STA        $0E,S                
                    REP        #$30                 
*--                                                 
                    LDAL       $E1C068              ; Direct Page and Stack in Bank 00/
                    AND        #$FFCF               
                    STAL       $E1C068              
                    LDA        StackAddress         ; Restore Stack
                    TCS                             
                    PLD                             ; Restore Direct Page
                    CLI                             ; Enable Interrupts
                    PLB
                    RTL                             
                                                    
*-----------------------------------                                
Sprite_BL_031       CLC                             ; Sprite #031 : 32x64, 1189 bytes, 1930 cycles
                    SEI                             ; Disable Interrupts
                    PHD                             ; Backup Direct Page
                    TSC                             ; Backup Stack
                    STA        StackAddress         
                    LDAL       $E1C068              ; Direct Page and Stack in Bank 01/
                    ORA        #$0030               
                    STAL       $E1C068              
                    TYA                             ; Y = Sprite Target Screen Address (upper left corner)
                    TCS                             ; New Stack address
                    LDX        #$7575               ; Pattern #1 : 15
                    LDY        #$4444               ; Pattern #2 : 14
                    LDA        #$7777               ; Pattern #3 : 10
                    TCD                             
*--                                                 
                    LDA        #$5555               ; Line 0
                    STA        $A3,S                
                    LDA        $03,S                
                    AND        #$00F0               
                    ORA        #$5505               
                    STA        $03,S                
                    LDA        $A5,S                
                    AND        #$0F00               
                    ORA        #$5033               
                    STA        $A5,S                
                    SEP        #$20                 
                    LDA        $05,S                
                    AND        #$0F                 
                    ORA        #$30                 
                    STA        $05,S                
                    REP        #$30                 
                    TSC                             ; Line 2
                    ADC        #$0140               
                    TCS                             
                    LDA        $A6,S                
                    AND        #$0F00               
                    ORA        #$5055               
                    STA        $A6,S                
                    SEP        #$20                 
                    LDA        $02,S                
                    AND        #$F0                 
                    ORA        #$05                 
                    STA        $02,S                
                    REP        #$30                 
                    TSC                             
                    ADC        #$0006               
                    TCS                             
                    PEA        $5535                
                    PEA        $5355                
                    TSC                             ; Line 3
                    ADC        #$00A3               
                    TCS                             
                    LDA        $A1,S                
                    AND        #$0F00               
                    ORA        #$5055               
                    STA        $A1,S                
                    PEA        $3553                
                    PEA        $5555                
                    TSC                             ; Line 4
                    ADC        #$00A4               
                    TCS                             
                    LDA        $A2,S                
                    AND        #$000F               
                    ORA        #$5750               
                    STA        $A2,S                
                    SEP        #$20                 
                    LDA        #$55                 
                    STA        $9D,S                
                    REP        #$30                 
                    PEA        $5533                
                    PEA        $5555                
                    TSC                             ; Line 5
                    ADC        #$00A5               
                    TCS                             
                    PEA        $4555                
                    PEA        $3553                
                    TSC                             ; Line 6
                    ADC        #$00A7               
                    TCS                             
                    LDA        $99,S                
                    AND        #$00F0               
                    ORA        #$3303               
                    STA        $99,S                
                    LDA        $A1,S                
                    AND        #$0F00               
                    ORA        #$5057               
                    STA        $A1,S                
                    PHX                             
                    PEA        $4454                
                    PEA        $4534                
                    PEA        $3355                
                    TSC                             ; Line 7
                    ADC        #$00A8               
                    TCS                             
                    SEP        #$20                 
                    LDA        #$34                 
                    STA        $9A,S                
                    REP        #$30                 
                    PEA        $5767                
                    PHY                             
                    PHY                             
                    TSC                             ; Line 8
                    ADC        #$00A8               
                    TCS                             
                    SEP        #$20                 
                    LDA        $A1,S                
                    AND        #$0F                 
                    ORA        #$50                 
                    STA        $A1,S                
                    REP        #$30                 
                    PHX                             
                    PEA        $7765                
                    PHY                             
                    PEA        $5445                
                    TSC                             ; Line 9
                    ADC        #$00A8               
                    TCS                             
                    SEP        #$20                 
                    LDA        $99,S                
                    AND        #$F0                 
                    ORA        #$04                 
                    STA        $99,S                
                    REP        #$30                 
                    PEA        $5757                
                    PEA        $6775                
                    PEA        $4644                
                    PHY                             
                    TSC                             ; Line 10
                    ADC        #$00A9               
                    TCS                             
                    LDA        $99,S                
                    AND        #$0FF0               
                    ORA        #$4004               
                    STA        $99,S                
                    SEP        #$20                 
                    LDA        $A1,S                
                    AND        #$0F                 
                    ORA        #$50                 
                    STA        $A1,S                
                    REP        #$30                 
                    PHX                             
                    PEA        $7577                
                    PEA        $5646                
                    PHY                             
                    TSC                             ; Line 11
                    ADC        #$00A8               
                    TCS                             
                    SEP        #$20                 
                    LDA        #$67                 
                    STA        $9B,S                
                    REP        #$30                 
                    PEA        $5757                
                    PEA        $7767                
                    PEA        $6165                
                    TSC                             ; Line 12
                    ADC        #$00A7               
                    TCS                             
                    LDA        $A0,S                
                    AND        #$0F00               
                    ORA        #$5057               
                    STA        $A0,S                
                    PHX                             
                    PHD                             
                    PEA        $7716                
                    TSC                             ; Line 13
                    ADC        #$00A5               
                    TCS                             
                    LDA        $A1,S                
                    AND        #$0F00               
                    ORA        #$7075               
                    STA        $A1,S                
                    SEP        #$20                 
                    LDA        $9A,S                
                    AND        #$F0                 
                    ORA        #$06                 
                    STA        $9A,S                
                    REP        #$30                 
                    PHD                             
                    PHD                             
                    PEA        $6765                
                    TSC                             ; Line 14
                    ADC        #$00A6               
                    TCS                             
                    LDA        $A1,S                
                    AND        #$0F00               
                    ORA        #$5057               
                    STA        $A1,S                
                    SEP        #$20                 
                    LDA        $9A,S                
                    AND        #$F0                 
                    ORA        #$06                 
                    STA        $9A,S                
                    REP        #$30                 
                    PHD                             
                    PEA        $7677                
                    PEA        $1675                
                    TSC                             ; Line 15
                    ADC        #$00A6               
                    TCS                             
                    SEP        #$20                 
                    LDA        $9A,S                
                    AND        #$F0                 
                    ORA        #$06                 
                    STA        $9A,S                
                    REP        #$30                 
                    PEA        $7767                
                    PEA        $5777                
                    PEA        $6775                
                    TSC                             ; Line 16
                    ADC        #$00A8               
                    TCS                             
                    SEP        #$20                 
                    LDA        $98,S                
                    AND        #$F0                 
                    ORA        #$07                 
                    STA        $98,S                
                    REP        #$30                 
                    PHX                             
                    PEA        $7776                
                    PEA        $7675                
                    PEA        $6657                
                    TSC                             ; Line 17
                    ADC        #$00A8               
                    TCS                             
                    LDA        $95,S                
                    AND        #$00F0               
                    ORA        #$7601               
                    STA        $95,S                
                    LDA        $97,S                
                    AND        #$000F               
                    ORA        #$7760               
                    STA        $97,S                
                    PEA        $5757                
                    PEA        $7767                
                    PEA        $5757                
                    PEA        $6756                
                    TSC                             ; Line 18
                    ADC        #$00A8               
                    TCS                             
                    PHX                             
                    PEA        $7576                
                    PEA        $7675                
                    PEA        $7656                
                    TSC                             ; Line 19
                    ADC        #$00A8               
                    TCS                             
                    LDA        $93,S                
                    AND        #$00F0               
                    ORA        #$7701               
                    STA        $93,S                
                    PEA        $3353                
                    PEA        $5767                
                    PEA        $5657                
                    PEA        $6756                
                    PEA        $6577                
                    PEA        $6717                
                    TSC                             ; Line 20
                    ADC        #$00AC               
                    TCS                             
                    PEA        $7733                
                    PEA        $3337                
                    PEA        $3375                
                    PEA        $7567                
                    PEA        $5657                
                    PEA        $7766                
                    TSC                             ; Line 21
                    ADC        #$00AC               
                    TCS                             
                    PEA        $7766                
                    PEA        $3333                
                    PEA        $6656                
                    PEA        $5777                
                    PEA        $6666                
                    PHY                             
                    PEA        $7717                
                    TSC                             ; Line 22
                    ADC        #$00AE               
                    TCS                             
                    LDA        $9F,S                
                    AND        #$0F00               
                    ORA        #$7067               
                    STA        $9F,S                
                    PHD                             
                    PEA        $6666                
                    PEA        $6666                
                    PHX                             
                    PEA        $6567                
                    PHY                             
                    PEA        $7566                
                    TSC                             ; Line 23
                    ADC        #$00AC               
                    TCS                             
                    LDA        $95,S                
                    AND        #$00F0               
                    ORA        #$7506               
                    STA        $95,S                
                    LDA        $A1,S                
                    AND        #$0F00               
                    ORA        #$7077               
                    STA        $A1,S                
                    PEA        $6767                
                    PEA        $6766                
                    PEA        $6757                
                    PEA        $5757                
                    PEA        $4464                
                    PEA        $5517                
                    TSC                             ; Line 24
                    ADC        #$00AC               
                    TCS                             
                    LDA        $9A,S                
                    AND        #$00F0               
                    ORA        #$5705               
                    STA        $9A,S                
                    SEP        #$20                 
                    LDA        $A2,S                
                    AND        #$0F                 
                    ORA        #$50                 
                    STA        $A2,S                
                    REP        #$30                 
                    PEA        $7676                
                    PEA        $7676                
                    PEA        $7675                
                    PEA        $5575                
                    PEA        $7767                
                    TSC                             ; Line 25
                    ADC        #$00A3               
                    TCS                             
                    TXA                             
                    STA        $9F,S                
                    LDA        $9D,S                
                    AND        #$00F0               
                    ORA        #$6706               
                    STA        $9D,S                
                    SEP        #$20                 
                    LDA        #$55                 
                    STA        $A2,S                
                    REP        #$30                 
                    PEA        $5577                
                    PEA        $6667                
                    TSC                             
                    ADC        #$000C               
                    TCS                             
                    PHD                             
                    PEA        $6767                
                    PEA        $7757                
                    TSC                             ; Line 26
                    ADC        #$00A6               
                    TCS                             
                    LDA        #$7766               
                    STA        $96,S                
                    LDA        $98,S                
                    AND        #$0F00               
                    ORA        #$5057               
                    STA        $98,S                
                    LDA        $9F,S                
                    AND        #$0F00               
                    ORA        #$5057               
                    STA        $9F,S                
                    PEA        $7577                
                    PHD                             
                    PHX                             
                    TSC                             ; Line 27
                    ADC        #$00A4               
                    TCS                             
                    SEP        #$20                 
                    LDA        $9D,S                
                    AND        #$F0                 
                    ORA        #$05                 
                    STA        $9D,S                
                    REP        #$30                 
                    PEA        $5757                
                    PEA        $5757                
                    TSC                             ; Line 28
                    ADC        #$009F               
                    TCS                             
                    SEP        #$20                 
                    LDA        $A1,S                
                    AND        #$0F                 
                    ORA        #$40                 
                    STA        $A1,S                
                    REP        #$30                 
                    PEA        $7557                
                    PEA        $7567                
                    TSC                             
                    ADC        #$000A               
                    TCS                             
                    PHX                             
                    PHX                             
                    TSC                             ; Line 29
                    ADC        #$009E               
                    TCS                             
                    LDA        #$7567               
                    STA        $9D,S                
                    TYA                             
                    STA        $A0,S                
                    PEA        $7457                
                    PEA        $7766                
                    TSC                             ; Line 31
                    ADC        #$013E               
                    TCS                             
                    LDA        #$7566               
                    STA        $03,S                
                    TYA                             
                    STA        $A3,S                
                    LDA        $06,S                
                    AND        #$0F00               
                    ORA        #$4044               
                    STA        $06,S                
                    LDA        $A5,S                
                    AND        #$0FF0               
                    ORA        #$4004               
                    STA        $A5,S                
                    SEP        #$20                 
                    LDA        $A2,S                
                    AND        #$F0                 
                    ORA        #$04                 
                    STA        $A2,S                
                    REP        #$30                 
                    TSC                             ; Line 33
                    ADC        #$0144               
                    TCS                             
                    PHY                             
                    PHY                             
                    TSC                             ; Line 60
                    ADC        #$10E0               
                    TCS                             
                    LDA        $08,S                
                    AND        #$0F0F               
                    ORA        #$5050               
                    STA        $08,S                
                    LDA        $0A,S                
                    AND        #$0F0F               
                    ORA        #$5050               
                    STA        $0A,S                
                    LDA        $A0,S                
                    AND        #$F0F0               
                    ORA        #$0505               
                    STA        $A0,S                
                    LDA        $A2,S                
                    AND        #$F0F0               
                    ORA        #$0505               
                    STA        $A2,S                
                    LDA        $A4,S                
                    AND        #$F0F0               
                    ORA        #$0505               
                    STA        $A4,S                
                    LDA        $A6,S                
                    AND        #$F0F0               
                    ORA        #$0505               
                    STA        $A6,S                
                    LDA        $A8,S                
                    AND        #$F0F0               
                    ORA        #$0505               
                    STA        $A8,S                
                    LDA        $AA,S                
                    AND        #$F0F0               
                    ORA        #$0505               
                    STA        $AA,S                
                    LDA        $AC,S                
                    AND        #$F0F0               
                    ORA        #$0505               
                    STA        $AC,S                
                    LDA        $AE,S                
                    AND        #$F0F0               
                    ORA        #$0505               
                    STA        $AE,S                
                    SEP        #$20                 
                    LDA        $0C,S                
                    AND        #$0F                 
                    ORA        #$50                 
                    STA        $0C,S                
                    REP        #$30                 
                    TSC                             ; Line 62
                    ADC        #$0140               
                    TCS                             
                    LDA        $00,S                
                    AND        #$0F0F               
                    ORA        #$5050               
                    STA        $00,S                
                    LDA        $02,S                
                    AND        #$0F0F               
                    ORA        #$5050               
                    STA        $02,S                
                    LDA        $04,S                
                    AND        #$0F0F               
                    ORA        #$5050               
                    STA        $04,S                
                    LDA        $06,S                
                    AND        #$0F0F               
                    ORA        #$5050               
                    STA        $06,S                
                    LDA        $08,S                
                    AND        #$0F0F               
                    ORA        #$5050               
                    STA        $08,S                
                    LDA        $0A,S                
                    AND        #$0F0F               
                    ORA        #$5050               
                    STA        $0A,S                
                    LDA        $0C,S                
                    AND        #$0F0F               
                    ORA        #$5050               
                    STA        $0C,S                
                    LDA        $A2,S                
                    AND        #$F0F0               
                    ORA        #$0505               
                    STA        $A2,S                
                    LDA        $A4,S                
                    AND        #$F0F0               
                    ORA        #$0505               
                    STA        $A4,S                
                    LDA        $A6,S                
                    AND        #$F0F0               
                    ORA        #$0505               
                    STA        $A6,S                
                    LDA        $A8,S                
                    AND        #$F0F0               
                    ORA        #$0505               
                    STA        $A8,S                
                    LDA        $AA,S                
                    AND        #$F0F0               
                    ORA        #$0505               
                    STA        $AA,S                
                    SEP        #$20                 
                    LDA        $0E,S                
                    AND        #$0F                 
                    ORA        #$50                 
                    STA        $0E,S                
                    REP        #$30                 
*--                                                 
                    LDAL       $E1C068              ; Direct Page and Stack in Bank 00/
                    AND        #$FFCF               
                    STAL       $E1C068              
                    LDA        StackAddress         ; Restore Stack
                    TCS                             
                    PLD                             ; Restore Direct Page
                    CLI                             ; Enable Interrupts
                    PLB
                    RTL                             
                                                    
*-----------------------------------                                
Sprite_BL_032       CLC                             ; Sprite #032 : 32x72, 1038 bytes, 1694 cycles
                    SEI                             ; Disable Interrupts
                    PHD                             ; Backup Direct Page
                    TSC                             ; Backup Stack
                    STA        StackAddress         
                    LDAL       $E1C068              ; Direct Page and Stack in Bank 01/
                    ORA        #$0030               
                    STAL       $E1C068              
                    TYA                             ; Y = Sprite Target Screen Address (upper left corner)
                    TCS                             ; New Stack address
                    LDX        #$7575               ; Pattern #1 : 19
                    LDY        #$7777               ; Pattern #2 : 19
                    LDA        #$5757               ; Pattern #3 : 14
                    TCD                             
*--                                                 
                    TDC                             ; Line 0
                    STA        $08,S                
                    LDA        $0A,S                
                    AND        #$0F00               
                    ORA        #$5057               
                    STA        $0A,S                
                    SEP        #$20                 
                    LDA        #$75                 
                    STA        $AC,S                
                    LDA        $07,S                
                    AND        #$F0                 
                    ORA        #$07                 
                    STA        $07,S                
                    REP        #$30                 
                    TSC                             ; Line 1
                    ADC        #$00AB               
                    TCS                             
                    SEP        #$20                 
                    LDA        #$57                 
                    STA        $A2,S                
                    REP        #$30                 
                    PHX                             
                    PHX                             
                    PHX                             
                    TSC                             ; Line 2
                    ADC        #$00A7               
                    TCS                             
                    LDA        $95,S                
                    AND        #$00F0               
                    ORA        #$5505               
                    STA        $95,S                
                    LDA        $97,S                
                    AND        #$F00F               
                    ORA        #$0550               
                    STA        $97,S                
                    SEP        #$20                 
                    LDA        #$75                 
                    STA        $99,S                
                    LDA        $A2,S                
                    AND        #$0F                 
                    ORA        #$70                 
                    STA        $A2,S                
                    REP        #$30                 
                    PHD                             
                    PEA        $5777                
                    PHY                             
                    PHD                             
                    TSC                             ; Line 3
                    ADC        #$00A9               
                    TCS                             
                    LDA        #$5555               
                    STA        $95,S                
                    LDA        $93,S                
                    AND        #$00F0               
                    ORA        #$3503               
                    STA        $93,S                
                    SEP        #$20                 
                    LDA        $97,S                
                    AND        #$F0                 
                    ORA        #$04                 
                    STA        $97,S                
                    REP        #$30                 
                    PHX                             
                    PHY                             
                    PHY                             
                    PEA        $7776                
                    TSC                             ; Line 4
                    ADC        #$00A9               
                    TCS                             
                    LDA        $92,S                
                    AND        #$00F0               
                    ORA        #$3505               
                    STA        $92,S                
                    LDA        $A0,S                
                    AND        #$0F00               
                    ORA        #$3075               
                    STA        $A0,S                
                    PHD                             
                    PHY                             
                    PHY                             
                    PEA        $6767                
                    PEA        $5777                
                    TSC                             ; Line 5
                    ADC        #$00A9               
                    TCS                             
                    PEA        $7577                
                    PHY                             
                    PHY                             
                    PEA        $7657                
                    PEA        $4644                
                    PEA        $5555                
                    TSC                             ; Line 6
                    ADC        #$00AE               
                    TCS                             
                    PEA        $3757                
                    PHY                             
                    PEA        $7757                
                    PEA        $5767                
                    PEA        $6757                
                    PEA        $4644                
                    PEA        $4455                
                    PEA        $3355                
                    TSC                             ; Line 7
                    ADC        #$00B0               
                    TCS                             
                    SEP        #$20                 
                    LDA        #$55                 
                    STA        $91,S                
                    LDA        $96,S                
                    AND        #$0F                 
                    ORA        #$40                 
                    STA        $96,S                
                    REP        #$30                 
                    PEA        $7573                
                    PEA        $7767                
                    PEA        $6775                
                    PEA        $7576                
                    PEA        $7675                
                    PEA        $4644                
                    PEA        $5455                
                    PEA        $3355                
                    TSC                             ; Line 8
                    ADC        #$00A5               
                    TCS                             
                    SEP        #$20                 
                    LDA        #$55                 
                    STA        $9C,S                
                    LDA        $A1,S                
                    AND        #$0F                 
                    ORA        #$40                 
                    STA        $A1,S                
                    REP        #$30                 
                    PEA        $4444                
                    PEA        $5433                
                    TSC                             
                    ADC        #$000F               
                    TCS                             
                    PEA        $5773                
                    PEA        $7676                
                    PEA        $6657                
                    PEA        $5767                
                    PEA        $7765                
                    TSC                             ; Line 9
                    ADC        #$009F               
                    TCS                             
                    SEP        #$20                 
                    LDA        $9C,S                
                    AND        #$F0                 
                    ORA        #$05                 
                    STA        $9C,S                
                    LDA        $A1,S                
                    AND        #$0F                 
                    ORA        #$40                 
                    STA        $A1,S                
                    REP        #$30                 
                    PEA        $4444                
                    PEA        $4453                
                    TSC                             
                    ADC        #$000F               
                    TCS                             
                    PEA        $7537                
                    PEA        $6367                
                    PEA        $6775                
                    PEA        $7566                
                    PEA        $5777                
                    TSC                             ; Line 10
                    ADC        #$009F               
                    TCS                             
                    LDA        #$3453               
                    STA        $9D,S                
                    LDA        $9F,S                
                    AND        #$0F00               
                    ORA        #$4044               
                    STA        $9F,S                
                    PEA        $4454                
                    PEA        $3453                
                    TSC                             
                    ADC        #$000F               
                    TCS                             
                    PEA        $5777                
                    PEA        $3333                
                    PEA        $6657                
                    PEA        $6767                
                    PEA        $7567                
                    TSC                             ; Line 11
                    ADC        #$00AA               
                    TCS                             
                    LDA        $92,S                
                    AND        #$0FF0               
                    ORA        #$3003               
                    STA        $92,S                
                    PEA        $7577                
                    PEA        $7636                
                    PEA        $7375                
                    PEA        $7566                
                    PEA        $5767                
                    TSC                             ; Line 12
                    ADC        #$00AA               
                    TCS                             
                    LDA        $96,S                
                    AND        #$00F0               
                    ORA        #$7706               
                    STA        $96,S                
                    SEP        #$20                 
                    LDA        $A0,S                
                    AND        #$0F                 
                    ORA        #$70                 
                    STA        $A0,S                
                    REP        #$30                 
                    PEA        $5777                
                    PEA        $6767                
                    PEA        $6657                
                    PEA        $6767                
                    PEA        $7565                
                    TSC                             ; Line 13
                    ADC        #$00A9               
                    TCS                             
                    SEP        #$20                 
                    LDA        $97,S                
                    AND        #$F0                 
                    ORA        #$06                 
                    STA        $97,S                
                    REP        #$30                 
                    PEA        $7577                
                    PEA        $7666                
                    PHX                             
                    PEA        $6657                
                    TSC                             ; Line 14
                    ADC        #$00A9               
                    TCS                             
                    LDA        $9F,S                
                    AND        #$0F00               
                    ORA        #$5057               
                    STA        $9F,S                
                    PHX                             
                    PEA        $7577                
                    PEA        $6675                
                    PEA        $6666                
                    PEA        $7675                
                    TSC                             ; Line 15
                    ADC        #$00A8               
                    TCS                             
                    SEP        #$20                 
                    LDA        #$75                 
                    STA        $A1,S                
                    REP        #$30                 
                    PHD                             
                    PHD                             
                    PEA        $6776                
                    PEA        $6667                
                    TSC                             ; Line 16
                    ADC        #$00A8               
                    TCS                             
                    LDA        $9F,S                
                    AND        #$0F00               
                    ORA        #$5055               
                    STA        $9F,S                
                    PHX                             
                    PHX                             
                    PEA        $6676                
                    PEA        $6767                
                    TSC                             ; Line 17
                    ADC        #$00A6               
                    TCS                             
                    PEA        $5557                
                    PEA        $6766                
                    PEA        $7776                
                    TSC                             ; Line 18
                    ADC        #$00AA               
                    TCS                             
                    PEA        $4475                
                    PHX                             
                    PHX                             
                    PEA        $7666                
                    PEA        $7771                
                    TSC                             ; Line 19
                    ADC        #$00AA               
                    TCS                             
                    PEA        $4457                
                    PHD                             
                    PHD                             
                    PEA        $6766                
                    PEA        $6776                
                    TSC                             ; Line 20
                    ADC        #$00AA               
                    TCS                             
                    PEA        $4477                
                    PHY                             
                    PHY                             
                    PEA        $4744                
                    PEA        $6671                
                    TSC                             ; Line 21
                    ADC        #$00AA               
                    TCS                             
                    PEA        $4467                
                    PEA        $6767                
                    PEA        $6767                
                    PEA        $4744                
                    PEA        $1646                
                    TSC                             ; Line 22
                    ADC        #$00AA               
                    TCS                             
                    SEP        #$20                 
                    LDA        $A0,S                
                    AND        #$F0                 
                    ORA        #$04                 
                    STA        $A0,S                
                    REP        #$30                 
                    PEA        $4466                
                    PEA        $6666                
                    PEA        $6666                
                    PEA        $4644                
                    PEA        $7444                
                    TSC                             ; Line 23
                    ADC        #$00A9               
                    TCS                             
                    LDA        $A0,S                
                    AND        #$F000               
                    ORA        #$0444               
                    STA        $A0,S                
                    PEA        $4476                
                    PEA        $7676                
                    PEA        $7676                
                    PEA        $4477                
                    TSC                             ; Line 25
                    ADC        #$013A               
                    TCS                             
                    SEP        #$20                 
                    LDA        $0E,S                
                    AND        #$F0                 
                    ORA        #$04                 
                    STA        $0E,S                
                    LDA        $AE,S                
                    AND        #$F0                 
                    ORA        #$04                 
                    STA        $AE,S                
                    REP        #$30                 
                    TSC                             ; Line 68
                    ADC        #$1AE0               
                    TCS                             
                    LDA        $08,S                
                    AND        #$0F0F               
                    ORA        #$5050               
                    STA        $08,S                
                    LDA        $0A,S                
                    AND        #$0F0F               
                    ORA        #$5050               
                    STA        $0A,S                
                    LDA        $A0,S                
                    AND        #$F0F0               
                    ORA        #$0505               
                    STA        $A0,S                
                    LDA        $A2,S                
                    AND        #$F0F0               
                    ORA        #$0505               
                    STA        $A2,S                
                    LDA        $A4,S                
                    AND        #$F0F0               
                    ORA        #$0505               
                    STA        $A4,S                
                    LDA        $A6,S                
                    AND        #$F0F0               
                    ORA        #$0505               
                    STA        $A6,S                
                    LDA        $A8,S                
                    AND        #$F0F0               
                    ORA        #$0505               
                    STA        $A8,S                
                    LDA        $AA,S                
                    AND        #$F0F0               
                    ORA        #$0505               
                    STA        $AA,S                
                    LDA        $AC,S                
                    AND        #$F0F0               
                    ORA        #$0505               
                    STA        $AC,S                
                    LDA        $AE,S                
                    AND        #$F0F0               
                    ORA        #$0505               
                    STA        $AE,S                
                    SEP        #$20                 
                    LDA        $0C,S                
                    AND        #$0F                 
                    ORA        #$50                 
                    STA        $0C,S                
                    REP        #$30                 
                    TSC                             ; Line 70
                    ADC        #$0140               
                    TCS                             
                    LDA        $00,S                
                    AND        #$0F0F               
                    ORA        #$5050               
                    STA        $00,S                
                    LDA        $02,S                
                    AND        #$0F0F               
                    ORA        #$5050               
                    STA        $02,S                
                    LDA        $04,S                
                    AND        #$0F0F               
                    ORA        #$5050               
                    STA        $04,S                
                    LDA        $06,S                
                    AND        #$0F0F               
                    ORA        #$5050               
                    STA        $06,S                
                    LDA        $08,S                
                    AND        #$0F0F               
                    ORA        #$5050               
                    STA        $08,S                
                    LDA        $0A,S                
                    AND        #$0F0F               
                    ORA        #$5050               
                    STA        $0A,S                
                    LDA        $0C,S                
                    AND        #$0F0F               
                    ORA        #$5050               
                    STA        $0C,S                
                    LDA        $A2,S                
                    AND        #$F0F0               
                    ORA        #$0505               
                    STA        $A2,S                
                    LDA        $A4,S                
                    AND        #$F0F0               
                    ORA        #$0505               
                    STA        $A4,S                
                    LDA        $A6,S                
                    AND        #$F0F0               
                    ORA        #$0505               
                    STA        $A6,S                
                    LDA        $A8,S                
                    AND        #$F0F0               
                    ORA        #$0505               
                    STA        $A8,S                
                    LDA        $AA,S                
                    AND        #$F0F0               
                    ORA        #$0505               
                    STA        $AA,S                
                    SEP        #$20                 
                    LDA        $0E,S                
                    AND        #$0F                 
                    ORA        #$50                 
                    STA        $0E,S                
                    REP        #$30                 
*--                                                 
                    LDAL       $E1C068              ; Direct Page and Stack in Bank 00/
                    AND        #$FFCF               
                    STAL       $E1C068              
                    LDA        StackAddress         ; Restore Stack
                    TCS                             
                    PLD                             ; Restore Direct Page
                    CLI                             ; Enable Interrupts
                    PLB
                    RTL                             
                                                    
*-----------------------------------                                
Sprite_BL_033       CLC                             ; Sprite #033 : 32x80, 1290 bytes, 2081 cycles
                    SEI                             ; Disable Interrupts
                    PHD                             ; Backup Direct Page
                    TSC                             ; Backup Stack
                    STA        StackAddress         
                    LDAL       $E1C068              ; Direct Page and Stack in Bank 01/
                    ORA        #$0030               
                    STAL       $E1C068              
                    TYA                             ; Y = Sprite Target Screen Address (upper left corner)
                    TCS                             ; New Stack address
                    LDX        #$5757               ; Pattern #1 : 16
                    LDY        #$7575               ; Pattern #2 : 13
                    LDA        #$7777               ; Pattern #3 : 10
                    TCD                             
*--                                                 
                    TXA                             ; Line 0
                    STA        $06,S                
                    LDA        #$4444               
                    STA        $AC,S                
                    LDA        $04,S                
                    AND        #$00F0               
                    ORA        #$5707               
                    STA        $04,S                
                    LDA        $AA,S                
                    AND        #$00F0               
                    ORA        #$4404               
                    STA        $AA,S                
                    SEP        #$20                 
                    LDA        #$33                 
                    STA        $A4,S                
                    REP        #$30                 
                    TSC                             ; Line 1
                    ADC        #$00A8               
                    TCS                             
                    LDA        #$4444               
                    STA        $A3,S                
                    LDA        $9B,S                
                    AND        #$00F0               
                    ORA        #$5707               
                    STA        $9B,S                
                    LDA        $A1,S                
                    AND        #$F00F               
                    ORA        #$0450               
                    STA        $A1,S                
                    PHY                             
                    PHY                             
                    TSC                             ; Line 2
                    ADC        #$00A4               
                    TCS                             
                    SEP        #$20                 
                    LDA        $9B,S                
                    AND        #$F0                 
                    ORA        #$05                 
                    STA        $9B,S                
                    LDA        $A2,S                
                    AND        #$F0                 
                    ORA        #$05                 
                    STA        $A2,S                
                    REP        #$30                 
                    PEA        $5777                
                    PEA        $7733                
                    TSC                             ; Line 3
                    ADC        #$00A5               
                    TCS                             
                    LDA        #$4466               
                    STA        $A3,S                
                    LDA        $A1,S                
                    AND        #$00F0               
                    ORA        #$5707               
                    STA        $A1,S                
                    SEP        #$20                 
                    LDA        #$75                 
                    STA        $9A,S                
                    REP        #$30                 
                    PHY                             
                    PEA        $7737                
                    PEA        $7775                
                    TSC                             
                    ADC        #$000B               
                    TCS                             
                    PEA        $4444                
                    PEA        $7677                
                    TSC                             ; Line 4
                    ADC        #$009F               
                    TCS                             
                    LDA        #$7677               
                    STA        $A2,S                
                    LDA        $99,S                
                    AND        #$00F0               
                    ORA        #$5707               
                    STA        $99,S                
                    SEP        #$20                 
                    LDA        $A1,S                
                    AND        #$F0                 
                    ORA        #$05                 
                    STA        $A1,S                
                    LDA        $A4,S                
                    AND        #$0F                 
                    ORA        #$60                 
                    STA        $A4,S                
                    REP        #$30                 
                    PEA        $5777                
                    PEA        $6733                
                    PEA        $7657                
                    TSC                             ; Line 5
                    ADC        #$00A6               
                    TCS                             
                    LDA        $99,S                
                    AND        #$00F0               
                    ORA        #$7505               
                    STA        $99,S                
                    LDA        $A3,S                
                    AND        #$0F00               
                    ORA        #$7066               
                    STA        $A3,S                
                    PHY                             
                    PEA        $7663                
                    PEA        $7757                
                    TSC                             ; Line 6
                    ADC        #$00A8               
                    TCS                             
                    LDA        $A1,S                
                    AND        #$0F00               
                    ORA        #$6076               
                    STA        $A1,S                
                    PHX                             
                    PEA        $5767                
                    PEA        $6773                
                    PEA        $7677                
                    TSC                             ; Line 7
                    ADC        #$00A8               
                    TCS                             
                    LDA        $A1,S                
                    AND        #$0F00               
                    ORA        #$7066               
                    STA        $A1,S                
                    PEA        $7755                
                    PEA        $7577                
                    PEA        $3663                
                    PHD                             
                    PHX                             
                    TSC                             ; Line 8
                    ADC        #$00AA               
                    TCS                             
                    LDA        $A1,S                
                    AND        #$0F00               
                    ORA        #$6076               
                    STA        $A1,S                
                    PHX                             
                    PEA        $5767                
                    PEA        $3676                
                    PEA        $6777                
                    PEA        $7775                
                    TSC                             ; Line 9
                    ADC        #$00AA               
                    TCS                             
                    LDA        $A1,S                
                    AND        #$0F00               
                    ORA        #$7066               
                    STA        $A1,S                
                    SEP        #$20                 
                    LDA        $96,S                
                    AND        #$F0                 
                    ORA        #$05                 
                    STA        $96,S                
                    REP        #$30                 
                    PEA        $7755                
                    PEA        $7566                
                    PEA        $7676                
                    PEA        $7677                
                    PEA        $7757                
                    TSC                             ; Line 10
                    ADC        #$00AA               
                    TCS                             
                    LDA        $A1,S                
                    AND        #$0F00               
                    ORA        #$6076               
                    STA        $A1,S                
                    SEP        #$20                 
                    LDA        $96,S                
                    AND        #$F0                 
                    ORA        #$07                 
                    STA        $96,S                
                    REP        #$30                 
                    PHX                             
                    PEA        $5756                
                    PEA        $7766                
                    PEA        $6677                
                    PEA        $7775                
                    TSC                             ; Line 11
                    ADC        #$00AA               
                    TCS                             
                    LDA        $A1,S                
                    AND        #$0F00               
                    ORA        #$7066               
                    STA        $A1,S                
                    SEP        #$20                 
                    LDA        $96,S                
                    AND        #$F0                 
                    ORA        #$05                 
                    STA        $96,S                
                    REP        #$30                 
                    PEA        $7775                
                    PHY                             
                    PHX                             
                    PEA        $5777                
                    PEA        $7757                
                    TSC                             ; Line 12
                    ADC        #$00AA               
                    TCS                             
                    LDA        $96,S                
                    AND        #$00F0               
                    ORA        #$5707               
                    STA        $96,S                
                    SEP        #$20                 
                    LDA        $A2,S                
                    AND        #$0F                 
                    ORA        #$60                 
                    STA        $A2,S                
                    REP        #$30                 
                    PHX                             
                    PEA        $5777                
                    PHY                             
                    PHY                             
                    PEA        $7775                
                    TSC                             ; Line 13
                    ADC        #$00AB               
                    TCS                             
                    LDA        $A0,S                
                    AND        #$0F00               
                    ORA        #$7044               
                    STA        $A0,S                
                    SEP        #$20                 
                    LDA        $95,S                
                    AND        #$F0                 
                    ORA        #$05                 
                    STA        $95,S                
                    REP        #$30                 
                    PEA        $7677                
                    PEA        $7676                
                    PHX                             
                    PHX                             
                    PHD                             
                    TSC                             ; Line 14
                    ADC        #$00A9               
                    TCS                             
                    LDA        $A1,S                
                    AND        #$0F00               
                    ORA        #$4044               
                    STA        $A1,S                
                    SEP        #$20                 
                    LDA        $96,S                
                    AND        #$F0                 
                    ORA        #$07                 
                    STA        $96,S                
                    REP        #$30                 
                    PEA        $6467                
                    PEA        $7676                
                    PEA        $7676                
                    PHY                             
                    PHD                             
                    TSC                             ; Line 15
                    ADC        #$00AA               
                    TCS                             
                    SEP        #$20                 
                    LDA        $96,S                
                    AND        #$F0                 
                    ORA        #$05                 
                    STA        $96,S                
                    REP        #$30                 
                    PEA        $6466                
                    PEA        $6666                
                    PEA        $6767                
                    PEA        $6777                
                    PEA        $7757                
                    TSC                             ; Line 16
                    ADC        #$00AC               
                    TCS                             
                    LDA        #$6666               
                    PEA        $4444                
                    PHA                             
                    PHA                             
                    PHA                             
                    PEA        $7676                
                    PEA        $7677                
                    TSC                             ; Line 17
                    ADC        #$00AC               
                    TCS                             
                    LDA        $95,S                
                    AND        #$00F0               
                    ORA        #$7707               
                    STA        $95,S                
                    PEA        $4766                
                    PEA        $6776                
                    PEA        $6757                
                    PEA        $5777                
                    PEA        $7676                
                    PEA        $7775                
                    TSC                             ; Line 18
                    ADC        #$00AC               
                    TCS                             
                    LDA        $95,S                
                    AND        #$00F0               
                    ORA        #$7605               
                    STA        $95,S                
                    LDA        $9F,S                
                    AND        #$0F00               
                    ORA        #$4066               
                    STA        $9F,S                
                    PEA        $7761                
                    PHD                             
                    PEA        $7675                
                    PHY                             
                    PEA        $6767                
                    TSC                             ; Line 19
                    ADC        #$00A8               
                    TCS                             
                    LDA        $97,S                
                    AND        #$00F0               
                    ORA        #$5707               
                    STA        $97,S                
                    LDA        $A1,S                
                    AND        #$0F00               
                    ORA        #$4016               
                    STA        $A1,S                
                    PEA        $7667                
                    PEA        $5657                
                    PEA        $7757                
                    PEA        $7577                
                    TSC                             ; Line 20
                    ADC        #$00A8               
                    TCS                             
                    LDA        #$7675               
                    STA        $98,S                
                    LDA        #$7767               
                    STA        $9F,S                
                    LDA        $9D,S                
                    AND        #$00F0               
                    ORA        #$6606               
                    STA        $9D,S                
                    LDA        $A1,S                
                    AND        #$0F00               
                    ORA        #$4074               
                    STA        $A1,S                
                    SEP        #$20                 
                    LDA        #$66                 
                    STA        $9A,S                
                    REP        #$30                 
                    PEA        $1676                
                    PEA        $7767                
                    PEA        $6667                
                    PEA        $5755                
                    TSC                             ; Line 22
                    ADC        #$0143               
                    TCS                             
                    LDA        #$4444               
                    STA        $9E,S                
                    LDA        $A0,S                
                    AND        #$0F00               
                    ORA        #$4044               
                    STA        $A0,S                
                    SEP        #$20                 
                    LDA        $01,S                
                    AND        #$0F                 
                    ORA        #$40                 
                    STA        $01,S                
                    LDA        $9D,S                
                    AND        #$F0                 
                    ORA        #$05                 
                    STA        $9D,S                
                    REP        #$30                 
                    PEA        $4444                
                    PEA        $7457                
                    TSC                             ; Line 24
                    ADC        #$013E               
                    TCS                             
                    LDA        #$4444               
                    STA        $06,S                
                    LDA        $04,S                
                    AND        #$00F0               
                    ORA        #$4404               
                    STA        $04,S                
                    TSC                             ; Line 25
                    ADC        #$00A7               
                    TCS                             
                    SEP        #$20                 
                    LDA        $9C,S                
                    AND        #$F0                 
                    ORA        #$05                 
                    STA        $9C,S                
                    REP        #$30                 
                    PEA        $4444                
                    PEA        $4455                
                    TSC                             ; Line 26
                    ADC        #$00A4               
                    TCS                             
                    SEP        #$20                 
                    LDA        $9C,S                
                    AND        #$F0                 
                    ORA        #$05                 
                    STA        $9C,S                
                    REP        #$30                 
                    PEA        $5444                
                    PEA        $4555                
                    TSC                             ; Line 27
                    ADC        #$00A4               
                    TCS                             
                    LDA        #$5455               
                    STA        $9E,S                
                    LDA        $9C,S                
                    AND        #$00F0               
                    ORA        #$5505               
                    STA        $9C,S                
                    LDA        $A0,S                
                    AND        #$0F00               
                    ORA        #$3033               
                    STA        $A0,S                
                    PEA        $4444                
                    PEA        $5555                
                    TSC                             ; Line 29
                    ADC        #$013D               
                    TCS                             
                    LDA        #$3333               
                    STA        $05,S                
                    LDA        $03,S                
                    AND        #$00F0               
                    ORA        #$5505               
                    STA        $03,S                
                    LDA        $07,S                
                    AND        #$0F00               
                    ORA        #$3033               
                    STA        $07,S                
                    SEP        #$20                 
                    LDA        $A8,S                
                    AND        #$0F                 
                    ORA        #$50                 
                    STA        $A8,S                
                    REP        #$30                 
                    TSC                             ; Line 30
                    ADC        #$00A7               
                    TCS                             
                    PEA        $5535                
                    PEA        $3333                
                    TSC                             ; Line 31
                    ADC        #$00A4               
                    TCS                             
                    PEA        $5555                
                    PEA        $5535                
                    TSC                             ; Line 32
                    ADC        #$00A4               
                    TCS                             
                    LDA        #$5555               
                    STA        $9E,S                
                    SEP        #$20                 
                    LDA        $9D,S                
                    AND        #$F0                 
                    ORA        #$05                 
                    STA        $9D,S                
                    REP        #$30                 
                    PEA        $5555                
                    PEA        $5555                
                    TSC                             ; Line 76
                    ADC        #$1B7D               
                    TCS                             
                    LDA        $08,S                
                    AND        #$0F0F               
                    ORA        #$5050               
                    STA        $08,S                
                    LDA        $0A,S                
                    AND        #$0F0F               
                    ORA        #$5050               
                    STA        $0A,S                
                    LDA        $A0,S                
                    AND        #$F0F0               
                    ORA        #$0505               
                    STA        $A0,S                
                    LDA        $A2,S                
                    AND        #$F0F0               
                    ORA        #$0505               
                    STA        $A2,S                
                    LDA        $A4,S                
                    AND        #$F0F0               
                    ORA        #$0505               
                    STA        $A4,S                
                    LDA        $A6,S                
                    AND        #$F0F0               
                    ORA        #$0505               
                    STA        $A6,S                
                    LDA        $A8,S                
                    AND        #$F0F0               
                    ORA        #$0505               
                    STA        $A8,S                
                    LDA        $AA,S                
                    AND        #$F0F0               
                    ORA        #$0505               
                    STA        $AA,S                
                    LDA        $AC,S                
                    AND        #$F0F0               
                    ORA        #$0505               
                    STA        $AC,S                
                    LDA        $AE,S                
                    AND        #$F0F0               
                    ORA        #$0505               
                    STA        $AE,S                
                    SEP        #$20                 
                    LDA        $0C,S                
                    AND        #$0F                 
                    ORA        #$50                 
                    STA        $0C,S                
                    REP        #$30                 
                    TSC                             ; Line 78
                    ADC        #$0140               
                    TCS                             
                    LDA        $00,S                
                    AND        #$0F0F               
                    ORA        #$5050               
                    STA        $00,S                
                    LDA        $02,S                
                    AND        #$0F0F               
                    ORA        #$5050               
                    STA        $02,S                
                    LDA        $04,S                
                    AND        #$0F0F               
                    ORA        #$5050               
                    STA        $04,S                
                    LDA        $06,S                
                    AND        #$0F0F               
                    ORA        #$5050               
                    STA        $06,S                
                    LDA        $08,S                
                    AND        #$0F0F               
                    ORA        #$5050               
                    STA        $08,S                
                    LDA        $0A,S                
                    AND        #$0F0F               
                    ORA        #$5050               
                    STA        $0A,S                
                    LDA        $0C,S                
                    AND        #$0F0F               
                    ORA        #$5050               
                    STA        $0C,S                
                    LDA        $A2,S                
                    AND        #$F0F0               
                    ORA        #$0505               
                    STA        $A2,S                
                    LDA        $A4,S                
                    AND        #$F0F0               
                    ORA        #$0505               
                    STA        $A4,S                
                    LDA        $A6,S                
                    AND        #$F0F0               
                    ORA        #$0505               
                    STA        $A6,S                
                    LDA        $A8,S                
                    AND        #$F0F0               
                    ORA        #$0505               
                    STA        $A8,S                
                    LDA        $AA,S                
                    AND        #$F0F0               
                    ORA        #$0505               
                    STA        $AA,S                
                    SEP        #$20                 
                    LDA        $0E,S                
                    AND        #$0F                 
                    ORA        #$50                 
                    STA        $0E,S                
                    REP        #$30                 
*--                                                 
                    LDAL       $E1C068              ; Direct Page and Stack in Bank 00/
                    AND        #$FFCF               
                    STAL       $E1C068              
                    LDA        StackAddress         ; Restore Stack
                    TCS                             
                    PLD                             ; Restore Direct Page
                    CLI                             ; Enable Interrupts
                    PLB
                    RTL                             
                                                    
*-----------------------------------                                
Sprite_BL_034       CLC                             ; Sprite #034 : 32x76, 1157 bytes, 1885 cycles
                    SEI                             ; Disable Interrupts
                    PHD                             ; Backup Direct Page
                    TSC                             ; Backup Stack
                    STA        StackAddress         
                    LDAL       $E1C068              ; Direct Page and Stack in Bank 01/
                    ORA        #$0030               
                    STAL       $E1C068              
                    TYA                             ; Y = Sprite Target Screen Address (upper left corner)
                    TCS                             ; New Stack address
                    LDX        #$5757               ; Pattern #1 : 19
                    LDY        #$7777               ; Pattern #2 : 19
                    LDA        #$7575               ; Pattern #3 : 13
                    TCD                             
*--                                                 
                    SEP        #$20                 ; Line 0
                    LDA        $01,S                
                    AND        #$F0                 
                    ORA        #$04                 
                    STA        $01,S                
                    LDA        $A1,S                
                    AND        #$F0                 
                    ORA        #$04                 
                    STA        $A1,S                
                    REP        #$30                 
                    TSC                             ; Line 2
                    ADC        #$0140               
                    TCS                             
                    LDA        $00,S                
                    AND        #$F0F0               
                    ORA        #$0404               
                    STA        $00,S                
                    LDA        $A0,S                
                    AND        #$F0F0               
                    ORA        #$0404               
                    STA        $A0,S                
                    LDA        $A8,S                
                    AND        #$0F00               
                    ORA        #$7047               
                    STA        $A8,S                
                    SEP        #$20                 
                    LDA        $02,S                
                    AND        #$0F                 
                    ORA        #$40                 
                    STA        $02,S                
                    REP        #$30                 
                    TSC                             ; Line 3
                    ADC        #$00A7               
                    TCS                             
                    LDA        $A2,S                
                    AND        #$0F00               
                    ORA        #$4074               
                    STA        $A2,S                
                    SEP        #$20                 
                    LDA        $99,S                
                    AND        #$F0                 
                    ORA        #$04                 
                    STA        $99,S                
                    REP        #$30                 
                    PEA        $7476                
                    PEA        $7676                
                    PEA        $7646                
                    TSC                             ; Line 4
                    ADC        #$00A7               
                    TCS                             
                    LDA        $A1,S                
                    AND        #$0F00               
                    ORA        #$4016               
                    STA        $A1,S                
                    SEP        #$20                 
                    LDA        $98,S                
                    AND        #$F0                 
                    ORA        #$04                 
                    STA        $98,S                
                    REP        #$30                 
                    PEA        $4444                
                    PEA        $6666                
                    PEA        $6666                
                    PEA        $6646                
                    TSC                             ; Line 5
                    ADC        #$00A8               
                    TCS                             
                    LDA        $A1,S                
                    AND        #$0F00               
                    ORA        #$7061               
                    STA        $A1,S                
                    SEP        #$20                 
                    LDA        $98,S                
                    AND        #$F0                 
                    ORA        #$04                 
                    STA        $98,S                
                    REP        #$30                 
                    PEA        $4644                
                    PEA        $6767                
                    PEA        $6767                
                    PEA        $6747                
                    TSC                             ; Line 6
                    ADC        #$00A8               
                    TCS                             
                    LDA        $A1,S                
                    AND        #$0F00               
                    ORA        #$7066               
                    STA        $A1,S                
                    SEP        #$20                 
                    LDA        $98,S                
                    AND        #$F0                 
                    ORA        #$04                 
                    STA        $98,S                
                    REP        #$30                 
                    PEA        $4644                
                    PHY                             
                    PHY                             
                    PEA        $7747                
                    TSC                             ; Line 7
                    ADC        #$00A8               
                    TCS                             
                    LDA        $98,S                
                    AND        #$00F0               
                    ORA        #$4504               
                    STA        $98,S                
                    SEP        #$20                 
                    LDA        $A2,S                
                    AND        #$0F                 
                    ORA        #$70                 
                    STA        $A2,S                
                    REP        #$30                 
                    PEA        $6766                
                    PHX                             
                    PHX                             
                    PEA        $5747                
                    TSC                             ; Line 8
                    ADC        #$00A9               
                    TCS                             
                    LDA        $A0,S                
                    AND        #$0F00               
                    ORA        #$7076               
                    STA        $A0,S                
                    PEA        $7167                
                    PEA        $7676                
                    PHD                             
                    PHD                             
                    TSC                             ; Line 9
                    ADC        #$00A7               
                    TCS                             
                    LDA        $99,S                
                    AND        #$00F0               
                    ORA        #$7505               
                    STA        $99,S                
                    LDA        $A1,S                
                    AND        #$0F00               
                    ORA        #$6067               
                    STA        $A1,S                
                    PEA        $6766                
                    PHX                             
                    PEA        $5555                
                    TSC                             ; Line 10
                    ADC        #$00A6               
                    TCS                             
                    LDA        $A1,S                
                    AND        #$0F00               
                    ORA        #$6067               
                    STA        $A1,S                
                    PEA        $7766                
                    PEA        $7675                
                    PHD                             
                    TSC                             ; Line 11
                    ADC        #$00A6               
                    TCS                             
                    LDA        $A1,S                
                    AND        #$0F00               
                    ORA        #$6057               
                    STA        $A1,S                
                    SEP        #$20                 
                    LDA        $98,S                
                    AND        #$F0                 
                    ORA        #$05                 
                    STA        $98,S                
                    REP        #$30                 
                    PEA        $7666                
                    PHX                             
                    PHX                             
                    PHX                             
                    TSC                             ; Line 12
                    ADC        #$00A8               
                    TCS                             
                    LDA        $A1,S                
                    AND        #$0F00               
                    ORA        #$6077               
                    STA        $A1,S                
                    SEP        #$20                 
                    LDA        $98,S                
                    AND        #$F0                 
                    ORA        #$07                 
                    STA        $98,S                
                    REP        #$30                 
                    PEA        $6766                
                    PEA        $7665                
                    PEA        $7677                
                    PHD                             
                    TSC                             ; Line 13
                    ADC        #$00A8               
                    TCS                             
                    LDA        $A5,S                
                    AND        #$00F0               
                    ORA        #$4503               
                    STA        $A5,S                
                    PEA        $7566                
                    PHX                             
                    PEA        $6667                
                    PEA        $7757                
                    TSC                             ; Line 14
                    ADC        #$00A9               
                    TCS                             
                    LDA        #$4344               
                    STA        $A3,S                
                    LDA        $A5,S                
                    AND        #$0F00               
                    ORA        #$5035               
                    STA        $A5,S                
                    SEP        #$20                 
                    LDA        $A2,S                
                    AND        #$F0                 
                    ORA        #$04                 
                    STA        $A2,S                
                    REP        #$30                 
                    PEA        $5657                
                    PEA        $7676                
                    PEA        $7566                
                    PEA        $7676                
                    PEA        $7775                
                    TSC                             ; Line 15
                    ADC        #$00AA               
                    TCS                             
                    SEP        #$20                 
                    LDA        $A1,S                
                    AND        #$F0                 
                    ORA        #$04                 
                    STA        $A1,S                
                    LDA        $A6,S                
                    AND        #$0F                 
                    ORA        #$50                 
                    STA        $A6,S                
                    REP        #$30                 
                    PEA        $7675                
                    PEA        $6657                
                    PEA        $5737                
                    PEA        $6367                
                    PEA        $7757                
                    TSC                             ; Line 16
                    ADC        #$00AA               
                    TCS                             
                    LDA        $A1,S                
                    AND        #$00F0               
                    ORA        #$4404               
                    STA        $A1,S                
                    PEA        $7657                
                    PEA        $7676                
                    PEA        $7566                
                    PEA        $3333                
                    PEA        $7775                
                    TSC                             
                    ADC        #$000F               
                    TCS                             
                    PEA        $3543                
                    PEA        $4544                
                    TSC                             ; Line 17
                    ADC        #$009F               
                    TCS                             
                    LDA        $A1,S                
                    AND        #$00F0               
                    ORA        #$4404               
                    STA        $A1,S                
                    PEA        $7775                
                    PEA        $6657                
                    PEA        $5776                
                    PEA        $7636                
                    PEA        $7357                
                    TSC                             
                    ADC        #$0010               
                    TCS                             
                    PEA        $5535                
                    PEA        $4444                
                    TSC                             ; Line 18
                    ADC        #$009E               
                    TCS                             
                    PEA        $5677                
                    PEA        $7675                
                    PEA        $7566                
                    PEA        $6767                
                    PEA        $3775                
                    TSC                             
                    ADC        #$0010               
                    TCS                             
                    PEA        $5533                
                    PEA        $4544                
                    TSC                             ; Line 19
                    ADC        #$00A4               
                    TCS                             
                    PEA        $5533                
                    PEA        $5545                
                    PEA        $4464                
                    PEA        $5767                
                    PEA        $6757                
                    PEA        $5776                
                    PEA        $7677                
                    PEA        $3757                
                    TSC                             ; Line 20
                    ADC        #$00B0               
                    TCS                             
                    LDA        $91,S                
                    AND        #$00F0               
                    ORA        #$5703               
                    STA        $91,S                
                    PEA        $5533                
                    PEA        $5544                
                    PEA        $4464                
                    PEA        $7576                
                    PEA        $7675                
                    PEA        $7577                
                    PHY                             
                    PEA        $7573                
                    TSC                             ; Line 21
                    ADC        #$00B0               
                    TCS                             
                    LDA        #$5355               
                    STA        $9E,S                
                    LDA        $9C,S                
                    AND        #$000F               
                    ORA        #$5540               
                    STA        $9C,S                
                    SEP        #$20                 
                    LDA        $A0,S                
                    AND        #$0F                 
                    ORA        #$30                 
                    STA        $A0,S                
                    REP        #$30                 
                    PEA        $5553                
                    PEA        $5555                
                    PEA        $4464                
                    PEA        $7567                
                    PHY                             
                    PHY                             
                    PEA        $7757                
                    TSC                             ; Line 22
                    ADC        #$00A9               
                    TCS                             
                    LDA        $97,S                
                    AND        #$00F0               
                    ORA        #$5707               
                    STA        $97,S                
                    LDA        $A1,S                
                    AND        #$F00F               
                    ORA        #$0550               
                    STA        $A1,S                
                    LDA        $A3,S                
                    AND        #$0F00               
                    ORA        #$5055               
                    STA        $A3,S                
                    PEA        $7775                
                    PEA        $7676                
                    PHY                             
                    PHY                             
                    PHD                             
                    TSC                             ; Line 23
                    ADC        #$00AA               
                    TCS                             
                    SEP        #$20                 
                    LDA        #$75                 
                    STA        $A0,S                
                    REP        #$30                 
                    PEA        $5767                
                    PHY                             
                    PHY                             
                    PEA        $7757                
                    TSC                             ; Line 24
                    ADC        #$00A7               
                    TCS                             
                    SEP        #$20                 
                    LDA        #$57                 
                    STA        $A0,S                
                    REP        #$30                 
                    PEA        $7577                
                    PHY                             
                    PHD                             
                    PHD                             
                    TSC                             ; Line 25
                    ADC        #$00A7               
                    TCS                             
                    TDC                             
                    STA        $9D,S                
                    LDA        $9F,S                
                    AND        #$0F00               
                    ORA        #$7075               
                    STA        $9F,S                
                    SEP        #$20                 
                    LDA        $9C,S                
                    AND        #$F0                 
                    ORA        #$05                 
                    STA        $9C,S                
                    REP        #$30                 
                    PHX                             
                    PHX                             
                    PHX                             
                    TSC                             ; Line 72
                    ADC        #$1D5E               
                    TCS                             
                    LDA        $08,S                
                    AND        #$0F0F               
                    ORA        #$5050               
                    STA        $08,S                
                    LDA        $0A,S                
                    AND        #$0F0F               
                    ORA        #$5050               
                    STA        $0A,S                
                    LDA        $A0,S                
                    AND        #$F0F0               
                    ORA        #$0505               
                    STA        $A0,S                
                    LDA        $A2,S                
                    AND        #$F0F0               
                    ORA        #$0505               
                    STA        $A2,S                
                    LDA        $A4,S                
                    AND        #$F0F0               
                    ORA        #$0505               
                    STA        $A4,S                
                    LDA        $A6,S                
                    AND        #$F0F0               
                    ORA        #$0505               
                    STA        $A6,S                
                    LDA        $A8,S                
                    AND        #$F0F0               
                    ORA        #$0505               
                    STA        $A8,S                
                    LDA        $AA,S                
                    AND        #$F0F0               
                    ORA        #$0505               
                    STA        $AA,S                
                    LDA        $AC,S                
                    AND        #$F0F0               
                    ORA        #$0505               
                    STA        $AC,S                
                    LDA        $AE,S                
                    AND        #$F0F0               
                    ORA        #$0505               
                    STA        $AE,S                
                    SEP        #$20                 
                    LDA        $0C,S                
                    AND        #$0F                 
                    ORA        #$50                 
                    STA        $0C,S                
                    REP        #$30                 
                    TSC                             ; Line 74
                    ADC        #$0140               
                    TCS                             
                    LDA        $00,S                
                    AND        #$0F0F               
                    ORA        #$5050               
                    STA        $00,S                
                    LDA        $02,S                
                    AND        #$0F0F               
                    ORA        #$5050               
                    STA        $02,S                
                    LDA        $04,S                
                    AND        #$0F0F               
                    ORA        #$5050               
                    STA        $04,S                
                    LDA        $06,S                
                    AND        #$0F0F               
                    ORA        #$5050               
                    STA        $06,S                
                    LDA        $08,S                
                    AND        #$0F0F               
                    ORA        #$5050               
                    STA        $08,S                
                    LDA        $0A,S                
                    AND        #$0F0F               
                    ORA        #$5050               
                    STA        $0A,S                
                    LDA        $0C,S                
                    AND        #$0F0F               
                    ORA        #$5050               
                    STA        $0C,S                
                    LDA        $A2,S                
                    AND        #$F0F0               
                    ORA        #$0505               
                    STA        $A2,S                
                    LDA        $A4,S                
                    AND        #$F0F0               
                    ORA        #$0505               
                    STA        $A4,S                
                    LDA        $A6,S                
                    AND        #$F0F0               
                    ORA        #$0505               
                    STA        $A6,S                
                    LDA        $A8,S                
                    AND        #$F0F0               
                    ORA        #$0505               
                    STA        $A8,S                
                    LDA        $AA,S                
                    AND        #$F0F0               
                    ORA        #$0505               
                    STA        $AA,S                
                    SEP        #$20                 
                    LDA        $0E,S                
                    AND        #$0F                 
                    ORA        #$50                 
                    STA        $0E,S                
                    REP        #$30                 
*--                                                 
                    LDAL       $E1C068              ; Direct Page and Stack in Bank 00/
                    AND        #$FFCF               
                    STAL       $E1C068              
                    LDA        StackAddress         ; Restore Stack
                    TCS                             
                    PLD                             ; Restore Direct Page
                    CLI                             ; Enable Interrupts
                    PLB
                    RTL                             
                                                    
*-----------------------------------                                
Sprite_BL_035       CLC                             ; Sprite #035 : 32x68, 1125 bytes, 1832 cycles
                    SEI                             ; Disable Interrupts
                    PHD                             ; Backup Direct Page
                    TSC                             ; Backup Stack
                    STA        StackAddress         
                    LDAL       $E1C068              ; Direct Page and Stack in Bank 01/
                    ORA        #$0030               
                    STAL       $E1C068              
                    TYA                             ; Y = Sprite Target Screen Address (upper left corner)
                    TCS                             ; New Stack address
                    LDX        #$5757               ; Pattern #1 : 19
                    LDY        #$7575               ; Pattern #2 : 13
                    LDA        #$7577               ; Pattern #3 : 11
                    TCD                             
*--                                                 
                    LDA        #$5555               ; Line 0
                    STA        $0A,S                
                    SEP        #$20                 
                    LDA        $0C,S                
                    AND        #$0F                 
                    ORA        #$50                 
                    STA        $0C,S                
                    REP        #$30                 
                    TSC                             ; Line 1
                    ADC        #$00AC               
                    TCS                             
                    PEA        $5555                
                    PEA        $5555                
                    TSC                             ; Line 2
                    ADC        #$00A4               
                    TCS                             
                    SEP        #$20                 
                    LDA        $9C,S                
                    AND        #$F0                 
                    ORA        #$05                 
                    STA        $9C,S                
                    REP        #$30                 
                    PEA        $5355                
                    PEA        $5555                
                    TSC                             ; Line 3
                    ADC        #$00A4               
                    TCS                             
                    LDA        #$3333               
                    STA        $9E,S                
                    LDA        $9C,S                
                    AND        #$00F0               
                    ORA        #$3303               
                    STA        $9C,S                
                    LDA        $A0,S                
                    AND        #$0F00               
                    ORA        #$5055               
                    STA        $A0,S                
                    PEA        $3333                
                    PEA        $5355                
                    TSC                             ; Line 5
                    ADC        #$0138               
                    TCS                             
                    LDA        #$5545               
                    STA        $0A,S                
                    LDA        $08,S                
                    AND        #$00F0               
                    ORA        #$3303               
                    STA        $08,S                
                    LDA        $0C,S                
                    AND        #$0F00               
                    ORA        #$5055               
                    STA        $0C,S                
                    SEP        #$20                 
                    LDA        $AD,S                
                    AND        #$0F                 
                    ORA        #$50                 
                    STA        $AD,S                
                    REP        #$30                 
                    TSC                             ; Line 6
                    ADC        #$00AC               
                    TCS                             
                    SEP        #$20                 
                    LDA        $A1,S                
                    AND        #$0F                 
                    ORA        #$50                 
                    STA        $A1,S                
                    REP        #$30                 
                    PEA        $5555                
                    PEA        $4444                
                    TSC                             ; Line 7
                    ADC        #$00A4               
                    TCS                             
                    PEA        $5554                
                    PEA        $4445                
                    TSC                             ; Line 8
                    ADC        #$00A4               
                    TCS                             
                    LDA        #$4444               
                    STA        $9D,S                
                    LDA        $9F,S                
                    AND        #$0F00               
                    ORA        #$4044               
                    STA        $9F,S                
                    PEA        $5544                
                    PEA        $4444                
                    TSC                             ; Line 10
                    ADC        #$0138               
                    TCS                             
                    LDA        #$4444               
                    STA        $0A,S                
                    LDA        $0C,S                
                    AND        #$0F00               
                    ORA        #$5044               
                    STA        $0C,S                
                    SEP        #$20                 
                    LDA        $09,S                
                    AND        #$F0                 
                    ORA        #$04                 
                    STA        $09,S                
                    LDA        $A9,S                
                    AND        #$F0                 
                    ORA        #$04                 
                    STA        $A9,S                
                    REP        #$30                 
                    TSC                             ; Line 11
                    ADC        #$00AD               
                    TCS                             
                    LDA        #$7677               
                    STA        $98,S                
                    LDA        #$6766               
                    STA        $9E,S                
                    LDA        $96,S                
                    AND        #$00F0               
                    ORA        #$4704               
                    STA        $96,S                
                    LDA        $9A,S                
                    AND        #$0F00               
                    ORA        #$6066               
                    STA        $9A,S                
                    SEP        #$20                 
                    LDA        #$57                 
                    STA        $A0,S                
                    REP        #$30                 
                    PEA        $7547                
                    PEA        $4444                
                    TSC                             ; Line 13
                    ADC        #$0137               
                    TCS                             
                    LDA        $03,S                
                    AND        #$00F0               
                    ORA        #$6104               
                    STA        $03,S                
                    LDA        $0D,S                
                    AND        #$0F00               
                    ORA        #$7075               
                    STA        $0D,S                
                    LDA        $AD,S                
                    AND        #$0F00               
                    ORA        #$5067               
                    STA        $AD,S                
                    TSC                             
                    ADC        #$000C               
                    TCS                             
                    PEA        $5575                
                    PEA        $7666                
                    PEA        $7677                
                    PEA        $6761                
                    TSC                             ; Line 14
                    ADC        #$00A8               
                    TCS                             
                    LDA        $A1,S                
                    AND        #$0F00               
                    ORA        #$7077               
                    STA        $A1,S                
                    PEA        $7757                
                    PHD                             
                    PEA        $7565                
                    PEA        $7667                
                    PEA        $1677                
                    TSC                             ; Line 15
                    ADC        #$00AA               
                    TCS                             
                    PEA        $7676                
                    PHX                             
                    PEA        $5767                
                    PEA        $7777                
                    PEA        $6674                
                    TSC                             ; Line 16
                    ADC        #$00AC               
                    TCS                             
                    PEA        $5777                
                    PEA        $6767                
                    PEA        $7775                
                    PEA        $7576                
                    PEA        $6766                
                    PEA        $4444                
                    TSC                             ; Line 17
                    ADC        #$00AC               
                    TCS                             
                    LDA        #$6666               
                    PHD                             
                    PEA        $7676                
                    PHA                             
                    PHA                             
                    PHA                             
                    PEA        $4444                
                    TSC                             ; Line 18
                    ADC        #$00AC               
                    TCS                             
                    PEA        $5777                
                    PEA        $7767                
                    PEA        $6767                
                    PEA        $6766                
                    PEA        $6667                
                    PEA        $4474                
                    TSC                             ; Line 19
                    ADC        #$00AC               
                    TCS                             
                    PHD                             
                    PEA        $7775                
                    PEA        $7576                
                    PEA        $7676                
                    PEA        $7676                
                    PEA        $7766                
                    TSC                             ; Line 20
                    ADC        #$00AC               
                    TCS                             
                    PEA        $5777                
                    PEA        $7757                
                    PHX                             
                    PHX                             
                    PHX                             
                    PEA        $6776                
                    TSC                             ; Line 21
                    ADC        #$00AC               
                    TCS                             
                    PHY                             
                    PEA        $7775                
                    PHY                             
                    PHY                             
                    PHY                             
                    PEA        $7766                
                    TSC                             ; Line 22
                    ADC        #$00AC               
                    TCS                             
                    PEA        $5777                
                    PEA        $7757                
                    PHX                             
                    PEA        $5756                
                    PHX                             
                    PEA        $6776                
                    TSC                             ; Line 23
                    ADC        #$00AC               
                    TCS                             
                    LDA        $9F,S                
                    AND        #$0F00               
                    ORA        #$5077               
                    STA        $9F,S                
                    PHY                             
                    PEA        $7767                
                    PEA        $6676                
                    PEA        $6676                
                    PEA        $5575                
                    PEA        $7766                
                    TSC                             ; Line 24
                    ADC        #$00AA               
                    TCS                             
                    LDA        $A1,S                
                    AND        #$0F00               
                    ORA        #$7075               
                    STA        $A1,S                
                    PEA        $7777                
                    PEA        $7636                
                    PEA        $6657                
                    PHX                             
                    PEA        $6776                
                    TSC                             ; Line 25
                    ADC        #$00AA               
                    TCS                             
                    LDA        $A1,S                
                    AND        #$0F00               
                    ORA        #$5057               
                    STA        $A1,S                
                    PEA        $7767                
                    PEA        $6733                
                    PEA        $7677                
                    PEA        $5575                
                    PEA        $7766                
                    TSC                             ; Line 26
                    ADC        #$00AA               
                    TCS                             
                    TDC                             
                    STA        $98,S                
                    LDA        $9A,S                
                    AND        #$00F0               
                    ORA        #$7505               
                    STA        $9A,S                
                    SEP        #$20                 
                    LDA        #$66                 
                    STA        $97,S                
                    REP        #$30                 
                    PEA        $7777                
                    PEA        $7663                
                    PEA        $6757                
                    PHX                             
                    PEA        $6776                
                    TSC                             ; Line 27
                    ADC        #$00AB               
                    TCS                             
                    LDA        #$5767               
                    STA        $97,S                
                    LDA        $95,S                
                    AND        #$00F0               
                    ORA        #$4604               
                    STA        $95,S                
                    LDA        $99,S                
                    AND        #$00F0               
                    ORA        #$5707               
                    STA        $99,S                
                    PHY                             
                    PEA        $7767                
                    PEA        $7376                
                    TSC                             ; Line 28
                    ADC        #$00A6               
                    TCS                             
                    SEP        #$20                 
                    LDA        $94,S                
                    AND        #$F0                 
                    ORA        #$04                 
                    STA        $94,S                
                    LDA        $99,S                
                    AND        #$F0                 
                    ORA        #$05                 
                    STA        $99,S                
                    LDA        $A0,S                
                    AND        #$0F                 
                    ORA        #$70                 
                    STA        $A0,S                
                    REP        #$30                 
                    PHX                             
                    PEA        $7736                
                    PEA        $6377                
                    TSC                             ; Line 29
                    ADC        #$009E               
                    TCS                             
                    LDA        #$4444               
                    STA        $9F,S                
                    SEP        #$20                 
                    LDA        $9E,S                
                    AND        #$F0                 
                    ORA        #$04                 
                    STA        $9E,S                
                    REP        #$30                 
                    PHD                             
                    PEA        $4644                
                    TSC                             
                    ADC        #$000B               
                    TCS                             
                    PHY                             
                    PEA        $3777                
                    PEA        $7775                
                    TSC                             ; Line 30
                    ADC        #$00A6               
                    TCS                             
                    LDA        #$4444               
                    STA        $98,S                
                    TYA                             
                    STA        $9D,S                
                    LDA        $96,S                
                    AND        #$00F0               
                    ORA        #$4404               
                    STA        $96,S                
                    LDA        $9B,S                
                    AND        #$00F0               
                    ORA        #$7505               
                    STA        $9B,S                
                    LDA        $9F,S                
                    AND        #$0F00               
                    ORA        #$3073               
                    STA        $9F,S                
                    PEA        $5737                
                    PEA        $7377                
                    PHX                             
                    TSC                             ; Line 32
                    ADC        #$013A               
                    TCS                             
                    TXA                             
                    STA        $0A,S                
                    LDA        $08,S                
                    AND        #$00F0               
                    ORA        #$5707               
                    STA        $08,S                
                    TSC                             ; Line 64
                    ADC        #$1400               
                    TCS                             
                    LDA        $08,S                
                    AND        #$0F0F               
                    ORA        #$5050               
                    STA        $08,S                
                    LDA        $0A,S                
                    AND        #$0F0F               
                    ORA        #$5050               
                    STA        $0A,S                
                    LDA        $A0,S                
                    AND        #$F0F0               
                    ORA        #$0505               
                    STA        $A0,S                
                    LDA        $A2,S                
                    AND        #$F0F0               
                    ORA        #$0505               
                    STA        $A2,S                
                    LDA        $A4,S                
                    AND        #$F0F0               
                    ORA        #$0505               
                    STA        $A4,S                
                    LDA        $A6,S                
                    AND        #$F0F0               
                    ORA        #$0505               
                    STA        $A6,S                
                    LDA        $A8,S                
                    AND        #$F0F0               
                    ORA        #$0505               
                    STA        $A8,S                
                    LDA        $AA,S                
                    AND        #$F0F0               
                    ORA        #$0505               
                    STA        $AA,S                
                    LDA        $AC,S                
                    AND        #$F0F0               
                    ORA        #$0505               
                    STA        $AC,S                
                    LDA        $AE,S                
                    AND        #$F0F0               
                    ORA        #$0505               
                    STA        $AE,S                
                    SEP        #$20                 
                    LDA        $0C,S                
                    AND        #$0F                 
                    ORA        #$50                 
                    STA        $0C,S                
                    REP        #$30                 
                    TSC                             ; Line 66
                    ADC        #$0140               
                    TCS                             
                    LDA        $00,S                
                    AND        #$0F0F               
                    ORA        #$5050               
                    STA        $00,S                
                    LDA        $02,S                
                    AND        #$0F0F               
                    ORA        #$5050               
                    STA        $02,S                
                    LDA        $04,S                
                    AND        #$0F0F               
                    ORA        #$5050               
                    STA        $04,S                
                    LDA        $06,S                
                    AND        #$0F0F               
                    ORA        #$5050               
                    STA        $06,S                
                    LDA        $08,S                
                    AND        #$0F0F               
                    ORA        #$5050               
                    STA        $08,S                
                    LDA        $0A,S                
                    AND        #$0F0F               
                    ORA        #$5050               
                    STA        $0A,S                
                    LDA        $0C,S                
                    AND        #$0F0F               
                    ORA        #$5050               
                    STA        $0C,S                
                    LDA        $A2,S                
                    AND        #$F0F0               
                    ORA        #$0505               
                    STA        $A2,S                
                    LDA        $A4,S                
                    AND        #$F0F0               
                    ORA        #$0505               
                    STA        $A4,S                
                    LDA        $A6,S                
                    AND        #$F0F0               
                    ORA        #$0505               
                    STA        $A6,S                
                    LDA        $A8,S                
                    AND        #$F0F0               
                    ORA        #$0505               
                    STA        $A8,S                
                    LDA        $AA,S                
                    AND        #$F0F0               
                    ORA        #$0505               
                    STA        $AA,S                
                    SEP        #$20                 
                    LDA        $0E,S                
                    AND        #$0F                 
                    ORA        #$50                 
                    STA        $0E,S                
                    REP        #$30                 
*--                                                 
                    LDAL       $E1C068              ; Direct Page and Stack in Bank 00/
                    AND        #$FFCF               
                    STAL       $E1C068              
                    LDA        StackAddress         ; Restore Stack
                    TCS                             
                    PLD                             ; Restore Direct Page
                    CLI                             ; Enable Interrupts
                    PLB
                    RTL                             
                                                    
*-----------------------------------                                
Sprite_BL_036       CLC                             ; Sprite #036 : 32x59, 1125 bytes, 1832 cycles
                    SEI                             ; Disable Interrupts
                    PHD                             ; Backup Direct Page
                    TSC                             ; Backup Stack
                    STA        StackAddress         
                    LDAL       $E1C068              ; Direct Page and Stack in Bank 01/
                    ORA        #$0030               
                    STAL       $E1C068              
                    TYA                             ; Y = Sprite Target Screen Address (upper left corner)
                    TCS                             ; New Stack address
                    LDX        #$5757               ; Pattern #1 : 19
                    LDY        #$7575               ; Pattern #2 : 13
                    LDA        #$7577               ; Pattern #3 : 11
                    TCD                             
*--                                                 
                    LDA        #$5555               ; Line 0
                    STA        $0A,S                
                    SEP        #$20                 
                    LDA        $0C,S                
                    AND        #$0F                 
                    ORA        #$50                 
                    STA        $0C,S                
                    REP        #$30                 
                    TSC                             ; Line 1
                    ADC        #$00AC               
                    TCS                             
                    PEA        $5555                
                    PEA        $5555                
                    TSC                             ; Line 2
                    ADC        #$00A4               
                    TCS                             
                    SEP        #$20                 
                    LDA        $9C,S                
                    AND        #$F0                 
                    ORA        #$05                 
                    STA        $9C,S                
                    REP        #$30                 
                    PEA        $5355                
                    PEA        $5555                
                    TSC                             ; Line 3
                    ADC        #$00A4               
                    TCS                             
                    LDA        #$3333               
                    STA        $9E,S                
                    LDA        $9C,S                
                    AND        #$00F0               
                    ORA        #$3303               
                    STA        $9C,S                
                    LDA        $A0,S                
                    AND        #$0F00               
                    ORA        #$5055               
                    STA        $A0,S                
                    PEA        $3333                
                    PEA        $5355                
                    TSC                             ; Line 5
                    ADC        #$0138               
                    TCS                             
                    LDA        #$5545               
                    STA        $0A,S                
                    LDA        $08,S                
                    AND        #$00F0               
                    ORA        #$3303               
                    STA        $08,S                
                    LDA        $0C,S                
                    AND        #$0F00               
                    ORA        #$5055               
                    STA        $0C,S                
                    SEP        #$20                 
                    LDA        $AD,S                
                    AND        #$0F                 
                    ORA        #$50                 
                    STA        $AD,S                
                    REP        #$30                 
                    TSC                             ; Line 6
                    ADC        #$00AC               
                    TCS                             
                    SEP        #$20                 
                    LDA        $A1,S                
                    AND        #$0F                 
                    ORA        #$50                 
                    STA        $A1,S                
                    REP        #$30                 
                    PEA        $5555                
                    PEA        $4444                
                    TSC                             ; Line 7
                    ADC        #$00A4               
                    TCS                             
                    PEA        $5554                
                    PEA        $4445                
                    TSC                             ; Line 8
                    ADC        #$00A4               
                    TCS                             
                    LDA        #$4444               
                    STA        $9D,S                
                    LDA        $9F,S                
                    AND        #$0F00               
                    ORA        #$4044               
                    STA        $9F,S                
                    PEA        $5544                
                    PEA        $4444                
                    TSC                             ; Line 10
                    ADC        #$0138               
                    TCS                             
                    LDA        #$4444               
                    STA        $0A,S                
                    LDA        $0C,S                
                    AND        #$0F00               
                    ORA        #$5044               
                    STA        $0C,S                
                    SEP        #$20                 
                    LDA        $09,S                
                    AND        #$F0                 
                    ORA        #$04                 
                    STA        $09,S                
                    LDA        $A9,S                
                    AND        #$F0                 
                    ORA        #$04                 
                    STA        $A9,S                
                    REP        #$30                 
                    TSC                             ; Line 11
                    ADC        #$00AD               
                    TCS                             
                    LDA        #$7677               
                    STA        $98,S                
                    LDA        #$6766               
                    STA        $9E,S                
                    LDA        $96,S                
                    AND        #$00F0               
                    ORA        #$4704               
                    STA        $96,S                
                    LDA        $9A,S                
                    AND        #$0F00               
                    ORA        #$6066               
                    STA        $9A,S                
                    SEP        #$20                 
                    LDA        #$57                 
                    STA        $A0,S                
                    REP        #$30                 
                    PEA        $7547                
                    PEA        $4444                
                    TSC                             ; Line 13
                    ADC        #$0137               
                    TCS                             
                    LDA        $03,S                
                    AND        #$00F0               
                    ORA        #$6104               
                    STA        $03,S                
                    LDA        $0D,S                
                    AND        #$0F00               
                    ORA        #$7075               
                    STA        $0D,S                
                    LDA        $AD,S                
                    AND        #$0F00               
                    ORA        #$5067               
                    STA        $AD,S                
                    TSC                             
                    ADC        #$000C               
                    TCS                             
                    PEA        $5575                
                    PEA        $7666                
                    PEA        $7677                
                    PEA        $6761                
                    TSC                             ; Line 14
                    ADC        #$00A8               
                    TCS                             
                    LDA        $A1,S                
                    AND        #$0F00               
                    ORA        #$7077               
                    STA        $A1,S                
                    PEA        $7757                
                    PHD                             
                    PEA        $7565                
                    PEA        $7667                
                    PEA        $1677                
                    TSC                             ; Line 15
                    ADC        #$00AA               
                    TCS                             
                    PEA        $7676                
                    PHX                             
                    PEA        $5767                
                    PEA        $7777                
                    PEA        $6674                
                    TSC                             ; Line 16
                    ADC        #$00AC               
                    TCS                             
                    PEA        $5777                
                    PEA        $6767                
                    PEA        $7775                
                    PEA        $7576                
                    PEA        $6766                
                    PEA        $4444                
                    TSC                             ; Line 17
                    ADC        #$00AC               
                    TCS                             
                    LDA        #$6666               
                    PHD                             
                    PEA        $7676                
                    PHA                             
                    PHA                             
                    PHA                             
                    PEA        $4444                
                    TSC                             ; Line 18
                    ADC        #$00AC               
                    TCS                             
                    PEA        $5777                
                    PEA        $7767                
                    PEA        $6767                
                    PEA        $6766                
                    PEA        $6667                
                    PEA        $4474                
                    TSC                             ; Line 19
                    ADC        #$00AC               
                    TCS                             
                    PHD                             
                    PEA        $7775                
                    PEA        $7576                
                    PEA        $7676                
                    PEA        $7676                
                    PEA        $7766                
                    TSC                             ; Line 20
                    ADC        #$00AC               
                    TCS                             
                    PEA        $5777                
                    PEA        $7757                
                    PHX                             
                    PHX                             
                    PHX                             
                    PEA        $6776                
                    TSC                             ; Line 21
                    ADC        #$00AC               
                    TCS                             
                    PHY                             
                    PEA        $7775                
                    PHY                             
                    PHY                             
                    PHY                             
                    PEA        $7766                
                    TSC                             ; Line 22
                    ADC        #$00AC               
                    TCS                             
                    PEA        $5777                
                    PEA        $7757                
                    PHX                             
                    PEA        $5756                
                    PHX                             
                    PEA        $6776                
                    TSC                             ; Line 23
                    ADC        #$00AC               
                    TCS                             
                    LDA        $9F,S                
                    AND        #$0F00               
                    ORA        #$5077               
                    STA        $9F,S                
                    PHY                             
                    PEA        $7767                
                    PEA        $6676                
                    PEA        $6676                
                    PEA        $5575                
                    PEA        $7766                
                    TSC                             ; Line 24
                    ADC        #$00AA               
                    TCS                             
                    LDA        $A1,S                
                    AND        #$0F00               
                    ORA        #$7075               
                    STA        $A1,S                
                    PEA        $7777                
                    PEA        $7636                
                    PEA        $6657                
                    PHX                             
                    PEA        $6776                
                    TSC                             ; Line 25
                    ADC        #$00AA               
                    TCS                             
                    LDA        $A1,S                
                    AND        #$0F00               
                    ORA        #$5057               
                    STA        $A1,S                
                    PEA        $7767                
                    PEA        $6733                
                    PEA        $7677                
                    PEA        $5575                
                    PEA        $7766                
                    TSC                             ; Line 26
                    ADC        #$00AA               
                    TCS                             
                    TDC                             
                    STA        $98,S                
                    LDA        $9A,S                
                    AND        #$00F0               
                    ORA        #$7505               
                    STA        $9A,S                
                    SEP        #$20                 
                    LDA        #$66                 
                    STA        $97,S                
                    REP        #$30                 
                    PEA        $7777                
                    PEA        $7663                
                    PEA        $6757                
                    PHX                             
                    PEA        $6776                
                    TSC                             ; Line 27
                    ADC        #$00AB               
                    TCS                             
                    LDA        #$5767               
                    STA        $97,S                
                    LDA        $95,S                
                    AND        #$00F0               
                    ORA        #$4604               
                    STA        $95,S                
                    LDA        $99,S                
                    AND        #$00F0               
                    ORA        #$5707               
                    STA        $99,S                
                    PHY                             
                    PEA        $7767                
                    PEA        $7376                
                    TSC                             ; Line 28
                    ADC        #$00A6               
                    TCS                             
                    SEP        #$20                 
                    LDA        $94,S                
                    AND        #$F0                 
                    ORA        #$04                 
                    STA        $94,S                
                    LDA        $99,S                
                    AND        #$F0                 
                    ORA        #$05                 
                    STA        $99,S                
                    LDA        $A0,S                
                    AND        #$0F                 
                    ORA        #$70                 
                    STA        $A0,S                
                    REP        #$30                 
                    PHX                             
                    PEA        $7736                
                    PEA        $6377                
                    TSC                             ; Line 29
                    ADC        #$009E               
                    TCS                             
                    LDA        #$4444               
                    STA        $9F,S                
                    SEP        #$20                 
                    LDA        $9E,S                
                    AND        #$F0                 
                    ORA        #$04                 
                    STA        $9E,S                
                    REP        #$30                 
                    PHD                             
                    PEA        $4644                
                    TSC                             
                    ADC        #$000B               
                    TCS                             
                    PHY                             
                    PEA        $3777                
                    PEA        $7775                
                    TSC                             ; Line 30
                    ADC        #$00A6               
                    TCS                             
                    LDA        #$4444               
                    STA        $98,S                
                    TYA                             
                    STA        $9D,S                
                    LDA        $96,S                
                    AND        #$00F0               
                    ORA        #$4404               
                    STA        $96,S                
                    LDA        $9B,S                
                    AND        #$00F0               
                    ORA        #$7505               
                    STA        $9B,S                
                    LDA        $9F,S                
                    AND        #$0F00               
                    ORA        #$3073               
                    STA        $9F,S                
                    PEA        $5737                
                    PEA        $7377                
                    PHX                             
                    TSC                             ; Line 32
                    ADC        #$013A               
                    TCS                             
                    TXA                             
                    STA        $0A,S                
                    LDA        $08,S                
                    AND        #$00F0               
                    ORA        #$5707               
                    STA        $08,S                
                    TSC                             ; Line 55
                    ADC        #$0E60               
                    TCS                             
                    LDA        $08,S                
                    AND        #$0F0F               
                    ORA        #$5050               
                    STA        $08,S                
                    LDA        $0A,S                
                    AND        #$0F0F               
                    ORA        #$5050               
                    STA        $0A,S                
                    LDA        $A0,S                
                    AND        #$F0F0               
                    ORA        #$0505               
                    STA        $A0,S                
                    LDA        $A2,S                
                    AND        #$F0F0               
                    ORA        #$0505               
                    STA        $A2,S                
                    LDA        $A4,S                
                    AND        #$F0F0               
                    ORA        #$0505               
                    STA        $A4,S                
                    LDA        $A6,S                
                    AND        #$F0F0               
                    ORA        #$0505               
                    STA        $A6,S                
                    LDA        $A8,S                
                    AND        #$F0F0               
                    ORA        #$0505               
                    STA        $A8,S                
                    LDA        $AA,S                
                    AND        #$F0F0               
                    ORA        #$0505               
                    STA        $AA,S                
                    LDA        $AC,S                
                    AND        #$F0F0               
                    ORA        #$0505               
                    STA        $AC,S                
                    LDA        $AE,S                
                    AND        #$F0F0               
                    ORA        #$0505               
                    STA        $AE,S                
                    SEP        #$20                 
                    LDA        $0C,S                
                    AND        #$0F                 
                    ORA        #$50                 
                    STA        $0C,S                
                    REP        #$30                 
                    TSC                             ; Line 57
                    ADC        #$0140               
                    TCS                             
                    LDA        $00,S                
                    AND        #$0F0F               
                    ORA        #$5050               
                    STA        $00,S                
                    LDA        $02,S                
                    AND        #$0F0F               
                    ORA        #$5050               
                    STA        $02,S                
                    LDA        $04,S                
                    AND        #$0F0F               
                    ORA        #$5050               
                    STA        $04,S                
                    LDA        $06,S                
                    AND        #$0F0F               
                    ORA        #$5050               
                    STA        $06,S                
                    LDA        $08,S                
                    AND        #$0F0F               
                    ORA        #$5050               
                    STA        $08,S                
                    LDA        $0A,S                
                    AND        #$0F0F               
                    ORA        #$5050               
                    STA        $0A,S                
                    LDA        $0C,S                
                    AND        #$0F0F               
                    ORA        #$5050               
                    STA        $0C,S                
                    LDA        $A2,S                
                    AND        #$F0F0               
                    ORA        #$0505               
                    STA        $A2,S                
                    LDA        $A4,S                
                    AND        #$F0F0               
                    ORA        #$0505               
                    STA        $A4,S                
                    LDA        $A6,S                
                    AND        #$F0F0               
                    ORA        #$0505               
                    STA        $A6,S                
                    LDA        $A8,S                
                    AND        #$F0F0               
                    ORA        #$0505               
                    STA        $A8,S                
                    LDA        $AA,S                
                    AND        #$F0F0               
                    ORA        #$0505               
                    STA        $AA,S                
                    SEP        #$20                 
                    LDA        $0E,S                
                    AND        #$0F                 
                    ORA        #$50                 
                    STA        $0E,S                
                    REP        #$30                 
*--                                                 
                    LDAL       $E1C068              ; Direct Page and Stack in Bank 00/
                    AND        #$FFCF               
                    STAL       $E1C068              
                    LDA        StackAddress         ; Restore Stack
                    TCS                             
                    PLD                             ; Restore Direct Page
                    CLI                             ; Enable Interrupts
                    PLB
                    RTL                             
                                                    
*-----------------------------------                                
Sprite_BL_037       CLC                             ; Sprite #037 : 32x60, 1467 bytes, 2344 cycles
                    SEI                             ; Disable Interrupts
                    PHD                             ; Backup Direct Page
                    TSC                             ; Backup Stack
                    STA        StackAddress         
                    LDAL       $E1C068              ; Direct Page and Stack in Bank 01/
                    ORA        #$0030               
                    STAL       $E1C068              
                    TYA                             ; Y = Sprite Target Screen Address (upper left corner)
                    TCS                             ; New Stack address
                    LDX        #$7575               ; Pattern #1 : 14
                    LDY        #$7767               ; Pattern #2 : 11
                    LDA        #$5757               ; Pattern #3 : 9
                    TCD                             
*--                                                 
                    LDA        #$5555               ; Line 0
                    STA        $09,S                
                    STA        $A8,S                
                    LDA        $AA,S                
                    AND        #$0F00               
                    ORA        #$5055               
                    STA        $AA,S                
                    TSC                             ; Line 2
                    ADC        #$0140               
                    TCS                             
                    SEP        #$20                 
                    LDA        $07,S                
                    AND        #$F0                 
                    ORA        #$05                 
                    STA        $07,S                
                    LDA        $A7,S                
                    AND        #$F0                 
                    ORA        #$03                 
                    STA        $A7,S                
                    REP        #$30                 
                    TSC                             
                    ADC        #$000B               
                    TCS                             
                    PEA        $5555                
                    PEA        $5555                
                    TSC                             ; Line 3
                    ADC        #$00A4               
                    TCS                             
                    SEP        #$20                 
                    LDA        $9C,S                
                    AND        #$F0                 
                    ORA        #$03                 
                    STA        $9C,S                
                    REP        #$30                 
                    PEA        $3333                
                    PEA        $3333                
                    TSC                             ; Line 4
                    ADC        #$00A4               
                    TCS                             
                    SEP        #$20                 
                    LDA        $9C,S                
                    AND        #$F0                 
                    ORA        #$04                 
                    STA        $9C,S                
                    REP        #$30                 
                    PEA        $3333                
                    PEA        $3333                
                    TSC                             ; Line 5
                    ADC        #$00A4               
                    TCS                             
                    SEP        #$20                 
                    LDA        $9C,S                
                    AND        #$F0                 
                    ORA        #$04                 
                    STA        $9C,S                
                    REP        #$30                 
                    PEA        $5555                
                    PEA        $4544                
                    TSC                             ; Line 6
                    ADC        #$00A4               
                    TCS                             
                    SEP        #$20                 
                    LDA        #$55                 
                    STA        $A0,S                
                    REP        #$30                 
                    PEA        $5555                
                    PEA        $4555                
                    TSC                             ; Line 7
                    ADC        #$00A3               
                    TCS                             
                    SEP        #$20                 
                    LDA        $A1,S                
                    AND        #$0F                 
                    ORA        #$50                 
                    STA        $A1,S                
                    REP        #$30                 
                    PEA        $4545                
                    PEA        $4444                
                    TSC                             ; Line 8
                    ADC        #$00A4               
                    TCS                             
                    LDA        #$4444               
                    STA        $9E,S                
                    LDA        $A0,S                
                    AND        #$0F00               
                    ORA        #$5045               
                    STA        $A0,S                
                    SEP        #$20                 
                    LDA        $9D,S                
                    AND        #$F0                 
                    ORA        #$04                 
                    STA        $9D,S                
                    REP        #$30                 
                    PEA        $4544                
                    PEA        $4444                
                    TSC                             ; Line 10
                    ADC        #$013A               
                    TCS                             
                    LDA        #$4444               
                    STA        $09,S                
                    LDA        $07,S                
                    AND        #$00F0               
                    ORA        #$4404               
                    STA        $07,S                
                    LDA        $A8,S                
                    AND        #$00F0               
                    ORA        #$4404               
                    STA        $A8,S                
                    LDA        $AA,S                
                    AND        #$0F00               
                    ORA        #$6044               
                    STA        $AA,S                
                    TSC                             ; Line 12
                    ADC        #$0140               
                    TCS                             
                    SEP        #$20                 
                    LDA        $07,S                
                    AND        #$F0                 
                    ORA        #$07                 
                    STA        $07,S                
                    REP        #$30                 
                    TSC                             
                    ADC        #$000B               
                    TCS                             
                    PEA        $1646                
                    PEA        $4467                
                    TSC                             ; Line 13
                    ADC        #$00A5               
                    TCS                             
                    LDA        $9A,S                
                    AND        #$00F0               
                    ORA        #$1707               
                    STA        $9A,S                
                    LDA        $A0,S                
                    AND        #$0F00               
                    ORA        #$7067               
                    STA        $A0,S                
                    PEA        $5667                
                    PEA        $6144                
                    PEA        $7576                
                    TSC                             ; Line 14
                    ADC        #$00A5               
                    TCS                             
                    LDA        $9B,S                
                    AND        #$00F0               
                    ORA        #$7501               
                    STA        $9B,S                
                    SEP        #$20                 
                    LDA        $95,S                
                    AND        #$F0                 
                    ORA        #$04                 
                    STA        $95,S                
                    REP        #$30                 
                    PEA        $7516                
                    PEA        $4654                
                    TSC                             ; Line 15
                    ADC        #$00A6               
                    TCS                             
                    LDA        $93,S                
                    AND        #$0F00               
                    ORA        #$4044               
                    STA        $93,S                
                    PEA        $5777                
                    PEA        $5667                
                    PEA        $6174                
                    TSC                             ; Line 16
                    ADC        #$00A6               
                    TCS                             
                    LDA        #$4444               
                    STA        $93,S                
                    LDA        $98,S                
                    AND        #$00F0               
                    ORA        #$6706               
                    STA        $98,S                
                    LDA        $A0,S                
                    AND        #$0F00               
                    ORA        #$5057               
                    STA        $A0,S                
                    SEP        #$20                 
                    LDA        $95,S                
                    AND        #$0F                 
                    ORA        #$10                 
                    STA        $95,S                
                    REP        #$30                 
                    PEA        $7577                
                    PEA        $6775                
                    PEA        $1646                
                    PEA        $5717                
                    TSC                             ; Line 17
                    ADC        #$00A7               
                    TCS                             
                    LDA        #$6144               
                    STA        $95,S                
                    SEP        #$20                 
                    LDA        $94,S                
                    AND        #$F0                 
                    ORA        #$04                 
                    STA        $94,S                
                    REP        #$30                 
                    PEA        $7677                
                    PEA        $5667                
                    PEA        $6154                
                    TSC                             ; Line 18
                    ADC        #$00A8               
                    TCS                             
                    LDA        #$6677               
                    STA        $93,S                
                    SEP        #$20                 
                    LDA        $95,S                
                    AND        #$0F                 
                    ORA        #$10                 
                    STA        $95,S                
                    REP        #$30                 
                    PHX                             
                    PEA        $6777                
                    PEA        $6775                
                    PEA        $1646                
                    PEA        $7566                
                    TSC                             ; Line 19
                    ADC        #$00AA               
                    TCS                             
                    SEP        #$20                 
                    LDA        $A1,S                
                    AND        #$0F                 
                    ORA        #$70                 
                    STA        $A1,S                
                    REP        #$30                 
                    PEA        $5777                
                    PEA        $7675                
                    PEA        $7756                
                    PEA        $7756                
                    PEA        $7567                
                    TSC                             ; Line 20
                    ADC        #$00AA               
                    TCS                             
                    SEP        #$20                 
                    LDA        $93,S                
                    AND        #$F0                 
                    ORA        #$05                 
                    STA        $93,S                
                    REP        #$30                 
                    PEA        $7567                
                    PEA        $6757                
                    PHY                             
                    PEA        $6571                
                    PEA        $5676                
                    PEA        $7666                
                    PEA        $7657                
                    TSC                             ; Line 21
                    ADC        #$00AF               
                    TCS                             
                    PEA        $5777                
                    PEA        $7676                
                    PHX                             
                    PEA        $7756                
                    PEA        $7777                
                    PEA        $6567                
                    PEA        $6777                
                    TSC                             ; Line 22
                    ADC        #$00AE               
                    TCS                             
                    LDA        $93,S                
                    AND        #$00F0               
                    ORA        #$7705               
                    STA        $93,S                
                    PHX                             
                    PEA        $6657                
                    PHD                             
                    PHY                             
                    PEA        $7555                
                    PEA        $5776                
                    PEA        $7657                
                    TSC                             ; Line 23
                    ADC        #$00AE               
                    TCS                             
                    SEP        #$20                 
                    LDA        $A0,S                
                    AND        #$0F                 
                    ORA        #$70                 
                    STA        $A0,S                
                    REP        #$30                 
                    PEA        $5767                
                    PEA        $6776                
                    PHX                             
                    PEA        $7577                
                    PEA        $7676                
                    PEA        $7577                
                    TSC                             ; Line 24
                    ADC        #$00AB               
                    TCS                             
                    LDA        $98,S                
                    AND        #$00F0               
                    ORA        #$7707               
                    STA        $98,S                
                    LDA        $A0,S                
                    AND        #$0F00               
                    ORA        #$5057               
                    STA        $A0,S                
                    PEA        $7517                
                    PEA        $1616                
                    PEA        $4654                
                    PHY                             
                    PHD                             
                    PHD                             
                    TSC                             ; Line 25
                    ADC        #$00AB               
                    TCS                             
                    SEP        #$20                 
                    LDA        #$75                 
                    STA        $A0,S                
                    REP        #$30                 
                    PEA        $5767                
                    PEA        $6747                
                    PEA        $4474                
                    TSC                             ; Line 26
                    ADC        #$00A5               
                    TCS                             
                    LDA        $99,S                
                    AND        #$0F00               
                    ORA        #$6061               
                    STA        $99,S                
                    SEP        #$20                 
                    LDA        $98,S                
                    AND        #$F0                 
                    ORA        #$01                 
                    STA        $98,S                
                    REP        #$30                 
                    PHX                             
                    PEA        $4544                
                    PEA        $7467                
                    TSC                             ; Line 27
                    ADC        #$00A6               
                    TCS                             
                    SEP        #$20                 
                    LDA        #$33                 
                    STA        $A0,S                
                    REP        #$30                 
                    PEA        $7777                
                    PEA        $7777                
                    PEA        $7736                
                    TSC                             ; Line 28
                    ADC        #$00A5               
                    TCS                             
                    LDA        $98,S                
                    AND        #$00F0               
                    ORA        #$6701               
                    STA        $98,S                
                    PEA        $7377                
                    PEA        $3333                
                    PEA        $6366                
                    PEA        $1616                
                    TSC                             ; Line 29
                    ADC        #$00A9               
                    TCS                             
                    PEA        $7576                
                    PEA        $7675                
                    PEA        $3776                
                    PEA        $7667                
                    TSC                             ; Line 30
                    ADC        #$00A8               
                    TCS                             
                    LDA        $96,S                
                    AND        #$00F0               
                    ORA        #$6701               
                    STA        $96,S                
                    LDA        $A0,S                
                    AND        #$0F00               
                    ORA        #$7075               
                    STA        $A0,S                
                    PEA        $5767                
                    PEA        $6761                
                    PEA        $7663                
                    PEA        $5777                
                    PEA        $7666                
                    TSC                             ; Line 31
                    ADC        #$00A9               
                    TCS                             
                    LDA        $97,S                
                    AND        #$00F0               
                    ORA        #$7606               
                    STA        $97,S                
                    LDA        $A1,S                
                    AND        #$0F00               
                    ORA        #$5057               
                    STA        $A1,S                
                    PEA        $7517                
                    PEA        $1666                
                    PEA        $7375                
                    PEA        $7567                
                    TSC                             ; Line 32
                    ADC        #$00A8               
                    TCS                             
                    TYA                             
                    STA        $98,S                
                    LDA        $9A,S                
                    AND        #$00F0               
                    ORA        #$7505               
                    STA        $9A,S                
                    SEP        #$20                 
                    LDA        #$67                 
                    STA        $97,S                
                    LDA        $A2,S                
                    AND        #$0F                 
                    ORA        #$70                 
                    STA        $A2,S                
                    REP        #$30                 
                    PHY                             
                    PEA        $6767                
                    PEA        $5657                
                    PEA        $5777                
                    TSC                             ; Line 33
                    ADC        #$00A9               
                    TCS                             
                    LDA        $95,S                
                    AND        #$00F0               
                    ORA        #$7606               
                    STA        $95,S                
                    LDA        $97,S                
                    AND        #$0F00               
                    ORA        #$7077               
                    STA        $97,S                
                    SEP        #$20                 
                    LDA        #$56                 
                    STA        $9A,S                
                    REP        #$30                 
                    PHX                             
                    PEA        $7576                
                    PEA        $7616                
                    TSC                             ; Line 34
                    ADC        #$00A6               
                    TCS                             
                    TYA                             
                    STA        $96,S                
                    LDA        $94,S                
                    AND        #$F000               
                    ORA        #$0644               
                    STA        $94,S                
                    SEP        #$20                 
                    LDA        #$16                 
                    STA        $9A,S                
                    REP        #$30                 
                    PHD                             
                    PEA        $5777                
                    PEA        $6767                
                    TSC                             ; Line 35
                    ADC        #$00A6               
                    TCS                             
                    LDA        #$4444               
                    STA        $94,S                
                    LDA        $96,S                
                    AND        #$0F00               
                    ORA        #$7077               
                    STA        $96,S                
                    LDA        $99,S                
                    AND        #$00F0               
                    ORA        #$6701               
                    STA        $99,S                
                    LDA        $9F,S                
                    AND        #$0F00               
                    ORA        #$5057               
                    STA        $9F,S                
                    PHX                             
                    PHX                             
                    PEA        $7776                
                    TSC                             ; Line 36
                    ADC        #$00A4               
                    TCS                             
                    LDA        #$4744               
                    STA        $97,S                
                    SEP        #$20                 
                    LDA        $96,S                
                    AND        #$F0                 
                    ORA        #$04                 
                    STA        $96,S                
                    LDA        $A1,S                
                    AND        #$0F                 
                    ORA        #$70                 
                    STA        $A1,S                
                    REP        #$30                 
                    PHD                             
                    PHY                             
                    TSC                             ; Line 37
                    ADC        #$00A4               
                    TCS                             
                    TYA                             
                    STA        $9C,S                
                    LDA        $9A,S                
                    AND        #$00F0               
                    ORA        #$6706               
                    STA        $9A,S                
                    SEP        #$20                 
                    LDA        #$44                 
                    STA        $97,S                
                    REP        #$30                 
                    PHX                             
                    PEA        $7577                
                    PEA        $7666                
                    TSC                             ; Line 39
                    ADC        #$013C               
                    TCS                             
                    LDA        #$7644               
                    STA        $04,S                
                    LDA        #$7747               
                    STA        $A5,S                
                    LDA        $06,S                
                    AND        #$0F00               
                    ORA        #$7077               
                    STA        $06,S                
                    LDA        $A3,S                
                    AND        #$00F0               
                    ORA        #$4404               
                    STA        $A3,S                
                    TSC                             ; Line 41
                    ADC        #$0140               
                    TCS                             
                    LDA        $03,S                
                    AND        #$00F0               
                    ORA        #$4404               
                    STA        $03,S                
                    SEP        #$20                 
                    LDA        #$44                 
                    STA        $A4,S                
                    LDA        $05,S                
                    AND        #$0F                 
                    ORA        #$40                 
                    STA        $05,S                
                    REP        #$30                 
                    TSC                             ; Line 56
                    ADC        #$0960               
                    TCS                             
                    LDA        $08,S                
                    AND        #$0F0F               
                    ORA        #$5050               
                    STA        $08,S                
                    LDA        $0A,S                
                    AND        #$0F0F               
                    ORA        #$5050               
                    STA        $0A,S                
                    LDA        $A0,S                
                    AND        #$F0F0               
                    ORA        #$0505               
                    STA        $A0,S                
                    LDA        $A2,S                
                    AND        #$F0F0               
                    ORA        #$0505               
                    STA        $A2,S                
                    LDA        $A4,S                
                    AND        #$F0F0               
                    ORA        #$0505               
                    STA        $A4,S                
                    LDA        $A6,S                
                    AND        #$F0F0               
                    ORA        #$0505               
                    STA        $A6,S                
                    LDA        $A8,S                
                    AND        #$F0F0               
                    ORA        #$0505               
                    STA        $A8,S                
                    LDA        $AA,S                
                    AND        #$F0F0               
                    ORA        #$0505               
                    STA        $AA,S                
                    LDA        $AC,S                
                    AND        #$F0F0               
                    ORA        #$0505               
                    STA        $AC,S                
                    LDA        $AE,S                
                    AND        #$F0F0               
                    ORA        #$0505               
                    STA        $AE,S                
                    SEP        #$20                 
                    LDA        $0C,S                
                    AND        #$0F                 
                    ORA        #$50                 
                    STA        $0C,S                
                    REP        #$30                 
                    TSC                             ; Line 58
                    ADC        #$0140               
                    TCS                             
                    LDA        $00,S                
                    AND        #$0F0F               
                    ORA        #$5050               
                    STA        $00,S                
                    LDA        $02,S                
                    AND        #$0F0F               
                    ORA        #$5050               
                    STA        $02,S                
                    LDA        $04,S                
                    AND        #$0F0F               
                    ORA        #$5050               
                    STA        $04,S                
                    LDA        $06,S                
                    AND        #$0F0F               
                    ORA        #$5050               
                    STA        $06,S                
                    LDA        $08,S                
                    AND        #$0F0F               
                    ORA        #$5050               
                    STA        $08,S                
                    LDA        $0A,S                
                    AND        #$0F0F               
                    ORA        #$5050               
                    STA        $0A,S                
                    LDA        $0C,S                
                    AND        #$0F0F               
                    ORA        #$5050               
                    STA        $0C,S                
                    LDA        $A2,S                
                    AND        #$F0F0               
                    ORA        #$0505               
                    STA        $A2,S                
                    LDA        $A4,S                
                    AND        #$F0F0               
                    ORA        #$0505               
                    STA        $A4,S                
                    LDA        $A6,S                
                    AND        #$F0F0               
                    ORA        #$0505               
                    STA        $A6,S                
                    LDA        $A8,S                
                    AND        #$F0F0               
                    ORA        #$0505               
                    STA        $A8,S                
                    LDA        $AA,S                
                    AND        #$F0F0               
                    ORA        #$0505               
                    STA        $AA,S                
                    SEP        #$20                 
                    LDA        $0E,S                
                    AND        #$0F                 
                    ORA        #$50                 
                    STA        $0E,S                
                    REP        #$30                 
*--                                                 
                    LDAL       $E1C068              ; Direct Page and Stack in Bank 00/
                    AND        #$FFCF               
                    STAL       $E1C068              
                    LDA        StackAddress         ; Restore Stack
                    TCS                             
                    PLD                             ; Restore Direct Page
                    CLI                             ; Enable Interrupts
                    PLB
                    RTL                             
                                                    
*-----------------------------------                                
Sprite_BL_038       CLC                             ; Sprite #038 : 32x70, 1467 bytes, 2344 cycles
                    SEI                             ; Disable Interrupts
                    PHD                             ; Backup Direct Page
                    TSC                             ; Backup Stack
                    STA        StackAddress         
                    LDAL       $E1C068              ; Direct Page and Stack in Bank 01/
                    ORA        #$0030               
                    STAL       $E1C068              
                    TYA                             ; Y = Sprite Target Screen Address (upper left corner)
                    TCS                             ; New Stack address
                    LDX        #$7575               ; Pattern #1 : 14
                    LDY        #$7767               ; Pattern #2 : 11
                    LDA        #$5757               ; Pattern #3 : 9
                    TCD                             
*--                                                 
                    LDA        #$5555               ; Line 0
                    STA        $09,S                
                    STA        $A8,S                
                    LDA        $AA,S                
                    AND        #$0F00               
                    ORA        #$5055               
                    STA        $AA,S                
                    TSC                             ; Line 2
                    ADC        #$0140               
                    TCS                             
                    SEP        #$20                 
                    LDA        $07,S                
                    AND        #$F0                 
                    ORA        #$05                 
                    STA        $07,S                
                    LDA        $A7,S                
                    AND        #$F0                 
                    ORA        #$03                 
                    STA        $A7,S                
                    REP        #$30                 
                    TSC                             
                    ADC        #$000B               
                    TCS                             
                    PEA        $5555                
                    PEA        $5555                
                    TSC                             ; Line 3
                    ADC        #$00A4               
                    TCS                             
                    SEP        #$20                 
                    LDA        $9C,S                
                    AND        #$F0                 
                    ORA        #$03                 
                    STA        $9C,S                
                    REP        #$30                 
                    PEA        $3333                
                    PEA        $3333                
                    TSC                             ; Line 4
                    ADC        #$00A4               
                    TCS                             
                    SEP        #$20                 
                    LDA        $9C,S                
                    AND        #$F0                 
                    ORA        #$04                 
                    STA        $9C,S                
                    REP        #$30                 
                    PEA        $3333                
                    PEA        $3333                
                    TSC                             ; Line 5
                    ADC        #$00A4               
                    TCS                             
                    SEP        #$20                 
                    LDA        $9C,S                
                    AND        #$F0                 
                    ORA        #$04                 
                    STA        $9C,S                
                    REP        #$30                 
                    PEA        $5555                
                    PEA        $4544                
                    TSC                             ; Line 6
                    ADC        #$00A4               
                    TCS                             
                    SEP        #$20                 
                    LDA        #$55                 
                    STA        $A0,S                
                    REP        #$30                 
                    PEA        $5555                
                    PEA        $4555                
                    TSC                             ; Line 7
                    ADC        #$00A3               
                    TCS                             
                    SEP        #$20                 
                    LDA        $A1,S                
                    AND        #$0F                 
                    ORA        #$50                 
                    STA        $A1,S                
                    REP        #$30                 
                    PEA        $4545                
                    PEA        $4444                
                    TSC                             ; Line 8
                    ADC        #$00A4               
                    TCS                             
                    LDA        #$4444               
                    STA        $9E,S                
                    LDA        $A0,S                
                    AND        #$0F00               
                    ORA        #$5045               
                    STA        $A0,S                
                    SEP        #$20                 
                    LDA        $9D,S                
                    AND        #$F0                 
                    ORA        #$04                 
                    STA        $9D,S                
                    REP        #$30                 
                    PEA        $4544                
                    PEA        $4444                
                    TSC                             ; Line 10
                    ADC        #$013A               
                    TCS                             
                    LDA        #$4444               
                    STA        $09,S                
                    LDA        $07,S                
                    AND        #$00F0               
                    ORA        #$4404               
                    STA        $07,S                
                    LDA        $A8,S                
                    AND        #$00F0               
                    ORA        #$4404               
                    STA        $A8,S                
                    LDA        $AA,S                
                    AND        #$0F00               
                    ORA        #$6044               
                    STA        $AA,S                
                    TSC                             ; Line 12
                    ADC        #$0140               
                    TCS                             
                    SEP        #$20                 
                    LDA        $07,S                
                    AND        #$F0                 
                    ORA        #$07                 
                    STA        $07,S                
                    REP        #$30                 
                    TSC                             
                    ADC        #$000B               
                    TCS                             
                    PEA        $1646                
                    PEA        $4467                
                    TSC                             ; Line 13
                    ADC        #$00A5               
                    TCS                             
                    LDA        $9A,S                
                    AND        #$00F0               
                    ORA        #$1707               
                    STA        $9A,S                
                    LDA        $A0,S                
                    AND        #$0F00               
                    ORA        #$7067               
                    STA        $A0,S                
                    PEA        $5667                
                    PEA        $6144                
                    PEA        $7576                
                    TSC                             ; Line 14
                    ADC        #$00A5               
                    TCS                             
                    LDA        $9B,S                
                    AND        #$00F0               
                    ORA        #$7501               
                    STA        $9B,S                
                    SEP        #$20                 
                    LDA        $95,S                
                    AND        #$F0                 
                    ORA        #$04                 
                    STA        $95,S                
                    REP        #$30                 
                    PEA        $7516                
                    PEA        $4654                
                    TSC                             ; Line 15
                    ADC        #$00A6               
                    TCS                             
                    LDA        $93,S                
                    AND        #$0F00               
                    ORA        #$4044               
                    STA        $93,S                
                    PEA        $5777                
                    PEA        $5667                
                    PEA        $6174                
                    TSC                             ; Line 16
                    ADC        #$00A6               
                    TCS                             
                    LDA        #$4444               
                    STA        $93,S                
                    LDA        $98,S                
                    AND        #$00F0               
                    ORA        #$6706               
                    STA        $98,S                
                    LDA        $A0,S                
                    AND        #$0F00               
                    ORA        #$5057               
                    STA        $A0,S                
                    SEP        #$20                 
                    LDA        $95,S                
                    AND        #$0F                 
                    ORA        #$10                 
                    STA        $95,S                
                    REP        #$30                 
                    PEA        $7577                
                    PEA        $6775                
                    PEA        $1646                
                    PEA        $5717                
                    TSC                             ; Line 17
                    ADC        #$00A7               
                    TCS                             
                    LDA        #$6144               
                    STA        $95,S                
                    SEP        #$20                 
                    LDA        $94,S                
                    AND        #$F0                 
                    ORA        #$04                 
                    STA        $94,S                
                    REP        #$30                 
                    PEA        $7677                
                    PEA        $5667                
                    PEA        $6154                
                    TSC                             ; Line 18
                    ADC        #$00A8               
                    TCS                             
                    LDA        #$6677               
                    STA        $93,S                
                    SEP        #$20                 
                    LDA        $95,S                
                    AND        #$0F                 
                    ORA        #$10                 
                    STA        $95,S                
                    REP        #$30                 
                    PHX                             
                    PEA        $6777                
                    PEA        $6775                
                    PEA        $1646                
                    PEA        $7566                
                    TSC                             ; Line 19
                    ADC        #$00AA               
                    TCS                             
                    SEP        #$20                 
                    LDA        $A1,S                
                    AND        #$0F                 
                    ORA        #$70                 
                    STA        $A1,S                
                    REP        #$30                 
                    PEA        $5777                
                    PEA        $7675                
                    PEA        $7756                
                    PEA        $7756                
                    PEA        $7567                
                    TSC                             ; Line 20
                    ADC        #$00AA               
                    TCS                             
                    SEP        #$20                 
                    LDA        $93,S                
                    AND        #$F0                 
                    ORA        #$05                 
                    STA        $93,S                
                    REP        #$30                 
                    PEA        $7567                
                    PEA        $6757                
                    PHY                             
                    PEA        $6571                
                    PEA        $5676                
                    PEA        $7666                
                    PEA        $7657                
                    TSC                             ; Line 21
                    ADC        #$00AF               
                    TCS                             
                    PEA        $5777                
                    PEA        $7676                
                    PHX                             
                    PEA        $7756                
                    PEA        $7777                
                    PEA        $6567                
                    PEA        $6777                
                    TSC                             ; Line 22
                    ADC        #$00AE               
                    TCS                             
                    LDA        $93,S                
                    AND        #$00F0               
                    ORA        #$7705               
                    STA        $93,S                
                    PHX                             
                    PEA        $6657                
                    PHD                             
                    PHY                             
                    PEA        $7555                
                    PEA        $5776                
                    PEA        $7657                
                    TSC                             ; Line 23
                    ADC        #$00AE               
                    TCS                             
                    SEP        #$20                 
                    LDA        $A0,S                
                    AND        #$0F                 
                    ORA        #$70                 
                    STA        $A0,S                
                    REP        #$30                 
                    PEA        $5767                
                    PEA        $6776                
                    PHX                             
                    PEA        $7577                
                    PEA        $7676                
                    PEA        $7577                
                    TSC                             ; Line 24
                    ADC        #$00AB               
                    TCS                             
                    LDA        $98,S                
                    AND        #$00F0               
                    ORA        #$7707               
                    STA        $98,S                
                    LDA        $A0,S                
                    AND        #$0F00               
                    ORA        #$5057               
                    STA        $A0,S                
                    PEA        $7517                
                    PEA        $1616                
                    PEA        $4654                
                    PHY                             
                    PHD                             
                    PHD                             
                    TSC                             ; Line 25
                    ADC        #$00AB               
                    TCS                             
                    SEP        #$20                 
                    LDA        #$75                 
                    STA        $A0,S                
                    REP        #$30                 
                    PEA        $5767                
                    PEA        $6747                
                    PEA        $4474                
                    TSC                             ; Line 26
                    ADC        #$00A5               
                    TCS                             
                    LDA        $99,S                
                    AND        #$0F00               
                    ORA        #$6061               
                    STA        $99,S                
                    SEP        #$20                 
                    LDA        $98,S                
                    AND        #$F0                 
                    ORA        #$01                 
                    STA        $98,S                
                    REP        #$30                 
                    PHX                             
                    PEA        $4544                
                    PEA        $7467                
                    TSC                             ; Line 27
                    ADC        #$00A6               
                    TCS                             
                    SEP        #$20                 
                    LDA        #$33                 
                    STA        $A0,S                
                    REP        #$30                 
                    PEA        $7777                
                    PEA        $7777                
                    PEA        $7736                
                    TSC                             ; Line 28
                    ADC        #$00A5               
                    TCS                             
                    LDA        $98,S                
                    AND        #$00F0               
                    ORA        #$6701               
                    STA        $98,S                
                    PEA        $7377                
                    PEA        $3333                
                    PEA        $6366                
                    PEA        $1616                
                    TSC                             ; Line 29
                    ADC        #$00A9               
                    TCS                             
                    PEA        $7576                
                    PEA        $7675                
                    PEA        $3776                
                    PEA        $7667                
                    TSC                             ; Line 30
                    ADC        #$00A8               
                    TCS                             
                    LDA        $96,S                
                    AND        #$00F0               
                    ORA        #$6701               
                    STA        $96,S                
                    LDA        $A0,S                
                    AND        #$0F00               
                    ORA        #$7075               
                    STA        $A0,S                
                    PEA        $5767                
                    PEA        $6761                
                    PEA        $7663                
                    PEA        $5777                
                    PEA        $7666                
                    TSC                             ; Line 31
                    ADC        #$00A9               
                    TCS                             
                    LDA        $97,S                
                    AND        #$00F0               
                    ORA        #$7606               
                    STA        $97,S                
                    LDA        $A1,S                
                    AND        #$0F00               
                    ORA        #$5057               
                    STA        $A1,S                
                    PEA        $7517                
                    PEA        $1666                
                    PEA        $7375                
                    PEA        $7567                
                    TSC                             ; Line 32
                    ADC        #$00A8               
                    TCS                             
                    TYA                             
                    STA        $98,S                
                    LDA        $9A,S                
                    AND        #$00F0               
                    ORA        #$7505               
                    STA        $9A,S                
                    SEP        #$20                 
                    LDA        #$67                 
                    STA        $97,S                
                    LDA        $A2,S                
                    AND        #$0F                 
                    ORA        #$70                 
                    STA        $A2,S                
                    REP        #$30                 
                    PHY                             
                    PEA        $6767                
                    PEA        $5657                
                    PEA        $5777                
                    TSC                             ; Line 33
                    ADC        #$00A9               
                    TCS                             
                    LDA        $95,S                
                    AND        #$00F0               
                    ORA        #$7606               
                    STA        $95,S                
                    LDA        $97,S                
                    AND        #$0F00               
                    ORA        #$7077               
                    STA        $97,S                
                    SEP        #$20                 
                    LDA        #$56                 
                    STA        $9A,S                
                    REP        #$30                 
                    PHX                             
                    PEA        $7576                
                    PEA        $7616                
                    TSC                             ; Line 34
                    ADC        #$00A6               
                    TCS                             
                    TYA                             
                    STA        $96,S                
                    LDA        $94,S                
                    AND        #$F000               
                    ORA        #$0644               
                    STA        $94,S                
                    SEP        #$20                 
                    LDA        #$16                 
                    STA        $9A,S                
                    REP        #$30                 
                    PHD                             
                    PEA        $5777                
                    PEA        $6767                
                    TSC                             ; Line 35
                    ADC        #$00A6               
                    TCS                             
                    LDA        #$4444               
                    STA        $94,S                
                    LDA        $96,S                
                    AND        #$0F00               
                    ORA        #$7077               
                    STA        $96,S                
                    LDA        $99,S                
                    AND        #$00F0               
                    ORA        #$6701               
                    STA        $99,S                
                    LDA        $9F,S                
                    AND        #$0F00               
                    ORA        #$5057               
                    STA        $9F,S                
                    PHX                             
                    PHX                             
                    PEA        $7776                
                    TSC                             ; Line 36
                    ADC        #$00A4               
                    TCS                             
                    LDA        #$4744               
                    STA        $97,S                
                    SEP        #$20                 
                    LDA        $96,S                
                    AND        #$F0                 
                    ORA        #$04                 
                    STA        $96,S                
                    LDA        $A1,S                
                    AND        #$0F                 
                    ORA        #$70                 
                    STA        $A1,S                
                    REP        #$30                 
                    PHD                             
                    PHY                             
                    TSC                             ; Line 37
                    ADC        #$00A4               
                    TCS                             
                    TYA                             
                    STA        $9C,S                
                    LDA        $9A,S                
                    AND        #$00F0               
                    ORA        #$6706               
                    STA        $9A,S                
                    SEP        #$20                 
                    LDA        #$44                 
                    STA        $97,S                
                    REP        #$30                 
                    PHX                             
                    PEA        $7577                
                    PEA        $7666                
                    TSC                             ; Line 39
                    ADC        #$013C               
                    TCS                             
                    LDA        #$7644               
                    STA        $04,S                
                    LDA        #$7747               
                    STA        $A5,S                
                    LDA        $06,S                
                    AND        #$0F00               
                    ORA        #$7077               
                    STA        $06,S                
                    LDA        $A3,S                
                    AND        #$00F0               
                    ORA        #$4404               
                    STA        $A3,S                
                    TSC                             ; Line 41
                    ADC        #$0140               
                    TCS                             
                    LDA        $03,S                
                    AND        #$00F0               
                    ORA        #$4404               
                    STA        $03,S                
                    SEP        #$20                 
                    LDA        #$44                 
                    STA        $A4,S                
                    LDA        $05,S                
                    AND        #$0F                 
                    ORA        #$40                 
                    STA        $05,S                
                    REP        #$30                 
                    TSC                             ; Line 66
                    ADC        #$0FA0               
                    TCS                             
                    LDA        $08,S                
                    AND        #$0F0F               
                    ORA        #$5050               
                    STA        $08,S                
                    LDA        $0A,S                
                    AND        #$0F0F               
                    ORA        #$5050               
                    STA        $0A,S                
                    LDA        $A0,S                
                    AND        #$F0F0               
                    ORA        #$0505               
                    STA        $A0,S                
                    LDA        $A2,S                
                    AND        #$F0F0               
                    ORA        #$0505               
                    STA        $A2,S                
                    LDA        $A4,S                
                    AND        #$F0F0               
                    ORA        #$0505               
                    STA        $A4,S                
                    LDA        $A6,S                
                    AND        #$F0F0               
                    ORA        #$0505               
                    STA        $A6,S                
                    LDA        $A8,S                
                    AND        #$F0F0               
                    ORA        #$0505               
                    STA        $A8,S                
                    LDA        $AA,S                
                    AND        #$F0F0               
                    ORA        #$0505               
                    STA        $AA,S                
                    LDA        $AC,S                
                    AND        #$F0F0               
                    ORA        #$0505               
                    STA        $AC,S                
                    LDA        $AE,S                
                    AND        #$F0F0               
                    ORA        #$0505               
                    STA        $AE,S                
                    SEP        #$20                 
                    LDA        $0C,S                
                    AND        #$0F                 
                    ORA        #$50                 
                    STA        $0C,S                
                    REP        #$30                 
                    TSC                             ; Line 68
                    ADC        #$0140               
                    TCS                             
                    LDA        $00,S                
                    AND        #$0F0F               
                    ORA        #$5050               
                    STA        $00,S                
                    LDA        $02,S                
                    AND        #$0F0F               
                    ORA        #$5050               
                    STA        $02,S                
                    LDA        $04,S                
                    AND        #$0F0F               
                    ORA        #$5050               
                    STA        $04,S                
                    LDA        $06,S                
                    AND        #$0F0F               
                    ORA        #$5050               
                    STA        $06,S                
                    LDA        $08,S                
                    AND        #$0F0F               
                    ORA        #$5050               
                    STA        $08,S                
                    LDA        $0A,S                
                    AND        #$0F0F               
                    ORA        #$5050               
                    STA        $0A,S                
                    LDA        $0C,S                
                    AND        #$0F0F               
                    ORA        #$5050               
                    STA        $0C,S                
                    LDA        $A2,S                
                    AND        #$F0F0               
                    ORA        #$0505               
                    STA        $A2,S                
                    LDA        $A4,S                
                    AND        #$F0F0               
                    ORA        #$0505               
                    STA        $A4,S                
                    LDA        $A6,S                
                    AND        #$F0F0               
                    ORA        #$0505               
                    STA        $A6,S                
                    LDA        $A8,S                
                    AND        #$F0F0               
                    ORA        #$0505               
                    STA        $A8,S                
                    LDA        $AA,S                
                    AND        #$F0F0               
                    ORA        #$0505               
                    STA        $AA,S                
                    SEP        #$20                 
                    LDA        $0E,S                
                    AND        #$0F                 
                    ORA        #$50                 
                    STA        $0E,S                
                    REP        #$30                 
*--                                                 
                    LDAL       $E1C068              ; Direct Page and Stack in Bank 00/
                    AND        #$FFCF               
                    STAL       $E1C068              
                    LDA        StackAddress         ; Restore Stack
                    TCS                             
                    PLD                             ; Restore Direct Page
                    CLI                             ; Enable Interrupts
                    PLB
                    RTL                             
                                                    
*-----------------------------------                                
Sprite_BL_039       CLC                             ; Sprite #039 : 32x77, 1467 bytes, 2344 cycles
                    SEI                             ; Disable Interrupts
                    PHD                             ; Backup Direct Page
                    TSC                             ; Backup Stack
                    STA        StackAddress         
                    LDAL       $E1C068              ; Direct Page and Stack in Bank 01/
                    ORA        #$0030               
                    STAL       $E1C068              
                    TYA                             ; Y = Sprite Target Screen Address (upper left corner)
                    TCS                             ; New Stack address
                    LDX        #$7575               ; Pattern #1 : 14
                    LDY        #$7767               ; Pattern #2 : 11
                    LDA        #$5757               ; Pattern #3 : 9
                    TCD                             
*--                                                 
                    LDA        #$5555               ; Line 0
                    STA        $09,S                
                    STA        $A8,S                
                    LDA        $AA,S                
                    AND        #$0F00               
                    ORA        #$5055               
                    STA        $AA,S                
                    TSC                             ; Line 2
                    ADC        #$0140               
                    TCS                             
                    SEP        #$20                 
                    LDA        $07,S                
                    AND        #$F0                 
                    ORA        #$05                 
                    STA        $07,S                
                    LDA        $A7,S                
                    AND        #$F0                 
                    ORA        #$03                 
                    STA        $A7,S                
                    REP        #$30                 
                    TSC                             
                    ADC        #$000B               
                    TCS                             
                    PEA        $5555                
                    PEA        $5555                
                    TSC                             ; Line 3
                    ADC        #$00A4               
                    TCS                             
                    SEP        #$20                 
                    LDA        $9C,S                
                    AND        #$F0                 
                    ORA        #$03                 
                    STA        $9C,S                
                    REP        #$30                 
                    PEA        $3333                
                    PEA        $3333                
                    TSC                             ; Line 4
                    ADC        #$00A4               
                    TCS                             
                    SEP        #$20                 
                    LDA        $9C,S                
                    AND        #$F0                 
                    ORA        #$04                 
                    STA        $9C,S                
                    REP        #$30                 
                    PEA        $3333                
                    PEA        $3333                
                    TSC                             ; Line 5
                    ADC        #$00A4               
                    TCS                             
                    SEP        #$20                 
                    LDA        $9C,S                
                    AND        #$F0                 
                    ORA        #$04                 
                    STA        $9C,S                
                    REP        #$30                 
                    PEA        $5555                
                    PEA        $4544                
                    TSC                             ; Line 6
                    ADC        #$00A4               
                    TCS                             
                    SEP        #$20                 
                    LDA        #$55                 
                    STA        $A0,S                
                    REP        #$30                 
                    PEA        $5555                
                    PEA        $4555                
                    TSC                             ; Line 7
                    ADC        #$00A3               
                    TCS                             
                    SEP        #$20                 
                    LDA        $A1,S                
                    AND        #$0F                 
                    ORA        #$50                 
                    STA        $A1,S                
                    REP        #$30                 
                    PEA        $4545                
                    PEA        $4444                
                    TSC                             ; Line 8
                    ADC        #$00A4               
                    TCS                             
                    LDA        #$4444               
                    STA        $9E,S                
                    LDA        $A0,S                
                    AND        #$0F00               
                    ORA        #$5045               
                    STA        $A0,S                
                    SEP        #$20                 
                    LDA        $9D,S                
                    AND        #$F0                 
                    ORA        #$04                 
                    STA        $9D,S                
                    REP        #$30                 
                    PEA        $4544                
                    PEA        $4444                
                    TSC                             ; Line 10
                    ADC        #$013A               
                    TCS                             
                    LDA        #$4444               
                    STA        $09,S                
                    LDA        $07,S                
                    AND        #$00F0               
                    ORA        #$4404               
                    STA        $07,S                
                    LDA        $A8,S                
                    AND        #$00F0               
                    ORA        #$4404               
                    STA        $A8,S                
                    LDA        $AA,S                
                    AND        #$0F00               
                    ORA        #$6044               
                    STA        $AA,S                
                    TSC                             ; Line 12
                    ADC        #$0140               
                    TCS                             
                    SEP        #$20                 
                    LDA        $07,S                
                    AND        #$F0                 
                    ORA        #$07                 
                    STA        $07,S                
                    REP        #$30                 
                    TSC                             
                    ADC        #$000B               
                    TCS                             
                    PEA        $1646                
                    PEA        $4467                
                    TSC                             ; Line 13
                    ADC        #$00A5               
                    TCS                             
                    LDA        $9A,S                
                    AND        #$00F0               
                    ORA        #$1707               
                    STA        $9A,S                
                    LDA        $A0,S                
                    AND        #$0F00               
                    ORA        #$7067               
                    STA        $A0,S                
                    PEA        $5667                
                    PEA        $6144                
                    PEA        $7576                
                    TSC                             ; Line 14
                    ADC        #$00A5               
                    TCS                             
                    LDA        $9B,S                
                    AND        #$00F0               
                    ORA        #$7501               
                    STA        $9B,S                
                    SEP        #$20                 
                    LDA        $95,S                
                    AND        #$F0                 
                    ORA        #$04                 
                    STA        $95,S                
                    REP        #$30                 
                    PEA        $7516                
                    PEA        $4654                
                    TSC                             ; Line 15
                    ADC        #$00A6               
                    TCS                             
                    LDA        $93,S                
                    AND        #$0F00               
                    ORA        #$4044               
                    STA        $93,S                
                    PEA        $5777                
                    PEA        $5667                
                    PEA        $6174                
                    TSC                             ; Line 16
                    ADC        #$00A6               
                    TCS                             
                    LDA        #$4444               
                    STA        $93,S                
                    LDA        $98,S                
                    AND        #$00F0               
                    ORA        #$6706               
                    STA        $98,S                
                    LDA        $A0,S                
                    AND        #$0F00               
                    ORA        #$5057               
                    STA        $A0,S                
                    SEP        #$20                 
                    LDA        $95,S                
                    AND        #$0F                 
                    ORA        #$10                 
                    STA        $95,S                
                    REP        #$30                 
                    PEA        $7577                
                    PEA        $6775                
                    PEA        $1646                
                    PEA        $5717                
                    TSC                             ; Line 17
                    ADC        #$00A7               
                    TCS                             
                    LDA        #$6144               
                    STA        $95,S                
                    SEP        #$20                 
                    LDA        $94,S                
                    AND        #$F0                 
                    ORA        #$04                 
                    STA        $94,S                
                    REP        #$30                 
                    PEA        $7677                
                    PEA        $5667                
                    PEA        $6154                
                    TSC                             ; Line 18
                    ADC        #$00A8               
                    TCS                             
                    LDA        #$6677               
                    STA        $93,S                
                    SEP        #$20                 
                    LDA        $95,S                
                    AND        #$0F                 
                    ORA        #$10                 
                    STA        $95,S                
                    REP        #$30                 
                    PHX                             
                    PEA        $6777                
                    PEA        $6775                
                    PEA        $1646                
                    PEA        $7566                
                    TSC                             ; Line 19
                    ADC        #$00AA               
                    TCS                             
                    SEP        #$20                 
                    LDA        $A1,S                
                    AND        #$0F                 
                    ORA        #$70                 
                    STA        $A1,S                
                    REP        #$30                 
                    PEA        $5777                
                    PEA        $7675                
                    PEA        $7756                
                    PEA        $7756                
                    PEA        $7567                
                    TSC                             ; Line 20
                    ADC        #$00AA               
                    TCS                             
                    SEP        #$20                 
                    LDA        $93,S                
                    AND        #$F0                 
                    ORA        #$05                 
                    STA        $93,S                
                    REP        #$30                 
                    PEA        $7567                
                    PEA        $6757                
                    PHY                             
                    PEA        $6571                
                    PEA        $5676                
                    PEA        $7666                
                    PEA        $7657                
                    TSC                             ; Line 21
                    ADC        #$00AF               
                    TCS                             
                    PEA        $5777                
                    PEA        $7676                
                    PHX                             
                    PEA        $7756                
                    PEA        $7777                
                    PEA        $6567                
                    PEA        $6777                
                    TSC                             ; Line 22
                    ADC        #$00AE               
                    TCS                             
                    LDA        $93,S                
                    AND        #$00F0               
                    ORA        #$7705               
                    STA        $93,S                
                    PHX                             
                    PEA        $6657                
                    PHD                             
                    PHY                             
                    PEA        $7555                
                    PEA        $5776                
                    PEA        $7657                
                    TSC                             ; Line 23
                    ADC        #$00AE               
                    TCS                             
                    SEP        #$20                 
                    LDA        $A0,S                
                    AND        #$0F                 
                    ORA        #$70                 
                    STA        $A0,S                
                    REP        #$30                 
                    PEA        $5767                
                    PEA        $6776                
                    PHX                             
                    PEA        $7577                
                    PEA        $7676                
                    PEA        $7577                
                    TSC                             ; Line 24
                    ADC        #$00AB               
                    TCS                             
                    LDA        $98,S                
                    AND        #$00F0               
                    ORA        #$7707               
                    STA        $98,S                
                    LDA        $A0,S                
                    AND        #$0F00               
                    ORA        #$5057               
                    STA        $A0,S                
                    PEA        $7517                
                    PEA        $1616                
                    PEA        $4654                
                    PHY                             
                    PHD                             
                    PHD                             
                    TSC                             ; Line 25
                    ADC        #$00AB               
                    TCS                             
                    SEP        #$20                 
                    LDA        #$75                 
                    STA        $A0,S                
                    REP        #$30                 
                    PEA        $5767                
                    PEA        $6747                
                    PEA        $4474                
                    TSC                             ; Line 26
                    ADC        #$00A5               
                    TCS                             
                    LDA        $99,S                
                    AND        #$0F00               
                    ORA        #$6061               
                    STA        $99,S                
                    SEP        #$20                 
                    LDA        $98,S                
                    AND        #$F0                 
                    ORA        #$01                 
                    STA        $98,S                
                    REP        #$30                 
                    PHX                             
                    PEA        $4544                
                    PEA        $7467                
                    TSC                             ; Line 27
                    ADC        #$00A6               
                    TCS                             
                    SEP        #$20                 
                    LDA        #$33                 
                    STA        $A0,S                
                    REP        #$30                 
                    PEA        $7777                
                    PEA        $7777                
                    PEA        $7736                
                    TSC                             ; Line 28
                    ADC        #$00A5               
                    TCS                             
                    LDA        $98,S                
                    AND        #$00F0               
                    ORA        #$6701               
                    STA        $98,S                
                    PEA        $7377                
                    PEA        $3333                
                    PEA        $6366                
                    PEA        $1616                
                    TSC                             ; Line 29
                    ADC        #$00A9               
                    TCS                             
                    PEA        $7576                
                    PEA        $7675                
                    PEA        $3776                
                    PEA        $7667                
                    TSC                             ; Line 30
                    ADC        #$00A8               
                    TCS                             
                    LDA        $96,S                
                    AND        #$00F0               
                    ORA        #$6701               
                    STA        $96,S                
                    LDA        $A0,S                
                    AND        #$0F00               
                    ORA        #$7075               
                    STA        $A0,S                
                    PEA        $5767                
                    PEA        $6761                
                    PEA        $7663                
                    PEA        $5777                
                    PEA        $7666                
                    TSC                             ; Line 31
                    ADC        #$00A9               
                    TCS                             
                    LDA        $97,S                
                    AND        #$00F0               
                    ORA        #$7606               
                    STA        $97,S                
                    LDA        $A1,S                
                    AND        #$0F00               
                    ORA        #$5057               
                    STA        $A1,S                
                    PEA        $7517                
                    PEA        $1666                
                    PEA        $7375                
                    PEA        $7567                
                    TSC                             ; Line 32
                    ADC        #$00A8               
                    TCS                             
                    TYA                             
                    STA        $98,S                
                    LDA        $9A,S                
                    AND        #$00F0               
                    ORA        #$7505               
                    STA        $9A,S                
                    SEP        #$20                 
                    LDA        #$67                 
                    STA        $97,S                
                    LDA        $A2,S                
                    AND        #$0F                 
                    ORA        #$70                 
                    STA        $A2,S                
                    REP        #$30                 
                    PHY                             
                    PEA        $6767                
                    PEA        $5657                
                    PEA        $5777                
                    TSC                             ; Line 33
                    ADC        #$00A9               
                    TCS                             
                    LDA        $95,S                
                    AND        #$00F0               
                    ORA        #$7606               
                    STA        $95,S                
                    LDA        $97,S                
                    AND        #$0F00               
                    ORA        #$7077               
                    STA        $97,S                
                    SEP        #$20                 
                    LDA        #$56                 
                    STA        $9A,S                
                    REP        #$30                 
                    PHX                             
                    PEA        $7576                
                    PEA        $7616                
                    TSC                             ; Line 34
                    ADC        #$00A6               
                    TCS                             
                    TYA                             
                    STA        $96,S                
                    LDA        $94,S                
                    AND        #$F000               
                    ORA        #$0644               
                    STA        $94,S                
                    SEP        #$20                 
                    LDA        #$16                 
                    STA        $9A,S                
                    REP        #$30                 
                    PHD                             
                    PEA        $5777                
                    PEA        $6767                
                    TSC                             ; Line 35
                    ADC        #$00A6               
                    TCS                             
                    LDA        #$4444               
                    STA        $94,S                
                    LDA        $96,S                
                    AND        #$0F00               
                    ORA        #$7077               
                    STA        $96,S                
                    LDA        $99,S                
                    AND        #$00F0               
                    ORA        #$6701               
                    STA        $99,S                
                    LDA        $9F,S                
                    AND        #$0F00               
                    ORA        #$5057               
                    STA        $9F,S                
                    PHX                             
                    PHX                             
                    PEA        $7776                
                    TSC                             ; Line 36
                    ADC        #$00A4               
                    TCS                             
                    LDA        #$4744               
                    STA        $97,S                
                    SEP        #$20                 
                    LDA        $96,S                
                    AND        #$F0                 
                    ORA        #$04                 
                    STA        $96,S                
                    LDA        $A1,S                
                    AND        #$0F                 
                    ORA        #$70                 
                    STA        $A1,S                
                    REP        #$30                 
                    PHD                             
                    PHY                             
                    TSC                             ; Line 37
                    ADC        #$00A4               
                    TCS                             
                    TYA                             
                    STA        $9C,S                
                    LDA        $9A,S                
                    AND        #$00F0               
                    ORA        #$6706               
                    STA        $9A,S                
                    SEP        #$20                 
                    LDA        #$44                 
                    STA        $97,S                
                    REP        #$30                 
                    PHX                             
                    PEA        $7577                
                    PEA        $7666                
                    TSC                             ; Line 39
                    ADC        #$013C               
                    TCS                             
                    LDA        #$7644               
                    STA        $04,S                
                    LDA        #$7747               
                    STA        $A5,S                
                    LDA        $06,S                
                    AND        #$0F00               
                    ORA        #$7077               
                    STA        $06,S                
                    LDA        $A3,S                
                    AND        #$00F0               
                    ORA        #$4404               
                    STA        $A3,S                
                    TSC                             ; Line 41
                    ADC        #$0140               
                    TCS                             
                    LDA        $03,S                
                    AND        #$00F0               
                    ORA        #$4404               
                    STA        $03,S                
                    SEP        #$20                 
                    LDA        #$44                 
                    STA        $A4,S                
                    LDA        $05,S                
                    AND        #$0F                 
                    ORA        #$40                 
                    STA        $05,S                
                    REP        #$30                 
                    TSC                             ; Line 73
                    ADC        #$1400               
                    TCS                             
                    LDA        $08,S                
                    AND        #$0F0F               
                    ORA        #$5050               
                    STA        $08,S                
                    LDA        $0A,S                
                    AND        #$0F0F               
                    ORA        #$5050               
                    STA        $0A,S                
                    LDA        $A0,S                
                    AND        #$F0F0               
                    ORA        #$0505               
                    STA        $A0,S                
                    LDA        $A2,S                
                    AND        #$F0F0               
                    ORA        #$0505               
                    STA        $A2,S                
                    LDA        $A4,S                
                    AND        #$F0F0               
                    ORA        #$0505               
                    STA        $A4,S                
                    LDA        $A6,S                
                    AND        #$F0F0               
                    ORA        #$0505               
                    STA        $A6,S                
                    LDA        $A8,S                
                    AND        #$F0F0               
                    ORA        #$0505               
                    STA        $A8,S                
                    LDA        $AA,S                
                    AND        #$F0F0               
                    ORA        #$0505               
                    STA        $AA,S                
                    LDA        $AC,S                
                    AND        #$F0F0               
                    ORA        #$0505               
                    STA        $AC,S                
                    LDA        $AE,S                
                    AND        #$F0F0               
                    ORA        #$0505               
                    STA        $AE,S                
                    SEP        #$20                 
                    LDA        $0C,S                
                    AND        #$0F                 
                    ORA        #$50                 
                    STA        $0C,S                
                    REP        #$30                 
                    TSC                             ; Line 75
                    ADC        #$0140               
                    TCS                             
                    LDA        $00,S                
                    AND        #$0F0F               
                    ORA        #$5050               
                    STA        $00,S                
                    LDA        $02,S                
                    AND        #$0F0F               
                    ORA        #$5050               
                    STA        $02,S                
                    LDA        $04,S                
                    AND        #$0F0F               
                    ORA        #$5050               
                    STA        $04,S                
                    LDA        $06,S                
                    AND        #$0F0F               
                    ORA        #$5050               
                    STA        $06,S                
                    LDA        $08,S                
                    AND        #$0F0F               
                    ORA        #$5050               
                    STA        $08,S                
                    LDA        $0A,S                
                    AND        #$0F0F               
                    ORA        #$5050               
                    STA        $0A,S                
                    LDA        $0C,S                
                    AND        #$0F0F               
                    ORA        #$5050               
                    STA        $0C,S                
                    LDA        $A2,S                
                    AND        #$F0F0               
                    ORA        #$0505               
                    STA        $A2,S                
                    LDA        $A4,S                
                    AND        #$F0F0               
                    ORA        #$0505               
                    STA        $A4,S                
                    LDA        $A6,S                
                    AND        #$F0F0               
                    ORA        #$0505               
                    STA        $A6,S                
                    LDA        $A8,S                
                    AND        #$F0F0               
                    ORA        #$0505               
                    STA        $A8,S                
                    LDA        $AA,S                
                    AND        #$F0F0               
                    ORA        #$0505               
                    STA        $AA,S                
                    SEP        #$20                 
                    LDA        $0E,S                
                    AND        #$0F                 
                    ORA        #$50                 
                    STA        $0E,S                
                    REP        #$30                 
*--                                                 
                    LDAL       $E1C068              ; Direct Page and Stack in Bank 00/
                    AND        #$FFCF               
                    STAL       $E1C068              
                    LDA        StackAddress         ; Restore Stack
                    TCS                             
                    PLD                             ; Restore Direct Page
                    CLI                             ; Enable Interrupts
                    PLB
                    RTL                             
                                                    
*-----------------------------------                                
Sprite_BL_03A       CLC                             ; Sprite #03A : 52x79, 1520 bytes, 2512 cycles
                    SEI                             ; Disable Interrupts
                    PHD                             ; Backup Direct Page
                    TSC                             ; Backup Stack
                    STA        StackAddress         
                    LDAL       $E1C068              ; Direct Page and Stack in Bank 01/
                    ORA        #$0030               
                    STAL       $E1C068              
                    TYA                             ; Y = Sprite Target Screen Address (upper left corner)
                    TCS                             ; New Stack address
                    LDX        #$7575               ; Pattern #1 : 27
                    LDY        #$6767               ; Pattern #2 : 22
                    LDA        #$4444               ; Pattern #3 : 18
                    TCD                             
*--                                                 
                    LDA        #$5555               ; Line 0
                    STA        $B3,S                
                    LDA        $12,S                
                    AND        #$00F0               
                    ORA        #$5505               
                    STA        $12,S                
                    LDA        $B1,S                
                    AND        #$00F0               
                    ORA        #$5505               
                    STA        $B1,S                
                    SEP        #$20                 
                    LDA        $14,S                
                    AND        #$0F                 
                    ORA        #$50                 
                    STA        $14,S                
                    REP        #$30                 
                    TSC                             ; Line 2
                    ADC        #$0154               
                    TCS                             
                    SEP        #$20                 
                    LDA        $01,S                
                    AND        #$0F                 
                    ORA        #$50                 
                    STA        $01,S                
                    LDA        $A1,S                
                    AND        #$0F                 
                    ORA        #$30                 
                    STA        $A1,S                
                    REP        #$30                 
                    PEA        $5555                
                    PEA        $5555                
                    TSC                             ; Line 3
                    ADC        #$00A4               
                    TCS                             
                    SEP        #$20                 
                    LDA        $A1,S                
                    AND        #$0F                 
                    ORA        #$30                 
                    STA        $A1,S                
                    REP        #$30                 
                    PEA        $3333                
                    PEA        $3333                
                    TSC                             ; Line 4
                    ADC        #$00A4               
                    TCS                             
                    SEP        #$20                 
                    LDA        $A1,S                
                    AND        #$0F                 
                    ORA        #$50                 
                    STA        $A1,S                
                    REP        #$30                 
                    PEA        $3333                
                    PEA        $3333                
                    TSC                             ; Line 5
                    ADC        #$00A4               
                    TCS                             
                    SEP        #$20                 
                    LDA        $A1,S                
                    AND        #$0F                 
                    ORA        #$50                 
                    STA        $A1,S                
                    REP        #$30                 
                    PEA        $5555                
                    PHD                             
                    TSC                             ; Line 6
                    ADC        #$00A4               
                    TCS                             
                    LDA        #$5444               
                    STA        $9E,S                
                    LDA        $9C,S                
                    AND        #$00F0               
                    ORA        #$4404               
                    STA        $9C,S                
                    LDA        $A0,S                
                    AND        #$0F00               
                    ORA        #$5055               
                    STA        $A0,S                
                    PEA        $5555                
                    PEA        $5445                
                    TSC                             ; Line 8
                    ADC        #$0130               
                    TCS                             
                    SEP        #$20                 
                    LDA        $10,S                
                    AND        #$F0                 
                    ORA        #$04                 
                    STA        $10,S                
                    REP        #$30                 
                    TSC                             
                    ADC        #$0014               
                    TCS                             
                    PEA        $5544                
                    PHD                             
                    TSC                             ; Line 9
                    ADC        #$00A4               
                    TCS                             
                    TDC                             
                    STA        $9D,S                
                    LDA        $9F,S                
                    AND        #$0F00               
                    ORA        #$4044               
                    STA        $9F,S                
                    PEA        $5544                
                    PHD                             
                    TSC                             ; Line 11
                    ADC        #$0130               
                    TCS                             
                    TDC                             
                    STA        $12,S                
                    SEP        #$20                 
                    LDA        #$46                 
                    STA        $14,S                
                    LDA        $B5,S                
                    AND        #$0F                 
                    ORA        #$60                 
                    STA        $B5,S                
                    REP        #$30                 
                    TSC                             ; Line 12
                    ADC        #$00B4               
                    TCS                             
                    LDA        $A1,S                
                    AND        #$0F00               
                    ORA        #$6075               
                    STA        $A1,S                
                    SEP        #$20                 
                    LDA        $9C,S                
                    AND        #$F0                 
                    ORA        #$07                 
                    STA        $9C,S                
                    REP        #$30                 
                    PEA        $6144                
                    PEA        $7476                
                    TSC                             ; Line 13
                    ADC        #$00A4               
                    TCS                             
                    LDA        $9B,S                
                    AND        #$00F0               
                    ORA        #$7106               
                    STA        $9B,S                
                    PEA        $1646                
                    PEA        $5467                
                    TSC                             ; Line 14
                    ADC        #$00A6               
                    TCS                             
                    LDA        $A0,S                
                    AND        #$0F00               
                    ORA        #$7075               
                    STA        $A0,S                
                    PEA        $7756                
                    PEA        $6761                
                    PEA        $4475                
                    TSC                             ; Line 15
                    ADC        #$00A5               
                    TCS                             
                    LDA        $95,S                
                    AND        #$00F0               
                    ORA        #$6606               
                    STA        $95,S                
                    LDA        $A1,S                
                    AND        #$0F00               
                    ORA        #$5077               
                    STA        $A1,S                
                    PEA        $6775                
                    PEA        $1646                
                    PEA        $5767                
                    PEA        $7766                
                    TSC                             ; Line 16
                    ADC        #$00A8               
                    TCS                             
                    SEP        #$20                 
                    LDA        #$75                 
                    STA        $A2,S                
                    REP        #$30                 
                    PEA        $7756                
                    PEA        $6761                
                    PEA        $7415                
                    PHY                             
                    PEA        $6666                
                    TSC                             ; Line 17
                    ADC        #$00AB               
                    TCS                             
                    LDA        $A1,S                
                    AND        #$0F00               
                    ORA        #$5057               
                    STA        $A1,S                
                    LDA        #$6666               
                    PEA        $6577                
                    PEA        $6775                
                    PEA        $1646                
                    PEA        $7576                
                    PEA        $7676                
                    PHA                             
                    PHA                             
                    PHA                             
                    PHD                             
                    TSC                             ; Line 18
                    ADC        #$00B2               
                    TCS                             
                    LDA        $8F,S                
                    AND        #$0FF0               
                    ORA        #$4004               
                    STA        $8F,S                
                    LDA        $A1,S                
                    AND        #$0F00               
                    ORA        #$7075               
                    STA        $A1,S                
                    PEA        $7776                
                    PEA        $7756                
                    PEA        $6761                
                    PEA        $1577                
                    PHY                             
                    PHY                             
                    PHY                             
                    PHY                             
                    PHD                             
                    TSC                             ; Line 19
                    ADC        #$00B2               
                    TCS                             
                    LDA        $91,S                
                    AND        #$00F0               
                    ORA        #$7505               
                    STA        $91,S                
                    PEA        $6757                
                    PEA        $7767                
                    PEA        $7567                
                    PEA        $6556                
                    PEA        $5757                
                    PEA        $7777                
                    PEA        $7776                
                    PEA        $7676                
                    TSC                             ; Line 20
                    ADC        #$00B2               
                    TCS                             
                    LDA        $96,S                
                    AND        #$00F0               
                    ORA        #$5707               
                    STA        $96,S                
                    LDA        $A0,S                
                    AND        #$0F00               
                    ORA        #$7075               
                    STA        $A0,S                
                    PEA        $5777                
                    PEA        $7676                
                    PEA        $7577                
                    PEA        $5616                
                    PEA        $1776                
                    PHX                             
                    PHX                             
                    PHX                             
                    TSC                             ; Line 21
                    ADC        #$00AF               
                    TCS                             
                    LDA        $A1,S                
                    AND        #$0F00               
                    ORA        #$5057               
                    STA        $A1,S                
                    SEP        #$20                 
                    LDA        $98,S                
                    AND        #$F0                 
                    ORA        #$05                 
                    STA        $98,S                
                    REP        #$30                 
                    PHY                             
                    PEA        $5757                
                    PEA        $7767                
                    PEA        $7577                
                    TSC                             ; Line 22
                    ADC        #$00A8               
                    TCS                             
                    LDA        $A1,S                
                    AND        #$0F00               
                    ORA        #$7075               
                    STA        $A1,S                
                    PEA        $6776                
                    PHX                             
                    PEA        $7577                
                    PEA        $5657                
                    TSC                             ; Line 23
                    ADC        #$00A8               
                    TCS                             
                    SEP        #$20                 
                    LDA        #$57                 
                    STA        $A1,S                
                    REP        #$30                 
                    PEA        $7666                
                    PEA        $5757                
                    PEA        $5777                
                    PHY                             
                    TSC                             ; Line 24
                    ADC        #$00A8               
                    TCS                             
                    SEP        #$20                 
                    LDA        #$75                 
                    STA        $A1,S                
                    REP        #$30                 
                    PEA        $7761                
                    PEA        $6161                
                    PEA        $4475                
                    PEA        $7776                
                    TSC                             ; Line 25
                    ADC        #$00A8               
                    TCS                             
                    LDA        $99,S                
                    AND        #$00F0               
                    ORA        #$7706               
                    STA        $99,S                
                    LDA        $9F,S                
                    AND        #$0F00               
                    ORA        #$5057               
                    STA        $9F,S                
                    PHX                             
                    PEA        $7676                
                    PHD                             
                    PEA        $7777                
                    TSC                             ; Line 26
                    ADC        #$00A6               
                    TCS                             
                    LDA        $A0,S                
                    AND        #$0F00               
                    ORA        #$7077               
                    STA        $A0,S                
                    SEP        #$20                 
                    LDA        $9B,S                
                    AND        #$F0                 
                    ORA        #$03                 
                    STA        $9B,S                
                    REP        #$30                 
                    PEA        $5757                
                    PHD                             
                    TSC                             ; Line 27
                    ADC        #$00A3               
                    TCS                             
                    SEP        #$20                 
                    LDA        $A2,S                
                    AND        #$0F                 
                    ORA        #$30                 
                    STA        $A2,S                
                    REP        #$30                 
                    PEA        $7777                
                    PEA        $7767                
                    TSC                             ; Line 28
                    ADC        #$00A5               
                    TCS                             
                    LDA        $97,S                
                    AND        #$00F0               
                    ORA        #$6606               
                    STA        $97,S                
                    SEP        #$20                 
                    LDA        $A1,S                
                    AND        #$0F                 
                    ORA        #$50                 
                    STA        $A1,S                
                    REP        #$30                 
                    PEA        $3377                
                    PEA        $3733                
                    PEA        $3366                
                    TSC                             ; Line 29
                    ADC        #$00A6               
                    TCS                             
                    SEP        #$20                 
                    LDA        $A1,S                
                    AND        #$0F                 
                    ORA        #$70                 
                    STA        $A1,S                
                    REP        #$30                 
                    PHY                             
                    PEA        $5777                
                    PEA        $6367                
                    PEA        $6666                
                    TSC                             ; Line 30
                    ADC        #$00A8               
                    TCS                             
                    SEP        #$20                 
                    LDA        #$57                 
                    STA        $A1,S                
                    REP        #$30                 
                    LDA        #$6666               
                    PEA        $7576                
                    PEA        $1666                
                    PEA        $3776                
                    PHY                             
                    PEA        $6616                
                    PEA        $1616                
                    PHA                             
                    PHA                             
                    PHA                             
                    TSC                             ; Line 31
                    ADC        #$00B2               
                    TCS                             
                    PEA        $5777                
                    PEA        $6161                
                    PEA        $3657                
                    PEA        $7767                
                    PHY                             
                    PEA        $6766                
                    PEA        $6666                
                    PHY                             
                    PHY                             
                    PHD                             
                    PHD                             
                    TSC                             ; Line 32
                    ADC        #$00B7               
                    TCS                             
                    LDA        $8D,S                
                    AND        #$000F               
                    ORA        #$7740               
                    STA        $8D,S                
                    SEP        #$20                 
                    LDA        #$44                 
                    STA        $8C,S                
                    REP        #$30                 
                    LDA        #$7676               
                    PHX                             
                    PEA        $7776                
                    PEA        $7666                
                    PHX                             
                    PEA        $7576                
                    PHA                             
                    PHA                             
                    PHA                             
                    PHA                             
                    PEA        $7644                
                    PHD                             
                    TSC                             ; Line 33
                    ADC        #$00B6               
                    TCS                             
                    SEP        #$20                 
                    LDA        $A0,S                
                    AND        #$0F                 
                    ORA        #$70                 
                    STA        $A0,S                
                    REP        #$30                 
                    LDA        #$7777               
                    PEA        $5757                
                    PEA        $5767                
                    PHY                             
                    PEA        $5157                
                    PEA        $5757                
                    PEA        $5777                
                    PHA                             
                    PHA                             
                    PHA                             
                    TSC                             ; Line 34
                    ADC        #$00B1               
                    TCS                             
                    LDA        $95,S                
                    AND        #$00F0               
                    ORA        #$5707               
                    STA        $95,S                
                    SEP        #$20                 
                    LDA        $A1,S                
                    AND        #$0F                 
                    ORA        #$50                 
                    STA        $A1,S                
                    REP        #$30                 
                    PHX                             
                    PEA        $7577                
                    PEA        $7666                
                    PHX                             
                    PHX                             
                    PHX                             
                    PHX                             
                    PHX                             
                    PHX                             
                    TSC                             ; Line 35
                    ADC        #$00B2               
                    TCS                             
                    SEP        #$20                 
                    LDA        #$16                 
                    STA        $9A,S                
                    REP        #$30                 
                    PEA        $5757                
                    PEA        $5777                
                    PHY                             
                    PEA        $5157                
                    PEA        $5757                
                    TSC                             ; Line 36
                    ADC        #$00AA               
                    TCS                             
                    SEP        #$20                 
                    LDA        $99,S                
                    AND        #$F0                 
                    ORA        #$06                 
                    STA        $99,S                
                    REP        #$30                 
                    PHX                             
                    PHX                             
                    PEA        $7776                
                    TSC                             ; Line 37
                    ADC        #$00A5               
                    TCS                             
                    LDA        #$7666               
                    STA        $9A,S                
                    LDA        $9C,S                
                    AND        #$0F00               
                    ORA        #$7077               
                    STA        $9C,S                
                    PEA        $5757                
                    PEA        $5777                
                    PHY                             
                    TSC                             ; Line 39
                    ADC        #$0132               
                    TCS                             
                    LDA        #$7767               
                    STA        $0F,S                
                    TDC                             
                    STA        $AD,S                
                    LDA        $0D,S                
                    AND        #$00F0               
                    ORA        #$4704               
                    STA        $0D,S                
                    LDA        $AF,S                
                    AND        #$0F00               
                    ORA        #$7077               
                    STA        $AF,S                
                    TSC                             ; Line 41
                    ADC        #$0140               
                    TCS                             
                    TDC                             
                    STA        $0D,S                
                    LDA        $AD,S                
                    AND        #$0FF0               
                    ORA        #$4004               
                    STA        $AD,S                
                    TSC                             ; Line 75
                    ADC        #$1540               
                    TCS                             
                    LDA        $11,S                
                    AND        #$F0F0               
                    ORA        #$0505               
                    STA        $11,S                
                    LDA        $13,S                
                    AND        #$F0F0               
                    ORA        #$0505               
                    STA        $13,S                
                    LDA        $A2,S                
                    AND        #$0F0F               
                    ORA        #$5050               
                    STA        $A2,S                
                    LDA        $A4,S                
                    AND        #$0F0F               
                    ORA        #$5050               
                    STA        $A4,S                
                    LDA        $A6,S                
                    AND        #$0F0F               
                    ORA        #$5050               
                    STA        $A6,S                
                    LDA        $A8,S                
                    AND        #$0F0F               
                    ORA        #$5050               
                    STA        $A8,S                
                    LDA        $AA,S                
                    AND        #$0F0F               
                    ORA        #$5050               
                    STA        $AA,S                
                    LDA        $AC,S                
                    AND        #$0F0F               
                    ORA        #$5050               
                    STA        $AC,S                
                    LDA        $AE,S                
                    AND        #$0F0F               
                    ORA        #$5050               
                    STA        $AE,S                
                    LDA        $B0,S                
                    AND        #$0F0F               
                    ORA        #$5050               
                    STA        $B0,S                
                    LDA        $B2,S                
                    AND        #$0F0F               
                    ORA        #$5050               
                    STA        $B2,S                
                    LDA        $B4,S                
                    AND        #$0F0F               
                    ORA        #$5050               
                    STA        $B4,S                
                    LDA        $B6,S                
                    AND        #$0F0F               
                    ORA        #$5050               
                    STA        $B6,S                
                    LDA        $B8,S                
                    AND        #$0F0F               
                    ORA        #$5050               
                    STA        $B8,S                
                    SEP        #$20                 
                    LDA        $15,S                
                    AND        #$F0                 
                    ORA        #$05                 
                    STA        $15,S                
                    REP        #$30                 
                    TSC                             ; Line 77
                    ADC        #$0140               
                    TCS                             
                    LDA        $01,S                
                    AND        #$F0F0               
                    ORA        #$0505               
                    STA        $01,S                
                    LDA        $03,S                
                    AND        #$F0F0               
                    ORA        #$0505               
                    STA        $03,S                
                    LDA        $05,S                
                    AND        #$F0F0               
                    ORA        #$0505               
                    STA        $05,S                
                    LDA        $07,S                
                    AND        #$F0F0               
                    ORA        #$0505               
                    STA        $07,S                
                    LDA        $09,S                
                    AND        #$F0F0               
                    ORA        #$0505               
                    STA        $09,S                
                    LDA        $0B,S                
                    AND        #$F0F0               
                    ORA        #$0505               
                    STA        $0B,S                
                    LDA        $0D,S                
                    AND        #$F0F0               
                    ORA        #$0505               
                    STA        $0D,S                
                    LDA        $0F,S                
                    AND        #$F0F0               
                    ORA        #$0505               
                    STA        $0F,S                
                    LDA        $11,S                
                    AND        #$F0F0               
                    ORA        #$0505               
                    STA        $11,S                
                    LDA        $13,S                
                    AND        #$F0F0               
                    ORA        #$0505               
                    STA        $13,S                
                    LDA        $15,S                
                    AND        #$F0F0               
                    ORA        #$0505               
                    STA        $15,S                
                    LDA        $A8,S                
                    AND        #$0F0F               
                    ORA        #$5050               
                    STA        $A8,S                
                    LDA        $AA,S                
                    AND        #$0F0F               
                    ORA        #$5050               
                    STA        $AA,S                
                    LDA        $AC,S                
                    AND        #$0F0F               
                    ORA        #$5050               
                    STA        $AC,S                
                    LDA        $AE,S                
                    AND        #$0F0F               
                    ORA        #$5050               
                    STA        $AE,S                
                    LDA        $B0,S                
                    AND        #$0F0F               
                    ORA        #$5050               
                    STA        $B0,S                
                    LDA        $B2,S                
                    AND        #$0F0F               
                    ORA        #$5050               
                    STA        $B2,S                
                    LDA        $B4,S                
                    AND        #$0F0F               
                    ORA        #$5050               
                    STA        $B4,S                
                    SEP        #$20                 
                    LDA        $17,S                
                    AND        #$F0                 
                    ORA        #$05                 
                    STA        $17,S                
                    REP        #$30                 
*--                                                 
                    LDAL       $E1C068              ; Direct Page and Stack in Bank 00/
                    AND        #$FFCF               
                    STAL       $E1C068              
                    LDA        StackAddress         ; Restore Stack
                    TCS                             
                    PLD                             ; Restore Direct Page
                    CLI                             ; Enable Interrupts
                    PLB
                    RTL                             
                                                    
*-----------------------------------                                
Sprite_BL_03B       CLC                             ; Sprite #03B : 32x41, 1364 bytes, 2185 cycles
                    SEI                             ; Disable Interrupts
                    PHD                             ; Backup Direct Page
                    TSC                             ; Backup Stack
                    STA        StackAddress         
                    LDAL       $E1C068              ; Direct Page and Stack in Bank 01/
                    ORA        #$0030               
                    STAL       $E1C068              
                    TYA                             ; Y = Sprite Target Screen Address (upper left corner)
                    TCS                             ; New Stack address
                    LDX        #$7777               ; Pattern #1 : 14
                    LDY        #$4444               ; Pattern #2 : 14
                    LDA        #$5777               ; Pattern #3 : 8
                    TCD                             
*--                                                 
                    LDA        #$5555               ; Line 0
                    STA        $AB,S                
                    LDA        $0A,S                
                    AND        #$00F0               
                    ORA        #$5505               
                    STA        $0A,S                
                    LDA        $A9,S                
                    AND        #$00F0               
                    ORA        #$5505               
                    STA        $A9,S                
                    SEP        #$20                 
                    LDA        $0C,S                
                    AND        #$0F                 
                    ORA        #$50                 
                    STA        $0C,S                
                    REP        #$30                 
                    TSC                             ; Line 2
                    ADC        #$014C               
                    TCS                             
                    SEP        #$20                 
                    LDA        $01,S                
                    AND        #$0F                 
                    ORA        #$50                 
                    STA        $01,S                
                    LDA        $A1,S                
                    AND        #$0F                 
                    ORA        #$30                 
                    STA        $A1,S                
                    REP        #$30                 
                    PEA        $5555                
                    PEA        $5555                
                    TSC                             ; Line 3
                    ADC        #$00A4               
                    TCS                             
                    SEP        #$20                 
                    LDA        $A1,S                
                    AND        #$0F                 
                    ORA        #$30                 
                    STA        $A1,S                
                    REP        #$30                 
                    PEA        $3333                
                    PEA        $3333                
                    TSC                             ; Line 4
                    ADC        #$00A4               
                    TCS                             
                    SEP        #$20                 
                    LDA        $A1,S                
                    AND        #$0F                 
                    ORA        #$50                 
                    STA        $A1,S                
                    REP        #$30                 
                    PEA        $3333                
                    PEA        $3333                
                    TSC                             ; Line 5
                    ADC        #$00A4               
                    TCS                             
                    SEP        #$20                 
                    LDA        $A1,S                
                    AND        #$0F                 
                    ORA        #$50                 
                    STA        $A1,S                
                    REP        #$30                 
                    PEA        $5555                
                    PHY                             
                    TSC                             ; Line 6
                    ADC        #$00A4               
                    TCS                             
                    LDA        #$5444               
                    STA        $9E,S                
                    LDA        $9C,S                
                    AND        #$00F0               
                    ORA        #$4404               
                    STA        $9C,S                
                    LDA        $A0,S                
                    AND        #$0F00               
                    ORA        #$5055               
                    STA        $A0,S                
                    PEA        $5555                
                    PEA        $5445                
                    TSC                             ; Line 8
                    ADC        #$0138               
                    TCS                             
                    SEP        #$20                 
                    LDA        $08,S                
                    AND        #$F0                 
                    ORA        #$04                 
                    STA        $08,S                
                    REP        #$30                 
                    TSC                             
                    ADC        #$000C               
                    TCS                             
                    PEA        $5544                
                    PHY                             
                    TSC                             ; Line 9
                    ADC        #$00A4               
                    TCS                             
                    TYA                             
                    STA        $9D,S                
                    LDA        $9F,S                
                    AND        #$0F00               
                    ORA        #$4044               
                    STA        $9F,S                
                    PEA        $5544                
                    PHY                             
                    TSC                             ; Line 11
                    ADC        #$0138               
                    TCS                             
                    TYA                             
                    STA        $0A,S                
                    SEP        #$20                 
                    LDA        #$46                 
                    STA        $0C,S                
                    LDA        $AD,S                
                    AND        #$0F                 
                    ORA        #$60                 
                    STA        $AD,S                
                    REP        #$30                 
                    TSC                             ; Line 12
                    ADC        #$00AC               
                    TCS                             
                    SEP        #$20                 
                    LDA        $A2,S                
                    AND        #$0F                 
                    ORA        #$60                 
                    STA        $A2,S                
                    REP        #$30                 
                    PEA        $6144                
                    PEA        $7476                
                    TSC                             ; Line 13
                    ADC        #$00A5               
                    TCS                             
                    LDA        $9A,S                
                    AND        #$00F0               
                    ORA        #$7606               
                    STA        $9A,S                
                    SEP        #$20                 
                    LDA        #$44                 
                    STA        $99,S                
                    REP        #$30                 
                    PEA        $7516                
                    PEA        $4654                
                    PEA        $6767                
                    TSC                             ; Line 14
                    ADC        #$00A7               
                    TCS                             
                    LDA        $A0,S                
                    AND        #$0F00               
                    ORA        #$7077               
                    STA        $A0,S                
                    SEP        #$20                 
                    LDA        $97,S                
                    AND        #$F0                 
                    ORA        #$04                 
                    STA        $97,S                
                    REP        #$30                 
                    PEA        $7756                
                    PEA        $6761                
                    PEA        $4475                
                    TSC                             ; Line 15
                    ADC        #$00A5               
                    TCS                             
                    LDA        $95,S                
                    AND        #$0FF0               
                    ORA        #$4004               
                    STA        $95,S                
                    LDA        $A1,S                
                    AND        #$0F00               
                    ORA        #$5077               
                    STA        $A1,S                
                    SEP        #$20                 
                    LDA        $98,S                
                    AND        #$F0                 
                    ORA        #$04                 
                    STA        $98,S                
                    REP        #$30                 
                    PEA        $6775                
                    PEA        $1646                
                    PEA        $5767                
                    PEA        $4744                
                    TSC                             ; Line 16
                    ADC        #$00A8               
                    TCS                             
                    TYA                             
                    STA        $95,S                
                    LDA        $A1,S                
                    AND        #$0F00               
                    ORA        #$7075               
                    STA        $A1,S                
                    PEA        $7756                
                    PEA        $6761                
                    PEA        $7475                
                    PHY                             
                    TSC                             ; Line 17
                    ADC        #$00A8               
                    TCS                             
                    TYA                             
                    STA        $95,S                
                    SEP        #$20                 
                    LDA        $97,S                
                    AND        #$0F                 
                    ORA        #$40                 
                    STA        $97,S                
                    LDA        $A2,S                
                    AND        #$0F                 
                    ORA        #$50                 
                    STA        $A2,S                
                    REP        #$30                 
                    PEA        $7767                
                    PEA        $7516                
                    PEA        $4647                
                    PHY                             
                    TSC                             ; Line 18
                    ADC        #$00A9               
                    TCS                             
                    TYA                             
                    STA        $95,S                
                    LDA        $98,S                
                    AND        #$F0F0               
                    ORA        #$0406               
                    STA        $98,S                
                    SEP        #$20                 
                    LDA        #$71                 
                    STA        $9A,S                
                    LDA        $97,S                
                    AND        #$F0                 
                    ORA        #$06                 
                    STA        $97,S                
                    LDA        $A1,S                
                    AND        #$0F                 
                    ORA        #$50                 
                    STA        $A1,S                
                    REP        #$30                 
                    PEA        $7776                
                    PEA        $7756                
                    PEA        $6771                
                    PEA        $4644                
                    TSC                             ; Line 19
                    ADC        #$00A8               
                    TCS                             
                    LDA        #$6744               
                    STA        $96,S                
                    SEP        #$20                 
                    LDA        $95,S                
                    AND        #$F0                 
                    ORA        #$04                 
                    STA        $95,S                
                    LDA        $98,S                
                    AND        #$0F                 
                    ORA        #$60                 
                    STA        $98,S                
                    LDA        $A1,S                
                    AND        #$0F                 
                    ORA        #$70                 
                    STA        $A1,S                
                    REP        #$30                 
                    PEA        $7567                
                    PEA        $7167                
                    PEA        $7567                
                    TSC                             ; Line 20
                    ADC        #$00A6               
                    TCS                             
                    LDA        #$7676               
                    STA        $97,S                
                    LDA        $99,S                
                    AND        #$00F0               
                    ORA        #$7707               
                    STA        $99,S                
                    SEP        #$20                 
                    LDA        #$47                 
                    STA        $96,S                
                    LDA        $A1,S                
                    AND        #$0F                 
                    ORA        #$50                 
                    STA        $A1,S                
                    REP        #$30                 
                    PEA        $7566                
                    PEA        $1677                
                    PEA        $5616                
                    PEA        $7765                
                    TSC                             ; Line 21
                    ADC        #$00A8               
                    TCS                             
                    LDA        $96,S                
                    AND        #$00F0               
                    ORA        #$7705               
                    STA        $96,S                
                    LDA        $A0,S                
                    AND        #$0F00               
                    ORA        #$7075               
                    STA        $A0,S                
                    PHX                             
                    PEA        $6671                
                    PEA        $6771                
                    TSC                             ; Line 22
                    ADC        #$00A5               
                    TCS                             
                    PEA        $7766                
                    PEA        $6611                
                    PEA        $7757                
                    PEA        $6777                
                    TSC                             ; Line 23
                    ADC        #$00A9               
                    TCS                             
                    SEP        #$20                 
                    LDA        #$55                 
                    STA        $98,S                
                    REP        #$30                 
                    PHD                             
                    PEA        $7766                
                    PHX                             
                    PEA        $7577                
                    PEA        $7755                
                    TSC                             ; Line 24
                    ADC        #$00AA               
                    TCS                             
                    PEA        $7775                
                    PEA        $7776                
                    PEA        $7757                
                    PHX                             
                    TSC                             ; Line 25
                    ADC        #$00A8               
                    TCS                             
                    PEA        $7757                
                    PHX                             
                    PEA        $7775                
                    PEA        $7757                
                    TSC                             ; Line 26
                    ADC        #$00A8               
                    TCS                             
                    LDA        $9F,S                
                    AND        #$0F00               
                    ORA        #$7077               
                    STA        $9F,S                
                    SEP        #$20                 
                    LDA        $94,S                
                    AND        #$F0                 
                    ORA        #$06                 
                    STA        $94,S                
                    REP        #$30                 
                    PHX                             
                    PEA        $7576                
                    PHD                             
                    PEA        $7666                
                    PEA        $6666                
                    PEA        $6616                
                    TSC                             ; Line 27
                    ADC        #$00AA               
                    TCS                             
                    LDA        $96,S                
                    AND        #$00F0               
                    ORA        #$7601               
                    STA        $96,S                
                    PEA        $5757                
                    PEA        $7767                
                    PEA        $6766                
                    PEA        $6767                
                    PEA        $1767                
                    TSC                             ; Line 28
                    ADC        #$00AB               
                    TCS                             
                    SEP        #$20                 
                    LDA        $95,S                
                    AND        #$F0                 
                    ORA        #$06                 
                    STA        $95,S                
                    REP        #$30                 
                    PEA        $6675                
                    PEA        $7735                
                    PEA        $7776                
                    PEA        $7676                
                    PHX                             
                    TSC                             ; Line 29
                    ADC        #$00AB               
                    TCS                             
                    SEP        #$20                 
                    LDA        $94,S                
                    AND        #$F0                 
                    ORA        #$06                 
                    STA        $94,S                
                    REP        #$30                 
                    PEA        $6767                
                    PEA        $6767                
                    PEA        $2333                
                    PHX                             
                    PEA        $5757                
                    PEA        $7767                
                    TSC                             ; Line 30
                    ADC        #$00AC               
                    TCS                             
                    SEP        #$20                 
                    LDA        $A1,S                
                    AND        #$0F                 
                    ORA        #$60                 
                    STA        $A1,S                
                    REP        #$30                 
                    PEA        $1616                
                    PEA        $6676                
                    PEA        $3732                
                    PEA        $7575                
                    PEA        $7575                
                    PEA        $7577                
                    TSC                             ; Line 31
                    ADC        #$00AC               
                    TCS                             
                    LDA        #$7577               
                    STA        $95,S                
                    SEP        #$20                 
                    LDA        $A1,S                
                    AND        #$0F                 
                    ORA        #$70                 
                    STA        $A1,S                
                    REP        #$30                 
                    PEA        $6767                
                    PEA        $7676                
                    PEA        $3257                
                    PEA        $5757                
                    PEA        $5757                
                    PEA        $5767                
                    TSC                             ; Line 32
                    ADC        #$00AC               
                    TCS                             
                    TDC                             
                    STA        $95,S                
                    LDA        $9B,S                
                    AND        #$00F0               
                    ORA        #$5707               
                    STA        $9B,S                
                    SEP        #$20                 
                    LDA        $97,S                
                    AND        #$0F                 
                    ORA        #$50                 
                    STA        $97,S                
                    LDA        $A1,S                
                    AND        #$0F                 
                    ORA        #$60                 
                    STA        $A1,S                
                    REP        #$30                 
                    PEA        $7667                
                    PEA        $6777                
                    PEA        $7275                
                    PEA        $7575                
                    TSC                             ; Line 33
                    ADC        #$00A8               
                    TCS                             
                    TXA                             
                    STA        $9F,S                
                    LDA        $95,S                
                    AND        #$00F0               
                    ORA        #$7507               
                    STA        $95,S                
                    LDA        $9D,S                
                    AND        #$00F0               
                    ORA        #$6707               
                    STA        $9D,S                
                    SEP        #$20                 
                    LDA        $97,S                
                    AND        #$0F                 
                    ORA        #$70                 
                    STA        $97,S                
                    REP        #$30                 
                    PHX                             
                    PEA        $7656                
                    TSC                             ; Line 35
                    ADC        #$0136               
                    TCS                             
                    TXA                             
                    STA        $0D,S                
                    STA        $AD,S                
                    LDA        #$7575               
                    STA        $A4,S                
                    LDA        $03,S                
                    AND        #$00F0               
                    ORA        #$7707               
                    STA        $03,S                
                    LDA        $0B,S                
                    AND        #$00F0               
                    ORA        #$7607               
                    STA        $0B,S                
                    SEP        #$20                 
                    LDA        $05,S                
                    AND        #$0F                 
                    ORA        #$50                 
                    STA        $05,S                
                    LDA        $AC,S                
                    AND        #$F0                 
                    ORA        #$06                 
                    STA        $AC,S                
                    REP        #$30                 
                    TSC                             ; Line 37
                    ADC        #$0140               
                    TCS                             
                    TDC                             
                    STA        $04,S                
                    LDA        #$7577               
                    STA        $0D,S                
                    LDA        #$4454               
                    STA        $A4,S                
                    LDA        $01,S                
                    AND        #$F0F0               
                    ORA        #$0505               
                    STA        $01,S                
                    LDA        $07,S                
                    AND        #$F0F0               
                    ORA        #$0505               
                    STA        $07,S                
                    LDA        $09,S                
                    AND        #$F0F0               
                    ORA        #$0505               
                    STA        $09,S                
                    LDA        $0B,S                
                    AND        #$F0F0               
                    ORA        #$0705               
                    STA        $0B,S                
                    LDA        $A0,S                
                    AND        #$0F0F               
                    ORA        #$5050               
                    STA        $A0,S                
                    LDA        $A2,S                
                    AND        #$0F0F               
                    ORA        #$5050               
                    STA        $A2,S                
                    LDA        $A7,S                
                    AND        #$0F0F               
                    ORA        #$5050               
                    STA        $A7,S                
                    LDA        $A9,S                
                    AND        #$0F0F               
                    ORA        #$5050               
                    STA        $A9,S                
                    LDA        $AB,S                
                    AND        #$0F0F               
                    ORA        #$5050               
                    STA        $AB,S                
                    LDA        $AE,S                
                    AND        #$0F0F               
                    ORA        #$5070               
                    STA        $AE,S                
                    SEP        #$20                 
                    LDA        #$77                 
                    STA        $AD,S                
                    LDA        $03,S                
                    AND        #$F0                 
                    ORA        #$05                 
                    STA        $03,S                
                    LDA        $06,S                
                    AND        #$F0                 
                    ORA        #$05                 
                    STA        $06,S                
                    LDA        $A6,S                
                    AND        #$0F                 
                    ORA        #$50                 
                    STA        $A6,S                
                    REP        #$30                 
                    TSC                             ; Line 39
                    ADC        #$0140               
                    TCS                             
                    TYA                             
                    STA        $04,S                
                    STA        $AD,S                
                    LDA        #$4544               
                    STA        $0D,S                
                    LDA        $00,S                
                    AND        #$F0F0               
                    ORA        #$0505               
                    STA        $00,S                
                    LDA        $02,S                
                    AND        #$F0F0               
                    ORA        #$0405               
                    STA        $02,S                
                    LDA        $07,S                
                    AND        #$F0F0               
                    ORA        #$0505               
                    STA        $07,S                
                    LDA        $09,S                
                    AND        #$F0F0               
                    ORA        #$0505               
                    STA        $09,S                
                    LDA        $0B,S                
                    AND        #$F0F0               
                    ORA        #$0505               
                    STA        $0B,S                
                    LDA        $A7,S                
                    AND        #$0F0F               
                    ORA        #$5050               
                    STA        $A7,S                
                    LDA        $A9,S                
                    AND        #$0F0F               
                    ORA        #$5050               
                    STA        $A9,S                
                    LDA        $AB,S                
                    AND        #$000F               
                    ORA        #$5450               
                    STA        $AB,S                
                    SEP        #$20                 
                    LDA        $06,S                
                    AND        #$F0                 
                    ORA        #$05                 
                    STA        $06,S                
                    REP        #$30                 
*--                                                 
                    LDAL       $E1C068              ; Direct Page and Stack in Bank 00/
                    AND        #$FFCF               
                    STAL       $E1C068              
                    LDA        StackAddress         ; Restore Stack
                    TCS                             
                    PLD                             ; Restore Direct Page
                    CLI                             ; Enable Interrupts
                    PLB
                    RTL                             
                                                    
*-----------------------------------                                
Sprite_BL_03C       CLC                             ; Sprite #03C : 40x42, 1370 bytes, 2232 cycles
                    SEI                             ; Disable Interrupts
                    PHD                             ; Backup Direct Page
                    TSC                             ; Backup Stack
                    STA        StackAddress         
                    LDAL       $E1C068              ; Direct Page and Stack in Bank 01/
                    ORA        #$0030               
                    STAL       $E1C068              
                    TYA                             ; Y = Sprite Target Screen Address (upper left corner)
                    TCS                             ; New Stack address
                    LDX        #$7777               ; Pattern #1 : 21
                    LDY        #$5757               ; Pattern #2 : 18
                    LDA        #$7575               ; Pattern #3 : 18
                    TCD                             
*--                                                 
                    LDA        #$5555               ; Line 0
                    STA        $0D,S                
                    STA        $AC,S                
                    LDA        $AE,S                
                    AND        #$0F00               
                    ORA        #$5055               
                    STA        $AE,S                
                    TSC                             ; Line 2
                    ADC        #$0140               
                    TCS                             
                    SEP        #$20                 
                    LDA        $0B,S                
                    AND        #$F0                 
                    ORA        #$05                 
                    STA        $0B,S                
                    LDA        $AB,S                
                    AND        #$F0                 
                    ORA        #$03                 
                    STA        $AB,S                
                    REP        #$30                 
                    TSC                             
                    ADC        #$000F               
                    TCS                             
                    PEA        $5555                
                    PEA        $5555                
                    TSC                             ; Line 3
                    ADC        #$00A4               
                    TCS                             
                    SEP        #$20                 
                    LDA        $9C,S                
                    AND        #$F0                 
                    ORA        #$03                 
                    STA        $9C,S                
                    REP        #$30                 
                    PEA        $3333                
                    PEA        $3333                
                    TSC                             ; Line 4
                    ADC        #$00A4               
                    TCS                             
                    SEP        #$20                 
                    LDA        $9C,S                
                    AND        #$F0                 
                    ORA        #$04                 
                    STA        $9C,S                
                    REP        #$30                 
                    PEA        $3333                
                    PEA        $3333                
                    TSC                             ; Line 5
                    ADC        #$00A4               
                    TCS                             
                    SEP        #$20                 
                    LDA        $9C,S                
                    AND        #$F0                 
                    ORA        #$04                 
                    STA        $9C,S                
                    REP        #$30                 
                    PEA        $5555                
                    PEA        $4544                
                    TSC                             ; Line 6
                    ADC        #$00A4               
                    TCS                             
                    SEP        #$20                 
                    LDA        #$55                 
                    STA        $A0,S                
                    REP        #$30                 
                    PEA        $5555                
                    PEA        $4555                
                    TSC                             ; Line 7
                    ADC        #$00A3               
                    TCS                             
                    SEP        #$20                 
                    LDA        $A1,S                
                    AND        #$0F                 
                    ORA        #$50                 
                    STA        $A1,S                
                    REP        #$30                 
                    PEA        $4545                
                    PEA        $4444                
                    TSC                             ; Line 8
                    ADC        #$00A4               
                    TCS                             
                    LDA        #$4444               
                    STA        $9E,S                
                    LDA        $A0,S                
                    AND        #$0F00               
                    ORA        #$5045               
                    STA        $A0,S                
                    SEP        #$20                 
                    LDA        $9D,S                
                    AND        #$F0                 
                    ORA        #$04                 
                    STA        $9D,S                
                    REP        #$30                 
                    PEA        $4544                
                    PEA        $4444                
                    TSC                             ; Line 10
                    ADC        #$0136               
                    TCS                             
                    LDA        #$4444               
                    STA        $0C,S                
                    LDA        #$4644               
                    STA        $AE,S                
                    LDA        $0E,S                
                    AND        #$0F00               
                    ORA        #$4044               
                    STA        $0E,S                
                    LDA        $AC,S                
                    AND        #$00F0               
                    ORA        #$4404               
                    STA        $AC,S                
                    SEP        #$20                 
                    LDA        $0B,S                
                    AND        #$F0                 
                    ORA        #$04                 
                    STA        $0B,S                
                    REP        #$30                 
                    TSC                             ; Line 12
                    ADC        #$0140               
                    TCS                             
                    LDA        #$4474               
                    STA        $0D,S                
                    LDA        $0F,S                
                    AND        #$0F00               
                    ORA        #$5065               
                    STA        $0F,S                
                    SEP        #$20                 
                    LDA        #$67                 
                    STA        $B0,S                
                    LDA        $0C,S                
                    AND        #$F0                 
                    ORA        #$05                 
                    STA        $0C,S                
                    REP        #$30                 
                    TSC                             ; Line 13
                    ADC        #$00AF               
                    TCS                             
                    LDA        $91,S                
                    AND        #$0FF0               
                    ORA        #$4004               
                    STA        $91,S                
                    SEP        #$20                 
                    LDA        $9D,S                
                    AND        #$F0                 
                    ORA        #$06                 
                    STA        $9D,S                
                    REP        #$30                 
                    PEA        $7666                
                    PEA        $5657                
                    TSC                             ; Line 14
                    ADC        #$00A5               
                    TCS                             
                    SEP        #$20                 
                    LDA        #$77                 
                    STA        $A0,S                
                    REP        #$30                 
                    PEA        $6767                
                    PEA        $6776                
                    TSC                             ; Line 15
                    ADC        #$00A3               
                    TCS                             
                    SEP        #$20                 
                    LDA        #$44                 
                    STA        $91,S                
                    REP        #$30                 
                    LDA        #$6666               
                    PEA        $7667                
                    PEA        $6766                
                    PHA                             
                    PHA                             
                    PHA                             
                    PHA                             
                    PEA        $6646                
                    PEA        $4444                
                    TSC                             ; Line 16
                    ADC        #$00B1               
                    TCS                             
                    LDA        $92,S                
                    AND        #$00F0               
                    ORA        #$7705               
                    STA        $92,S                
                    LDA        $A0,S                
                    AND        #$0F00               
                    ORA        #$7077               
                    STA        $A0,S                
                    LDA        #$6666               
                    PHX                             
                    PEA        $7676                
                    PHA                             
                    PHA                             
                    PHA                             
                    PEA        $6667                
                    PEA        $6777                
                    PEA        $4744                
                    TSC                             ; Line 17
                    ADC        #$00AF               
                    TCS                             
                    LDA        $93,S                
                    AND        #$00F0               
                    ORA        #$5707               
                    STA        $93,S                
                    LDA        $A1,S                
                    AND        #$0F00               
                    ORA        #$5077               
                    STA        $A1,S                
                    LDA        #$6767               
                    PHX                             
                    PHA                             
                    PHA                             
                    PHA                             
                    PHX                             
                    PHX                             
                    TSC                             ; Line 18
                    ADC        #$00AC               
                    TCS                             
                    LDA        $A1,S                
                    AND        #$0F00               
                    ORA        #$7077               
                    STA        $A1,S                
                    PHX                             
                    PHX                             
                    PHX                             
                    PEA        $7757                
                    PHY                             
                    PHY                             
                    TSC                             ; Line 19
                    ADC        #$00AC               
                    TCS                             
                    LDA        $99,S                
                    AND        #$00F0               
                    ORA        #$5707               
                    STA        $99,S                
                    LDA        $A1,S                
                    AND        #$0F00               
                    ORA        #$5077               
                    STA        $A1,S                
                    PHX                             
                    PHX                             
                    PEA        $7775                
                    PHD                             
                    PHD                             
                    TSC                             ; Line 20
                    ADC        #$00AA               
                    TCS                             
                    SEP        #$20                 
                    LDA        $A2,S                
                    AND        #$0F                 
                    ORA        #$70                 
                    STA        $A2,S                
                    REP        #$30                 
                    PHX                             
                    PEA        $7757                
                    PHY                             
                    TSC                             ; Line 21
                    ADC        #$00A7               
                    TCS                             
                    LDA        $A0,S                
                    AND        #$0F00               
                    ORA        #$5057               
                    STA        $A0,S                
                    SEP        #$20                 
                    LDA        $9B,S                
                    AND        #$F0                 
                    ORA        #$07                 
                    STA        $9B,S                
                    REP        #$30                 
                    PEA        $7577                
                    PEA        $7775                
                    PHD                             
                    TSC                             ; Line 22
                    ADC        #$00A5               
                    TCS                             
                    LDA        $A1,S                
                    AND        #$0F00               
                    ORA        #$7075               
                    STA        $A1,S                
                    PHY                             
                    PHY                             
                    TSC                             ; Line 23
                    ADC        #$00A4               
                    TCS                             
                    TYA                             
                    STA        $9F,S                
                    LDA        $9D,S                
                    AND        #$00F0               
                    ORA        #$5707               
                    STA        $9D,S                
                    LDA        $A1,S                
                    AND        #$0F00               
                    ORA        #$5057               
                    STA        $A1,S                
                    PHD                             
                    PHD                             
                    TSC                             ; Line 25
                    ADC        #$0135               
                    TCS                             
                    LDA        $0C,S                
                    AND        #$00F0               
                    ORA        #$7505               
                    STA        $0C,S                
                    LDA        $AC,S                
                    AND        #$00F0               
                    ORA        #$5707               
                    STA        $AC,S                
                    TSC                             
                    ADC        #$0011               
                    TCS                             
                    PEA        $3375                
                    PHD                             
                    TSC                             ; Line 26
                    ADC        #$00A4               
                    TCS                             
                    LDA        $A0,S                
                    AND        #$0F00               
                    ORA        #$6076               
                    STA        $A0,S                
                    SEP        #$20                 
                    LDA        $97,S                
                    AND        #$F0                 
                    ORA        #$06                 
                    STA        $97,S                
                    REP        #$30                 
                    PEA        $3633                
                    PEA        $5357                
                    TSC                             ; Line 27
                    ADC        #$00A3               
                    TCS                             
                    LDA        $97,S                
                    AND        #$00F0               
                    ORA        #$6701               
                    STA        $97,S                
                    LDA        $A1,S                
                    AND        #$0F00               
                    ORA        #$6066               
                    STA        $A1,S                
                    PEA        $2632                
                    PEA        $3333                
                    PEA        $6366                
                    PEA        $6666                
                    TSC                             ; Line 28
                    ADC        #$00A8               
                    TCS                             
                    PHX                             
                    PEA        $5723                
                    PEA        $6667                
                    PEA        $6767                
                    TSC                             ; Line 29
                    ADC        #$00AA               
                    TCS                             
                    PEA        $6676                
                    PEA        $7775                
                    PEA        $7532                
                    PEA        $7676                
                    PHX                             
                    PEA        $7666                
                    TSC                             ; Line 30
                    ADC        #$00AC               
                    TCS                             
                    SEP        #$20                 
                    LDA        $A1,S                
                    AND        #$0F                 
                    ORA        #$70                 
                    STA        $A1,S                
                    REP        #$30                 
                    PEA        $6767                
                    PEA        $6757                
                    PEA        $5732                
                    PEA        $7757                
                    PHY                             
                    PEA        $6716                
                    TSC                             ; Line 31
                    ADC        #$00AC               
                    TCS                             
                    LDA        #$5777               
                    STA        $95,S                
                    LDA        $97,S                
                    AND        #$000F               
                    ORA        #$5750               
                    STA        $97,S                
                    SEP        #$20                 
                    LDA        $A1,S                
                    AND        #$0F                 
                    ORA        #$60                 
                    STA        $A1,S                
                    REP        #$30                 
                    PEA        $1676                
                    PEA        $7675                
                    PEA        $7535                
                    PHD                             
                    PHD                             
                    PEA        $7566                
                    TSC                             ; Line 32
                    ADC        #$00AC               
                    TCS                             
                    TDC                             
                    STA        $9A,S                
                    LDA        $95,S                
                    AND        #$00F0               
                    ORA        #$7507               
                    STA        $95,S                
                    SEP        #$20                 
                    LDA        #$75                 
                    STA        $99,S                
                    LDA        $97,S                
                    AND        #$0F                 
                    ORA        #$50                 
                    STA        $97,S                
                    LDA        $9C,S                
                    AND        #$F0                 
                    ORA        #$05                 
                    STA        $9C,S                
                    LDA        $A1,S                
                    AND        #$0F                 
                    ORA        #$70                 
                    STA        $A1,S                
                    REP        #$30                 
                    PEA        $6776                
                    PEA        $7757                
                    PHY                             
                    PHY                             
                    TSC                             ; Line 33
                    ADC        #$00A8               
                    TCS                             
                    LDA        #$7577               
                    STA        $96,S                
                    SEP        #$20                 
                    LDA        $95,S                
                    AND        #$F0                 
                    ORA        #$07                 
                    STA        $95,S                
                    LDA        $A1,S                
                    AND        #$0F                 
                    ORA        #$70                 
                    STA        $A1,S                
                    REP        #$30                 
                    PEA        $6767                
                    PEA        $7775                
                    TSC                             ; Line 34
                    ADC        #$00A4               
                    TCS                             
                    LDA        #$5777               
                    STA        $96,S                
                    TXA                             
                    STA        $9F,S                
                    SEP        #$20                 
                    LDA        $98,S                
                    AND        #$0F                 
                    ORA        #$50                 
                    STA        $98,S                
                    LDA        $A1,S                
                    AND        #$0F                 
                    ORA        #$70                 
                    STA        $A1,S                
                    REP        #$30                 
                    PEA        $7776                
                    PHY                             
                    TSC                             ; Line 36
                    ADC        #$0132               
                    TCS                             
                    LDA        #$7577               
                    STA        $08,S                
                    STA        $A9,S                
                    LDA        #$7776               
                    STA        $11,S                
                    LDA        $B1,S                
                    AND        #$00F0               
                    ORA        #$7706               
                    STA        $B1,S                
                    SEP        #$20                 
                    LDA        $0A,S                
                    AND        #$0F                 
                    ORA        #$70                 
                    STA        $0A,S                
                    LDA        $13,S                
                    AND        #$0F                 
                    ORA        #$70                 
                    STA        $13,S                
                    LDA        $B3,S                
                    AND        #$0F                 
                    ORA        #$70                 
                    STA        $B3,S                
                    REP        #$30                 
                    TSC                             ; Line 38
                    ADC        #$0140               
                    TCS                             
                    LDA        #$5777               
                    STA        $09,S                
                    LDA        #$4454               
                    STA        $A9,S                
                    LDA        $05,S                
                    AND        #$F0F0               
                    ORA        #$0505               
                    STA        $05,S                
                    LDA        $07,S                
                    AND        #$F0F0               
                    ORA        #$0505               
                    STA        $07,S                
                    LDA        $0C,S                
                    AND        #$F0F0               
                    ORA        #$0505               
                    STA        $0C,S                
                    LDA        $0E,S                
                    AND        #$F0F0               
                    ORA        #$0505               
                    STA        $0E,S                
                    LDA        $10,S                
                    AND        #$F0F0               
                    ORA        #$0705               
                    STA        $10,S                
                    LDA        $12,S                
                    AND        #$0F00               
                    ORA        #$7077               
                    STA        $12,S                
                    LDA        $A0,S                
                    AND        #$0F0F               
                    ORA        #$5050               
                    STA        $A0,S                
                    LDA        $A2,S                
                    AND        #$0F0F               
                    ORA        #$5050               
                    STA        $A2,S                
                    LDA        $A4,S                
                    AND        #$0F0F               
                    ORA        #$5050               
                    STA        $A4,S                
                    LDA        $A6,S                
                    AND        #$0F0F               
                    ORA        #$5050               
                    STA        $A6,S                
                    LDA        $AC,S                
                    AND        #$0F0F               
                    ORA        #$5050               
                    STA        $AC,S                
                    LDA        $AE,S                
                    AND        #$0F0F               
                    ORA        #$5050               
                    STA        $AE,S                
                    LDA        $B0,S                
                    AND        #$0F0F               
                    ORA        #$5050               
                    STA        $B0,S                
                    LDA        $B2,S                
                    AND        #$0F00               
                    ORA        #$7077               
                    STA        $B2,S                
                    SEP        #$20                 
                    LDA        $0B,S                
                    AND        #$F0                 
                    ORA        #$05                 
                    STA        $0B,S                
                    LDA        $A8,S                
                    AND        #$0F                 
                    ORA        #$50                 
                    STA        $A8,S                
                    LDA        $AB,S                
                    AND        #$0F                 
                    ORA        #$50                 
                    STA        $AB,S                
                    REP        #$30                 
                    TSC                             ; Line 40
                    ADC        #$0140               
                    TCS                             
                    LDA        #$4444               
                    STA        $09,S                
                    STA        $B2,S                
                    LDA        #$4544               
                    STA        $12,S                
                    LDA        $01,S                
                    AND        #$F0F0               
                    ORA        #$0505               
                    STA        $01,S                
                    LDA        $03,S                
                    AND        #$F0F0               
                    ORA        #$0505               
                    STA        $03,S                
                    LDA        $05,S                
                    AND        #$F0F0               
                    ORA        #$0505               
                    STA        $05,S                
                    LDA        $07,S                
                    AND        #$F0F0               
                    ORA        #$0405               
                    STA        $07,S                
                    LDA        $0C,S                
                    AND        #$F0F0               
                    ORA        #$0505               
                    STA        $0C,S                
                    LDA        $0E,S                
                    AND        #$F0F0               
                    ORA        #$0505               
                    STA        $0E,S                
                    LDA        $10,S                
                    AND        #$F0F0               
                    ORA        #$0505               
                    STA        $10,S                
                    LDA        $AC,S                
                    AND        #$0F0F               
                    ORA        #$5050               
                    STA        $AC,S                
                    LDA        $AE,S                
                    AND        #$0F0F               
                    ORA        #$5050               
                    STA        $AE,S                
                    LDA        $B0,S                
                    AND        #$000F               
                    ORA        #$5450               
                    STA        $B0,S                
                    SEP        #$20                 
                    LDA        $0B,S                
                    AND        #$F0                 
                    ORA        #$05                 
                    STA        $0B,S                
                    REP        #$30                 
*--                                                 
                    LDAL       $E1C068              ; Direct Page and Stack in Bank 00/
                    AND        #$FFCF               
                    STAL       $E1C068              
                    LDA        StackAddress         ; Restore Stack
                    TCS                             
                    PLD                             ; Restore Direct Page
                    CLI                             ; Enable Interrupts
                    PLB
                    RTL                             
                                                    
*-----------------------------------                                
Sprite_BL_03D       CLC                             ; Sprite #03D : 46x39, 1171 bytes, 1951 cycles
                    SEI                             ; Disable Interrupts
                    PHD                             ; Backup Direct Page
                    TSC                             ; Backup Stack
                    STA        StackAddress         
                    LDAL       $E1C068              ; Direct Page and Stack in Bank 01/
                    ORA        #$0030               
                    STAL       $E1C068              
                    TYA                             ; Y = Sprite Target Screen Address (upper left corner)
                    TCS                             ; New Stack address
                    LDX        #$7575               ; Pattern #1 : 41
                    LDY        #$5757               ; Pattern #2 : 35
                    LDA        #$6666               ; Pattern #3 : 16
                    TCD                             
*--                                                 
                    LDA        #$5555               ; Line 0
                    STA        $0F,S                
                    STA        $AE,S                
                    LDA        $B0,S                
                    AND        #$0F00               
                    ORA        #$5055               
                    STA        $B0,S                
                    SEP        #$20                 
                    LDA        $0E,S                
                    AND        #$F0                 
                    ORA        #$05                 
                    STA        $0E,S                
                    REP        #$30                 
                    TSC                             ; Line 2
                    ADC        #$0140               
                    TCS                             
                    LDA        #$3333               
                    STA        $0E,S                
                    STA        $AE,S                
                    LDA        $10,S                
                    AND        #$0F00               
                    ORA        #$3033               
                    STA        $10,S                
                    LDA        $B0,S                
                    AND        #$0F00               
                    ORA        #$3033               
                    STA        $B0,S                
                    SEP        #$20                 
                    LDA        $0D,S                
                    AND        #$F0                 
                    ORA        #$03                 
                    STA        $0D,S                
                    LDA        $AD,S                
                    AND        #$F0                 
                    ORA        #$03                 
                    STA        $AD,S                
                    REP        #$30                 
                    TSC                             ; Line 4
                    ADC        #$0140               
                    TCS                             
                    LDA        #$4454               
                    STA        $0E,S                
                    LDA        #$5445               
                    STA        $AE,S                
                    LDA        $10,S                
                    AND        #$0F00               
                    ORA        #$5044               
                    STA        $10,S                
                    LDA        $B0,S                
                    AND        #$0F00               
                    ORA        #$4055               
                    STA        $B0,S                
                    SEP        #$20                 
                    LDA        $0D,S                
                    AND        #$F0                 
                    ORA        #$05                 
                    STA        $0D,S                
                    LDA        $AD,S                
                    AND        #$F0                 
                    ORA        #$05                 
                    STA        $AD,S                
                    REP        #$30                 
                    TSC                             ; Line 6
                    ADC        #$0140               
                    TCS                             
                    LDA        #$4444               
                    STA        $0E,S                
                    STA        $AF,S                
                    LDA        $10,S                
                    AND        #$0F00               
                    ORA        #$4044               
                    STA        $10,S                
                    SEP        #$20                 
                    LDA        $0D,S                
                    AND        #$F0                 
                    ORA        #$05                 
                    STA        $0D,S                
                    LDA        $AE,S                
                    AND        #$F0                 
                    ORA        #$04                 
                    STA        $AE,S                
                    REP        #$30                 
                    TSC                             ; Line 8
                    ADC        #$0140               
                    TCS                             
                    LDA        #$5455               
                    STA        $0F,S                
                    LDA        #$4444               
                    STA        $AF,S                
                    SEP        #$20                 
                    LDA        $0E,S                
                    AND        #$F0                 
                    ORA        #$04                 
                    STA        $0E,S                
                    LDA        $AE,S                
                    AND        #$F0                 
                    ORA        #$04                 
                    STA        $AE,S                
                    REP        #$30                 
                    TSC                             ; Line 10
                    ADC        #$0140               
                    TCS                             
                    LDA        #$4475               
                    STA        $0E,S                
                    LDA        $10,S                
                    AND        #$0F00               
                    ORA        #$7045               
                    STA        $10,S                
                    SEP        #$20                 
                    LDA        #$75                 
                    STA        $B1,S                
                    REP        #$30                 
                    TSC                             ; Line 11
                    ADC        #$00B0               
                    TCS                             
                    SEP        #$20                 
                    LDA        $9C,S                
                    AND        #$F0                 
                    ORA        #$06                 
                    STA        $9C,S                
                    REP        #$30                 
                    PEA        $4544                
                    PEA        $5577                
                    TSC                             ; Line 12
                    ADC        #$00A6               
                    TCS                             
                    LDA        $A0,S                
                    AND        #$0F00               
                    ORA        #$6066               
                    STA        $A0,S                
                    SEP        #$20                 
                    LDA        $99,S                
                    AND        #$F0                 
                    ORA        #$06                 
                    STA        $99,S                
                    REP        #$30                 
                    PEA        $7675                
                    PEA        $4544                
                    PEA        $1557                
                    TSC                             ; Line 13
                    ADC        #$00A5               
                    TCS                             
                    SEP        #$20                 
                    LDA        $98,S                
                    AND        #$F0                 
                    ORA        #$06                 
                    STA        $98,S                
                    REP        #$30                 
                    PEA        $7555                
                    PEA        $4465                
                    PEA        $5766                
                    TSC                             ; Line 14
                    ADC        #$00A8               
                    TCS                             
                    LDA        $A0,S                
                    AND        #$0F00               
                    ORA        #$6076               
                    STA        $A0,S                
                    PEA        $6676                
                    PEA        $7557                
                    PEA        $5471                
                    PEA        $6567                
                    PEA        $6766                
                    TSC                             ; Line 15
                    ADC        #$00A9               
                    TCS                             
                    SEP        #$20                 
                    LDA        $A2,S                
                    AND        #$0F                 
                    ORA        #$60                 
                    STA        $A2,S                
                    REP        #$30                 
                    PHX                             
                    PEA        $7745                
                    PEA        $5477                
                    PEA        $7777                
                    PEA        $7666                
                    PHD                             
                    TSC                             ; Line 16
                    ADC        #$00AD               
                    TCS                             
                    PEA        $5657                
                    PEA        $7766                
                    PEA        $4444                
                    PEA        $7777                
                    PEA        $7577                
                    PEA        $6767                
                    PEA        $6766                
                    PEA        $6644                
                    TSC                             ; Line 17
                    ADC        #$00B1               
                    TCS                             
                    PEA        $7677                
                    PEA        $7566                
                    PEA        $7644                
                    PEA        $7475                
                    PHY                             
                    PHY                             
                    PHY                             
                    PEA        $5777                
                    PEA        $4444                
                    TSC                             ; Line 18
                    ADC        #$00B2               
                    TCS                             
                    LDA        $97,S                
                    AND        #$00F0               
                    ORA        #$5707               
                    STA        $97,S                
                    PHD                             
                    PHD                             
                    PEA        $7675                
                    PEA        $7777                
                    PHX                             
                    PHX                             
                    PHX                             
                    PHX                             
                    TSC                             ; Line 19
                    ADC        #$00B0               
                    TCS                             
                    SEP        #$20                 
                    LDA        $98,S                
                    AND        #$F0                 
                    ORA        #$05                 
                    STA        $98,S                
                    REP        #$30                 
                    PEA        $6767                
                    PEA        $6767                
                    PHY                             
                    PHY                             
                    TSC                             ; Line 20
                    ADC        #$00A8               
                    TCS                             
                    LDA        $9F,S                
                    AND        #$0F00               
                    ORA        #$6077               
                    STA        $9F,S                
                    PEA        $7676                
                    PEA        $7677                
                    PHX                             
                    PHX                             
                    TSC                             ; Line 21
                    ADC        #$00A6               
                    TCS                             
                    LDA        $A1,S                
                    AND        #$0F00               
                    ORA        #$7075               
                    STA        $A1,S                
                    PEA        $7757                
                    PHY                             
                    PHY                             
                    TSC                             ; Line 22
                    ADC        #$00A6               
                    TCS                             
                    SEP        #$20                 
                    LDA        $A1,S                
                    AND        #$0F                 
                    ORA        #$50                 
                    STA        $A1,S                
                    REP        #$30                 
                    PEA        $5575                
                    PHX                             
                    PHX                             
                    TSC                             ; Line 23
                    ADC        #$00A6               
                    TCS                             
                    LDA        $A0,S                
                    AND        #$0F00               
                    ORA        #$2033               
                    STA        $A0,S                
                    SEP        #$20                 
                    LDA        $9B,S                
                    AND        #$F0                 
                    ORA        #$02                 
                    STA        $9B,S                
                    REP        #$30                 
                    PEA        $5557                
                    PHY                             
                    PEA        $5753                
                    TSC                             ; Line 24
                    ADC        #$00A5               
                    TCS                             
                    LDA        $9C,S                
                    AND        #$00F0               
                    ORA        #$6606               
                    STA        $9C,S                
                    SEP        #$20                 
                    LDA        $A2,S                
                    AND        #$0F                 
                    ORA        #$30                 
                    STA        $A2,S                
                    REP        #$30                 
                    PEA        $7333                
                    PEA        $3333                
                    TSC                             ; Line 25
                    ADC        #$00A5               
                    TCS                             
                    SEP        #$20                 
                    LDA        #$66                 
                    STA        $A1,S                
                    REP        #$30                 
                    PHD                             
                    PEA        $3262                
                    TSC                             ; Line 26
                    ADC        #$00A4               
                    TCS                             
                    SEP        #$20                 
                    LDA        $A2,S                
                    AND        #$0F                 
                    ORA        #$60                 
                    STA        $A2,S                
                    REP        #$30                 
                    PEA        $6676                
                    PEA        $3663                
                    PHD                             
                    PHD                             
                    TSC                             ; Line 27
                    ADC        #$00A9               
                    TCS                             
                    SEP        #$20                 
                    LDA        $91,S                
                    AND        #$F0                 
                    ORA        #$06                 
                    STA        $91,S                
                    REP        #$30                 
                    PEA        $1667                
                    PEA        $6773                
                    PEA        $7376                
                    PEA        $7676                
                    PHD                             
                    PHD                             
                    TSC                             ; Line 28
                    ADC        #$00AD               
                    TCS                             
                    SEP        #$20                 
                    LDA        #$44                 
                    STA        $8C,S                
                    REP        #$30                 
                    PEA        $1676                
                    PEA        $7677                
                    PEA        $5333                
                    PHY                             
                    PEA        $5767                
                    PEA        $6767                
                    PEA        $6766                
                    PHD                             
                    TSC                             ; Line 29
                    ADC        #$00B0               
                    TCS                             
                    PEA        $6767                
                    PEA        $7535                
                    PHX                             
                    PHX                             
                    PHX                             
                    PHX                             
                    PHX                             
                    PEA        $7676                
                    PHD                             
                    PEA        $4444                
                    TSC                             ; Line 30
                    ADC        #$00B4               
                    TCS                             
                    SEP        #$20                 
                    LDA        #$77                 
                    STA        $A0,S                
                    REP        #$30                 
                    PEA        $5657                
                    PHY                             
                    PHY                             
                    PHY                             
                    PHY                             
                    PHY                             
                    PHY                             
                    PHY                             
                    PEA        $6767                
                    PEA        $4444                
                    TSC                             ; Line 31
                    ADC        #$00B3               
                    TCS                             
                    SEP        #$20                 
                    LDA        $A1,S                
                    AND        #$0F                 
                    ORA        #$70                 
                    STA        $A1,S                
                    REP        #$30                 
                    PHX                             
                    PHX                             
                    PHX                             
                    PHX                             
                    PHX                             
                    PHX                             
                    PHX                             
                    PHX                             
                    PEA        $7544                
                    TSC                             ; Line 32
                    ADC        #$00B2               
                    TCS                             
                    TXA                             
                    STA        $9E,S                
                    SEP        #$20                 
                    LDA        $A0,S                
                    AND        #$0F                 
                    ORA        #$70                 
                    STA        $A0,S                
                    REP        #$30                 
                    PEA        $7757                
                    PHY                             
                    TSC                             ; Line 34
                    ADC        #$0131               
                    TCS                             
                    TYA                             
                    STA        $11,S                
                    LDA        #$7775               
                    STA        $B1,S                
                    SEP        #$20                 
                    LDA        $13,S                
                    AND        #$0F                 
                    ORA        #$70                 
                    STA        $13,S                
                    REP        #$30                 
                    TSC                             ; Line 36
                    ADC        #$0140               
                    TCS                             
                    LDA        #$4544               
                    STA        $B1,S                
                    LDA        $0A,S                
                    AND        #$F0F0               
                    ORA        #$0505               
                    STA        $0A,S                
                    LDA        $0C,S                
                    AND        #$F0F0               
                    ORA        #$0505               
                    STA        $0C,S                
                    LDA        $0E,S                
                    AND        #$F0F0               
                    ORA        #$0505               
                    STA        $0E,S                
                    LDA        $10,S                
                    AND        #$00F0               
                    ORA        #$4405               
                    STA        $10,S                
                    LDA        $13,S                
                    AND        #$0F0F               
                    ORA        #$5050               
                    STA        $13,S                
                    LDA        $A5,S                
                    AND        #$0F0F               
                    ORA        #$5050               
                    STA        $A5,S                
                    LDA        $A7,S                
                    AND        #$0F0F               
                    ORA        #$5050               
                    STA        $A7,S                
                    LDA        $A9,S                
                    AND        #$0F0F               
                    ORA        #$5050               
                    STA        $A9,S                
                    LDA        $AB,S                
                    AND        #$0F0F               
                    ORA        #$5050               
                    STA        $AB,S                
                    LDA        $AD,S                
                    AND        #$0F0F               
                    ORA        #$5050               
                    STA        $AD,S                
                    LDA        $AF,S                
                    AND        #$0F0F               
                    ORA        #$5050               
                    STA        $AF,S                
                    LDA        $B4,S                
                    AND        #$F0F0               
                    ORA        #$0505               
                    STA        $B4,S                
                    SEP        #$20                 
                    LDA        $12,S                
                    AND        #$0F                 
                    ORA        #$40                 
                    STA        $12,S                
                    LDA        $B3,S                
                    AND        #$F0                 
                    ORA        #$05                 
                    STA        $B3,S                
                    REP        #$30                 
                    TSC                             ; Line 38
                    ADC        #$0140               
                    TCS                             
                    LDA        #$4444               
                    STA        $11,S                
                    LDA        $02,S                
                    AND        #$F0F0               
                    ORA        #$0505               
                    STA        $02,S                
                    LDA        $04,S                
                    AND        #$F0F0               
                    ORA        #$0505               
                    STA        $04,S                
                    LDA        $06,S                
                    AND        #$F0F0               
                    ORA        #$0505               
                    STA        $06,S                
                    LDA        $08,S                
                    AND        #$F0F0               
                    ORA        #$0505               
                    STA        $08,S                
                    LDA        $0A,S                
                    AND        #$F0F0               
                    ORA        #$0505               
                    STA        $0A,S                
                    LDA        $0C,S                
                    AND        #$F0F0               
                    ORA        #$0505               
                    STA        $0C,S                
                    LDA        $0E,S                
                    AND        #$F0F0               
                    ORA        #$0505               
                    STA        $0E,S                
                    LDA        $13,S                
                    AND        #$0F0F               
                    ORA        #$5050               
                    STA        $13,S                
                    LDA        $15,S                
                    AND        #$0F0F               
                    ORA        #$5050               
                    STA        $15,S                
                    SEP        #$20                 
                    LDA        $10,S                
                    AND        #$F0                 
                    ORA        #$05                 
                    STA        $10,S                
                    REP        #$30                 
*--                                                 
                    LDAL       $E1C068              ; Direct Page and Stack in Bank 00/
                    AND        #$FFCF               
                    STAL       $E1C068              
                    LDA        StackAddress         ; Restore Stack
                    TCS                             
                    PLD                             ; Restore Direct Page
                    CLI                             ; Enable Interrupts
                    PLB
                    RTL                             
                                                    
*-----------------------------------                                
Sprite_BL_03E       CLC                             ; Sprite #03E : 32x38, 1186 bytes, 1919 cycles
                    SEI                             ; Disable Interrupts
                    PHD                             ; Backup Direct Page
                    TSC                             ; Backup Stack
                    STA        StackAddress         
                    LDAL       $E1C068              ; Direct Page and Stack in Bank 01/
                    ORA        #$0030               
                    STAL       $E1C068              
                    TYA                             ; Y = Sprite Target Screen Address (upper left corner)
                    TCS                             ; New Stack address
                    LDX        #$7575               ; Pattern #1 : 22
                    LDY        #$5757               ; Pattern #2 : 16
                    LDA        #$5555               ; Pattern #3 : 6
                    TCD                             
*--                                                 
                    TDC                             ; Line 0
                    STA        $04,S                
                    SEP        #$20                 
                    LDA        $06,S                
                    AND        #$0F                 
                    ORA        #$50                 
                    STA        $06,S                
                    LDA        $A7,S                
                    AND        #$0F                 
                    ORA        #$50                 
                    STA        $A7,S                
                    REP        #$30                 
                    TSC                             ; Line 1
                    ADC        #$00A6               
                    TCS                             
                    SEP        #$20                 
                    LDA        $A1,S                
                    AND        #$0F                 
                    ORA        #$30                 
                    STA        $A1,S                
                    REP        #$30                 
                    PHD                             
                    PHD                             
                    TSC                             ; Line 2
                    ADC        #$00A4               
                    TCS                             
                    SEP        #$20                 
                    LDA        $A1,S                
                    AND        #$0F                 
                    ORA        #$30                 
                    STA        $A1,S                
                    REP        #$30                 
                    PHD                             
                    PEA        $5535                
                    TSC                             ; Line 3
                    ADC        #$00A4               
                    TCS                             
                    SEP        #$20                 
                    LDA        $A1,S                
                    AND        #$0F                 
                    ORA        #$50                 
                    STA        $A1,S                
                    REP        #$30                 
                    PEA        $3333                
                    PEA        $3333                
                    TSC                             ; Line 4
                    ADC        #$00A4               
                    TCS                             
                    SEP        #$20                 
                    LDA        $A1,S                
                    AND        #$0F                 
                    ORA        #$50                 
                    STA        $A1,S                
                    REP        #$30                 
                    PEA        $3433                
                    PEA        $3354                
                    TSC                             ; Line 5
                    ADC        #$00A4               
                    TCS                             
                    LDA        #$4555               
                    STA        $9E,S                
                    LDA        $A0,S                
                    AND        #$0F00               
                    ORA        #$5054               
                    STA        $A0,S                
                    SEP        #$20                 
                    LDA        $9D,S                
                    AND        #$F0                 
                    ORA        #$04                 
                    STA        $9D,S                
                    REP        #$30                 
                    PEA        $4444                
                    PEA        $4454                
                    TSC                             ; Line 7
                    ADC        #$013E               
                    TCS                             
                    LDA        #$4454               
                    STA        $05,S                
                    LDA        #$4475               
                    STA        $A3,S                
                    LDA        $03,S                
                    AND        #$00F0               
                    ORA        #$4404               
                    STA        $03,S                
                    LDA        $A5,S                
                    AND        #$0F00               
                    ORA        #$4044               
                    STA        $A5,S                
                    TSC                             ; Line 9
                    ADC        #$0145               
                    TCS                             
                    LDA        $01,S                
                    AND        #$0F00               
                    ORA        #$6056               
                    STA        $01,S                
                    LDA        $9C,S                
                    AND        #$00F0               
                    ORA        #$1706               
                    STA        $9C,S                
                    LDA        $A2,S                
                    AND        #$0F00               
                    ORA        #$6076               
                    STA        $A2,S                
                    PEA        $5445                
                    PEA        $7576                
                    TSC                             ; Line 10
                    ADC        #$00A5               
                    TCS                             
                    PEA        $5746                
                    PEA        $5676                
                    TSC                             ; Line 11
                    ADC        #$00A6               
                    TCS                             
                    LDA        $98,S                
                    AND        #$00F0               
                    ORA        #$1606               
                    STA        $98,S                
                    LDA        $A0,S                
                    AND        #$0F00               
                    ORA        #$6067               
                    STA        $A0,S                
                    PEA        $7657                
                    PEA        $7645                
                    PEA        $6556                
                    PEA        $6661                
                    TSC                             ; Line 12
                    ADC        #$00A7               
                    TCS                             
                    LDA        $99,S                
                    AND        #$00F0               
                    ORA        #$6606               
                    STA        $99,S                
                    PEA        $5776                
                    PEA        $4565                
                    PEA        $7567                
                    TSC                             ; Line 13
                    ADC        #$00A8               
                    TCS                             
                    LDA        $97,S                
                    AND        #$00F0               
                    ORA        #$6706               
                    STA        $97,S                
                    SEP        #$20                 
                    LDA        $A1,S                
                    AND        #$0F                 
                    ORA        #$60                 
                    STA        $A1,S                
                    REP        #$30                 
                    PEA        $7676                
                    PEA        $5776                
                    PEA        $4565                
                    PEA        $5777                
                    TSC                             ; Line 14
                    ADC        #$00A8               
                    TCS                             
                    SEP        #$20                 
                    LDA        $97,S                
                    AND        #$F0                 
                    ORA        #$06                 
                    STA        $97,S                
                    REP        #$30                 
                    PEA        $6775                
                    PEA        $5766                
                    PEA        $7565                
                    PHX                             
                    TSC                             ; Line 15
                    ADC        #$00A9               
                    TCS                             
                    LDA        #$6777               
                    STA        $A0,S                
                    LDA        $96,S                
                    AND        #$00F0               
                    ORA        #$6706               
                    STA        $96,S                
                    LDA        $9E,S                
                    AND        #$00F0               
                    ORA        #$7505               
                    STA        $9E,S                
                    PEA        $7657                
                    PEA        $5777                
                    PEA        $6555                
                    PEA        $7757                
                    PEA        $5777                
                    TSC                             ; Line 16
                    ADC        #$00A7               
                    TCS                             
                    LDA        $99,S                
                    AND        #$00F0               
                    ORA        #$6601               
                    STA        $99,S                
                    SEP        #$20                 
                    LDA        $A8,S                
                    AND        #$0F                 
                    ORA        #$40                 
                    STA        $A8,S                
                    REP        #$30                 
                    PEA        $7565                
                    PEA        $5657                
                    PHX                             
                    TSC                             ; Line 17
                    ADC        #$00A6               
                    TCS                             
                    LDA        $99,S                
                    AND        #$00F0               
                    ORA        #$7606               
                    STA        $99,S                
                    SEP        #$20                 
                    LDA        $A2,S                
                    AND        #$F0                 
                    ORA        #$05                 
                    STA        $A2,S                
                    REP        #$30                 
                    PEA        $5744                
                    PEA        $4466                
                    PEA        $6161                
                    TSC                             
                    ADC        #$000D               
                    TCS                             
                    PEA        $7476                
                    PEA        $7676                
                    PHY                             
                    TSC                             ; Line 18
                    ADC        #$009F               
                    TCS                             
                    TYA                             
                    STA        $A4,S                
                    LDA        $99,S                
                    AND        #$00F0               
                    ORA        #$7707               
                    STA        $99,S                
                    LDA        $A6,S                
                    AND        #$0F00               
                    ORA        #$5057               
                    STA        $A6,S                
                    PEA        $7547                
                    PEA        $4476                
                    PEA        $7676                
                    TSC                             
                    ADC        #$000E               
                    TCS                             
                    PEA        $4474                
                    PHX                             
                    PHX                             
                    TSC                             ; Line 19
                    ADC        #$009E               
                    TCS                             
                    SEP        #$20                 
                    LDA        $9A,S                
                    AND        #$F0                 
                    ORA        #$05                 
                    STA        $9A,S                
                    REP        #$30                 
                    PHY                             
                    PEA        $5777                
                    PEA        $7777                
                    TSC                             ; Line 20
                    ADC        #$00A6               
                    TCS                             
                    LDA        $9A,S                
                    AND        #$00F0               
                    ORA        #$5707               
                    STA        $9A,S                
                    LDA        $A0,S                
                    AND        #$0F00               
                    ORA        #$5057               
                    STA        $A0,S                
                    PHX                             
                    PHX                             
                    PHX                             
                    TSC                             ; Line 21
                    ADC        #$00A5               
                    TCS                             
                    SEP        #$20                 
                    LDA        $A2,S                
                    AND        #$0F                 
                    ORA        #$70                 
                    STA        $A2,S                
                    REP        #$30                 
                    PHY                             
                    PHY                             
                    TSC                             ; Line 22
                    ADC        #$00A5               
                    TCS                             
                    PEA        $7375                
                    PHX                             
                    PHX                             
                    TSC                             ; Line 23
                    ADC        #$00A6               
                    TCS                             
                    PEA        $3233                
                    PEA        $3373                
                    PEA        $3323                
                    TSC                             ; Line 24
                    ADC        #$00A6               
                    TCS                             
                    LDA        $9A,S                
                    AND        #$00F0               
                    ORA        #$6606               
                    STA        $9A,S                
                    PEA        $6666                
                    PEA        $3272                
                    PEA        $6636                
                    TSC                             ; Line 25
                    ADC        #$00A7               
                    TCS                             
                    SEP        #$20                 
                    LDA        #$66                 
                    STA        $A1,S                
                    REP        #$30                 
                    PEA        $6666                
                    PEA        $7637                
                    PEA        $7766                
                    TSC                             ; Line 26
                    ADC        #$00A6               
                    TCS                             
                    LDA        $A1,S                
                    AND        #$0F00               
                    ORA        #$7061               
                    STA        $A1,S                
                    SEP        #$20                 
                    LDA        $98,S                
                    AND        #$F0                 
                    ORA        #$06                 
                    STA        $98,S                
                    REP        #$30                 
                    PEA        $7676                
                    PEA        $7735                
                    PEA        $7367                
                    PEA        $1766                
                    TSC                             ; Line 27
                    ADC        #$00A8               
                    TCS                             
                    LDA        $A1,S                
                    AND        #$0F00               
                    ORA        #$7017               
                    STA        $A1,S                
                    SEP        #$20                 
                    LDA        $98,S                
                    AND        #$F0                 
                    ORA        #$07                 
                    STA        $98,S                
                    REP        #$30                 
                    PEA        $6177                
                    PEA        $5737                
                    PEA        $3777                
                    PEA        $7616                
                    TSC                             ; Line 28
                    ADC        #$00A8               
                    TCS                             
                    SEP        #$20                 
                    LDA        $98,S                
                    AND        #$F0                 
                    ORA        #$07                 
                    STA        $98,S                
                    LDA        $9D,S                
                    AND        #$F0                 
                    ORA        #$07                 
                    STA        $9D,S                
                    LDA        $A2,S                
                    AND        #$0F                 
                    ORA        #$70                 
                    STA        $A2,S                
                    REP        #$30                 
                    PEA        $7777                
                    PHX                             
                    PHX                             
                    PEA        $6767                
                    TSC                             ; Line 29
                    ADC        #$00A4               
                    TCS                             
                    TXA                             
                    STA        $9D,S                
                    LDA        $9F,S                
                    AND        #$0F00               
                    ORA        #$7075               
                    STA        $9F,S                
                    SEP        #$20                 
                    LDA        $9C,S                
                    AND        #$F0                 
                    ORA        #$07                 
                    STA        $9C,S                
                    REP        #$30                 
                    PHY                             
                    PHY                             
                    TSC                             
                    ADC        #$0009               
                    TCS                             
                    PEA        $7757                
                    PHY                             
                    TSC                             ; Line 30
                    ADC        #$00A4               
                    TCS                             
                    LDA        #$7777               
                    STA        $98,S                
                    LDA        #$7757               
                    STA        $9F,S                
                    LDA        $9A,S                
                    AND        #$0F00               
                    ORA        #$5057               
                    STA        $9A,S                
                    LDA        $9D,S                
                    AND        #$00F0               
                    ORA        #$5707               
                    STA        $9D,S                
                    PEA        $7777                
                    PHX                             
                    TSC                             ; Line 32
                    ADC        #$013B               
                    TCS                             
                    TXA                             
                    STA        $02,S                
                    TYA                             
                    STA        $A3,S                
                    STA        $A6,S                
                    LDA        $06,S                
                    AND        #$00F0               
                    ORA        #$7505               
                    STA        $06,S                
                    LDA        $08,S                
                    AND        #$0F00               
                    ORA        #$7077               
                    STA        $08,S                
                    LDA        $A8,S                
                    AND        #$0F00               
                    ORA        #$7057               
                    STA        $A8,S                
                    SEP        #$20                 
                    LDA        #$77                 
                    STA        $A2,S                
                    LDA        $04,S                
                    AND        #$0F                 
                    ORA        #$70                 
                    STA        $04,S                
                    REP        #$30                 
                    TSC                             ; Line 34
                    ADC        #$0140               
                    TCS                             
                    TXA                             
                    STA        $03,S                
                    STA        $06,S                
                    LDA        #$5777               
                    STA        $A6,S                
                    LDA        $A1,S                
                    AND        #$0F0F               
                    ORA        #$5050               
                    STA        $A1,S                
                    LDA        $A3,S                
                    AND        #$0F00               
                    ORA        #$4044               
                    STA        $A3,S                
                    LDA        $A9,S                
                    AND        #$0F0F               
                    ORA        #$5050               
                    STA        $A9,S                
                    SEP        #$20                 
                    LDA        #$77                 
                    STA        $08,S                
                    LDA        $02,S                
                    AND        #$F0                 
                    ORA        #$07                 
                    STA        $02,S                
                    LDA        $A8,S                
                    AND        #$0F                 
                    ORA        #$50                 
                    STA        $A8,S                
                    REP        #$30                 
                    TSC                             ; Line 36
                    ADC        #$0140               
                    TCS                             
                    LDA        #$4444               
                    STA        $06,S                
                    STA        $A7,S                
                    LDA        #$4544               
                    STA        $A3,S                
                    LDA        $00,S                
                    AND        #$F0F0               
                    ORA        #$0505               
                    STA        $00,S                
                    LDA        $02,S                
                    AND        #$00F0               
                    ORA        #$4405               
                    STA        $02,S                
                    LDA        $04,S                
                    AND        #$0F0F               
                    ORA        #$5040               
                    STA        $04,S                
                    LDA        $08,S                
                    AND        #$F0F0               
                    ORA        #$0505               
                    STA        $08,S                
                    LDA        $0A,S                
                    AND        #$F0F0               
                    ORA        #$0505               
                    STA        $0A,S                
                    LDA        $0C,S                
                    AND        #$F0F0               
                    ORA        #$0505               
                    STA        $0C,S                
                    LDA        $A0,S                
                    AND        #$0F0F               
                    ORA        #$5050               
                    STA        $A0,S                
                    LDA        $A5,S                
                    AND        #$00F0               
                    ORA        #$4405               
                    STA        $A5,S                
                    LDA        $A9,S                
                    AND        #$0F0F               
                    ORA        #$5050               
                    STA        $A9,S                
                    LDA        $AB,S                
                    AND        #$0F0F               
                    ORA        #$5050               
                    STA        $AB,S                
                    LDA        $AD,S                
                    AND        #$0F0F               
                    ORA        #$5050               
                    STA        $AD,S                
                    SEP        #$20                 
                    LDA        #$54                 
                    STA        $A2,S                
                    REP        #$30                 
*--                                                 
                    LDAL       $E1C068              ; Direct Page and Stack in Bank 00/
                    AND        #$FFCF               
                    STAL       $E1C068              
                    LDA        StackAddress         ; Restore Stack
                    TCS                             
                    PLD                             ; Restore Direct Page
                    CLI                             ; Enable Interrupts
                    PLB
                    RTL                             
                                                    
*-----------------------------------                                
Sprite_BL_03F       CLC                             ; Sprite #03F : 38x48, 1616 bytes, 2588 cycles
                    SEI                             ; Disable Interrupts
                    PHD                             ; Backup Direct Page
                    TSC                             ; Backup Stack
                    STA        StackAddress         
                    LDAL       $E1C068              ; Direct Page and Stack in Bank 01/
                    ORA        #$0030               
                    STAL       $E1C068              
                    TYA                             ; Y = Sprite Target Screen Address (upper left corner)
                    TCS                             ; New Stack address
                    LDX        #$7575               ; Pattern #1 : 14
                    LDY        #$5777               ; Pattern #2 : 11
                    LDA        #$6766               ; Pattern #3 : 9
                    TCD                             
*--                                                 
                    LDA        #$5555               ; Line 0
                    STA        $0A,S                
                    STA        $AB,S                
                    LDA        $A9,S                
                    AND        #$00F0               
                    ORA        #$5505               
                    STA        $A9,S                
                    SEP        #$20                 
                    LDA        $0C,S                
                    AND        #$0F                 
                    ORA        #$50                 
                    STA        $0C,S                
                    REP        #$30                 
                    TSC                             ; Line 2
                    ADC        #$0140               
                    TCS                             
                    LDA        #$3333               
                    STA        $0A,S                
                    STA        $AA,S                
                    LDA        $0C,S                
                    AND        #$0F00               
                    ORA        #$3033               
                    STA        $0C,S                
                    LDA        $AC,S                
                    AND        #$0F00               
                    ORA        #$3033               
                    STA        $AC,S                
                    SEP        #$20                 
                    LDA        $09,S                
                    AND        #$F0                 
                    ORA        #$03                 
                    STA        $09,S                
                    LDA        $A9,S                
                    AND        #$F0                 
                    ORA        #$03                 
                    STA        $A9,S                
                    REP        #$30                 
                    TSC                             ; Line 4
                    ADC        #$0140               
                    TCS                             
                    LDA        #$4444               
                    STA        $0A,S                
                    LDA        #$4555               
                    STA        $AA,S                
                    LDA        $0C,S                
                    AND        #$0F00               
                    ORA        #$5045               
                    STA        $0C,S                
                    LDA        $AC,S                
                    AND        #$0F00               
                    ORA        #$5054               
                    STA        $AC,S                
                    SEP        #$20                 
                    LDA        $09,S                
                    AND        #$F0                 
                    ORA        #$05                 
                    STA        $09,S                
                    LDA        $A9,S                
                    AND        #$F0                 
                    ORA        #$04                 
                    STA        $A9,S                
                    REP        #$30                 
                    TSC                             ; Line 6
                    ADC        #$0140               
                    TCS                             
                    LDA        #$4444               
                    STA        $0A,S                
                    STA        $AA,S                
                    LDA        $0C,S                
                    AND        #$0F00               
                    ORA        #$5044               
                    STA        $0C,S                
                    SEP        #$20                 
                    LDA        $09,S                
                    AND        #$F0                 
                    ORA        #$04                 
                    STA        $09,S                
                    LDA        $AC,S                
                    AND        #$0F                 
                    ORA        #$40                 
                    STA        $AC,S                
                    REP        #$30                 
                    TSC                             ; Line 8
                    ADC        #$0140               
                    TCS                             
                    LDA        #$5545               
                    STA        $0A,S                
                    STA        $AA,S                
                    SEP        #$20                 
                    LDA        $0C,S                
                    AND        #$0F                 
                    ORA        #$40                 
                    STA        $0C,S                
                    LDA        $AC,S                
                    AND        #$0F                 
                    ORA        #$40                 
                    STA        $AC,S                
                    REP        #$30                 
                    TSC                             ; Line 10
                    ADC        #$0140               
                    TCS                             
                    LDA        #$4454               
                    STA        $0A,S                
                    LDA        $0C,S                
                    AND        #$0F00               
                    ORA        #$6056               
                    STA        $0C,S                
                    SEP        #$20                 
                    LDA        $09,S                
                    AND        #$F0                 
                    ORA        #$06                 
                    STA        $09,S                
                    REP        #$30                 
                    TSC                             ; Line 11
                    ADC        #$00AE               
                    TCS                             
                    LDA        $A0,S                
                    AND        #$0F00               
                    ORA        #$5077               
                    STA        $A0,S                
                    PEA        $7567                
                    PEA        $5544                
                    PEA        $5476                
                    TSC                             ; Line 12
                    ADC        #$00A5               
                    TCS                             
                    SEP        #$20                 
                    LDA        #$75                 
                    STA        $A2,S                
                    REP        #$30                 
                    PEA        $6556                
                    PEA        $4454                
                    PEA        $7666                
                    TSC                             ; Line 13
                    ADC        #$00A7               
                    TCS                             
                    LDA        $98,S                
                    AND        #$00F0               
                    ORA        #$6601               
                    STA        $98,S                
                    SEP        #$20                 
                    LDA        $A2,S                
                    AND        #$0F                 
                    ORA        #$50                 
                    STA        $A2,S                
                    REP        #$30                 
                    PHX                             
                    PEA        $5644                
                    PEA        $6567                
                    PEA        $6661                
                    TSC                             ; Line 14
                    ADC        #$00A9               
                    TCS                             
                    SEP        #$20                 
                    LDA        #$16                 
                    STA        $97,S                
                    REP        #$30                 
                    PHY                             
                    PEA        $5666                
                    PEA        $4565                
                    PEA        $7567                
                    TSC                             ; Line 15
                    ADC        #$00A9               
                    TCS                             
                    LDA        $95,S                
                    AND        #$00F0               
                    ORA        #$6606               
                    STA        $95,S                
                    PHX                             
                    PEA        $6757                
                    PEA        $6745                
                    PEA        $6575                
                    PEA        $7767                
                    TSC                             ; Line 16
                    ADC        #$00AA               
                    TCS                             
                    LDA        $94,S                
                    AND        #$00F0               
                    ORA        #$6606               
                    STA        $94,S                
                    LDA        $A0,S                
                    AND        #$0F00               
                    ORA        #$7075               
                    STA        $A0,S                
                    PHY                             
                    PEA        $7666                
                    PEA        $1575                
                    PEA        $6575                
                    PHX                             
                    TSC                             ; Line 17
                    ADC        #$00A9               
                    TCS                             
                    SEP        #$20                 
                    LDA        $A2,S                
                    AND        #$0F                 
                    ORA        #$70                 
                    STA        $A2,S                
                    REP        #$30                 
                    PEA        $6767                
                    PEA        $6765                
                    PEA        $5551                
                    PEA        $7757                
                    PEA        $5767                
                    TSC                             ; Line 18
                    ADC        #$00AB               
                    TCS                             
                    LDA        $A0,S                
                    AND        #$0F00               
                    ORA        #$5077               
                    STA        $A0,S                
                    PEA        $7576                
                    PEA        $6677                
                    PEA        $5651                
                    PEA        $5676                
                    PHX                             
                    PEA        $7567                
                    PEA        $6666                
                    TSC                             ; Line 19
                    ADC        #$00AD               
                    TCS                             
                    LDA        $99,S                
                    AND        #$00F0               
                    ORA        #$7607               
                    STA        $99,S                
                    LDA        $A1,S                
                    AND        #$0F00               
                    ORA        #$7075               
                    STA        $A1,S                
                    SEP        #$20                 
                    LDA        #$44                 
                    STA        $91,S                
                    REP        #$30                 
                    PEA        $6756                
                    PEA        $7767                
                    PEA        $1557                
                    PEA        $6677                
                    PEA        $5757                
                    PEA        $7766                
                    PEA        $6666                
                    PEA        $4444                
                    TSC                             ; Line 20
                    ADC        #$00A7               
                    TCS                             
                    LDA        #$5757               
                    STA        $9C,S                
                    LDA        $9E,S                
                    AND        #$0F00               
                    ORA        #$5057               
                    STA        $9E,S                
                    SEP        #$20                 
                    LDA        #$44                 
                    STA        $9A,S                
                    LDA        #$57                 
                    STA        $AB,S                
                    REP        #$30                 
                    PHX                             
                    PEA        $7776                
                    PEA        $7644                
                    TSC                             
                    ADC        #$000F               
                    TCS                             
                    PEA        $1675                
                    PEA        $7577                
                    PEA        $5671                
                    TSC                             ; Line 21
                    ADC        #$00A7               
                    TCS                             
                    SEP        #$20                 
                    LDA        #$75                 
                    STA        $A1,S                
                    REP        #$30                 
                    PHD                             
                    PEA        $5757                
                    PEA        $6767                
                    PEA        $6566                
                    TSC                             ; Line 22
                    ADC        #$00A8               
                    TCS                             
                    TDC                             
                    STA        $9A,S                
                    LDA        $9C,S                
                    AND        #$000F               
                    ORA        #$5760               
                    STA        $9C,S                
                    SEP        #$20                 
                    LDA        $99,S                
                    AND        #$F0                 
                    ORA        #$05                 
                    STA        $99,S                
                    LDA        $A2,S                
                    AND        #$0F                 
                    ORA        #$50                 
                    STA        $A2,S                
                    REP        #$30                 
                    PEA        $7766                
                    PHX                             
                    PEA        $7766                
                    PEA        $5666                
                    TSC                             ; Line 23
                    ADC        #$00A9               
                    TCS                             
                    LDA        $98,S                
                    AND        #$00F0               
                    ORA        #$6606               
                    STA        $98,S                
                    LDA        $A0,S                
                    AND        #$0F00               
                    ORA        #$7075               
                    STA        $A0,S                
                    PEA        $5766                
                    PEA        $5157                
                    TSC                             ; Line 24
                    ADC        #$00A3               
                    TCS                             
                    LDA        $99,S                
                    AND        #$00F0               
                    ORA        #$3303               
                    STA        $99,S                
                    LDA        $A1,S                
                    AND        #$0F00               
                    ORA        #$5067               
                    STA        $A1,S                
                    PEA        $6736                
                    PEA        $7375                
                    PEA        $7776                
                    TSC                             ; Line 25
                    ADC        #$00A6               
                    TCS                             
                    LDA        $A0,S                
                    AND        #$00F0               
                    ORA        #$4404               
                    STA        $A0,S                
                    SEP        #$20                 
                    LDA        #$72                 
                    STA        $99,S                
                    REP        #$30                 
                    PEA        $1622                
                    PEA        $3233                
                    PEA        $3333                
                    TSC                             ; Line 26
                    ADC        #$00A5               
                    TCS                             
                    LDA        #$4444               
                    STA        $A2,S                
                    LDA        $99,S                
                    AND        #$00F0               
                    ORA        #$7606               
                    STA        $99,S                
                    PEA        $7527                
                    PEA        $2222                
                    PEA        $3222                
                    TSC                             ; Line 27
                    ADC        #$00A6               
                    TCS                             
                    LDA        $A2,S                
                    AND        #$00F0               
                    ORA        #$4404               
                    STA        $A2,S                
                    PHY                             
                    PHD                             
                    PEA        $2373                
                    TSC                             ; Line 28
                    ADC        #$00A6               
                    TCS                             
                    SEP        #$20                 
                    LDA        $98,S                
                    AND        #$F0                 
                    ORA        #$06                 
                    STA        $98,S                
                    REP        #$30                 
                    PEA        $7577                
                    PEA        $6626                
                    PEA        $6363                
                    PEA        $6666                
                    TSC                             ; Line 29
                    ADC        #$00A8               
                    TCS                             
                    SEP        #$20                 
                    LDA        #$75                 
                    STA        $A0,S                
                    REP        #$30                 
                    PHY                             
                    PEA        $6636                
                    PEA        $6332                
                    PHD                             
                    TSC                             ; Line 30
                    ADC        #$00A7               
                    TCS                             
                    LDA        $98,S                
                    AND        #$00F0               
                    ORA        #$1606               
                    STA        $98,S                
                    LDA        $A0,S                
                    AND        #$0F00               
                    ORA        #$5077               
                    STA        $A0,S                
                    PEA        $7767                
                    PEA        $2676                
                    PEA        $3676                
                    PEA        $6661                
                    TSC                             ; Line 31
                    ADC        #$00A7               
                    TCS                             
                    LDA        $A1,S                
                    AND        #$0F00               
                    ORA        #$7075               
                    STA        $A1,S                
                    PEA        $6666                
                    PEA        $7777                
                    PEA        $6767                
                    TSC                             ; Line 32
                    ADC        #$00A6               
                    TCS                             
                    LDA        #$7776               
                    STA        $A0,S                
                    LDA        $98,S                
                    AND        #$00F0               
                    ORA        #$6606               
                    STA        $98,S                
                    LDA        $9E,S                
                    AND        #$00F0               
                    ORA        #$1606               
                    STA        $9E,S                
                    SEP        #$20                 
                    LDA        $A2,S                
                    AND        #$0F                 
                    ORA        #$50                 
                    STA        $A2,S                
                    REP        #$30                 
                    PHD                             
                    PEA        $5677                
                    PEA        $7766                
                    PEA        $6661                
                    TSC                             ; Line 33
                    ADC        #$00A5               
                    TCS                             
                    LDA        #$7567               
                    STA        $A3,S                
                    LDA        $9B,S                
                    AND        #$00F0               
                    ORA        #$1606               
                    STA        $9B,S                
                    LDA        $A1,S                
                    AND        #$00F0               
                    ORA        #$6606               
                    STA        $A1,S                
                    SEP        #$20                 
                    LDA        $A5,S                
                    AND        #$0F                 
                    ORA        #$70                 
                    STA        $A5,S                
                    REP        #$30                 
                    PEA        $7577                
                    PHD                             
                    TSC                             ; Line 34
                    ADC        #$00A4               
                    TCS                             
                    SEP        #$20                 
                    LDA        #$67                 
                    STA        $9B,S                
                    LDA        $A0,S                
                    AND        #$0F                 
                    ORA        #$50                 
                    STA        $A0,S                
                    REP        #$30                 
                    PHX                             
                    PEA        $7766                
                    TSC                             ; Line 35
                    ADC        #$00A3               
                    TCS                             
                    SEP        #$20                 
                    LDA        #$76                 
                    STA        $9C,S                
                    REP        #$30                 
                    PHY                             
                    PEA        $6761                
                    TSC                             
                    ADC        #$0009               
                    TCS                             
                    PHY                             
                    PEA        $1666                
                    TSC                             ; Line 36
                    ADC        #$009F               
                    TCS                             
                    SEP        #$20                 
                    LDA        $A0,S                
                    AND        #$0F                 
                    ORA        #$50                 
                    STA        $A0,S                
                    REP        #$30                 
                    PHX                             
                    PEA        $7676                
                    TSC                             
                    ADC        #$0009               
                    TCS                             
                    PEA        $7567                
                    PEA        $6661                
                    TSC                             ; Line 37
                    ADC        #$009E               
                    TCS                             
                    PEA        $5767                
                    PEA        $7667                
                    TSC                             
                    ADC        #$000A               
                    TCS                             
                    PHY                             
                    PEA        $1666                
                    TSC                             ; Line 38
                    ADC        #$009E               
                    TCS                             
                    TYA                             
                    STA        $9D,S                
                    STA        $A5,S                
                    LDA        $9F,S                
                    AND        #$0F00               
                    ORA        #$5057               
                    STA        $9F,S                
                    LDA        $A3,S                
                    AND        #$00F0               
                    ORA        #$7607               
                    STA        $A3,S                
                    PEA        $7577                
                    PHX                             
                    TSC                             
                    ADC        #$000A               
                    TCS                             
                    PEA        $7567                
                    PEA        $6777                
                    TSC                             ; Line 40
                    ADC        #$0136               
                    TCS                             
                    TXA                             
                    STA        $06,S                
                    STA        $0D,S                
                    LDA        #$5557               
                    STA        $A6,S                
                    TYA                             
                    STA        $AC,S                
                    LDA        $0B,S                
                    AND        #$00F0               
                    ORA        #$7507               
                    STA        $0B,S                
                    LDA        $AE,S                
                    AND        #$0F00               
                    ORA        #$5057               
                    STA        $AE,S                
                    SEP        #$20                 
                    LDA        $05,S                
                    AND        #$F0                 
                    ORA        #$07                 
                    STA        $05,S                
                    LDA        $A5,S                
                    AND        #$F0                 
                    ORA        #$07                 
                    STA        $A5,S                
                    REP        #$30                 
                    TSC                             ; Line 42
                    ADC        #$0140               
                    TCS                             
                    LDA        #$7555               
                    STA        $AE,S                
                    LDA        $05,S                
                    AND        #$00F0               
                    ORA        #$7507               
                    STA        $05,S                
                    LDA        $0C,S                
                    AND        #$00F0               
                    ORA        #$7507               
                    STA        $0C,S                
                    LDA        $0E,S                
                    AND        #$0F00               
                    ORA        #$5075               
                    STA        $0E,S                
                    LDA        $A5,S                
                    AND        #$00F0               
                    ORA        #$5707               
                    STA        $A5,S                
                    LDA        $AC,S                
                    AND        #$00F0               
                    ORA        #$7707               
                    STA        $AC,S                
                    SEP        #$20                 
                    LDA        $07,S                
                    AND        #$0F                 
                    ORA        #$50                 
                    STA        $07,S                
                    LDA        $A7,S                
                    AND        #$0F                 
                    ORA        #$50                 
                    STA        $A7,S                
                    REP        #$30                 
                    TSC                             ; Line 44
                    ADC        #$0140               
                    TCS                             
                    LDA        #$7557               
                    STA        $05,S                
                    LDA        #$5575               
                    STA        $0E,S                
                    LDA        #$4457               
                    STA        $AE,S                
                    LDA        $07,S                
                    AND        #$0F0F               
                    ORA        #$5050               
                    STA        $07,S                
                    LDA        $09,S                
                    AND        #$0F0F               
                    ORA        #$5050               
                    STA        $09,S                
                    LDA        $0B,S                
                    AND        #$0F0F               
                    ORA        #$5050               
                    STA        $0B,S                
                    LDA        $A1,S                
                    AND        #$F0F0               
                    ORA        #$0505               
                    STA        $A1,S                
                    LDA        $A3,S                
                    AND        #$F0F0               
                    ORA        #$0505               
                    STA        $A3,S                
                    LDA        $A6,S                
                    AND        #$F000               
                    ORA        #$0544               
                    STA        $A6,S                
                    LDA        $A8,S                
                    AND        #$F0F0               
                    ORA        #$0505               
                    STA        $A8,S                
                    LDA        $AA,S                
                    AND        #$F0F0               
                    ORA        #$0505               
                    STA        $AA,S                
                    LDA        $AC,S                
                    AND        #$F0F0               
                    ORA        #$0705               
                    STA        $AC,S                
                    LDA        $B0,S                
                    AND        #$0F0F               
                    ORA        #$5050               
                    STA        $B0,S                
                    SEP        #$20                 
                    LDA        #$75                 
                    STA        $0D,S                
                    LDA        $04,S                
                    AND        #$0F                 
                    ORA        #$50                 
                    STA        $04,S                
                    LDA        $10,S                
                    AND        #$F0                 
                    ORA        #$05                 
                    STA        $10,S                
                    LDA        $A5,S                
                    AND        #$F0                 
                    ORA        #$04                 
                    STA        $A5,S                
                    REP        #$30                 
                    TSC                             ; Line 46
                    ADC        #$0140               
                    TCS                             
                    LDA        #$4444               
                    STA        $05,S                
                    STA        $0F,S                
                    STA        $A4,S                
                    STA        $AF,S                
                    LDA        $00,S                
                    AND        #$0F0F               
                    ORA        #$5050               
                    STA        $00,S                
                    LDA        $02,S                
                    AND        #$0F0F               
                    ORA        #$5050               
                    STA        $02,S                
                    LDA        $08,S                
                    AND        #$0F0F               
                    ORA        #$5050               
                    STA        $08,S                
                    LDA        $0A,S                
                    AND        #$0F0F               
                    ORA        #$5050               
                    STA        $0A,S                
                    LDA        $0C,S                
                    AND        #$0F0F               
                    ORA        #$5050               
                    STA        $0C,S                
                    LDA        $AA,S                
                    AND        #$F0F0               
                    ORA        #$0505               
                    STA        $AA,S                
                    LDA        $AC,S                
                    AND        #$F0F0               
                    ORA        #$0505               
                    STA        $AC,S                
                    SEP        #$20                 
                    LDA        #$54                 
                    STA        $04,S                
                    LDA        #$44                 
                    STA        $0E,S                
                    STA        $A6,S                
                    LDA        $07,S                
                    AND        #$0F                 
                    ORA        #$50                 
                    STA        $07,S                
                    LDA        $AE,S                
                    AND        #$F0                 
                    ORA        #$05                 
                    STA        $AE,S                
                    REP        #$30                 
*--                                                 
                    LDAL       $E1C068              ; Direct Page and Stack in Bank 00/
                    AND        #$FFCF               
                    STAL       $E1C068              
                    LDA        StackAddress         ; Restore Stack
                    TCS                             
                    PLD                             ; Restore Direct Page
                    CLI                             ; Enable Interrupts
                    PLB
                    RTL                             
                       
*-----------------------------------

Sprite_AM_040       CLC                             ; Sprite #040 : 16x19, 370 bytes, 651 cycles
                    SEI                             ; Disable Interrupts
                    PHD                             ; Backup Direct Page
                    TSC                             ; Backup Stack
                    STA        StackAddress         
                    LDAL       $E1C068              ; Direct Page and Stack in Bank 01/
                    ORA        #$0030               
                    STAL       $E1C068              
                    TYA                             ; Y = Sprite Target Screen Address (upper left corner)
                    TCS                             ; New Stack address
                    LDX        #$5552               ; Pattern #1 : 9
                    LDY        #$5555               ; Pattern #2 : 8
                    LDA        #$5255               ; Pattern #3 : 7
                    TCD                             
*--                                                 
                    TYA                             ; Line 0
                    STA        $03,S                
                    LDA        $01,S                
                    AND        #$00F0               
                    ORA        #$5505               
                    STA        $01,S                
                    LDA        $05,S                
                    AND        #$0F00               
                    ORA        #$5055               
                    STA        $05,S                
                    TSC                             ; Line 1
                    ADC        #$00A5               
                    TCS                             
                    LDA        $9D,S                
                    AND        #$00F0               
                    ORA        #$5202               
                    STA        $9D,S                
                    LDA        $9F,S                
                    AND        #$0F00               
                    ORA        #$5052               
                    STA        $9F,S                
                    PHY                             
                    PHY                             
                    TSC                             ; Line 3
                    ADC        #$013F               
                    TCS                             
                    LDA        $02,S                
                    AND        #$00F0               
                    ORA        #$2202               
                    STA        $02,S                
                    LDA        $04,S                
                    AND        #$0F00               
                    ORA        #$2022               
                    STA        $04,S                
                    LDA        $A2,S                
                    AND        #$00F0               
                    ORA        #$5505               
                    STA        $A2,S                
                    LDA        $A4,S                
                    AND        #$0F00               
                    ORA        #$5055               
                    STA        $A4,S                
                    TSC                             ; Line 5
                    ADC        #$0145               
                    TCS                             
                    PHX                             
                    PHX                             
                    TSC                             ; Line 6
                    ADC        #$00A4               
                    TCS                             
                    LDA        #$2222               
                    STA        $9E,S                
                    LDA        $9C,S                
                    AND        #$00F0               
                    ORA        #$2202               
                    STA        $9C,S                
                    LDA        $A0,S                
                    AND        #$0F00               
                    ORA        #$2022               
                    STA        $A0,S                
                    PEA        $2525                
                    PEA        $2525                
                    TSC                             ; Line 8
                    ADC        #$0145               
                    TCS                             
                    LDA        $9A,S                
                    AND        #$00F0               
                    ORA        #$5205               
                    STA        $9A,S                
                    LDA        $A0,S                
                    AND        #$0F00               
                    ORA        #$5055               
                    STA        $A0,S                
                    LDA        #$2225               
                    PHA                             
                    PHA                             
                    PHA                             
                    TSC                             ; Line 9
                    ADC        #$00A5               
                    TCS                             
                    LDA        $9B,S                
                    AND        #$00F0               
                    ORA        #$5502               
                    STA        $9B,S                
                    LDA        $A1,S                
                    AND        #$0F00               
                    ORA        #$5052               
                    STA        $A1,S                
                    PHD                             
                    PHD                             
                    TSC                             ; Line 10
                    ADC        #$00A4               
                    TCS                             
                    PHX                             
                    PHX                             
                    TSC                             ; Line 11
                    ADC        #$00A6               
                    TCS                             
                    LDA        #$2522               
                    PEA        $2222                
                    PHA                             
                    PHA                             
                    PHA                             
                    TSC                             ; Line 12
                    ADC        #$00A8               
                    TCS                             
                    LDA        #$2255               
                    PHA                             
                    PHA                             
                    PHA                             
                    PHA                             
                    TSC                             ; Line 13
                    ADC        #$00A8               
                    TCS                             
                    PHX                             
                    PHX                             
                    PHX                             
                    PHX                             
                    TSC                             ; Line 14
                    ADC        #$00A8               
                    TCS                             
                    LDA        $99,S                
                    AND        #$00F0               
                    ORA        #$2202               
                    STA        $99,S                
                    LDA        $9F,S                
                    AND        #$0F00               
                    ORA        #$2052               
                    STA        $9F,S                
                    LDA        #$5225               
                    PHA                             
                    PHA                             
                    PHA                             
                    PHA                             
                    TSC                             ; Line 15
                    ADC        #$00A6               
                    TCS                             
                    PEA        $2252                
                    PEA        $2252                
                    TSC                             ; Line 16
                    ADC        #$00A5               
                    TCS                             
                    LDA        #$5525               
                    PHA                             
                    PHA                             
                    PHA                             
                    TSC                             ; Line 17
                    ADC        #$00A5               
                    TCS                             
                    TYA                             
                    STA        $9E,S                
                    LDA        $9C,S                
                    AND        #$00F0               
                    ORA        #$5505               
                    STA        $9C,S                
                    LDA        $A0,S                
                    AND        #$0F00               
                    ORA        #$5055               
                    STA        $A0,S                
                    PHY                             
                    PHY                             
*--                                                 
                    LDAL       $E1C068              ; Direct Page and Stack in Bank 00/
                    AND        #$FFCF               
                    STAL       $E1C068              
                    LDA        StackAddress         ; Restore Stack
                    TCS                             
                    PLD                             ; Restore Direct Page
                    CLI                             ; Enable Interrupts
                    PLB
                    RTL                             
                                                                                 
*-----------------------------------                                

Sprite_RR_041       CLC                             ; Sprite #041 : 44x56, 1985 bytes, 3185 cycles
                    SEI                             ; Disable Interrupts
                    PHD                             ; Backup Direct Page
                    TSC                             ; Backup Stack
                    STA        StackAddress         
                    LDAL       $E1C068              ; Direct Page and Stack in Bank 01/
                    ORA        #$0030               
                    STAL       $E1C068              
                    TYA                             ; Y = Sprite Target Screen Address (upper left corner)
                    TCS                             ; New Stack address
                    LDX        #$6161               ; Pattern #1 : 17
                    LDY        #$4444               ; Pattern #2 : 15
                    LDA        #$3111               ; Pattern #3 : 14
                    TCD                             
*--                                                 
                    LDA        #$6666               ; Line 0
                    STA        $A9,S                
                    LDA        $09,S                
                    AND        #$00F0               
                    ORA        #$6606               
                    STA        $09,S                
                    LDA        $AB,S                
                    AND        #$0F00               
                    ORA        #$6066               
                    STA        $AB,S                
                    SEP        #$20                 
                    LDA        $0B,S                
                    AND        #$0F                 
                    ORA        #$60                 
                    STA        $0B,S                
                    REP        #$30                 
                    TSC                             ; Line 2
                    ADC        #$0140               
                    TCS                             
                    SEP        #$20                 
                    LDA        $08,S                
                    AND        #$F0                 
                    ORA        #$06                 
                    STA        $08,S                
                    LDA        $A8,S                
                    AND        #$F0                 
                    ORA        #$05                 
                    STA        $A8,S                
                    REP        #$30                 
                    TSC                             
                    ADC        #$000C               
                    TCS                             
                    PEA        $6666                
                    PEA        $6666                
                    TSC                             ; Line 3
                    ADC        #$00A4               
                    TCS                             
                    SEP        #$20                 
                    LDA        $9C,S                
                    AND        #$F0                 
                    ORA        #$05                 
                    STA        $9C,S                
                    REP        #$30                 
                    PEA        $5555                
                    PEA        $5555                
                    TSC                             ; Line 4
                    ADC        #$00A4               
                    TCS                             
                    SEP        #$20                 
                    LDA        $9C,S                
                    AND        #$F0                 
                    ORA        #$06                 
                    STA        $9C,S                
                    REP        #$30                 
                    PEA        $5555                
                    PEA        $5555                
                    TSC                             ; Line 5
                    ADC        #$00A4               
                    TCS                             
                    SEP        #$20                 
                    LDA        $9C,S                
                    AND        #$F0                 
                    ORA        #$06                 
                    STA        $9C,S                
                    REP        #$30                 
                    PHY                             
                    PEA        $6666                
                    TSC                             ; Line 6
                    ADC        #$00A4               
                    TCS                             
                    LDA        #$4446               
                    STA        $9E,S                
                    LDA        $9C,S                
                    AND        #$00F0               
                    ORA        #$6606               
                    STA        $9C,S                
                    LDA        $A0,S                
                    AND        #$0F00               
                    ORA        #$4044               
                    STA        $A0,S                
                    PEA        $6446                
                    PEA        $6666                
                    TSC                             ; Line 8
                    ADC        #$0144               
                    TCS                             
                    SEP        #$20                 
                    LDA        $01,S                
                    AND        #$0F                 
                    ORA        #$40                 
                    STA        $01,S                
                    REP        #$30                 
                    PHY                             
                    PEA        $4466                
                    TSC                             ; Line 9
                    ADC        #$00A4               
                    TCS                             
                    TYA                             
                    STA        $9F,S                
                    LDA        $9D,S                
                    AND        #$00F0               
                    ORA        #$4404               
                    STA        $9D,S                
                    PHY                             
                    PEA        $4466                
                    TSC                             ; Line 11
                    ADC        #$0138               
                    TCS                             
                    TYA                             
                    STA        $0A,S                
                    SEP        #$20                 
                    LDA        #$34                 
                    STA        $09,S                
                    LDA        $A8,S                
                    AND        #$F0                 
                    ORA        #$03                 
                    STA        $A8,S                
                    REP        #$30                 
                    TSC                             ; Line 12
                    ADC        #$00AC               
                    TCS                             
                    SEP        #$20                 
                    LDA        $9B,S                
                    AND        #$F0                 
                    ORA        #$03                 
                    STA        $9B,S                
                    REP        #$30                 
                    PEA        $3141                
                    PEA        $4423                
                    TSC                             ; Line 13
                    ADC        #$00A5               
                    TCS                             
                    LDA        $A1,S                
                    AND        #$000F               
                    ORA        #$4430               
                    STA        $A1,S                
                    SEP        #$20                 
                    LDA        #$11                 
                    STA        $9A,S                
                    REP        #$30                 
                    PEA        $1313                
                    PEA        $4634                
                    PEA        $3261                
                    TSC                             ; Line 14
                    ADC        #$00A6               
                    TCS                             
                    LDA        $A2,S                
                    AND        #$0F00               
                    ORA        #$4044               
                    STA        $A2,S                
                    SEP        #$20                 
                    LDA        $99,S                
                    AND        #$F0                 
                    ORA        #$01                 
                    STA        $99,S                
                    REP        #$30                 
                    PEA        $3161                
                    PEA        $4423                
                    PEA        $1336                
                    TSC                             ; Line 15
                    ADC        #$00A7               
                    TCS                             
                    LDA        $98,S                
                    AND        #$00F0               
                    ORA        #$1106               
                    STA        $98,S                
                    LDA        $A4,S                
                    AND        #$0FF0               
                    ORA        #$4004               
                    STA        $A4,S                
                    SEP        #$20                 
                    LDA        $A2,S                
                    AND        #$0F                 
                    ORA        #$40                 
                    STA        $A2,S                
                    REP        #$30                 
                    PEA        $1413                
                    PEA        $1634                
                    PEA        $3261                
                    PEA        $1311                
                    TSC                             ; Line 16
                    ADC        #$00A9               
                    TCS                             
                    TYA                             
                    STA        $A3,S                
                    LDA        $97,S                
                    AND        #$00F0               
                    ORA        #$6101               
                    STA        $97,S                
                    PHY                             
                    PEA        $6141                
                    PEA        $2313                
                    PEA        $3611                
                    TSC                             ; Line 17
                    ADC        #$00A8               
                    TCS                             
                    TYA                             
                    STA        $A3,S                
                    SEP        #$20                 
                    LDA        $97,S                
                    AND        #$F0                 
                    ORA        #$06                 
                    STA        $97,S                
                    LDA        $A2,S                
                    AND        #$F0                 
                    ORA        #$04                 
                    STA        $A2,S                
                    REP        #$30                 
                    PHY                             
                    PEA        $1434                
                    PEA        $3261                
                    PEA        $1311                
                    TSC                             ; Line 18
                    ADC        #$00A7               
                    TCS                             
                    TYA                             
                    STA        $A3,S                
                    LDA        $9F,S                
                    AND        #$0F00               
                    ORA        #$4021               
                    STA        $9F,S                
                    SEP        #$20                 
                    LDA        $98,S                
                    AND        #$F0                 
                    ORA        #$01                 
                    STA        $98,S                
                    LDA        $A2,S                
                    AND        #$0F                 
                    ORA        #$30                 
                    STA        $A2,S                
                    REP        #$30                 
                    PEA        $4434                
                    PEA        $2113                
                    PEA        $3611                
                    PHD                             
                    TSC                             ; Line 19
                    ADC        #$00A6               
                    TCS                             
                    LDA        #$4413               
                    STA        $A4,S                
                    LDA        $9A,S                
                    AND        #$00F0               
                    ORA        #$1106               
                    STA        $9A,S                
                    LDA        $A2,S                
                    AND        #$F00F               
                    ORA        #$0360               
                    STA        $A2,S                
                    SEP        #$20                 
                    LDA        $A6,S                
                    AND        #$0F                 
                    ORA        #$40                 
                    STA        $A6,S                
                    REP        #$30                 
                    PEA        $1361                
                    PEA        $1321                
                    PEA        $1361                
                    TSC                             ; Line 20
                    ADC        #$00A7               
                    TCS                             
                    LDA        #$1431               
                    STA        $A3,S                
                    LDA        $99,S                
                    AND        #$00F0               
                    ORA        #$6101               
                    STA        $99,S                
                    LDA        $A1,S                
                    AND        #$000F               
                    ORA        #$3110               
                    STA        $A1,S                
                    PEA        $1132                
                    PEA        $3611                
                    PEA        $3233                
                    TSC                             ; Line 21
                    ADC        #$00A6               
                    TCS                             
                    SEP        #$20                 
                    LDA        #$61                 
                    STA        $A4,S                
                    REP        #$30                 
                    PEA        $1121                
                    PEA        $1321                
                    PEA        $3311                
                    TSC                             ; Line 22
                    ADC        #$00A9               
                    TCS                             
                    SEP        #$20                 
                    LDA        $A1,S                
                    AND        #$0F                 
                    ORA        #$10                 
                    STA        $A1,S                
                    REP        #$30                 
                    PEA        $1113                
                    PEA        $1316                
                    PEA        $1122                
                    PEA        $3333                
                    PEA        $1116                
                    TSC                             ; Line 23
                    ADC        #$00AA               
                    TCS                             
                    LDA        $97,S                
                    AND        #$00F0               
                    ORA        #$1601               
                    STA        $97,S                
                    PEA        $1631                
                    PEA        $1163                
                    PEA        $1111                
                    PEA        $3311                
                    PEA        $6111                
                    TSC                             ; Line 24
                    ADC        #$00AA               
                    TCS                             
                    LDA        $97,S                
                    AND        #$00F0               
                    ORA        #$1101               
                    STA        $97,S                
                    LDA        $9F,S                
                    AND        #$0F00               
                    ORA        #$1016               
                    STA        $9F,S                
                    PHX                             
                    PEA        $6133                
                    PEA        $1111                
                    PHD                             
                    TSC                             ; Line 25
                    ADC        #$00A6               
                    TCS                             
                    LDA        $A0,S                
                    AND        #$0F00               
                    ORA        #$6061               
                    STA        $A0,S                
                    SEP        #$20                 
                    LDA        $99,S                
                    AND        #$F0                 
                    ORA        #$01                 
                    STA        $99,S                
                    REP        #$30                 
                    PEA        $1613                
                    PEA        $6111                
                    PEA        $1161                
                    TSC                             ; Line 26
                    ADC        #$00A5               
                    TCS                             
                    SEP        #$20                 
                    LDA        $9A,S                
                    AND        #$F0                 
                    ORA        #$07                 
                    STA        $9A,S                
                    REP        #$30                 
                    PEA        $3311                
                    PHX                             
                    PEA        $1611                
                    TSC                             ; Line 27
                    ADC        #$00A6               
                    TCS                             
                    LDA        $9A,S                
                    AND        #$00F0               
                    ORA        #$5505               
                    STA        $9A,S                
                    LDA        $A0,S                
                    AND        #$0F00               
                    ORA        #$5035               
                    STA        $A0,S                
                    PEA        $3313                
                    PEA        $1311                
                    PEA        $1171                
                    TSC                             ; Line 28
                    ADC        #$00A5               
                    TCS                             
                    LDA        $9B,S                
                    AND        #$00F0               
                    ORA        #$1606               
                    STA        $9B,S                
                    LDA        $A1,S                
                    AND        #$0F00               
                    ORA        #$5075               
                    STA        $A1,S                
                    PEA        $1171                
                    PEA        $7777                
                    TSC                             ; Line 29
                    ADC        #$00A4               
                    TCS                             
                    LDA        $9B,S                
                    AND        #$00F0               
                    ORA        #$6101               
                    STA        $9B,S                
                    LDA        $A1,S                
                    AND        #$0F00               
                    ORA        #$3033               
                    STA        $A1,S                
                    PEA        $7755                
                    PEA        $5555                
                    TSC                             ; Line 30
                    ADC        #$00A4               
                    TCS                             
                    LDA        $9B,S                
                    AND        #$00F0               
                    ORA        #$1606               
                    STA        $9B,S                
                    LDA        $A1,S                
                    AND        #$0F00               
                    ORA        #$3053               
                    STA        $A1,S                
                    PEA        $7511                
                    PHX                             
                    TSC                             ; Line 31
                    ADC        #$00A4               
                    TCS                             
                    LDA        $A1,S                
                    AND        #$0F00               
                    ORA        #$3075               
                    STA        $A1,S                
                    PEA        $5711                
                    PHD                             
                    TSC                             ; Line 32
                    ADC        #$00A4               
                    TCS                             
                    SEP        #$20                 
                    LDA        $9A,S                
                    AND        #$F0                 
                    ORA        #$06                 
                    STA        $9A,S                
                    REP        #$30                 
                    PEA        $7335                
                    PEA        $1313                
                    PHX                             
                    TSC                             ; Line 33
                    ADC        #$00A8               
                    TCS                             
                    LDA        $A0,S                
                    AND        #$0F00               
                    ORA        #$3032               
                    STA        $A0,S                
                    PEA        $1375                
                    PEA        $7355                
                    PEA        $3311                
                    PEA        $1116                
                    TSC                             ; Line 34
                    ADC        #$00A7               
                    TCS                             
                    SEP        #$20                 
                    LDA        $98,S                
                    AND        #$F0                 
                    ORA        #$06                 
                    STA        $98,S                
                    REP        #$30                 
                    PEA        $7531                
                    PEA        $5713                
                    PEA        $1313                
                    PHX                             
                    TSC                             ; Line 35
                    ADC        #$00AA               
                    TCS                             
                    LDA        $A0,S                
                    AND        #$0F00               
                    ORA        #$3032               
                    STA        $A0,S                
                    PEA        $2313                
                    PEA        $1511                
                    PEA        $3333                
                    PHD                             
                    PEA        $1616                
                    TSC                             ; Line 36
                    ADC        #$00A9               
                    TCS                             
                    SEP        #$20                 
                    LDA        $96,S                
                    AND        #$F0                 
                    ORA        #$06                 
                    STA        $96,S                
                    REP        #$30                 
                    PHD                             
                    PEA        $1616                
                    PEA        $3313                
                    PEA        $1361                
                    PHX                             
                    TSC                             ; Line 37
                    ADC        #$00AC               
                    TCS                             
                    LDA        $94,S                
                    AND        #$00F0               
                    ORA        #$6101               
                    STA        $94,S                
                    LDA        $A0,S                
                    AND        #$0F00               
                    ORA        #$3032               
                    STA        $A0,S                
                    PEA        $2313                
                    PEA        $1361                
                    PHX                             
                    PEA        $3333                
                    PHD                             
                    PEA        $1616                
                    TSC                             ; Line 38
                    ADC        #$00AB               
                    TCS                             
                    LDA        $A1,S                
                    AND        #$0F00               
                    ORA        #$2013               
                    STA        $A1,S                
                    PHD                             
                    PEA        $1616                
                    PEA        $1636                
                    PEA        $3313                
                    PEA        $1361                
                    TSC                             ; Line 39
                    ADC        #$00A4               
                    TCS                             
                    LDA        $9F,S                
                    AND        #$0F00               
                    ORA        #$3033               
                    STA        $9F,S                
                    LDA        $A3,S                
                    AND        #$00F0               
                    ORA        #$1606               
                    STA        $A3,S                
                    PEA        $2313                
                    PHD                             
                    PEA        $1616                
                    TSC                             
                    ADC        #$000C               
                    TCS                             
                    PEA        $1361                
                    PHX                             
                    TSC                             ; Line 40
                    ADC        #$009C               
                    TCS                             
                    LDA        $9C,S                
                    AND        #$00F0               
                    ORA        #$1606               
                    STA        $9C,S                
                    SEP        #$20                 
                    LDA        #$12                 
                    STA        $AA,S                
                    REP        #$30                 
                    PEA        $1313                
                    PHX                             
                    TSC                             
                    ADC        #$000E               
                    TCS                             
                    PEA        $3331                
                    PEA        $1116                
                    TSC                             ; Line 41
                    ADC        #$009B               
                    TCS                             
                    LDA        #$1313               
                    STA        $9D,S                
                    LDA        #$1111               
                    STA        $A7,S                
                    LDA        $9B,S                
                    AND        #$00F0               
                    ORA        #$6101               
                    STA        $9B,S                
                    LDA        $9F,S                
                    AND        #$0F00               
                    ORA        #$3033               
                    STA        $9F,S                
                    LDA        $A5,S                
                    AND        #$00F0               
                    ORA        #$1606               
                    STA        $A5,S                
                    LDA        $A9,S                
                    AND        #$0F00               
                    ORA        #$2031               
                    STA        $A9,S                
                    PEA        $2333                
                    PHD                             
                    TSC                             
                    ADC        #$000C               
                    TCS                             
                    PEA        $1311                
                    PHX                             
                    TSC                             ; Line 43
                    ADC        #$013A               
                    TCS                             
                    LDA        #$1116               
                    STA        $A9,S                
                    LDA        $AB,S                
                    AND        #$0F00               
                    ORA        #$3011               
                    STA        $AB,S                
                    SEP        #$20                 
                    LDA        #$23                 
                    STA        $01,S                
                    LDA        $0C,S                
                    AND        #$0F                 
                    ORA        #$30                 
                    STA        $0C,S                
                    LDA        $A1,S                
                    AND        #$0F                 
                    ORA        #$30                 
                    STA        $A1,S                
                    LDA        $A8,S                
                    AND        #$F0                 
                    ORA        #$06                 
                    STA        $A8,S                
                    REP        #$30                 
                    PEA        $3313                
                    PEA        $1116                
                    TSC                             
                    ADC        #$000F               
                    TCS                             
                    PEA        $1211                
                    PHX                             
                    TSC                             ; Line 44
                    ADC        #$0099               
                    TCS                             
                    TXA                             
                    STA        $A9,S                
                    LDA        $AB,S                
                    AND        #$0F00               
                    ORA        #$3013               
                    STA        $AB,S                
                    SEP        #$20                 
                    LDA        $9C,S                
                    AND        #$F0                 
                    ORA        #$06                 
                    STA        $9C,S                
                    REP        #$30                 
                    PEA        $3232                
                    PEA        $3161                
                    TSC                             ; Line 45
                    ADC        #$00A4               
                    TCS                             
                    LDA        $A9,S                
                    AND        #$00F0               
                    ORA        #$1106               
                    STA        $A9,S                
                    LDA        $AB,S                
                    AND        #$0F00               
                    ORA        #$3011               
                    STA        $AB,S                
                    SEP        #$20                 
                    LDA        #$33                 
                    STA        $A0,S                
                    REP        #$30                 
                    PEA        $2323                
                    PEA        $1316                
                    TSC                             ; Line 46
                    ADC        #$00A3               
                    TCS                             
                    LDA        $AA,S                
                    AND        #$00F0               
                    ORA        #$6101               
                    STA        $AA,S                
                    LDA        $AC,S                
                    AND        #$0F00               
                    ORA        #$3011               
                    STA        $AC,S                
                    SEP        #$20                 
                    LDA        $A1,S                
                    AND        #$0F                 
                    ORA        #$30                 
                    STA        $A1,S                
                    REP        #$30                 
                    PEA        $3212                
                    PHX                             
                    TSC                             ; Line 47
                    ADC        #$00A4               
                    TCS                             
                    LDA        $AA,S                
                    AND        #$00F0               
                    ORA        #$1106               
                    STA        $AA,S                
                    LDA        $AC,S                
                    AND        #$0F00               
                    ORA        #$3011               
                    STA        $AC,S                
                    PEA        $2313                
                    PEA        $1116                
                    TSC                             ; Line 48
                    ADC        #$00A4               
                    TCS                             
                    LDA        #$1311               
                    STA        $9D,S                
                    LDA        $9F,S                
                    AND        #$0F00               
                    ORA        #$1013               
                    STA        $9F,S                
                    LDA        $AA,S                
                    AND        #$00F0               
                    ORA        #$6101               
                    STA        $AA,S                
                    LDA        $AC,S                
                    AND        #$0F00               
                    ORA        #$3013               
                    STA        $AC,S                
                    SEP        #$20                 
                    LDA        $9C,S                
                    AND        #$F0                 
                    ORA        #$06                 
                    STA        $9C,S                
                    REP        #$30                 
                    PEA        $3331                
                    PEA        $1161                
                    TSC                             ; Line 50
                    ADC        #$013F               
                    TCS                             
                    TDC                             
                    STA        $03,S                
                    LDA        $01,S                
                    AND        #$00F0               
                    ORA        #$6101               
                    STA        $01,S                
                    LDA        $0F,S                
                    AND        #$00F0               
                    ORA        #$1106               
                    STA        $0F,S                
                    LDA        $11,S                
                    AND        #$0F00               
                    ORA        #$3011               
                    STA        $11,S                
                    LDA        $A1,S                
                    AND        #$00F0               
                    ORA        #$1106               
                    STA        $A1,S                
                    LDA        $A3,S                
                    AND        #$0F00               
                    ORA        #$1013               
                    STA        $A3,S                
                    LDA        $AF,S                
                    AND        #$00F0               
                    ORA        #$6101               
                    STA        $AF,S                
                    LDA        $B1,S                
                    AND        #$0F00               
                    ORA        #$3013               
                    STA        $B1,S                
                    TSC                             ; Line 52
                    ADC        #$0140               
                    TCS                             
                    TDC                             
                    STA        $02,S                
                    LDA        #$1111               
                    STA        $10,S                
                    LDA        #$4464               
                    STA        $B0,S                
                    LDA        $06,S                
                    AND        #$F0F0               
                    ORA        #$0606               
                    STA        $06,S                
                    LDA        $08,S                
                    AND        #$F0F0               
                    ORA        #$0606               
                    STA        $08,S                
                    LDA        $0A,S                
                    AND        #$F0F0               
                    ORA        #$0606               
                    STA        $0A,S                
                    LDA        $0C,S                
                    AND        #$F0F0               
                    ORA        #$0606               
                    STA        $0C,S                
                    LDA        $0E,S                
                    AND        #$F0F0               
                    ORA        #$0606               
                    STA        $0E,S                
                    LDA        $A2,S                
                    AND        #$0F00               
                    ORA        #$4044               
                    STA        $A2,S                
                    LDA        $A4,S                
                    AND        #$0F0F               
                    ORA        #$6060               
                    STA        $A4,S                
                    LDA        $A6,S                
                    AND        #$0F0F               
                    ORA        #$6060               
                    STA        $A6,S                
                    LDA        $A8,S                
                    AND        #$0F0F               
                    ORA        #$6060               
                    STA        $A8,S                
                    LDA        $AA,S                
                    AND        #$0F0F               
                    ORA        #$6060               
                    STA        $AA,S                
                    LDA        $AC,S                
                    AND        #$0F0F               
                    ORA        #$6060               
                    STA        $AC,S                
                    LDA        $AE,S                
                    AND        #$0F0F               
                    ORA        #$6060               
                    STA        $AE,S                
                    LDA        $B3,S                
                    AND        #$0F0F               
                    ORA        #$6060               
                    STA        $B3,S                
                    SEP        #$20                 
                    LDA        #$36                 
                    STA        $12,S                
                    LDA        $01,S                
                    AND        #$F0                 
                    ORA        #$01                 
                    STA        $01,S                
                    LDA        $B5,S                
                    AND        #$0F                 
                    ORA        #$60                 
                    STA        $B5,S                
                    REP        #$30                 
                    TSC                             ; Line 54
                    ADC        #$0140               
                    TCS                             
                    LDA        #$4644               
                    STA        $02,S                
                    TYA                             
                    STA        $11,S                
                    STA        $A0,S                
                    STA        $B2,S                
                    LDA        $05,S                
                    AND        #$F0F0               
                    ORA        #$0606               
                    STA        $05,S                
                    LDA        $07,S                
                    AND        #$F0F0               
                    ORA        #$0606               
                    STA        $07,S                
                    LDA        $09,S                
                    AND        #$F0F0               
                    ORA        #$0606               
                    STA        $09,S                
                    LDA        $0B,S                
                    AND        #$F0F0               
                    ORA        #$0606               
                    STA        $0B,S                
                    LDA        $0D,S                
                    AND        #$F0F0               
                    ORA        #$0606               
                    STA        $0D,S                
                    LDA        $0F,S                
                    AND        #$F0F0               
                    ORA        #$0406               
                    STA        $0F,S                
                    LDA        $13,S                
                    AND        #$F0F0               
                    ORA        #$0606               
                    STA        $13,S                
                    LDA        $A8,S                
                    AND        #$0F0F               
                    ORA        #$6060               
                    STA        $A8,S                
                    LDA        $AA,S                
                    AND        #$0F0F               
                    ORA        #$6060               
                    STA        $AA,S                
                    LDA        $AC,S                
                    AND        #$0F0F               
                    ORA        #$6060               
                    STA        $AC,S                
                    LDA        $B0,S                
                    AND        #$00F0               
                    ORA        #$4404               
                    STA        $B0,S                
                    SEP        #$20                 
                    LDA        #$44                 
                    STA        $01,S                
                    LDA        $04,S                
                    AND        #$F0                 
                    ORA        #$06                 
                    STA        $04,S                
                    LDA        $A2,S                
                    AND        #$0F                 
                    ORA        #$40                 
                    STA        $A2,S                
                    LDA        $AE,S                
                    AND        #$0F                 
                    ORA        #$60                 
                    STA        $AE,S                
                    REP        #$30                 
*--                                                 
                    LDAL       $E1C068              ; Direct Page and Stack in Bank 00/
                    AND        #$FFCF               
                    STAL       $E1C068              
                    LDA        StackAddress         ; Restore Stack
                    TCS                             
                    PLD                             ; Restore Direct Page
                    CLI                             ; Enable Interrupts
                    PLB
                    RTL                             
                                                    
*-----------------------------------                                
Sprite_RR_042       CLC                             ; Sprite #042 : 30x56, 1735 bytes, 2764 cycles
                    SEI                             ; Disable Interrupts
                    PHD                             ; Backup Direct Page
                    TSC                             ; Backup Stack
                    STA        StackAddress         
                    LDAL       $E1C068              ; Direct Page and Stack in Bank 01/
                    ORA        #$0030               
                    STAL       $E1C068              
                    TYA                             ; Y = Sprite Target Screen Address (upper left corner)
                    TCS                             ; New Stack address
                    LDX        #$1116               ; Pattern #1 : 14
                    LDY        #$1311               ; Pattern #2 : 11
                    LDA        #$4444               ; Pattern #3 : 10
                    TCD                             
*--                                                 
                    LDA        #$6666               ; Line 0
                    STA        $04,S                
                    STA        $A5,S                
                    LDA        $A3,S                
                    AND        #$00F0               
                    ORA        #$6606               
                    STA        $A3,S                
                    TSC                             ; Line 2
                    ADC        #$0146               
                    TCS                             
                    SEP        #$20                 
                    LDA        $01,S                
                    AND        #$0F                 
                    ORA        #$60                 
                    STA        $01,S                
                    LDA        $A1,S                
                    AND        #$0F                 
                    ORA        #$50                 
                    STA        $A1,S                
                    REP        #$30                 
                    PEA        $6666                
                    PEA        $6666                
                    TSC                             ; Line 3
                    ADC        #$00A4               
                    TCS                             
                    SEP        #$20                 
                    LDA        $A1,S                
                    AND        #$0F                 
                    ORA        #$50                 
                    STA        $A1,S                
                    REP        #$30                 
                    PEA        $5555                
                    PEA        $5555                
                    TSC                             ; Line 4
                    ADC        #$00A4               
                    TCS                             
                    SEP        #$20                 
                    LDA        $A1,S                
                    AND        #$0F                 
                    ORA        #$40                 
                    STA        $A1,S                
                    REP        #$30                 
                    PEA        $5555                
                    PEA        $5555                
                    TSC                             ; Line 5
                    ADC        #$00A4               
                    TCS                             
                    SEP        #$20                 
                    LDA        $A1,S                
                    AND        #$0F                 
                    ORA        #$40                 
                    STA        $A1,S                
                    REP        #$30                 
                    PEA        $4464                
                    PEA        $6666                
                    TSC                             ; Line 6
                    ADC        #$00A4               
                    TCS                             
                    SEP        #$20                 
                    LDA        #$66                 
                    STA        $9D,S                
                    REP        #$30                 
                    PEA        $6664                
                    PEA        $6666                
                    TSC                             ; Line 7
                    ADC        #$00A5               
                    TCS                             
                    SEP        #$20                 
                    LDA        $9C,S                
                    AND        #$F0                 
                    ORA        #$06                 
                    STA        $9C,S                
                    REP        #$30                 
                    PHD                             
                    PEA        $6464                
                    TSC                             ; Line 8
                    ADC        #$00A4               
                    TCS                             
                    TDC                             
                    STA        $9E,S                
                    LDA        $9C,S                
                    AND        #$00F0               
                    ORA        #$6406               
                    STA        $9C,S                
                    SEP        #$20                 
                    LDA        $A0,S                
                    AND        #$0F                 
                    ORA        #$40                 
                    STA        $A0,S                
                    REP        #$30                 
                    PHD                             
                    PEA        $4464                
                    TSC                             ; Line 10
                    ADC        #$013D               
                    TCS                             
                    TDC                             
                    STA        $04,S                
                    LDA        $06,S                
                    AND        #$0F00               
                    ORA        #$4044               
                    STA        $06,S                
                    LDA        $A3,S                
                    AND        #$00F0               
                    ORA        #$4403               
                    STA        $A3,S                
                    LDA        $A5,S                
                    AND        #$0F00               
                    ORA        #$4044               
                    STA        $A5,S                
                    TSC                             ; Line 12
                    ADC        #$0146               
                    TCS                             
                    SEP        #$20                 
                    LDA        $01,S                
                    AND        #$0F                 
                    ORA        #$10                 
                    STA        $01,S                
                    LDA        $A2,S                
                    AND        #$0F                 
                    ORA        #$30                 
                    STA        $A2,S                
                    REP        #$30                 
                    PEA        $1344                
                    PEA        $3432                
                    TSC                             ; Line 13
                    ADC        #$00A5               
                    TCS                             
                    LDA        $9A,S                
                    AND        #$00F0               
                    ORA        #$1301               
                    STA        $9A,S                
                    LDA        $A2,S                
                    AND        #$0FF0               
                    ORA        #$4004               
                    STA        $A2,S                
                    PEA        $3161                
                    PEA        $4423                
                    PEA        $1336                
                    TSC                             ; Line 14
                    ADC        #$00A7               
                    TCS                             
                    PEA        $1313                
                    PEA        $4634                
                    PEA        $3261                
                    TSC                             ; Line 15
                    ADC        #$00A8               
                    TCS                             
                    SEP        #$20                 
                    LDA        #$44                 
                    STA        $A3,S                
                    REP        #$30                 
                    PHD                             
                    PEA        $3161                
                    PEA        $4123                
                    PEA        $1336                
                    PEA        $1111                
                    TSC                             ; Line 16
                    ADC        #$00AA               
                    TCS                             
                    LDA        $9F,S                
                    AND        #$0F00               
                    ORA        #$4044               
                    STA        $9F,S                
                    LDA        $A2,S                
                    AND        #$00F0               
                    ORA        #$4404               
                    STA        $A2,S                
                    SEP        #$20                 
                    LDA        $A4,S                
                    AND        #$0F                 
                    ORA        #$40                 
                    STA        $A4,S                
                    REP        #$30                 
                    PHD                             
                    PEA        $1416                
                    PEA        $3432                
                    PEA        $6113                
                    PEA        $1161                
                    TSC                             ; Line 17
                    ADC        #$00A8               
                    TCS                             
                    TDC                             
                    STA        $A4,S                
                    SEP        #$20                 
                    LDA        $A1,S                
                    AND        #$0F                 
                    ORA        #$40                 
                    STA        $A1,S                
                    LDA        $A6,S                
                    AND        #$0F                 
                    ORA        #$40                 
                    STA        $A6,S                
                    REP        #$30                 
                    PEA        $4441                
                    PEA        $2313                
                    PEA        $3611                
                    PHX                             
                    TSC                             ; Line 18
                    ADC        #$00A8               
                    TCS                             
                    LDA        $A2,S                
                    AND        #$F0F0               
                    ORA        #$0403               
                    STA        $A2,S                
                    LDA        $A4,S                
                    AND        #$0F00               
                    ORA        #$4044               
                    STA        $A4,S                
                    PEA        $4413                
                    PEA        $3261                
                    PHY                             
                    PEA        $1361                
                    TSC                             ; Line 19
                    ADC        #$00A8               
                    TCS                             
                    LDA        #$3431               
                    STA        $A2,S                
                    SEP        #$20                 
                    LDA        #$44                 
                    STA        $A4,S                
                    REP        #$30                 
                    PEA        $1432                
                    PEA        $1136                
                    PEA        $1132                
                    PHX                             
                    TSC                             ; Line 20
                    ADC        #$00A8               
                    TCS                             
                    LDA        #$1113               
                    STA        $A2,S                
                    SEP        #$20                 
                    LDA        $A1,S                
                    AND        #$F0                 
                    ORA        #$03                 
                    STA        $A1,S                
                    LDA        $A4,S                
                    AND        #$0F                 
                    ORA        #$40                 
                    STA        $A4,S                
                    REP        #$30                 
                    PEA        $1621                
                    PEA        $6313                
                    PEA        $2133                
                    PEA        $1361                
                    TSC                             ; Line 21
                    ADC        #$00A8               
                    TCS                             
                    LDA        $99,S                
                    AND        #$00F0               
                    ORA        #$6101               
                    STA        $99,S                
                    LDA        $A3,S                
                    AND        #$0F00               
                    ORA        #$1016               
                    STA        $A3,S                
                    PEA        $1111                
                    PEA        $3211                
                    PEA        $3213                
                    PHX                             
                    TSC                             ; Line 22
                    ADC        #$00AA               
                    TCS                             
                    SEP        #$20                 
                    LDA        $97,S                
                    AND        #$F0                 
                    ORA        #$01                 
                    STA        $97,S                
                    REP        #$30                 
                    PEA        $3131                
                    PEA        $6111                
                    PEA        $2132                
                    PEA        $3313                
                    TSC                             ; Line 23
                    ADC        #$00A9               
                    TCS                             
                    LDA        $9F,S                
                    AND        #$0F00               
                    ORA        #$1016               
                    STA        $9F,S                
                    PEA        $6111                
                    PEA        $1331                
                    PEA        $1611                
                    PEA        $3113                
                    PHX                             
                    TSC                             ; Line 24
                    ADC        #$00A8               
                    TCS                             
                    SEP        #$20                 
                    LDA        #$61                 
                    STA        $A1,S                
                    REP        #$30                 
                    PEA        $1636                
                    PHY                             
                    PEA        $1113                
                    PEA        $6111                
                    TSC                             ; Line 25
                    ADC        #$00A8               
                    TCS                             
                    PEA        $6131                
                    PHX                             
                    PEA        $1111                
                    PEA        $1611                
                    TSC                             ; Line 26
                    ADC        #$00A8               
                    TCS                             
                    SEP        #$20                 
                    LDA        $9F,S                
                    AND        #$0F                 
                    ORA        #$30                 
                    STA        $9F,S                
                    REP        #$30                 
                    PEA        $1636                
                    PHY                             
                    PEA        $1666                
                    PEA        $1111                
                    TSC                             ; Line 27
                    ADC        #$00A6               
                    TCS                             
                    SEP        #$20                 
                    LDA        #$55                 
                    STA        $A1,S                
                    REP        #$30                 
                    PEA        $3331                
                    PEA        $1111                
                    PEA        $1177                
                    TSC                             ; Line 28
                    ADC        #$00A6               
                    TCS                             
                    SEP        #$20                 
                    LDA        #$55                 
                    STA        $A1,S                
                    REP        #$30                 
                    PHY                             
                    PEA        $7777                
                    PEA        $5755                
                    TSC                             ; Line 29
                    ADC        #$00A6               
                    TCS                             
                    SEP        #$20                 
                    LDA        #$33                 
                    STA        $A1,S                
                    REP        #$30                 
                    PEA        $7757                
                    PEA        $5555                
                    PEA        $6561                
                    TSC                             ; Line 30
                    ADC        #$00A6               
                    TCS                             
                    SEP        #$20                 
                    LDA        #$61                 
                    STA        $9B,S                
                    REP        #$30                 
                    PEA        $5317                
                    PHX                             
                    PEA        $1616                
                    TSC                             ; Line 31
                    ADC        #$00A7               
                    TCS                             
                    LDA        $A0,S                
                    AND        #$0F00               
                    ORA        #$3033               
                    STA        $A0,S                
                    SEP        #$20                 
                    LDA        $99,S                
                    AND        #$F0                 
                    ORA        #$06                 
                    STA        $99,S                
                    REP        #$30                 
                    PEA        $3375                
                    PEA        $7511                
                    PEA        $1361                
                    TSC                             ; Line 32
                    ADC        #$00A5               
                    TCS                             
                    LDA        $A1,S                
                    AND        #$0F00               
                    ORA        #$3073               
                    STA        $A1,S                
                    SEP        #$20                 
                    LDA        $9A,S                
                    AND        #$F0                 
                    ORA        #$01                 
                    STA        $9A,S                
                    REP        #$30                 
                    PEA        $7553                
                    PEA        $7731                
                    PHX                             
                    TSC                             ; Line 33
                    ADC        #$00A6               
                    TCS                             
                    LDA        $A1,S                
                    AND        #$0F00               
                    ORA        #$3053               
                    STA        $A1,S                
                    SEP        #$20                 
                    LDA        $9A,S                
                    AND        #$F0                 
                    ORA        #$06                 
                    STA        $9A,S                
                    REP        #$30                 
                    PEA        $3733                
                    PEA        $5315                
                    PEA        $1161                
                    TSC                             ; Line 34
                    ADC        #$00A6               
                    TCS                             
                    SEP        #$20                 
                    LDA        $9A,S                
                    AND        #$F0                 
                    ORA        #$01                 
                    STA        $9A,S                
                    REP        #$30                 
                    PEA        $1313                
                    PEA        $3331                
                    PEA        $3111                
                    TSC                             ; Line 35
                    ADC        #$00A8               
                    TCS                             
                    SEP        #$20                 
                    LDA        #$33                 
                    STA        $A0,S                
                    REP        #$30                 
                    PEA        $3333                
                    PEA        $3131                
                    PEA        $3113                
                    PEA        $1361                
                    TSC                             ; Line 36
                    ADC        #$00A7               
                    TCS                             
                    SEP        #$20                 
                    LDA        #$61                 
                    STA        $99,S                
                    REP        #$30                 
                    PEA        $1363                
                    PEA        $6131                
                    PEA        $3331                
                    PHX                             
                    TSC                             ; Line 37
                    ADC        #$00A9               
                    TCS                             
                    LDA        $A0,S                
                    AND        #$0F00               
                    ORA        #$3013               
                    STA        $A0,S                
                    PEA        $3331                
                    PHX                             
                    PEA        $3613                
                    PEA        $1313                
                    TSC                             ; Line 38
                    ADC        #$00A7               
                    TCS                             
                    SEP        #$20                 
                    LDA        $A2,S                
                    AND        #$0F                 
                    ORA        #$30                 
                    STA        $A2,S                
                    REP        #$30                 
                    PEA        $1361                
                    PEA        $6131                
                    PEA        $3331                
                    PEA        $3116                
                    TSC                             ; Line 39
                    ADC        #$00A4               
                    TCS                             
                    SEP        #$20                 
                    LDA        $A2,S                
                    AND        #$F0                 
                    ORA        #$01                 
                    STA        $A2,S                
                    REP        #$30                 
                    PEA        $3313                
                    PEA        $1361                
                    TSC                             
                    ADC        #$0009               
                    TCS                             
                    PEA        $3311                
                    PEA        $1616                
                    TSC                             ; Line 40
                    ADC        #$009F               
                    TCS                             
                    LDA        #$1161               
                    STA        $9D,S                
                    LDA        $9F,S                
                    AND        #$0F00               
                    ORA        #$3033               
                    STA        $9F,S                
                    PEA        $2333                
                    PEA        $3111                
                    TSC                             
                    ADC        #$000A               
                    TCS                             
                    PEA        $3313                
                    PEA        $6161                
                    TSC                             ; Line 41
                    ADC        #$00A4               
                    TCS                             
                    TYA                             
                    STA        $97,S                
                    LDA        #$1361               
                    STA        $9E,S                
                    LDA        $99,S                
                    AND        #$0F00               
                    ORA        #$3023               
                    STA        $99,S                
                    LDA        $A0,S                
                    AND        #$0F00               
                    ORA        #$3033               
                    STA        $A0,S                
                    SEP        #$20                 
                    LDA        $96,S                
                    AND        #$F0                 
                    ORA        #$06                 
                    STA        $96,S                
                    LDA        $9D,S                
                    AND        #$F0                 
                    ORA        #$01                 
                    STA        $9D,S                
                    REP        #$30                 
                    PEA        $2333                
                    PHX                             
                    TSC                             ; Line 43
                    ADC        #$013A               
                    TCS                             
                    LDA        #$3332               
                    STA        $02,S                
                    LDA        #$1316               
                    STA        $08,S                
                    LDA        #$2313               
                    STA        $A2,S                
                    LDA        #$6161               
                    STA        $A8,S                
                    LDA        $00,S                
                    AND        #$00F0               
                    ORA        #$6101               
                    STA        $00,S                
                    LDA        $0A,S                
                    AND        #$0F00               
                    ORA        #$3023               
                    STA        $0A,S                
                    LDA        $A0,S                
                    AND        #$00F0               
                    ORA        #$1106               
                    STA        $A0,S                
                    LDA        $AA,S                
                    AND        #$0F00               
                    ORA        #$3032               
                    STA        $AA,S                
                    TSC                             ; Line 45
                    ADC        #$0140               
                    TCS                             
                    LDA        #$3333               
                    STA        $02,S                
                    TXA                             
                    STA        $A0,S                
                    LDA        $00,S                
                    AND        #$00F0               
                    ORA        #$6101               
                    STA        $00,S                
                    LDA        $08,S                
                    AND        #$00F0               
                    ORA        #$1306               
                    STA        $08,S                
                    LDA        $0A,S                
                    AND        #$0F00               
                    ORA        #$3013               
                    STA        $0A,S                
                    LDA        $A2,S                
                    AND        #$0F00               
                    ORA        #$3013               
                    STA        $A2,S                
                    LDA        $A8,S                
                    AND        #$00F0               
                    ORA        #$6101               
                    STA        $A8,S                
                    LDA        $AA,S                
                    AND        #$0F00               
                    ORA        #$3031               
                    STA        $AA,S                
                    TSC                             ; Line 47
                    ADC        #$0140               
                    TCS                             
                    LDA        #$6161               
                    STA        $00,S                
                    TYA                             
                    STA        $A1,S                
                    LDA        $02,S                
                    AND        #$0F00               
                    ORA        #$3033               
                    STA        $02,S                
                    LDA        $08,S                
                    AND        #$00F0               
                    ORA        #$1306               
                    STA        $08,S                
                    LDA        $0A,S                
                    AND        #$0F00               
                    ORA        #$3013               
                    STA        $0A,S                
                    LDA        $A8,S                
                    AND        #$00F0               
                    ORA        #$6101               
                    STA        $A8,S                
                    LDA        $AA,S                
                    AND        #$0F00               
                    ORA        #$3033               
                    STA        $AA,S                
                    SEP        #$20                 
                    LDA        $A0,S                
                    AND        #$F0                 
                    ORA        #$06                 
                    STA        $A0,S                
                    REP        #$30                 
                    TSC                             ; Line 49
                    ADC        #$0140               
                    TCS                             
                    LDA        #$3361               
                    STA        $01,S                
                    TYA                             
                    STA        $A1,S                
                    LDA        $08,S                
                    AND        #$00F0               
                    ORA        #$1306               
                    STA        $08,S                
                    LDA        $0A,S                
                    AND        #$0F00               
                    ORA        #$3013               
                    STA        $0A,S                
                    LDA        $A8,S                
                    AND        #$00F0               
                    ORA        #$6101               
                    STA        $A8,S                
                    LDA        $AA,S                
                    AND        #$0F00               
                    ORA        #$3033               
                    STA        $AA,S                
                    SEP        #$20                 
                    LDA        $00,S                
                    AND        #$F0                 
                    ORA        #$01                 
                    STA        $00,S                
                    LDA        $A0,S                
                    AND        #$F0                 
                    ORA        #$06                 
                    STA        $A0,S                
                    REP        #$30                 
                    TSC                             ; Line 51
                    ADC        #$0140               
                    TCS                             
                    LDA        #$3361               
                    STA        $01,S                
                    LDA        #$1313               
                    STA        $09,S                
                    TYA                             
                    STA        $A1,S                
                    LDA        #$3633               
                    STA        $AA,S                
                    LDA        $05,S                
                    AND        #$F0F0               
                    ORA        #$0606               
                    STA        $05,S                
                    LDA        $07,S                
                    AND        #$F0F0               
                    ORA        #$0606               
                    STA        $07,S                
                    LDA        $A3,S                
                    AND        #$0F0F               
                    ORA        #$6060               
                    STA        $A3,S                
                    LDA        $A5,S                
                    AND        #$0F0F               
                    ORA        #$6060               
                    STA        $A5,S                
                    LDA        $A7,S                
                    AND        #$0F0F               
                    ORA        #$6060               
                    STA        $A7,S                
                    SEP        #$20                 
                    LDA        #$61                 
                    STA        $A9,S                
                    LDA        $00,S                
                    AND        #$F0                 
                    ORA        #$01                 
                    STA        $00,S                
                    LDA        $0B,S                
                    AND        #$0F                 
                    ORA        #$30                 
                    STA        $0B,S                
                    LDA        $A0,S                
                    AND        #$F0                 
                    ORA        #$06                 
                    STA        $A0,S                
                    LDA        $AC,S                
                    AND        #$F0                 
                    ORA        #$06                 
                    STA        $AC,S                
                    REP        #$30                 
                    TSC                             ; Line 53
                    ADC        #$0140               
                    TCS                             
                    LDA        #$4644               
                    STA        $01,S                
                    STA        $AA,S                
                    LDA        $03,S                
                    AND        #$F0F0               
                    ORA        #$0606               
                    STA        $03,S                
                    LDA        $05,S                
                    AND        #$F0F0               
                    ORA        #$0606               
                    STA        $05,S                
                    LDA        $07,S                
                    AND        #$F0F0               
                    ORA        #$0606               
                    STA        $07,S                
                    LDA        $0A,S                
                    AND        #$0F0F               
                    ORA        #$6040               
                    STA        $0A,S                
                    LDA        $0C,S                
                    AND        #$0F0F               
                    ORA        #$6060               
                    STA        $0C,S                
                    LDA        $A1,S                
                    AND        #$0F00               
                    ORA        #$4044               
                    STA        $A1,S                
                    LDA        $A3,S                
                    AND        #$0F0F               
                    ORA        #$6060               
                    STA        $A3,S                
                    LDA        $A5,S                
                    AND        #$0F0F               
                    ORA        #$6060               
                    STA        $A5,S                
                    LDA        $A7,S                
                    AND        #$0F0F               
                    ORA        #$6060               
                    STA        $A7,S                
                    SEP        #$20                 
                    LDA        #$44                 
                    STA        $09,S                
                    STA        $A9,S                
                    LDA        $A0,S                
                    AND        #$F0                 
                    ORA        #$04                 
                    STA        $A0,S                
                    LDA        $AC,S                
                    AND        #$F0                 
                    ORA        #$06                 
                    STA        $AC,S                
                    REP        #$30                 
                    TSC                             ; Line 55
                    ADC        #$0140               
                    TCS                             
                    TDC                             
                    STA        $00,S                
                    STA        $09,S                
                    LDA        $02,S                
                    AND        #$F0F0               
                    ORA        #$0606               
                    STA        $02,S                
                    LDA        $0B,S                
                    AND        #$0F00               
                    ORA        #$4044               
                    STA        $0B,S                
*--                                                 
                    LDAL       $E1C068              ; Direct Page and Stack in Bank 00/
                    AND        #$FFCF               
                    STAL       $E1C068              
                    LDA        StackAddress         ; Restore Stack
                    TCS                             
                    PLD                             ; Restore Direct Page
                    CLI                             ; Enable Interrupts
                    PLB
                    RTL                             
                                                    
*-----------------------------------                                
Sprite_RR_043       CLC                             ; Sprite #043 : 32x55, 1655 bytes, 2653 cycles
                    SEI                             ; Disable Interrupts
                    PHD                             ; Backup Direct Page
                    TSC                             ; Backup Stack
                    STA        StackAddress         
                    LDAL       $E1C068              ; Direct Page and Stack in Bank 01/
                    ORA        #$0030               
                    STAL       $E1C068              
                    TYA                             ; Y = Sprite Target Screen Address (upper left corner)
                    TCS                             ; New Stack address
                    LDX        #$6111               ; Pattern #1 : 15
                    LDY        #$1616               ; Pattern #2 : 13
                    LDA        #$1116               ; Pattern #3 : 11
                    TCD                             
*--                                                 
                    LDA        #$6666               ; Line 0
                    STA        $06,S                
                    STA        $A5,S                
                    LDA        $A7,S                
                    AND        #$0F00               
                    ORA        #$6066               
                    STA        $A7,S                
                    SEP        #$20                 
                    LDA        $05,S                
                    AND        #$F0                 
                    ORA        #$06                 
                    STA        $05,S                
                    REP        #$30                 
                    TSC                             ; Line 2
                    ADC        #$0148               
                    TCS                             
                    PEA        $5555                
                    PEA        $5555                
                    TSC                             ; Line 3
                    ADC        #$00A4               
                    TCS                             
                    PEA        $5555                
                    PEA        $5555                
                    TSC                             ; Line 4
                    ADC        #$00A4               
                    TCS                             
                    PEA        $6644                
                    PEA        $4464                
                    TSC                             ; Line 5
                    ADC        #$00A4               
                    TCS                             
                    PEA        $4666                
                    PEA        $6446                
                    TSC                             ; Line 6
                    ADC        #$00A4               
                    TCS                             
                    LDA        #$4444               
                    STA        $9E,S                
                    SEP        #$20                 
                    LDA        $9D,S                
                    AND        #$F0                 
                    ORA        #$04                 
                    STA        $9D,S                
                    REP        #$30                 
                    PEA        $4644                
                    PEA        $4444                
                    TSC                             ; Line 8
                    ADC        #$013C               
                    TCS                             
                    LDA        #$6466               
                    STA        $06,S                
                    LDA        #$4444               
                    STA        $A6,S                
                    SEP        #$20                 
                    LDA        $05,S                
                    AND        #$F0                 
                    ORA        #$04                 
                    STA        $05,S                
                    LDA        $A5,S                
                    AND        #$F0                 
                    ORA        #$04                 
                    STA        $A5,S                
                    REP        #$30                 
                    TSC                             ; Line 10
                    ADC        #$0140               
                    TCS                             
                    LDA        #$4416               
                    STA        $05,S                
                    LDA        $07,S                
                    AND        #$0F00               
                    ORA        #$1046               
                    STA        $07,S                
                    LDA        $A3,S                
                    AND        #$F0F0               
                    ORA        #$0601               
                    STA        $A3,S                
                    SEP        #$20                 
                    LDA        $A9,S                
                    AND        #$0F                 
                    ORA        #$10                 
                    STA        $A9,S                
                    REP        #$30                 
                    TSC                             ; Line 11
                    ADC        #$00A8               
                    TCS                             
                    SEP        #$20                 
                    LDA        #$33                 
                    STA        $9B,S                
                    REP        #$30                 
                    PEA        $6146                
                    PEA        $4416                
                    TSC                             ; Line 12
                    ADC        #$00A5               
                    TCS                             
                    LDA        $A0,S                
                    AND        #$0F00               
                    ORA        #$3063               
                    STA        $A0,S                
                    SEP        #$20                 
                    LDA        $99,S                
                    AND        #$F0                 
                    ORA        #$03                 
                    STA        $99,S                
                    REP        #$30                 
                    PEA        $6321                
                    PEA        $4644                
                    PHY                             
                    TSC                             ; Line 13
                    ADC        #$00A5               
                    TCS                             
                    SEP        #$20                 
                    LDA        #$44                 
                    STA        $A7,S                
                    LDA        $A2,S                
                    AND        #$0F                 
                    ORA        #$30                 
                    STA        $A2,S                
                    REP        #$30                 
                    PEA        $3146                
                    PEA        $6416                
                    PEA        $3631                
                    TSC                             ; Line 14
                    ADC        #$00A7               
                    TCS                             
                    SEP        #$20                 
                    LDA        #$13                 
                    STA        $A1,S                
                    LDA        #$44                 
                    STA        $A6,S                
                    REP        #$30                 
                    PHD                             
                    PEA        $6264                
                    PHD                             
                    PEA        $3323                
                    TSC                             ; Line 15
                    ADC        #$00A8               
                    TCS                             
                    LDA        $A5,S                
                    AND        #$00F0               
                    ORA        #$4404               
                    STA        $A5,S                
                    SEP        #$20                 
                    LDA        #$36                 
                    STA        $99,S                
                    LDA        #$31                 
                    STA        $A4,S                
                    REP        #$30                 
                    PEA        $1316                
                    PEA        $6364                
                    PHD                             
                    PEA        $6133                
                    TSC                             ; Line 16
                    ADC        #$00A9               
                    TCS                             
                    LDA        $97,S                
                    AND        #$00F0               
                    ORA        #$3103               
                    STA        $97,S                
                    LDA        $A2,S                
                    AND        #$00F0               
                    ORA        #$3103               
                    STA        $A2,S                
                    LDA        $A4,S                
                    AND        #$0F00               
                    ORA        #$4014               
                    STA        $A4,S                
                    PEA        $3311                
                    PEA        $6121                
                    PEA        $4464                
                    PHD                             
                    TSC                             ; Line 17
                    ADC        #$00A8               
                    TCS                             
                    LDA        #$1416               
                    STA        $A3,S                
                    LDA        $97,S                
                    AND        #$00F0               
                    ORA        #$1603               
                    STA        $97,S                
                    LDA        $A1,S                
                    AND        #$000F               
                    ORA        #$3130               
                    STA        $A1,S                
                    PEA        $1311                
                    PEA        $1136                
                    PEA        $4444                
                    PEA        $6361                
                    TSC                             ; Line 18
                    ADC        #$00A8               
                    TCS                             
                    LDA        $97,S                
                    AND        #$00F0               
                    ORA        #$3103               
                    STA        $97,S                
                    PHD                             
                    PHD                             
                    PEA        $4434                
                    PEA        $3316                
                    TSC                             ; Line 19
                    ADC        #$00AC               
                    TCS                             
                    LDA        $93,S                
                    AND        #$00F0               
                    ORA        #$3303               
                    STA        $93,S                
                    LDA        $9F,S                
                    AND        #$0F00               
                    ORA        #$1016               
                    STA        $9F,S                
                    PEA        $6161                
                    PEA        $1113                
                    PEA        $6361                
                    PEA        $1161                
                    PEA        $2316                
                    PEA        $3663                
                    TSC                             ; Line 20
                    ADC        #$00AA               
                    TCS                             
                    LDA        $95,S                
                    AND        #$00F0               
                    ORA        #$3101               
                    STA        $95,S                
                    SEP        #$20                 
                    LDA        $9D,S                
                    AND        #$0F                 
                    ORA        #$60                 
                    STA        $9D,S                
                    REP        #$30                 
                    PEA        $1631                
                    PHY                             
                    PEA        $1161                
                    PEA        $3166                
                    PEA        $3133                
                    TSC                             ; Line 21
                    ADC        #$00A6               
                    TCS                             
                    TYA                             
                    STA        $A3,S                
                    LDA        $99,S                
                    AND        #$00F0               
                    ORA        #$1603               
                    STA        $99,S                
                    LDA        $A1,S                
                    AND        #$F00F               
                    ORA        #$0610               
                    STA        $A1,S                
                    PEA        $1111                
                    PEA        $1662                
                    PEA        $1636                
                    TSC                             
                    ADC        #$000B               
                    TCS                             
                    PEA        $6161                
                    PEA        $6161                
                    TSC                             ; Line 22
                    ADC        #$009F               
                    TCS                             
                    LDA        $A0,S                
                    AND        #$0F00               
                    ORA        #$6011               
                    STA        $A0,S                
                    LDA        $A3,S                
                    AND        #$0F00               
                    ORA        #$6061               
                    STA        $A3,S                
                    SEP        #$20                 
                    LDA        $99,S                
                    AND        #$F0                 
                    ORA        #$01                 
                    STA        $99,S                
                    REP        #$30                 
                    PEA        $1611                
                    PEA        $1663                
                    PHX                             
                    TSC                             ; Line 23
                    ADC        #$00A5               
                    TCS                             
                    LDA        $A1,S                
                    AND        #$0F00               
                    ORA        #$1016               
                    STA        $A1,S                
                    SEP        #$20                 
                    LDA        $9A,S                
                    AND        #$F0                 
                    ORA        #$06                 
                    STA        $9A,S                
                    REP        #$30                 
                    PEA        $1161                
                    PEA        $2336                
                    PEA        $6661                
                    TSC                             ; Line 24
                    ADC        #$00A6               
                    TCS                             
                    LDA        $9C,S                
                    AND        #$00F0               
                    ORA        #$6303               
                    STA        $9C,S                
                    SEP        #$20                 
                    LDA        $A2,S                
                    AND        #$0F                 
                    ORA        #$60                 
                    STA        $A2,S                
                    REP        #$30                 
                    PEA        $1161                
                    PEA        $3136                
                    PEA        $1316                
                    TSC                             ; Line 25
                    ADC        #$00A7               
                    TCS                             
                    LDA        $9B,S                
                    AND        #$00F0               
                    ORA        #$3306               
                    STA        $9B,S                
                    SEP        #$20                 
                    LDA        $A1,S                
                    AND        #$0F                 
                    ORA        #$10                 
                    STA        $A1,S                
                    REP        #$30                 
                    PHX                             
                    PHD                             
                    TSC                             ; Line 26
                    ADC        #$00A4               
                    TCS                             
                    LDA        $A0,S                
                    AND        #$0F00               
                    ORA        #$6061               
                    STA        $A0,S                
                    SEP        #$20                 
                    LDA        $9B,S                
                    AND        #$F0                 
                    ORA        #$06                 
                    STA        $9B,S                
                    REP        #$30                 
                    PHY                             
                    PHD                             
                    TSC                             ; Line 27
                    ADC        #$00A3               
                    TCS                             
                    SEP        #$20                 
                    LDA        $9C,S                
                    AND        #$F0                 
                    ORA        #$05                 
                    STA        $9C,S                
                    REP        #$30                 
                    PHX                             
                    PEA        $6131                
                    TSC                             ; Line 28
                    ADC        #$00A6               
                    TCS                             
                    SEP        #$20                 
                    LDA        $9A,S                
                    AND        #$F0                 
                    ORA        #$07                 
                    STA        $9A,S                
                    REP        #$30                 
                    PEA        $5516                
                    PHY                             
                    PEA        $1155                
                    TSC                             ; Line 29
                    ADC        #$00A6               
                    TCS                             
                    SEP        #$20                 
                    LDA        $9A,S                
                    AND        #$F0                 
                    ORA        #$03                 
                    STA        $9A,S                
                    REP        #$30                 
                    PEA        $5755                
                    PEA        $5555                
                    PEA        $7575                
                    TSC                             ; Line 30
                    ADC        #$00A6               
                    TCS                             
                    SEP        #$20                 
                    LDA        #$61                 
                    STA        $A0,S                
                    REP        #$30                 
                    PEA        $7677                
                    PEA        $1771                
                    PEA        $7535                
                    TSC                             ; Line 31
                    ADC        #$00A5               
                    TCS                             
                    SEP        #$20                 
                    LDA        #$16                 
                    STA        $A1,S                
                    REP        #$30                 
                    PHX                             
                    PEA        $5775                
                    PEA        $1533                
                    TSC                             ; Line 32
                    ADC        #$00A6               
                    TCS                             
                    LDA        $9A,S                
                    AND        #$00F0               
                    ORA        #$3303               
                    STA        $9A,S                
                    PHY                             
                    PEA        $5716                
                    PEA        $5531                
                    TSC                             ; Line 33
                    ADC        #$00A7               
                    TCS                             
                    LDA        $99,S                
                    AND        #$00F0               
                    ORA        #$3103               
                    STA        $99,S                
                    PHX                             
                    PEA        $1177                
                    PEA        $1157                
                    TSC                             ; Line 34
                    ADC        #$00A6               
                    TCS                             
                    LDA        $99,S                
                    AND        #$00F0               
                    ORA        #$1303               
                    STA        $99,S                
                    PHY                             
                    PEA        $1111                
                    PEA        $1657                
                    TSC                             ; Line 35
                    ADC        #$00A6               
                    TCS                             
                    LDA        #$3133               
                    STA        $99,S                
                    LDA        #$1633               
                    STA        $9E,S                
                    LDA        $9B,S                
                    AND        #$0F00               
                    ORA        #$1016               
                    STA        $9B,S                
                    LDA        $A0,S                
                    AND        #$0F00               
                    ORA        #$1016               
                    STA        $A0,S                
                    PHX                             
                    PEA        $1163                
                    PHX                             
                    TSC                             ; Line 37
                    ADC        #$013D               
                    TCS                             
                    LDA        #$1131               
                    STA        $02,S                
                    STA        $07,S                
                    LDA        #$1133               
                    STA        $A2,S                
                    STA        $A7,S                
                    LDA        $04,S                
                    AND        #$0F00               
                    ORA        #$6061               
                    STA        $04,S                
                    LDA        $09,S                
                    AND        #$0F00               
                    ORA        #$6061               
                    STA        $09,S                
                    LDA        $A4,S                
                    AND        #$0F00               
                    ORA        #$1016               
                    STA        $A4,S                
                    LDA        $A9,S                
                    AND        #$0F00               
                    ORA        #$1016               
                    STA        $A9,S                
                    TSC                             ; Line 39
                    ADC        #$0140               
                    TCS                             
                    LDA        #$1131               
                    STA        $02,S                
                    LDA        #$3131               
                    STA        $07,S                
                    TYA                             
                    STA        $A3,S                
                    LDA        $04,S                
                    AND        #$0F00               
                    ORA        #$6061               
                    STA        $04,S                
                    LDA        $09,S                
                    AND        #$0F00               
                    ORA        #$6061               
                    STA        $09,S                
                    LDA        $A7,S                
                    AND        #$00F0               
                    ORA        #$1103               
                    STA        $A7,S                
                    LDA        $A9,S                
                    AND        #$0F00               
                    ORA        #$1016               
                    STA        $A9,S                
                    SEP        #$20                 
                    LDA        #$33                 
                    STA        $A2,S                
                    REP        #$30                 
                    TSC                             ; Line 41
                    ADC        #$0140               
                    TCS                             
                    TXA                             
                    STA        $03,S                
                    STA        $09,S                
                    TYA                             
                    STA        $A3,S                
                    STA        $A9,S                
                    LDA        $01,S                
                    AND        #$00F0               
                    ORA        #$3103               
                    STA        $01,S                
                    LDA        $07,S                
                    AND        #$00F0               
                    ORA        #$3103               
                    STA        $07,S                
                    LDA        $A1,S                
                    AND        #$00F0               
                    ORA        #$1103               
                    STA        $A1,S                
                    LDA        $A7,S                
                    AND        #$00F0               
                    ORA        #$1303               
                    STA        $A7,S                
                    TSC                             ; Line 43
                    ADC        #$0140               
                    TCS                             
                    LDA        #$6161               
                    STA        $03,S                
                    TXA                             
                    STA        $09,S                
                    TYA                             
                    STA        $A9,S                
                    LDA        $01,S                
                    AND        #$00F0               
                    ORA        #$3103               
                    STA        $01,S                
                    LDA        $A1,S                
                    AND        #$00F0               
                    ORA        #$1103               
                    STA        $A1,S                
                    LDA        $A3,S                
                    AND        #$0F00               
                    ORA        #$1016               
                    STA        $A3,S                
                    SEP        #$20                 
                    LDA        #$31                 
                    STA        $08,S                
                    LDA        #$33                 
                    STA        $A8,S                
                    REP        #$30                 
                    TSC                             ; Line 45
                    ADC        #$0140               
                    TCS                             
                    TXA                             
                    STA        $02,S                
                    STA        $09,S                
                    TYA                             
                    STA        $A2,S                
                    LDA        $A8,S                
                    AND        #$00F0               
                    ORA        #$1603               
                    STA        $A8,S                
                    LDA        $AA,S                
                    AND        #$0F00               
                    ORA        #$1016               
                    STA        $AA,S                
                    SEP        #$20                 
                    LDA        #$33                 
                    STA        $A1,S                
                    LDA        $01,S                
                    AND        #$F0                 
                    ORA        #$03                 
                    STA        $01,S                
                    LDA        $08,S                
                    AND        #$F0                 
                    ORA        #$03                 
                    STA        $08,S                
                    REP        #$30                 
                    TSC                             ; Line 47
                    ADC        #$0140               
                    TCS                             
                    TXA                             
                    STA        $02,S                
                    LDA        #$1633               
                    STA        $A1,S                
                    STA        $A9,S                
                    LDA        $08,S                
                    AND        #$00F0               
                    ORA        #$3103               
                    STA        $08,S                
                    LDA        $0A,S                
                    AND        #$0F00               
                    ORA        #$6061               
                    STA        $0A,S                
                    SEP        #$20                 
                    LDA        #$31                 
                    STA        $01,S                
                    LDA        $A3,S                
                    AND        #$0F                 
                    ORA        #$10                 
                    STA        $A3,S                
                    LDA        $AB,S                
                    AND        #$0F                 
                    ORA        #$10                 
                    STA        $AB,S                
                    REP        #$30                 
                    TSC                             ; Line 49
                    ADC        #$0140               
                    TCS                             
                    LDA        #$1131               
                    STA        $01,S                
                    STA        $09,S                
                    LDA        #$1631               
                    STA        $A1,S                
                    LDA        #$1633               
                    STA        $A9,S                
                    SEP        #$20                 
                    LDA        $03,S                
                    AND        #$0F                 
                    ORA        #$60                 
                    STA        $03,S                
                    LDA        $0B,S                
                    AND        #$0F                 
                    ORA        #$60                 
                    STA        $0B,S                
                    LDA        $A3,S                
                    AND        #$0F                 
                    ORA        #$10                 
                    STA        $A3,S                
                    LDA        $AB,S                
                    AND        #$0F                 
                    ORA        #$10                 
                    STA        $AB,S                
                    REP        #$30                 
                    TSC                             ; Line 51
                    ADC        #$0140               
                    TCS                             
                    LDA        #$6131               
                    STA        $01,S                
                    LDA        #$1131               
                    STA        $09,S                
                    LDA        $A2,S                
                    AND        #$0F0F               
                    ORA        #$6040               
                    STA        $A2,S                
                    LDA        $A4,S                
                    AND        #$0F0F               
                    ORA        #$6060               
                    STA        $A4,S                
                    LDA        $A6,S                
                    AND        #$0F0F               
                    ORA        #$6060               
                    STA        $A6,S                
                    LDA        $A8,S                
                    AND        #$0F0F               
                    ORA        #$6060               
                    STA        $A8,S                
                    LDA        $AA,S                
                    AND        #$0F00               
                    ORA        #$4044               
                    STA        $AA,S                
                    SEP        #$20                 
                    LDA        #$44                 
                    STA        $A1,S                
                    LDA        $03,S                
                    AND        #$0F                 
                    ORA        #$60                 
                    STA        $03,S                
                    LDA        $0B,S                
                    AND        #$0F                 
                    ORA        #$60                 
                    STA        $0B,S                
                    REP        #$30                 
                    TSC                             ; Line 53
                    ADC        #$0140               
                    TCS                             
                    LDA        #$4644               
                    STA        $01,S                
                    LDA        #$4444               
                    STA        $0A,S                
                    LDA        $04,S                
                    AND        #$F0F0               
                    ORA        #$0606               
                    STA        $04,S                
                    LDA        $06,S                
                    AND        #$F0F0               
                    ORA        #$0606               
                    STA        $06,S                
                    LDA        $08,S                
                    AND        #$F0F0               
                    ORA        #$0606               
                    STA        $08,S                
                    LDA        $0C,S                
                    AND        #$F0F0               
                    ORA        #$0606               
                    STA        $0C,S                
                    LDA        $A1,S                
                    AND        #$0F0F               
                    ORA        #$6040               
                    STA        $A1,S                
                    LDA        $A3,S                
                    AND        #$0F0F               
                    ORA        #$6060               
                    STA        $A3,S                
                    LDA        $A5,S                
                    AND        #$0F0F               
                    ORA        #$6060               
                    STA        $A5,S                
                    LDA        $A7,S                
                    AND        #$0F0F               
                    ORA        #$6060               
                    STA        $A7,S                
                    LDA        $A9,S                
                    AND        #$0F0F               
                    ORA        #$6060               
                    STA        $A9,S                
                    LDA        $AB,S                
                    AND        #$0F00               
                    ORA        #$4044               
                    STA        $AB,S                
                    LDA        $AD,S                
                    AND        #$0F0F               
                    ORA        #$6060               
                    STA        $AD,S                
                    SEP        #$20                 
                    LDA        #$44                 
                    STA        $A0,S                
                    LDA        $00,S                
                    AND        #$F0                 
                    ORA        #$04                 
                    STA        $00,S                
                    LDA        $03,S                
                    AND        #$F0                 
                    ORA        #$06                 
                    STA        $03,S                
                    REP        #$30                 
*--                                                 
                    LDAL       $E1C068              ; Direct Page and Stack in Bank 00/
                    AND        #$FFCF               
                    STAL       $E1C068              
                    LDA        StackAddress         ; Restore Stack
                    TCS                             
                    PLD                             ; Restore Direct Page
                    CLI                             ; Enable Interrupts
                    PLB
                    RTL                             
                                                    
*-----------------------------------                                
Sprite_RR_044       CLC                             ; Sprite #044 : 44x56, 1952 bytes, 3130 cycles
                    SEI                             ; Disable Interrupts
                    PHD                             ; Backup Direct Page
                    TSC                             ; Backup Stack
                    STA        StackAddress         
                    LDAL       $E1C068              ; Direct Page and Stack in Bank 01/
                    ORA        #$0030               
                    STAL       $E1C068              
                    TYA                             ; Y = Sprite Target Screen Address (upper left corner)
                    TCS                             ; New Stack address
                    LDX        #$6161               ; Pattern #1 : 21
                    LDY        #$1116               ; Pattern #2 : 15
                    LDA        #$3111               ; Pattern #3 : 14
                    TCD                             
*--                                                 
                    LDA        #$6666               ; Line 0
                    STA        $A8,S                
                    LDA        $08,S                
                    AND        #$00F0               
                    ORA        #$6606               
                    STA        $08,S                
                    LDA        $AA,S                
                    AND        #$0F00               
                    ORA        #$6066               
                    STA        $AA,S                
                    SEP        #$20                 
                    LDA        $0A,S                
                    AND        #$0F                 
                    ORA        #$60                 
                    STA        $0A,S                
                    REP        #$30                 
                    TSC                             ; Line 2
                    ADC        #$0140               
                    TCS                             
                    SEP        #$20                 
                    LDA        $07,S                
                    AND        #$F0                 
                    ORA        #$06                 
                    STA        $07,S                
                    LDA        $A7,S                
                    AND        #$F0                 
                    ORA        #$05                 
                    STA        $A7,S                
                    REP        #$30                 
                    TSC                             
                    ADC        #$000B               
                    TCS                             
                    PEA        $6666                
                    PEA        $6666                
                    TSC                             ; Line 3
                    ADC        #$00A4               
                    TCS                             
                    SEP        #$20                 
                    LDA        $9C,S                
                    AND        #$F0                 
                    ORA        #$05                 
                    STA        $9C,S                
                    REP        #$30                 
                    PEA        $5555                
                    PEA        $5555                
                    TSC                             ; Line 4
                    ADC        #$00A4               
                    TCS                             
                    SEP        #$20                 
                    LDA        $9C,S                
                    AND        #$F0                 
                    ORA        #$06                 
                    STA        $9C,S                
                    REP        #$30                 
                    PEA        $5555                
                    PEA        $5555                
                    TSC                             ; Line 5
                    ADC        #$00A4               
                    TCS                             
                    SEP        #$20                 
                    LDA        $9C,S                
                    AND        #$F0                 
                    ORA        #$06                 
                    STA        $9C,S                
                    REP        #$30                 
                    PEA        $4444                
                    PEA        $6666                
                    TSC                             ; Line 6
                    ADC        #$00A4               
                    TCS                             
                    LDA        #$4446               
                    STA        $9E,S                
                    LDA        $9C,S                
                    AND        #$00F0               
                    ORA        #$6606               
                    STA        $9C,S                
                    LDA        $A0,S                
                    AND        #$0F00               
                    ORA        #$4044               
                    STA        $A0,S                
                    PEA        $6446                
                    PEA        $6666                
                    TSC                             ; Line 8
                    ADC        #$0144               
                    TCS                             
                    SEP        #$20                 
                    LDA        $01,S                
                    AND        #$0F                 
                    ORA        #$40                 
                    STA        $01,S                
                    LDA        $A5,S                
                    AND        #$0F                 
                    ORA        #$40                 
                    STA        $A5,S                
                    REP        #$30                 
                    PEA        $4444                
                    PEA        $4466                
                    TSC                             ; Line 9
                    ADC        #$00A4               
                    TCS                             
                    LDA        #$4444               
                    STA        $9F,S                
                    LDA        $A4,S                
                    AND        #$00F0               
                    ORA        #$4404               
                    STA        $A4,S                
                    SEP        #$20                 
                    LDA        $9E,S                
                    AND        #$F0                 
                    ORA        #$04                 
                    STA        $9E,S                
                    REP        #$30                 
                    PEA        $4444                
                    PEA        $4466                
                    TSC                             ; Line 11
                    ADC        #$0139               
                    TCS                             
                    LDA        #$4434               
                    STA        $09,S                
                    LDA        $0F,S                
                    AND        #$00F0               
                    ORA        #$4404               
                    STA        $0F,S                
                    LDA        $AF,S                
                    AND        #$0FF0               
                    ORA        #$4004               
                    STA        $AF,S                
                    SEP        #$20                 
                    LDA        $A8,S                
                    AND        #$F0                 
                    ORA        #$03                 
                    STA        $A8,S                
                    REP        #$30                 
                    TSC                             ; Line 12
                    ADC        #$00AC               
                    TCS                             
                    LDA        $A0,S                
                    AND        #$0F00               
                    ORA        #$3031               
                    STA        $A0,S                
                    LDA        $A3,S                
                    AND        #$0FF0               
                    ORA        #$4004               
                    STA        $A3,S                
                    SEP        #$20                 
                    LDA        $9B,S                
                    AND        #$F0                 
                    ORA        #$03                 
                    STA        $9B,S                
                    REP        #$30                 
                    PEA        $1363                
                    PEA        $4423                
                    TSC                             ; Line 13
                    ADC        #$00A3               
                    TCS                             
                    LDA        $A4,S                
                    AND        #$00F0               
                    ORA        #$1603               
                    STA        $A4,S                
                    SEP        #$20                 
                    LDA        #$12                 
                    STA        $A2,S                
                    REP        #$30                 
                    PEA        $4634                
                    PEA        $3261                
                    TSC                             ; Line 14
                    ADC        #$00A5               
                    TCS                             
                    LDA        $9A,S                
                    AND        #$00F0               
                    ORA        #$3103               
                    STA        $9A,S                
                    LDA        $A2,S                
                    AND        #$F00F               
                    ORA        #$0220               
                    STA        $A2,S                
                    SEP        #$20                 
                    LDA        #$11                 
                    STA        $A4,S                
                    REP        #$30                 
                    PEA        $6344                
                    PEA        $2313                
                    PEA        $3633                
                    TSC                             ; Line 15
                    ADC        #$00A7               
                    TCS                             
                    LDA        $A2,S                
                    AND        #$00F0               
                    ORA        #$3603               
                    STA        $A2,S                
                    SEP        #$20                 
                    LDA        #$31                 
                    STA        $99,S                
                    REP        #$30                 
                    PEA        $1163                
                    PEA        $3432                
                    PEA        $6133                
                    TSC                             ; Line 16
                    ADC        #$00A7               
                    TCS                             
                    SEP        #$20                 
                    LDA        #$11                 
                    STA        $A2,S                
                    REP        #$30                 
                    PEA        $3231                
                    PEA        $4623                
                    PEA        $1336                
                    PEA        $1113                
                    TSC                             ; Line 17
                    ADC        #$00A9               
                    TCS                             
                    LDA        $96,S                
                    AND        #$00F0               
                    ORA        #$6101               
                    STA        $96,S                
                    PEA        $3213                
                    PEA        $3136                
                    PEA        $4461                
                    PEA        $1331                
                    PHY                             
                    TSC                             ; Line 18
                    ADC        #$00AB               
                    TCS                             
                    LDA        $95,S                
                    AND        #$00F0               
                    ORA        #$1606               
                    STA        $95,S                
                    PEA        $3633                
                    PEA        $3161                
                    PEA        $4344                
                    PEA        $3411                
                    PEA        $1613                
                    TSC                             ; Line 19
                    ADC        #$00AA               
                    TCS                             
                    LDA        $95,S                
                    AND        #$00F0               
                    ORA        #$6101               
                    STA        $95,S                
                    PEA        $1113                
                    PEA        $1336                
                    PEA        $4244                
                    PEA        $4464                
                    PEA        $3611                
                    TSC                             ; Line 20
                    ADC        #$00AA               
                    TCS                             
                    LDA        $95,S                
                    AND        #$00F0               
                    ORA        #$1606               
                    STA        $95,S                
                    LDA        $9F,S                
                    AND        #$0F00               
                    ORA        #$1013               
                    STA        $9F,S                
                    PEA        $3631                
                    PEA        $6121                
                    PEA        $1336                
                    PEA        $4434                
                    PEA        $3613                
                    TSC                             ; Line 21
                    ADC        #$00A8               
                    TCS                             
                    SEP        #$20                 
                    LDA        $97,S                
                    AND        #$F0                 
                    ORA        #$01                 
                    STA        $97,S                
                    REP        #$30                 
                    PEA        $1632                
                    PEA        $6111                
                    PEA        $4631                
                    PEA        $3311                
                    TSC                             ; Line 22
                    ADC        #$00A9               
                    TCS                             
                    SEP        #$20                 
                    LDA        $96,S                
                    AND        #$F0                 
                    ORA        #$06                 
                    STA        $96,S                
                    REP        #$30                 
                    PHX                             
                    PEA        $1336                
                    PEA        $1161                
                    PEA        $6131                
                    PEA        $1361                
                    TSC                             ; Line 23
                    ADC        #$00A8               
                    TCS                             
                    SEP        #$20                 
                    LDA        $98,S                
                    AND        #$F0                 
                    ORA        #$01                 
                    STA        $98,S                
                    REP        #$30                 
                    PEA        $6113                
                    PEA        $1111                
                    PEA        $1616                
                    PHY                             
                    TSC                             ; Line 24
                    ADC        #$00A8               
                    TCS                             
                    SEP        #$20                 
                    LDA        $98,S                
                    AND        #$F0                 
                    ORA        #$06                 
                    STA        $98,S                
                    REP        #$30                 
                    PEA        $3631                
                    PEA        $1111                
                    PHX                             
                    PHX                             
                    TSC                             ; Line 25
                    ADC        #$00A8               
                    TCS                             
                    PEA        $3313                
                    PEA        $3311                
                    PHY                             
                    PEA        $1616                
                    TSC                             ; Line 26
                    ADC        #$00A8               
                    TCS                             
                    SEP        #$20                 
                    LDA        $9A,S                
                    AND        #$F0                 
                    ORA        #$07                 
                    STA        $9A,S                
                    REP        #$30                 
                    PEA        $3331                
                    PHD                             
                    PEA        $1161                
                    PHX                             
                    TSC                             ; Line 27
                    ADC        #$00A8               
                    TCS                             
                    LDA        $9A,S                
                    AND        #$00F0               
                    ORA        #$5505               
                    STA        $9A,S                
                    LDA        $A0,S                
                    AND        #$0F00               
                    ORA        #$5035               
                    STA        $A0,S                
                    PEA        $3313                
                    PEA        $1313                
                    PEA        $1171                
                    TSC                             ; Line 28
                    ADC        #$00A5               
                    TCS                             
                    LDA        $9B,S                
                    AND        #$00F0               
                    ORA        #$1606               
                    STA        $9B,S                
                    LDA        $A1,S                
                    AND        #$0F00               
                    ORA        #$7075               
                    STA        $A1,S                
                    PEA        $1171                
                    PEA        $7777                
                    TSC                             ; Line 29
                    ADC        #$00A4               
                    TCS                             
                    LDA        $9B,S                
                    AND        #$00F0               
                    ORA        #$6101               
                    STA        $9B,S                
                    LDA        $A1,S                
                    AND        #$0F00               
                    ORA        #$1071               
                    STA        $A1,S                
                    PEA        $7755                
                    PEA        $5555                
                    TSC                             ; Line 30
                    ADC        #$00A4               
                    TCS                             
                    LDA        $9B,S                
                    AND        #$00F0               
                    ORA        #$1606               
                    STA        $9B,S                
                    LDA        $A1,S                
                    AND        #$0F00               
                    ORA        #$3053               
                    STA        $A1,S                
                    PEA        $7511                
                    PHX                             
                    TSC                             ; Line 31
                    ADC        #$00A4               
                    TCS                             
                    LDA        $A1,S                
                    AND        #$0F00               
                    ORA        #$3075               
                    STA        $A1,S                
                    PEA        $5711                
                    PHD                             
                    TSC                             ; Line 32
                    ADC        #$00A4               
                    TCS                             
                    SEP        #$20                 
                    LDA        $9A,S                
                    AND        #$F0                 
                    ORA        #$06                 
                    STA        $9A,S                
                    REP        #$30                 
                    PEA        $7335                
                    PEA        $1313                
                    PHX                             
                    TSC                             ; Line 33
                    ADC        #$00A8               
                    TCS                             
                    LDA        $A0,S                
                    AND        #$0F00               
                    ORA        #$3032               
                    STA        $A0,S                
                    PEA        $1375                
                    PEA        $7355                
                    PEA        $3311                
                    PHY                             
                    TSC                             ; Line 34
                    ADC        #$00A7               
                    TCS                             
                    SEP        #$20                 
                    LDA        $98,S                
                    AND        #$F0                 
                    ORA        #$06                 
                    STA        $98,S                
                    REP        #$30                 
                    PEA        $7531                
                    PEA        $5713                
                    PEA        $1313                
                    PHX                             
                    TSC                             ; Line 35
                    ADC        #$00AA               
                    TCS                             
                    LDA        $A0,S                
                    AND        #$0F00               
                    ORA        #$3032               
                    STA        $A0,S                
                    PEA        $2313                
                    PEA        $1511                
                    PEA        $3333                
                    PHD                             
                    PEA        $1616                
                    TSC                             ; Line 36
                    ADC        #$00A9               
                    TCS                             
                    SEP        #$20                 
                    LDA        $96,S                
                    AND        #$F0                 
                    ORA        #$06                 
                    STA        $96,S                
                    REP        #$30                 
                    PHD                             
                    PEA        $1616                
                    PEA        $3313                
                    PEA        $1361                
                    PHX                             
                    TSC                             ; Line 37
                    ADC        #$00AC               
                    TCS                             
                    LDA        $94,S                
                    AND        #$00F0               
                    ORA        #$6101               
                    STA        $94,S                
                    LDA        $A0,S                
                    AND        #$0F00               
                    ORA        #$3032               
                    STA        $A0,S                
                    PEA        $2313                
                    PEA        $1361                
                    PHX                             
                    PEA        $3333                
                    PHD                             
                    PEA        $1616                
                    TSC                             ; Line 38
                    ADC        #$00AB               
                    TCS                             
                    LDA        $A1,S                
                    AND        #$0F00               
                    ORA        #$2013               
                    STA        $A1,S                
                    PHD                             
                    PEA        $1616                
                    PEA        $1636                
                    PEA        $3313                
                    PEA        $1361                
                    TSC                             ; Line 39
                    ADC        #$00A4               
                    TCS                             
                    LDA        $9F,S                
                    AND        #$0F00               
                    ORA        #$3033               
                    STA        $9F,S                
                    LDA        $A3,S                
                    AND        #$00F0               
                    ORA        #$1606               
                    STA        $A3,S                
                    PEA        $2313                
                    PHD                             
                    PEA        $1616                
                    TSC                             
                    ADC        #$000C               
                    TCS                             
                    PEA        $1361                
                    PHX                             
                    TSC                             ; Line 40
                    ADC        #$009C               
                    TCS                             
                    LDA        $9C,S                
                    AND        #$00F0               
                    ORA        #$1606               
                    STA        $9C,S                
                    SEP        #$20                 
                    LDA        #$12                 
                    STA        $AA,S                
                    REP        #$30                 
                    PEA        $1313                
                    PHX                             
                    TSC                             
                    ADC        #$000E               
                    TCS                             
                    PEA        $3331                
                    PHY                             
                    TSC                             ; Line 41
                    ADC        #$009B               
                    TCS                             
                    LDA        #$1313               
                    STA        $9D,S                
                    LDA        #$1111               
                    STA        $A7,S                
                    LDA        $9B,S                
                    AND        #$00F0               
                    ORA        #$6101               
                    STA        $9B,S                
                    LDA        $9F,S                
                    AND        #$0F00               
                    ORA        #$3033               
                    STA        $9F,S                
                    LDA        $A5,S                
                    AND        #$00F0               
                    ORA        #$1606               
                    STA        $A5,S                
                    LDA        $A9,S                
                    AND        #$0F00               
                    ORA        #$2031               
                    STA        $A9,S                
                    PEA        $2333                
                    PHD                             
                    TSC                             
                    ADC        #$000C               
                    TCS                             
                    PEA        $1311                
                    PHX                             
                    TSC                             ; Line 43
                    ADC        #$013A               
                    TCS                             
                    TYA                             
                    STA        $A9,S                
                    LDA        $AB,S                
                    AND        #$0F00               
                    ORA        #$3011               
                    STA        $AB,S                
                    SEP        #$20                 
                    LDA        #$23                 
                    STA        $01,S                
                    LDA        $0C,S                
                    AND        #$0F                 
                    ORA        #$30                 
                    STA        $0C,S                
                    LDA        $A1,S                
                    AND        #$0F                 
                    ORA        #$30                 
                    STA        $A1,S                
                    LDA        $A8,S                
                    AND        #$F0                 
                    ORA        #$06                 
                    STA        $A8,S                
                    REP        #$30                 
                    PEA        $3313                
                    PHY                             
                    TSC                             
                    ADC        #$000F               
                    TCS                             
                    PEA        $1211                
                    PHX                             
                    TSC                             ; Line 44
                    ADC        #$0099               
                    TCS                             
                    TXA                             
                    STA        $A9,S                
                    LDA        $AB,S                
                    AND        #$0F00               
                    ORA        #$3013               
                    STA        $AB,S                
                    SEP        #$20                 
                    LDA        $9C,S                
                    AND        #$F0                 
                    ORA        #$06                 
                    STA        $9C,S                
                    REP        #$30                 
                    PEA        $3232                
                    PEA        $3161                
                    TSC                             ; Line 45
                    ADC        #$00A4               
                    TCS                             
                    LDA        $A9,S                
                    AND        #$00F0               
                    ORA        #$1106               
                    STA        $A9,S                
                    LDA        $AB,S                
                    AND        #$0F00               
                    ORA        #$3011               
                    STA        $AB,S                
                    SEP        #$20                 
                    LDA        #$33                 
                    STA        $A0,S                
                    REP        #$30                 
                    PEA        $2323                
                    PEA        $1316                
                    TSC                             ; Line 46
                    ADC        #$00A3               
                    TCS                             
                    LDA        $AA,S                
                    AND        #$00F0               
                    ORA        #$6101               
                    STA        $AA,S                
                    LDA        $AC,S                
                    AND        #$0F00               
                    ORA        #$3011               
                    STA        $AC,S                
                    SEP        #$20                 
                    LDA        $A1,S                
                    AND        #$0F                 
                    ORA        #$30                 
                    STA        $A1,S                
                    REP        #$30                 
                    PEA        $3212                
                    PHX                             
                    TSC                             ; Line 47
                    ADC        #$00A4               
                    TCS                             
                    LDA        $AA,S                
                    AND        #$00F0               
                    ORA        #$1106               
                    STA        $AA,S                
                    LDA        $AC,S                
                    AND        #$0F00               
                    ORA        #$3011               
                    STA        $AC,S                
                    PEA        $2313                
                    PHY                             
                    TSC                             ; Line 48
                    ADC        #$00A4               
                    TCS                             
                    LDA        #$1311               
                    STA        $9D,S                
                    LDA        $9F,S                
                    AND        #$0F00               
                    ORA        #$1013               
                    STA        $9F,S                
                    LDA        $AA,S                
                    AND        #$00F0               
                    ORA        #$6101               
                    STA        $AA,S                
                    LDA        $AC,S                
                    AND        #$0F00               
                    ORA        #$3013               
                    STA        $AC,S                
                    SEP        #$20                 
                    LDA        $9C,S                
                    AND        #$F0                 
                    ORA        #$06                 
                    STA        $9C,S                
                    REP        #$30                 
                    PEA        $3331                
                    PEA        $1161                
                    TSC                             ; Line 50
                    ADC        #$013F               
                    TCS                             
                    TDC                             
                    STA        $03,S                
                    LDA        $01,S                
                    AND        #$00F0               
                    ORA        #$6101               
                    STA        $01,S                
                    LDA        $0F,S                
                    AND        #$00F0               
                    ORA        #$1106               
                    STA        $0F,S                
                    LDA        $11,S                
                    AND        #$0F00               
                    ORA        #$3011               
                    STA        $11,S                
                    LDA        $A1,S                
                    AND        #$00F0               
                    ORA        #$1106               
                    STA        $A1,S                
                    LDA        $A3,S                
                    AND        #$0F00               
                    ORA        #$1013               
                    STA        $A3,S                
                    LDA        $AF,S                
                    AND        #$00F0               
                    ORA        #$6101               
                    STA        $AF,S                
                    LDA        $B1,S                
                    AND        #$0F00               
                    ORA        #$3013               
                    STA        $B1,S                
                    TSC                             ; Line 52
                    ADC        #$0140               
                    TCS                             
                    TDC                             
                    STA        $02,S                
                    LDA        #$1111               
                    STA        $10,S                
                    LDA        #$4464               
                    STA        $B0,S                
                    LDA        $06,S                
                    AND        #$F0F0               
                    ORA        #$0606               
                    STA        $06,S                
                    LDA        $08,S                
                    AND        #$F0F0               
                    ORA        #$0606               
                    STA        $08,S                
                    LDA        $0A,S                
                    AND        #$F0F0               
                    ORA        #$0606               
                    STA        $0A,S                
                    LDA        $0C,S                
                    AND        #$F0F0               
                    ORA        #$0606               
                    STA        $0C,S                
                    LDA        $0E,S                
                    AND        #$F0F0               
                    ORA        #$0606               
                    STA        $0E,S                
                    LDA        $A2,S                
                    AND        #$0F00               
                    ORA        #$4044               
                    STA        $A2,S                
                    LDA        $A4,S                
                    AND        #$0F0F               
                    ORA        #$6060               
                    STA        $A4,S                
                    LDA        $A6,S                
                    AND        #$0F0F               
                    ORA        #$6060               
                    STA        $A6,S                
                    LDA        $A8,S                
                    AND        #$0F0F               
                    ORA        #$6060               
                    STA        $A8,S                
                    LDA        $AA,S                
                    AND        #$0F0F               
                    ORA        #$6060               
                    STA        $AA,S                
                    LDA        $AC,S                
                    AND        #$0F0F               
                    ORA        #$6060               
                    STA        $AC,S                
                    LDA        $AE,S                
                    AND        #$0F0F               
                    ORA        #$6060               
                    STA        $AE,S                
                    LDA        $B3,S                
                    AND        #$0F0F               
                    ORA        #$6060               
                    STA        $B3,S                
                    SEP        #$20                 
                    LDA        #$36                 
                    STA        $12,S                
                    LDA        $01,S                
                    AND        #$F0                 
                    ORA        #$01                 
                    STA        $01,S                
                    LDA        $B5,S                
                    AND        #$0F                 
                    ORA        #$60                 
                    STA        $B5,S                
                    REP        #$30                 
                    TSC                             ; Line 54
                    ADC        #$0140               
                    TCS                             
                    LDA        #$4644               
                    STA        $02,S                
                    LDA        #$4444               
                    STA        $11,S                
                    STA        $A0,S                
                    STA        $B2,S                
                    LDA        $05,S                
                    AND        #$F0F0               
                    ORA        #$0606               
                    STA        $05,S                
                    LDA        $07,S                
                    AND        #$F0F0               
                    ORA        #$0606               
                    STA        $07,S                
                    LDA        $09,S                
                    AND        #$F0F0               
                    ORA        #$0606               
                    STA        $09,S                
                    LDA        $0B,S                
                    AND        #$F0F0               
                    ORA        #$0606               
                    STA        $0B,S                
                    LDA        $0D,S                
                    AND        #$F0F0               
                    ORA        #$0606               
                    STA        $0D,S                
                    LDA        $0F,S                
                    AND        #$F0F0               
                    ORA        #$0406               
                    STA        $0F,S                
                    LDA        $13,S                
                    AND        #$F0F0               
                    ORA        #$0606               
                    STA        $13,S                
                    LDA        $A8,S                
                    AND        #$0F0F               
                    ORA        #$6060               
                    STA        $A8,S                
                    LDA        $AA,S                
                    AND        #$0F0F               
                    ORA        #$6060               
                    STA        $AA,S                
                    LDA        $AC,S                
                    AND        #$0F0F               
                    ORA        #$6060               
                    STA        $AC,S                
                    LDA        $B0,S                
                    AND        #$00F0               
                    ORA        #$4404               
                    STA        $B0,S                
                    SEP        #$20                 
                    LDA        #$44                 
                    STA        $01,S                
                    LDA        $04,S                
                    AND        #$F0                 
                    ORA        #$06                 
                    STA        $04,S                
                    LDA        $A2,S                
                    AND        #$0F                 
                    ORA        #$40                 
                    STA        $A2,S                
                    LDA        $AE,S                
                    AND        #$0F                 
                    ORA        #$60                 
                    STA        $AE,S                
                    REP        #$30                 
*--                                                 
                    LDAL       $E1C068              ; Direct Page and Stack in Bank 00/
                    AND        #$FFCF               
                    STAL       $E1C068              
                    LDA        StackAddress         ; Restore Stack
                    TCS                             
                    PLD                             ; Restore Direct Page
                    CLI                             ; Enable Interrupts
                    PLB
                    RTL                             
                                                    
*-----------------------------------                                
Sprite_RR_045       CLC                             ; Sprite #045 : 50x56, 1966 bytes, 3176 cycles
                    SEI                             ; Disable Interrupts
                    PHD                             ; Backup Direct Page
                    TSC                             ; Backup Stack
                    STA        StackAddress         
                    LDAL       $E1C068              ; Direct Page and Stack in Bank 01/
                    ORA        #$0030               
                    STAL       $E1C068              
                    TYA                             ; Y = Sprite Target Screen Address (upper left corner)
                    TCS                             ; New Stack address
                    LDX        #$1111               ; Pattern #1 : 24
                    LDY        #$6161               ; Pattern #2 : 24
                    LDA        #$1616               ; Pattern #3 : 21
                    TCD                             
*--                                                 
                    LDA        #$6666               ; Line 0
                    STA        $0A,S                
                    STA        $AB,S                
                    LDA        $A9,S                
                    AND        #$00F0               
                    ORA        #$6606               
                    STA        $A9,S                
                    TSC                             ; Line 2
                    ADC        #$014C               
                    TCS                             
                    SEP        #$20                 
                    LDA        $01,S                
                    AND        #$0F                 
                    ORA        #$60                 
                    STA        $01,S                
                    LDA        $A1,S                
                    AND        #$0F                 
                    ORA        #$50                 
                    STA        $A1,S                
                    REP        #$30                 
                    PEA        $6666                
                    PEA        $6666                
                    TSC                             ; Line 3
                    ADC        #$00A4               
                    TCS                             
                    SEP        #$20                 
                    LDA        $A1,S                
                    AND        #$0F                 
                    ORA        #$50                 
                    STA        $A1,S                
                    REP        #$30                 
                    PEA        $5555                
                    PEA        $5555                
                    TSC                             ; Line 4
                    ADC        #$00A4               
                    TCS                             
                    SEP        #$20                 
                    LDA        $A1,S                
                    AND        #$0F                 
                    ORA        #$40                 
                    STA        $A1,S                
                    REP        #$30                 
                    PEA        $5555                
                    PEA        $5555                
                    TSC                             ; Line 5
                    ADC        #$00A4               
                    TCS                             
                    SEP        #$20                 
                    LDA        $A1,S                
                    AND        #$0F                 
                    ORA        #$40                 
                    STA        $A1,S                
                    REP        #$30                 
                    PEA        $4464                
                    PEA        $6666                
                    TSC                             ; Line 6
                    ADC        #$00A4               
                    TCS                             
                    SEP        #$20                 
                    LDA        #$44                 
                    STA        $A1,S                
                    LDA        $AB,S                
                    AND        #$F0                 
                    ORA        #$04                 
                    STA        $AB,S                
                    REP        #$30                 
                    PEA        $6664                
                    PEA        $6666                
                    TSC                             ; Line 7
                    ADC        #$00A4               
                    TCS                             
                    LDA        $AB,S                
                    AND        #$0F00               
                    ORA        #$4044               
                    STA        $AB,S                
                    SEP        #$20                 
                    LDA        $9D,S                
                    AND        #$F0                 
                    ORA        #$06                 
                    STA        $9D,S                
                    REP        #$30                 
                    PEA        $4464                
                    PEA        $6466                
                    TSC                             ; Line 8
                    ADC        #$00A5               
                    TCS                             
                    LDA        #$4464               
                    STA        $9D,S                
                    LDA        #$4444               
                    STA        $AA,S                
                    LDA        $9F,S                
                    AND        #$0F00               
                    ORA        #$4044               
                    STA        $9F,S                
                    LDA        $A8,S                
                    AND        #$00F0               
                    ORA        #$3402               
                    STA        $A8,S                
                    SEP        #$20                 
                    LDA        $9C,S                
                    AND        #$F0                 
                    ORA        #$06                 
                    STA        $9C,S                
                    REP        #$30                 
                    PEA        $4444                
                    PEA        $4464                
                    TSC                             ; Line 10
                    ADC        #$0137               
                    TCS                             
                    LDA        #$4444               
                    STA        $0A,S                
                    STA        $AA,S                
                    LDA        #$2333               
                    STA        $15,S                
                    LDA        #$4434               
                    STA        $A9,S                
                    LDA        #$3323               
                    STA        $B4,S                
                    LDA        $0C,S                
                    AND        #$0F00               
                    ORA        #$4044               
                    STA        $0C,S                
                    LDA        $17,S                
                    AND        #$0F00               
                    ORA        #$4044               
                    STA        $17,S                
                    LDA        $AC,S                
                    AND        #$FF0F               
                    ORA        #$0040               
                    STA        $AC,S                
                    LDA        $B6,S                
                    AND        #$0F00               
                    ORA        #$4031               
                    STA        $B6,S                
                    SEP        #$20                 
                    LDA        $09,S                
                    AND        #$F0                 
                    ORA        #$04                 
                    STA        $09,S                
                    LDA        $14,S                
                    AND        #$F0                 
                    ORA        #$02                 
                    STA        $14,S                
                    LDA        $B3,S                
                    AND        #$F0                 
                    ORA        #$03                 
                    STA        $B3,S                
                    REP        #$30                 
                    TSC                             ; Line 12
                    ADC        #$0140               
                    TCS                             
                    LDA        #$4463               
                    STA        $09,S                
                    LDA        #$1113               
                    STA        $14,S                
                    LDA        $0B,S                
                    AND        #$0F00               
                    ORA        #$3041               
                    STA        $0B,S                
                    LDA        $12,S                
                    AND        #$00F0               
                    ORA        #$2303               
                    STA        $12,S                
                    LDA        $16,S                
                    AND        #$0F00               
                    ORA        #$1016               
                    STA        $16,S                
                    SEP        #$20                 
                    LDA        #$13                 
                    STA        $AC,S                
                    LDA        $08,S                
                    AND        #$F0                 
                    ORA        #$06                 
                    STA        $08,S                
                    LDA        $B7,S                
                    AND        #$0F                 
                    ORA        #$60                 
                    STA        $B7,S                
                    REP        #$30                 
                    TSC                             ; Line 13
                    ADC        #$00AB               
                    TCS                             
                    LDA        $A3,S                
                    AND        #$00F0               
                    ORA        #$2303               
                    STA        $A3,S                
                    SEP        #$20                 
                    LDA        $9C,S                
                    AND        #$F0                 
                    ORA        #$01                 
                    STA        $9C,S                
                    REP        #$30                 
                    PEA        $4634                
                    PEA        $3611                
                    TSC                             
                    ADC        #$000F               
                    TCS                             
                    PHY                             
                    PEA        $3131                
                    PEA        $3332                
                    TSC                             ; Line 14
                    ADC        #$009D               
                    TCS                             
                    LDA        $A6,S                
                    AND        #$0F00               
                    ORA        #$6061               
                    STA        $A6,S                
                    PEA        $3363                
                    PEA        $3363                
                    PEA        $1331                
                    TSC                             
                    ADC        #$000E               
                    TCS                             
                    PHD                             
                    PEA        $1613                
                    PEA        $1332                
                    TSC                             ; Line 15
                    ADC        #$00A3               
                    TCS                             
                    SEP        #$20                 
                    LDA        #$16                 
                    STA        $A1,S                
                    REP        #$30                 
                    PEA        $6131                
                    PEA        $3131                
                    PEA        $3133                
                    PEA        $3313                
                    PEA        $3331                
                    PEA        $1113                
                    TSC                             ; Line 16
                    ADC        #$00AC               
                    TCS                             
                    LDA        $9F,S                
                    AND        #$0F00               
                    ORA        #$6061               
                    STA        $9F,S                
                    PHD                             
                    PEA        $1113                
                    PEA        $1313                
                    PEA        $1331                
                    PEA        $3111                
                    PEA        $1311                
                    TSC                             ; Line 17
                    ADC        #$00AA               
                    TCS                             
                    PEA        $6111                
                    PHX                             
                    PEA        $3111                
                    PHX                             
                    PEA        $1161                
                    TSC                             ; Line 18
                    ADC        #$00AA               
                    TCS                             
                    SEP        #$20                 
                    LDA        #$61                 
                    STA        $97,S                
                    REP        #$30                 
                    PHD                             
                    PEA        $1611                
                    PHX                             
                    PHX                             
                    PHX                             
                    TSC                             ; Line 19
                    ADC        #$00A9               
                    TCS                             
                    PHY                             
                    PHX                             
                    PHX                             
                    PHX                             
                    TSC                             ; Line 20
                    ADC        #$00A7               
                    TCS                             
                    LDA        $9F,S                
                    AND        #$0F00               
                    ORA        #$6061               
                    STA        $9F,S                
                    PHD                             
                    PHD                             
                    PHX                             
                    PHX                             
                    TSC                             ; Line 21
                    ADC        #$00A6               
                    TCS                             
                    SEP        #$20                 
                    LDA        $9B,S                
                    AND        #$F0                 
                    ORA        #$06                 
                    STA        $9B,S                
                    REP        #$30                 
                    PHY                             
                    PEA        $6111                
                    PEA        $1161                
                    TSC                             ; Line 22
                    ADC        #$00A7               
                    TCS                             
                    SEP        #$20                 
                    LDA        $9A,S                
                    AND        #$F0                 
                    ORA        #$01                 
                    STA        $9A,S                
                    REP        #$30                 
                    PHD                             
                    PHD                             
                    PEA        $1611                
                    TSC                             ; Line 23
                    ADC        #$00A6               
                    TCS                             
                    SEP        #$20                 
                    LDA        $9A,S                
                    AND        #$F0                 
                    ORA        #$06                 
                    STA        $9A,S                
                    REP        #$30                 
                    PEA        $3111                
                    PHY                             
                    PHY                             
                    TSC                             ; Line 24
                    ADC        #$00A6               
                    TCS                             
                    SEP        #$20                 
                    LDA        $9A,S                
                    AND        #$F0                 
                    ORA        #$01                 
                    STA        $9A,S                
                    REP        #$30                 
                    PEA        $1313                
                    PEA        $1311                
                    PHD                             
                    TSC                             ; Line 25
                    ADC        #$00A6               
                    TCS                             
                    SEP        #$20                 
                    LDA        $9A,S                
                    AND        #$F0                 
                    ORA        #$06                 
                    STA        $9A,S                
                    REP        #$30                 
                    PEA        $3131                
                    PEA        $3161                
                    PHY                             
                    TSC                             ; Line 26
                    ADC        #$00A6               
                    TCS                             
                    SEP        #$20                 
                    LDA        $9A,S                
                    AND        #$F0                 
                    ORA        #$07                 
                    STA        $9A,S                
                    REP        #$30                 
                    PEA        $3313                
                    PEA        $1116                
                    PHD                             
                    TSC                             ; Line 27
                    ADC        #$00A6               
                    TCS                             
                    LDA        $9A,S                
                    AND        #$00F0               
                    ORA        #$5505               
                    STA        $9A,S                
                    LDA        $A0,S                
                    AND        #$0F00               
                    ORA        #$5035               
                    STA        $A0,S                
                    PEA        $3313                
                    PEA        $1161                
                    PEA        $6171                
                    TSC                             ; Line 28
                    ADC        #$00A5               
                    TCS                             
                    LDA        $9B,S                
                    AND        #$00F0               
                    ORA        #$1606               
                    STA        $9B,S                
                    LDA        $A1,S                
                    AND        #$0F00               
                    ORA        #$5075               
                    STA        $A1,S                
                    PEA        $1171                
                    PEA        $7777                
                    TSC                             ; Line 29
                    ADC        #$00A4               
                    TCS                             
                    LDA        $9B,S                
                    AND        #$00F0               
                    ORA        #$6101               
                    STA        $9B,S                
                    LDA        $A1,S                
                    AND        #$0F00               
                    ORA        #$3033               
                    STA        $A1,S                
                    PEA        $7755                
                    PEA        $5555                
                    TSC                             ; Line 30
                    ADC        #$00A4               
                    TCS                             
                    LDA        $9B,S                
                    AND        #$00F0               
                    ORA        #$1606               
                    STA        $9B,S                
                    LDA        $A1,S                
                    AND        #$0F00               
                    ORA        #$3053               
                    STA        $A1,S                
                    PEA        $7511                
                    PHY                             
                    TSC                             ; Line 31
                    ADC        #$00A4               
                    TCS                             
                    LDA        $A1,S                
                    AND        #$0F00               
                    ORA        #$3075               
                    STA        $A1,S                
                    PEA        $5711                
                    PEA        $3111                
                    TSC                             ; Line 32
                    ADC        #$00A4               
                    TCS                             
                    SEP        #$20                 
                    LDA        $9A,S                
                    AND        #$F0                 
                    ORA        #$06                 
                    STA        $9A,S                
                    REP        #$30                 
                    PEA        $7335                
                    PEA        $1313                
                    PHY                             
                    TSC                             ; Line 33
                    ADC        #$00A8               
                    TCS                             
                    LDA        $A0,S                
                    AND        #$0F00               
                    ORA        #$3032               
                    STA        $A0,S                
                    PEA        $1375                
                    PEA        $7355                
                    PEA        $3311                
                    PEA        $1116                
                    TSC                             ; Line 34
                    ADC        #$00A7               
                    TCS                             
                    SEP        #$20                 
                    LDA        $98,S                
                    AND        #$F0                 
                    ORA        #$06                 
                    STA        $98,S                
                    REP        #$30                 
                    PEA        $7531                
                    PEA        $5713                
                    PEA        $1313                
                    PHY                             
                    TSC                             ; Line 35
                    ADC        #$00AA               
                    TCS                             
                    LDA        $A0,S                
                    AND        #$0F00               
                    ORA        #$3032               
                    STA        $A0,S                
                    PEA        $2313                
                    PEA        $1511                
                    PEA        $3333                
                    PEA        $3111                
                    PHD                             
                    TSC                             ; Line 36
                    ADC        #$00A9               
                    TCS                             
                    SEP        #$20                 
                    LDA        $96,S                
                    AND        #$F0                 
                    ORA        #$06                 
                    STA        $96,S                
                    REP        #$30                 
                    PEA        $3111                
                    PHD                             
                    PEA        $3313                
                    PEA        $1361                
                    PHY                             
                    TSC                             ; Line 37
                    ADC        #$00AC               
                    TCS                             
                    LDA        $94,S                
                    AND        #$00F0               
                    ORA        #$6101               
                    STA        $94,S                
                    LDA        $A0,S                
                    AND        #$0F00               
                    ORA        #$3032               
                    STA        $A0,S                
                    PEA        $2313                
                    PEA        $1361                
                    PHY                             
                    PEA        $3333                
                    PEA        $3111                
                    PHD                             
                    TSC                             ; Line 38
                    ADC        #$00AB               
                    TCS                             
                    LDA        $A1,S                
                    AND        #$0F00               
                    ORA        #$2013               
                    STA        $A1,S                
                    PEA        $3111                
                    PHD                             
                    PEA        $1636                
                    PEA        $3313                
                    PEA        $1361                
                    TSC                             ; Line 39
                    ADC        #$00A4               
                    TCS                             
                    LDA        $9F,S                
                    AND        #$0F00               
                    ORA        #$3033               
                    STA        $9F,S                
                    LDA        $A3,S                
                    AND        #$00F0               
                    ORA        #$1606               
                    STA        $A3,S                
                    PEA        $2313                
                    PEA        $3111                
                    PHD                             
                    TSC                             
                    ADC        #$000C               
                    TCS                             
                    PEA        $1361                
                    PHY                             
                    TSC                             ; Line 40
                    ADC        #$009C               
                    TCS                             
                    LDA        $9C,S                
                    AND        #$00F0               
                    ORA        #$1606               
                    STA        $9C,S                
                    SEP        #$20                 
                    LDA        #$12                 
                    STA        $AA,S                
                    REP        #$30                 
                    PEA        $1313                
                    PHY                             
                    TSC                             
                    ADC        #$000E               
                    TCS                             
                    PEA        $3331                
                    PEA        $1116                
                    TSC                             ; Line 41
                    ADC        #$009B               
                    TCS                             
                    LDA        #$1313               
                    STA        $9D,S                
                    TXA                             
                    STA        $A7,S                
                    LDA        $9B,S                
                    AND        #$00F0               
                    ORA        #$6101               
                    STA        $9B,S                
                    LDA        $9F,S                
                    AND        #$0F00               
                    ORA        #$3033               
                    STA        $9F,S                
                    LDA        $A5,S                
                    AND        #$00F0               
                    ORA        #$1606               
                    STA        $A5,S                
                    LDA        $A9,S                
                    AND        #$0F00               
                    ORA        #$2031               
                    STA        $A9,S                
                    PEA        $2333                
                    PEA        $3111                
                    TSC                             
                    ADC        #$000C               
                    TCS                             
                    PEA        $1311                
                    PHY                             
                    TSC                             ; Line 43
                    ADC        #$013A               
                    TCS                             
                    TXA                             
                    STA        $AA,S                
                    LDA        $A8,S                
                    AND        #$00F0               
                    ORA        #$1606               
                    STA        $A8,S                
                    SEP        #$20                 
                    LDA        #$23                 
                    STA        $01,S                
                    LDA        $0C,S                
                    AND        #$0F                 
                    ORA        #$30                 
                    STA        $0C,S                
                    LDA        $A1,S                
                    AND        #$0F                 
                    ORA        #$30                 
                    STA        $A1,S                
                    LDA        $AC,S                
                    AND        #$0F                 
                    ORA        #$30                 
                    STA        $AC,S                
                    REP        #$30                 
                    PEA        $3313                
                    PEA        $1116                
                    TSC                             
                    ADC        #$000F               
                    TCS                             
                    PEA        $1211                
                    PHY                             
                    TSC                             ; Line 44
                    ADC        #$0099               
                    TCS                             
                    TYA                             
                    STA        $A9,S                
                    LDA        $AB,S                
                    AND        #$0F00               
                    ORA        #$3013               
                    STA        $AB,S                
                    SEP        #$20                 
                    LDA        $9C,S                
                    AND        #$F0                 
                    ORA        #$06                 
                    STA        $9C,S                
                    REP        #$30                 
                    PEA        $3232                
                    PEA        $3161                
                    TSC                             ; Line 45
                    ADC        #$00A4               
                    TCS                             
                    LDA        $A9,S                
                    AND        #$00F0               
                    ORA        #$1106               
                    STA        $A9,S                
                    LDA        $AB,S                
                    AND        #$0F00               
                    ORA        #$3011               
                    STA        $AB,S                
                    SEP        #$20                 
                    LDA        #$33                 
                    STA        $A0,S                
                    REP        #$30                 
                    PEA        $2323                
                    PEA        $1316                
                    TSC                             ; Line 46
                    ADC        #$00A3               
                    TCS                             
                    LDA        $AA,S                
                    AND        #$00F0               
                    ORA        #$6101               
                    STA        $AA,S                
                    LDA        $AC,S                
                    AND        #$0F00               
                    ORA        #$3011               
                    STA        $AC,S                
                    SEP        #$20                 
                    LDA        $A1,S                
                    AND        #$0F                 
                    ORA        #$30                 
                    STA        $A1,S                
                    REP        #$30                 
                    PEA        $3212                
                    PHY                             
                    TSC                             ; Line 47
                    ADC        #$00A4               
                    TCS                             
                    LDA        $AA,S                
                    AND        #$00F0               
                    ORA        #$1106               
                    STA        $AA,S                
                    LDA        $AC,S                
                    AND        #$0F00               
                    ORA        #$3011               
                    STA        $AC,S                
                    PEA        $2313                
                    PEA        $1116                
                    TSC                             ; Line 48
                    ADC        #$00A4               
                    TCS                             
                    LDA        #$1311               
                    STA        $9D,S                
                    LDA        $9F,S                
                    AND        #$0F00               
                    ORA        #$1013               
                    STA        $9F,S                
                    LDA        $AA,S                
                    AND        #$00F0               
                    ORA        #$6101               
                    STA        $AA,S                
                    LDA        $AC,S                
                    AND        #$0F00               
                    ORA        #$3013               
                    STA        $AC,S                
                    SEP        #$20                 
                    LDA        $9C,S                
                    AND        #$F0                 
                    ORA        #$06                 
                    STA        $9C,S                
                    REP        #$30                 
                    PEA        $3331                
                    PEA        $1161                
                    TSC                             ; Line 50
                    ADC        #$013F               
                    TCS                             
                    LDA        #$3111               
                    STA        $03,S                
                    LDA        $01,S                
                    AND        #$00F0               
                    ORA        #$6101               
                    STA        $01,S                
                    LDA        $0F,S                
                    AND        #$00F0               
                    ORA        #$1106               
                    STA        $0F,S                
                    LDA        $11,S                
                    AND        #$0F00               
                    ORA        #$3011               
                    STA        $11,S                
                    LDA        $A1,S                
                    AND        #$00F0               
                    ORA        #$1106               
                    STA        $A1,S                
                    LDA        $A3,S                
                    AND        #$0F00               
                    ORA        #$1013               
                    STA        $A3,S                
                    LDA        $AF,S                
                    AND        #$00F0               
                    ORA        #$6101               
                    STA        $AF,S                
                    LDA        $B1,S                
                    AND        #$0F00               
                    ORA        #$3013               
                    STA        $B1,S                
                    TSC                             ; Line 52
                    ADC        #$0140               
                    TCS                             
                    LDA        #$3111               
                    STA        $02,S                
                    TXA                             
                    STA        $10,S                
                    LDA        #$4464               
                    STA        $B0,S                
                    LDA        $06,S                
                    AND        #$F0F0               
                    ORA        #$0606               
                    STA        $06,S                
                    LDA        $08,S                
                    AND        #$F0F0               
                    ORA        #$0606               
                    STA        $08,S                
                    LDA        $0A,S                
                    AND        #$F0F0               
                    ORA        #$0606               
                    STA        $0A,S                
                    LDA        $0C,S                
                    AND        #$F0F0               
                    ORA        #$0606               
                    STA        $0C,S                
                    LDA        $0E,S                
                    AND        #$F0F0               
                    ORA        #$0606               
                    STA        $0E,S                
                    LDA        $A2,S                
                    AND        #$0F00               
                    ORA        #$4044               
                    STA        $A2,S                
                    LDA        $A4,S                
                    AND        #$0F0F               
                    ORA        #$6060               
                    STA        $A4,S                
                    LDA        $A6,S                
                    AND        #$0F0F               
                    ORA        #$6060               
                    STA        $A6,S                
                    LDA        $A8,S                
                    AND        #$0F0F               
                    ORA        #$6060               
                    STA        $A8,S                
                    LDA        $AA,S                
                    AND        #$0F0F               
                    ORA        #$6060               
                    STA        $AA,S                
                    LDA        $AC,S                
                    AND        #$0F0F               
                    ORA        #$6060               
                    STA        $AC,S                
                    LDA        $AE,S                
                    AND        #$0F0F               
                    ORA        #$6060               
                    STA        $AE,S                
                    LDA        $B3,S                
                    AND        #$0F0F               
                    ORA        #$6060               
                    STA        $B3,S                
                    SEP        #$20                 
                    LDA        #$36                 
                    STA        $12,S                
                    LDA        $01,S                
                    AND        #$F0                 
                    ORA        #$01                 
                    STA        $01,S                
                    LDA        $B5,S                
                    AND        #$0F                 
                    ORA        #$60                 
                    STA        $B5,S                
                    REP        #$30                 
                    TSC                             ; Line 54
                    ADC        #$0140               
                    TCS                             
                    LDA        #$4644               
                    STA        $02,S                
                    LDA        #$4444               
                    STA        $11,S                
                    STA        $A0,S                
                    STA        $B2,S                
                    LDA        $05,S                
                    AND        #$F0F0               
                    ORA        #$0606               
                    STA        $05,S                
                    LDA        $07,S                
                    AND        #$F0F0               
                    ORA        #$0606               
                    STA        $07,S                
                    LDA        $09,S                
                    AND        #$F0F0               
                    ORA        #$0606               
                    STA        $09,S                
                    LDA        $0B,S                
                    AND        #$F0F0               
                    ORA        #$0606               
                    STA        $0B,S                
                    LDA        $0D,S                
                    AND        #$F0F0               
                    ORA        #$0606               
                    STA        $0D,S                
                    LDA        $0F,S                
                    AND        #$F0F0               
                    ORA        #$0406               
                    STA        $0F,S                
                    LDA        $13,S                
                    AND        #$F0F0               
                    ORA        #$0606               
                    STA        $13,S                
                    LDA        $A8,S                
                    AND        #$0F0F               
                    ORA        #$6060               
                    STA        $A8,S                
                    LDA        $AA,S                
                    AND        #$0F0F               
                    ORA        #$6060               
                    STA        $AA,S                
                    LDA        $AC,S                
                    AND        #$0F0F               
                    ORA        #$6060               
                    STA        $AC,S                
                    LDA        $B0,S                
                    AND        #$00F0               
                    ORA        #$4404               
                    STA        $B0,S                
                    SEP        #$20                 
                    LDA        #$44                 
                    STA        $01,S                
                    LDA        $04,S                
                    AND        #$F0                 
                    ORA        #$06                 
                    STA        $04,S                
                    LDA        $A2,S                
                    AND        #$0F                 
                    ORA        #$40                 
                    STA        $A2,S                
                    LDA        $AE,S                
                    AND        #$0F                 
                    ORA        #$60                 
                    STA        $AE,S                
                    REP        #$30                 
*--                                                 
                    LDAL       $E1C068              ; Direct Page and Stack in Bank 00/
                    AND        #$FFCF               
                    STAL       $E1C068              
                    LDA        StackAddress         ; Restore Stack
                    TCS                             
                    PLD                             ; Restore Direct Page
                    CLI                             ; Enable Interrupts
                    PLB
                    RTL                             
                                                    
*-----------------------------------                                
Sprite_RR_046       CLC                             ; Sprite #046 : 50x56, 1920 bytes, 3122 cycles
                    SEI                             ; Disable Interrupts
                    PHD                             ; Backup Direct Page
                    TSC                             ; Backup Stack
                    STA        StackAddress         
                    LDAL       $E1C068              ; Direct Page and Stack in Bank 01/
                    ORA        #$0030               
                    STAL       $E1C068              
                    TYA                             ; Y = Sprite Target Screen Address (upper left corner)
                    TCS                             ; New Stack address
                    LDX        #$6161               ; Pattern #1 : 33
                    LDY        #$1616               ; Pattern #2 : 24
                    LDA        #$3111               ; Pattern #3 : 17
                    TCD                             
*--                                                 
                    LDA        #$6666               ; Line 0
                    STA        $0A,S                
                    STA        $AB,S                
                    LDA        $A9,S                
                    AND        #$00F0               
                    ORA        #$6606               
                    STA        $A9,S                
                    TSC                             ; Line 2
                    ADC        #$014C               
                    TCS                             
                    SEP        #$20                 
                    LDA        $01,S                
                    AND        #$0F                 
                    ORA        #$60                 
                    STA        $01,S                
                    LDA        $A1,S                
                    AND        #$0F                 
                    ORA        #$50                 
                    STA        $A1,S                
                    REP        #$30                 
                    PEA        $6666                
                    PEA        $6666                
                    TSC                             ; Line 3
                    ADC        #$00A4               
                    TCS                             
                    SEP        #$20                 
                    LDA        $A1,S                
                    AND        #$0F                 
                    ORA        #$50                 
                    STA        $A1,S                
                    REP        #$30                 
                    PEA        $5555                
                    PEA        $5555                
                    TSC                             ; Line 4
                    ADC        #$00A4               
                    TCS                             
                    SEP        #$20                 
                    LDA        $A1,S                
                    AND        #$0F                 
                    ORA        #$40                 
                    STA        $A1,S                
                    REP        #$30                 
                    PEA        $5555                
                    PEA        $5555                
                    TSC                             ; Line 5
                    ADC        #$00A4               
                    TCS                             
                    SEP        #$20                 
                    LDA        $A1,S                
                    AND        #$0F                 
                    ORA        #$40                 
                    STA        $A1,S                
                    REP        #$30                 
                    PEA        $4464                
                    PEA        $6666                
                    TSC                             ; Line 6
                    ADC        #$00A4               
                    TCS                             
                    SEP        #$20                 
                    LDA        #$44                 
                    STA        $A1,S                
                    REP        #$30                 
                    PEA        $6664                
                    PEA        $6666                
                    TSC                             ; Line 7
                    ADC        #$00A4               
                    TCS                             
                    SEP        #$20                 
                    LDA        $9D,S                
                    AND        #$F0                 
                    ORA        #$06                 
                    STA        $9D,S                
                    REP        #$30                 
                    PEA        $4464                
                    PEA        $6466                
                    TSC                             ; Line 8
                    ADC        #$00A5               
                    TCS                             
                    LDA        #$4464               
                    STA        $9D,S                
                    LDA        $9F,S                
                    AND        #$0F00               
                    ORA        #$4044               
                    STA        $9F,S                
                    SEP        #$20                 
                    LDA        $9C,S                
                    AND        #$F0                 
                    ORA        #$06                 
                    STA        $9C,S                
                    REP        #$30                 
                    PEA        $4444                
                    PEA        $4464                
                    TSC                             ; Line 10
                    ADC        #$0137               
                    TCS                             
                    LDA        #$4444               
                    STA        $0A,S                
                    STA        $AA,S                
                    LDA        #$4434               
                    STA        $A9,S                
                    LDA        $0C,S                
                    AND        #$0F00               
                    ORA        #$4044               
                    STA        $0C,S                
                    LDA        $AC,S                
                    AND        #$FF0F               
                    ORA        #$0040               
                    STA        $AC,S                
                    SEP        #$20                 
                    LDA        $09,S                
                    AND        #$F0                 
                    ORA        #$04                 
                    STA        $09,S                
                    REP        #$30                 
                    TSC                             ; Line 12
                    ADC        #$0140               
                    TCS                             
                    LDA        #$1461               
                    STA        $09,S                
                    LDA        $0B,S                
                    AND        #$0F00               
                    ORA        #$3041               
                    STA        $0B,S                
                    SEP        #$20                 
                    LDA        #$13                 
                    STA        $AC,S                
                    LDA        $08,S                
                    AND        #$F0                 
                    ORA        #$06                 
                    STA        $08,S                
                    REP        #$30                 
                    TSC                             ; Line 13
                    ADC        #$00AB               
                    TCS                             
                    LDA        $A1,S                
                    AND        #$0F00               
                    ORA        #$3061               
                    STA        $A1,S                
                    SEP        #$20                 
                    LDA        $9C,S                
                    AND        #$F0                 
                    ORA        #$06                 
                    STA        $9C,S                
                    REP        #$30                 
                    PEA        $4614                
                    PEA        $1611                
                    TSC                             ; Line 14
                    ADC        #$00A4               
                    TCS                             
                    SEP        #$20                 
                    LDA        $A2,S                
                    AND        #$0F                 
                    ORA        #$30                 
                    STA        $A2,S                
                    REP        #$30                 
                    PEA        $4461                
                    PEA        $1313                
                    TSC                             ; Line 15
                    ADC        #$00A5               
                    TCS                             
                    SEP        #$20                 
                    LDA        $A1,S                
                    AND        #$0F                 
                    ORA        #$10                 
                    STA        $A1,S                
                    REP        #$30                 
                    PEA        $1144                
                    PEA        $3131                
                    PEA        $1111                
                    TSC                             ; Line 16
                    ADC        #$00A6               
                    TCS                             
                    SEP        #$20                 
                    LDA        $A1,S                
                    AND        #$0F                 
                    ORA        #$10                 
                    STA        $A1,S                
                    REP        #$30                 
                    PEA        $4633                
                    PEA        $1313                
                    PEA        $1316                
                    TSC                             ; Line 17
                    ADC        #$00A6               
                    TCS                             
                    SEP        #$20                 
                    LDA        $A1,S                
                    AND        #$0F                 
                    ORA        #$30                 
                    STA        $A1,S                
                    REP        #$30                 
                    PEA        $3133                
                    PHD                             
                    PHX                             
                    TSC                             ; Line 18
                    ADC        #$00A6               
                    TCS                             
                    LDA        $A1,S                
                    AND        #$0F00               
                    ORA        #$3033               
                    STA        $A1,S                
                    PEA        $3313                
                    PEA        $1311                
                    PHY                             
                    TSC                             ; Line 19
                    ADC        #$00A6               
                    TCS                             
                    SEP        #$20                 
                    LDA        $A3,S                
                    AND        #$0F                 
                    ORA        #$30                 
                    STA        $A3,S                
                    REP        #$30                 
                    PHD                             
                    PEA        $1161                
                    PHX                             
                    TSC                             ; Line 20
                    ADC        #$00A8               
                    TCS                             
                    LDA        $A1,S                
                    AND        #$0F00               
                    ORA        #$3033               
                    STA        $A1,S                
                    PEA        $1313                
                    PEA        $1111                
                    PHY                             
                    PHY                             
                    TSC                             ; Line 21
                    ADC        #$00A8               
                    TCS                             
                    LDA        $A2,S                
                    AND        #$0F00               
                    ORA        #$3013               
                    STA        $A2,S                
                    SEP        #$20                 
                    LDA        $99,S                
                    AND        #$F0                 
                    ORA        #$06                 
                    STA        $99,S                
                    REP        #$30                 
                    PHD                             
                    PHX                             
                    PHX                             
                    PHX                             
                    TSC                             ; Line 22
                    ADC        #$00A9               
                    TCS                             
                    LDA        $98,S                
                    AND        #$00F0               
                    ORA        #$6101               
                    STA        $98,S                
                    LDA        $A8,S                
                    AND        #$0F00               
                    ORA        #$4044               
                    STA        $A8,S                
                    PEA        $1313                
                    PEA        $1116                
                    PHY                             
                    PHY                             
                    TSC                             ; Line 23
                    ADC        #$00AF               
                    TCS                             
                    LDA        $91,S                
                    AND        #$00F0               
                    ORA        #$1606               
                    STA        $91,S                
                    LDA        $A1,S                
                    AND        #$0F00               
                    ORA        #$4044               
                    STA        $A1,S                
                    PEA        $3433                
                    PEA        $3333                
                    PEA        $3333                
                    PHD                             
                    PHX                             
                    PEA        $1161                
                    PHX                             
                    TSC                             ; Line 24
                    ADC        #$00AE               
                    TCS                             
                    LDA        $9F,S                
                    AND        #$0F00               
                    ORA        #$6061               
                    STA        $9F,S                
                    LDA        $A1,S                
                    AND        #$0FF0               
                    ORA        #$4004               
                    STA        $A1,S                
                    SEP        #$20                 
                    LDA        $91,S                
                    AND        #$F0                 
                    ORA        #$01                 
                    STA        $91,S                
                    REP        #$30                 
                    PEA        $3431                
                    PEA        $3131                
                    PHD                             
                    PEA        $1116                
                    PHY                             
                    PEA        $1313                
                    PHY                             
                    TSC                             ; Line 25
                    ADC        #$00A5               
                    TCS                             
                    SEP        #$20                 
                    LDA        $9A,S                
                    AND        #$F0                 
                    ORA        #$06                 
                    STA        $9A,S                
                    LDA        $A9,S                
                    AND        #$0F                 
                    ORA        #$10                 
                    STA        $A9,S                
                    REP        #$30                 
                    PEA        $3131                
                    PEA        $3161                
                    PHX                             
                    TSC                             
                    ADC        #$000D               
                    TCS                             
                    PHX                             
                    PHX                             
                    PHX                             
                    TSC                             ; Line 26
                    ADC        #$009F               
                    TCS                             
                    SEP        #$20                 
                    LDA        $9A,S                
                    AND        #$F0                 
                    ORA        #$07                 
                    STA        $9A,S                
                    REP        #$30                 
                    PEA        $3313                
                    PEA        $1116                
                    PHY                             
                    TSC                             
                    ADC        #$000E               
                    TCS                             
                    PHY                             
                    PHY                             
                    PHY                             
                    TSC                             ; Line 27
                    ADC        #$009E               
                    TCS                             
                    LDA        $9A,S                
                    AND        #$00F0               
                    ORA        #$5505               
                    STA        $9A,S                
                    LDA        $A0,S                
                    AND        #$0F00               
                    ORA        #$5035               
                    STA        $A0,S                
                    PEA        $3313                
                    PEA        $1161                
                    PEA        $6171                
                    TSC                             ; Line 28
                    ADC        #$00A5               
                    TCS                             
                    LDA        $9B,S                
                    AND        #$00F0               
                    ORA        #$1606               
                    STA        $9B,S                
                    LDA        $A1,S                
                    AND        #$0F00               
                    ORA        #$5075               
                    STA        $A1,S                
                    PEA        $1171                
                    PEA        $7777                
                    TSC                             ; Line 29
                    ADC        #$00A4               
                    TCS                             
                    LDA        $9B,S                
                    AND        #$00F0               
                    ORA        #$6101               
                    STA        $9B,S                
                    LDA        $A1,S                
                    AND        #$0F00               
                    ORA        #$3033               
                    STA        $A1,S                
                    PEA        $7755                
                    PEA        $5555                
                    TSC                             ; Line 30
                    ADC        #$00A4               
                    TCS                             
                    LDA        $9B,S                
                    AND        #$00F0               
                    ORA        #$1606               
                    STA        $9B,S                
                    LDA        $A1,S                
                    AND        #$0F00               
                    ORA        #$3053               
                    STA        $A1,S                
                    PEA        $7511                
                    PHX                             
                    TSC                             ; Line 31
                    ADC        #$00A4               
                    TCS                             
                    LDA        $A1,S                
                    AND        #$0F00               
                    ORA        #$3075               
                    STA        $A1,S                
                    PEA        $5711                
                    PHD                             
                    TSC                             ; Line 32
                    ADC        #$00A4               
                    TCS                             
                    SEP        #$20                 
                    LDA        $9A,S                
                    AND        #$F0                 
                    ORA        #$06                 
                    STA        $9A,S                
                    REP        #$30                 
                    PEA        $7335                
                    PEA        $1313                
                    PHX                             
                    TSC                             ; Line 33
                    ADC        #$00A8               
                    TCS                             
                    LDA        $A0,S                
                    AND        #$0F00               
                    ORA        #$3032               
                    STA        $A0,S                
                    PEA        $1375                
                    PEA        $7355                
                    PEA        $3311                
                    PEA        $1116                
                    TSC                             ; Line 34
                    ADC        #$00A7               
                    TCS                             
                    SEP        #$20                 
                    LDA        $98,S                
                    AND        #$F0                 
                    ORA        #$06                 
                    STA        $98,S                
                    REP        #$30                 
                    PEA        $7531                
                    PEA        $5713                
                    PEA        $1313                
                    PHX                             
                    TSC                             ; Line 35
                    ADC        #$00AA               
                    TCS                             
                    LDA        $A0,S                
                    AND        #$0F00               
                    ORA        #$3032               
                    STA        $A0,S                
                    PEA        $2313                
                    PEA        $1511                
                    PEA        $3333                
                    PHD                             
                    PHY                             
                    TSC                             ; Line 36
                    ADC        #$00A9               
                    TCS                             
                    SEP        #$20                 
                    LDA        $96,S                
                    AND        #$F0                 
                    ORA        #$06                 
                    STA        $96,S                
                    REP        #$30                 
                    PHD                             
                    PHY                             
                    PEA        $3313                
                    PEA        $1361                
                    PHX                             
                    TSC                             ; Line 37
                    ADC        #$00AC               
                    TCS                             
                    LDA        $94,S                
                    AND        #$00F0               
                    ORA        #$6101               
                    STA        $94,S                
                    LDA        $A0,S                
                    AND        #$0F00               
                    ORA        #$3032               
                    STA        $A0,S                
                    PEA        $2313                
                    PEA        $1361                
                    PHX                             
                    PEA        $3333                
                    PHD                             
                    PHY                             
                    TSC                             ; Line 38
                    ADC        #$00AB               
                    TCS                             
                    LDA        $A1,S                
                    AND        #$0F00               
                    ORA        #$2013               
                    STA        $A1,S                
                    PHD                             
                    PHY                             
                    PEA        $1636                
                    PEA        $3313                
                    PEA        $1361                
                    TSC                             ; Line 39
                    ADC        #$00A4               
                    TCS                             
                    LDA        $9F,S                
                    AND        #$0F00               
                    ORA        #$3033               
                    STA        $9F,S                
                    LDA        $A3,S                
                    AND        #$00F0               
                    ORA        #$1606               
                    STA        $A3,S                
                    PEA        $2313                
                    PHD                             
                    PHY                             
                    TSC                             
                    ADC        #$000C               
                    TCS                             
                    PEA        $1361                
                    PHX                             
                    TSC                             ; Line 40
                    ADC        #$009C               
                    TCS                             
                    LDA        $9C,S                
                    AND        #$00F0               
                    ORA        #$1606               
                    STA        $9C,S                
                    SEP        #$20                 
                    LDA        #$12                 
                    STA        $AA,S                
                    REP        #$30                 
                    PEA        $1313                
                    PHX                             
                    TSC                             
                    ADC        #$000E               
                    TCS                             
                    PEA        $3331                
                    PEA        $1116                
                    TSC                             ; Line 41
                    ADC        #$009B               
                    TCS                             
                    LDA        #$1313               
                    STA        $9D,S                
                    LDA        #$1111               
                    STA        $A7,S                
                    LDA        $9B,S                
                    AND        #$00F0               
                    ORA        #$6101               
                    STA        $9B,S                
                    LDA        $9F,S                
                    AND        #$0F00               
                    ORA        #$3033               
                    STA        $9F,S                
                    LDA        $A5,S                
                    AND        #$00F0               
                    ORA        #$1606               
                    STA        $A5,S                
                    LDA        $A9,S                
                    AND        #$0F00               
                    ORA        #$2031               
                    STA        $A9,S                
                    PEA        $2333                
                    PHD                             
                    TSC                             
                    ADC        #$000C               
                    TCS                             
                    PEA        $1311                
                    PHX                             
                    TSC                             ; Line 43
                    ADC        #$013A               
                    TCS                             
                    LDA        #$1116               
                    STA        $A9,S                
                    LDA        $AB,S                
                    AND        #$0F00               
                    ORA        #$3011               
                    STA        $AB,S                
                    SEP        #$20                 
                    LDA        #$23                 
                    STA        $01,S                
                    LDA        $0C,S                
                    AND        #$0F                 
                    ORA        #$30                 
                    STA        $0C,S                
                    LDA        $A1,S                
                    AND        #$0F                 
                    ORA        #$30                 
                    STA        $A1,S                
                    LDA        $A8,S                
                    AND        #$F0                 
                    ORA        #$06                 
                    STA        $A8,S                
                    REP        #$30                 
                    PEA        $3313                
                    PEA        $1116                
                    TSC                             
                    ADC        #$000F               
                    TCS                             
                    PEA        $1211                
                    PHX                             
                    TSC                             ; Line 44
                    ADC        #$0099               
                    TCS                             
                    TXA                             
                    STA        $A9,S                
                    LDA        $AB,S                
                    AND        #$0F00               
                    ORA        #$3013               
                    STA        $AB,S                
                    SEP        #$20                 
                    LDA        $9C,S                
                    AND        #$F0                 
                    ORA        #$06                 
                    STA        $9C,S                
                    REP        #$30                 
                    PEA        $3232                
                    PEA        $3161                
                    TSC                             ; Line 45
                    ADC        #$00A4               
                    TCS                             
                    LDA        $A9,S                
                    AND        #$00F0               
                    ORA        #$1106               
                    STA        $A9,S                
                    LDA        $AB,S                
                    AND        #$0F00               
                    ORA        #$3011               
                    STA        $AB,S                
                    SEP        #$20                 
                    LDA        #$33                 
                    STA        $A0,S                
                    REP        #$30                 
                    PEA        $2323                
                    PEA        $1316                
                    TSC                             ; Line 46
                    ADC        #$00A3               
                    TCS                             
                    LDA        $AA,S                
                    AND        #$00F0               
                    ORA        #$6101               
                    STA        $AA,S                
                    LDA        $AC,S                
                    AND        #$0F00               
                    ORA        #$3011               
                    STA        $AC,S                
                    SEP        #$20                 
                    LDA        $A1,S                
                    AND        #$0F                 
                    ORA        #$30                 
                    STA        $A1,S                
                    REP        #$30                 
                    PEA        $3212                
                    PHX                             
                    TSC                             ; Line 47
                    ADC        #$00A4               
                    TCS                             
                    LDA        $AA,S                
                    AND        #$00F0               
                    ORA        #$1106               
                    STA        $AA,S                
                    LDA        $AC,S                
                    AND        #$0F00               
                    ORA        #$3011               
                    STA        $AC,S                
                    PEA        $2313                
                    PEA        $1116                
                    TSC                             ; Line 48
                    ADC        #$00A4               
                    TCS                             
                    LDA        #$1311               
                    STA        $9D,S                
                    LDA        $9F,S                
                    AND        #$0F00               
                    ORA        #$1013               
                    STA        $9F,S                
                    LDA        $AA,S                
                    AND        #$00F0               
                    ORA        #$6101               
                    STA        $AA,S                
                    LDA        $AC,S                
                    AND        #$0F00               
                    ORA        #$3013               
                    STA        $AC,S                
                    SEP        #$20                 
                    LDA        $9C,S                
                    AND        #$F0                 
                    ORA        #$06                 
                    STA        $9C,S                
                    REP        #$30                 
                    PEA        $3331                
                    PEA        $1161                
                    TSC                             ; Line 50
                    ADC        #$013F               
                    TCS                             
                    TDC                             
                    STA        $03,S                
                    LDA        $01,S                
                    AND        #$00F0               
                    ORA        #$6101               
                    STA        $01,S                
                    LDA        $0F,S                
                    AND        #$00F0               
                    ORA        #$1106               
                    STA        $0F,S                
                    LDA        $11,S                
                    AND        #$0F00               
                    ORA        #$3011               
                    STA        $11,S                
                    LDA        $A1,S                
                    AND        #$00F0               
                    ORA        #$1106               
                    STA        $A1,S                
                    LDA        $A3,S                
                    AND        #$0F00               
                    ORA        #$1013               
                    STA        $A3,S                
                    LDA        $AF,S                
                    AND        #$00F0               
                    ORA        #$6101               
                    STA        $AF,S                
                    LDA        $B1,S                
                    AND        #$0F00               
                    ORA        #$3013               
                    STA        $B1,S                
                    TSC                             ; Line 52
                    ADC        #$0140               
                    TCS                             
                    TDC                             
                    STA        $02,S                
                    LDA        #$1111               
                    STA        $10,S                
                    LDA        #$4464               
                    STA        $B0,S                
                    LDA        $06,S                
                    AND        #$F0F0               
                    ORA        #$0606               
                    STA        $06,S                
                    LDA        $08,S                
                    AND        #$F0F0               
                    ORA        #$0606               
                    STA        $08,S                
                    LDA        $0A,S                
                    AND        #$F0F0               
                    ORA        #$0606               
                    STA        $0A,S                
                    LDA        $0C,S                
                    AND        #$F0F0               
                    ORA        #$0606               
                    STA        $0C,S                
                    LDA        $0E,S                
                    AND        #$F0F0               
                    ORA        #$0606               
                    STA        $0E,S                
                    LDA        $A2,S                
                    AND        #$0F00               
                    ORA        #$4044               
                    STA        $A2,S                
                    LDA        $A4,S                
                    AND        #$0F0F               
                    ORA        #$6060               
                    STA        $A4,S                
                    LDA        $A6,S                
                    AND        #$0F0F               
                    ORA        #$6060               
                    STA        $A6,S                
                    LDA        $A8,S                
                    AND        #$0F0F               
                    ORA        #$6060               
                    STA        $A8,S                
                    LDA        $AA,S                
                    AND        #$0F0F               
                    ORA        #$6060               
                    STA        $AA,S                
                    LDA        $AC,S                
                    AND        #$0F0F               
                    ORA        #$6060               
                    STA        $AC,S                
                    LDA        $AE,S                
                    AND        #$0F0F               
                    ORA        #$6060               
                    STA        $AE,S                
                    LDA        $B3,S                
                    AND        #$0F0F               
                    ORA        #$6060               
                    STA        $B3,S                
                    SEP        #$20                 
                    LDA        #$36                 
                    STA        $12,S                
                    LDA        $01,S                
                    AND        #$F0                 
                    ORA        #$01                 
                    STA        $01,S                
                    LDA        $B5,S                
                    AND        #$0F                 
                    ORA        #$60                 
                    STA        $B5,S                
                    REP        #$30                 
                    TSC                             ; Line 54
                    ADC        #$0140               
                    TCS                             
                    LDA        #$4644               
                    STA        $02,S                
                    LDA        #$4444               
                    STA        $11,S                
                    STA        $A0,S                
                    STA        $B2,S                
                    LDA        $05,S                
                    AND        #$F0F0               
                    ORA        #$0606               
                    STA        $05,S                
                    LDA        $07,S                
                    AND        #$F0F0               
                    ORA        #$0606               
                    STA        $07,S                
                    LDA        $09,S                
                    AND        #$F0F0               
                    ORA        #$0606               
                    STA        $09,S                
                    LDA        $0B,S                
                    AND        #$F0F0               
                    ORA        #$0606               
                    STA        $0B,S                
                    LDA        $0D,S                
                    AND        #$F0F0               
                    ORA        #$0606               
                    STA        $0D,S                
                    LDA        $0F,S                
                    AND        #$F0F0               
                    ORA        #$0406               
                    STA        $0F,S                
                    LDA        $13,S                
                    AND        #$F0F0               
                    ORA        #$0606               
                    STA        $13,S                
                    LDA        $A8,S                
                    AND        #$0F0F               
                    ORA        #$6060               
                    STA        $A8,S                
                    LDA        $AA,S                
                    AND        #$0F0F               
                    ORA        #$6060               
                    STA        $AA,S                
                    LDA        $AC,S                
                    AND        #$0F0F               
                    ORA        #$6060               
                    STA        $AC,S                
                    LDA        $B0,S                
                    AND        #$00F0               
                    ORA        #$4404               
                    STA        $B0,S                
                    SEP        #$20                 
                    LDA        #$44                 
                    STA        $01,S                
                    LDA        $04,S                
                    AND        #$F0                 
                    ORA        #$06                 
                    STA        $04,S                
                    LDA        $A2,S                
                    AND        #$0F                 
                    ORA        #$40                 
                    STA        $A2,S                
                    LDA        $AE,S                
                    AND        #$0F                 
                    ORA        #$60                 
                    STA        $AE,S                
                    REP        #$30                 
*--                                                 
                    LDAL       $E1C068              ; Direct Page and Stack in Bank 00/
                    AND        #$FFCF               
                    STAL       $E1C068              
                    LDA        StackAddress         ; Restore Stack
                    TCS                             
                    PLD                             ; Restore Direct Page
                    CLI                             ; Enable Interrupts
                    PLB
                    RTL                             
                                                    
*-----------------------------------                                
Sprite_RR_047       CLC                             ; Sprite #047 : 44x56, 2047 bytes, 3322 cycles
                    SEI                             ; Disable Interrupts
                    PHD                             ; Backup Direct Page
                    TSC                             ; Backup Stack
                    STA        StackAddress         
                    LDAL       $E1C068              ; Direct Page and Stack in Bank 01/
                    ORA        #$0030               
                    STAL       $E1C068              
                    TYA                             ; Y = Sprite Target Screen Address (upper left corner)
                    TCS                             ; New Stack address
                    LDX        #$6161               ; Pattern #1 : 28
                    LDY        #$1616               ; Pattern #2 : 24
                    LDA        #$1111               ; Pattern #3 : 17
                    TCD                             
*--                                                 
                    LDA        #$6666               ; Line 0
                    STA        $A9,S                
                    LDA        $09,S                
                    AND        #$00F0               
                    ORA        #$6606               
                    STA        $09,S                
                    LDA        $AB,S                
                    AND        #$0F00               
                    ORA        #$6066               
                    STA        $AB,S                
                    SEP        #$20                 
                    LDA        $0B,S                
                    AND        #$0F                 
                    ORA        #$60                 
                    STA        $0B,S                
                    REP        #$30                 
                    TSC                             ; Line 2
                    ADC        #$0140               
                    TCS                             
                    SEP        #$20                 
                    LDA        $08,S                
                    AND        #$F0                 
                    ORA        #$06                 
                    STA        $08,S                
                    LDA        $A8,S                
                    AND        #$F0                 
                    ORA        #$05                 
                    STA        $A8,S                
                    REP        #$30                 
                    TSC                             
                    ADC        #$000C               
                    TCS                             
                    PEA        $6666                
                    PEA        $6666                
                    TSC                             ; Line 3
                    ADC        #$00A4               
                    TCS                             
                    SEP        #$20                 
                    LDA        $9C,S                
                    AND        #$F0                 
                    ORA        #$05                 
                    STA        $9C,S                
                    REP        #$30                 
                    PEA        $5555                
                    PEA        $5555                
                    TSC                             ; Line 4
                    ADC        #$00A4               
                    TCS                             
                    SEP        #$20                 
                    LDA        $9C,S                
                    AND        #$F0                 
                    ORA        #$06                 
                    STA        $9C,S                
                    REP        #$30                 
                    PEA        $5555                
                    PEA        $5555                
                    TSC                             ; Line 5
                    ADC        #$00A4               
                    TCS                             
                    SEP        #$20                 
                    LDA        $9C,S                
                    AND        #$F0                 
                    ORA        #$06                 
                    STA        $9C,S                
                    REP        #$30                 
                    PEA        $4444                
                    PEA        $6666                
                    TSC                             ; Line 6
                    ADC        #$00A4               
                    TCS                             
                    LDA        $A0,S                
                    AND        #$0F00               
                    ORA        #$4044               
                    STA        $A0,S                
                    LDA        $A6,S                
                    AND        #$00F0               
                    ORA        #$4404               
                    STA        $A6,S                
                    PEA        $6446                
                    PEA        $6666                
                    TSC                             ; Line 7
                    ADC        #$00A3               
                    TCS                             
                    LDA        $A7,S                
                    AND        #$00F0               
                    ORA        #$4404               
                    STA        $A7,S                
                    SEP        #$20                 
                    LDA        $A2,S                
                    AND        #$0F                 
                    ORA        #$40                 
                    STA        $A2,S                
                    REP        #$30                 
                    PEA        $4446                
                    PEA        $4644                
                    PEA        $3433                
                    PEA        $3333                
                    TSC                             ; Line 8
                    ADC        #$00A9               
                    TCS                             
                    TDC                             
                    STA        $98,S                
                    LDA        $96,S                
                    AND        #$00F0               
                    ORA        #$1101               
                    STA        $96,S                
                    LDA        $9A,S                
                    AND        #$0F00               
                    ORA        #$1011               
                    STA        $9A,S                
                    LDA        $A6,S                
                    AND        #$0FF0               
                    ORA        #$4004               
                    STA        $A6,S                
                    PEA        $4444                
                    PEA        $4446                
                    PEA        $4434                
                    PEA        $3131                
                    PEA        $3131                
                    TSC                             ; Line 9
                    ADC        #$00AA               
                    TCS                             
                    TDC                             
                    STA        $98,S                
                    LDA        #$4444               
                    STA        $9F,S                
                    LDA        $96,S                
                    AND        #$00F0               
                    ORA        #$1106               
                    STA        $96,S                
                    LDA        $9A,S                
                    AND        #$0F00               
                    ORA        #$1011               
                    STA        $9A,S                
                    LDA        $9D,S                
                    AND        #$00F0               
                    ORA        #$4404               
                    STA        $9D,S                
                    LDA        $A6,S                
                    AND        #$0FF0               
                    ORA        #$4004               
                    STA        $A6,S                
                    PEA        $4444                
                    PEA        $4446                
                    TSC                             ; Line 11
                    ADC        #$0138               
                    TCS                             
                    LDA        #$4434               
                    STA        $09,S                
                    LDA        #$3311               
                    STA        $12,S                
                    STA        $A4,S                
                    LDA        #$1311               
                    STA        $B2,S                
                    LDA        $02,S                
                    AND        #$00F0               
                    ORA        #$6101               
                    STA        $02,S                
                    LDA        $04,S                
                    AND        #$0F00               
                    ORA        #$3013               
                    STA        $04,S                
                    LDA        $A2,S                
                    AND        #$00F0               
                    ORA        #$1606               
                    STA        $A2,S                
                    SEP        #$20                 
                    LDA        #$44                 
                    STA        $0B,S                
                    LDA        $A8,S                
                    AND        #$F0                 
                    ORA        #$03                 
                    STA        $A8,S                
                    REP        #$30                 
                    TSC                             ; Line 12
                    ADC        #$00AC               
                    TCS                             
                    LDA        #$3361               
                    STA        $A6,S                
                    SEP        #$20                 
                    LDA        $96,S                
                    AND        #$F0                 
                    ORA        #$01                 
                    STA        $96,S                
                    LDA        $9B,S                
                    AND        #$F0                 
                    ORA        #$03                 
                    STA        $9B,S                
                    REP        #$30                 
                    PEA        $3141                
                    PEA        $4423                
                    TSC                             ; Line 13
                    ADC        #$009E               
                    TCS                             
                    LDA        #$1316               
                    STA        $AC,S                
                    SEP        #$20                 
                    LDA        $AB,S                
                    AND        #$F0                 
                    ORA        #$06                 
                    STA        $AB,S                
                    REP        #$30                 
                    PEA        $3313                
                    PHX                             
                    TSC                             
                    ADC        #$000B               
                    TCS                             
                    PEA        $1363                
                    PEA        $4344                
                    PEA        $3361                
                    TSC                             ; Line 14
                    ADC        #$00A7               
                    TCS                             
                    SEP        #$20                 
                    LDA        $95,S                
                    AND        #$F0                 
                    ORA        #$01                 
                    STA        $95,S                
                    REP        #$30                 
                    PEA        $3321                
                    PEA        $6144                
                    PEA        $2413                
                    PEA        $3633                
                    PEA        $1311                
                    PHY                             
                    TSC                             ; Line 15
                    ADC        #$00B1               
                    TCS                             
                    PEA        $3331                
                    PEA        $3131                
                    PEA        $3311                
                    PEA        $3161                
                    PEA        $4434                
                    PEA        $6131                
                    PEA        $3111                
                    PHX                             
                    TSC                             ; Line 16
                    ADC        #$00B0               
                    TCS                             
                    LDA        $91,S                
                    AND        #$00F0               
                    ORA        #$6101               
                    STA        $91,S                
                    PEA        $6111                
                    PEA        $1313                
                    PEA        $1313                
                    PEA        $2163                
                    PEA        $4434                
                    PEA        $6111                
                    PEA        $1311                
                    PHY                             
                    TSC                             ; Line 17
                    ADC        #$00B0               
                    TCS                             
                    SEP        #$20                 
                    LDA        $A0,S                
                    AND        #$0F                 
                    ORA        #$60                 
                    STA        $A0,S                
                    REP        #$30                 
                    PHY                             
                    PEA        $1611                
                    PHD                             
                    PEA        $3162                
                    PEA        $4632                
                    PEA        $1631                
                    PEA        $1161                
                    TSC                             ; Line 18
                    ADC        #$00AD               
                    TCS                             
                    SEP        #$20                 
                    LDA        $93,S                
                    AND        #$F0                 
                    ORA        #$01                 
                    STA        $93,S                
                    REP        #$30                 
                    PHX                             
                    PEA        $6111                
                    PHD                             
                    PEA        $1346                
                    PEA        $6311                
                    PHD                             
                    PHY                             
                    TSC                             ; Line 19
                    ADC        #$00AD               
                    TCS                             
                    SEP        #$20                 
                    LDA        $9F,S                
                    AND        #$0F                 
                    ORA        #$60                 
                    STA        $9F,S                
                    REP        #$30                 
                    PHY                             
                    PHY                             
                    PEA        $1133                
                    PEA        $2663                
                    PHD                             
                    PHX                             
                    TSC                             ; Line 20
                    ADC        #$00AA               
                    TCS                             
                    LDA        $97,S                
                    AND        #$00F0               
                    ORA        #$6101               
                    STA        $97,S                
                    LDA        $9F,S                
                    AND        #$0F00               
                    ORA        #$1016               
                    STA        $9F,S                
                    PHX                             
                    PEA        $1161                
                    PEA        $3216                
                    PHD                             
                    PHY                             
                    TSC                             ; Line 21
                    ADC        #$00A8               
                    TCS                             
                    LDA        $A0,S                
                    AND        #$0F00               
                    ORA        #$6011               
                    STA        $A0,S                
                    PEA        $1121                
                    PEA        $6311                
                    PEA        $1161                
                    TSC                             ; Line 22
                    ADC        #$00A5               
                    TCS                             
                    SEP        #$20                 
                    LDA        $9B,S                
                    AND        #$F0                 
                    ORA        #$01                 
                    STA        $9B,S                
                    REP        #$30                 
                    PEA        $3216                
                    PHD                             
                    PHY                             
                    TSC                             ; Line 23
                    ADC        #$00A7               
                    TCS                             
                    SEP        #$20                 
                    LDA        $9A,S                
                    AND        #$F0                 
                    ORA        #$06                 
                    STA        $9A,S                
                    REP        #$30                 
                    PEA        $2163                
                    PHD                             
                    PHX                             
                    TSC                             ; Line 24
                    ADC        #$00A6               
                    TCS                             
                    SEP        #$20                 
                    LDA        $9A,S                
                    AND        #$F0                 
                    ORA        #$01                 
                    STA        $9A,S                
                    REP        #$30                 
                    PEA        $3316                
                    PHY                             
                    PHY                             
                    TSC                             ; Line 25
                    ADC        #$00A6               
                    TCS                             
                    SEP        #$20                 
                    LDA        $9A,S                
                    AND        #$F0                 
                    ORA        #$06                 
                    STA        $9A,S                
                    REP        #$30                 
                    PEA        $6361                
                    PHX                             
                    PHX                             
                    TSC                             ; Line 26
                    ADC        #$00A6               
                    TCS                             
                    SEP        #$20                 
                    LDA        $9A,S                
                    AND        #$F0                 
                    ORA        #$07                 
                    STA        $9A,S                
                    REP        #$30                 
                    PEA        $1316                
                    PHY                             
                    PHY                             
                    TSC                             ; Line 27
                    ADC        #$00A6               
                    TCS                             
                    LDA        $9A,S                
                    AND        #$00F0               
                    ORA        #$5505               
                    STA        $9A,S                
                    LDA        $A0,S                
                    AND        #$0F00               
                    ORA        #$5065               
                    STA        $A0,S                
                    PEA        $6361                
                    PHX                             
                    PEA        $6171                
                    TSC                             ; Line 28
                    ADC        #$00A5               
                    TCS                             
                    LDA        $9B,S                
                    AND        #$00F0               
                    ORA        #$1606               
                    STA        $9B,S                
                    LDA        $A1,S                
                    AND        #$0F00               
                    ORA        #$5075               
                    STA        $A1,S                
                    PEA        $1676                
                    PEA        $7777                
                    TSC                             ; Line 29
                    ADC        #$00A4               
                    TCS                             
                    LDA        $9B,S                
                    AND        #$00F0               
                    ORA        #$6101               
                    STA        $9B,S                
                    LDA        $A1,S                
                    AND        #$0F00               
                    ORA        #$3033               
                    STA        $A1,S                
                    PEA        $7755                
                    PEA        $5555                
                    TSC                             ; Line 30
                    ADC        #$00A4               
                    TCS                             
                    LDA        $9B,S                
                    AND        #$00F0               
                    ORA        #$1606               
                    STA        $9B,S                
                    LDA        $A1,S                
                    AND        #$0F00               
                    ORA        #$3053               
                    STA        $A1,S                
                    PEA        $7511                
                    PHX                             
                    TSC                             ; Line 31
                    ADC        #$00A4               
                    TCS                             
                    LDA        $A1,S                
                    AND        #$0F00               
                    ORA        #$3075               
                    STA        $A1,S                
                    PEA        $5711                
                    PEA        $3111                
                    TSC                             ; Line 32
                    ADC        #$00A4               
                    TCS                             
                    SEP        #$20                 
                    LDA        $9A,S                
                    AND        #$F0                 
                    ORA        #$06                 
                    STA        $9A,S                
                    REP        #$30                 
                    PEA        $7335                
                    PEA        $1313                
                    PHX                             
                    TSC                             ; Line 33
                    ADC        #$00A8               
                    TCS                             
                    LDA        $A0,S                
                    AND        #$0F00               
                    ORA        #$3032               
                    STA        $A0,S                
                    PEA        $1375                
                    PEA        $7355                
                    PEA        $3311                
                    PEA        $1116                
                    TSC                             ; Line 34
                    ADC        #$00A7               
                    TCS                             
                    SEP        #$20                 
                    LDA        $98,S                
                    AND        #$F0                 
                    ORA        #$06                 
                    STA        $98,S                
                    REP        #$30                 
                    PEA        $7531                
                    PEA        $5713                
                    PEA        $1313                
                    PHX                             
                    TSC                             ; Line 35
                    ADC        #$00AA               
                    TCS                             
                    LDA        $A0,S                
                    AND        #$0F00               
                    ORA        #$3032               
                    STA        $A0,S                
                    PEA        $2313                
                    PEA        $1511                
                    PEA        $3333                
                    PEA        $3111                
                    PHY                             
                    TSC                             ; Line 36
                    ADC        #$00A9               
                    TCS                             
                    SEP        #$20                 
                    LDA        $96,S                
                    AND        #$F0                 
                    ORA        #$06                 
                    STA        $96,S                
                    REP        #$30                 
                    PEA        $3111                
                    PHY                             
                    PEA        $3313                
                    PEA        $1361                
                    PHX                             
                    TSC                             ; Line 37
                    ADC        #$00AC               
                    TCS                             
                    LDA        $94,S                
                    AND        #$00F0               
                    ORA        #$6101               
                    STA        $94,S                
                    LDA        $A0,S                
                    AND        #$0F00               
                    ORA        #$3032               
                    STA        $A0,S                
                    PEA        $2313                
                    PEA        $1361                
                    PHX                             
                    PEA        $3333                
                    PEA        $3111                
                    PHY                             
                    TSC                             ; Line 38
                    ADC        #$00AB               
                    TCS                             
                    LDA        $A1,S                
                    AND        #$0F00               
                    ORA        #$2013               
                    STA        $A1,S                
                    PEA        $3111                
                    PHY                             
                    PEA        $1636                
                    PEA        $3313                
                    PEA        $1361                
                    TSC                             ; Line 39
                    ADC        #$00A4               
                    TCS                             
                    LDA        $9F,S                
                    AND        #$0F00               
                    ORA        #$3033               
                    STA        $9F,S                
                    LDA        $A3,S                
                    AND        #$00F0               
                    ORA        #$1606               
                    STA        $A3,S                
                    PEA        $2313                
                    PEA        $3111                
                    PHY                             
                    TSC                             
                    ADC        #$000C               
                    TCS                             
                    PEA        $1361                
                    PHX                             
                    TSC                             ; Line 40
                    ADC        #$009C               
                    TCS                             
                    LDA        $9C,S                
                    AND        #$00F0               
                    ORA        #$1606               
                    STA        $9C,S                
                    SEP        #$20                 
                    LDA        #$12                 
                    STA        $AA,S                
                    REP        #$30                 
                    PEA        $1313                
                    PHX                             
                    TSC                             
                    ADC        #$000E               
                    TCS                             
                    PEA        $3331                
                    PEA        $1116                
                    TSC                             ; Line 41
                    ADC        #$009B               
                    TCS                             
                    LDA        #$1313               
                    STA        $9D,S                
                    TDC                             
                    STA        $A7,S                
                    LDA        $9B,S                
                    AND        #$00F0               
                    ORA        #$6101               
                    STA        $9B,S                
                    LDA        $9F,S                
                    AND        #$0F00               
                    ORA        #$3033               
                    STA        $9F,S                
                    LDA        $A5,S                
                    AND        #$00F0               
                    ORA        #$1606               
                    STA        $A5,S                
                    LDA        $A9,S                
                    AND        #$0F00               
                    ORA        #$2031               
                    STA        $A9,S                
                    PEA        $2333                
                    PEA        $3111                
                    TSC                             
                    ADC        #$000C               
                    TCS                             
                    PEA        $1311                
                    PHX                             
                    TSC                             ; Line 43
                    ADC        #$013A               
                    TCS                             
                    TDC                             
                    STA        $AA,S                
                    LDA        $A8,S                
                    AND        #$00F0               
                    ORA        #$1606               
                    STA        $A8,S                
                    SEP        #$20                 
                    LDA        #$23                 
                    STA        $01,S                
                    LDA        $0C,S                
                    AND        #$0F                 
                    ORA        #$30                 
                    STA        $0C,S                
                    LDA        $A1,S                
                    AND        #$0F                 
                    ORA        #$30                 
                    STA        $A1,S                
                    LDA        $AC,S                
                    AND        #$0F                 
                    ORA        #$30                 
                    STA        $AC,S                
                    REP        #$30                 
                    PEA        $3313                
                    PEA        $1116                
                    TSC                             
                    ADC        #$000F               
                    TCS                             
                    PEA        $1211                
                    PHX                             
                    TSC                             ; Line 44
                    ADC        #$0099               
                    TCS                             
                    TXA                             
                    STA        $A9,S                
                    LDA        $AB,S                
                    AND        #$0F00               
                    ORA        #$3013               
                    STA        $AB,S                
                    SEP        #$20                 
                    LDA        $9C,S                
                    AND        #$F0                 
                    ORA        #$06                 
                    STA        $9C,S                
                    REP        #$30                 
                    PEA        $3232                
                    PEA        $3161                
                    TSC                             ; Line 45
                    ADC        #$00A4               
                    TCS                             
                    LDA        $A9,S                
                    AND        #$00F0               
                    ORA        #$1106               
                    STA        $A9,S                
                    LDA        $AB,S                
                    AND        #$0F00               
                    ORA        #$3011               
                    STA        $AB,S                
                    SEP        #$20                 
                    LDA        #$33                 
                    STA        $A0,S                
                    REP        #$30                 
                    PEA        $2323                
                    PEA        $1316                
                    TSC                             ; Line 46
                    ADC        #$00A3               
                    TCS                             
                    LDA        $AA,S                
                    AND        #$00F0               
                    ORA        #$6101               
                    STA        $AA,S                
                    LDA        $AC,S                
                    AND        #$0F00               
                    ORA        #$3011               
                    STA        $AC,S                
                    SEP        #$20                 
                    LDA        $A1,S                
                    AND        #$0F                 
                    ORA        #$30                 
                    STA        $A1,S                
                    REP        #$30                 
                    PEA        $3212                
                    PHX                             
                    TSC                             ; Line 47
                    ADC        #$00A4               
                    TCS                             
                    LDA        $AA,S                
                    AND        #$00F0               
                    ORA        #$1106               
                    STA        $AA,S                
                    LDA        $AC,S                
                    AND        #$0F00               
                    ORA        #$3011               
                    STA        $AC,S                
                    PEA        $2313                
                    PEA        $1116                
                    TSC                             ; Line 48
                    ADC        #$00A4               
                    TCS                             
                    LDA        #$1311               
                    STA        $9D,S                
                    LDA        $9F,S                
                    AND        #$0F00               
                    ORA        #$1013               
                    STA        $9F,S                
                    LDA        $AA,S                
                    AND        #$00F0               
                    ORA        #$6101               
                    STA        $AA,S                
                    LDA        $AC,S                
                    AND        #$0F00               
                    ORA        #$3013               
                    STA        $AC,S                
                    SEP        #$20                 
                    LDA        $9C,S                
                    AND        #$F0                 
                    ORA        #$06                 
                    STA        $9C,S                
                    REP        #$30                 
                    PEA        $3331                
                    PEA        $1161                
                    TSC                             ; Line 50
                    ADC        #$013F               
                    TCS                             
                    LDA        #$3111               
                    STA        $03,S                
                    LDA        $01,S                
                    AND        #$00F0               
                    ORA        #$6101               
                    STA        $01,S                
                    LDA        $0F,S                
                    AND        #$00F0               
                    ORA        #$1106               
                    STA        $0F,S                
                    LDA        $11,S                
                    AND        #$0F00               
                    ORA        #$3011               
                    STA        $11,S                
                    LDA        $A1,S                
                    AND        #$00F0               
                    ORA        #$1106               
                    STA        $A1,S                
                    LDA        $A3,S                
                    AND        #$0F00               
                    ORA        #$1013               
                    STA        $A3,S                
                    LDA        $AF,S                
                    AND        #$00F0               
                    ORA        #$6101               
                    STA        $AF,S                
                    LDA        $B1,S                
                    AND        #$0F00               
                    ORA        #$3013               
                    STA        $B1,S                
                    TSC                             ; Line 52
                    ADC        #$0140               
                    TCS                             
                    LDA        #$3111               
                    STA        $02,S                
                    TDC                             
                    STA        $10,S                
                    LDA        #$4464               
                    STA        $B0,S                
                    LDA        $06,S                
                    AND        #$F0F0               
                    ORA        #$0606               
                    STA        $06,S                
                    LDA        $08,S                
                    AND        #$F0F0               
                    ORA        #$0606               
                    STA        $08,S                
                    LDA        $0A,S                
                    AND        #$F0F0               
                    ORA        #$0606               
                    STA        $0A,S                
                    LDA        $0C,S                
                    AND        #$F0F0               
                    ORA        #$0606               
                    STA        $0C,S                
                    LDA        $0E,S                
                    AND        #$F0F0               
                    ORA        #$0606               
                    STA        $0E,S                
                    LDA        $A2,S                
                    AND        #$0F00               
                    ORA        #$4044               
                    STA        $A2,S                
                    LDA        $A4,S                
                    AND        #$0F0F               
                    ORA        #$6060               
                    STA        $A4,S                
                    LDA        $A6,S                
                    AND        #$0F0F               
                    ORA        #$6060               
                    STA        $A6,S                
                    LDA        $A8,S                
                    AND        #$0F0F               
                    ORA        #$6060               
                    STA        $A8,S                
                    LDA        $AA,S                
                    AND        #$0F0F               
                    ORA        #$6060               
                    STA        $AA,S                
                    LDA        $AC,S                
                    AND        #$0F0F               
                    ORA        #$6060               
                    STA        $AC,S                
                    LDA        $AE,S                
                    AND        #$0F0F               
                    ORA        #$6060               
                    STA        $AE,S                
                    LDA        $B3,S                
                    AND        #$0F0F               
                    ORA        #$6060               
                    STA        $B3,S                
                    SEP        #$20                 
                    LDA        #$36                 
                    STA        $12,S                
                    LDA        $01,S                
                    AND        #$F0                 
                    ORA        #$01                 
                    STA        $01,S                
                    LDA        $B5,S                
                    AND        #$0F                 
                    ORA        #$60                 
                    STA        $B5,S                
                    REP        #$30                 
                    TSC                             ; Line 54
                    ADC        #$0140               
                    TCS                             
                    LDA        #$4644               
                    STA        $02,S                
                    LDA        #$4444               
                    STA        $11,S                
                    STA        $A0,S                
                    STA        $B2,S                
                    LDA        $05,S                
                    AND        #$F0F0               
                    ORA        #$0606               
                    STA        $05,S                
                    LDA        $07,S                
                    AND        #$F0F0               
                    ORA        #$0606               
                    STA        $07,S                
                    LDA        $09,S                
                    AND        #$F0F0               
                    ORA        #$0606               
                    STA        $09,S                
                    LDA        $0B,S                
                    AND        #$F0F0               
                    ORA        #$0606               
                    STA        $0B,S                
                    LDA        $0D,S                
                    AND        #$F0F0               
                    ORA        #$0606               
                    STA        $0D,S                
                    LDA        $0F,S                
                    AND        #$F0F0               
                    ORA        #$0406               
                    STA        $0F,S                
                    LDA        $13,S                
                    AND        #$F0F0               
                    ORA        #$0606               
                    STA        $13,S                
                    LDA        $A8,S                
                    AND        #$0F0F               
                    ORA        #$6060               
                    STA        $A8,S                
                    LDA        $AA,S                
                    AND        #$0F0F               
                    ORA        #$6060               
                    STA        $AA,S                
                    LDA        $AC,S                
                    AND        #$0F0F               
                    ORA        #$6060               
                    STA        $AC,S                
                    LDA        $B0,S                
                    AND        #$00F0               
                    ORA        #$4404               
                    STA        $B0,S                
                    SEP        #$20                 
                    LDA        #$44                 
                    STA        $01,S                
                    LDA        $04,S                
                    AND        #$F0                 
                    ORA        #$06                 
                    STA        $04,S                
                    LDA        $A2,S                
                    AND        #$0F                 
                    ORA        #$40                 
                    STA        $A2,S                
                    LDA        $AE,S                
                    AND        #$0F                 
                    ORA        #$60                 
                    STA        $AE,S                
                    REP        #$30                 
*--                                                 
                    LDAL       $E1C068              ; Direct Page and Stack in Bank 00/
                    AND        #$FFCF               
                    STAL       $E1C068              
                    LDA        StackAddress         ; Restore Stack
                    TCS                             
                    PLD                             ; Restore Direct Page
                    CLI                             ; Enable Interrupts
                    PLB
                    RTL                             
                                                    
*-----------------------------------                                
Sprite_RR_048       CLC                             ; Sprite #048 : 48x56, 1816 bytes, 2886 cycles
                    SEI                             ; Disable Interrupts
                    PHD                             ; Backup Direct Page
                    TSC                             ; Backup Stack
                    STA        StackAddress         
                    LDAL       $E1C068              ; Direct Page and Stack in Bank 01/
                    ORA        #$0030               
                    STAL       $E1C068              
                    TYA                             ; Y = Sprite Target Screen Address (upper left corner)
                    TCS                             ; New Stack address
                    LDX        #$6161               ; Pattern #1 : 14
                    LDY        #$1111               ; Pattern #2 : 12
                    LDA        #$1161               ; Pattern #3 : 12
                    TCD                             
*--                                                 
                    LDA        #$6666               ; Line 0
                    STA        $10,S                
                    STA        $B0,S                
                    LDA        $B2,S                
                    AND        #$0F00               
                    ORA        #$6066               
                    STA        $B2,S                
                    SEP        #$20                 
                    LDA        $12,S                
                    AND        #$0F                 
                    ORA        #$60                 
                    STA        $12,S                
                    LDA        $AF,S                
                    AND        #$F0                 
                    ORA        #$06                 
                    STA        $AF,S                
                    REP        #$30                 
                    TSC                             ; Line 2
                    ADC        #$0152               
                    TCS                             
                    SEP        #$20                 
                    LDA        #$66                 
                    STA        $01,S                
                    LDA        #$55                 
                    STA        $A1,S                
                    REP        #$30                 
                    PEA        $6666                
                    PEA        $6666                
                    TSC                             ; Line 3
                    ADC        #$00A4               
                    TCS                             
                    SEP        #$20                 
                    LDA        #$55                 
                    STA        $A1,S                
                    REP        #$30                 
                    PEA        $5555                
                    PEA        $5555                
                    TSC                             ; Line 4
                    ADC        #$00A4               
                    TCS                             
                    SEP        #$20                 
                    LDA        #$44                 
                    STA        $A1,S                
                    REP        #$30                 
                    PEA        $5555                
                    PEA        $5555                
                    TSC                             ; Line 5
                    ADC        #$00A4               
                    TCS                             
                    SEP        #$20                 
                    LDA        #$64                 
                    STA        $A1,S                
                    REP        #$30                 
                    PEA        $4464                
                    PEA        $6666                
                    TSC                             ; Line 6
                    ADC        #$00A4               
                    TCS                             
                    LDA        $A1,S                
                    AND        #$0F00               
                    ORA        #$4044               
                    STA        $A1,S                
                    PEA        $4664                
                    PEA        $6666                
                    TSC                             ; Line 7
                    ADC        #$00A4               
                    TCS                             
                    LDA        #$4444               
                    STA        $9F,S                
                    LDA        $9D,S                
                    AND        #$00F0               
                    ORA        #$6406               
                    STA        $9D,S                
                    LDA        $A1,S                
                    AND        #$0F00               
                    ORA        #$4044               
                    STA        $A1,S                
                    PEA        $4464                
                    PEA        $6466                
                    TSC                             ; Line 9
                    ADC        #$0145               
                    TCS                             
                    SEP        #$20                 
                    LDA        #$44                 
                    STA        $A0,S                
                    REP        #$30                 
                    PEA        $4444                
                    PEA        $4444                
                    TSC                             ; Line 10
                    ADC        #$00A3               
                    TCS                             
                    SEP        #$20                 
                    LDA        $9B,S                
                    AND        #$F0                 
                    ORA        #$01                 
                    STA        $9B,S                
                    REP        #$30                 
                    PEA        $4444                
                    PEA        $4433                
                    TSC                             ; Line 11
                    ADC        #$00A3               
                    TCS                             
                    LDA        #$1116               
                    STA        $9D,S                
                    LDA        $9B,S                
                    AND        #$00F0               
                    ORA        #$1101               
                    STA        $9B,S                
                    LDA        $9F,S                
                    AND        #$0F00               
                    ORA        #$4034               
                    STA        $9F,S                
                    PEA        $4434                
                    PEA        $1316                
                    TSC                             ; Line 13
                    ADC        #$0133               
                    TCS                             
                    LDA        $0C,S                
                    AND        #$00F0               
                    ORA        #$1106               
                    STA        $0C,S                
                    LDA        $12,S                
                    AND        #$0F00               
                    ORA        #$1013               
                    STA        $12,S                
                    LDA        $B2,S                
                    AND        #$0F00               
                    ORA        #$3061               
                    STA        $B2,S                
                    TSC                             
                    ADC        #$0011               
                    TCS                             
                    PEA        $4634                
                    PEA        $6111                
                    TSC                             ; Line 14
                    ADC        #$00A4               
                    TCS                             
                    SEP        #$20                 
                    LDA        $9A,S                
                    AND        #$F0                 
                    ORA        #$06                 
                    STA        $9A,S                
                    REP        #$30                 
                    PEA        $4413                
                    PEA        $6611                
                    PHX                             
                    TSC                             ; Line 15
                    ADC        #$00A8               
                    TCS                             
                    SEP        #$20                 
                    LDA        $98,S                
                    AND        #$F0                 
                    ORA        #$01                 
                    STA        $98,S                
                    REP        #$30                 
                    PEA        $1361                
                    PEA        $4413                
                    PEA        $1611                
                    PHY                             
                    TSC                             ; Line 16
                    ADC        #$00A8               
                    TCS                             
                    SEP        #$20                 
                    LDA        $98,S                
                    AND        #$F0                 
                    ORA        #$06                 
                    STA        $98,S                
                    REP        #$30                 
                    PEA        $3116                
                    PEA        $3461                
                    PHY                             
                    PEA        $1361                
                    TSC                             ; Line 17
                    ADC        #$00A8               
                    TCS                             
                    LDA        $98,S                
                    AND        #$00F0               
                    ORA        #$6101               
                    STA        $98,S                
                    LDA        $A0,S                
                    AND        #$0F00               
                    ORA        #$3014               
                    STA        $A0,S                
                    PEA        $3316                
                    PEA        $1361                
                    PEA        $1121                
                    PEA        $1311                
                    TSC                             ; Line 18
                    ADC        #$00A7               
                    TCS                             
                    SEP        #$20                 
                    LDA        $A2,S                
                    AND        #$0F                 
                    ORA        #$40                 
                    STA        $A2,S                
                    REP        #$30                 
                    PEA        $4611                
                    PEA        $1611                
                    PEA        $3133                
                    TSC                             ; Line 19
                    ADC        #$00A7               
                    TCS                             
                    LDA        $98,S                
                    AND        #$00F0               
                    ORA        #$6101               
                    STA        $98,S                
                    LDA        $A0,S                
                    AND        #$0F00               
                    ORA        #$4044               
                    STA        $A0,S                
                    PEA        $4413                
                    PEA        $6116                
                    PEA        $1132                
                    PEA        $1116                
                    TSC                             ; Line 20
                    ADC        #$00A7               
                    TCS                             
                    SEP        #$20                 
                    LDA        $A2,S                
                    AND        #$0F                 
                    ORA        #$30                 
                    STA        $A2,S                
                    REP        #$30                 
                    PEA        $3463                
                    PEA        $1121                
                    PEA        $1363                
                    TSC                             ; Line 21
                    ADC        #$00A7               
                    TCS                             
                    SEP        #$20                 
                    LDA        $A1,S                
                    AND        #$0F                 
                    ORA        #$30                 
                    STA        $A1,S                
                    REP        #$30                 
                    PEA        $6111                
                    PEA        $1311                
                    PEA        $3131                
                    PEA        $1116                
                    TSC                             ; Line 22
                    ADC        #$00A8               
                    TCS                             
                    LDA        #$4444               
                    STA        $A3,S                
                    LDA        $98,S                
                    AND        #$00F0               
                    ORA        #$1601               
                    STA        $98,S                
                    LDA        $A0,S                
                    AND        #$0F00               
                    ORA        #$3011               
                    STA        $A0,S                
                    PEA        $1316                
                    PEA        $3133                
                    PEA        $3213                
                    PEA        $6111                
                    TSC                             ; Line 23
                    ADC        #$00A7               
                    TCS                             
                    LDA        $99,S                
                    AND        #$00F0               
                    ORA        #$7107               
                    STA        $99,S                
                    SEP        #$20                 
                    LDA        $9F,S                
                    AND        #$0F                 
                    ORA        #$60                 
                    STA        $9F,S                
                    REP        #$30                 
                    PEA        $1116                
                    PEA        $3611                
                    PEA        $1116                
                    TSC                             ; Line 24
                    ADC        #$00A4               
                    TCS                             
                    LDA        $9B,S                
                    AND        #$00F0               
                    ORA        #$5105               
                    STA        $9B,S                
                    LDA        $A1,S                
                    AND        #$000F               
                    ORA        #$1110               
                    STA        $A1,S                
                    SEP        #$20                 
                    LDA        $A7,S                
                    AND        #$0F                 
                    ORA        #$40                 
                    STA        $A7,S                
                    REP        #$30                 
                    PHX                             
                    PHX                             
                    TSC                             
                    ADC        #$000B               
                    TCS                             
                    PEA        $4444                
                    PEA        $3413                
                    PEA        $1361                
                    TSC                             ; Line 25
                    ADC        #$009F               
                    TCS                             
                    SEP        #$20                 
                    LDA        $A1,S                
                    AND        #$0F                 
                    ORA        #$10                 
                    STA        $A1,S                
                    LDA        $A6,S                
                    AND        #$0F                 
                    ORA        #$60                 
                    STA        $A6,S                
                    REP        #$30                 
                    PEA        $1616                
                    PEA        $1616                
                    TSC                             
                    ADC        #$000A               
                    TCS                             
                    PEA        $1411                
                    PEA        $3111                
                    TSC                             ; Line 26
                    ADC        #$009E               
                    TCS                             
                    LDA        #$1616               
                    STA        $A4,S                
                    LDA        $A1,S                
                    AND        #$F00F               
                    ORA        #$0630               
                    STA        $A1,S                
                    SEP        #$20                 
                    LDA        #$16                 
                    STA        $A3,S                
                    LDA        $A6,S                
                    AND        #$0F                 
                    ORA        #$10                 
                    STA        $A6,S                
                    REP        #$30                 
                    PHY                             
                    PEA        $1171                
                    PEA        $5761                
                    TSC                             
                    ADC        #$000B               
                    TCS                             
                    PEA        $6111                
                    PEA        $3161                
                    TSC                             ; Line 27
                    ADC        #$009F               
                    TCS                             
                    TXA                             
                    STA        $A3,S                
                    LDA        $A0,S                
                    AND        #$0F00               
                    ORA        #$1013               
                    STA        $A0,S                
                    PHY                             
                    PEA        $7757                
                    PEA        $1566                
                    TSC                             ; Line 28
                    ADC        #$00A5               
                    TCS                             
                    LDA        $A1,S                
                    AND        #$0F00               
                    ORA        #$5011               
                    STA        $A1,S                
                    PEA        $1355                
                    PEA        $1511                
                    PEA        $1166                
                    TSC                             ; Line 29
                    ADC        #$00A6               
                    TCS                             
                    PEA        $5735                
                    PHY                             
                    PEA        $6111                
                    TSC                             ; Line 30
                    ADC        #$00A8               
                    TCS                             
                    SEP        #$20                 
                    LDA        $98,S                
                    AND        #$F0                 
                    ORA        #$01                 
                    STA        $98,S                
                    REP        #$30                 
                    PEA        $5577                
                    PEA        $1713                
                    PEA        $1311                
                    PEA        $1166                
                    TSC                             ; Line 31
                    ADC        #$00A8               
                    TCS                             
                    SEP        #$20                 
                    LDA        $A0,S                
                    AND        #$0F                 
                    ORA        #$30                 
                    STA        $A0,S                
                    REP        #$30                 
                    PEA        $3731                
                    PEA        $5737                
                    PEA        $3131                
                    PHD                             
                    TSC                             ; Line 32
                    ADC        #$00A7               
                    TCS                             
                    SEP        #$20                 
                    LDA        $A1,S                
                    AND        #$0F                 
                    ORA        #$30                 
                    STA        $A1,S                
                    REP        #$30                 
                    PEA        $5355                
                    PEA        $3733                
                    PEA        $1313                
                    PEA        $1616                
                    TSC                             ; Line 33
                    ADC        #$00A8               
                    TCS                             
                    LDA        $98,S                
                    AND        #$00F0               
                    ORA        #$1606               
                    STA        $98,S                
                    LDA        $A0,S                
                    AND        #$0F00               
                    ORA        #$3053               
                    STA        $A0,S                
                    PEA        $5357                
                    PEA        $1533                
                    PEA        $3331                
                    PHX                             
                    TSC                             ; Line 34
                    ADC        #$00A7               
                    TCS                             
                    LDA        $99,S                
                    AND        #$00F0               
                    ORA        #$6101               
                    STA        $99,S                
                    LDA        $A1,S                
                    AND        #$0F00               
                    ORA        #$3053               
                    STA        $A1,S                
                    PEA        $1315                
                    PEA        $1633                
                    PEA        $1313                
                    TSC                             ; Line 35
                    ADC        #$00A6               
                    TCS                             
                    LDA        $A1,S                
                    AND        #$0F00               
                    ORA        #$3033               
                    STA        $A1,S                
                    PHD                             
                    PEA        $6133                
                    PEA        $3331                
                    TSC                             ; Line 36
                    ADC        #$00A6               
                    TCS                             
                    LDA        $91,S                
                    AND        #$00F0               
                    ORA        #$4104               
                    STA        $91,S                
                    SEP        #$20                 
                    LDA        $A2,S                
                    AND        #$0F                 
                    ORA        #$30                 
                    STA        $A2,S                
                    REP        #$30                 
                    PEA        $1316                
                    PEA        $1633                
                    PEA        $3313                
                    PEA        $3616                
                    TSC                             ; Line 37
                    ADC        #$00A4               
                    TCS                             
                    SEP        #$20                 
                    LDA        $A6,S                
                    AND        #$0F                 
                    ORA        #$30                 
                    STA        $A6,S                
                    REP        #$30                 
                    PEA        $2333                
                    PEA        $1311                
                    PEA        $1313                
                    PEA        $1313                
                    PEA        $1331                
                    TSC                             
                    ADC        #$000F               
                    TCS                             
                    PEA        $3311                
                    PHX                             
                    TSC                             ; Line 38
                    ADC        #$009F               
                    TCS                             
                    TDC                             
                    STA        $A3,S                
                    LDA        $9F,S                
                    AND        #$0F00               
                    ORA        #$1012               
                    STA        $9F,S                
                    LDA        $A5,S                
                    AND        #$0F00               
                    ORA        #$3033               
                    STA        $A5,S                
                    SEP        #$20                 
                    LDA        $A2,S                
                    AND        #$F0                 
                    ORA        #$01                 
                    STA        $A2,S                
                    REP        #$30                 
                    PEA        $3333                
                    PEA        $3331                
                    PEA        $3131                
                    PEA        $3111                
                    PHY                             
                    PEA        $4144                
                    TSC                             
                    ADC        #$0011               
                    TCS                             
                    PEA        $1313                
                    PEA        $1616                
                    TSC                             ; Line 39
                    ADC        #$009D               
                    TCS                             
                    LDA        #$1316               
                    STA        $A5,S                
                    LDA        $97,S                
                    AND        #$F000               
                    ORA        #$0644               
                    STA        $97,S                
                    LDA        $A7,S                
                    AND        #$0F00               
                    ORA        #$2033               
                    STA        $A7,S                
                    SEP        #$20                 
                    LDA        $A1,S                
                    AND        #$0F                 
                    ORA        #$10                 
                    STA        $A1,S                
                    LDA        $A4,S                
                    AND        #$F0                 
                    ORA        #$06                 
                    STA        $A4,S                
                    REP        #$30                 
                    PEA        $1313                
                    PEA        $1311                
                    PHX                             
                    PHX                             
                    PEA        $4144                
                    TSC                             ; Line 40
                    ADC        #$00AA               
                    TCS                             
                    TDC                             
                    STA        $A5,S                
                    LDA        $9B,S                
                    AND        #$00F0               
                    ORA        #$6101               
                    STA        $9B,S                
                    LDA        $A7,S                
                    AND        #$0F00               
                    ORA        #$3033               
                    STA        $A7,S                
                    SEP        #$20                 
                    LDA        $A4,S                
                    AND        #$F0                 
                    ORA        #$01                 
                    STA        $A4,S                
                    REP        #$30                 
                    PEA        $1136                
                    PEA        $1116                
                    PEA        $1616                
                    PEA        $1616                
                    TSC                             ; Line 41
                    ADC        #$00A8               
                    TCS                             
                    LDA        #$1216               
                    STA        $A5,S                
                    LDA        $A7,S                
                    AND        #$0F00               
                    ORA        #$3032               
                    STA        $A7,S                
                    SEP        #$20                 
                    LDA        $A4,S                
                    AND        #$F0                 
                    ORA        #$06                 
                    STA        $A4,S                
                    REP        #$30                 
                    PHX                             
                    PHX                             
                    TSC                             ; Line 43
                    ADC        #$013B               
                    TCS                             
                    TDC                             
                    STA        $0E,S                
                    LDA        #$1316               
                    STA        $AE,S                
                    SEP        #$20                 
                    LDA        #$33                 
                    STA        $10,S                
                    STA        $B0,S                
                    REP        #$30                 
                    TSC                             ; Line 45
                    ADC        #$0140               
                    TCS                             
                    TDC                             
                    STA        $0E,S                
                    LDA        #$1316               
                    STA        $AE,S                
                    SEP        #$20                 
                    LDA        #$33                 
                    STA        $10,S                
                    LDA        #$13                 
                    STA        $B0,S                
                    REP        #$30                 
                    TSC                             ; Line 47
                    ADC        #$0140               
                    TCS                             
                    TDC                             
                    STA        $0E,S                
                    LDA        #$1316               
                    STA        $AE,S                
                    SEP        #$20                 
                    LDA        #$33                 
                    STA        $10,S                
                    STA        $B0,S                
                    REP        #$30                 
                    TSC                             ; Line 49
                    ADC        #$0140               
                    TCS                             
                    TDC                             
                    STA        $0E,S                
                    LDA        #$1316               
                    STA        $AE,S                
                    SEP        #$20                 
                    LDA        #$33                 
                    STA        $10,S                
                    LDA        $B0,S                
                    AND        #$0F                 
                    ORA        #$30                 
                    STA        $B0,S                
                    REP        #$30                 
                    TSC                             ; Line 51
                    ADC        #$0140               
                    TCS                             
                    LDA        #$1361               
                    STA        $0E,S                
                    LDA        $A9,S                
                    AND        #$0F0F               
                    ORA        #$6060               
                    STA        $A9,S                
                    LDA        $AB,S                
                    AND        #$0F0F               
                    ORA        #$6060               
                    STA        $AB,S                
                    LDA        $AD,S                
                    AND        #$000F               
                    ORA        #$1660               
                    STA        $AD,S                
                    LDA        $AF,S                
                    AND        #$0F00               
                    ORA        #$3033               
                    STA        $AF,S                
                    LDA        $B1,S                
                    AND        #$0F0F               
                    ORA        #$6060               
                    STA        $B1,S                
                    SEP        #$20                 
                    LDA        $10,S                
                    AND        #$0F                 
                    ORA        #$30                 
                    STA        $10,S                
                    REP        #$30                 
                    TSC                             ; Line 53
                    ADC        #$0140               
                    TCS                             
                    LDA        $00,S                
                    AND        #$F0F0               
                    ORA        #$0606               
                    STA        $00,S                
                    LDA        $02,S                
                    AND        #$F0F0               
                    ORA        #$0606               
                    STA        $02,S                
                    LDA        $04,S                
                    AND        #$F0F0               
                    ORA        #$0606               
                    STA        $04,S                
                    LDA        $06,S                
                    AND        #$F0F0               
                    ORA        #$0606               
                    STA        $06,S                
                    LDA        $08,S                
                    AND        #$F0F0               
                    ORA        #$0606               
                    STA        $08,S                
                    LDA        $0A,S                
                    AND        #$F0F0               
                    ORA        #$0606               
                    STA        $0A,S                
                    LDA        $0C,S                
                    AND        #$F0F0               
                    ORA        #$0606               
                    STA        $0C,S                
                    LDA        $0E,S                
                    AND        #$00F0               
                    ORA        #$1101               
                    STA        $0E,S                
                    LDA        $11,S                
                    AND        #$F0F0               
                    ORA        #$0606               
                    STA        $11,S                
                    LDA        $13,S                
                    AND        #$F0F0               
                    ORA        #$0606               
                    STA        $13,S                
                    LDA        $A1,S                
                    AND        #$0F0F               
                    ORA        #$6060               
                    STA        $A1,S                
                    LDA        $A3,S                
                    AND        #$0F0F               
                    ORA        #$6060               
                    STA        $A3,S                
                    LDA        $A5,S                
                    AND        #$0F0F               
                    ORA        #$6060               
                    STA        $A5,S                
                    LDA        $A7,S                
                    AND        #$0F0F               
                    ORA        #$6060               
                    STA        $A7,S                
                    LDA        $A9,S                
                    AND        #$0F0F               
                    ORA        #$6060               
                    STA        $A9,S                
                    LDA        $AB,S                
                    AND        #$0F0F               
                    ORA        #$6060               
                    STA        $AB,S                
                    LDA        $AD,S                
                    AND        #$000F               
                    ORA        #$6460               
                    STA        $AD,S                
                    LDA        $AF,S                
                    AND        #$0F00               
                    ORA        #$4044               
                    STA        $AF,S                
                    LDA        $B1,S                
                    AND        #$0F0F               
                    ORA        #$6060               
                    STA        $B1,S                
                    LDA        $B3,S                
                    AND        #$0F0F               
                    ORA        #$6060               
                    STA        $B3,S                
                    LDA        $B5,S                
                    AND        #$0F0F               
                    ORA        #$6060               
                    STA        $B5,S                
                    SEP        #$20                 
                    LDA        $10,S                
                    AND        #$F0                 
                    ORA        #$06                 
                    STA        $10,S                
                    REP        #$30                 
                    TSC                             ; Line 55
                    ADC        #$0140               
                    TCS                             
                    LDA        #$4644               
                    STA        $0F,S                
                    LDA        $07,S                
                    AND        #$F0F0               
                    ORA        #$0606               
                    STA        $07,S                
                    LDA        $09,S                
                    AND        #$F0F0               
                    ORA        #$0606               
                    STA        $09,S                
                    LDA        $0B,S                
                    AND        #$F0F0               
                    ORA        #$0606               
                    STA        $0B,S                
                    LDA        $0D,S                
                    AND        #$F0F0               
                    ORA        #$0606               
                    STA        $0D,S                
                    LDA        $11,S                
                    AND        #$F0F0               
                    ORA        #$0606               
                    STA        $11,S                
                    LDA        $13,S                
                    AND        #$F0F0               
                    ORA        #$0606               
                    STA        $13,S                
                    LDA        $15,S                
                    AND        #$F0F0               
                    ORA        #$0606               
                    STA        $15,S                
*--                                                 
                    LDAL       $E1C068              ; Direct Page and Stack in Bank 00/
                    AND        #$FFCF               
                    STAL       $E1C068              
                    LDA        StackAddress         ; Restore Stack
                    TCS                             
                    PLD                             ; Restore Direct Page
                    CLI                             ; Enable Interrupts
                    PLB
                    RTL                             
                                                    
*-----------------------------------                                
Sprite_RR_049       CLC                             ; Sprite #049 : 64x49, 1818 bytes, 2911 cycles
                    SEI                             ; Disable Interrupts
                    PHD                             ; Backup Direct Page
                    TSC                             ; Backup Stack
                    STA        StackAddress         
                    LDAL       $E1C068              ; Direct Page and Stack in Bank 01/
                    ORA        #$0030               
                    STAL       $E1C068              
                    TYA                             ; Y = Sprite Target Screen Address (upper left corner)
                    TCS                             ; New Stack address
                    LDX        #$1116               ; Pattern #1 : 20
                    LDY        #$1313               ; Pattern #2 : 19
                    LDA        #$3111               ; Pattern #3 : 10
                    TCD                             
*--                                                 
                    LDA        #$4444               ; Line 0
                    STA        $A4,S                
                    LDA        $04,S                
                    AND        #$0F00               
                    ORA        #$4044               
                    STA        $04,S                
                    TSC                             ; Line 2
                    ADC        #$0140               
                    TCS                             
                    LDA        #$1144               
                    STA        $A5,S                
                    LDA        $04,S                
                    AND        #$00F0               
                    ORA        #$4404               
                    STA        $04,S                
                    LDA        $06,S                
                    AND        #$0F00               
                    ORA        #$3043               
                    STA        $06,S                
                    SEP        #$20                 
                    LDA        #$33                 
                    STA        $A7,S                
                    REP        #$30                 
                    TSC                             ; Line 4
                    ADC        #$0140               
                    TCS                             
                    LDA        #$1161               
                    STA        $05,S                
                    LDA        $07,S                
                    AND        #$0F00               
                    ORA        #$3033               
                    STA        $07,S                
                    TSC                             ; Line 5
                    ADC        #$00A8               
                    TCS                             
                    TYA                             
                    STA        $9F,S                
                    LDA        $9D,S                
                    AND        #$00F0               
                    ORA        #$6101               
                    STA        $9D,S                
                    SEP        #$20                 
                    LDA        $A1,S                
                    AND        #$0F                 
                    ORA        #$30                 
                    STA        $A1,S                
                    REP        #$30                 
                    PEA        $3211                
                    PHX                             
                    TSC                             ; Line 7
                    ADC        #$0145               
                    TCS                             
                    SEP        #$20                 
                    LDA        $01,S                
                    AND        #$0F                 
                    ORA        #$20                 
                    STA        $01,S                
                    LDA        $9D,S                
                    AND        #$F0                 
                    ORA        #$01                 
                    STA        $9D,S                
                    REP        #$30                 
                    PEA        $3331                
                    PHX                             
                    TSC                             ; Line 8
                    ADC        #$00A5               
                    TCS                             
                    SEP        #$20                 
                    LDA        $A1,S                
                    AND        #$0F                 
                    ORA        #$20                 
                    STA        $A1,S                
                    REP        #$30                 
                    PEA        $1213                
                    PEA        $1361                
                    TSC                             ; Line 9
                    ADC        #$00A4               
                    TCS                             
                    TYA                             
                    STA        $9F,S                
                    LDA        $9D,S                
                    AND        #$00F0               
                    ORA        #$6101               
                    STA        $9D,S                
                    LDA        $A1,S                
                    AND        #$0F00               
                    ORA        #$2013               
                    STA        $A1,S                
                    PEA        $3131                
                    PHX                             
                    TSC                             ; Line 11
                    ADC        #$0145               
                    TCS                             
                    LDA        $9D,S                
                    AND        #$00F0               
                    ORA        #$6101               
                    STA        $9D,S                
                    SEP        #$20                 
                    LDA        #$33                 
                    STA        $01,S                
                    REP        #$30                 
                    PEA        $3131                
                    PHX                             
                    TSC                             ; Line 12
                    ADC        #$00A6               
                    TCS                             
                    PEA        $3313                
                    PEA        $1311                
                    TSC                             ; Line 13
                    ADC        #$00A5               
                    TCS                             
                    SEP        #$20                 
                    LDA        $9B,S                
                    AND        #$F0                 
                    ORA        #$01                 
                    STA        $9B,S                
                    REP        #$30                 
                    PEA        $3333                
                    PHD                             
                    PEA        $1616                
                    TSC                             ; Line 14
                    ADC        #$00A7               
                    TCS                             
                    LDA        $A3,S                
                    AND        #$00F0               
                    ORA        #$3101               
                    STA        $A3,S                
                    SEP        #$20                 
                    LDA        #$16                 
                    STA        $9B,S                
                    REP        #$30                 
                    PEA        $3133                
                    PHY                             
                    PEA        $6161                
                    TSC                             
                    ADC        #$000F               
                    TCS                             
                    PEA        $1111                
                    PEA        $1611                
                    TSC                             ; Line 15
                    ADC        #$009C               
                    TCS                             
                    LDA        $9A,S                
                    AND        #$00F0               
                    ORA        #$6101               
                    STA        $9A,S                
                    PEA        $3333                
                    PEA        $3331                
                    PHX                             
                    TSC                             
                    ADC        #$000F               
                    TCS                             
                    PEA        $1331                
                    PEA        $3161                
                    PEA        $6131                
                    TSC                             ; Line 16
                    ADC        #$00A6               
                    TCS                             
                    LDA        $A0,S                
                    AND        #$0F00               
                    ORA        #$1013               
                    STA        $A0,S                
                    PEA        $1113                
                    PHY                             
                    PEA        $1616                
                    PEA        $1353                
                    PEA        $3333                
                    PHY                             
                    PEA        $1161                
                    TSC                             ; Line 17
                    ADC        #$00AD               
                    TCS                             
                    LDA        $93,S                
                    AND        #$00F0               
                    ORA        #$6101               
                    STA        $93,S                
                    LDA        $A1,S                
                    AND        #$0F00               
                    ORA        #$3011               
                    STA        $A1,S                
                    PEA        $1133                
                    PHY                             
                    PEA        $6131                
                    PEA        $5513                
                    PEA        $1333                
                    PEA        $1111                
                    PEA        $1616                
                    TSC                             ; Line 18
                    ADC        #$00AE               
                    TCS                             
                    SEP        #$20                 
                    LDA        $A2,S                
                    AND        #$0F                 
                    ORA        #$60                 
                    STA        $A2,S                
                    REP        #$30                 
                    PEA        $1126                
                    PEA        $3331                
                    PHX                             
                    PEA        $5533                
                    PHD                             
                    PEA        $6161                
                    TSC                             ; Line 19
                    ADC        #$00AD               
                    TCS                             
                    LDA        #$6566               
                    STA        $A3,S                
                    SEP        #$20                 
                    LDA        #$56                 
                    STA        $A5,S                
                    LDA        $93,S                
                    AND        #$F0                 
                    ORA        #$01                 
                    STA        $93,S                
                    REP        #$30                 
                    PEA        $1611                
                    PEA        $1126                
                    PHY                             
                    PEA        $6155                
                    PHY                             
                    PHX                             
                    PEA        $1616                
                    TSC                             ; Line 20
                    ADC        #$00AF               
                    TCS                             
                    LDA        #$5665               
                    STA        $A3,S                
                    LDA        $A1,S                
                    AND        #$00F0               
                    ORA        #$6606               
                    STA        $A1,S                
                    SEP        #$20                 
                    LDA        $A5,S                
                    AND        #$0F                 
                    ORA        #$60                 
                    STA        $A5,S                
                    REP        #$30                 
                    PEA        $1361                
                    PEA        $1661                
                    PEA        $6132                
                    PEA        $1316                
                    PEA        $3533                
                    PHD                             
                    PEA        $6161                
                    TSC                             ; Line 21
                    ADC        #$00AE               
                    TCS                             
                    SEP        #$20                 
                    LDA        #$66                 
                    STA        $A5,S                
                    REP        #$30                 
                    PEA        $3311                
                    PEA        $6611                
                    PEA        $1616                
                    PEA        $1261                
                    PEA        $3513                
                    PEA        $1311                
                    PEA        $1616                
                    TSC                             ; Line 22
                    ADC        #$00B2               
                    TCS                             
                    SEP        #$20                 
                    LDA        $8F,S                
                    AND        #$F0                 
                    ORA        #$06                 
                    STA        $8F,S                
                    REP        #$30                 
                    PEA        $5665                
                    PEA        $6646                
                    PEA        $3433                
                    PEA        $1166                
                    PEA        $6111                
                    PEA        $3316                
                    PEA        $3531                
                    PEA        $1161                
                    PEA        $6161                
                    TSC                             ; Line 23
                    ADC        #$00B3               
                    TCS                             
                    PEA        $6656                
                    PEA        $6546                
                    PEA        $4444                
                    PEA        $4433                
                    PEA        $1166                
                    PEA        $3163                
                    PEA        $6135                
                    PHY                             
                    PEA        $1616                
                    TSC                             ; Line 24
                    ADC        #$00B2               
                    TCS                             
                    PEA        $6656                
                    PEA        $6566                
                    PEA        $4444                
                    PEA        $4444                
                    PEA        $1361                
                    PEA        $3213                
                    PEA        $5635                
                    PHD                             
                    PEA        $6161                
                    TSC                             ; Line 25
                    ADC        #$00B2               
                    TCS                             
                    LDA        #$3311               
                    STA        $91,S                
                    LDA        $8F,S                
                    AND        #$00F0               
                    ORA        #$6101               
                    STA        $8F,S                
                    LDA        $93,S                
                    AND        #$0F0F               
                    ORA        #$5050               
                    STA        $93,S                
                    LDA        $9B,S                
                    AND        #$00F0               
                    ORA        #$4404               
                    STA        $9B,S                
                    PEA        $6656                
                    PEA        $4544                
                    PEA        $4444                
                    PEA        $3333                
                    PEA        $3411                
                    PEA        $3361                
                    PEA        $5155                
                    PEA        $1311                
                    PEA        $1616                
                    TSC                             ; Line 26
                    ADC        #$00AC               
                    TCS                             
                    LDA        #$3311               
                    STA        $97,S                
                    LDA        $95,S                
                    AND        #$00F0               
                    ORA        #$1606               
                    STA        $95,S                
                    LDA        $9A,S                
                    AND        #$F00F               
                    ORA        #$0650               
                    STA        $9A,S                
                    LDA        $A0,S                
                    AND        #$F00F               
                    ORA        #$0430               
                    STA        $A0,S                
                    SEP        #$20                 
                    LDA        $99,S                
                    AND        #$0F                 
                    ORA        #$50                 
                    STA        $99,S                
                    LDA        $A6,S                
                    AND        #$0F                 
                    ORA        #$60                 
                    STA        $A6,S                
                    REP        #$30                 
                    PEA        $1366                
                    PEA        $1124                
                    PEA        $1311                
                    TSC                             
                    ADC        #$000C               
                    TCS                             
                    PEA        $6656                
                    PEA        $4544                
                    TSC                             ; Line 27
                    ADC        #$009D               
                    TCS                             
                    LDA        #$1311               
                    STA        $98,S                
                    LDA        $96,S                
                    AND        #$00F0               
                    ORA        #$6101               
                    STA        $96,S                
                    LDA        $9B,S                
                    AND        #$F0F0               
                    ORA        #$0105               
                    STA        $9B,S                
                    LDA        $A1,S                
                    AND        #$F00F               
                    ORA        #$0430               
                    STA        $A1,S                
                    SEP        #$20                 
                    LDA        $9A,S                
                    AND        #$0F                 
                    ORA        #$50                 
                    STA        $9A,S                
                    LDA        $A7,S                
                    AND        #$0F                 
                    ORA        #$60                 
                    STA        $A7,S                
                    REP        #$30                 
                    PEA        $1166                
                    PEA        $3614                
                    TSC                             
                    ADC        #$000A               
                    TCS                             
                    PEA        $5645                
                    PEA        $4644                
                    TSC                             ; Line 28
                    ADC        #$009E               
                    TCS                             
                    TXA                             
                    STA        $97,S                
                    LDA        #$4544               
                    STA        $A4,S                
                    LDA        $99,S                
                    AND        #$0F00               
                    ORA        #$3033               
                    STA        $99,S                
                    SEP        #$20                 
                    LDA        #$56                 
                    STA        $A6,S                
                    LDA        $96,S                
                    AND        #$F0                 
                    ORA        #$06                 
                    STA        $96,S                
                    REP        #$30                 
                    PEA        $1363                
                    PEA        $4414                
                    TSC                             
                    ADC        #$000A               
                    TCS                             
                    PEA        $5645                
                    PEA        $4644                
                    TSC                             ; Line 29
                    ADC        #$009E               
                    TCS                             
                    LDA        #$1161               
                    STA        $97,S                
                    LDA        #$3216               
                    STA        $9F,S                
                    LDA        $99,S                
                    AND        #$0F00               
                    ORA        #$2033               
                    STA        $99,S                
                    LDA        $9D,S                
                    AND        #$00F0               
                    ORA        #$4104               
                    STA        $9D,S                
                    SEP        #$20                 
                    LDA        $96,S                
                    AND        #$F0                 
                    ORA        #$01                 
                    STA        $96,S                
                    REP        #$30                 
                    PEA        $3311                
                    PEA        $4444                
                    TSC                             ; Line 31
                    ADC        #$012C               
                    TCS                             
                    TXA                             
                    STA        $0F,S                
                    LDA        #$6361               
                    STA        $16,S                
                    LDA        #$1161               
                    STA        $AF,S                
                    LDA        #$3316               
                    STA        $B6,S                
                    LDA        $11,S                
                    AND        #$0F00               
                    ORA        #$3013               
                    STA        $11,S                
                    LDA        $B1,S                
                    AND        #$0F00               
                    ORA        #$2033               
                    STA        $B1,S                
                    SEP        #$20                 
                    LDA        $0E,S                
                    AND        #$F0                 
                    ORA        #$06                 
                    STA        $0E,S                
                    LDA        $18,S                
                    AND        #$0F                 
                    ORA        #$20                 
                    STA        $18,S                
                    LDA        $AE,S                
                    AND        #$F0                 
                    ORA        #$01                 
                    STA        $AE,S                
                    LDA        $B5,S                
                    AND        #$F0                 
                    ORA        #$06                 
                    STA        $B5,S                
                    REP        #$30                 
                    TSC                             ; Line 33
                    ADC        #$0140               
                    TCS                             
                    TXA                             
                    STA        $0F,S                
                    TYA                             
                    STA        $B0,S                
                    STA        $B6,S                
                    LDA        $11,S                
                    AND        #$0F00               
                    ORA        #$3033               
                    STA        $11,S                
                    LDA        $15,S                
                    AND        #$00F0               
                    ORA        #$1101               
                    STA        $15,S                
                    SEP        #$20                 
                    LDA        #$61                 
                    STA        $AF,S                
                    LDA        $17,S                
                    AND        #$0F                 
                    ORA        #$30                 
                    STA        $17,S                
                    LDA        $B5,S                
                    AND        #$F0                 
                    ORA        #$06                 
                    STA        $B5,S                
                    REP        #$30                 
                    TSC                             ; Line 35
                    ADC        #$0140               
                    TCS                             
                    TXA                             
                    STA        $0F,S                
                    LDA        #$3211               
                    STA        $16,S                
                    TYA                             
                    STA        $B0,S                
                    LDA        #$1311               
                    STA        $B6,S                
                    SEP        #$20                 
                    LDA        #$32                 
                    STA        $11,S                
                    LDA        #$61                 
                    STA        $AF,S                
                    LDA        $15,S                
                    AND        #$F0                 
                    ORA        #$01                 
                    STA        $15,S                
                    LDA        $B8,S                
                    AND        #$0F                 
                    ORA        #$20                 
                    STA        $B8,S                
                    REP        #$30                 
                    TSC                             ; Line 37
                    ADC        #$0140               
                    TCS                             
                    TXA                             
                    STA        $0F,S                
                    TYA                             
                    STA        $B0,S                
                    LDA        #$4414               
                    STA        $B7,S                
                    LDA        $16,S                
                    AND        #$00F0               
                    ORA        #$1101               
                    STA        $16,S                
                    SEP        #$20                 
                    LDA        #$32                 
                    STA        $11,S                
                    LDA        #$61                 
                    STA        $AF,S                
                    LDA        $18,S                
                    AND        #$0F                 
                    ORA        #$40                 
                    STA        $18,S                
                    REP        #$30                 
                    TSC                             ; Line 39
                    ADC        #$0140               
                    TCS                             
                    TXA                             
                    STA        $0F,S                
                    TYA                             
                    STA        $B0,S                
                    LDA        $17,S                
                    AND        #$00F0               
                    ORA        #$4404               
                    STA        $17,S                
                    SEP        #$20                 
                    LDA        #$32                 
                    STA        $11,S                
                    LDA        #$61                 
                    STA        $AF,S                
                    LDA        #$44                 
                    STA        $B8,S                
                    REP        #$30                 
                    TSC                             ; Line 41
                    ADC        #$0140               
                    TCS                             
                    TXA                             
                    STA        $0F,S                
                    LDA        #$1361               
                    STA        $AF,S                
                    SEP        #$20                 
                    LDA        #$33                 
                    STA        $11,S                
                    LDA        $B1,S                
                    AND        #$0F                 
                    ORA        #$30                 
                    STA        $B1,S                
                    REP        #$30                 
                    TSC                             ; Line 43
                    ADC        #$0140               
                    TCS                             
                    LDA        #$1111               
                    STA        $0F,S                
                    LDA        #$1361               
                    STA        $AF,S                
                    SEP        #$20                 
                    LDA        $11,S                
                    AND        #$0F                 
                    ORA        #$30                 
                    STA        $11,S                
                    LDA        $B1,S                
                    AND        #$0F                 
                    ORA        #$30                 
                    STA        $B1,S                
                    REP        #$30                 
                    TSC                             ; Line 45
                    ADC        #$0140               
                    TCS                             
                    LDA        $0B,S                
                    AND        #$F0F0               
                    ORA        #$0606               
                    STA        $0B,S                
                    LDA        $0D,S                
                    AND        #$F0F0               
                    ORA        #$0606               
                    STA        $0D,S                
                    LDA        $0F,S                
                    AND        #$00F0               
                    ORA        #$1101               
                    STA        $0F,S                
                    LDA        $11,S                
                    AND        #$0F0F               
                    ORA        #$6030               
                    STA        $11,S                
                    LDA        $13,S                
                    AND        #$0F0F               
                    ORA        #$6060               
                    STA        $13,S                
                    LDA        $15,S                
                    AND        #$0F0F               
                    ORA        #$6060               
                    STA        $15,S                
                    LDA        $A0,S                
                    AND        #$0F0F               
                    ORA        #$6060               
                    STA        $A0,S                
                    LDA        $A2,S                
                    AND        #$0F0F               
                    ORA        #$6060               
                    STA        $A2,S                
                    LDA        $A4,S                
                    AND        #$0F0F               
                    ORA        #$6060               
                    STA        $A4,S                
                    LDA        $A6,S                
                    AND        #$0F0F               
                    ORA        #$6060               
                    STA        $A6,S                
                    LDA        $A8,S                
                    AND        #$0F0F               
                    ORA        #$6060               
                    STA        $A8,S                
                    LDA        $AA,S                
                    AND        #$0F0F               
                    ORA        #$6060               
                    STA        $AA,S                
                    LDA        $AC,S                
                    AND        #$0F0F               
                    ORA        #$6060               
                    STA        $AC,S                
                    LDA        $AE,S                
                    AND        #$000F               
                    ORA        #$6460               
                    STA        $AE,S                
                    LDA        $B0,S                
                    AND        #$F000               
                    ORA        #$0644               
                    STA        $B0,S                
                    LDA        $B2,S                
                    AND        #$F0F0               
                    ORA        #$0606               
                    STA        $B2,S                
                    LDA        $B4,S                
                    AND        #$F0F0               
                    ORA        #$0606               
                    STA        $B4,S                
                    LDA        $B6,S                
                    AND        #$F0F0               
                    ORA        #$0606               
                    STA        $B6,S                
                    LDA        $B8,S                
                    AND        #$F0F0               
                    ORA        #$0606               
                    STA        $B8,S                
                    LDA        $BA,S                
                    AND        #$F0F0               
                    ORA        #$0606               
                    STA        $BA,S                
                    LDA        $BC,S                
                    AND        #$F0F0               
                    ORA        #$0606               
                    STA        $BC,S                
                    TSC                             ; Line 47
                    ADC        #$0140               
                    TCS                             
                    LDA        #$4444               
                    STA        $10,S                
                    LDA        #$4464               
                    STA        $B0,S                
                    LDA        $02,S                
                    AND        #$F0F0               
                    ORA        #$0606               
                    STA        $02,S                
                    LDA        $04,S                
                    AND        #$F0F0               
                    ORA        #$0606               
                    STA        $04,S                
                    LDA        $06,S                
                    AND        #$F0F0               
                    ORA        #$0606               
                    STA        $06,S                
                    LDA        $08,S                
                    AND        #$F0F0               
                    ORA        #$0606               
                    STA        $08,S                
                    LDA        $0A,S                
                    AND        #$F0F0               
                    ORA        #$0606               
                    STA        $0A,S                
                    LDA        $0C,S                
                    AND        #$F0F0               
                    ORA        #$0606               
                    STA        $0C,S                
                    LDA        $0E,S                
                    AND        #$F0F0               
                    ORA        #$0406               
                    STA        $0E,S                
                    LDA        $13,S                
                    AND        #$0F0F               
                    ORA        #$6060               
                    STA        $13,S                
                    LDA        $15,S                
                    AND        #$0F0F               
                    ORA        #$6060               
                    STA        $15,S                
                    LDA        $17,S                
                    AND        #$0F0F               
                    ORA        #$6060               
                    STA        $17,S                
                    LDA        $19,S                
                    AND        #$0F0F               
                    ORA        #$6060               
                    STA        $19,S                
                    LDA        $1B,S                
                    AND        #$0F0F               
                    ORA        #$6060               
                    STA        $1B,S                
                    LDA        $1D,S                
                    AND        #$0F0F               
                    ORA        #$6060               
                    STA        $1D,S                
                    LDA        $A9,S                
                    AND        #$0F0F               
                    ORA        #$6060               
                    STA        $A9,S                
                    LDA        $AB,S                
                    AND        #$0F0F               
                    ORA        #$6060               
                    STA        $AB,S                
                    LDA        $AD,S                
                    AND        #$0F0F               
                    ORA        #$6060               
                    STA        $AD,S                
                    LDA        $B2,S                
                    AND        #$F0F0               
                    ORA        #$0606               
                    STA        $B2,S                
                    LDA        $BA,S                
                    AND        #$F0F0               
                    ORA        #$0606               
                    STA        $BA,S                
                    SEP        #$20                 
                    LDA        $12,S                
                    AND        #$0F                 
                    ORA        #$60                 
                    STA        $12,S                
                    LDA        $AF,S                
                    AND        #$0F                 
                    ORA        #$60                 
                    STA        $AF,S                
                    LDA        $BC,S                
                    AND        #$F0                 
                    ORA        #$06                 
                    STA        $BC,S                
                    REP        #$30                 
*--                                                 
                    LDAL       $E1C068              ; Direct Page and Stack in Bank 00/
                    AND        #$FFCF               
                    STAL       $E1C068              
                    LDA        StackAddress         ; Restore Stack
                    TCS                             
                    PLD                             ; Restore Direct Page
                    CLI                             ; Enable Interrupts
                    PLB
                    RTL                             
                                                    
*-----------------------------------                                
Sprite_RR_04A       CLC                             ; Sprite #04A : 32x56, 1762 bytes, 2823 cycles
                    SEI                             ; Disable Interrupts
                    PHD                             ; Backup Direct Page
                    TSC                             ; Backup Stack
                    STA        StackAddress         
                    LDAL       $E1C068              ; Direct Page and Stack in Bank 01/
                    ORA        #$0030               
                    STAL       $E1C068              
                    TYA                             ; Y = Sprite Target Screen Address (upper left corner)
                    TCS                             ; New Stack address
                    LDX        #$6161               ; Pattern #1 : 18
                    LDY        #$1116               ; Pattern #2 : 15
                    LDA        #$1616               ; Pattern #3 : 14
                    TCD                             
*--                                                 
                    LDA        #$6666               ; Line 0
                    STA        $03,S                
                    STA        $A4,S                
                    LDA        $A2,S                
                    AND        #$00F0               
                    ORA        #$6606               
                    STA        $A2,S                
                    TSC                             ; Line 2
                    ADC        #$0145               
                    TCS                             
                    SEP        #$20                 
                    LDA        $01,S                
                    AND        #$0F                 
                    ORA        #$60                 
                    STA        $01,S                
                    LDA        $A1,S                
                    AND        #$0F                 
                    ORA        #$50                 
                    STA        $A1,S                
                    REP        #$30                 
                    PEA        $6666                
                    PEA        $6666                
                    TSC                             ; Line 3
                    ADC        #$00A4               
                    TCS                             
                    SEP        #$20                 
                    LDA        $A1,S                
                    AND        #$0F                 
                    ORA        #$50                 
                    STA        $A1,S                
                    REP        #$30                 
                    PEA        $5555                
                    PEA        $5555                
                    TSC                             ; Line 4
                    ADC        #$00A4               
                    TCS                             
                    SEP        #$20                 
                    LDA        $A1,S                
                    AND        #$0F                 
                    ORA        #$40                 
                    STA        $A1,S                
                    REP        #$30                 
                    PEA        $5555                
                    PEA        $5555                
                    TSC                             ; Line 5
                    ADC        #$00A4               
                    TCS                             
                    SEP        #$20                 
                    LDA        $A1,S                
                    AND        #$0F                 
                    ORA        #$40                 
                    STA        $A1,S                
                    REP        #$30                 
                    PEA        $4464                
                    PEA        $6666                
                    TSC                             ; Line 6
                    ADC        #$00A4               
                    TCS                             
                    SEP        #$20                 
                    LDA        #$44                 
                    STA        $A1,S                
                    REP        #$30                 
                    PEA        $6664                
                    PEA        $6666                
                    TSC                             ; Line 7
                    ADC        #$00A4               
                    TCS                             
                    SEP        #$20                 
                    LDA        $9D,S                
                    AND        #$F0                 
                    ORA        #$06                 
                    STA        $9D,S                
                    REP        #$30                 
                    PEA        $4464                
                    PEA        $6466                
                    TSC                             ; Line 8
                    ADC        #$00A5               
                    TCS                             
                    LDA        #$4464               
                    STA        $9D,S                
                    LDA        $9F,S                
                    AND        #$0F00               
                    ORA        #$4044               
                    STA        $9F,S                
                    SEP        #$20                 
                    LDA        $9C,S                
                    AND        #$F0                 
                    ORA        #$06                 
                    STA        $9C,S                
                    LDA        $A4,S                
                    AND        #$F0                 
                    ORA        #$04                 
                    STA        $A4,S                
                    REP        #$30                 
                    PEA        $4444                
                    PEA        $4464                
                    TSC                             ; Line 10
                    ADC        #$013E               
                    TCS                             
                    LDA        #$4444               
                    STA        $04,S                
                    LDA        $0A,S                
                    AND        #$0F00               
                    ORA        #$4044               
                    STA        $0A,S                
                    LDA        $A3,S                
                    AND        #$00F0               
                    ORA        #$4403               
                    STA        $A3,S                
                    LDA        $AA,S                
                    AND        #$0F00               
                    ORA        #$4044               
                    STA        $AA,S                
                    SEP        #$20                 
                    LDA        $06,S                
                    AND        #$0F                 
                    ORA        #$40                 
                    STA        $06,S                
                    LDA        $A5,S                
                    AND        #$0F                 
                    ORA        #$40                 
                    STA        $A5,S                
                    REP        #$30                 
                    TSC                             ; Line 12
                    ADC        #$0146               
                    TCS                             
                    SEP        #$20                 
                    LDA        #$44                 
                    STA        $04,S                
                    STA        $A4,S                
                    LDA        $01,S                
                    AND        #$0F                 
                    ORA        #$30                 
                    STA        $01,S                
                    REP        #$30                 
                    PEA        $3146                
                    PEA        $3432                
                    TSC                             ; Line 13
                    ADC        #$00A5               
                    TCS                             
                    LDA        $9A,S                
                    AND        #$00F0               
                    ORA        #$3303               
                    STA        $9A,S                
                    LDA        $A0,S                
                    AND        #$0F00               
                    ORA        #$2031               
                    STA        $A0,S                
                    LDA        $A3,S                
                    AND        #$0F00               
                    ORA        #$6031               
                    STA        $A3,S                
                    PEA        $1363                
                    PEA        $4423                
                    PEA        $1336                
                    TSC                             ; Line 14
                    ADC        #$00A5               
                    TCS                             
                    LDA        $A4,S                
                    AND        #$0F00               
                    ORA        #$1021               
                    STA        $A4,S                
                    PEA        $4634                
                    PEA        $3261                
                    TSC                             ; Line 15
                    ADC        #$00A6               
                    TCS                             
                    LDA        $A2,S                
                    AND        #$0F00               
                    ORA        #$6033               
                    STA        $A2,S                
                    SEP        #$20                 
                    LDA        $98,S                
                    AND        #$F0                 
                    ORA        #$03                 
                    STA        $98,S                
                    LDA        $A1,S                
                    AND        #$0F                 
                    ORA        #$20                 
                    STA        $A1,S                
                    REP        #$30                 
                    PEA        $1231                
                    PEA        $4623                
                    PEA        $1336                
                    PEA        $1333                
                    TSC                             ; Line 16
                    ADC        #$00A8               
                    TCS                             
                    LDA        $98,S                
                    AND        #$00F0               
                    ORA        #$6101               
                    STA        $98,S                
                    LDA        $A2,S                
                    AND        #$0F00               
                    ORA        #$1021               
                    STA        $A2,S                
                    PEA        $1363                
                    PEA        $3432                
                    PEA        $6113                
                    PEA        $3111                
                    TSC                             ; Line 17
                    ADC        #$00A9               
                    TCS                             
                    LDA        $A1,S                
                    AND        #$0F00               
                    ORA        #$6033               
                    STA        $A1,S                
                    PEA        $3311                
                    PEA        $6343                
                    PEA        $1436                
                    PEA        $1113                
                    TSC                             ; Line 18
                    ADC        #$00A8               
                    TCS                             
                    LDA        $A1,S                
                    AND        #$0F00               
                    ORA        #$1031               
                    STA        $A1,S                
                    PEA        $1313                
                    PEA        $3644                
                    PEA        $4413                
                    PEA        $6131                
                    PHY                             
                    TSC                             ; Line 19
                    ADC        #$00AA               
                    TCS                             
                    LDA        $A1,S                
                    AND        #$0F00               
                    ORA        #$6013               
                    STA        $A1,S                
                    PEA        $3161                
                    PEA        $2344                
                    PEA        $4444                
                    PEA        $6613                
                    PHX                             
                    TSC                             ; Line 20
                    ADC        #$00AA               
                    TCS                             
                    SEP        #$20                 
                    LDA        #$31                 
                    STA        $A1,S                
                    REP        #$30                 
                    PEA        $1316                
                    PEA        $3261                
                    PEA        $4344                
                    PEA        $6333                
                    PHY                             
                    TSC                             ; Line 21
                    ADC        #$00AA               
                    TCS                             
                    SEP        #$20                 
                    LDA        $A1,S                
                    AND        #$0F                 
                    ORA        #$10                 
                    STA        $A1,S                
                    REP        #$30                 
                    PEA        $6121                
                    PEA        $1316                
                    PEA        $6114                
                    PEA        $3313                
                    PHX                             
                    TSC                             ; Line 22
                    ADC        #$00AA               
                    TCS                             
                    SEP        #$20                 
                    LDA        $9F,S                
                    AND        #$0F                 
                    ORA        #$10                 
                    STA        $9F,S                
                    REP        #$30                 
                    PEA        $1636                
                    PEA        $6113                
                    PHY                             
                    PEA        $1633                
                    PHY                             
                    TSC                             ; Line 23
                    ADC        #$00A8               
                    TCS                             
                    SEP        #$20                 
                    LDA        $A1,S                
                    AND        #$0F                 
                    ORA        #$60                 
                    STA        $A1,S                
                    REP        #$30                 
                    PEA        $3611                
                    PEA        $1161                
                    PEA        $6111                
                    PHX                             
                    TSC                             ; Line 24
                    ADC        #$00A8               
                    TCS                             
                    SEP        #$20                 
                    LDA        $A1,S                
                    AND        #$0F                 
                    ORA        #$30                 
                    STA        $A1,S                
                    REP        #$30                 
                    PEA        $1313                
                    PEA        $1111                
                    PHD                             
                    PHD                             
                    TSC                             ; Line 25
                    ADC        #$00A8               
                    TCS                             
                    LDA        $99,S                
                    AND        #$00F0               
                    ORA        #$1606               
                    STA        $99,S                
                    SEP        #$20                 
                    LDA        $A1,S                
                    AND        #$0F                 
                    ORA        #$30                 
                    STA        $A1,S                
                    REP        #$30                 
                    PEA        $3331                
                    PEA        $1311                
                    PHX                             
                    PHX                             
                    TSC                             ; Line 26
                    ADC        #$00A8               
                    TCS                             
                    SEP        #$20                 
                    LDA        $A1,S                
                    AND        #$0F                 
                    ORA        #$30                 
                    STA        $A1,S                
                    REP        #$30                 
                    PEA        $1313                
                    PEA        $1311                
                    PHY                             
                    TSC                             ; Line 27
                    ADC        #$00A6               
                    TCS                             
                    SEP        #$20                 
                    LDA        #$55                 
                    STA        $A1,S                
                    REP        #$30                 
                    PEA        $3331                
                    PEA        $3111                
                    PEA        $1177                
                    TSC                             ; Line 28
                    ADC        #$00A6               
                    TCS                             
                    SEP        #$20                 
                    LDA        #$57                 
                    STA        $A1,S                
                    REP        #$30                 
                    PEA        $1311                
                    PEA        $7777                
                    PEA        $5755                
                    TSC                             ; Line 29
                    ADC        #$00A6               
                    TCS                             
                    SEP        #$20                 
                    LDA        #$11                 
                    STA        $A1,S                
                    REP        #$30                 
                    PEA        $7757                
                    PEA        $5555                
                    PEA        $6561                
                    TSC                             ; Line 30
                    ADC        #$00A6               
                    TCS                             
                    SEP        #$20                 
                    LDA        #$16                 
                    STA        $9B,S                
                    REP        #$30                 
                    PEA        $5717                
                    PHY                             
                    PHD                             
                    TSC                             ; Line 31
                    ADC        #$00A9               
                    TCS                             
                    SEP        #$20                 
                    LDA        $A2,S                
                    AND        #$0F                 
                    ORA        #$30                 
                    STA        $A2,S                
                    REP        #$30                 
                    PEA        $3353                
                    PEA        $5717                
                    PEA        $1131                
                    PHY                             
                    TSC                             ; Line 32
                    ADC        #$00A9               
                    TCS                             
                    LDA        $A1,S                
                    AND        #$0F00               
                    ORA        #$3033               
                    STA        $A1,S                
                    PEA        $3333                
                    PEA        $7551                
                    PEA        $3733                
                    PEA        $1313                
                    PHX                             
                    TSC                             ; Line 33
                    ADC        #$00AA               
                    TCS                             
                    PEA        $1313                
                    PEA        $1775                
                    PEA        $3333                
                    PEA        $3311                
                    PHD                             
                    TSC                             ; Line 34
                    ADC        #$00AC               
                    TCS                             
                    SEP        #$20                 
                    LDA        #$33                 
                    STA        $A1,S                
                    REP        #$30                 
                    PEA        $2333                
                    PEA        $3131                
                    PEA        $1175                
                    PEA        $3131                
                    PEA        $1313                
                    PHX                             
                    TSC                             ; Line 35
                    ADC        #$00AC               
                    TCS                             
                    LDA        $A1,S                
                    AND        #$0F00               
                    ORA        #$2023               
                    STA        $A1,S                
                    PEA        $1313                
                    PEA        $1311                
                    PEA        $1161                
                    PEA        $1333                
                    PEA        $3311                
                    PHY                             
                    TSC                             ; Line 36
                    ADC        #$00AC               
                    TCS                             
                    LDA        $95,S                
                    AND        #$00F0               
                    ORA        #$1106               
                    STA        $95,S                
                    PEA        $3111                
                    PHY                             
                    PHD                             
                    PEA        $3631                
                    PEA        $1313                
                    PHX                             
                    TSC                             ; Line 37
                    ADC        #$00AE               
                    TCS                             
                    LDA        $93,S                
                    AND        #$00F0               
                    ORA        #$6101               
                    STA        $93,S                
                    PEA        $3232                
                    PEA        $1111                
                    PHX                             
                    PHX                             
                    PEA        $3133                
                    PEA        $3111                
                    TSC                             ; Line 38
                    ADC        #$00AC               
                    TCS                             
                    SEP        #$20                 
                    LDA        #$13                 
                    STA        $A0,S                
                    LDA        $93,S                
                    AND        #$F0                 
                    ORA        #$06                 
                    STA        $93,S                
                    REP        #$30                 
                    PEA        $2313                
                    PHY                             
                    PHD                             
                    PHD                             
                    PEA        $1633                
                    PEA        $1313                
                    TSC                             ; Line 39
                    ADC        #$00A3               
                    TCS                             
                    LDA        #$1316               
                    STA        $A8,S                
                    LDA        $A6,S                
                    AND        #$00F0               
                    ORA        #$1606               
                    STA        $A6,S                
                    SEP        #$20                 
                    LDA        $9C,S                
                    AND        #$F0                 
                    ORA        #$01                 
                    STA        $9C,S                
                    REP        #$30                 
                    PEA        $3131                
                    PEA        $1111                
                    TSC                             
                    ADC        #$000C               
                    TCS                             
                    PHX                             
                    PHX                             
                    TSC                             ; Line 40
                    ADC        #$009C               
                    TCS                             
                    LDA        #$3111               
                    STA        $9D,S                
                    LDA        #$1161               
                    STA        $A8,S                
                    LDA        $9F,S                
                    AND        #$0F00               
                    ORA        #$3033               
                    STA        $9F,S                
                    LDA        $A6,S                
                    AND        #$00F0               
                    ORA        #$6101               
                    STA        $A6,S                
                    SEP        #$20                 
                    LDA        $9C,S                
                    AND        #$F0                 
                    ORA        #$06                 
                    STA        $9C,S                
                    REP        #$30                 
                    PEA        $2313                
                    PEA        $1361                
                    TSC                             ; Line 42
                    ADC        #$013E               
                    TCS                             
                    LDA        #$1361               
                    STA        $03,S                
                    LDA        #$1311               
                    STA        $A3,S                
                    LDA        $05,S                
                    AND        #$0F00               
                    ORA        #$3032               
                    STA        $05,S                
                    LDA        $0C,S                
                    AND        #$00F0               
                    ORA        #$1606               
                    STA        $0C,S                
                    LDA        $0E,S                
                    AND        #$0F00               
                    ORA        #$3011               
                    STA        $0E,S                
                    LDA        $A5,S                
                    AND        #$0F00               
                    ORA        #$3023               
                    STA        $A5,S                
                    LDA        $AC,S                
                    AND        #$00F0               
                    ORA        #$6101               
                    STA        $AC,S                
                    LDA        $AE,S                
                    AND        #$0F00               
                    ORA        #$1013               
                    STA        $AE,S                
                    SEP        #$20                 
                    LDA        $02,S                
                    AND        #$F0                 
                    ORA        #$01                 
                    STA        $02,S                
                    LDA        $A2,S                
                    AND        #$F0                 
                    ORA        #$06                 
                    STA        $A2,S                
                    REP        #$30                 
                    TSC                             ; Line 44
                    ADC        #$0140               
                    TCS                             
                    LDA        #$3261               
                    STA        $03,S                
                    TYA                             
                    STA        $0D,S                
                    LDA        #$3313               
                    STA        $A3,S                
                    TXA                             
                    STA        $AC,S                
                    LDA        $05,S                
                    AND        #$0F00               
                    ORA        #$3032               
                    STA        $05,S                
                    LDA        $A5,S                
                    AND        #$0F00               
                    ORA        #$3023               
                    STA        $A5,S                
                    SEP        #$20                 
                    LDA        #$16                 
                    STA        $0C,S                
                    LDA        #$13                 
                    STA        $AE,S                
                    LDA        $02,S                
                    AND        #$F0                 
                    ORA        #$01                 
                    STA        $02,S                
                    LDA        $A2,S                
                    AND        #$F0                 
                    ORA        #$06                 
                    STA        $A2,S                
                    REP        #$30                 
                    TSC                             ; Line 46
                    ADC        #$0140               
                    TCS                             
                    LDA        #$3312               
                    STA        $04,S                
                    LDA        #$3311               
                    STA        $A4,S                
                    LDA        #$1341               
                    STA        $AC,S                
                    LDA        $02,S                
                    AND        #$00F0               
                    ORA        #$6101               
                    STA        $02,S                
                    LDA        $0B,S                
                    AND        #$00F0               
                    ORA        #$1606               
                    STA        $0B,S                
                    LDA        $0D,S                
                    AND        #$0F00               
                    ORA        #$3011               
                    STA        $0D,S                
                    LDA        $A2,S                
                    AND        #$00F0               
                    ORA        #$1606               
                    STA        $A2,S                
                    SEP        #$20                 
                    LDA        $AE,S                
                    AND        #$0F                 
                    ORA        #$10                 
                    STA        $AE,S                
                    REP        #$30                 
                    TSC                             ; Line 48
                    ADC        #$0140               
                    TCS                             
                    LDA        #$1313               
                    STA        $04,S                
                    LDA        #$4444               
                    STA        $0C,S                
                    STA        $AD,S                
                    TYA                             
                    STA        $A3,S                
                    LDA        $02,S                
                    AND        #$00F0               
                    ORA        #$6101               
                    STA        $02,S                
                    SEP        #$20                 
                    LDA        #$33                 
                    STA        $A5,S                
                    LDA        $AC,S                
                    AND        #$F0                 
                    ORA        #$04                 
                    STA        $AC,S                
                    REP        #$30                 
                    TSC                             ; Line 50
                    ADC        #$0140               
                    TCS                             
                    LDA        #$1361               
                    STA        $03,S                
                    TYA                             
                    STA        $A3,S                
                    LDA        $0D,S                
                    AND        #$00F0               
                    ORA        #$4404               
                    STA        $0D,S                
                    SEP        #$20                 
                    LDA        #$33                 
                    STA        $05,S                
                    LDA        $0F,S                
                    AND        #$0F                 
                    ORA        #$40                 
                    STA        $0F,S                
                    LDA        $A5,S                
                    AND        #$0F                 
                    ORA        #$30                 
                    STA        $A5,S                
                    REP        #$30                 
                    TSC                             ; Line 52
                    ADC        #$0140               
                    TCS                             
                    TXA                             
                    STA        $03,S                
                    LDA        $08,S                
                    AND        #$0F0F               
                    ORA        #$6060               
                    STA        $08,S                
                    LDA        $0A,S                
                    AND        #$0F0F               
                    ORA        #$6060               
                    STA        $0A,S                
                    LDA        $0C,S                
                    AND        #$0F0F               
                    ORA        #$6060               
                    STA        $0C,S                
                    LDA        $A3,S                
                    AND        #$00F0               
                    ORA        #$4404               
                    STA        $A3,S                
                    LDA        $A6,S                
                    AND        #$F0F0               
                    ORA        #$0606               
                    STA        $A6,S                
                    LDA        $A8,S                
                    AND        #$F0F0               
                    ORA        #$0606               
                    STA        $A8,S                
                    LDA        $AA,S                
                    AND        #$F0F0               
                    ORA        #$0606               
                    STA        $AA,S                
                    LDA        $AC,S                
                    AND        #$F0F0               
                    ORA        #$0606               
                    STA        $AC,S                
                    LDA        $AE,S                
                    AND        #$F0F0               
                    ORA        #$0606               
                    STA        $AE,S                
                    SEP        #$20                 
                    LDA        $05,S                
                    AND        #$0F                 
                    ORA        #$30                 
                    STA        $05,S                
                    LDA        $A5,S                
                    AND        #$F0                 
                    ORA        #$06                 
                    STA        $A5,S                
                    REP        #$30                 
                    TSC                             ; Line 54
                    ADC        #$0140               
                    TCS                             
                    LDA        #$4444               
                    STA        $A2,S                
                    LDA        $02,S                
                    AND        #$00F0               
                    ORA        #$4404               
                    STA        $02,S                
                    LDA        $04,S                
                    AND        #$0F00               
                    ORA        #$6044               
                    STA        $04,S                
                    LDA        $06,S                
                    AND        #$0F0F               
                    ORA        #$6060               
                    STA        $06,S                
                    LDA        $08,S                
                    AND        #$0F0F               
                    ORA        #$6060               
                    STA        $08,S                
                    LDA        $0A,S                
                    AND        #$0F0F               
                    ORA        #$6060               
                    STA        $0A,S                
                    LDA        $0C,S                
                    AND        #$0F0F               
                    ORA        #$6060               
                    STA        $0C,S                
                    LDA        $0E,S                
                    AND        #$0F0F               
                    ORA        #$6060               
                    STA        $0E,S                
                    LDA        $A4,S                
                    AND        #$F0F0               
                    ORA        #$0606               
                    STA        $A4,S                
                    LDA        $A6,S                
                    AND        #$F0F0               
                    ORA        #$0606               
                    STA        $A6,S                
                    LDA        $A8,S                
                    AND        #$F0F0               
                    ORA        #$0606               
                    STA        $A8,S                
                    LDA        $AA,S                
                    AND        #$F0F0               
                    ORA        #$0606               
                    STA        $AA,S                
                    LDA        $AC,S                
                    AND        #$F0F0               
                    ORA        #$0606               
                    STA        $AC,S                
                    SEP        #$20                 
                    LDA        $A1,S                
                    AND        #$F0                 
                    ORA        #$04                 
                    STA        $A1,S                
                    REP        #$30                 
*--                                                 
                    LDAL       $E1C068              ; Direct Page and Stack in Bank 00/
                    AND        #$FFCF               
                    STAL       $E1C068              
                    LDA        StackAddress         ; Restore Stack
                    TCS                             
                    PLD                             ; Restore Direct Page
                    CLI                             ; Enable Interrupts
                    PLB
                    RTL                             
                                                    
*-----------------------------------                                
Sprite_RR_04B       CLC                             ; Sprite #04B : 56x53, 1909 bytes, 3121 cycles
                    SEI                             ; Disable Interrupts
                    PHD                             ; Backup Direct Page
                    TSC                             ; Backup Stack
                    STA        StackAddress         
                    LDAL       $E1C068              ; Direct Page and Stack in Bank 01/
                    ORA        #$0030               
                    STAL       $E1C068              
                    TYA                             ; Y = Sprite Target Screen Address (upper left corner)
                    TCS                             ; New Stack address
                    LDX        #$6161               ; Pattern #1 : 31
                    LDY        #$1111               ; Pattern #2 : 29
                    LDA        #$3333               ; Pattern #3 : 21
                    TCD                             
*--                                                 
                    LDA        #$6666               ; Line 0
                    STA        $A3,S                
                    LDA        $03,S                
                    AND        #$00F0               
                    ORA        #$6606               
                    STA        $03,S                
                    LDA        $A5,S                
                    AND        #$0F00               
                    ORA        #$6066               
                    STA        $A5,S                
                    SEP        #$20                 
                    LDA        $05,S                
                    AND        #$0F                 
                    ORA        #$60                 
                    STA        $05,S                
                    REP        #$30                 
                    TSC                             ; Line 2
                    ADC        #$0140               
                    TCS                             
                    SEP        #$20                 
                    LDA        $02,S                
                    AND        #$F0                 
                    ORA        #$06                 
                    STA        $02,S                
                    LDA        $A2,S                
                    AND        #$F0                 
                    ORA        #$05                 
                    STA        $A2,S                
                    REP        #$30                 
                    TSC                             
                    ADC        #$0006               
                    TCS                             
                    PEA        $6666                
                    PEA        $6666                
                    TSC                             ; Line 3
                    ADC        #$00A4               
                    TCS                             
                    SEP        #$20                 
                    LDA        $9C,S                
                    AND        #$F0                 
                    ORA        #$05                 
                    STA        $9C,S                
                    REP        #$30                 
                    PEA        $5555                
                    PEA        $5555                
                    TSC                             ; Line 4
                    ADC        #$00A4               
                    TCS                             
                    SEP        #$20                 
                    LDA        $9C,S                
                    AND        #$F0                 
                    ORA        #$06                 
                    STA        $9C,S                
                    REP        #$30                 
                    PEA        $5555                
                    PEA        $5555                
                    TSC                             ; Line 5
                    ADC        #$00A4               
                    TCS                             
                    SEP        #$20                 
                    LDA        $9C,S                
                    AND        #$F0                 
                    ORA        #$06                 
                    STA        $9C,S                
                    REP        #$30                 
                    PEA        $4444                
                    PEA        $6666                
                    TSC                             ; Line 6
                    ADC        #$00A4               
                    TCS                             
                    LDA        #$4466               
                    STA        $9E,S                
                    LDA        $9C,S                
                    AND        #$00F0               
                    ORA        #$6606               
                    STA        $9C,S                
                    LDA        $A0,S                
                    AND        #$0F00               
                    ORA        #$4044               
                    STA        $A0,S                
                    PEA        $6446                
                    PEA        $6666                
                    TSC                             ; Line 8
                    ADC        #$0144               
                    TCS                             
                    SEP        #$20                 
                    LDA        #$44                 
                    STA        $AD,S                
                    LDA        $01,S                
                    AND        #$0F                 
                    ORA        #$40                 
                    STA        $01,S                
                    REP        #$30                 
                    PEA        $4444                
                    PEA        $4666                
                    TSC                             ; Line 9
                    ADC        #$00B0               
                    TCS                             
                    LDA        $A1,S                
                    AND        #$0F00               
                    ORA        #$4044               
                    STA        $A1,S                
                    PEA        $4434                
                    PHD                             
                    PHD                             
                    PHD                             
                    PHD                             
                    PEA        $1311                
                    PEA        $4444                
                    PEA        $4466                
                    TSC                             ; Line 10
                    ADC        #$00B0               
                    TCS                             
                    LDA        $9F,S                
                    AND        #$F00F               
                    ORA        #$0410               
                    STA        $9F,S                
                    SEP        #$20                 
                    LDA        #$44                 
                    STA        $A1,S                
                    LDA        $90,S                
                    AND        #$F0                 
                    ORA        #$03                 
                    STA        $90,S                
                    REP        #$30                 
                    PEA        $4434                
                    PEA        $3131                
                    PEA        $3111                
                    PEA        $1313                
                    PEA        $3131                
                    PEA        $3111                
                    PEA        $4444                
                    PEA        $4444                
                    TSC                             ; Line 11
                    ADC        #$00AE               
                    TCS                             
                    SEP        #$20                 
                    LDA        $A0,S                
                    AND        #$0F                 
                    ORA        #$60                 
                    STA        $A0,S                
                    REP        #$30                 
                    PEA        $1113                
                    PHY                             
                    PHY                             
                    PHY                             
                    PEA        $1313                
                    PEA        $2363                
                    PEA        $4434                
                    TSC                             ; Line 12
                    ADC        #$00AD               
                    TCS                             
                    LDA        $9D,S                
                    AND        #$0F00               
                    ORA        #$1016               
                    STA        $9D,S                
                    SEP        #$20                 
                    LDA        $92,S                
                    AND        #$F0                 
                    ORA        #$06                 
                    STA        $92,S                
                    REP        #$30                 
                    PHX                             
                    PHX                             
                    PHX                             
                    PEA        $1133                
                    PEA        $1132                
                    PEA        $6644                
                    PEA        $3361                
                    TSC                             ; Line 13
                    ADC        #$00AA               
                    TCS                             
                    SEP        #$20                 
                    LDA        #$61                 
                    STA        $96,S                
                    REP        #$30                 
                    PEA        $1616                
                    PEA        $3611                
                    PEA        $2163                
                    PEA        $4444                
                    PEA        $1316                
                    TSC                             ; Line 14
                    ADC        #$00AA               
                    TCS                             
                    SEP        #$20                 
                    LDA        $A0,S                
                    AND        #$0F                 
                    ORA        #$10                 
                    STA        $A0,S                
                    REP        #$30                 
                    PHX                             
                    PHY                             
                    PEA        $3246                
                    PEA        $4434                
                    PEA        $6361                
                    TSC                             ; Line 15
                    ADC        #$00A9               
                    TCS                             
                    SEP        #$20                 
                    LDA        $A1,S                
                    AND        #$0F                 
                    ORA        #$60                 
                    STA        $A1,S                
                    REP        #$30                 
                    PEA        $1611                
                    PEA        $1163                
                    PEA        $4434                
                    PEA        $3316                
                    PEA        $1116                
                    TSC                             ; Line 16
                    ADC        #$00AA               
                    TCS                             
                    LDA        $96,S                
                    AND        #$00F0               
                    ORA        #$1606               
                    STA        $96,S                
                    LDA        $A0,S                
                    AND        #$0F00               
                    ORA        #$1011               
                    STA        $A0,S                
                    PHY                             
                    PEA        $2163                
                    PEA        $4433                
                    PEA        $6611                
                    PEA        $1161                
                    TSC                             ; Line 17
                    ADC        #$00A9               
                    TCS                             
                    LDA        $97,S                
                    AND        #$00F0               
                    ORA        #$6301               
                    STA        $97,S                
                    LDA        $A1,S                
                    AND        #$0F00               
                    ORA        #$1011               
                    STA        $A1,S                
                    PEA        $1131                
                    PHD                             
                    PEA        $6611                
                    PEA        $1131                
                    TSC                             ; Line 18
                    ADC        #$00A8               
                    TCS                             
                    LDA        $97,S                
                    AND        #$00F0               
                    ORA        #$1106               
                    STA        $97,S                
                    PHD                             
                    PEA        $6666                
                    PEA        $3131                
                    PHY                             
                    TSC                             ; Line 19
                    ADC        #$00AA               
                    TCS                             
                    SEP        #$20                 
                    LDA        $A1,S                
                    AND        #$0F                 
                    ORA        #$10                 
                    STA        $A1,S                
                    REP        #$30                 
                    PEA        $3363                
                    PEA        $6666                
                    PEA        $1313                
                    PEA        $1313                
                    PEA        $1131                
                    TSC                             ; Line 20
                    ADC        #$00AA               
                    TCS                             
                    LDA        $A3,S                
                    AND        #$0F00               
                    ORA        #$3033               
                    STA        $A3,S                
                    PEA        $6636                
                    PHD                             
                    PEA        $3131                
                    PEA        $3111                
                    PEA        $1131                
                    PEA        $6361                
                    TSC                             ; Line 21
                    ADC        #$00AE               
                    TCS                             
                    LDA        $AD,S                
                    AND        #$00F0               
                    ORA        #$4404               
                    STA        $AD,S                
                    SEP        #$20                 
                    LDA        $AB,S                
                    AND        #$0F                 
                    ORA        #$30                 
                    STA        $AB,S                
                    REP        #$30                 
                    PEA        $5733                
                    PHD                             
                    PEA        $3113                
                    PEA        $1311                
                    PHY                             
                    PEA        $1613                
                    PEA        $1316                
                    TSC                             ; Line 22
                    ADC        #$00B8               
                    TCS                             
                    PHD                             
                    PHD                             
                    PHD                             
                    PHD                             
                    PHD                             
                    PEA        $7777                
                    PEA        $3131                
                    PEA        $3331                
                    PHY                             
                    PHX                             
                    PEA        $6131                
                    PHX                             
                    TSC                             ; Line 23
                    ADC        #$00BC               
                    TCS                             
                    TXA                             
                    STA        $85,S                
                    LDA        $87,S                
                    AND        #$0F00               
                    ORA        #$6033               
                    STA        $87,S                
                    SEP        #$20                 
                    LDA        $A0,S                
                    AND        #$0F                 
                    ORA        #$40                 
                    STA        $A0,S                
                    REP        #$30                 
                    LDA        #$3131               
                    PEA        $4444                
                    PEA        $4434                
                    PHA                             
                    PHA                             
                    PHA                             
                    PHA                             
                    PHA                             
                    PEA        $3375                
                    PEA        $1313                
                    PEA        $1313                
                    PEA        $1116                
                    PEA        $1616                
                    PEA        $1613                
                    PEA        $1316                
                    TSC                             ; Line 24
                    ADC        #$00BB               
                    TCS                             
                    LDA        #$1116               
                    STA        $86,S                
                    LDA        $8B,S                
                    AND        #$00F0               
                    ORA        #$1606               
                    STA        $8B,S                
                    LDA        $9F,S                
                    AND        #$0F00               
                    ORA        #$4044               
                    STA        $9F,S                
                    SEP        #$20                 
                    LDA        #$13                 
                    STA        $88,S                
                    REP        #$30                 
                    PEA        $4444                
                    PEA        $1411                
                    PHY                             
                    PHY                             
                    PHY                             
                    PEA        $1113                
                    PEA        $1313                
                    PEA        $5137                
                    PEA        $3131                
                    PEA        $1161                
                    PHX                             
                    TSC                             ; Line 25
                    ADC        #$00B4               
                    TCS                             
                    TXA                             
                    STA        $88,S                
                    SEP        #$20                 
                    LDA        #$33                 
                    STA        $8A,S                
                    LDA        $A0,S                
                    AND        #$0F                 
                    ORA        #$60                 
                    STA        $A0,S                
                    REP        #$30                 
                    PEA        $1411                
                    PEA        $1616                
                    PHY                             
                    PHY                             
                    PHY                             
                    PEA        $3131                
                    PEA        $1157                
                    PHY                             
                    PEA        $1116                
                    TSC                             ; Line 26
                    ADC        #$00B1               
                    TCS                             
                    LDA        #$3316               
                    STA        $8A,S                
                    LDA        $8F,S                
                    AND        #$00F0               
                    ORA        #$1606               
                    STA        $8F,S                
                    SEP        #$20                 
                    LDA        $89,S                
                    AND        #$F0                 
                    ORA        #$06                 
                    STA        $89,S                
                    REP        #$30                 
                    PHX                             
                    PHX                             
                    PHX                             
                    PHX                             
                    PEA        $6111                
                    PEA        $1371                
                    PEA        $5517                
                    PHX                             
                    PHX                             
                    TSC                             ; Line 27
                    ADC        #$00B2               
                    TCS                             
                    LDA        #$1361               
                    STA        $8A,S                
                    SEP        #$20                 
                    LDA        $8C,S                
                    AND        #$0F                 
                    ORA        #$10                 
                    STA        $8C,S                
                    REP        #$30                 
                    LDA        #$1616               
                    PHA                             
                    PHA                             
                    PHA                             
                    PHA                             
                    PEA        $1636                
                    PEA        $3371                
                    PEA        $5577                
                    PEA        $7716                
                    TSC                             ; Line 28
                    ADC        #$00AB               
                    TCS                             
                    LDA        #$1616               
                    STA        $8F,S                
                    SEP        #$20                 
                    LDA        #$31                 
                    STA        $91,S                
                    LDA        $9E,S                
                    AND        #$0F                 
                    ORA        #$10                 
                    STA        $9E,S                
                    REP        #$30                 
                    PHX                             
                    PHX                             
                    PEA        $6133                
                    PEA        $7715                
                    PEA        $5175                
                    PEA        $7761                
                    TSC                             ; Line 29
                    ADC        #$00A9               
                    TCS                             
                    LDA        $92,S                
                    AND        #$00F0               
                    ORA        #$6101               
                    STA        $92,S                
                    LDA        $94,S                
                    AND        #$0F00               
                    ORA        #$1063               
                    STA        $94,S                
                    LDA        $99,S                
                    AND        #$00F0               
                    ORA        #$1606               
                    STA        $99,S                
                    LDA        $9F,S                
                    AND        #$0F00               
                    ORA        #$6061               
                    STA        $9F,S                
                    PEA        $1616                
                    PEA        $5375                
                    PEA        $1561                
                    PEA        $5175                
                    TSC                             ; Line 30
                    ADC        #$00A6               
                    TCS                             
                    LDA        #$1616               
                    STA        $95,S                
                    SEP        #$20                 
                    LDA        $97,S                
                    AND        #$0F                 
                    ORA        #$10                 
                    STA        $97,S                
                    REP        #$30                 
                    PEA        $3371                
                    PEA        $1516                
                    TSC                             ; Line 31
                    ADC        #$00A5               
                    TCS                             
                    LDA        #$4461               
                    STA        $95,S                
                    LDA        $9F,S                
                    AND        #$0F00               
                    ORA        #$1033               
                    STA        $9F,S                
                    SEP        #$20                 
                    LDA        $97,S                
                    AND        #$0F                 
                    ORA        #$40                 
                    STA        $97,S                
                    REP        #$30                 
                    PEA        $1631                
                    PEA        $1315                
                    PHX                             
                    TSC                             ; Line 32
                    ADC        #$00A4               
                    TCS                             
                    LDA        $97,S                
                    AND        #$00F0               
                    ORA        #$4404               
                    STA        $97,S                
                    LDA        $A1,S                
                    AND        #$0F00               
                    ORA        #$1033               
                    STA        $A1,S                
                    PEA        $1115                
                    PEA        $1616                
                    TSC                             ; Line 33
                    ADC        #$00A4               
                    TCS                             
                    LDA        #$3111               
                    STA        $9F,S                
                    LDA        $9D,S                
                    AND        #$00F0               
                    ORA        #$1606               
                    STA        $9D,S                
                    LDA        $A1,S                
                    AND        #$0F00               
                    ORA        #$1031               
                    STA        $A1,S                
                    SEP        #$20                 
                    LDA        #$44                 
                    STA        $98,S                
                    REP        #$30                 
                    PEA        $1311                
                    PHX                             
                    TSC                             ; Line 35
                    ADC        #$0138               
                    TCS                             
                    SEP        #$20                 
                    LDA        $09,S                
                    AND        #$F0                 
                    ORA        #$01                 
                    STA        $09,S                
                    LDA        $A9,S                
                    AND        #$F0                 
                    ORA        #$06                 
                    STA        $A9,S                
                    REP        #$30                 
                    TSC                             
                    ADC        #$000D               
                    TCS                             
                    PEA        $3313                
                    PEA        $1161                
                    TSC                             ; Line 36
                    ADC        #$00A4               
                    TCS                             
                    PEA        $3331                
                    PEA        $3116                
                    TSC                             ; Line 37
                    ADC        #$00A4               
                    TCS                             
                    LDA        #$1116               
                    STA        $9D,S                
                    LDA        $9F,S                
                    AND        #$0F00               
                    ORA        #$3031               
                    STA        $9F,S                
                    PEA        $3312                
                    PEA        $1361                
                    TSC                             ; Line 39
                    ADC        #$0137               
                    TCS                             
                    LDA        #$1361               
                    STA        $0A,S                
                    LDA        #$1116               
                    STA        $AA,S                
                    LDA        $0C,S                
                    AND        #$0F00               
                    ORA        #$3012               
                    STA        $0C,S                
                    LDA        $AC,S                
                    AND        #$0F00               
                    ORA        #$3021               
                    STA        $AC,S                
                    TSC                             ; Line 41
                    ADC        #$0140               
                    TCS                             
                    LDA        #$6361               
                    STA        $0A,S                
                    LDA        #$3116               
                    STA        $AA,S                
                    LDA        $0C,S                
                    AND        #$0F00               
                    ORA        #$3013               
                    STA        $0C,S                
                    LDA        $AC,S                
                    AND        #$0F00               
                    ORA        #$3023               
                    STA        $AC,S                
                    TSC                             ; Line 43
                    ADC        #$0140               
                    TCS                             
                    LDA        #$1261               
                    STA        $0A,S                
                    LDA        #$1116               
                    STA        $AA,S                
                    SEP        #$20                 
                    LDA        #$13                 
                    STA        $0C,S                
                    LDA        #$23                 
                    STA        $AC,S                
                    REP        #$30                 
                    TSC                             ; Line 45
                    ADC        #$0140               
                    TCS                             
                    LDA        #$1361               
                    STA        $0A,S                
                    LDA        #$1116               
                    STA        $AA,S                
                    SEP        #$20                 
                    LDA        #$13                 
                    STA        $0C,S                
                    LDA        #$33                 
                    STA        $AC,S                
                    REP        #$30                 
                    TSC                             ; Line 47
                    ADC        #$0140               
                    TCS                             
                    LDA        #$1361               
                    STA        $0A,S                
                    LDA        #$1116               
                    STA        $AA,S                
                    LDA        $B1,S                
                    AND        #$F0F0               
                    ORA        #$0606               
                    STA        $B1,S                
                    SEP        #$20                 
                    LDA        #$33                 
                    STA        $0C,S                
                    LDA        $AC,S                
                    AND        #$0F                 
                    ORA        #$30                 
                    STA        $AC,S                
                    REP        #$30                 
                    TSC                             ; Line 49
                    ADC        #$0140               
                    TCS                             
                    TXA                             
                    STA        $0A,S                
                    LDA        $01,S                
                    AND        #$F0F0               
                    ORA        #$0606               
                    STA        $01,S                
                    LDA        $03,S                
                    AND        #$F0F0               
                    ORA        #$0606               
                    STA        $03,S                
                    LDA        $0E,S                
                    AND        #$0F0F               
                    ORA        #$6060               
                    STA        $0E,S                
                    LDA        $10,S                
                    AND        #$0F0F               
                    ORA        #$6060               
                    STA        $10,S                
                    LDA        $12,S                
                    AND        #$0F0F               
                    ORA        #$6060               
                    STA        $12,S                
                    LDA        $14,S                
                    AND        #$0F0F               
                    ORA        #$6060               
                    STA        $14,S                
                    LDA        $16,S                
                    AND        #$0F0F               
                    ORA        #$6060               
                    STA        $16,S                
                    LDA        $A0,S                
                    AND        #$0F0F               
                    ORA        #$6060               
                    STA        $A0,S                
                    LDA        $A2,S                
                    AND        #$0F0F               
                    ORA        #$6060               
                    STA        $A2,S                
                    LDA        $A4,S                
                    AND        #$0F0F               
                    ORA        #$6060               
                    STA        $A4,S                
                    LDA        $A6,S                
                    AND        #$0F0F               
                    ORA        #$6060               
                    STA        $A6,S                
                    LDA        $A8,S                
                    AND        #$0F0F               
                    ORA        #$6060               
                    STA        $A8,S                
                    LDA        $AA,S                
                    AND        #$00F0               
                    ORA        #$4404               
                    STA        $AA,S                
                    LDA        $AD,S                
                    AND        #$F0F0               
                    ORA        #$0606               
                    STA        $AD,S                
                    LDA        $AF,S                
                    AND        #$F0F0               
                    ORA        #$0606               
                    STA        $AF,S                
                    LDA        $B1,S                
                    AND        #$F0F0               
                    ORA        #$0606               
                    STA        $B1,S                
                    LDA        $B3,S                
                    AND        #$F0F0               
                    ORA        #$0606               
                    STA        $B3,S                
                    LDA        $B5,S                
                    AND        #$F0F0               
                    ORA        #$0606               
                    STA        $B5,S                
                    LDA        $B7,S                
                    AND        #$F0F0               
                    ORA        #$0606               
                    STA        $B7,S                
                    LDA        $B9,S                
                    AND        #$F0F0               
                    ORA        #$0606               
                    STA        $B9,S                
                    SEP        #$20                 
                    LDA        $05,S                
                    AND        #$F0                 
                    ORA        #$06                 
                    STA        $05,S                
                    LDA        $0C,S                
                    AND        #$0F                 
                    ORA        #$30                 
                    STA        $0C,S                
                    LDA        $AC,S                
                    AND        #$F0                 
                    ORA        #$06                 
                    STA        $AC,S                
                    REP        #$30                 
                    TSC                             ; Line 51
                    ADC        #$0140               
                    TCS                             
                    LDA        #$4444               
                    STA        $0A,S                
                    LDA        $00,S                
                    AND        #$F0F0               
                    ORA        #$0606               
                    STA        $00,S                
                    LDA        $02,S                
                    AND        #$F0F0               
                    ORA        #$0606               
                    STA        $02,S                
                    LDA        $04,S                
                    AND        #$F0F0               
                    ORA        #$0606               
                    STA        $04,S                
                    LDA        $06,S                
                    AND        #$F0F0               
                    ORA        #$0606               
                    STA        $06,S                
                    LDA        $08,S                
                    AND        #$F0F0               
                    ORA        #$0406               
                    STA        $08,S                
                    LDA        $0C,S                
                    AND        #$0F0F               
                    ORA        #$6060               
                    STA        $0C,S                
                    LDA        $0E,S                
                    AND        #$0F0F               
                    ORA        #$6060               
                    STA        $0E,S                
                    LDA        $10,S                
                    AND        #$0F0F               
                    ORA        #$6060               
                    STA        $10,S                
                    LDA        $12,S                
                    AND        #$0F0F               
                    ORA        #$6060               
                    STA        $12,S                
                    LDA        $14,S                
                    AND        #$0F0F               
                    ORA        #$6060               
                    STA        $14,S                
                    LDA        $16,S                
                    AND        #$0F0F               
                    ORA        #$6060               
                    STA        $16,S                
                    LDA        $18,S                
                    AND        #$0F0F               
                    ORA        #$6060               
                    STA        $18,S                
                    LDA        $A2,S                
                    AND        #$0F0F               
                    ORA        #$6060               
                    STA        $A2,S                
                    LDA        $A4,S                
                    AND        #$0F0F               
                    ORA        #$6060               
                    STA        $A4,S                
                    LDA        $A6,S                
                    AND        #$0F0F               
                    ORA        #$6060               
                    STA        $A6,S                
                    LDA        $A8,S                
                    AND        #$00F0               
                    ORA        #$4404               
                    STA        $A8,S                
                    LDA        $AA,S                
                    AND        #$F000               
                    ORA        #$0644               
                    STA        $AA,S                
                    LDA        $AC,S                
                    AND        #$F0F0               
                    ORA        #$0606               
                    STA        $AC,S                
                    LDA        $AE,S                
                    AND        #$F0F0               
                    ORA        #$0606               
                    STA        $AE,S                
                    LDA        $B0,S                
                    AND        #$F0F0               
                    ORA        #$0606               
                    STA        $B0,S                
*--                                                 
                    LDAL       $E1C068              ; Direct Page and Stack in Bank 00/
                    AND        #$FFCF               
                    STAL       $E1C068              
                    LDA        StackAddress         ; Restore Stack
                    TCS                             
                    PLD                             ; Restore Direct Page
                    CLI                             ; Enable Interrupts
                    PLB
                    RTL                             
                                                    
*-----------------------------------                                
Sprite_RR_04C       CLC                             ; Sprite #04C : 62x53, 2341 bytes, 3772 cycles
                    SEI                             ; Disable Interrupts
                    PHD                             ; Backup Direct Page
                    TSC                             ; Backup Stack
                    STA        StackAddress         
                    LDAL       $E1C068              ; Direct Page and Stack in Bank 01/
                    ORA        #$0030               
                    STAL       $E1C068              
                    TYA                             ; Y = Sprite Target Screen Address (upper left corner)
                    TCS                             ; New Stack address
                    LDX        #$1111               ; Pattern #1 : 23
                    LDY        #$6161               ; Pattern #2 : 21
                    LDA        #$3131               ; Pattern #3 : 17
                    TCD                             
*--                                                 
                    LDA        #$6666               ; Line 0
                    STA        $03,S                
                    STA        $A4,S                
                    LDA        $A2,S                
                    AND        #$00F0               
                    ORA        #$6606               
                    STA        $A2,S                
                    TSC                             ; Line 2
                    ADC        #$0145               
                    TCS                             
                    SEP        #$20                 
                    LDA        #$55                 
                    STA        $A1,S                
                    LDA        $01,S                
                    AND        #$0F                 
                    ORA        #$60                 
                    STA        $01,S                
                    REP        #$30                 
                    PEA        $6666                
                    PEA        $6666                
                    TSC                             ; Line 3
                    ADC        #$00A4               
                    TCS                             
                    LDA        $AC,S                
                    AND        #$00F0               
                    ORA        #$4404               
                    STA        $AC,S                
                    SEP        #$20                 
                    LDA        #$55                 
                    STA        $A1,S                
                    REP        #$30                 
                    PEA        $5555                
                    PEA        $5555                
                    TSC                             ; Line 4
                    ADC        #$00A4               
                    TCS                             
                    LDA        #$4434               
                    STA        $AB,S                
                    SEP        #$20                 
                    LDA        $A1,S                
                    AND        #$0F                 
                    ORA        #$40                 
                    STA        $A1,S                
                    LDA        $AD,S                
                    AND        #$0F                 
                    ORA        #$40                 
                    STA        $AD,S                
                    REP        #$30                 
                    PEA        $5555                
                    PEA        $5555                
                    TSC                             ; Line 5
                    ADC        #$00A4               
                    TCS                             
                    LDA        #$3332               
                    STA        $AA,S                
                    SEP        #$20                 
                    LDA        $A1,S                
                    AND        #$0F                 
                    ORA        #$40                 
                    STA        $A1,S                
                    LDA        $AC,S                
                    AND        #$0F                 
                    ORA        #$40                 
                    STA        $AC,S                
                    LDA        $B6,S                
                    AND        #$0F                 
                    ORA        #$40                 
                    STA        $B6,S                
                    REP        #$30                 
                    PEA        $4464                
                    PEA        $6666                
                    TSC                             ; Line 6
                    ADC        #$00A4               
                    TCS                             
                    LDA        #$3333               
                    STA        $AA,S                
                    LDA        $A8,S                
                    AND        #$00F0               
                    ORA        #$3202               
                    STA        $A8,S                
                    LDA        $B5,S                
                    AND        #$0FF0               
                    ORA        #$4004               
                    STA        $B5,S                
                    SEP        #$20                 
                    LDA        #$44                 
                    STA        $A1,S                
                    REP        #$30                 
                    PEA        $6664                
                    PEA        $6666                
                    TSC                             ; Line 7
                    ADC        #$00A4               
                    TCS                             
                    LDA        $A5,S                
                    AND        #$00F0               
                    ORA        #$3203               
                    STA        $A5,S                
                    LDA        $AB,S                
                    AND        #$0F00               
                    ORA        #$1011               
                    STA        $AB,S                
                    LDA        $B5,S                
                    AND        #$0F00               
                    ORA        #$4044               
                    STA        $B5,S                
                    SEP        #$20                 
                    LDA        $9D,S                
                    AND        #$F0                 
                    ORA        #$06                 
                    STA        $9D,S                
                    REP        #$30                 
                    PEA        $4464                
                    PEA        $6666                
                    TSC                             ; Line 8
                    ADC        #$00A5               
                    TCS                             
                    LDA        #$4444               
                    STA        $9E,S                
                    LDA        $9C,S                
                    AND        #$00F0               
                    ORA        #$6406               
                    STA        $9C,S                
                    LDA        $A0,S                
                    AND        #$F00F               
                    ORA        #$0340               
                    STA        $A0,S                
                    LDA        $B3,S                
                    AND        #$00F0               
                    ORA        #$4404               
                    STA        $B3,S                
                    SEP        #$20                 
                    LDA        #$33                 
                    STA        $A2,S                
                    LDA        $AB,S                
                    AND        #$0F                 
                    ORA        #$10                 
                    STA        $AB,S                
                    REP        #$30                 
                    PEA        $4444                
                    PEA        $6464                
                    TSC                             
                    ADC        #$000D               
                    TCS                             
                    PHD                             
                    PEA        $3132                
                    TSC                             ; Line 9
                    ADC        #$00A5               
                    TCS                             
                    LDA        #$4444               
                    STA        $94,S                
                    STA        $A9,S                
                    LDA        $96,S                
                    AND        #$000F               
                    ORA        #$1340               
                    STA        $96,S                
                    SEP        #$20                 
                    LDA        #$44                 
                    STA        $93,S                
                    LDA        $A0,S                
                    AND        #$0F                 
                    ORA        #$10                 
                    STA        $A0,S                
                    REP        #$30                 
                    PHX                             
                    PEA        $1113                
                    PEA        $1313                
                    PEA        $3333                
                    TSC                             ; Line 10
                    ADC        #$00A7               
                    TCS                             
                    LDA        $93,S                
                    AND        #$00F0               
                    ORA        #$4403               
                    STA        $93,S                
                    LDA        $9F,S                
                    AND        #$0F00               
                    ORA        #$1016               
                    STA        $9F,S                
                    LDA        $A9,S                
                    AND        #$00F0               
                    ORA        #$4403               
                    STA        $A9,S                
                    SEP        #$20                 
                    LDA        $AB,S                
                    AND        #$0F                 
                    ORA        #$40                 
                    STA        $AB,S                
                    REP        #$30                 
                    PHY                             
                    PHX                             
                    PHD                             
                    PHD                             
                    TSC                             ; Line 11
                    ADC        #$00A6               
                    TCS                             
                    LDA        #$3433               
                    STA        $AB,S                
                    SEP        #$20                 
                    LDA        $95,S                
                    AND        #$F0                 
                    ORA        #$03                 
                    STA        $95,S                
                    LDA        $AD,S                
                    AND        #$0F                 
                    ORA        #$40                 
                    STA        $AD,S                
                    REP        #$30                 
                    PEA        $1616                
                    PHX                             
                    PEA        $1313                
                    PEA        $2113                
                    PEA        $4644                
                    TSC                             ; Line 12
                    ADC        #$00AB               
                    TCS                             
                    LDA        #$3333               
                    STA        $A9,S                
                    LDA        $93,S                
                    AND        #$00F0               
                    ORA        #$1306               
                    STA        $93,S                
                    LDA        $AB,S                
                    AND        #$0F00               
                    ORA        #$4014               
                    STA        $AB,S                
                    SEP        #$20                 
                    LDA        $9F,S                
                    AND        #$0F                 
                    ORA        #$10                 
                    STA        $9F,S                
                    REP        #$30                 
                    PHY                             
                    PHY                             
                    PEA        $1133                
                    PEA        $1132                
                    PEA        $1146                
                    PEA        $4434                
                    TSC                             ; Line 13
                    ADC        #$00AA               
                    TCS                             
                    LDA        #$3133               
                    STA        $AB,S                
                    LDA        $A9,S                
                    AND        #$00F0               
                    ORA        #$2303               
                    STA        $A9,S                
                    LDA        $AD,S                
                    AND        #$0F00               
                    ORA        #$1036               
                    STA        $AD,S                
                    PEA        $1616                
                    PEA        $3611                
                    PEA        $2113                
                    PEA        $6644                
                    PEA        $4433                
                    TSC                             ; Line 14
                    ADC        #$00AA               
                    TCS                             
                    LDA        $9F,S                
                    AND        #$0F00               
                    ORA        #$1016               
                    STA        $9F,S                
                    LDA        $A8,S                
                    AND        #$00F0               
                    ORA        #$2303               
                    STA        $A8,S                
                    SEP        #$20                 
                    LDA        $94,S                
                    AND        #$F0                 
                    ORA        #$01                 
                    STA        $94,S                
                    REP        #$30                 
                    PHY                             
                    PHX                             
                    PEA        $3161                
                    PEA        $4644                
                    PEA        $3433                
                    PHY                             
                    TSC                             ; Line 15
                    ADC        #$00AA               
                    TCS                             
                    LDA        $96,S                
                    AND        #$00F0               
                    ORA        #$1106               
                    STA        $96,S                
                    LDA        $AE,S                
                    AND        #$0F00               
                    ORA        #$6061               
                    STA        $AE,S                
                    SEP        #$20                 
                    LDA        $A9,S                
                    AND        #$F0                 
                    ORA        #$02                 
                    STA        $A9,S                
                    REP        #$30                 
                    PHX                             
                    PEA        $3246                
                    PEA        $4433                
                    PEA        $3366                
                    PEA        $1661                
                    TSC                             
                    ADC        #$0019               
                    TCS                             
                    PEA        $6116                
                    PEA        $1333                
                    TSC                             ; Line 16
                    ADC        #$0096               
                    TCS                             
                    LDA        $AC,S                
                    AND        #$0F00               
                    ORA        #$1016               
                    STA        $AC,S                
                    SEP        #$20                 
                    LDA        $A7,S                
                    AND        #$F0                 
                    ORA        #$02                 
                    STA        $A7,S                
                    REP        #$30                 
                    PHX                             
                    PEA        $1113                
                    PEA        $4633                
                    PEA        $3366                
                    PHX                             
                    TSC                             
                    ADC        #$0016               
                    TCS                             
                    PHD                             
                    PEA        $3332                
                    TSC                             ; Line 17
                    ADC        #$0098               
                    TCS                             
                    SEP        #$20                 
                    LDA        $A1,S                
                    AND        #$0F                 
                    ORA        #$10                 
                    STA        $A1,S                
                    LDA        $A6,S                
                    AND        #$F0                 
                    ORA        #$03                 
                    STA        $A6,S                
                    REP        #$30                 
                    PHX                             
                    PEA        $3133                
                    PEA        $3363                
                    PEA        $6616                
                    PHX                             
                    PHY                             
                    TSC                             
                    ADC        #$0017               
                    TCS                             
                    PHD                             
                    PEA        $3333                
                    TSC                             ; Line 18
                    ADC        #$0099               
                    TCS                             
                    SEP        #$20                 
                    LDA        #$61                 
                    STA        $95,S                
                    LDA        $AC,S                
                    AND        #$0F                 
                    ORA        #$10                 
                    STA        $AC,S                
                    REP        #$30                 
                    PEA        $1133                
                    PEA        $3366                
                    PEA        $6616                
                    PHX                             
                    PHX                             
                    PEA        $1116                
                    TSC                             
                    ADC        #$0018               
                    TCS                             
                    PEA        $6111                
                    PEA        $1313                
                    PEA        $3333                
                    TSC                             ; Line 19
                    ADC        #$009B               
                    TCS                             
                    LDA        $A0,S                
                    AND        #$0F00               
                    ORA        #$1066               
                    STA        $A0,S                
                    LDA        $A3,S                
                    AND        #$00F0               
                    ORA        #$3303               
                    STA        $A3,S                
                    LDA        $A9,S                
                    AND        #$0F00               
                    ORA        #$6061               
                    STA        $A9,S                
                    PEA        $3363                
                    PEA        $6666                
                    PHX                             
                    PEA        $1313                
                    PHX                             
                    PEA        $1361                
                    TSC                             
                    ADC        #$0016               
                    TCS                             
                    PEA        $1616                
                    PHD                             
                    PEA        $3333                
                    TSC                             ; Line 20
                    ADC        #$009B               
                    TCS                             
                    LDA        $A9,S                
                    AND        #$0F00               
                    ORA        #$1016               
                    STA        $A9,S                
                    PEA        $3633                
                    PEA        $3331                
                    PHD                             
                    PHX                             
                    PEA        $6131                
                    PEA        $1116                
                    TSC                             
                    ADC        #$0015               
                    TCS                             
                    PEA        $1113                
                    PEA        $1333                
                    TSC                             ; Line 21
                    ADC        #$00A3               
                    TCS                             
                    SEP        #$20                 
                    LDA        $8D,S                
                    AND        #$F0                 
                    ORA        #$06                 
                    STA        $8D,S                
                    REP        #$30                 
                    PEA        $1631                
                    PEA        $3133                
                    PEA        $3333                
                    PEA        $7533                
                    PEA        $3331                
                    PEA        $1313                
                    PHX                             
                    PEA        $1116                
                    PEA        $1613                
                    PHY                             
                    TSC                             ; Line 22
                    ADC        #$00B5               
                    TCS                             
                    LDA        #$1361               
                    STA        $8D,S                
                    LDA        $8F,S                
                    AND        #$F00F               
                    ORA        #$0630               
                    STA        $8F,S                
                    SEP        #$20                 
                    LDA        #$16                 
                    STA        $91,S                
                    LDA        $8C,S                
                    AND        #$F0                 
                    ORA        #$01                 
                    STA        $8C,S                
                    LDA        $A0,S                
                    AND        #$0F                 
                    ORA        #$10                 
                    STA        $A0,S                
                    REP        #$30                 
                    PHY                             
                    PEA        $1113                
                    PEA        $1333                
                    PEA        $3375                
                    PHD                             
                    PEA        $3331                
                    PHX                             
                    PHY                             
                    PEA        $6131                
                    PEA        $3111                
                    TSC                             ; Line 23
                    ADC        #$00B3               
                    TCS                             
                    LDA        $8D,S                
                    AND        #$00F0               
                    ORA        #$1106               
                    STA        $8D,S                
                    LDA        $8F,S                
                    AND        #$0F00               
                    ORA        #$3031               
                    STA        $8F,S                
                    PEA        $1616                
                    PHD                             
                    PEA        $3133                
                    PEA        $7513                
                    PEA        $1313                
                    PEA        $1311                
                    PEA        $1616                
                    TSC                             ; Line 24
                    ADC        #$00AE               
                    TCS                             
                    LDA        $8D,S                
                    AND        #$00F0               
                    ORA        #$6101               
                    STA        $8D,S                
                    LDA        $8F,S                
                    AND        #$0F00               
                    ORA        #$3013               
                    STA        $8F,S                
                    LDA        $93,S                
                    AND        #$00F0               
                    ORA        #$1606               
                    STA        $93,S                
                    LDA        $9F,S                
                    AND        #$0F00               
                    ORA        #$1016               
                    STA        $9F,S                
                    PHY                             
                    PEA        $1113                
                    PEA        $1333                
                    PEA        $5137                
                    PHD                             
                    PEA        $1161                
                    PHY                             
                    TSC                             ; Line 25
                    ADC        #$00AC               
                    TCS                             
                    LDA        $8F,S                
                    AND        #$00F0               
                    ORA        #$1106               
                    STA        $8F,S                
                    LDA        $91,S                
                    AND        #$0F00               
                    ORA        #$3033               
                    STA        $91,S                
                    PEA        $1611                
                    PEA        $3133                
                    PEA        $1157                
                    PHX                             
                    PEA        $1116                
                    TSC                             ; Line 26
                    ADC        #$00AB               
                    TCS                             
                    LDA        $8E,S                
                    AND        #$00F0               
                    ORA        #$6101               
                    STA        $8E,S                
                    LDA        $90,S                
                    AND        #$0F00               
                    ORA        #$3013               
                    STA        $90,S                
                    LDA        $95,S                
                    AND        #$00F0               
                    ORA        #$1606               
                    STA        $95,S                
                    LDA        $9F,S                
                    AND        #$0F00               
                    ORA        #$1016               
                    STA        $9F,S                
                    PHY                             
                    PEA        $6111                
                    PEA        $3371                
                    PEA        $5517                
                    PEA        $1161                
                    PHY                             
                    TSC                             ; Line 27
                    ADC        #$00AA               
                    TCS                             
                    LDA        $90,S                
                    AND        #$00F0               
                    ORA        #$1106               
                    STA        $90,S                
                    LDA        $92,S                
                    AND        #$0F00               
                    ORA        #$3033               
                    STA        $92,S                
                    LDA        $A0,S                
                    AND        #$0F00               
                    ORA        #$6061               
                    STA        $A0,S                
                    PEA        $1636                
                    PEA        $3371                
                    PEA        $5577                
                    PEA        $7716                
                    TSC                             ; Line 28
                    ADC        #$00A7               
                    TCS                             
                    LDA        $91,S                
                    AND        #$00F0               
                    ORA        #$6101               
                    STA        $91,S                
                    LDA        $93,S                
                    AND        #$0F00               
                    ORA        #$3013               
                    STA        $93,S                
                    PEA        $6133                
                    PEA        $7715                
                    PEA        $5175                
                    PEA        $7761                
                    TSC                             ; Line 29
                    ADC        #$00A9               
                    TCS                             
                    LDA        #$3311               
                    STA        $91,S                
                    LDA        $99,S                
                    AND        #$00F0               
                    ORA        #$1606               
                    STA        $99,S                
                    LDA        $9F,S                
                    AND        #$0F00               
                    ORA        #$6061               
                    STA        $9F,S                
                    SEP        #$20                 
                    LDA        $90,S                
                    AND        #$F0                 
                    ORA        #$06                 
                    STA        $90,S                
                    REP        #$30                 
                    PEA        $1616                
                    PEA        $5375                
                    PEA        $1561                
                    PEA        $5175                
                    TSC                             ; Line 30
                    ADC        #$00A6               
                    TCS                             
                    LDA        #$1361               
                    STA        $93,S                
                    SEP        #$20                 
                    LDA        #$11                 
                    STA        $9B,S                
                    LDA        $92,S                
                    AND        #$F0                 
                    ORA        #$01                 
                    STA        $92,S                
                    REP        #$30                 
                    PEA        $3371                
                    PEA        $1516                
                    TSC                             ; Line 31
                    ADC        #$00A5               
                    TCS                             
                    LDA        #$3311               
                    STA        $92,S                
                    LDA        $9F,S                
                    AND        #$0F00               
                    ORA        #$1033               
                    STA        $9F,S                
                    SEP        #$20                 
                    LDA        $91,S                
                    AND        #$F0                 
                    ORA        #$06                 
                    STA        $91,S                
                    LDA        $9A,S                
                    AND        #$F0                 
                    ORA        #$06                 
                    STA        $9A,S                
                    REP        #$30                 
                    PEA        $1631                
                    PEA        $1315                
                    PHY                             
                    TSC                             ; Line 32
                    ADC        #$00A4               
                    TCS                             
                    LDA        $A1,S                
                    AND        #$0F00               
                    ORA        #$1033               
                    STA        $A1,S                
                    SEP        #$20                 
                    LDA        #$44                 
                    STA        $94,S                
                    REP        #$30                 
                    PEA        $1115                
                    PEA        $1616                
                    TSC                             ; Line 33
                    ADC        #$00A4               
                    TCS                             
                    LDA        #$3111               
                    STA        $9F,S                
                    LDA        $9D,S                
                    AND        #$00F0               
                    ORA        #$1606               
                    STA        $9D,S                
                    LDA        $A1,S                
                    AND        #$0F00               
                    ORA        #$1031               
                    STA        $A1,S                
                    SEP        #$20                 
                    LDA        #$44                 
                    STA        $94,S                
                    REP        #$30                 
                    PEA        $1311                
                    PHY                             
                    TSC                             ; Line 35
                    ADC        #$0137               
                    TCS                             
                    LDA        $A1,S                
                    AND        #$0FF0               
                    ORA        #$4004               
                    STA        $A1,S                
                    SEP        #$20                 
                    LDA        #$44                 
                    STA        $01,S                
                    LDA        $0A,S                
                    AND        #$F0                 
                    ORA        #$01                 
                    STA        $0A,S                
                    LDA        $AA,S                
                    AND        #$F0                 
                    ORA        #$06                 
                    STA        $AA,S                
                    REP        #$30                 
                    TSC                             
                    ADC        #$000E               
                    TCS                             
                    PEA        $3313                
                    PEA        $1161                
                    TSC                             ; Line 36
                    ADC        #$00A4               
                    TCS                             
                    PEA        $3331                
                    PEA        $3116                
                    TSC                             ; Line 37
                    ADC        #$00A4               
                    TCS                             
                    LDA        #$1116               
                    STA        $9D,S                
                    LDA        $9F,S                
                    AND        #$0F00               
                    ORA        #$3031               
                    STA        $9F,S                
                    PEA        $3313                
                    PEA        $1361                
                    TSC                             ; Line 39
                    ADC        #$0136               
                    TCS                             
                    LDA        #$1361               
                    STA        $0B,S                
                    LDA        #$1116               
                    STA        $AB,S                
                    LDA        $0D,S                
                    AND        #$0F00               
                    ORA        #$3013               
                    STA        $0D,S                
                    LDA        $AD,S                
                    AND        #$0F00               
                    ORA        #$3031               
                    STA        $AD,S                
                    TSC                             ; Line 41
                    ADC        #$0140               
                    TCS                             
                    LDA        #$6361               
                    STA        $0B,S                
                    LDA        #$3116               
                    STA        $AB,S                
                    LDA        $0D,S                
                    AND        #$0F00               
                    ORA        #$3013               
                    STA        $0D,S                
                    LDA        $AD,S                
                    AND        #$0F00               
                    ORA        #$3033               
                    STA        $AD,S                
                    TSC                             ; Line 43
                    ADC        #$0140               
                    TCS                             
                    LDA        #$1361               
                    STA        $0B,S                
                    LDA        #$3311               
                    STA        $AC,S                
                    LDA        $AA,S                
                    AND        #$00F0               
                    ORA        #$1606               
                    STA        $AA,S                
                    SEP        #$20                 
                    LDA        #$13                 
                    STA        $0D,S                
                    REP        #$30                 
                    TSC                             ; Line 45
                    ADC        #$0140               
                    TCS                             
                    LDA        #$1313               
                    STA        $0C,S                
                    LDA        #$1116               
                    STA        $AB,S                
                    LDA        $0A,S                
                    AND        #$00F0               
                    ORA        #$6101               
                    STA        $0A,S                
                    SEP        #$20                 
                    LDA        #$33                 
                    STA        $AD,S                
                    REP        #$30                 
                    TSC                             ; Line 47
                    ADC        #$0140               
                    TCS                             
                    LDA        #$1361               
                    STA        $0B,S                
                    LDA        #$1116               
                    STA        $AB,S                
                    LDA        $A3,S                
                    AND        #$F0F0               
                    ORA        #$0606               
                    STA        $A3,S                
                    LDA        $B2,S                
                    AND        #$F0F0               
                    ORA        #$0606               
                    STA        $B2,S                
                    SEP        #$20                 
                    LDA        #$33                 
                    STA        $0D,S                
                    LDA        $A5,S                
                    AND        #$F0                 
                    ORA        #$06                 
                    STA        $A5,S                
                    LDA        $AD,S                
                    AND        #$0F                 
                    ORA        #$30                 
                    STA        $AD,S                
                    LDA        $B4,S                
                    AND        #$F0                 
                    ORA        #$06                 
                    STA        $B4,S                
                    REP        #$30                 
                    TSC                             ; Line 49
                    ADC        #$0140               
                    TCS                             
                    TYA                             
                    STA        $0B,S                
                    LDA        $02,S                
                    AND        #$0F0F               
                    ORA        #$6060               
                    STA        $02,S                
                    LDA        $04,S                
                    AND        #$0F0F               
                    ORA        #$6060               
                    STA        $04,S                
                    LDA        $06,S                
                    AND        #$0F0F               
                    ORA        #$6060               
                    STA        $06,S                
                    LDA        $08,S                
                    AND        #$0F0F               
                    ORA        #$6060               
                    STA        $08,S                
                    LDA        $0F,S                
                    AND        #$0F0F               
                    ORA        #$6060               
                    STA        $0F,S                
                    LDA        $11,S                
                    AND        #$0F0F               
                    ORA        #$6060               
                    STA        $11,S                
                    LDA        $13,S                
                    AND        #$0F0F               
                    ORA        #$6060               
                    STA        $13,S                
                    LDA        $15,S                
                    AND        #$0F0F               
                    ORA        #$6060               
                    STA        $15,S                
                    LDA        $17,S                
                    AND        #$0F0F               
                    ORA        #$6060               
                    STA        $17,S                
                    LDA        $19,S                
                    AND        #$0F0F               
                    ORA        #$6060               
                    STA        $19,S                
                    LDA        $1B,S                
                    AND        #$0F0F               
                    ORA        #$6060               
                    STA        $1B,S                
                    LDA        $1D,S                
                    AND        #$0F0F               
                    ORA        #$6060               
                    STA        $1D,S                
                    LDA        $A1,S                
                    AND        #$F0F0               
                    ORA        #$0606               
                    STA        $A1,S                
                    LDA        $A3,S                
                    AND        #$F0F0               
                    ORA        #$0606               
                    STA        $A3,S                
                    LDA        $A5,S                
                    AND        #$F0F0               
                    ORA        #$0606               
                    STA        $A5,S                
                    LDA        $A7,S                
                    AND        #$F0F0               
                    ORA        #$0606               
                    STA        $A7,S                
                    LDA        $A9,S                
                    AND        #$F0F0               
                    ORA        #$0606               
                    STA        $A9,S                
                    LDA        $AB,S                
                    AND        #$00F0               
                    ORA        #$4404               
                    STA        $AB,S                
                    LDA        $AE,S                
                    AND        #$F0F0               
                    ORA        #$0606               
                    STA        $AE,S                
                    LDA        $B0,S                
                    AND        #$F0F0               
                    ORA        #$0606               
                    STA        $B0,S                
                    LDA        $B2,S                
                    AND        #$F0F0               
                    ORA        #$0606               
                    STA        $B2,S                
                    LDA        $B4,S                
                    AND        #$F0F0               
                    ORA        #$0606               
                    STA        $B4,S                
                    LDA        $B6,S                
                    AND        #$F0F0               
                    ORA        #$0606               
                    STA        $B6,S                
                    LDA        $B8,S                
                    AND        #$F0F0               
                    ORA        #$0606               
                    STA        $B8,S                
                    LDA        $BA,S                
                    AND        #$F0F0               
                    ORA        #$0606               
                    STA        $BA,S                
                    LDA        $BC,S                
                    AND        #$F0F0               
                    ORA        #$0606               
                    STA        $BC,S                
                    SEP        #$20                 
                    LDA        $0D,S                
                    AND        #$0F                 
                    ORA        #$30                 
                    STA        $0D,S                
                    LDA        $AD,S                
                    AND        #$F0                 
                    ORA        #$06                 
                    STA        $AD,S                
                    REP        #$30                 
                    TSC                             ; Line 51
                    ADC        #$0140               
                    TCS                             
                    LDA        #$4444               
                    STA        $0B,S                
                    LDA        $03,S                
                    AND        #$0F0F               
                    ORA        #$6060               
                    STA        $03,S                
                    LDA        $05,S                
                    AND        #$0F0F               
                    ORA        #$6060               
                    STA        $05,S                
                    LDA        $07,S                
                    AND        #$0F0F               
                    ORA        #$6060               
                    STA        $07,S                
                    LDA        $09,S                
                    AND        #$000F               
                    ORA        #$6460               
                    STA        $09,S                
                    LDA        $0D,S                
                    AND        #$0F0F               
                    ORA        #$6060               
                    STA        $0D,S                
                    LDA        $0F,S                
                    AND        #$0F0F               
                    ORA        #$6060               
                    STA        $0F,S                
                    LDA        $11,S                
                    AND        #$0F0F               
                    ORA        #$6060               
                    STA        $11,S                
                    LDA        $13,S                
                    AND        #$0F0F               
                    ORA        #$6060               
                    STA        $13,S                
                    LDA        $15,S                
                    AND        #$0F0F               
                    ORA        #$6060               
                    STA        $15,S                
                    LDA        $17,S                
                    AND        #$0F0F               
                    ORA        #$6060               
                    STA        $17,S                
                    LDA        $19,S                
                    AND        #$0F0F               
                    ORA        #$6060               
                    STA        $19,S                
                    LDA        $A3,S                
                    AND        #$F0F0               
                    ORA        #$0606               
                    STA        $A3,S                
                    LDA        $A5,S                
                    AND        #$F0F0               
                    ORA        #$0606               
                    STA        $A5,S                
                    LDA        $A9,S                
                    AND        #$00F0               
                    ORA        #$4404               
                    STA        $A9,S                
                    LDA        $AB,S                
                    AND        #$F000               
                    ORA        #$0644               
                    STA        $AB,S                
                    LDA        $AD,S                
                    AND        #$F0F0               
                    ORA        #$0606               
                    STA        $AD,S                
                    LDA        $AF,S                
                    AND        #$F0F0               
                    ORA        #$0606               
                    STA        $AF,S                
                    LDA        $B1,S                
                    AND        #$F0F0               
                    ORA        #$0606               
                    STA        $B1,S                
                    LDA        $B3,S                
                    AND        #$F0F0               
                    ORA        #$0606               
                    STA        $B3,S                
*--                                                 
                    LDAL       $E1C068              ; Direct Page and Stack in Bank 00/
                    AND        #$FFCF               
                    STAL       $E1C068              
                    LDA        StackAddress         ; Restore Stack
                    TCS                             
                    PLD                             ; Restore Direct Page
                    CLI                             ; Enable Interrupts
                    PLB
                    RTL                             
                                                    
*-----------------------------------                                
Sprite_RR_04D       CLC                             ; Sprite #04D : 48x56, 1942 bytes, 3118 cycles
                    SEI                             ; Disable Interrupts
                    PHD                             ; Backup Direct Page
                    TSC                             ; Backup Stack
                    STA        StackAddress         
                    LDAL       $E1C068              ; Direct Page and Stack in Bank 01/
                    ORA        #$0030               
                    STAL       $E1C068              
                    TYA                             ; Y = Sprite Target Screen Address (upper left corner)
                    TCS                             ; New Stack address
                    LDX        #$6161               ; Pattern #1 : 28
                    LDY        #$1116               ; Pattern #2 : 16
                    LDA        #$1616               ; Pattern #3 : 15
                    TCD                             
*--                                                 
                    LDA        #$6666               ; Line 0
                    STA        $07,S                
                    STA        $A8,S                
                    LDA        $A6,S                
                    AND        #$00F0               
                    ORA        #$6606               
                    STA        $A6,S                
                    TSC                             ; Line 2
                    ADC        #$0149               
                    TCS                             
                    SEP        #$20                 
                    LDA        $01,S                
                    AND        #$0F                 
                    ORA        #$60                 
                    STA        $01,S                
                    LDA        $A1,S                
                    AND        #$0F                 
                    ORA        #$50                 
                    STA        $A1,S                
                    REP        #$30                 
                    PEA        $6666                
                    PEA        $6666                
                    TSC                             ; Line 3
                    ADC        #$00A4               
                    TCS                             
                    SEP        #$20                 
                    LDA        $A1,S                
                    AND        #$0F                 
                    ORA        #$50                 
                    STA        $A1,S                
                    REP        #$30                 
                    PEA        $5555                
                    PEA        $5555                
                    TSC                             ; Line 4
                    ADC        #$00A4               
                    TCS                             
                    SEP        #$20                 
                    LDA        $A1,S                
                    AND        #$0F                 
                    ORA        #$40                 
                    STA        $A1,S                
                    REP        #$30                 
                    PEA        $5555                
                    PEA        $5555                
                    TSC                             ; Line 5
                    ADC        #$00A4               
                    TCS                             
                    SEP        #$20                 
                    LDA        $A1,S                
                    AND        #$0F                 
                    ORA        #$40                 
                    STA        $A1,S                
                    REP        #$30                 
                    PEA        $4464                
                    PEA        $6666                
                    TSC                             ; Line 6
                    ADC        #$00A4               
                    TCS                             
                    SEP        #$20                 
                    LDA        #$44                 
                    STA        $A1,S                
                    REP        #$30                 
                    PEA        $6664                
                    PEA        $6666                
                    TSC                             ; Line 7
                    ADC        #$00A4               
                    TCS                             
                    SEP        #$20                 
                    LDA        $9D,S                
                    AND        #$F0                 
                    ORA        #$06                 
                    STA        $9D,S                
                    REP        #$30                 
                    PEA        $4464                
                    PEA        $6466                
                    TSC                             ; Line 8
                    ADC        #$00A5               
                    TCS                             
                    LDA        #$4464               
                    STA        $9D,S                
                    LDA        $9F,S                
                    AND        #$0F00               
                    ORA        #$4044               
                    STA        $9F,S                
                    SEP        #$20                 
                    LDA        $9C,S                
                    AND        #$F0                 
                    ORA        #$06                 
                    STA        $9C,S                
                    REP        #$30                 
                    PEA        $4444                
                    PEA        $4464                
                    TSC                             ; Line 10
                    ADC        #$013A               
                    TCS                             
                    LDA        #$4444               
                    STA        $07,S                
                    STA        $A7,S                
                    LDA        #$4413               
                    STA        $A6,S                
                    LDA        $09,S                
                    AND        #$0F00               
                    ORA        #$4044               
                    STA        $09,S                
                    LDA        $A9,S                
                    AND        #$FF0F               
                    ORA        #$0040               
                    STA        $A9,S                
                    TSC                             ; Line 12
                    ADC        #$0140               
                    TCS                             
                    LDA        #$4444               
                    STA        $07,S                
                    LDA        $05,S                
                    AND        #$00F0               
                    ORA        #$1306               
                    STA        $05,S                
                    LDA        $09,S                
                    AND        #$0F00               
                    ORA        #$1011               
                    STA        $09,S                
                    TSC                             ; Line 13
                    ADC        #$00AA               
                    TCS                             
                    LDA        $9A,S                
                    AND        #$00F0               
                    ORA        #$1606               
                    STA        $9A,S                
                    LDA        $A0,S                
                    AND        #$0F00               
                    ORA        #$1011               
                    STA        $A0,S                
                    PEA        $1161                
                    PEA        $4433                
                    PEA        $1361                
                    TSC                             ; Line 14
                    ADC        #$00A5               
                    TCS                             
                    PEA        $4644                
                    PEA        $3311                
                    TSC                             ; Line 15
                    ADC        #$00A6               
                    TCS                             
                    LDA        $98,S                
                    AND        #$00F0               
                    ORA        #$1606               
                    STA        $98,S                
                    LDA        $A0,S                
                    AND        #$0F00               
                    ORA        #$3011               
                    STA        $A0,S                
                    PEA        $1161                
                    PEA        $4124                
                    PEA        $1316                
                    PHX                             
                    TSC                             ; Line 16
                    ADC        #$00A7               
                    TCS                             
                    PEA        $1644                
                    PEA        $3261                
                    PHY                             
                    TSC                             ; Line 17
                    ADC        #$00A8               
                    TCS                             
                    LDA        $96,S                
                    AND        #$00F0               
                    ORA        #$1606               
                    STA        $96,S                
                    LDA        $A0,S                
                    AND        #$0F00               
                    ORA        #$3011               
                    STA        $A0,S                
                    PEA        $1361                
                    PEA        $6124                
                    PEA        $1316                
                    PEA        $1111                
                    PHX                             
                    TSC                             ; Line 18
                    ADC        #$00A9               
                    TCS                             
                    PHY                             
                    PEA        $3261                
                    PEA        $1113                
                    PEA        $1311                
                    TSC                             ; Line 19
                    ADC        #$00AA               
                    TCS                             
                    LDA        $94,S                
                    AND        #$00F0               
                    ORA        #$1606               
                    STA        $94,S                
                    LDA        $A0,S                
                    AND        #$0F00               
                    ORA        #$3013               
                    STA        $A0,S                
                    PEA        $3361                
                    PEA        $6131                
                    PEA        $1316                
                    PEA        $3131                
                    PEA        $3111                
                    PHX                             
                    TSC                             ; Line 20
                    ADC        #$00AB               
                    TCS                             
                    LDA        $A2,S                
                    AND        #$0F00               
                    ORA        #$3033               
                    STA        $A2,S                
                    SEP        #$20                 
                    LDA        $95,S                
                    AND        #$F0                 
                    ORA        #$01                 
                    STA        $95,S                
                    REP        #$30                 
                    PHD                             
                    PEA        $3161                
                    PEA        $1113                
                    PEA        $1313                
                    PEA        $1311                
                    TSC                             ; Line 21
                    ADC        #$00AB               
                    TCS                             
                    PHX                             
                    PEA        $1133                
                    PEA        $1633                
                    PEA        $1111                
                    PEA        $1131                
                    PEA        $1161                
                    TSC                             ; Line 22
                    ADC        #$00AF               
                    TCS                             
                    LDA        #$1161               
                    STA        $91,S                
                    LDA        $93,S                
                    AND        #$F00F               
                    ORA        #$0630               
                    STA        $93,S                
                    SEP        #$20                 
                    LDA        #$16                 
                    STA        $95,S                
                    LDA        $A3,S                
                    AND        #$0F                 
                    ORA        #$40                 
                    STA        $A3,S                
                    REP        #$30                 
                    PEA        $3333                
                    PHY                             
                    PEA        $1636                
                    PEA        $1333                
                    PEA        $1313                
                    PEA        $6111                
                    PEA        $1113                
                    PHY                             
                    TSC                             ; Line 23
                    ADC        #$00AB               
                    TCS                             
                    LDA        #$1316               
                    STA        $96,S                
                    SEP        #$20                 
                    LDA        #$61                 
                    STA        $A0,S                
                    LDA        $95,S                
                    AND        #$F0                 
                    ORA        #$06                 
                    STA        $95,S                
                    LDA        $A2,S                
                    AND        #$F0                 
                    ORA        #$06                 
                    STA        $A2,S                
                    REP        #$30                 
                    PEA        $3136                
                    PEA        $3331                
                    PHY                             
                    TSC                             
                    ADC        #$000D               
                    TCS                             
                    PEA        $4433                
                    PEA        $3311                
                    PHX                             
                    TSC                             ; Line 24
                    ADC        #$009E               
                    TCS                             
                    LDA        #$3161               
                    STA        $97,S                
                    SEP        #$20                 
                    LDA        #$31                 
                    STA        $A1,S                
                    LDA        #$44                 
                    STA        $A8,S                
                    LDA        $96,S                
                    AND        #$F0                 
                    ORA        #$01                 
                    STA        $96,S                
                    REP        #$30                 
                    PEA        $3333                
                    PEA        $1361                
                    PHX                             
                    TSC                             
                    ADC        #$000F               
                    TCS                             
                    PEA        $4444                
                    PEA        $1313                
                    PEA        $1316                
                    TSC                             ; Line 25
                    ADC        #$009D               
                    TCS                             
                    LDA        #$1316               
                    STA        $96,S                
                    TDC                             
                    STA        $A6,S                
                    LDA        $A4,S                
                    AND        #$00F0               
                    ORA        #$1601               
                    STA        $A4,S                
                    SEP        #$20                 
                    LDA        #$31                 
                    STA        $A1,S                
                    LDA        $98,S                
                    AND        #$0F                 
                    ORA        #$10                 
                    STA        $98,S                
                    REP        #$30                 
                    PEA        $3331                
                    PHY                             
                    PHD                             
                    TSC                             
                    ADC        #$000D               
                    TCS                             
                    PHX                             
                    PHX                             
                    TSC                             ; Line 26
                    ADC        #$009D               
                    TCS                             
                    LDA        #$3161               
                    STA        $96,S                
                    SEP        #$20                 
                    LDA        $98,S                
                    AND        #$0F                 
                    ORA        #$30                 
                    STA        $98,S                
                    LDA        $A1,S                
                    AND        #$0F                 
                    ORA        #$30                 
                    STA        $A1,S                
                    REP        #$30                 
                    PEA        $3313                
                    PEA        $1161                
                    PHX                             
                    TSC                             ; Line 27
                    ADC        #$00A6               
                    TCS                             
                    LDA        #$1316               
                    STA        $96,S                
                    SEP        #$20                 
                    LDA        #$55                 
                    STA        $A1,S                
                    REP        #$30                 
                    PEA        $3331                
                    PEA        $1111                
                    PEA        $1677                
                    TSC                             ; Line 28
                    ADC        #$00A6               
                    TCS                             
                    LDA        $96,S                
                    AND        #$0F00               
                    ORA        #$3061               
                    STA        $96,S                
                    SEP        #$20                 
                    LDA        #$57                 
                    STA        $A1,S                
                    REP        #$30                 
                    PEA        $3313                
                    PEA        $7777                
                    PEA        $5755                
                    TSC                             ; Line 29
                    ADC        #$00A6               
                    TCS                             
                    SEP        #$20                 
                    LDA        #$43                 
                    STA        $96,S                
                    LDA        #$11                 
                    STA        $A1,S                
                    REP        #$30                 
                    PEA        $5755                
                    PEA        $5555                
                    PEA        $6561                
                    TSC                             ; Line 30
                    ADC        #$00A6               
                    TCS                             
                    LDA        $A1,S                
                    AND        #$0F00               
                    ORA        #$3073               
                    STA        $A1,S                
                    SEP        #$20                 
                    LDA        #$44                 
                    STA        $96,S                
                    LDA        $9A,S                
                    AND        #$F0                 
                    ORA        #$01                 
                    STA        $9A,S                
                    REP        #$30                 
                    PEA        $5115                
                    PHY                             
                    PHD                             
                    TSC                             ; Line 31
                    ADC        #$00A6               
                    TCS                             
                    SEP        #$20                 
                    LDA        #$44                 
                    STA        $96,S                
                    LDA        $9A,S                
                    AND        #$F0                 
                    ORA        #$06                 
                    STA        $9A,S                
                    REP        #$30                 
                    PEA        $7515                
                    PEA        $1113                
                    PHX                             
                    TSC                             ; Line 32
                    ADC        #$00A8               
                    TCS                             
                    LDA        $98,S                
                    AND        #$00F0               
                    ORA        #$6101               
                    STA        $98,S                
                    SEP        #$20                 
                    LDA        $94,S                
                    AND        #$F0                 
                    ORA        #$04                 
                    STA        $94,S                
                    REP        #$30                 
                    PEA        $3351                
                    PEA        $1157                
                    PEA        $3131                
                    PHY                             
                    TSC                             ; Line 33
                    ADC        #$00A9               
                    TCS                             
                    LDA        $A0,S                
                    AND        #$0F00               
                    ORA        #$3013               
                    STA        $A0,S                
                    SEP        #$20                 
                    LDA        $97,S                
                    AND        #$F0                 
                    ORA        #$06                 
                    STA        $97,S                
                    REP        #$30                 
                    PEA        $3311                
                    PEA        $5117                
                    PEA        $7335                
                    PEA        $1361                
                    TSC                             ; Line 34
                    ADC        #$00A7               
                    TCS                             
                    LDA        $98,S                
                    AND        #$00F0               
                    ORA        #$6101               
                    STA        $98,S                
                    LDA        $A2,S                
                    AND        #$0F00               
                    ORA        #$3013               
                    STA        $A2,S                
                    PEA        $1311                
                    PEA        $1173                
                    PEA        $3531                
                    PHY                             
                    TSC                             ; Line 35
                    ADC        #$00A9               
                    TCS                             
                    LDA        $97,S                
                    AND        #$00F0               
                    ORA        #$1606               
                    STA        $97,S                
                    PEA        $3311                
                    PEA        $1631                
                    PEA        $1135                
                    PEA        $1311                
                    TSC                             ; Line 36
                    ADC        #$00AA               
                    TCS                             
                    LDA        $A0,S                
                    AND        #$0F00               
                    ORA        #$3012               
                    STA        $A0,S                
                    PEA        $3331                
                    PEA        $1161                
                    PHX                             
                    PEA        $1333                
                    PEA        $3111                
                    TSC                             ; Line 37
                    ADC        #$00A9               
                    TCS                             
                    SEP        #$20                 
                    LDA        $A3,S                
                    AND        #$0F                 
                    ORA        #$20                 
                    STA        $A3,S                
                    REP        #$30                 
                    PEA        $1316                
                    PHD                             
                    PEA        $1633                
                    PEA        $1313                
                    PEA        $1161                
                    TSC                             ; Line 38
                    ADC        #$00AC               
                    TCS                             
                    SEP        #$20                 
                    LDA        $99,S                
                    AND        #$0F                 
                    ORA        #$10                 
                    STA        $99,S                
                    LDA        $9B,S                
                    AND        #$F0                 
                    ORA        #$06                 
                    STA        $9B,S                
                    REP        #$30                 
                    PEA        $2331                
                    PHX                             
                    PHX                             
                    PEA        $6131                
                    PEA        $3331                
                    PHY                             
                    TSC                             ; Line 39
                    ADC        #$00A4               
                    TCS                             
                    LDA        $A9,S                
                    AND        #$0F00               
                    ORA        #$2031               
                    STA        $A9,S                
                    SEP        #$20                 
                    LDA        $A1,S                
                    AND        #$0F                 
                    ORA        #$30                 
                    STA        $A1,S                
                    REP        #$30                 
                    PEA        $1313                
                    PEA        $1161                
                    TSC                             
                    ADC        #$000D               
                    TCS                             
                    PEA        $3212                
                    PEA        $1316                
                    PHD                             
                    TSC                             ; Line 40
                    ADC        #$009D               
                    TCS                             
                    LDA        $AA,S                
                    AND        #$0F00               
                    ORA        #$3013               
                    STA        $AA,S                
                    SEP        #$20                 
                    LDA        $A5,S                
                    AND        #$F0                 
                    ORA        #$06                 
                    STA        $A5,S                
                    REP        #$30                 
                    PEA        $3231                
                    PHY                             
                    TSC                             
                    ADC        #$000C               
                    TCS                             
                    PEA        $1161                
                    PHX                             
                    TSC                             ; Line 41
                    ADC        #$009C               
                    TCS                             
                    LDA        $AB,S                
                    AND        #$0F00               
                    ORA        #$3033               
                    STA        $AB,S                
                    SEP        #$20                 
                    LDA        $A6,S                
                    AND        #$F0                 
                    ORA        #$01                 
                    STA        $A6,S                
                    REP        #$30                 
                    PEA        $3313                
                    PEA        $1361                
                    TSC                             
                    ADC        #$000D               
                    TCS                             
                    PEA        $1316                
                    PHD                             
                    TSC                             ; Line 42
                    ADC        #$009B               
                    TCS                             
                    LDA        $AC,S                
                    AND        #$0F00               
                    ORA        #$3033               
                    STA        $AC,S                
                    PEA        $2333                
                    PHY                             
                    TSC                             
                    ADC        #$000E               
                    TCS                             
                    PEA        $3161                
                    PHX                             
                    TSC                             ; Line 43
                    ADC        #$009A               
                    TCS                             
                    SEP        #$20                 
                    LDA        $A9,S                
                    AND        #$F0                 
                    ORA        #$01                 
                    STA        $A9,S                
                    REP        #$30                 
                    PEA        $3332                
                    PEA        $1161                
                    TSC                             
                    ADC        #$000F               
                    TCS                             
                    PEA        $1313                
                    PHD                             
                    TSC                             ; Line 44
                    ADC        #$0099               
                    TCS                             
                    SEP        #$20                 
                    LDA        #$16                 
                    STA        $AA,S                
                    REP        #$30                 
                    PEA        $2323                
                    PEA        $1316                
                    TSC                             
                    ADC        #$0011               
                    TCS                             
                    PEA        $3431                
                    PHX                             
                    TSC                             ; Line 45
                    ADC        #$0097               
                    TCS                             
                    TYA                             
                    STA        $9D,S                
                    TXA                             
                    STA        $AB,S                
                    LDA        $9F,S                
                    AND        #$0F00               
                    ORA        #$3023               
                    STA        $9F,S                
                    LDA        $AE,S                
                    AND        #$0F00               
                    ORA        #$4044               
                    STA        $AE,S                
                    SEP        #$20                 
                    LDA        $AD,S                
                    AND        #$F0                 
                    ORA        #$04                 
                    STA        $AD,S                
                    REP        #$30                 
                    PEA        $3332                
                    PEA        $3361                
                    TSC                             
                    ADC        #$0012               
                    TCS                             
                    PEA        $4444                
                    PEA        $1316                
                    TSC                             ; Line 47
                    ADC        #$012E               
                    TCS                             
                    TXA                             
                    STA        $05,S                
                    LDA        #$4444               
                    STA        $16,S                
                    TYA                             
                    STA        $A5,S                
                    LDA        $07,S                
                    AND        #$0F00               
                    ORA        #$3013               
                    STA        $07,S                
                    LDA        $A7,S                
                    AND        #$0F00               
                    ORA        #$3031               
                    STA        $A7,S                
                    SEP        #$20                 
                    LDA        #$16                 
                    STA        $14,S                
                    REP        #$30                 
                    TSC                             ; Line 49
                    ADC        #$0140               
                    TCS                             
                    LDA        $05,S                
                    AND        #$00F0               
                    ORA        #$6101               
                    STA        $05,S                
                    LDA        $07,S                
                    AND        #$0F00               
                    ORA        #$3013               
                    STA        $07,S                
                    LDA        $A5,S                
                    AND        #$00F0               
                    ORA        #$1106               
                    STA        $A5,S                
                    LDA        $A7,S                
                    AND        #$0F00               
                    ORA        #$3033               
                    STA        $A7,S                
                    TSC                             ; Line 51
                    ADC        #$0140               
                    TCS                             
                    LDA        #$1361               
                    STA        $06,S                
                    LDA        #$1316               
                    STA        $A6,S                
                    LDA        $AA,S                
                    AND        #$F0F0               
                    ORA        #$0606               
                    STA        $AA,S                
                    LDA        $AC,S                
                    AND        #$F0F0               
                    ORA        #$0606               
                    STA        $AC,S                
                    LDA        $AE,S                
                    AND        #$F0F0               
                    ORA        #$0606               
                    STA        $AE,S                
                    SEP        #$20                 
                    LDA        $05,S                
                    AND        #$F0                 
                    ORA        #$01                 
                    STA        $05,S                
                    LDA        $A5,S                
                    AND        #$F0                 
                    ORA        #$06                 
                    STA        $A5,S                
                    REP        #$30                 
                    TSC                             ; Line 53
                    ADC        #$0140               
                    TCS                             
                    LDA        #$4444               
                    STA        $A5,S                
                    LDA        $01,S                
                    AND        #$0F0F               
                    ORA        #$6060               
                    STA        $01,S                
                    LDA        $03,S                
                    AND        #$0F0F               
                    ORA        #$6060               
                    STA        $03,S                
                    LDA        $06,S                
                    AND        #$0F00               
                    ORA        #$4044               
                    STA        $06,S                
                    LDA        $08,S                
                    AND        #$0F0F               
                    ORA        #$6060               
                    STA        $08,S                
                    LDA        $0A,S                
                    AND        #$0F0F               
                    ORA        #$6060               
                    STA        $0A,S                
                    LDA        $0C,S                
                    AND        #$0F0F               
                    ORA        #$6060               
                    STA        $0C,S                
                    LDA        $0E,S                
                    AND        #$0F0F               
                    ORA        #$6060               
                    STA        $0E,S                
                    LDA        $10,S                
                    AND        #$0F0F               
                    ORA        #$6060               
                    STA        $10,S                
                    LDA        $12,S                
                    AND        #$0F0F               
                    ORA        #$6060               
                    STA        $12,S                
                    LDA        $14,S                
                    AND        #$0F0F               
                    ORA        #$6060               
                    STA        $14,S                
                    LDA        $16,S                
                    AND        #$0F0F               
                    ORA        #$6060               
                    STA        $16,S                
                    LDA        $A0,S                
                    AND        #$F0F0               
                    ORA        #$0606               
                    STA        $A0,S                
                    LDA        $A2,S                
                    AND        #$F0F0               
                    ORA        #$0606               
                    STA        $A2,S                
                    LDA        $A7,S                
                    AND        #$F000               
                    ORA        #$0646               
                    STA        $A7,S                
                    LDA        $A9,S                
                    AND        #$F0F0               
                    ORA        #$0606               
                    STA        $A9,S                
                    LDA        $AB,S                
                    AND        #$F0F0               
                    ORA        #$0606               
                    STA        $AB,S                
                    LDA        $AD,S                
                    AND        #$F0F0               
                    ORA        #$0606               
                    STA        $AD,S                
                    LDA        $AF,S                
                    AND        #$F0F0               
                    ORA        #$0606               
                    STA        $AF,S                
                    LDA        $B1,S                
                    AND        #$F0F0               
                    ORA        #$0606               
                    STA        $B1,S                
                    LDA        $B3,S                
                    AND        #$F0F0               
                    ORA        #$0606               
                    STA        $B3,S                
                    LDA        $B5,S                
                    AND        #$F0F0               
                    ORA        #$0606               
                    STA        $B5,S                
                    SEP        #$20                 
                    LDA        $A4,S                
                    AND        #$F0                 
                    ORA        #$06                 
                    STA        $A4,S                
                    REP        #$30                 
                    TSC                             ; Line 55
                    ADC        #$0140               
                    TCS                             
                    LDA        #$4444               
                    STA        $04,S                
                    LDA        $01,S                
                    AND        #$0F0F               
                    ORA        #$6060               
                    STA        $01,S                
                    LDA        $07,S                
                    AND        #$0F0F               
                    ORA        #$6060               
                    STA        $07,S                
                    LDA        $09,S                
                    AND        #$0F0F               
                    ORA        #$6060               
                    STA        $09,S                
                    LDA        $0B,S                
                    AND        #$0F0F               
                    ORA        #$6060               
                    STA        $0B,S                
                    LDA        $0D,S                
                    AND        #$0F0F               
                    ORA        #$6060               
                    STA        $0D,S                
                    LDA        $0F,S                
                    AND        #$0F0F               
                    ORA        #$6060               
                    STA        $0F,S                
                    LDA        $11,S                
                    AND        #$0F0F               
                    ORA        #$6060               
                    STA        $11,S                
                    SEP        #$20                 
                    LDA        $06,S                
                    AND        #$0F                 
                    ORA        #$40                 
                    STA        $06,S                
                    REP        #$30                 
*--                                                 
                    LDAL       $E1C068              ; Direct Page and Stack in Bank 00/
                    AND        #$FFCF               
                    STAL       $E1C068              
                    LDA        StackAddress         ; Restore Stack
                    TCS                             
                    PLD                             ; Restore Direct Page
                    CLI                             ; Enable Interrupts
                    PLB
                    RTL                             
                                                    
*-----------------------------------                                
Sprite_RR_04E       CLC                             ; Sprite #04E : 40x53, 1764 bytes, 2823 cycles
                    SEI                             ; Disable Interrupts
                    PHD                             ; Backup Direct Page
                    TSC                             ; Backup Stack
                    STA        StackAddress         
                    LDAL       $E1C068              ; Direct Page and Stack in Bank 01/
                    ORA        #$0030               
                    STAL       $E1C068              
                    TYA                             ; Y = Sprite Target Screen Address (upper left corner)
                    TCS                             ; New Stack address
                    LDX        #$6161               ; Pattern #1 : 19
                    LDY        #$1616               ; Pattern #2 : 12
                    LDA        #$4444               ; Pattern #3 : 12
                    TCD                             
*--                                                 
                    LDA        #$6666               ; Line 0
                    STA        $A5,S                
                    LDA        $05,S                
                    AND        #$00F0               
                    ORA        #$6606               
                    STA        $05,S                
                    LDA        $A7,S                
                    AND        #$0F00               
                    ORA        #$6066               
                    STA        $A7,S                
                    SEP        #$20                 
                    LDA        $07,S                
                    AND        #$0F                 
                    ORA        #$60                 
                    STA        $07,S                
                    REP        #$30                 
                    TSC                             ; Line 2
                    ADC        #$0140               
                    TCS                             
                    SEP        #$20                 
                    LDA        $04,S                
                    AND        #$F0                 
                    ORA        #$06                 
                    STA        $04,S                
                    LDA        $A4,S                
                    AND        #$F0                 
                    ORA        #$05                 
                    STA        $A4,S                
                    REP        #$30                 
                    TSC                             
                    ADC        #$0008               
                    TCS                             
                    PEA        $6666                
                    PEA        $6666                
                    TSC                             ; Line 3
                    ADC        #$00A4               
                    TCS                             
                    SEP        #$20                 
                    LDA        $9C,S                
                    AND        #$F0                 
                    ORA        #$05                 
                    STA        $9C,S                
                    REP        #$30                 
                    PEA        $5555                
                    PEA        $5555                
                    TSC                             ; Line 4
                    ADC        #$00A4               
                    TCS                             
                    SEP        #$20                 
                    LDA        $9C,S                
                    AND        #$F0                 
                    ORA        #$06                 
                    STA        $9C,S                
                    REP        #$30                 
                    PEA        $5555                
                    PEA        $5555                
                    TSC                             ; Line 5
                    ADC        #$00A4               
                    TCS                             
                    SEP        #$20                 
                    LDA        $9C,S                
                    AND        #$F0                 
                    ORA        #$06                 
                    STA        $9C,S                
                    REP        #$30                 
                    PHD                             
                    PEA        $6666                
                    TSC                             ; Line 6
                    ADC        #$00A4               
                    TCS                             
                    LDA        #$4446               
                    STA        $9E,S                
                    LDA        $9C,S                
                    AND        #$00F0               
                    ORA        #$6606               
                    STA        $9C,S                
                    LDA        $A0,S                
                    AND        #$0F00               
                    ORA        #$4044               
                    STA        $A0,S                
                    PEA        $6446                
                    PEA        $6666                
                    TSC                             ; Line 8
                    ADC        #$0144               
                    TCS                             
                    SEP        #$20                 
                    LDA        $01,S                
                    AND        #$0F                 
                    ORA        #$40                 
                    STA        $01,S                
                    REP        #$30                 
                    PHD                             
                    PEA        $4466                
                    TSC                             ; Line 9
                    ADC        #$00A4               
                    TCS                             
                    TDC                             
                    STA        $9F,S                
                    LDA        $9D,S                
                    AND        #$00F0               
                    ORA        #$4404               
                    STA        $9D,S                
                    PHD                             
                    PEA        $4466                
                    TSC                             ; Line 11
                    ADC        #$013C               
                    TCS                             
                    TDC                             
                    STA        $06,S                
                    SEP        #$20                 
                    LDA        #$34                 
                    STA        $05,S                
                    LDA        $A4,S                
                    AND        #$F0                 
                    ORA        #$03                 
                    STA        $A4,S                
                    REP        #$30                 
                    TSC                             ; Line 12
                    ADC        #$00A8               
                    TCS                             
                    LDA        $A0,S                
                    AND        #$0F00               
                    ORA        #$1013               
                    STA        $A0,S                
                    SEP        #$20                 
                    LDA        $9B,S                
                    AND        #$F0                 
                    ORA        #$03                 
                    STA        $9B,S                
                    REP        #$30                 
                    PEA        $3141                
                    PEA        $4423                
                    TSC                             ; Line 13
                    ADC        #$00A3               
                    TCS                             
                    SEP        #$20                 
                    LDA        #$21                 
                    STA        $A2,S                
                    REP        #$30                 
                    PEA        $4634                
                    PEA        $3261                
                    TSC                             ; Line 14
                    ADC        #$00A5               
                    TCS                             
                    LDA        $9A,S                
                    AND        #$00F0               
                    ORA        #$1101               
                    STA        $9A,S                
                    PEA        $6144                
                    PEA        $2313                
                    PEA        $3611                
                    TSC                             ; Line 15
                    ADC        #$00A7               
                    TCS                             
                    LDA        $A0,S                
                    AND        #$0F00               
                    ORA        #$2061               
                    STA        $A0,S                
                    SEP        #$20                 
                    LDA        $99,S                
                    AND        #$F0                 
                    ORA        #$06                 
                    STA        $99,S                
                    REP        #$30                 
                    PEA        $1216                
                    PEA        $3432                
                    PEA        $6113                
                    TSC                             ; Line 16
                    ADC        #$00A5               
                    TCS                             
                    SEP        #$20                 
                    LDA        #$33                 
                    STA        $A2,S                
                    REP        #$30                 
                    PEA        $4123                
                    PEA        $1336                
                    PEA        $1111                
                    TSC                             ; Line 17
                    ADC        #$00A7               
                    TCS                             
                    LDA        $A1,S                
                    AND        #$0F00               
                    ORA        #$3013               
                    STA        $A1,S                
                    PEA        $6134                
                    PEA        $3261                
                    PEA        $1311                
                    PHX                             
                    TSC                             ; Line 18
                    ADC        #$00A8               
                    TCS                             
                    LDA        $A1,S                
                    AND        #$0F00               
                    ORA        #$3011               
                    STA        $A1,S                
                    PEA        $4623                
                    PEA        $1336                
                    PEA        $1111                
                    PEA        $1116                
                    TSC                             ; Line 19
                    ADC        #$00A8               
                    TCS                             
                    PEA        $6613                
                    PEA        $6113                
                    PEA        $1116                
                    PEA        $6361                
                    TSC                             ; Line 20
                    ADC        #$00AA               
                    TCS                             
                    SEP        #$20                 
                    LDA        $A1,S                
                    AND        #$0F                 
                    ORA        #$30                 
                    STA        $A1,S                
                    REP        #$30                 
                    PEA        $1363                
                    PEA        $1332                
                    PEA        $3611                
                    PEA        $6131                
                    PEA        $1116                
                    TSC                             ; Line 21
                    ADC        #$00AA               
                    TCS                             
                    LDA        $96,S                
                    AND        #$00F0               
                    ORA        #$1606               
                    STA        $96,S                
                    LDA        $A4,S                
                    AND        #$000F               
                    ORA        #$4430               
                    STA        $A4,S                
                    PEA        $3116                
                    PEA        $1161                
                    PEA        $1311                
                    PEA        $1636                
                    PEA        $1361                
                    TSC                             ; Line 22
                    ADC        #$00AD               
                    TCS                             
                    LDA        $A2,S                
                    AND        #$0F00               
                    ORA        #$4044               
                    STA        $A2,S                
                    SEP        #$20                 
                    LDA        $93,S                
                    AND        #$F0                 
                    ORA        #$01                 
                    STA        $93,S                
                    REP        #$30                 
                    PEA        $2323                
                    PEA        $1363                
                    PEA        $6116                
                    PEA        $3611                
                    PHX                             
                    PEA        $3311                
                    TSC                             ; Line 23
                    ADC        #$00AD               
                    TCS                             
                    LDA        $A1,S                
                    AND        #$0F00               
                    ORA        #$4044               
                    STA        $A1,S                
                    SEP        #$20                 
                    LDA        $92,S                
                    AND        #$F0                 
                    ORA        #$06                 
                    STA        $92,S                
                    REP        #$30                 
                    PEA        $3431                
                    PEA        $3133                
                    PEA        $1116                
                    PEA        $3313                
                    PEA        $3432                
                    PEA        $3231                
                    PEA        $1161                
                    TSC                             ; Line 24
                    ADC        #$00AE               
                    TCS                             
                    SEP        #$20                 
                    LDA        $A0,S                
                    AND        #$0F                 
                    ORA        #$10                 
                    STA        $A0,S                
                    REP        #$30                 
                    PEA        $1413                
                    PEA        $1361                
                    PHX                             
                    PEA        $4344                
                    PEA        $1413                
                    PEA        $1313                
                    PEA        $1316                
                    TSC                             ; Line 25
                    ADC        #$00A8               
                    TCS                             
                    LDA        $99,S                
                    AND        #$00F0               
                    ORA        #$1606               
                    STA        $99,S                
                    PEA        $4344                
                    PEA        $6461                
                    PHX                             
                    PHX                             
                    TSC                             
                    ADC        #$000D               
                    TCS                             
                    PHY                             
                    PHY                             
                    TSC                             ; Line 26
                    ADC        #$009F               
                    TCS                             
                    SEP        #$20                 
                    LDA        $9A,S                
                    AND        #$F0                 
                    ORA        #$07                 
                    STA        $9A,S                
                    REP        #$30                 
                    PEA        $3344                
                    PEA        $1416                
                    PHY                             
                    TSC                             ; Line 27
                    ADC        #$00A6               
                    TCS                             
                    LDA        $9A,S                
                    AND        #$00F0               
                    ORA        #$5505               
                    STA        $9A,S                
                    LDA        $A0,S                
                    AND        #$0F00               
                    ORA        #$5035               
                    STA        $A0,S                
                    PEA        $3313                
                    PEA        $1311                
                    PEA        $1171                
                    TSC                             ; Line 28
                    ADC        #$00A5               
                    TCS                             
                    LDA        $9B,S                
                    AND        #$00F0               
                    ORA        #$1606               
                    STA        $9B,S                
                    LDA        $A1,S                
                    AND        #$0F00               
                    ORA        #$7075               
                    STA        $A1,S                
                    PEA        $1171                
                    PEA        $7777                
                    TSC                             ; Line 29
                    ADC        #$00A4               
                    TCS                             
                    LDA        $9B,S                
                    AND        #$00F0               
                    ORA        #$6101               
                    STA        $9B,S                
                    LDA        $A1,S                
                    AND        #$0F00               
                    ORA        #$1071               
                    STA        $A1,S                
                    PEA        $7755                
                    PEA        $5555                
                    TSC                             ; Line 30
                    ADC        #$00A4               
                    TCS                             
                    LDA        $A2,S                
                    AND        #$0F00               
                    ORA        #$3053               
                    STA        $A2,S                
                    SEP        #$20                 
                    LDA        $9B,S                
                    AND        #$F0                 
                    ORA        #$06                 
                    STA        $9B,S                
                    REP        #$30                 
                    PEA        $7511                
                    PHX                             
                    TSC                             ; Line 31
                    ADC        #$00A5               
                    TCS                             
                    SEP        #$20                 
                    LDA        $9A,S                
                    AND        #$F0                 
                    ORA        #$01                 
                    STA        $9A,S                
                    REP        #$30                 
                    PEA        $5717                
                    PEA        $1131                
                    PEA        $1116                
                    TSC                             ; Line 32
                    ADC        #$00A8               
                    TCS                             
                    LDA        $98,S                
                    AND        #$00F0               
                    ORA        #$1606               
                    STA        $98,S                
                    PEA        $3375                
                    PEA        $5137                
                    PEA        $3313                
                    PEA        $1361                
                    TSC                             ; Line 33
                    ADC        #$00A9               
                    TCS                             
                    SEP        #$20                 
                    LDA        $97,S                
                    AND        #$F0                 
                    ORA        #$01                 
                    STA        $97,S                
                    REP        #$30                 
                    PEA        $3313                
                    PEA        $3775                
                    PEA        $3333                
                    PEA        $3311                
                    TSC                             ; Line 34
                    ADC        #$00A9               
                    TCS                             
                    LDA        $96,S                
                    AND        #$00F0               
                    ORA        #$1106               
                    STA        $96,S                
                    LDA        $A0,S                
                    AND        #$0F00               
                    ORA        #$3013               
                    STA        $A0,S                
                    PEA        $3331                
                    PEA        $3111                
                    PEA        $7531                
                    PEA        $3113                
                    PEA        $1361                
                    TSC                             ; Line 35
                    ADC        #$00A9               
                    TCS                             
                    LDA        $97,S                
                    AND        #$00F0               
                    ORA        #$6101               
                    STA        $97,S                
                    PEA        $1311                
                    PEA        $1161                
                    PEA        $1333                
                    PEA        $3311                
                    TSC                             ; Line 36
                    ADC        #$00AA               
                    TCS                             
                    LDA        $95,S                
                    AND        #$00F0               
                    ORA        #$1106               
                    STA        $95,S                
                    SEP        #$20                 
                    LDA        $A1,S                
                    AND        #$0F                 
                    ORA        #$30                 
                    STA        $A1,S                
                    REP        #$30                 
                    PEA        $3331                
                    PEA        $1116                
                    PHY                             
                    PEA        $3631                
                    PEA        $1313                
                    TSC                             ; Line 37
                    ADC        #$00AA               
                    TCS                             
                    LDA        $9A,S                
                    AND        #$00F0               
                    ORA        #$1606               
                    STA        $9A,S                
                    SEP        #$20                 
                    LDA        $95,S                
                    AND        #$F0                 
                    ORA        #$01                 
                    STA        $95,S                
                    REP        #$30                 
                    PEA        $3211                
                    PHX                             
                    PHX                             
                    PEA        $3133                
                    PEA        $3111                
                    TSC                             ; Line 38
                    ADC        #$00A3               
                    TCS                             
                    SEP        #$20                 
                    LDA        #$23                 
                    STA        $A8,S                
                    LDA        $9C,S                
                    AND        #$F0                 
                    ORA        #$06                 
                    STA        $9C,S                
                    REP        #$30                 
                    PEA        $3313                
                    PEA        $1361                
                    TSC                             
                    ADC        #$000C               
                    TCS                             
                    PEA        $3213                
                    PHY                             
                    PHY                             
                    TSC                             ; Line 39
                    ADC        #$009E               
                    TCS                             
                    SEP        #$20                 
                    LDA        $9C,S                
                    AND        #$F0                 
                    ORA        #$01                 
                    STA        $9C,S                
                    REP        #$30                 
                    PEA        $3131                
                    PEA        $1111                
                    TSC                             
                    ADC        #$000B               
                    TCS                             
                    PHX                             
                    PHX                             
                    TSC                             ; Line 40
                    ADC        #$009D               
                    TCS                             
                    LDA        #$3111               
                    STA        $9D,S                
                    LDA        #$1361               
                    STA        $A7,S                
                    LDA        $9F,S                
                    AND        #$0F00               
                    ORA        #$3033               
                    STA        $9F,S                
                    LDA        $A5,S                
                    AND        #$00F0               
                    ORA        #$6101               
                    STA        $A5,S                
                    SEP        #$20                 
                    LDA        $9C,S                
                    AND        #$F0                 
                    ORA        #$06                 
                    STA        $9C,S                
                    REP        #$30                 
                    PEA        $2313                
                    PEA        $1361                
                    TSC                             
                    ADC        #$000C               
                    TCS                             
                    PEA        $3311                
                    PHY                             
                    TSC                             ; Line 42
                    ADC        #$013B               
                    TCS                             
                    LDA        #$3316               
                    STA        $08,S                
                    LDA        #$1361               
                    STA        $A8,S                
                    SEP        #$20                 
                    LDA        $01,S                
                    AND        #$0F                 
                    ORA        #$30                 
                    STA        $01,S                
                    LDA        $07,S                
                    AND        #$F0                 
                    ORA        #$06                 
                    STA        $07,S                
                    LDA        $A7,S                
                    AND        #$F0                 
                    ORA        #$01                 
                    STA        $A7,S                
                    REP        #$30                 
                    PEA        $2313                
                    PHX                             
                    TSC                             ; Line 43
                    ADC        #$00A4               
                    TCS                             
                    LDA        #$3316               
                    STA        $A8,S                
                    SEP        #$20                 
                    LDA        $A7,S                
                    AND        #$F0                 
                    ORA        #$06                 
                    STA        $A7,S                
                    REP        #$30                 
                    PEA        $3213                
                    PEA        $1116                
                    TSC                             ; Line 44
                    ADC        #$00A4               
                    TCS                             
                    LDA        #$1316               
                    STA        $9D,S                
                    LDA        #$3361               
                    STA        $A8,S                
                    LDA        $9F,S                
                    AND        #$0F00               
                    ORA        #$3033               
                    STA        $9F,S                
                    SEP        #$20                 
                    LDA        $9C,S                
                    AND        #$F0                 
                    ORA        #$06                 
                    STA        $9C,S                
                    LDA        $A7,S                
                    AND        #$F0                 
                    ORA        #$01                 
                    STA        $A7,S                
                    REP        #$30                 
                    PEA        $2333                
                    PHX                             
                    TSC                             ; Line 46
                    ADC        #$0143               
                    TCS                             
                    LDA        #$1311               
                    STA        $09,S                
                    TYA                             
                    STA        $9D,S                
                    LDA        #$3361               
                    STA        $A9,S                
                    LDA        $9F,S                
                    AND        #$0F00               
                    ORA        #$3013               
                    STA        $9F,S                
                    SEP        #$20                 
                    LDA        $08,S                
                    AND        #$F0                 
                    ORA        #$06                 
                    STA        $08,S                
                    LDA        $A8,S                
                    AND        #$F0                 
                    ORA        #$01                 
                    STA        $A8,S                
                    REP        #$30                 
                    PEA        $3361                
                    PHX                             
                    TSC                             ; Line 48
                    ADC        #$013F               
                    TCS                             
                    LDA        #$3361               
                    STA        $03,S                
                    LDA        #$1316               
                    STA        $0E,S                
                    STA        $A2,S                
                    LDA        $01,S                
                    AND        #$00F0               
                    ORA        #$6101               
                    STA        $01,S                
                    LDA        $06,S                
                    AND        #$F0F0               
                    ORA        #$0606               
                    STA        $06,S                
                    LDA        $08,S                
                    AND        #$F0F0               
                    ORA        #$0606               
                    STA        $08,S                
                    LDA        $0A,S                
                    AND        #$F0F0               
                    ORA        #$0606               
                    STA        $0A,S                
                    LDA        $0C,S                
                    AND        #$F0F0               
                    ORA        #$0606               
                    STA        $0C,S                
                    LDA        $A4,S                
                    AND        #$0F0F               
                    ORA        #$6010               
                    STA        $A4,S                
                    LDA        $A6,S                
                    AND        #$0F0F               
                    ORA        #$6060               
                    STA        $A6,S                
                    LDA        $A8,S                
                    AND        #$0F0F               
                    ORA        #$6060               
                    STA        $A8,S                
                    LDA        $AA,S                
                    AND        #$0F0F               
                    ORA        #$6060               
                    STA        $AA,S                
                    LDA        $AC,S                
                    AND        #$0F0F               
                    ORA        #$6060               
                    STA        $AC,S                
                    LDA        $AF,S                
                    AND        #$F00F               
                    ORA        #$0640               
                    STA        $AF,S                
                    SEP        #$20                 
                    LDA        #$16                 
                    STA        $A1,S                
                    LDA        #$44                 
                    STA        $AE,S                
                    REP        #$30                 
                    TSC                             ; Line 50
                    ADC        #$0140               
                    TCS                             
                    LDA        #$3161               
                    STA        $02,S                
                    TDC                             
                    STA        $0E,S                
                    STA        $A1,S                
                    LDA        $00,S                
                    AND        #$00F0               
                    ORA        #$4106               
                    STA        $00,S                
                    LDA        $04,S                
                    AND        #$F0F0               
                    ORA        #$0606               
                    STA        $04,S                
                    LDA        $06,S                
                    AND        #$F0F0               
                    ORA        #$0606               
                    STA        $06,S                
                    LDA        $08,S                
                    AND        #$F0F0               
                    ORA        #$0606               
                    STA        $08,S                
                    LDA        $0A,S                
                    AND        #$F0F0               
                    ORA        #$0606               
                    STA        $0A,S                
                    LDA        $0C,S                
                    AND        #$F0F0               
                    ORA        #$0606               
                    STA        $0C,S                
                    LDA        $10,S                
                    AND        #$0F0F               
                    ORA        #$6040               
                    STA        $10,S                
                    LDA        $12,S                
                    AND        #$0F0F               
                    ORA        #$6060               
                    STA        $12,S                
                    LDA        $A4,S                
                    AND        #$0F0F               
                    ORA        #$6060               
                    STA        $A4,S                
                    LDA        $A6,S                
                    AND        #$0F0F               
                    ORA        #$6060               
                    STA        $A6,S                
                    LDA        $A8,S                
                    AND        #$0F0F               
                    ORA        #$6060               
                    STA        $A8,S                
                    LDA        $AA,S                
                    AND        #$0F0F               
                    ORA        #$6060               
                    STA        $AA,S                
                    LDA        $AC,S                
                    AND        #$0F0F               
                    ORA        #$6060               
                    STA        $AC,S                
                    LDA        $B2,S                
                    AND        #$F0F0               
                    ORA        #$0606               
                    STA        $B2,S                
                    SEP        #$20                 
                    LDA        $A0,S                
                    AND        #$0F                 
                    ORA        #$60                 
                    STA        $A0,S                
                    LDA        $A3,S                
                    AND        #$0F                 
                    ORA        #$40                 
                    STA        $A3,S                
                    REP        #$30                 
                    TSC                             ; Line 51
                    ADC        #$00B1               
                    TCS                             
                    TDC                             
                    STA        $91,S                
                    LDA        $93,S                
                    AND        #$F0F0               
                    ORA        #$0606               
                    STA        $93,S                
                    LDA        $95,S                
                    AND        #$F0F0               
                    ORA        #$0606               
                    STA        $95,S                
                    SEP        #$20                 
                    LDA        $90,S                
                    AND        #$F0                 
                    ORA        #$04                 
                    STA        $90,S                
                    REP        #$30                 
                    PEA        $4644                
                    PHD                             
*--                                                 
                    LDAL       $E1C068              ; Direct Page and Stack in Bank 00/
                    AND        #$FFCF               
                    STAL       $E1C068              
                    LDA        StackAddress         ; Restore Stack
                    TCS                             
                    PLD                             ; Restore Direct Page
                    CLI                             ; Enable Interrupts
                    PLB
                    RTL                             
                                                    
*-----------------------------------                                
Sprite_RR_04F       CLC                             ; Sprite #04F : 32x56, 1188 bytes, 1929 cycles
                    SEI                             ; Disable Interrupts
                    PHD                             ; Backup Direct Page
                    TSC                             ; Backup Stack
                    STA        StackAddress         
                    LDAL       $E1C068              ; Direct Page and Stack in Bank 01/
                    ORA        #$0030               
                    STAL       $E1C068              
                    TYA                             ; Y = Sprite Target Screen Address (upper left corner)
                    TCS                             ; New Stack address
                    LDX        #$6161               ; Pattern #1 : 14
                    LDY        #$4444               ; Pattern #2 : 14
                    LDA        #$1616               ; Pattern #3 : 10
                    TCD                             
*--                                                 
                    LDA        #$6666               ; Line 0
                    STA        $AB,S                
                    LDA        $0A,S                
                    AND        #$00F0               
                    ORA        #$6605               
                    STA        $0A,S                
                    LDA        $A9,S                
                    AND        #$00F0               
                    ORA        #$5506               
                    STA        $A9,S                
                    SEP        #$20                 
                    LDA        $0C,S                
                    AND        #$0F                 
                    ORA        #$60                 
                    STA        $0C,S                
                    REP        #$30                 
                    TSC                             ; Line 2
                    ADC        #$014C               
                    TCS                             
                    LDA        $9C,S                
                    AND        #$00F0               
                    ORA        #$6606               
                    STA        $9C,S                
                    SEP        #$20                 
                    LDA        $01,S                
                    AND        #$0F                 
                    ORA        #$60                 
                    STA        $01,S                
                    REP        #$30                 
                    PEA        $6656                
                    PEA        $6566                
                    TSC                             ; Line 3
                    ADC        #$00A5               
                    TCS                             
                    LDA        $9B,S                
                    AND        #$00F0               
                    ORA        #$6606               
                    STA        $9B,S                
                    PEA        $6666                
                    PEA        $5665                
                    TSC                             ; Line 4
                    ADC        #$00A4               
                    TCS                             
                    LDA        $9B,S                
                    AND        #$00F0               
                    ORA        #$6406               
                    STA        $9B,S                
                    SEP        #$20                 
                    LDA        #$16                 
                    STA        $9A,S                
                    REP        #$30                 
                    PEA        $6666                
                    PEA        $5566                
                    TSC                             ; Line 5
                    ADC        #$00A4               
                    TCS                             
                    PEA        $6656                
                    PEA        $6566                
                    TSC                             ; Line 6
                    ADC        #$00A4               
                    TCS                             
                    LDA        $97,S                
                    AND        #$00F0               
                    ORA        #$1606               
                    STA        $97,S                
                    LDA        $9F,S                
                    AND        #$0F00               
                    ORA        #$5055               
                    STA        $9F,S                
                    PEA        $6655                
                    PEA        $4564                
                    PEA        $4644                
                    PHX                             
                    TSC                             ; Line 7
                    ADC        #$00A6               
                    TCS                             
                    SEP        #$20                 
                    LDA        #$45                 
                    STA        $A1,S                
                    REP        #$30                 
                    PHY                             
                    PHY                             
                    PEA        $1316                
                    TSC                             ; Line 8
                    ADC        #$00A6               
                    TCS                             
                    SEP        #$20                 
                    LDA        $98,S                
                    AND        #$F0                 
                    ORA        #$06                 
                    STA        $98,S                
                    REP        #$30                 
                    PEA        $6446                
                    PHY                             
                    PEA        $6311                
                    PHX                             
                    TSC                             ; Line 9
                    ADC        #$00A8               
                    TCS                             
                    SEP        #$20                 
                    LDA        $A0,S                
                    AND        #$0F                 
                    ORA        #$40                 
                    STA        $A0,S                
                    REP        #$30                 
                    PHY                             
                    PEA        $4434                
                    PEA        $6113                
                    PHD                             
                    TSC                             ; Line 10
                    ADC        #$00A7               
                    TCS                             
                    LDA        $9F,S                
                    AND        #$0FF0               
                    ORA        #$4004               
                    STA        $9F,S                
                    SEP        #$20                 
                    LDA        $98,S                
                    AND        #$F0                 
                    ORA        #$06                 
                    STA        $98,S                
                    REP        #$30                 
                    PHY                             
                    PEA        $3436                
                    PEA        $1161                
                    PHX                             
                    TSC                             ; Line 11
                    ADC        #$00A6               
                    TCS                             
                    SEP        #$20                 
                    LDA        #$13                 
                    STA        $A0,S                
                    REP        #$30                 
                    PEA        $6323                
                    PEA        $1311                
                    PHD                             
                    TSC                             ; Line 12
                    ADC        #$00A5               
                    TCS                             
                    LDA        $9A,S                
                    AND        #$00F0               
                    ORA        #$1606               
                    STA        $9A,S                
                    PEA        $3211                
                    PEA        $1111                
                    PHX                             
                    TSC                             ; Line 13
                    ADC        #$00A7               
                    TCS                             
                    LDA        $A0,S                
                    AND        #$0F00               
                    ORA        #$3061               
                    STA        $A0,S                
                    SEP        #$20                 
                    LDA        $99,S                
                    AND        #$F0                 
                    ORA        #$01                 
                    STA        $99,S                
                    REP        #$30                 
                    PEA        $6313                
                    PEA        $1111                
                    PEA        $1111                
                    TSC                             ; Line 14
                    ADC        #$00A5               
                    TCS                             
                    LDA        $A1,S                
                    AND        #$0F00               
                    ORA        #$3061               
                    STA        $A1,S                
                    SEP        #$20                 
                    LDA        $9A,S                
                    AND        #$F0                 
                    ORA        #$06                 
                    STA        $9A,S                
                    REP        #$30                 
                    PEA        $3211                
                    PEA        $3111                
                    PEA        $1161                
                    TSC                             ; Line 15
                    ADC        #$00A6               
                    TCS                             
                    SEP        #$20                 
                    LDA        $A2,S                
                    AND        #$0F                 
                    ORA        #$30                 
                    STA        $A2,S                
                    REP        #$30                 
                    PEA        $1311                
                    PEA        $1613                
                    PEA        $1116                
                    TSC                             ; Line 16
                    ADC        #$00A7               
                    TCS                             
                    SEP        #$20                 
                    LDA        $A1,S                
                    AND        #$0F                 
                    ORA        #$10                 
                    STA        $A1,S                
                    REP        #$30                 
                    PEA        $1633                
                    PEA        $6131                
                    PEA        $3111                
                    PHX                             
                    TSC                             ; Line 17
                    ADC        #$00A8               
                    TCS                             
                    LDA        $A3,S                
                    AND        #$0F00               
                    ORA        #$2031               
                    STA        $A3,S                
                    SEP        #$20                 
                    LDA        #$61                 
                    STA        $99,S                
                    LDA        $A2,S                
                    AND        #$F0                 
                    ORA        #$03                 
                    STA        $A2,S                
                    REP        #$30                 
                    PEA        $3613                
                    PHD                             
                    PEA        $1311                
                    PHD                             
                    TSC                             ; Line 18
                    ADC        #$00A9               
                    TCS                             
                    PEA        $1136                
                    PEA        $3161                
                    PEA        $3131                
                    PHX                             
                    TSC                             ; Line 19
                    ADC        #$00AB               
                    TCS                             
                    LDA        $A1,S                
                    AND        #$0F00               
                    ORA        #$2011               
                    STA        $A1,S                
                    PEA        $1213                
                    PEA        $1163                
                    PEA        $3613                
                    PEA        $1636                
                    PEA        $1316                
                    PEA        $5655                
                    TSC                             ; Line 20
                    ADC        #$00AC               
                    TCS                             
                    PEA        $3311                
                    PEA        $1636                
                    PEA        $1361                
                    PEA        $6155                
                    PEA        $1555                
                    PEA        $5511                
                    TSC                             ; Line 21
                    ADC        #$00AE               
                    TCS                             
                    PEA        $1211                
                    PHY                             
                    PEA        $3333                
                    PEA        $1116                
                    PEA        $3633                
                    PEA        $5555                
                    PEA        $3311                
                    TSC                             ; Line 22
                    ADC        #$00AE               
                    TCS                             
                    LDA        $93,S                
                    AND        #$00F0               
                    ORA        #$1301               
                    STA        $93,S                
                    PEA        $3361                
                    PHY                             
                    PEA        $1363                
                    PHX                             
                    PEA        $3333                
                    PEA        $3333                
                    PEA        $1111                
                    TSC                             ; Line 23
                    ADC        #$00AE               
                    TCS                             
                    LDA        $93,S                
                    AND        #$00F0               
                    ORA        #$1101               
                    STA        $93,S                
                    LDA        $9F,S                
                    AND        #$0F00               
                    ORA        #$3061               
                    STA        $9F,S                
                    PEA        $1266                
                    PEA        $4344                
                    PHD                             
                    PEA        $1613                
                    PEA        $3313                
                    PEA        $1313                
                    TSC                             ; Line 24
                    ADC        #$00AA               
                    TCS                             
                    LDA        $95,S                
                    AND        #$00F0               
                    ORA        #$1106               
                    STA        $95,S                
                    SEP        #$20                 
                    LDA        $9D,S                
                    AND        #$0F                 
                    ORA        #$60                 
                    STA        $9D,S                
                    REP        #$30                 
                    PEA        $1311                
                    PEA        $6166                
                    PEA        $6131                
                    PEA        $3131                
                    PEA        $3131                
                    TSC                             ; Line 25
                    ADC        #$00A6               
                    TCS                             
                    TXA                             
                    STA        $A2,S                
                    LDA        $A4,S                
                    AND        #$0F00               
                    ORA        #$3013               
                    STA        $A4,S                
                    SEP        #$20                 
                    LDA        #$66                 
                    STA        $A0,S                
                    REP        #$30                 
                    PHD                             
                    PEA        $1113                
                    PEA        $1311                
                    TSC                             
                    ADC        #$000B               
                    TCS                             
                    PEA        $1333                
                    PEA        $1166                
                    TSC                             ; Line 26
                    ADC        #$009E               
                    TCS                             
                    LDA        #$3311               
                    STA        $A4,S                
                    LDA        $9B,S                
                    AND        #$00F0               
                    ORA        #$1606               
                    STA        $9B,S                
                    LDA        $A2,S                
                    AND        #$00F0               
                    ORA        #$1606               
                    STA        $A2,S                
                    PHX                             
                    PEA        $1111                
                    PEA        $1161                
                    TSC                             ; Line 27
                    ADC        #$00A6               
                    TCS                             
                    SEP        #$20                 
                    LDA        $A0,S                
                    AND        #$0F                 
                    ORA        #$60                 
                    STA        $A0,S                
                    REP        #$30                 
                    PHD                             
                    PHD                             
                    TSC                             ; Line 28
                    ADC        #$00A3               
                    TCS                             
                    SEP        #$20                 
                    LDA        $A2,S                
                    AND        #$F0                 
                    ORA        #$04                 
                    STA        $A2,S                
                    REP        #$30                 
                    PHX                             
                    PHX                             
                    TSC                             
                    ADC        #$000A               
                    TCS                             
                    PEA        $1361                
                    PEA        $1661                
                    TSC                             ; Line 29
                    ADC        #$00A4               
                    TCS                             
                    TYA                             
                    STA        $9C,S                
                    LDA        #$1361               
                    STA        $9F,S                
                    PEA        $3311                
                    PEA        $1641                
                    TSC                             ; Line 31
                    ADC        #$0138               
                    TCS                             
                    LDA        #$3361               
                    STA        $0B,S                
                    TYA                             
                    STA        $AB,S                
                    LDA        $08,S                
                    AND        #$00F0               
                    ORA        #$4404               
                    STA        $08,S                
                    LDA        $A9,S                
                    AND        #$0FF0               
                    ORA        #$4004               
                    STA        $A9,S                
                    SEP        #$20                 
                    LDA        $AD,S                
                    AND        #$0F                 
                    ORA        #$40                 
                    STA        $AD,S                
                    REP        #$30                 
                    TSC                             ; Line 33
                    ADC        #$014E               
                    TCS                             
                    PHY                             
                    PHY                             
                    TSC                             ; Line 52
                    ADC        #$0BD6               
                    TCS                             
                    LDA        $03,S                
                    AND        #$F0F0               
                    ORA        #$0606               
                    STA        $03,S                
                    LDA        $05,S                
                    AND        #$F0F0               
                    ORA        #$0606               
                    STA        $05,S                
                    LDA        $A0,S                
                    AND        #$0F0F               
                    ORA        #$6060               
                    STA        $A0,S                
                    LDA        $A2,S                
                    AND        #$0F0F               
                    ORA        #$6060               
                    STA        $A2,S                
                    LDA        $A4,S                
                    AND        #$0F0F               
                    ORA        #$6060               
                    STA        $A4,S                
                    LDA        $A6,S                
                    AND        #$0F0F               
                    ORA        #$6060               
                    STA        $A6,S                
                    LDA        $A8,S                
                    AND        #$0F0F               
                    ORA        #$6060               
                    STA        $A8,S                
                    LDA        $AA,S                
                    AND        #$0F0F               
                    ORA        #$6060               
                    STA        $AA,S                
                    LDA        $AC,S                
                    AND        #$0F0F               
                    ORA        #$6060               
                    STA        $AC,S                
                    LDA        $AE,S                
                    AND        #$0F0F               
                    ORA        #$6060               
                    STA        $AE,S                
                    SEP        #$20                 
                    LDA        $07,S                
                    AND        #$F0                 
                    ORA        #$06                 
                    STA        $07,S                
                    REP        #$30                 
                    TSC                             ; Line 54
                    ADC        #$0140               
                    TCS                             
                    LDA        $01,S                
                    AND        #$F0F0               
                    ORA        #$0606               
                    STA        $01,S                
                    LDA        $03,S                
                    AND        #$F0F0               
                    ORA        #$0606               
                    STA        $03,S                
                    LDA        $05,S                
                    AND        #$F0F0               
                    ORA        #$0606               
                    STA        $05,S                
                    LDA        $07,S                
                    AND        #$F0F0               
                    ORA        #$0606               
                    STA        $07,S                
                    LDA        $09,S                
                    AND        #$F0F0               
                    ORA        #$0606               
                    STA        $09,S                
                    LDA        $0B,S                
                    AND        #$F0F0               
                    ORA        #$0606               
                    STA        $0B,S                
                    LDA        $0D,S                
                    AND        #$F0F0               
                    ORA        #$0606               
                    STA        $0D,S                
                    LDA        $A4,S                
                    AND        #$0F0F               
                    ORA        #$6060               
                    STA        $A4,S                
                    LDA        $A6,S                
                    AND        #$0F0F               
                    ORA        #$6060               
                    STA        $A6,S                
                    LDA        $A8,S                
                    AND        #$0F0F               
                    ORA        #$6060               
                    STA        $A8,S                
                    LDA        $AA,S                
                    AND        #$0F0F               
                    ORA        #$6060               
                    STA        $AA,S                
                    LDA        $AC,S                
                    AND        #$0F0F               
                    ORA        #$6060               
                    STA        $AC,S                
                    SEP        #$20                 
                    LDA        $0F,S                
                    AND        #$F0                 
                    ORA        #$06                 
                    STA        $0F,S                
                    REP        #$30                 
*--                                                 
                    LDAL       $E1C068              ; Direct Page and Stack in Bank 00/
                    AND        #$FFCF               
                    STAL       $E1C068              
                    LDA        StackAddress         ; Restore Stack
                    TCS                             
                    PLD                             ; Restore Direct Page
                    CLI                             ; Enable Interrupts
                    PLB
                    RTL                             
                                                    
*-----------------------------------                                
Sprite_RR_050       CLC                             ; Sprite #050 : 32x64, 1188 bytes, 1929 cycles
                    SEI                             ; Disable Interrupts
                    PHD                             ; Backup Direct Page
                    TSC                             ; Backup Stack
                    STA        StackAddress         
                    LDAL       $E1C068              ; Direct Page and Stack in Bank 01/
                    ORA        #$0030               
                    STAL       $E1C068              
                    TYA                             ; Y = Sprite Target Screen Address (upper left corner)
                    TCS                             ; New Stack address
                    LDX        #$6161               ; Pattern #1 : 14
                    LDY        #$4444               ; Pattern #2 : 14
                    LDA        #$1616               ; Pattern #3 : 10
                    TCD                             
*--                                                 
                    LDA        #$6666               ; Line 0
                    STA        $AB,S                
                    LDA        $0A,S                
                    AND        #$00F0               
                    ORA        #$6605               
                    STA        $0A,S                
                    LDA        $A9,S                
                    AND        #$00F0               
                    ORA        #$5506               
                    STA        $A9,S                
                    SEP        #$20                 
                    LDA        $0C,S                
                    AND        #$0F                 
                    ORA        #$60                 
                    STA        $0C,S                
                    REP        #$30                 
                    TSC                             ; Line 2
                    ADC        #$014C               
                    TCS                             
                    LDA        $9C,S                
                    AND        #$00F0               
                    ORA        #$6606               
                    STA        $9C,S                
                    SEP        #$20                 
                    LDA        $01,S                
                    AND        #$0F                 
                    ORA        #$60                 
                    STA        $01,S                
                    REP        #$30                 
                    PEA        $6656                
                    PEA        $6566                
                    TSC                             ; Line 3
                    ADC        #$00A5               
                    TCS                             
                    LDA        $9B,S                
                    AND        #$00F0               
                    ORA        #$6606               
                    STA        $9B,S                
                    PEA        $6666                
                    PEA        $5665                
                    TSC                             ; Line 4
                    ADC        #$00A4               
                    TCS                             
                    LDA        $9B,S                
                    AND        #$00F0               
                    ORA        #$6406               
                    STA        $9B,S                
                    SEP        #$20                 
                    LDA        #$16                 
                    STA        $9A,S                
                    REP        #$30                 
                    PEA        $6666                
                    PEA        $5566                
                    TSC                             ; Line 5
                    ADC        #$00A4               
                    TCS                             
                    PEA        $6656                
                    PEA        $6566                
                    TSC                             ; Line 6
                    ADC        #$00A4               
                    TCS                             
                    LDA        $97,S                
                    AND        #$00F0               
                    ORA        #$1606               
                    STA        $97,S                
                    LDA        $9F,S                
                    AND        #$0F00               
                    ORA        #$5055               
                    STA        $9F,S                
                    PEA        $6655                
                    PEA        $4564                
                    PEA        $4644                
                    PHX                             
                    TSC                             ; Line 7
                    ADC        #$00A6               
                    TCS                             
                    SEP        #$20                 
                    LDA        #$45                 
                    STA        $A1,S                
                    REP        #$30                 
                    PHY                             
                    PHY                             
                    PEA        $1316                
                    TSC                             ; Line 8
                    ADC        #$00A6               
                    TCS                             
                    SEP        #$20                 
                    LDA        $98,S                
                    AND        #$F0                 
                    ORA        #$06                 
                    STA        $98,S                
                    REP        #$30                 
                    PEA        $6446                
                    PHY                             
                    PEA        $6311                
                    PHX                             
                    TSC                             ; Line 9
                    ADC        #$00A8               
                    TCS                             
                    SEP        #$20                 
                    LDA        $A0,S                
                    AND        #$0F                 
                    ORA        #$40                 
                    STA        $A0,S                
                    REP        #$30                 
                    PHY                             
                    PEA        $4434                
                    PEA        $6113                
                    PHD                             
                    TSC                             ; Line 10
                    ADC        #$00A7               
                    TCS                             
                    LDA        $9F,S                
                    AND        #$0FF0               
                    ORA        #$4004               
                    STA        $9F,S                
                    SEP        #$20                 
                    LDA        $98,S                
                    AND        #$F0                 
                    ORA        #$06                 
                    STA        $98,S                
                    REP        #$30                 
                    PHY                             
                    PEA        $3436                
                    PEA        $1161                
                    PHX                             
                    TSC                             ; Line 11
                    ADC        #$00A6               
                    TCS                             
                    SEP        #$20                 
                    LDA        #$13                 
                    STA        $A0,S                
                    REP        #$30                 
                    PEA        $6323                
                    PEA        $1311                
                    PHD                             
                    TSC                             ; Line 12
                    ADC        #$00A5               
                    TCS                             
                    LDA        $9A,S                
                    AND        #$00F0               
                    ORA        #$1606               
                    STA        $9A,S                
                    PEA        $3211                
                    PEA        $1111                
                    PHX                             
                    TSC                             ; Line 13
                    ADC        #$00A7               
                    TCS                             
                    LDA        $A0,S                
                    AND        #$0F00               
                    ORA        #$3061               
                    STA        $A0,S                
                    SEP        #$20                 
                    LDA        $99,S                
                    AND        #$F0                 
                    ORA        #$01                 
                    STA        $99,S                
                    REP        #$30                 
                    PEA        $6313                
                    PEA        $1111                
                    PEA        $1111                
                    TSC                             ; Line 14
                    ADC        #$00A5               
                    TCS                             
                    LDA        $A1,S                
                    AND        #$0F00               
                    ORA        #$3061               
                    STA        $A1,S                
                    SEP        #$20                 
                    LDA        $9A,S                
                    AND        #$F0                 
                    ORA        #$06                 
                    STA        $9A,S                
                    REP        #$30                 
                    PEA        $3211                
                    PEA        $3111                
                    PEA        $1161                
                    TSC                             ; Line 15
                    ADC        #$00A6               
                    TCS                             
                    SEP        #$20                 
                    LDA        $A2,S                
                    AND        #$0F                 
                    ORA        #$30                 
                    STA        $A2,S                
                    REP        #$30                 
                    PEA        $1311                
                    PEA        $1613                
                    PEA        $1116                
                    TSC                             ; Line 16
                    ADC        #$00A7               
                    TCS                             
                    SEP        #$20                 
                    LDA        $A1,S                
                    AND        #$0F                 
                    ORA        #$10                 
                    STA        $A1,S                
                    REP        #$30                 
                    PEA        $1633                
                    PEA        $6131                
                    PEA        $3111                
                    PHX                             
                    TSC                             ; Line 17
                    ADC        #$00A8               
                    TCS                             
                    LDA        $A3,S                
                    AND        #$0F00               
                    ORA        #$2031               
                    STA        $A3,S                
                    SEP        #$20                 
                    LDA        #$61                 
                    STA        $99,S                
                    LDA        $A2,S                
                    AND        #$F0                 
                    ORA        #$03                 
                    STA        $A2,S                
                    REP        #$30                 
                    PEA        $3613                
                    PHD                             
                    PEA        $1311                
                    PHD                             
                    TSC                             ; Line 18
                    ADC        #$00A9               
                    TCS                             
                    PEA        $1136                
                    PEA        $3161                
                    PEA        $3131                
                    PHX                             
                    TSC                             ; Line 19
                    ADC        #$00AB               
                    TCS                             
                    LDA        $A1,S                
                    AND        #$0F00               
                    ORA        #$2011               
                    STA        $A1,S                
                    PEA        $1213                
                    PEA        $1163                
                    PEA        $3613                
                    PEA        $1636                
                    PEA        $1316                
                    PEA        $5655                
                    TSC                             ; Line 20
                    ADC        #$00AC               
                    TCS                             
                    PEA        $3311                
                    PEA        $1636                
                    PEA        $1361                
                    PEA        $6155                
                    PEA        $1555                
                    PEA        $5511                
                    TSC                             ; Line 21
                    ADC        #$00AE               
                    TCS                             
                    PEA        $1211                
                    PHY                             
                    PEA        $3333                
                    PEA        $1116                
                    PEA        $3633                
                    PEA        $5555                
                    PEA        $3311                
                    TSC                             ; Line 22
                    ADC        #$00AE               
                    TCS                             
                    LDA        $93,S                
                    AND        #$00F0               
                    ORA        #$1301               
                    STA        $93,S                
                    PEA        $3361                
                    PHY                             
                    PEA        $1363                
                    PHX                             
                    PEA        $3333                
                    PEA        $3333                
                    PEA        $1111                
                    TSC                             ; Line 23
                    ADC        #$00AE               
                    TCS                             
                    LDA        $93,S                
                    AND        #$00F0               
                    ORA        #$1101               
                    STA        $93,S                
                    LDA        $9F,S                
                    AND        #$0F00               
                    ORA        #$3061               
                    STA        $9F,S                
                    PEA        $1266                
                    PEA        $4344                
                    PHD                             
                    PEA        $1613                
                    PEA        $3313                
                    PEA        $1313                
                    TSC                             ; Line 24
                    ADC        #$00AA               
                    TCS                             
                    LDA        $95,S                
                    AND        #$00F0               
                    ORA        #$1106               
                    STA        $95,S                
                    SEP        #$20                 
                    LDA        $9D,S                
                    AND        #$0F                 
                    ORA        #$60                 
                    STA        $9D,S                
                    REP        #$30                 
                    PEA        $1311                
                    PEA        $6166                
                    PEA        $6131                
                    PEA        $3131                
                    PEA        $3131                
                    TSC                             ; Line 25
                    ADC        #$00A6               
                    TCS                             
                    TXA                             
                    STA        $A2,S                
                    LDA        $A4,S                
                    AND        #$0F00               
                    ORA        #$3013               
                    STA        $A4,S                
                    SEP        #$20                 
                    LDA        #$66                 
                    STA        $A0,S                
                    REP        #$30                 
                    PHD                             
                    PEA        $1113                
                    PEA        $1311                
                    TSC                             
                    ADC        #$000B               
                    TCS                             
                    PEA        $1333                
                    PEA        $1166                
                    TSC                             ; Line 26
                    ADC        #$009E               
                    TCS                             
                    LDA        #$3311               
                    STA        $A4,S                
                    LDA        $9B,S                
                    AND        #$00F0               
                    ORA        #$1606               
                    STA        $9B,S                
                    LDA        $A2,S                
                    AND        #$00F0               
                    ORA        #$1606               
                    STA        $A2,S                
                    PHX                             
                    PEA        $1111                
                    PEA        $1161                
                    TSC                             ; Line 27
                    ADC        #$00A6               
                    TCS                             
                    SEP        #$20                 
                    LDA        $A0,S                
                    AND        #$0F                 
                    ORA        #$60                 
                    STA        $A0,S                
                    REP        #$30                 
                    PHD                             
                    PHD                             
                    TSC                             ; Line 28
                    ADC        #$00A3               
                    TCS                             
                    SEP        #$20                 
                    LDA        $A2,S                
                    AND        #$F0                 
                    ORA        #$04                 
                    STA        $A2,S                
                    REP        #$30                 
                    PHX                             
                    PHX                             
                    TSC                             
                    ADC        #$000A               
                    TCS                             
                    PEA        $1361                
                    PEA        $1661                
                    TSC                             ; Line 29
                    ADC        #$00A4               
                    TCS                             
                    TYA                             
                    STA        $9C,S                
                    LDA        #$1361               
                    STA        $9F,S                
                    PEA        $3311                
                    PEA        $1641                
                    TSC                             ; Line 31
                    ADC        #$0138               
                    TCS                             
                    LDA        #$3361               
                    STA        $0B,S                
                    TYA                             
                    STA        $AB,S                
                    LDA        $08,S                
                    AND        #$00F0               
                    ORA        #$4404               
                    STA        $08,S                
                    LDA        $A9,S                
                    AND        #$0FF0               
                    ORA        #$4004               
                    STA        $A9,S                
                    SEP        #$20                 
                    LDA        $AD,S                
                    AND        #$0F                 
                    ORA        #$40                 
                    STA        $AD,S                
                    REP        #$30                 
                    TSC                             ; Line 33
                    ADC        #$014E               
                    TCS                             
                    PHY                             
                    PHY                             
                    TSC                             ; Line 60
                    ADC        #$10D6               
                    TCS                             
                    LDA        $03,S                
                    AND        #$F0F0               
                    ORA        #$0606               
                    STA        $03,S                
                    LDA        $05,S                
                    AND        #$F0F0               
                    ORA        #$0606               
                    STA        $05,S                
                    LDA        $A0,S                
                    AND        #$0F0F               
                    ORA        #$6060               
                    STA        $A0,S                
                    LDA        $A2,S                
                    AND        #$0F0F               
                    ORA        #$6060               
                    STA        $A2,S                
                    LDA        $A4,S                
                    AND        #$0F0F               
                    ORA        #$6060               
                    STA        $A4,S                
                    LDA        $A6,S                
                    AND        #$0F0F               
                    ORA        #$6060               
                    STA        $A6,S                
                    LDA        $A8,S                
                    AND        #$0F0F               
                    ORA        #$6060               
                    STA        $A8,S                
                    LDA        $AA,S                
                    AND        #$0F0F               
                    ORA        #$6060               
                    STA        $AA,S                
                    LDA        $AC,S                
                    AND        #$0F0F               
                    ORA        #$6060               
                    STA        $AC,S                
                    LDA        $AE,S                
                    AND        #$0F0F               
                    ORA        #$6060               
                    STA        $AE,S                
                    SEP        #$20                 
                    LDA        $07,S                
                    AND        #$F0                 
                    ORA        #$06                 
                    STA        $07,S                
                    REP        #$30                 
                    TSC                             ; Line 62
                    ADC        #$0140               
                    TCS                             
                    LDA        $01,S                
                    AND        #$F0F0               
                    ORA        #$0606               
                    STA        $01,S                
                    LDA        $03,S                
                    AND        #$F0F0               
                    ORA        #$0606               
                    STA        $03,S                
                    LDA        $05,S                
                    AND        #$F0F0               
                    ORA        #$0606               
                    STA        $05,S                
                    LDA        $07,S                
                    AND        #$F0F0               
                    ORA        #$0606               
                    STA        $07,S                
                    LDA        $09,S                
                    AND        #$F0F0               
                    ORA        #$0606               
                    STA        $09,S                
                    LDA        $0B,S                
                    AND        #$F0F0               
                    ORA        #$0606               
                    STA        $0B,S                
                    LDA        $0D,S                
                    AND        #$F0F0               
                    ORA        #$0606               
                    STA        $0D,S                
                    LDA        $A4,S                
                    AND        #$0F0F               
                    ORA        #$6060               
                    STA        $A4,S                
                    LDA        $A6,S                
                    AND        #$0F0F               
                    ORA        #$6060               
                    STA        $A6,S                
                    LDA        $A8,S                
                    AND        #$0F0F               
                    ORA        #$6060               
                    STA        $A8,S                
                    LDA        $AA,S                
                    AND        #$0F0F               
                    ORA        #$6060               
                    STA        $AA,S                
                    LDA        $AC,S                
                    AND        #$0F0F               
                    ORA        #$6060               
                    STA        $AC,S                
                    SEP        #$20                 
                    LDA        $0F,S                
                    AND        #$F0                 
                    ORA        #$06                 
                    STA        $0F,S                
                    REP        #$30                 
*--                                                 
                    LDAL       $E1C068              ; Direct Page and Stack in Bank 00/
                    AND        #$FFCF               
                    STAL       $E1C068              
                    LDA        StackAddress         ; Restore Stack
                    TCS                             
                    PLD                             ; Restore Direct Page
                    CLI                             ; Enable Interrupts
                    PLB
                    RTL                             
                                                    
*-----------------------------------                                
Sprite_RR_051       CLC                             ; Sprite #051 : 32x72, 1022 bytes, 1674 cycles
                    SEI                             ; Disable Interrupts
                    PHD                             ; Backup Direct Page
                    TSC                             ; Backup Stack
                    STA        StackAddress         
                    LDAL       $E1C068              ; Direct Page and Stack in Bank 01/
                    ORA        #$0030               
                    STAL       $E1C068              
                    TYA                             ; Y = Sprite Target Screen Address (upper left corner)
                    TCS                             ; New Stack address
                    LDX        #$6161               ; Pattern #1 : 19
                    LDY        #$1111               ; Pattern #2 : 19
                    LDA        #$1616               ; Pattern #3 : 14
                    TCD                             
*--                                                 
                    TDC                             ; Line 0
                    STA        $05,S                
                    LDA        $07,S                
                    AND        #$0F00               
                    ORA        #$1016               
                    STA        $07,S                
                    SEP        #$20                 
                    LDA        #$61                 
                    STA        $A9,S                
                    LDA        $04,S                
                    AND        #$F0                 
                    ORA        #$06                 
                    STA        $04,S                
                    REP        #$30                 
                    TSC                             ; Line 1
                    ADC        #$00A8               
                    TCS                             
                    SEP        #$20                 
                    LDA        #$16                 
                    STA        $A2,S                
                    REP        #$30                 
                    PHX                             
                    PHX                             
                    PHX                             
                    TSC                             ; Line 2
                    ADC        #$00A7               
                    TCS                             
                    LDA        $98,S                
                    AND        #$00F0               
                    ORA        #$6101               
                    STA        $98,S                
                    LDA        $A2,S                
                    AND        #$F00F               
                    ORA        #$0660               
                    STA        $A2,S                
                    LDA        $A4,S                
                    AND        #$0F00               
                    ORA        #$6066               
                    STA        $A4,S                
                    PEA        $1611                
                    PHY                             
                    PHD                             
                    PHD                             
                    TSC                             ; Line 3
                    ADC        #$00A9               
                    TCS                             
                    LDA        #$6566               
                    STA        $A3,S                
                    LDA        $A1,S                
                    AND        #$000F               
                    ORA        #$6640               
                    STA        $A1,S                
                    SEP        #$20                 
                    LDA        $A5,S                
                    AND        #$0F                 
                    ORA        #$50                 
                    STA        $A5,S                
                    REP        #$30                 
                    PEA        $6131                
                    PHY                             
                    PHY                             
                    PEA        $1161                
                    TSC                             ; Line 4
                    ADC        #$00A8               
                    TCS                             
                    LDA        $96,S                
                    AND        #$00F0               
                    ORA        #$6105               
                    STA        $96,S                
                    LDA        $A4,S                
                    AND        #$0F00               
                    ORA        #$6065               
                    STA        $A4,S                
                    PEA        $1116                
                    PEA        $1313                
                    PHY                             
                    PHY                             
                    PHD                             
                    TSC                             ; Line 5
                    ADC        #$00AD               
                    TCS                             
                    PEA        $6666                
                    PEA        $4434                
                    PEA        $1631                
                    PHY                             
                    PHY                             
                    PEA        $1161                
                    TSC                             ; Line 6
                    ADC        #$00AE               
                    TCS                             
                    PEA        $6655                
                    PEA        $6644                
                    PEA        $4434                
                    PEA        $1613                
                    PEA        $1316                
                    PEA        $1611                
                    PHY                             
                    PEA        $1615                
                    TSC                             ; Line 7
                    ADC        #$00B0               
                    TCS                             
                    LDA        $9B,S                
                    AND        #$00F0               
                    ORA        #$4404               
                    STA        $9B,S                
                    PEA        $6655                
                    PEA        $6646                
                    PEA        $4434                
                    PEA        $6131                
                    PEA        $3161                
                    PEA        $6113                
                    PEA        $1311                
                    PEA        $5161                
                    TSC                             ; Line 8
                    ADC        #$00AA               
                    TCS                             
                    LDA        $A1,S                
                    AND        #$00F0               
                    ORA        #$4404               
                    STA        $A1,S                
                    PEA        $6311                
                    PEA        $1316                
                    PEA        $1633                
                    PEA        $3131                
                    PEA        $5116                
                    TSC                             
                    ADC        #$0010               
                    TCS                             
                    PEA        $6655                
                    PEA        $4644                
                    TSC                             ; Line 9
                    ADC        #$009E               
                    TCS                             
                    SEP        #$20                 
                    LDA        $A1,S                
                    AND        #$F0                 
                    ORA        #$04                 
                    STA        $A1,S                
                    LDA        $A6,S                
                    AND        #$0F                 
                    ORA        #$60                 
                    STA        $A6,S                
                    REP        #$30                 
                    PEA        $1116                
                    PEA        $3361                
                    PEA        $6113                
                    PEA        $1353                
                    PEA        $1561                
                    TSC                             
                    ADC        #$0010               
                    TCS                             
                    PEA        $6656                
                    PEA        $4444                
                    TSC                             ; Line 10
                    ADC        #$009E               
                    TCS                             
                    LDA        #$5645               
                    STA        $A4,S                
                    LDA        $A2,S                
                    AND        #$00F0               
                    ORA        #$4404               
                    STA        $A2,S                
                    PEA        $1361                
                    PEA        $1313                
                    PEA        $1633                
                    PEA        $5555                
                    PEA        $1116                
                    TSC                             
                    ADC        #$000F               
                    TCS                             
                    PEA        $5645                
                    PEA        $4644                
                    TSC                             ; Line 11
                    ADC        #$009F               
                    TCS                             
                    LDA        $A4,S                
                    AND        #$0FF0               
                    ORA        #$5005               
                    STA        $A4,S                
                    PEA        $1316                
                    PEA        $3361                
                    PEA        $6151                
                    PEA        $3531                
                    PEA        $1161                
                    TSC                             ; Line 12
                    ADC        #$00AA               
                    TCS                             
                    LDA        $A0,S                
                    AND        #$0F00               
                    ORA        #$3011               
                    STA        $A0,S                
                    SEP        #$20                 
                    LDA        $97,S                
                    AND        #$F0                 
                    ORA        #$01                 
                    STA        $97,S                
                    REP        #$30                 
                    PEA        $6361                
                    PEA        $1313                
                    PEA        $1633                
                    PEA        $1313                
                    PEA        $1116                
                    TSC                             ; Line 13
                    ADC        #$00A9               
                    TCS                             
                    SEP        #$20                 
                    LDA        $A2,S                
                    AND        #$0F                 
                    ORA        #$30                 
                    STA        $A2,S                
                    REP        #$30                 
                    PEA        $1633                
                    PHX                             
                    PEA        $3331                
                    PEA        $1161                
                    TSC                             ; Line 14
                    ADC        #$00A9               
                    TCS                             
                    LDA        $97,S                
                    AND        #$00F0               
                    ORA        #$1606               
                    STA        $97,S                
                    PEA        $6131                
                    PEA        $3333                
                    PEA        $6133                
                    PEA        $1161                
                    PHX                             
                    TSC                             ; Line 15
                    ADC        #$00AA               
                    TCS                             
                    SEP        #$20                 
                    LDA        #$13                 
                    STA        $A0,S                
                    REP        #$30                 
                    PEA        $1333                
                    PEA        $3113                
                    PHD                             
                    PHD                             
                    TSC                             ; Line 16
                    ADC        #$00A7               
                    TCS                             
                    LDA        $9A,S                
                    AND        #$00F0               
                    ORA        #$6606               
                    STA        $9A,S                
                    PEA        $1331                
                    PEA        $3361                
                    PHX                             
                    PHX                             
                    TSC                             ; Line 17
                    ADC        #$00A9               
                    TCS                             
                    PEA        $3111                
                    PEA        $3313                
                    PEA        $1666                
                    TSC                             ; Line 18
                    ADC        #$00A6               
                    TCS                             
                    PEA        $2111                
                    PEA        $3331                
                    PHX                             
                    PHX                             
                    PEA        $6144                
                    TSC                             ; Line 19
                    ADC        #$00AA               
                    TCS                             
                    PEA        $3113                
                    PEA        $3313                
                    PHD                             
                    PHD                             
                    PEA        $1644                
                    TSC                             ; Line 20
                    ADC        #$00AA               
                    TCS                             
                    PEA        $2133                
                    PEA        $4414                
                    PHY                             
                    PHY                             
                    PEA        $1144                
                    TSC                             ; Line 21
                    ADC        #$00AA               
                    TCS                             
                    PEA        $3432                
                    PEA        $4414                
                    PEA        $1313                
                    PEA        $1313                
                    PEA        $1344                
                    TSC                             ; Line 22
                    ADC        #$00AA               
                    TCS                             
                    SEP        #$20                 
                    LDA        $97,S                
                    AND        #$0F                 
                    ORA        #$40                 
                    STA        $97,S                
                    REP        #$30                 
                    PEA        $4441                
                    PEA        $4434                
                    PEA        $3333                
                    PEA        $3333                
                    PEA        $3344                
                    TSC                             ; Line 23
                    ADC        #$00A9               
                    TCS                             
                    LDA        $98,S                
                    AND        #$000F               
                    ORA        #$4440               
                    STA        $98,S                
                    PEA        $1144                
                    PEA        $3131                
                    PEA        $3131                
                    PEA        $3144                
                    TSC                             ; Line 25
                    ADC        #$0140               
                    TCS                             
                    SEP        #$20                 
                    LDA        $01,S                
                    AND        #$0F                 
                    ORA        #$40                 
                    STA        $01,S                
                    LDA        $A1,S                
                    AND        #$0F                 
                    ORA        #$40                 
                    STA        $A1,S                
                    REP        #$30                 
                    TSC                             ; Line 68
                    ADC        #$1AE0               
                    TCS                             
                    LDA        $03,S                
                    AND        #$F0F0               
                    ORA        #$0606               
                    STA        $03,S                
                    LDA        $05,S                
                    AND        #$F0F0               
                    ORA        #$0606               
                    STA        $05,S                
                    LDA        $A0,S                
                    AND        #$0F0F               
                    ORA        #$6060               
                    STA        $A0,S                
                    LDA        $A2,S                
                    AND        #$0F0F               
                    ORA        #$6060               
                    STA        $A2,S                
                    LDA        $A4,S                
                    AND        #$0F0F               
                    ORA        #$6060               
                    STA        $A4,S                
                    LDA        $A6,S                
                    AND        #$0F0F               
                    ORA        #$6060               
                    STA        $A6,S                
                    LDA        $A8,S                
                    AND        #$0F0F               
                    ORA        #$6060               
                    STA        $A8,S                
                    LDA        $AA,S                
                    AND        #$0F0F               
                    ORA        #$6060               
                    STA        $AA,S                
                    LDA        $AC,S                
                    AND        #$0F0F               
                    ORA        #$6060               
                    STA        $AC,S                
                    LDA        $AE,S                
                    AND        #$0F0F               
                    ORA        #$6060               
                    STA        $AE,S                
                    SEP        #$20                 
                    LDA        $07,S                
                    AND        #$F0                 
                    ORA        #$06                 
                    STA        $07,S                
                    REP        #$30                 
                    TSC                             ; Line 70
                    ADC        #$0140               
                    TCS                             
                    LDA        $01,S                
                    AND        #$F0F0               
                    ORA        #$0606               
                    STA        $01,S                
                    LDA        $03,S                
                    AND        #$F0F0               
                    ORA        #$0606               
                    STA        $03,S                
                    LDA        $05,S                
                    AND        #$F0F0               
                    ORA        #$0606               
                    STA        $05,S                
                    LDA        $07,S                
                    AND        #$F0F0               
                    ORA        #$0606               
                    STA        $07,S                
                    LDA        $09,S                
                    AND        #$F0F0               
                    ORA        #$0606               
                    STA        $09,S                
                    LDA        $0B,S                
                    AND        #$F0F0               
                    ORA        #$0606               
                    STA        $0B,S                
                    LDA        $0D,S                
                    AND        #$F0F0               
                    ORA        #$0606               
                    STA        $0D,S                
                    LDA        $A4,S                
                    AND        #$0F0F               
                    ORA        #$6060               
                    STA        $A4,S                
                    LDA        $A6,S                
                    AND        #$0F0F               
                    ORA        #$6060               
                    STA        $A6,S                
                    LDA        $A8,S                
                    AND        #$0F0F               
                    ORA        #$6060               
                    STA        $A8,S                
                    LDA        $AA,S                
                    AND        #$0F0F               
                    ORA        #$6060               
                    STA        $AA,S                
                    LDA        $AC,S                
                    AND        #$0F0F               
                    ORA        #$6060               
                    STA        $AC,S                
                    SEP        #$20                 
                    LDA        $0F,S                
                    AND        #$F0                 
                    ORA        #$06                 
                    STA        $0F,S                
                    REP        #$30                 
*--                                                 
                    LDAL       $E1C068              ; Direct Page and Stack in Bank 00/
                    AND        #$FFCF               
                    STAL       $E1C068              
                    LDA        StackAddress         ; Restore Stack
                    TCS                             
                    PLD                             ; Restore Direct Page
                    CLI                             ; Enable Interrupts
                    PLB
                    RTL                             
                                                    
*-----------------------------------                                
Sprite_RR_052       CLC                             ; Sprite #052 : 32x80, 1293 bytes, 2091 cycles
                    SEI                             ; Disable Interrupts
                    PHD                             ; Backup Direct Page
                    TSC                             ; Backup Stack
                    STA        StackAddress         
                    LDAL       $E1C068              ; Direct Page and Stack in Bank 01/
                    ORA        #$0030               
                    STAL       $E1C068              
                    TYA                             ; Y = Sprite Target Screen Address (upper left corner)
                    TCS                             ; New Stack address
                    LDX        #$1616               ; Pattern #1 : 17
                    LDY        #$6161               ; Pattern #2 : 12
                    LDA        #$1111               ; Pattern #3 : 10
                    TCD                             
*--                                                 
                    TXA                             ; Line 0
                    STA        $08,S                
                    LDA        #$4444               
                    STA        $A2,S                
                    LDA        $0A,S                
                    AND        #$0F00               
                    ORA        #$1016               
                    STA        $0A,S                
                    LDA        $A4,S                
                    AND        #$0F00               
                    ORA        #$4044               
                    STA        $A4,S                
                    SEP        #$20                 
                    LDA        #$55                 
                    STA        $AB,S                
                    REP        #$30                 
                    TSC                             ; Line 1
                    ADC        #$00AA               
                    TCS                             
                    LDA        #$4444               
                    STA        $99,S                
                    LDA        $9B,S                
                    AND        #$F00F               
                    ORA        #$0640               
                    STA        $9B,S                
                    SEP        #$20                 
                    LDA        #$16                 
                    STA        $9D,S                
                    LDA        $A2,S                
                    AND        #$0F                 
                    ORA        #$10                 
                    STA        $A2,S                
                    REP        #$30                 
                    PHY                             
                    PHY                             
                    TSC                             ; Line 2
                    ADC        #$00A5               
                    TCS                             
                    SEP        #$20                 
                    LDA        $9A,S                
                    AND        #$0F                 
                    ORA        #$60                 
                    STA        $9A,S                
                    LDA        $A1,S                
                    AND        #$0F                 
                    ORA        #$60                 
                    STA        $A1,S                
                    REP        #$30                 
                    PEA        $1655                
                    PHD                             
                    TSC                             ; Line 3
                    ADC        #$009D               
                    TCS                             
                    LDA        #$1633               
                    STA        $9F,S                
                    LDA        $A1,S                
                    AND        #$000F               
                    ORA        #$1610               
                    STA        $A1,S                
                    SEP        #$20                 
                    LDA        #$44                 
                    STA        $9E,S                
                    REP        #$30                 
                    PEA        $1131                
                    PEA        $4444                
                    TSC                             
                    ADC        #$000B               
                    TCS                             
                    PEA        $6111                
                    PEA        $1511                
                    PHY                             
                    TSC                             ; Line 4
                    ADC        #$00A7               
                    TCS                             
                    LDA        #$1131               
                    STA        $97,S                
                    LDA        $99,S                
                    AND        #$000F               
                    ORA        #$6160               
                    STA        $99,S                
                    SEP        #$20                 
                    LDA        $96,S                
                    AND        #$F0                 
                    ORA        #$03                 
                    STA        $96,S                
                    LDA        $A1,S                
                    AND        #$0F                 
                    ORA        #$10                 
                    STA        $A1,S                
                    REP        #$30                 
                    PEA        $6116                
                    PEA        $3155                
                    PEA        $1311                
                    TSC                             ; Line 5
                    ADC        #$00A6               
                    TCS                             
                    LDA        $96,S                
                    AND        #$00F0               
                    ORA        #$3301               
                    STA        $96,S                
                    LDA        $A0,S                
                    AND        #$0F00               
                    ORA        #$6061               
                    STA        $A0,S                
                    PHX                             
                    PEA        $1153                
                    PEA        $3161                
                    TSC                             ; Line 6
                    ADC        #$00A5               
                    TCS                             
                    LDA        $97,S                
                    AND        #$00F0               
                    ORA        #$3103               
                    STA        $97,S                
                    PEA        $1131                
                    PEA        $5113                
                    PEA        $1316                
                    PHX                             
                    TSC                             ; Line 7
                    ADC        #$00AA               
                    TCS                             
                    LDA        $95,S                
                    AND        #$00F0               
                    ORA        #$3301               
                    STA        $95,S                
                    PHX                             
                    PHD                             
                    PEA        $5335                
                    PEA        $1161                
                    PEA        $6611                
                    TSC                             ; Line 8
                    ADC        #$00AA               
                    TCS                             
                    LDA        $95,S                
                    AND        #$00F0               
                    ORA        #$3103               
                    STA        $95,S                
                    PEA        $6111                
                    PEA        $1113                
                    PEA        $3135                
                    PEA        $1316                
                    PHX                             
                    TSC                             ; Line 9
                    ADC        #$00AA               
                    TCS                             
                    LDA        $A0,S                
                    AND        #$0F00               
                    ORA        #$6061               
                    STA        $A0,S                
                    SEP        #$20                 
                    LDA        $95,S                
                    AND        #$F0                 
                    ORA        #$01                 
                    STA        $95,S                
                    REP        #$30                 
                    PEA        $1611                
                    PEA        $1131                
                    PEA        $3131                
                    PEA        $3361                
                    PEA        $6611                
                    TSC                             ; Line 10
                    ADC        #$00A9               
                    TCS                             
                    LDA        $A1,S                
                    AND        #$0F00               
                    ORA        #$1016               
                    STA        $A1,S                
                    SEP        #$20                 
                    LDA        $96,S                
                    AND        #$F0                 
                    ORA        #$03                 
                    STA        $96,S                
                    REP        #$30                 
                    PHD                             
                    PEA        $3333                
                    PEA        $1136                
                    PHX                             
                    PEA        $1633                
                    TSC                             ; Line 11
                    ADC        #$00AA               
                    TCS                             
                    LDA        $96,S                
                    AND        #$00F0               
                    ORA        #$3301               
                    STA        $96,S                
                    SEP        #$20                 
                    LDA        $A2,S                
                    AND        #$0F                 
                    ORA        #$60                 
                    STA        $A2,S                
                    REP        #$30                 
                    PHD                             
                    PHX                             
                    PEA        $1661                
                    PHY                             
                    PEA        $1131                
                    TSC                             ; Line 12
                    ADC        #$00AB               
                    TCS                             
                    LDA        $A0,S                
                    AND        #$0F00               
                    ORA        #$1016               
                    STA        $A0,S                
                    SEP        #$20                 
                    LDA        $95,S                
                    AND        #$F0                 
                    ORA        #$03                 
                    STA        $95,S                
                    REP        #$30                 
                    PEA        $6111                
                    PHY                             
                    PHY                             
                    PEA        $1116                
                    PHX                             
                    TSC                             ; Line 13
                    ADC        #$00A9               
                    TCS                             
                    LDA        $96,S                
                    AND        #$00F0               
                    ORA        #$4401               
                    STA        $96,S                
                    SEP        #$20                 
                    LDA        $A2,S                
                    AND        #$0F                 
                    ORA        #$60                 
                    STA        $A2,S                
                    REP        #$30                 
                    PHD                             
                    PHX                             
                    PHX                             
                    PEA        $3131                
                    PEA        $1131                
                    TSC                             ; Line 14
                    ADC        #$00AB               
                    TCS                             
                    LDA        $A0,S                
                    AND        #$0F00               
                    ORA        #$1016               
                    STA        $A0,S                
                    SEP        #$20                 
                    LDA        $95,S                
                    AND        #$F0                 
                    ORA        #$04                 
                    STA        $95,S                
                    REP        #$30                 
                    PHD                             
                    PHY                             
                    PEA        $3131                
                    PEA        $3131                
                    PEA        $1343                
                    TSC                             ; Line 15
                    ADC        #$00A9               
                    TCS                             
                    SEP        #$20                 
                    LDA        $A2,S                
                    AND        #$0F                 
                    ORA        #$60                 
                    STA        $A2,S                
                    REP        #$30                 
                    PHD                             
                    PEA        $1313                
                    PEA        $1333                
                    PEA        $3333                
                    PEA        $4344                
                    TSC                             ; Line 16
                    ADC        #$00AB               
                    TCS                             
                    LDA        #$3333               
                    PEA        $1131                
                    PEA        $3131                
                    PHA                             
                    PHA                             
                    PHA                             
                    PEA        $4444                
                    TSC                             ; Line 17
                    ADC        #$00AC               
                    TCS                             
                    LDA        $9F,S                
                    AND        #$0F00               
                    ORA        #$1011               
                    STA        $9F,S                
                    PEA        $6111                
                    PEA        $3131                
                    PEA        $1116                
                    PEA        $1613                
                    PEA        $3113                
                    PEA        $3314                
                    TSC                             ; Line 18
                    ADC        #$00AA               
                    TCS                             
                    LDA        $97,S                
                    AND        #$00F0               
                    ORA        #$3304               
                    STA        $97,S                
                    LDA        $A1,S                
                    AND        #$0F00               
                    ORA        #$6031               
                    STA        $A1,S                
                    PEA        $1313                
                    PHY                             
                    PEA        $6131                
                    PHD                             
                    PEA        $2311                
                    TSC                             ; Line 19
                    ADC        #$00AA               
                    TCS                             
                    LDA        $97,S                
                    AND        #$00F0               
                    ORA        #$3204               
                    STA        $97,S                
                    LDA        $A1,S                
                    AND        #$0F00               
                    ORA        #$1016               
                    STA        $A1,S                
                    PEA        $1161                
                    PEA        $1611                
                    PEA        $1636                
                    PEA        $1331                
                    TSC                             ; Line 20
                    ADC        #$00A8               
                    TCS                             
                    LDA        #$1311               
                    STA        $99,S                
                    LDA        #$3133               
                    STA        $9F,S                
                    LDA        $97,S                
                    AND        #$00F0               
                    ORA        #$4104               
                    STA        $97,S                
                    LDA        $9B,S                
                    AND        #$0F00               
                    ORA        #$3033               
                    STA        $9B,S                
                    SEP        #$20                 
                    LDA        #$61                 
                    STA        $A1,S                
                    REP        #$30                 
                    PEA        $6616                
                    PEA        $1333                
                    PEA        $1311                
                    PEA        $3132                
                    TSC                             ; Line 22
                    ADC        #$013D               
                    TCS                             
                    LDA        #$4444               
                    STA        $A9,S                
                    LDA        $AB,S                
                    AND        #$0F00               
                    ORA        #$6044               
                    STA        $AB,S                
                    SEP        #$20                 
                    LDA        $08,S                
                    AND        #$F0                 
                    ORA        #$04                 
                    STA        $08,S                
                    LDA        $A8,S                
                    AND        #$F0                 
                    ORA        #$04                 
                    STA        $A8,S                
                    REP        #$30                 
                    TSC                             
                    ADC        #$000C               
                    TCS                             
                    PEA        $1641                
                    PEA        $4444                
                    TSC                             ; Line 24
                    ADC        #$0138               
                    TCS                             
                    LDA        #$4444               
                    STA        $08,S                
                    LDA        $0A,S                
                    AND        #$0F00               
                    ORA        #$4044               
                    STA        $0A,S                
                    TSC                             ; Line 25
                    ADC        #$00AB               
                    TCS                             
                    SEP        #$20                 
                    LDA        $A1,S                
                    AND        #$0F                 
                    ORA        #$60                 
                    STA        $A1,S                
                    REP        #$30                 
                    PEA        $6644                
                    PEA        $4444                
                    TSC                             ; Line 26
                    ADC        #$00A4               
                    TCS                             
                    SEP        #$20                 
                    LDA        $A1,S                
                    AND        #$0F                 
                    ORA        #$60                 
                    STA        $A1,S                
                    REP        #$30                 
                    PEA        $6664                
                    PEA        $4446                
                    TSC                             ; Line 27
                    ADC        #$00A4               
                    TCS                             
                    LDA        #$6646               
                    STA        $9E,S                
                    LDA        $9C,S                
                    AND        #$00F0               
                    ORA        #$5505               
                    STA        $9C,S                
                    LDA        $A0,S                
                    AND        #$0F00               
                    ORA        #$6066               
                    STA        $A0,S                
                    PEA        $6666                
                    PEA        $4444                
                    TSC                             ; Line 29
                    ADC        #$0139               
                    TCS                             
                    LDA        #$5555               
                    STA        $09,S                
                    LDA        $07,S                
                    AND        #$00F0               
                    ORA        #$5505               
                    STA        $07,S                
                    LDA        $0B,S                
                    AND        #$0F00               
                    ORA        #$6066               
                    STA        $0B,S                
                    SEP        #$20                 
                    LDA        $A7,S                
                    AND        #$F0                 
                    ORA        #$06                 
                    STA        $A7,S                
                    REP        #$30                 
                    TSC                             ; Line 30
                    ADC        #$00AB               
                    TCS                             
                    PEA        $5555                
                    PEA        $6566                
                    TSC                             ; Line 31
                    ADC        #$00A4               
                    TCS                             
                    PEA        $6566                
                    PEA        $6666                
                    TSC                             ; Line 32
                    ADC        #$00A4               
                    TCS                             
                    LDA        #$6666               
                    STA        $9E,S                
                    SEP        #$20                 
                    LDA        $A0,S                
                    AND        #$0F                 
                    ORA        #$60                 
                    STA        $A0,S                
                    REP        #$30                 
                    PEA        $6666                
                    PEA        $6666                
                    TSC                             ; Line 76
                    ADC        #$1B79               
                    TCS                             
                    LDA        $03,S                
                    AND        #$F0F0               
                    ORA        #$0606               
                    STA        $03,S                
                    LDA        $05,S                
                    AND        #$F0F0               
                    ORA        #$0606               
                    STA        $05,S                
                    LDA        $A0,S                
                    AND        #$0F0F               
                    ORA        #$6060               
                    STA        $A0,S                
                    LDA        $A2,S                
                    AND        #$0F0F               
                    ORA        #$6060               
                    STA        $A2,S                
                    LDA        $A4,S                
                    AND        #$0F0F               
                    ORA        #$6060               
                    STA        $A4,S                
                    LDA        $A6,S                
                    AND        #$0F0F               
                    ORA        #$6060               
                    STA        $A6,S                
                    LDA        $A8,S                
                    AND        #$0F0F               
                    ORA        #$6060               
                    STA        $A8,S                
                    LDA        $AA,S                
                    AND        #$0F0F               
                    ORA        #$6060               
                    STA        $AA,S                
                    LDA        $AC,S                
                    AND        #$0F0F               
                    ORA        #$6060               
                    STA        $AC,S                
                    LDA        $AE,S                
                    AND        #$0F0F               
                    ORA        #$6060               
                    STA        $AE,S                
                    SEP        #$20                 
                    LDA        $07,S                
                    AND        #$F0                 
                    ORA        #$06                 
                    STA        $07,S                
                    REP        #$30                 
                    TSC                             ; Line 78
                    ADC        #$0140               
                    TCS                             
                    LDA        $01,S                
                    AND        #$F0F0               
                    ORA        #$0606               
                    STA        $01,S                
                    LDA        $03,S                
                    AND        #$F0F0               
                    ORA        #$0606               
                    STA        $03,S                
                    LDA        $05,S                
                    AND        #$F0F0               
                    ORA        #$0606               
                    STA        $05,S                
                    LDA        $07,S                
                    AND        #$F0F0               
                    ORA        #$0606               
                    STA        $07,S                
                    LDA        $09,S                
                    AND        #$F0F0               
                    ORA        #$0606               
                    STA        $09,S                
                    LDA        $0B,S                
                    AND        #$F0F0               
                    ORA        #$0606               
                    STA        $0B,S                
                    LDA        $0D,S                
                    AND        #$F0F0               
                    ORA        #$0606               
                    STA        $0D,S                
                    LDA        $A4,S                
                    AND        #$0F0F               
                    ORA        #$6060               
                    STA        $A4,S                
                    LDA        $A6,S                
                    AND        #$0F0F               
                    ORA        #$6060               
                    STA        $A6,S                
                    LDA        $A8,S                
                    AND        #$0F0F               
                    ORA        #$6060               
                    STA        $A8,S                
                    LDA        $AA,S                
                    AND        #$0F0F               
                    ORA        #$6060               
                    STA        $AA,S                
                    LDA        $AC,S                
                    AND        #$0F0F               
                    ORA        #$6060               
                    STA        $AC,S                
                    SEP        #$20                 
                    LDA        $0F,S                
                    AND        #$F0                 
                    ORA        #$06                 
                    STA        $0F,S                
                    REP        #$30                 
*--                                                 
                    LDAL       $E1C068              ; Direct Page and Stack in Bank 00/
                    AND        #$FFCF               
                    STAL       $E1C068              
                    LDA        StackAddress         ; Restore Stack
                    TCS                             
                    PLD                             ; Restore Direct Page
                    CLI                             ; Enable Interrupts
                    PLB
                    RTL                             
                                                    
*-----------------------------------                                

Sprite_RR_053       CLC                             ; Sprite #053 : 32x76, 1173 bytes, 1905 cycles
                    SEI                             ; Disable Interrupts
                    PHD                             ; Backup Direct Page
                    TSC                             ; Backup Stack
                    STA        StackAddress         
                    LDAL       $E1C068              ; Direct Page and Stack in Bank 01/
                    ORA        #$0030               
                    STAL       $E1C068              
                    TYA                             ; Y = Sprite Target Screen Address (upper left corner)
                    TCS                             ; New Stack address
                    LDX        #$1616               ; Pattern #1 : 20
                    LDY        #$1111               ; Pattern #2 : 19
                    LDA        #$6161               ; Pattern #3 : 13
                    TCD                             
*--                                                 
                    SEP        #$20                 ; Line 0
                    LDA        $0E,S                
                    AND        #$0F                 
                    ORA        #$40                 
                    STA        $0E,S                
                    LDA        $AE,S                
                    AND        #$0F                 
                    ORA        #$40                 
                    STA        $AE,S                
                    REP        #$30                 
                    TSC                             ; Line 2
                    ADC        #$0140               
                    TCS                             
                    LDA        $0D,S                
                    AND        #$0FF0               
                    ORA        #$4004               
                    STA        $0D,S                
                    LDA        $A6,S                
                    AND        #$00F0               
                    ORA        #$1401               
                    STA        $A6,S                
                    LDA        $AE,S                
                    AND        #$0F0F               
                    ORA        #$4040               
                    STA        $AE,S                
                    SEP        #$20                 
                    LDA        $0F,S                
                    AND        #$0F                 
                    ORA        #$40                 
                    STA        $0F,S                
                    REP        #$30                 
                    TSC                             ; Line 3
                    ADC        #$00AD               
                    TCS                             
                    LDA        $A1,S                
                    AND        #$0F00               
                    ORA        #$4034               
                    STA        $A1,S                
                    SEP        #$20                 
                    LDA        $98,S                
                    AND        #$F0                 
                    ORA        #$04                 
                    STA        $98,S                
                    REP        #$30                 
                    PEA        $3431                
                    PEA        $3131                
                    PEA        $3141                
                    TSC                             ; Line 4
                    ADC        #$00A6               
                    TCS                             
                    LDA        $A1,S                
                    AND        #$0F00               
                    ORA        #$4014               
                    STA        $A1,S                
                    SEP        #$20                 
                    LDA        $98,S                
                    AND        #$F0                 
                    ORA        #$04                 
                    STA        $98,S                
                    REP        #$30                 
                    PEA        $3333                
                    PEA        $3333                
                    PEA        $3344                
                    PEA        $4441                
                    TSC                             ; Line 5
                    ADC        #$00A8               
                    TCS                             
                    LDA        $A1,S                
                    AND        #$0F00               
                    ORA        #$4014               
                    STA        $A1,S                
                    SEP        #$20                 
                    LDA        $98,S                
                    AND        #$F0                 
                    ORA        #$01                 
                    STA        $98,S                
                    REP        #$30                 
                    PEA        $1313                
                    PEA        $1313                
                    PEA        $1344                
                    PEA        $3432                
                    TSC                             ; Line 6
                    ADC        #$00A8               
                    TCS                             
                    LDA        $A1,S                
                    AND        #$0F00               
                    ORA        #$4014               
                    STA        $A1,S                
                    SEP        #$20                 
                    LDA        $98,S                
                    AND        #$F0                 
                    ORA        #$01                 
                    STA        $98,S                
                    REP        #$30                 
                    PHY                             
                    PHY                             
                    PEA        $1144                
                    PEA        $3423                
                    TSC                             ; Line 7
                    ADC        #$00A8               
                    TCS                             
                    LDA        $A1,S                
                    AND        #$0F00               
                    ORA        #$4064               
                    STA        $A1,S                
                    SEP        #$20                 
                    LDA        $98,S                
                    AND        #$F0                 
                    ORA        #$01                 
                    STA        $98,S                
                    REP        #$30                 
                    PHX                             
                    PHX                             
                    PEA        $1633                
                    PEA        $1333                
                    TSC                             ; Line 8
                    ADC        #$00A8               
                    TCS                             
                    LDA        $98,S                
                    AND        #$00F0               
                    ORA        #$3101               
                    STA        $98,S                
                    PHD                             
                    PHD                             
                    PEA        $3131                
                    PEA        $1321                
                    TSC                             ; Line 9
                    ADC        #$00A7               
                    TCS                             
                    LDA        $99,S                
                    AND        #$00F0               
                    ORA        #$1303               
                    STA        $99,S                
                    LDA        $A1,S                
                    AND        #$0F00               
                    ORA        #$6061               
                    STA        $A1,S                
                    PEA        $6666                
                    PHX                             
                    PEA        $3313                
                    TSC                             ; Line 10
                    ADC        #$00A6               
                    TCS                             
                    LDA        $99,S                
                    AND        #$00F0               
                    ORA        #$1303               
                    STA        $99,S                
                    PHD                             
                    PEA        $6131                
                    PEA        $3311                
                    TSC                             ; Line 11
                    ADC        #$00A8               
                    TCS                             
                    LDA        $97,S                
                    AND        #$00F0               
                    ORA        #$1603               
                    STA        $97,S                
                    SEP        #$20                 
                    LDA        $A1,S                
                    AND        #$0F                 
                    ORA        #$60                 
                    STA        $A1,S                
                    REP        #$30                 
                    PHX                             
                    PHX                             
                    PHX                             
                    PEA        $3331                
                    TSC                             ; Line 12
                    ADC        #$00A8               
                    TCS                             
                    LDA        $97,S                
                    AND        #$00F0               
                    ORA        #$1103               
                    STA        $97,S                
                    SEP        #$20                 
                    LDA        $A1,S                
                    AND        #$0F                 
                    ORA        #$10                 
                    STA        $A1,S                
                    REP        #$30                 
                    PHD                             
                    PEA        $1131                
                    PEA        $6331                
                    PEA        $3313                
                    TSC                             ; Line 13
                    ADC        #$00A8               
                    TCS                             
                    LDA        $93,S                
                    AND        #$0F00               
                    ORA        #$5064               
                    STA        $93,S                
                    PEA        $1611                
                    PEA        $1333                
                    PHX                             
                    PEA        $3361                
                    TSC                             ; Line 14
                    ADC        #$00A9               
                    TCS                             
                    LDA        #$5465               
                    STA        $92,S                
                    LDA        $94,S                
                    AND        #$0F00               
                    ORA        #$4044               
                    STA        $94,S                
                    SEP        #$20                 
                    LDA        $91,S                
                    AND        #$F0                 
                    ORA        #$06                 
                    STA        $91,S                
                    REP        #$30                 
                    PEA        $6111                
                    PEA        $3131                
                    PEA        $3361                
                    PEA        $3131                
                    PEA        $1636                
                    TSC                             ; Line 15
                    ADC        #$00AA               
                    TCS                             
                    SEP        #$20                 
                    LDA        $91,S                
                    AND        #$F0                 
                    ORA        #$06                 
                    STA        $91,S                
                    LDA        $96,S                
                    AND        #$0F                 
                    ORA        #$40                 
                    STA        $96,S                
                    REP        #$30                 
                    PEA        $1611                
                    PEA        $1353                
                    PEA        $1516                
                    PEA        $1633                
                    PEA        $6131                
                    TSC                             ; Line 16
                    ADC        #$009F               
                    TCS                             
                    SEP        #$20                 
                    LDA        #$66                 
                    STA        $9C,S                
                    LDA        $A1,S                
                    AND        #$0F                 
                    ORA        #$40                 
                    STA        $A1,S                
                    REP        #$30                 
                    PEA        $4464                
                    PEA        $5465                
                    TSC                             
                    ADC        #$000F               
                    TCS                             
                    PEA        $6111                
                    PEA        $5555                
                    PEA        $3361                
                    PEA        $3131                
                    PEA        $1631                
                    TSC                             ; Line 17
                    ADC        #$009F               
                    TCS                             
                    SEP        #$20                 
                    LDA        #$66                 
                    STA        $9C,S                
                    LDA        $A1,S                
                    AND        #$0F                 
                    ORA        #$40                 
                    STA        $A1,S                
                    REP        #$30                 
                    PEA        $4444                
                    PEA        $4465                
                    TSC                             
                    ADC        #$000F               
                    TCS                             
                    PEA        $1651                
                    PEA        $3531                
                    PEA        $3116                
                    PEA        $1633                
                    PEA        $6111                
                    TSC                             ; Line 18
                    ADC        #$009F               
                    TCS                             
                    PEA        $4444                
                    PEA        $6455                
                    TSC                             
                    ADC        #$000F               
                    TCS                             
                    PEA        $6115                
                    PEA        $1313                
                    PEA        $3361                
                    PEA        $6131                
                    PEA        $1136                
                    TSC                             ; Line 19
                    ADC        #$00AA               
                    TCS                             
                    PEA        $1615                
                    PEA        $1131                
                    PEA        $3116                
                    PEA        $1613                
                    PEA        $1316                
                    PEA        $4344                
                    PEA        $6466                
                    PEA        $5566                
                    TSC                             ; Line 20
                    ADC        #$00B0               
                    TCS                             
                    LDA        $9F,S                
                    AND        #$0F00               
                    ORA        #$5016               
                    STA        $9F,S                
                    PEA        $5161                
                    PHY                             
                    PEA        $1161                
                    PEA        $6131                
                    PEA        $3161                
                    PEA        $4344                
                    PEA        $4466                
                    PEA        $5566                
                    TSC                             ; Line 21
                    ADC        #$00AE               
                    TCS                             
                    LDA        #$6666               
                    STA        $95,S                
                    LDA        $93,S                
                    AND        #$00F0               
                    ORA        #$5605               
                    STA        $93,S                
                    SEP        #$20                 
                    LDA        $97,S                
                    AND        #$F0                 
                    ORA        #$04                 
                    STA        $97,S                
                    REP        #$30                 
                    PEA        $1611                
                    PHY                             
                    PHY                             
                    PEA        $1361                
                    PEA        $4344                
                    PEA        $6666                
                    PEA        $5666                
                    TSC                             ; Line 22
                    ADC        #$00AF               
                    TCS                             
                    LDA        $93,S                
                    AND        #$00F0               
                    ORA        #$6606               
                    STA        $93,S                
                    LDA        $95,S                
                    AND        #$F00F               
                    ORA        #$0660               
                    STA        $95,S                
                    SEP        #$20                 
                    LDA        #$16                 
                    STA        $97,S                
                    LDA        $A0,S                
                    AND        #$0F                 
                    ORA        #$10                 
                    STA        $A0,S                
                    REP        #$30                 
                    PHD                             
                    PHY                             
                    PHY                             
                    PEA        $3131                
                    PEA        $6111                
                    TSC                             ; Line 23
                    ADC        #$00A9               
                    TCS                             
                    SEP        #$20                 
                    LDA        #$61                 
                    STA        $A0,S                
                    REP        #$30                 
                    PHX                             
                    PHY                             
                    PHY                             
                    PEA        $1113                
                    TSC                             ; Line 24
                    ADC        #$00A7               
                    TCS                             
                    SEP        #$20                 
                    LDA        #$16                 
                    STA        $A0,S                
                    REP        #$30                 
                    PHD                             
                    PEA        $6111                
                    PHY                             
                    PHD                             
                    TSC                             ; Line 25
                    ADC        #$00A7               
                    TCS                             
                    TDC                             
                    STA        $9D,S                
                    LDA        $9F,S                
                    AND        #$0F00               
                    ORA        #$6061               
                    STA        $9F,S                
                    SEP        #$20                 
                    LDA        $9C,S                
                    AND        #$F0                 
                    ORA        #$01                 
                    STA        $9C,S                
                    REP        #$30                 
                    PHX                             
                    PHX                             
                    PHX                             
                    TSC                             ; Line 72
                    ADC        #$1D5B               
                    TCS                             
                    LDA        $03,S                
                    AND        #$F0F0               
                    ORA        #$0606               
                    STA        $03,S                
                    LDA        $05,S                
                    AND        #$F0F0               
                    ORA        #$0606               
                    STA        $05,S                
                    LDA        $A0,S                
                    AND        #$0F0F               
                    ORA        #$6060               
                    STA        $A0,S                
                    LDA        $A2,S                
                    AND        #$0F0F               
                    ORA        #$6060               
                    STA        $A2,S                
                    LDA        $A4,S                
                    AND        #$0F0F               
                    ORA        #$6060               
                    STA        $A4,S                
                    LDA        $A6,S                
                    AND        #$0F0F               
                    ORA        #$6060               
                    STA        $A6,S                
                    LDA        $A8,S                
                    AND        #$0F0F               
                    ORA        #$6060               
                    STA        $A8,S                
                    LDA        $AA,S                
                    AND        #$0F0F               
                    ORA        #$6060               
                    STA        $AA,S                
                    LDA        $AC,S                
                    AND        #$0F0F               
                    ORA        #$6060               
                    STA        $AC,S                
                    LDA        $AE,S                
                    AND        #$0F0F               
                    ORA        #$6060               
                    STA        $AE,S                
                    SEP        #$20                 
                    LDA        $07,S                
                    AND        #$F0                 
                    ORA        #$06                 
                    STA        $07,S                
                    REP        #$30                 
                    TSC                             ; Line 74
                    ADC        #$0140               
                    TCS                             
                    LDA        $01,S                
                    AND        #$F0F0               
                    ORA        #$0606               
                    STA        $01,S                
                    LDA        $03,S                
                    AND        #$F0F0               
                    ORA        #$0606               
                    STA        $03,S                
                    LDA        $05,S                
                    AND        #$F0F0               
                    ORA        #$0606               
                    STA        $05,S                
                    LDA        $07,S                
                    AND        #$F0F0               
                    ORA        #$0606               
                    STA        $07,S                
                    LDA        $09,S                
                    AND        #$F0F0               
                    ORA        #$0606               
                    STA        $09,S                
                    LDA        $0B,S                
                    AND        #$F0F0               
                    ORA        #$0606               
                    STA        $0B,S                
                    LDA        $0D,S                
                    AND        #$F0F0               
                    ORA        #$0606               
                    STA        $0D,S                
                    LDA        $A4,S                
                    AND        #$0F0F               
                    ORA        #$6060               
                    STA        $A4,S                
                    LDA        $A6,S                
                    AND        #$0F0F               
                    ORA        #$6060               
                    STA        $A6,S                
                    LDA        $A8,S                
                    AND        #$0F0F               
                    ORA        #$6060               
                    STA        $A8,S                
                    LDA        $AA,S                
                    AND        #$0F0F               
                    ORA        #$6060               
                    STA        $AA,S                
                    LDA        $AC,S                
                    AND        #$0F0F               
                    ORA        #$6060               
                    STA        $AC,S                
                    SEP        #$20                 
                    LDA        $0F,S                
                    AND        #$F0                 
                    ORA        #$06                 
                    STA        $0F,S                
                    REP        #$30                 
*--                                                 
                    LDAL       $E1C068              ; Direct Page and Stack in Bank 00/
                    AND        #$FFCF               
                    STAL       $E1C068              
                    LDA        StackAddress         ; Restore Stack
                    TCS                             
                    PLD                             ; Restore Direct Page
                    CLI                             ; Enable Interrupts
                    PLB
                    RTL                             
                                                                       
********************************************************************************         
                                                                                                                       